#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 1193
#define SYMBOL_COUNT 311
#define ALIAS_COUNT 1
#define TOKEN_COUNT 150
#define EXTERNAL_TOKEN_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 3

enum {
  anon_sym_1 = 1,
  anon_sym_bool = 2,
  anon_sym_byte = 3,
  anon_sym_char = 4,
  anon_sym_decimal = 5,
  anon_sym_double = 6,
  anon_sym_float = 7,
  anon_sym_int = 8,
  anon_sym_long = 9,
  anon_sym_object = 10,
  anon_sym_sbyte = 11,
  anon_sym_short = 12,
  anon_sym_string = 13,
  anon_sym_uint = 14,
  anon_sym_ulong = 15,
  anon_sym_ushort = 16,
  anon_sym_LT = 17,
  anon_sym_COMMA = 18,
  anon_sym_GT = 19,
  anon_sym_abstract = 20,
  anon_sym_async = 21,
  anon_sym_extern = 22,
  anon_sym_internal = 23,
  anon_sym_new = 24,
  anon_sym_override = 25,
  anon_sym_private = 26,
  anon_sym_protected = 27,
  anon_sym_public = 28,
  anon_sym_readonly = 29,
  anon_sym_sealed = 30,
  anon_sym_static = 31,
  anon_sym_unsafe = 32,
  anon_sym_virtual = 33,
  anon_sym_volatile = 34,
  anon_sym_alias = 35,
  anon_sym_SEMI = 36,
  anon_sym_using = 37,
  anon_sym_EQ = 38,
  anon_sym_namespace = 39,
  anon_sym_LBRACE = 40,
  anon_sym_RBRACE = 41,
  anon_sym_EQ_GT = 42,
  anon_sym_get = 43,
  anon_sym_set = 44,
  anon_sym_partial = 45,
  anon_sym_class = 46,
  anon_sym_COLON = 47,
  anon_sym_COMMA1 = 48,
  anon_sym_dynamic = 49,
  anon_sym_where = 50,
  anon_sym_struct = 51,
  anon_sym_LPAREN = 52,
  anon_sym_RPAREN = 53,
  anon_sym_this = 54,
  anon_sym_LBRACK = 55,
  anon_sym_RBRACK = 56,
  anon_sym_DOT = 57,
  anon_sym_event = 58,
  anon_sym_add = 59,
  anon_sym_remove = 60,
  anon_sym_operator = 61,
  anon_sym_PLUS = 62,
  anon_sym_DASH = 63,
  anon_sym_BANG = 64,
  anon_sym_TILDE = 65,
  anon_sym_PLUS_PLUS = 66,
  anon_sym_DASH_DASH = 67,
  anon_sym_true = 68,
  anon_sym_false = 69,
  anon_sym_STAR = 70,
  anon_sym_SLASH = 71,
  anon_sym_PERCENT = 72,
  anon_sym_CARET = 73,
  anon_sym_PIPE = 74,
  anon_sym_AMP = 75,
  anon_sym_LT_LT = 76,
  anon_sym_GT_GT = 77,
  anon_sym_EQ_EQ = 78,
  anon_sym_BANG_EQ = 79,
  anon_sym_GT_EQ = 80,
  anon_sym_LT_EQ = 81,
  anon_sym_implicit = 82,
  anon_sym_explicit = 83,
  anon_sym_interface = 84,
  anon_sym_enum = 85,
  anon_sym_delegate = 86,
  sym_void_keyword = 87,
  anon_sym_ref = 88,
  anon_sym_out = 89,
  anon_sym_params = 90,
  anon_sym_assembly = 91,
  anon_sym_module = 92,
  anon_sym_const = 93,
  anon_sym_QMARK = 94,
  anon_sym_AMP_AMP = 95,
  anon_sym_PIPE_PIPE = 96,
  anon_sym_typeof = 97,
  anon_sym_sizeof = 98,
  anon_sym_SQUOTE = 99,
  aux_sym_SLASH_LBRACK_CARET_SQUOTE_RBRACK_SLASH = 100,
  sym__hexadecimal_escape_sequence = 101,
  aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH = 102,
  aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH = 103,
  anon_sym_BSLASH_SQUOTE = 104,
  anon_sym_BSLASH_DQUOTE = 105,
  anon_sym_BSLASH_BSLASH = 106,
  anon_sym_BSLASH0 = 107,
  anon_sym_BSLASHa = 108,
  anon_sym_BSLASHb = 109,
  anon_sym_BSLASHf = 110,
  anon_sym_BSLASHn = 111,
  anon_sym_BSLASHr = 112,
  anon_sym_BSLASHt = 113,
  anon_sym_BSLASHv = 114,
  aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH = 115,
  aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH = 116,
  sym__integer_type_suffix = 117,
  sym_null_literal = 118,
  sym__real_type_suffix = 119,
  sym__exponent_part = 120,
  anon_sym_DQUOTE = 121,
  aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH = 122,
  anon_sym_AT_DQUOTE = 123,
  aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH = 124,
  anon_sym_global = 125,
  anon_sym_COLON_COLON = 126,
  sym_identifier_name = 127,
  sym_comment = 128,
  anon_sym_try = 129,
  anon_sym_catch = 130,
  anon_sym_when = 131,
  anon_sym_finally = 132,
  anon_sym_checked = 133,
  anon_sym_unchecked = 134,
  anon_sym_lock = 135,
  anon_sym_yield = 136,
  anon_sym_return = 137,
  anon_sym_break = 138,
  anon_sym_if = 139,
  anon_sym_else = 140,
  anon_sym_switch = 141,
  anon_sym_case = 142,
  anon_sym_default = 143,
  anon_sym_while = 144,
  anon_sym_do = 145,
  anon_sym_continue = 146,
  anon_sym_throw = 147,
  anon_sym_goto = 148,
  anon_sym_var = 149,
  sym_compilation_unit = 150,
  sym__type_declaration = 151,
  sym__type = 152,
  sym_predefined_type = 153,
  sym_type_parameter_list = 154,
  sym_type_parameter = 155,
  sym_modifiers = 156,
  sym_extern_alias_directive = 157,
  sym_using_directive = 158,
  sym_name_equals = 159,
  sym_namespace_declaration = 160,
  sym_property_declaration = 161,
  sym__property_body = 162,
  sym__property_initializer = 163,
  sym__accessor_declarations = 164,
  sym_get_accessor_declaration = 165,
  sym_set_accessor_declaration = 166,
  sym_accessor_modifier = 167,
  sym_class_declaration = 168,
  sym_class_base = 169,
  sym_type_parameter_constraints_clause = 170,
  sym_type_parameter_constraints = 171,
  sym_constructor_constraint = 172,
  sym_indexer_declaration = 173,
  sym__indexer_declarator = 174,
  sym__indexer_body = 175,
  sym_event_declaration = 176,
  sym_add_accessor_declaration = 177,
  sym_remove_accessor_declaration = 178,
  sym_operator_declaration = 179,
  sym__operator_declarator = 180,
  sym__unary_operator_declarator = 181,
  sym_overloadable_unary_operator = 182,
  sym__binary_operator_declarator = 183,
  sym_overloadable_binary_operator = 184,
  sym__conversion_operator_declarator = 185,
  sym_overloadable_conversion_operator = 186,
  sym_interface_declaration = 187,
  sym_interface_base = 188,
  sym_interface_method_declaration = 189,
  sym_interface_event_declaration = 190,
  sym_interface_property_declaration = 191,
  sym_interface_accessor = 192,
  sym_interface_indexer_declaration = 193,
  sym_struct_declaration = 194,
  sym_struct_interfaces = 195,
  sym_enum_declaration = 196,
  sym_enum_member_declaration = 197,
  sym__integral_type = 198,
  sym_delegate_declaration = 199,
  sym_parameter_list = 200,
  sym__formal_parameter_list = 201,
  sym_parameter = 202,
  sym_default_argument = 203,
  sym_parameter_modifier = 204,
  sym_parameter_array = 205,
  sym_array_type = 206,
  sym_array_rank_specifier = 207,
  sym__attributes = 208,
  sym__attribute_section = 209,
  sym_attribute_list = 210,
  sym_attribute = 211,
  sym_attribute_argument_list = 212,
  sym__global_attributes = 213,
  sym_field_declaration = 214,
  sym_variable_declaration = 215,
  sym_generic_name = 216,
  sym_variable_declarator = 217,
  sym_variable_initializer = 218,
  sym_array_initalizer = 219,
  sym_equals_value_clause = 220,
  sym_constant_declaration = 221,
  sym__constant_declarators = 222,
  sym_constant_declarator = 223,
  sym__expression = 224,
  sym_boolean_expression = 225,
  sym_constant_expression = 226,
  sym_parenthesized_expression = 227,
  sym_ternary_expression = 228,
  sym_binary_expression = 229,
  sym_unary_expression = 230,
  sym__literal = 231,
  sym_boolean_literal = 232,
  sym_character_literal = 233,
  sym__unicode_escape_sequence = 234,
  sym__simple_escape_sequence = 235,
  sym_integer_literal = 236,
  sym_real_literal = 237,
  sym_string_literal = 238,
  sym__regular_string_literal = 239,
  sym__regular_string_literal_character = 240,
  sym__verbatim_string_literal = 241,
  sym_qualified_name = 242,
  sym_alias_qualified_name = 243,
  sym_constructor_declaration = 244,
  sym_destructor_declaration = 245,
  sym_method_declaration = 246,
  sym__statement = 247,
  sym_variable_assignment_statement = 248,
  sym_statement_block = 249,
  sym__statement_list = 250,
  sym__labeled_statement = 251,
  sym__embedded_statement = 252,
  sym_empty_statement = 253,
  sym_expression_statement = 254,
  sym__selection_statement = 255,
  sym__iteration_statement = 256,
  sym__jump_statement = 257,
  sym_try_statement = 258,
  sym_catch_clause = 259,
  sym__exception_specifier = 260,
  sym__exception_filter = 261,
  sym_finally_clause = 262,
  sym_checked_statement = 263,
  sym_unchecked_statement = 264,
  sym_lock_statement = 265,
  sym_yield_statement = 266,
  sym_if_statement = 267,
  sym_switch_statement = 268,
  sym_switch_section = 269,
  sym_switch_label = 270,
  sym_while_statement = 271,
  sym_do_statement = 272,
  sym_break_statement = 273,
  sym_continue_statement = 274,
  sym_return_statement = 275,
  sym_throw_statement = 276,
  sym_goto_statement = 277,
  sym__declaration_statement = 278,
  sym_local_variable_declaration = 279,
  sym__local_variable_type = 280,
  sym__local_variable_declarators = 281,
  sym_local_variable_declarator = 282,
  sym_local_variable_initializer = 283,
  sym_local_constant_declaration = 284,
  aux_sym_compilation_unit_repeat1 = 285,
  aux_sym_compilation_unit_repeat2 = 286,
  aux_sym_compilation_unit_repeat3 = 287,
  aux_sym_compilation_unit_repeat4 = 288,
  aux_sym_type_parameter_list_repeat1 = 289,
  aux_sym_modifiers_repeat1 = 290,
  aux_sym_namespace_declaration_repeat1 = 291,
  aux_sym_class_declaration_repeat1 = 292,
  aux_sym_class_declaration_repeat2 = 293,
  aux_sym_class_base_repeat1 = 294,
  aux_sym_interface_declaration_repeat1 = 295,
  aux_sym_interface_property_declaration_repeat1 = 296,
  aux_sym_struct_declaration_repeat1 = 297,
  aux_sym_enum_declaration_repeat1 = 298,
  aux_sym__formal_parameter_list_repeat1 = 299,
  aux_sym_array_rank_specifier_repeat1 = 300,
  aux_sym__attributes_repeat1 = 301,
  aux_sym_attribute_list_repeat1 = 302,
  aux_sym_variable_declaration_repeat1 = 303,
  aux_sym_array_initalizer_repeat1 = 304,
  aux_sym__constant_declarators_repeat1 = 305,
  aux_sym__regular_string_literal_repeat1 = 306,
  aux_sym__statement_list_repeat1 = 307,
  aux_sym_try_statement_repeat1 = 308,
  aux_sym_switch_statement_repeat1 = 309,
  aux_sym_switch_section_repeat1 = 310,
  alias_sym_label_name = 311,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "END",
  [anon_sym_1] = "ï»¿",
  [anon_sym_bool] = "bool",
  [anon_sym_byte] = "byte",
  [anon_sym_char] = "char",
  [anon_sym_decimal] = "decimal",
  [anon_sym_double] = "double",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_long] = "long",
  [anon_sym_object] = "object",
  [anon_sym_sbyte] = "sbyte",
  [anon_sym_short] = "short",
  [anon_sym_string] = "string",
  [anon_sym_uint] = "uint",
  [anon_sym_ulong] = "ulong",
  [anon_sym_ushort] = "ushort",
  [anon_sym_LT] = "<",
  [anon_sym_COMMA] = ",",
  [anon_sym_GT] = ">",
  [anon_sym_abstract] = "abstract",
  [anon_sym_async] = "async",
  [anon_sym_extern] = "extern",
  [anon_sym_internal] = "internal",
  [anon_sym_new] = "new",
  [anon_sym_override] = "override",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_public] = "public",
  [anon_sym_readonly] = "readonly",
  [anon_sym_sealed] = "sealed",
  [anon_sym_static] = "static",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_virtual] = "virtual",
  [anon_sym_volatile] = "volatile",
  [anon_sym_alias] = "alias",
  [anon_sym_SEMI] = ";",
  [anon_sym_using] = "using",
  [anon_sym_EQ] = "=",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_partial] = "partial",
  [anon_sym_class] = "class",
  [anon_sym_COLON] = ":",
  [anon_sym_COMMA1] = ", ",
  [anon_sym_dynamic] = "dynamic",
  [anon_sym_where] = "where",
  [anon_sym_struct] = "struct",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_this] = "this",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_event] = "event",
  [anon_sym_add] = "add",
  [anon_sym_remove] = "remove",
  [anon_sym_operator] = "operator",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_implicit] = "implicit",
  [anon_sym_explicit] = "explicit",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_delegate] = "delegate",
  [sym_void_keyword] = "void_keyword",
  [anon_sym_ref] = "ref",
  [anon_sym_out] = "out",
  [anon_sym_params] = "params",
  [anon_sym_assembly] = "assembly",
  [anon_sym_module] = "module",
  [anon_sym_const] = "const",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_typeof] = "typeof",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_SLASH_LBRACK_CARET_SQUOTE_RBRACK_SLASH] = "/[^']/",
  [sym__hexadecimal_escape_sequence] = "_hexadecimal_escape_sequence",
  [aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = "/\\\\u[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]/",
  [aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = "/\\\\U[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]/",
  [anon_sym_BSLASH_SQUOTE] = "\\'",
  [anon_sym_BSLASH_DQUOTE] = "\\\"",
  [anon_sym_BSLASH_BSLASH] = "\\\\",
  [anon_sym_BSLASH0] = "\\0",
  [anon_sym_BSLASHa] = "\\a",
  [anon_sym_BSLASHb] = "\\b",
  [anon_sym_BSLASHf] = "\\f",
  [anon_sym_BSLASHn] = "\\n",
  [anon_sym_BSLASHr] = "\\r",
  [anon_sym_BSLASHt] = "\\t",
  [anon_sym_BSLASHv] = "\\v",
  [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = "/[0-9]+/",
  [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = "/0x[0-9a-fA-F]+/",
  [sym__integer_type_suffix] = "_integer_type_suffix",
  [sym_null_literal] = "null_literal",
  [sym__real_type_suffix] = "_real_type_suffix",
  [sym__exponent_part] = "_exponent_part",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH] = "/[^\"\\\\\\n]/",
  [anon_sym_AT_DQUOTE] = "@\"",
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH] = "/[^\"]*/",
  [anon_sym_global] = "global",
  [anon_sym_COLON_COLON] = "::",
  [sym_identifier_name] = "identifier_name",
  [sym_comment] = "comment",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_when] = "when",
  [anon_sym_finally] = "finally",
  [anon_sym_checked] = "checked",
  [anon_sym_unchecked] = "unchecked",
  [anon_sym_lock] = "lock",
  [anon_sym_yield] = "yield",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_continue] = "continue",
  [anon_sym_throw] = "throw",
  [anon_sym_goto] = "goto",
  [anon_sym_var] = "var",
  [sym_compilation_unit] = "compilation_unit",
  [sym__type_declaration] = "_type_declaration",
  [sym__type] = "_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_type_parameter] = "type_parameter",
  [sym_modifiers] = "modifiers",
  [sym_extern_alias_directive] = "extern_alias_directive",
  [sym_using_directive] = "using_directive",
  [sym_name_equals] = "name_equals",
  [sym_namespace_declaration] = "namespace_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym__property_body] = "_property_body",
  [sym__property_initializer] = "_property_initializer",
  [sym__accessor_declarations] = "_accessor_declarations",
  [sym_get_accessor_declaration] = "get_accessor_declaration",
  [sym_set_accessor_declaration] = "set_accessor_declaration",
  [sym_accessor_modifier] = "accessor_modifier",
  [sym_class_declaration] = "class_declaration",
  [sym_class_base] = "class_base",
  [sym_type_parameter_constraints_clause] = "type_parameter_constraints_clause",
  [sym_type_parameter_constraints] = "type_parameter_constraints",
  [sym_constructor_constraint] = "constructor_constraint",
  [sym_indexer_declaration] = "indexer_declaration",
  [sym__indexer_declarator] = "_indexer_declarator",
  [sym__indexer_body] = "_indexer_body",
  [sym_event_declaration] = "event_declaration",
  [sym_add_accessor_declaration] = "add_accessor_declaration",
  [sym_remove_accessor_declaration] = "remove_accessor_declaration",
  [sym_operator_declaration] = "operator_declaration",
  [sym__operator_declarator] = "_operator_declarator",
  [sym__unary_operator_declarator] = "_unary_operator_declarator",
  [sym_overloadable_unary_operator] = "overloadable_unary_operator",
  [sym__binary_operator_declarator] = "_binary_operator_declarator",
  [sym_overloadable_binary_operator] = "overloadable_binary_operator",
  [sym__conversion_operator_declarator] = "_conversion_operator_declarator",
  [sym_overloadable_conversion_operator] = "overloadable_conversion_operator",
  [sym_interface_declaration] = "interface_declaration",
  [sym_interface_base] = "interface_base",
  [sym_interface_method_declaration] = "interface_method_declaration",
  [sym_interface_event_declaration] = "interface_event_declaration",
  [sym_interface_property_declaration] = "interface_property_declaration",
  [sym_interface_accessor] = "interface_accessor",
  [sym_interface_indexer_declaration] = "interface_indexer_declaration",
  [sym_struct_declaration] = "struct_declaration",
  [sym_struct_interfaces] = "struct_interfaces",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_member_declaration] = "enum_member_declaration",
  [sym__integral_type] = "_integral_type",
  [sym_delegate_declaration] = "delegate_declaration",
  [sym_parameter_list] = "parameter_list",
  [sym__formal_parameter_list] = "_formal_parameter_list",
  [sym_parameter] = "parameter",
  [sym_default_argument] = "default_argument",
  [sym_parameter_modifier] = "parameter_modifier",
  [sym_parameter_array] = "parameter_array",
  [sym_array_type] = "array_type",
  [sym_array_rank_specifier] = "array_rank_specifier",
  [sym__attributes] = "_attributes",
  [sym__attribute_section] = "_attribute_section",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute] = "attribute",
  [sym_attribute_argument_list] = "attribute_argument_list",
  [sym__global_attributes] = "_global_attributes",
  [sym_field_declaration] = "field_declaration",
  [sym_variable_declaration] = "variable_declaration",
  [sym_generic_name] = "generic_name",
  [sym_variable_declarator] = "variable_declarator",
  [sym_variable_initializer] = "variable_initializer",
  [sym_array_initalizer] = "array_initalizer",
  [sym_equals_value_clause] = "equals_value_clause",
  [sym_constant_declaration] = "constant_declaration",
  [sym__constant_declarators] = "_constant_declarators",
  [sym_constant_declarator] = "constant_declarator",
  [sym__expression] = "_expression",
  [sym_boolean_expression] = "boolean_expression",
  [sym_constant_expression] = "constant_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym__literal] = "_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_character_literal] = "character_literal",
  [sym__unicode_escape_sequence] = "_unicode_escape_sequence",
  [sym__simple_escape_sequence] = "_simple_escape_sequence",
  [sym_integer_literal] = "integer_literal",
  [sym_real_literal] = "real_literal",
  [sym_string_literal] = "string_literal",
  [sym__regular_string_literal] = "_regular_string_literal",
  [sym__regular_string_literal_character] = "_regular_string_literal_character",
  [sym__verbatim_string_literal] = "_verbatim_string_literal",
  [sym_qualified_name] = "qualified_name",
  [sym_alias_qualified_name] = "alias_qualified_name",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym_destructor_declaration] = "destructor_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym__statement] = "_statement",
  [sym_variable_assignment_statement] = "variable_assignment_statement",
  [sym_statement_block] = "statement_block",
  [sym__statement_list] = "_statement_list",
  [sym__labeled_statement] = "_labeled_statement",
  [sym__embedded_statement] = "_embedded_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym__selection_statement] = "_selection_statement",
  [sym__iteration_statement] = "_iteration_statement",
  [sym__jump_statement] = "_jump_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym__exception_specifier] = "_exception_specifier",
  [sym__exception_filter] = "_exception_filter",
  [sym_finally_clause] = "finally_clause",
  [sym_checked_statement] = "checked_statement",
  [sym_unchecked_statement] = "unchecked_statement",
  [sym_lock_statement] = "lock_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_section] = "switch_section",
  [sym_switch_label] = "switch_label",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_goto_statement] = "goto_statement",
  [sym__declaration_statement] = "_declaration_statement",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym__local_variable_type] = "_local_variable_type",
  [sym__local_variable_declarators] = "_local_variable_declarators",
  [sym_local_variable_declarator] = "local_variable_declarator",
  [sym_local_variable_initializer] = "local_variable_initializer",
  [sym_local_constant_declaration] = "local_constant_declaration",
  [aux_sym_compilation_unit_repeat1] = "compilation_unit_repeat1",
  [aux_sym_compilation_unit_repeat2] = "compilation_unit_repeat2",
  [aux_sym_compilation_unit_repeat3] = "compilation_unit_repeat3",
  [aux_sym_compilation_unit_repeat4] = "compilation_unit_repeat4",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_modifiers_repeat1] = "modifiers_repeat1",
  [aux_sym_namespace_declaration_repeat1] = "namespace_declaration_repeat1",
  [aux_sym_class_declaration_repeat1] = "class_declaration_repeat1",
  [aux_sym_class_declaration_repeat2] = "class_declaration_repeat2",
  [aux_sym_class_base_repeat1] = "class_base_repeat1",
  [aux_sym_interface_declaration_repeat1] = "interface_declaration_repeat1",
  [aux_sym_interface_property_declaration_repeat1] = "interface_property_declaration_repeat1",
  [aux_sym_struct_declaration_repeat1] = "struct_declaration_repeat1",
  [aux_sym_enum_declaration_repeat1] = "enum_declaration_repeat1",
  [aux_sym__formal_parameter_list_repeat1] = "_formal_parameter_list_repeat1",
  [aux_sym_array_rank_specifier_repeat1] = "array_rank_specifier_repeat1",
  [aux_sym__attributes_repeat1] = "_attributes_repeat1",
  [aux_sym_attribute_list_repeat1] = "attribute_list_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_array_initalizer_repeat1] = "array_initalizer_repeat1",
  [aux_sym__constant_declarators_repeat1] = "_constant_declarators_repeat1",
  [aux_sym__regular_string_literal_repeat1] = "_regular_string_literal_repeat1",
  [aux_sym__statement_list_repeat1] = "_statement_list_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_switch_statement_repeat1] = "switch_statement_repeat1",
  [aux_sym_switch_section_repeat1] = "switch_section_repeat1",
  [alias_sym_label_name] = "label_name",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_decimal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sbyte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ulong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ushort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_partial] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [sym_void_keyword] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_params] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_SQUOTE_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym__hexadecimal_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHa] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHv] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym__integer_type_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__real_type_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__exponent_part] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier_name] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unchecked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [sym_compilation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__type_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_alias_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_name_equals] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__property_body] = {
    .visible = false,
    .named = true,
  },
  [sym__property_initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__accessor_declarations] = {
    .visible = false,
    .named = true,
  },
  [sym_get_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_set_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_base] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraints_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_indexer_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__indexer_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__indexer_body] = {
    .visible = false,
    .named = true,
  },
  [sym_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_add_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_remove_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__operator_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_operator_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_overloadable_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__binary_operator_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_overloadable_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__conversion_operator_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_overloadable_conversion_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_base] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_accessor] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_indexer_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__integral_type] = {
    .visible = false,
    .named = true,
  },
  [sym_delegate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_rank_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__attributes] = {
    .visible = false,
    .named = true,
  },
  [sym__attribute_section] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__global_attributes] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_array_initalizer] = {
    .visible = true,
    .named = true,
  },
  [sym_equals_value_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__constant_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym_constant_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__unicode_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_real_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__regular_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__regular_string_literal_character] = {
    .visible = false,
    .named = true,
  },
  [sym__verbatim_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_list] = {
    .visible = false,
    .named = true,
  },
  [sym__labeled_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__embedded_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__selection_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__iteration_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__jump_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__exception_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__exception_filter] = {
    .visible = false,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unchecked_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_lock_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_section] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_variable_type] = {
    .visible = false,
    .named = true,
  },
  [sym__local_variable_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym_local_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_local_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_compilation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compilation_unit_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compilation_unit_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compilation_unit_repeat4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_base_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_property_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__formal_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_rank_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_initalizer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__constant_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__regular_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_label_name] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[3][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_label_name,
  },
  [2] = {
    [1] = alias_sym_label_name,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '-')
        ADVANCE(15);
      if (lookahead == '.')
        ADVANCE(17);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == ':')
        ADVANCE(27);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(33);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == 'L')
        ADVANCE(42);
      if (lookahead == 'U')
        ADVANCE(45);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(47);
      if (lookahead == ']')
        ADVANCE(78);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == 'l')
        ADVANCE(42);
      if (lookahead == 'p')
        ADVANCE(80);
      if (lookahead == 'u')
        ADVANCE(45);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '~')
        ADVANCE(90);
      if (lookahead == 239)
        ADVANCE(91);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(94);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'm')
        ADVANCE(98);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(26);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(16);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(19);
      if (lookahead == '/')
        ADVANCE(22);
      END_STATE();
    case 19:
      if (lookahead == '*')
        ADVANCE(20);
      if (lookahead != 0)
        ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead != 0)
        ADVANCE(19);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(22);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH);
      if (lookahead == 'x')
        ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(26);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(25);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(25);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(26);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(31);
      if (lookahead == '=')
        ADVANCE(32);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '>')
        ADVANCE(35);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(38);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 40:
      if (lookahead == '\"')
        ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AT_DQUOTE);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym__integer_type_suffix);
      if (lookahead == 'U')
        ADVANCE(43);
      if (lookahead == 'u')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym__integer_type_suffix);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_identifier_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym__integer_type_suffix);
      if (lookahead == 'L')
        ADVANCE(43);
      if (lookahead == 'l')
        ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 47:
      if (lookahead == '\"')
        ADVANCE(48);
      if (lookahead == '\'')
        ADVANCE(49);
      if (lookahead == '0')
        ADVANCE(50);
      if (lookahead == 'U')
        ADVANCE(51);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'a')
        ADVANCE(61);
      if (lookahead == 'b')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(63);
      if (lookahead == 'n')
        ADVANCE(64);
      if (lookahead == 'r')
        ADVANCE(65);
      if (lookahead == 't')
        ADVANCE(66);
      if (lookahead == 'u')
        ADVANCE(67);
      if (lookahead == 'v')
        ADVANCE(72);
      if (lookahead == 'x')
        ADVANCE(73);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_BSLASH_DQUOTE);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_BSLASH_SQUOTE);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_BSLASH0);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(52);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(53);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(54);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(55);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(56);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(57);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(58);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_BSLASH_BSLASH);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_BSLASHa);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_BSLASHb);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_BSLASHf);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_BSLASHn);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_BSLASHr);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_BSLASHt);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(68);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(69);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(70);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_BSLASHv);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym__hexadecimal_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(75);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym__hexadecimal_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym__hexadecimal_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym__hexadecimal_escape_sequence);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identifier_name);
      if (lookahead == 'a')
        ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_identifier_name);
      if (lookahead == 'r')
        ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_identifier_name);
      if (lookahead == 'a')
        ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identifier_name);
      if (lookahead == 'm')
        ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_identifier_name);
      if (lookahead == 's')
        ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_params);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 91:
      if (lookahead == 187)
        ADVANCE(92);
      END_STATE();
    case 92:
      if (lookahead == 191)
        ADVANCE(93);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_1);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier_name);
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(97);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym__exponent_part);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym__exponent_part);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(97);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym__real_type_suffix);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 99:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == 239)
        ADVANCE(91);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(99);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 100:
      if (lookahead == '*')
        ADVANCE(19);
      if (lookahead == '/')
        ADVANCE(22);
      END_STATE();
    case 101:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(101);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 102:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(102);
      END_STATE();
    case 103:
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ':')
        ADVANCE(104);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(103);
      END_STATE();
    case 104:
      if (lookahead == ':')
        ADVANCE(28);
      END_STATE();
    case 105:
      if (lookahead == '.')
        ADVANCE(17);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ':')
        ADVANCE(106);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(107);
      if (lookahead == '=')
        ADVANCE(108);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(105);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 109:
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(109);
      END_STATE();
    case 110:
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(107);
      if (lookahead == '>')
        ADVANCE(111);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 112:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 113:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '~')
        ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(113);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 114:
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(108);
      if (lookahead == '>')
        ADVANCE(111);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == 'p')
        ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(114);
      END_STATE();
    case 115:
      if (lookahead == 'a')
        ADVANCE(116);
      END_STATE();
    case 116:
      if (lookahead == 'r')
        ADVANCE(117);
      END_STATE();
    case 117:
      if (lookahead == 'a')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 'm')
        ADVANCE(119);
      END_STATE();
    case 119:
      if (lookahead == 's')
        ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_params);
      END_STATE();
    case 121:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(121);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 122:
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 123:
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(17);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(107);
      if (lookahead == '=')
        ADVANCE(124);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>')
        ADVANCE(35);
      END_STATE();
    case 125:
      if (lookahead == ',')
        ADVANCE(126);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(125);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 126:
      if (lookahead == ' ')
        ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_COMMA1);
      END_STATE();
    case 128:
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 129:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(133);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(129);
      END_STATE();
    case 130:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(34);
      END_STATE();
    case 134:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == 'p')
        ADVANCE(80);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 135:
      if (lookahead == '=')
        ADVANCE(34);
      END_STATE();
    case 136:
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == ':')
        ADVANCE(106);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(111);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 137:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '~')
        ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(137);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 138:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(139);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == '|')
        ADVANCE(140);
      if (lookahead == '~')
        ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 141:
      if (lookahead == '!')
        ADVANCE(142);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(15);
      if (lookahead == '.')
        ADVANCE(17);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '~')
        ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(26);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 143:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '.')
        ADVANCE(17);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == ':')
        ADVANCE(106);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == 'L')
        ADVANCE(144);
      if (lookahead == 'U')
        ADVANCE(146);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == ']')
        ADVANCE(78);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == 'l')
        ADVANCE(144);
      if (lookahead == 'p')
        ADVANCE(115);
      if (lookahead == 'u')
        ADVANCE(146);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(143);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'm')
        ADVANCE(148);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym__integer_type_suffix);
      if (lookahead == 'U')
        ADVANCE(145);
      if (lookahead == 'u')
        ADVANCE(145);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym__integer_type_suffix);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym__integer_type_suffix);
      if (lookahead == 'L')
        ADVANCE(145);
      if (lookahead == 'l')
        ADVANCE(145);
      END_STATE();
    case 147:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(96);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym__real_type_suffix);
      END_STATE();
    case 149:
      if (lookahead == '/')
        ADVANCE(150);
      if (lookahead == '\\')
        ADVANCE(151);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\'')
        ADVANCE(152);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_RBRACK_SLASH);
      if (lookahead == '*')
        ADVANCE(19);
      if (lookahead == '/')
        ADVANCE(22);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_RBRACK_SLASH);
      if (lookahead == '\"')
        ADVANCE(48);
      if (lookahead == '\'')
        ADVANCE(49);
      if (lookahead == '0')
        ADVANCE(50);
      if (lookahead == 'U')
        ADVANCE(51);
      if (lookahead == '\\')
        ADVANCE(60);
      if (lookahead == 'a')
        ADVANCE(61);
      if (lookahead == 'b')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(63);
      if (lookahead == 'n')
        ADVANCE(64);
      if (lookahead == 'r')
        ADVANCE(65);
      if (lookahead == 't')
        ADVANCE(66);
      if (lookahead == 'u')
        ADVANCE(67);
      if (lookahead == 'v')
        ADVANCE(72);
      if (lookahead == 'x')
        ADVANCE(73);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_RBRACK_SLASH);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(153);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '/')
        ADVANCE(154);
      if (lookahead == '\\')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(155);
      if (lookahead != 0)
        ADVANCE(155);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH);
      if (lookahead == '*')
        ADVANCE(19);
      if (lookahead == '/')
        ADVANCE(22);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH);
      if (lookahead == '/')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\"')
        ADVANCE(160);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH);
      if (lookahead == '*')
        ADVANCE(158);
      if (lookahead == '/')
        ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\"')
        ADVANCE(160);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH);
      if (lookahead == '\"')
        ADVANCE(19);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead != 0)
        ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH);
      if (lookahead == '\"')
        ADVANCE(19);
      if (lookahead == '/')
        ADVANCE(160);
      if (lookahead != 0)
        ADVANCE(158);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH);
      if (lookahead != 0 &&
          lookahead != '\"')
        ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH);
      if (lookahead == '\n')
        ADVANCE(160);
      if (lookahead == '\"')
        ADVANCE(22);
      if (lookahead != 0)
        ADVANCE(161);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH);
      if (lookahead == '/')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\"')
        ADVANCE(160);
      END_STATE();
    case 163:
      if (lookahead == '!')
        ADVANCE(142);
      if (lookahead == '\"')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(15);
      if (lookahead == '.')
        ADVANCE(17);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(23);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(86);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '~')
        ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(26);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 164:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == ':')
        ADVANCE(106);
      if (lookahead == ';')
        ADVANCE(29);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(133);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 165:
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == ']')
        ADVANCE(78);
      if (lookahead == 'p')
        ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(165);
      END_STATE();
    case 166:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(133);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == ']')
        ADVANCE(78);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == 'p')
        ADVANCE(115);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(166);
      END_STATE();
    case 167:
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(108);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(89);
      if (lookahead == '~')
        ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(167);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    case 168:
      if (lookahead == '!')
        ADVANCE(130);
      if (lookahead == '%')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(6);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(14);
      if (lookahead == '-')
        ADVANCE(132);
      if (lookahead == '/')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(30);
      if (lookahead == '=')
        ADVANCE(135);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '[')
        ADVANCE(46);
      if (lookahead == '^')
        ADVANCE(79);
      if (lookahead == 'p')
        ADVANCE(115);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(168);
      END_STATE();
    case 169:
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '/')
        ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(169);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(44);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a')
        ADVANCE(1);
      if (lookahead == 'b')
        ADVANCE(25);
      if (lookahead == 'c')
        ADVANCE(36);
      if (lookahead == 'd')
        ADVANCE(64);
      if (lookahead == 'e')
        ADVANCE(93);
      if (lookahead == 'f')
        ADVANCE(115);
      if (lookahead == 'g')
        ADVANCE(130);
      if (lookahead == 'i')
        ADVANCE(141);
      if (lookahead == 'l')
        ADVANCE(161);
      if (lookahead == 'm')
        ADVANCE(167);
      if (lookahead == 'n')
        ADVANCE(173);
      if (lookahead == 'o')
        ADVANCE(187);
      if (lookahead == 'p')
        ADVANCE(209);
      if (lookahead == 'r')
        ADVANCE(234);
      if (lookahead == 's')
        ADVANCE(251);
      if (lookahead == 't')
        ADVANCE(288);
      if (lookahead == 'u')
        ADVANCE(304);
      if (lookahead == 'v')
        ADVANCE(332);
      if (lookahead == 'w')
        ADVANCE(350);
      if (lookahead == 'y')
        ADVANCE(359);
      END_STATE();
    case 1:
      if (lookahead == 'b')
        ADVANCE(2);
      if (lookahead == 'd')
        ADVANCE(9);
      if (lookahead == 'l')
        ADVANCE(11);
      if (lookahead == 's')
        ADVANCE(15);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 't')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'r')
        ADVANCE(5);
      END_STATE();
    case 5:
      if (lookahead == 'a')
        ADVANCE(6);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 't')
        ADVANCE(8);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 9:
      if (lookahead == 'd')
        ADVANCE(10);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 11:
      if (lookahead == 'i')
        ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == 'a')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 's')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 15:
      if (lookahead == 's')
        ADVANCE(16);
      if (lookahead == 'y')
        ADVANCE(22);
      END_STATE();
    case 16:
      if (lookahead == 'e')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'm')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'b')
        ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == 'l')
        ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == 'y')
        ADVANCE(21);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 22:
      if (lookahead == 'n')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'c')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 25:
      if (lookahead == 'o')
        ADVANCE(26);
      if (lookahead == 'r')
        ADVANCE(29);
      if (lookahead == 'y')
        ADVANCE(33);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'l')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 29:
      if (lookahead == 'e')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 'a')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'k')
        ADVANCE(32);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 33:
      if (lookahead == 't')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'e')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 36:
      if (lookahead == 'a')
        ADVANCE(37);
      if (lookahead == 'h')
        ADVANCE(43);
      if (lookahead == 'l')
        ADVANCE(51);
      if (lookahead == 'o')
        ADVANCE(55);
      END_STATE();
    case 37:
      if (lookahead == 's')
        ADVANCE(38);
      if (lookahead == 't')
        ADVANCE(40);
      END_STATE();
    case 38:
      if (lookahead == 'e')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 40:
      if (lookahead == 'c')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'h')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 43:
      if (lookahead == 'a')
        ADVANCE(44);
      if (lookahead == 'e')
        ADVANCE(46);
      END_STATE();
    case 44:
      if (lookahead == 'r')
        ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 46:
      if (lookahead == 'c')
        ADVANCE(47);
      END_STATE();
    case 47:
      if (lookahead == 'k')
        ADVANCE(48);
      END_STATE();
    case 48:
      if (lookahead == 'e')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'd')
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_checked);
      END_STATE();
    case 51:
      if (lookahead == 'a')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 's')
        ADVANCE(53);
      END_STATE();
    case 53:
      if (lookahead == 's')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 55:
      if (lookahead == 'n')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 's')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(59);
      END_STATE();
    case 57:
      if (lookahead == 't')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 59:
      if (lookahead == 'i')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'n')
        ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == 'u')
        ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == 'e')
        ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 64:
      if (lookahead == 'e')
        ADVANCE(65);
      if (lookahead == 'o')
        ADVANCE(82);
      if (lookahead == 'y')
        ADVANCE(87);
      END_STATE();
    case 65:
      if (lookahead == 'c')
        ADVANCE(66);
      if (lookahead == 'f')
        ADVANCE(71);
      if (lookahead == 'l')
        ADVANCE(76);
      END_STATE();
    case 66:
      if (lookahead == 'i')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'm')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'a')
        ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 'l')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_decimal);
      END_STATE();
    case 71:
      if (lookahead == 'a')
        ADVANCE(72);
      END_STATE();
    case 72:
      if (lookahead == 'u')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'l')
        ADVANCE(74);
      END_STATE();
    case 74:
      if (lookahead == 't')
        ADVANCE(75);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 76:
      if (lookahead == 'e')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == 'g')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == 'a')
        ADVANCE(79);
      END_STATE();
    case 79:
      if (lookahead == 't')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'e')
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u')
        ADVANCE(83);
      END_STATE();
    case 83:
      if (lookahead == 'b')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'l')
        ADVANCE(85);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 87:
      if (lookahead == 'n')
        ADVANCE(88);
      END_STATE();
    case 88:
      if (lookahead == 'a')
        ADVANCE(89);
      END_STATE();
    case 89:
      if (lookahead == 'm')
        ADVANCE(90);
      END_STATE();
    case 90:
      if (lookahead == 'i')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'c')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_dynamic);
      END_STATE();
    case 93:
      if (lookahead == 'l')
        ADVANCE(94);
      if (lookahead == 'n')
        ADVANCE(97);
      if (lookahead == 'v')
        ADVANCE(100);
      if (lookahead == 'x')
        ADVANCE(104);
      END_STATE();
    case 94:
      if (lookahead == 's')
        ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'e')
        ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 97:
      if (lookahead == 'u')
        ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == 'm')
        ADVANCE(99);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 100:
      if (lookahead == 'e')
        ADVANCE(101);
      END_STATE();
    case 101:
      if (lookahead == 'n')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 't')
        ADVANCE(103);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 104:
      if (lookahead == 'p')
        ADVANCE(105);
      if (lookahead == 't')
        ADVANCE(111);
      END_STATE();
    case 105:
      if (lookahead == 'l')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'i')
        ADVANCE(107);
      END_STATE();
    case 107:
      if (lookahead == 'c')
        ADVANCE(108);
      END_STATE();
    case 108:
      if (lookahead == 'i')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 't')
        ADVANCE(110);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 111:
      if (lookahead == 'e')
        ADVANCE(112);
      END_STATE();
    case 112:
      if (lookahead == 'r')
        ADVANCE(113);
      END_STATE();
    case 113:
      if (lookahead == 'n')
        ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 115:
      if (lookahead == 'a')
        ADVANCE(116);
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 'l')
        ADVANCE(126);
      END_STATE();
    case 116:
      if (lookahead == 'l')
        ADVANCE(117);
      END_STATE();
    case 117:
      if (lookahead == 's')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 'e')
        ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 120:
      if (lookahead == 'n')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 'a')
        ADVANCE(122);
      END_STATE();
    case 122:
      if (lookahead == 'l')
        ADVANCE(123);
      END_STATE();
    case 123:
      if (lookahead == 'l')
        ADVANCE(124);
      END_STATE();
    case 124:
      if (lookahead == 'y')
        ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 126:
      if (lookahead == 'o')
        ADVANCE(127);
      END_STATE();
    case 127:
      if (lookahead == 'a')
        ADVANCE(128);
      END_STATE();
    case 128:
      if (lookahead == 't')
        ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 130:
      if (lookahead == 'e')
        ADVANCE(131);
      if (lookahead == 'l')
        ADVANCE(133);
      if (lookahead == 'o')
        ADVANCE(138);
      END_STATE();
    case 131:
      if (lookahead == 't')
        ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 133:
      if (lookahead == 'o')
        ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead == 'b')
        ADVANCE(135);
      END_STATE();
    case 135:
      if (lookahead == 'a')
        ADVANCE(136);
      END_STATE();
    case 136:
      if (lookahead == 'l')
        ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 138:
      if (lookahead == 't')
        ADVANCE(139);
      END_STATE();
    case 139:
      if (lookahead == 'o')
        ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 141:
      if (lookahead == 'f')
        ADVANCE(142);
      if (lookahead == 'm')
        ADVANCE(143);
      if (lookahead == 'n')
        ADVANCE(150);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 143:
      if (lookahead == 'p')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'l')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'i')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == 'c')
        ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 'i')
        ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 't')
        ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_implicit);
      END_STATE();
    case 150:
      if (lookahead == 't')
        ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e')
        ADVANCE(152);
      END_STATE();
    case 152:
      if (lookahead == 'r')
        ADVANCE(153);
      END_STATE();
    case 153:
      if (lookahead == 'f')
        ADVANCE(154);
      if (lookahead == 'n')
        ADVANCE(158);
      END_STATE();
    case 154:
      if (lookahead == 'a')
        ADVANCE(155);
      END_STATE();
    case 155:
      if (lookahead == 'c')
        ADVANCE(156);
      END_STATE();
    case 156:
      if (lookahead == 'e')
        ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 158:
      if (lookahead == 'a')
        ADVANCE(159);
      END_STATE();
    case 159:
      if (lookahead == 'l')
        ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 161:
      if (lookahead == 'o')
        ADVANCE(162);
      END_STATE();
    case 162:
      if (lookahead == 'c')
        ADVANCE(163);
      if (lookahead == 'n')
        ADVANCE(165);
      END_STATE();
    case 163:
      if (lookahead == 'k')
        ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_lock);
      END_STATE();
    case 165:
      if (lookahead == 'g')
        ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 167:
      if (lookahead == 'o')
        ADVANCE(168);
      END_STATE();
    case 168:
      if (lookahead == 'd')
        ADVANCE(169);
      END_STATE();
    case 169:
      if (lookahead == 'u')
        ADVANCE(170);
      END_STATE();
    case 170:
      if (lookahead == 'l')
        ADVANCE(171);
      END_STATE();
    case 171:
      if (lookahead == 'e')
        ADVANCE(172);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 173:
      if (lookahead == 'a')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(182);
      if (lookahead == 'u')
        ADVANCE(184);
      END_STATE();
    case 174:
      if (lookahead == 'm')
        ADVANCE(175);
      END_STATE();
    case 175:
      if (lookahead == 'e')
        ADVANCE(176);
      END_STATE();
    case 176:
      if (lookahead == 's')
        ADVANCE(177);
      END_STATE();
    case 177:
      if (lookahead == 'p')
        ADVANCE(178);
      END_STATE();
    case 178:
      if (lookahead == 'a')
        ADVANCE(179);
      END_STATE();
    case 179:
      if (lookahead == 'c')
        ADVANCE(180);
      END_STATE();
    case 180:
      if (lookahead == 'e')
        ADVANCE(181);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 182:
      if (lookahead == 'w')
        ADVANCE(183);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 184:
      if (lookahead == 'l')
        ADVANCE(185);
      END_STATE();
    case 185:
      if (lookahead == 'l')
        ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 187:
      if (lookahead == 'b')
        ADVANCE(188);
      if (lookahead == 'p')
        ADVANCE(193);
      if (lookahead == 'u')
        ADVANCE(200);
      if (lookahead == 'v')
        ADVANCE(202);
      END_STATE();
    case 188:
      if (lookahead == 'j')
        ADVANCE(189);
      END_STATE();
    case 189:
      if (lookahead == 'e')
        ADVANCE(190);
      END_STATE();
    case 190:
      if (lookahead == 'c')
        ADVANCE(191);
      END_STATE();
    case 191:
      if (lookahead == 't')
        ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 193:
      if (lookahead == 'e')
        ADVANCE(194);
      END_STATE();
    case 194:
      if (lookahead == 'r')
        ADVANCE(195);
      END_STATE();
    case 195:
      if (lookahead == 'a')
        ADVANCE(196);
      END_STATE();
    case 196:
      if (lookahead == 't')
        ADVANCE(197);
      END_STATE();
    case 197:
      if (lookahead == 'o')
        ADVANCE(198);
      END_STATE();
    case 198:
      if (lookahead == 'r')
        ADVANCE(199);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 200:
      if (lookahead == 't')
        ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 202:
      if (lookahead == 'e')
        ADVANCE(203);
      END_STATE();
    case 203:
      if (lookahead == 'r')
        ADVANCE(204);
      END_STATE();
    case 204:
      if (lookahead == 'r')
        ADVANCE(205);
      END_STATE();
    case 205:
      if (lookahead == 'i')
        ADVANCE(206);
      END_STATE();
    case 206:
      if (lookahead == 'd')
        ADVANCE(207);
      END_STATE();
    case 207:
      if (lookahead == 'e')
        ADVANCE(208);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 209:
      if (lookahead == 'a')
        ADVANCE(210);
      if (lookahead == 'r')
        ADVANCE(216);
      if (lookahead == 'u')
        ADVANCE(229);
      END_STATE();
    case 210:
      if (lookahead == 'r')
        ADVANCE(211);
      END_STATE();
    case 211:
      if (lookahead == 't')
        ADVANCE(212);
      END_STATE();
    case 212:
      if (lookahead == 'i')
        ADVANCE(213);
      END_STATE();
    case 213:
      if (lookahead == 'a')
        ADVANCE(214);
      END_STATE();
    case 214:
      if (lookahead == 'l')
        ADVANCE(215);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_partial);
      END_STATE();
    case 216:
      if (lookahead == 'i')
        ADVANCE(217);
      if (lookahead == 'o')
        ADVANCE(222);
      END_STATE();
    case 217:
      if (lookahead == 'v')
        ADVANCE(218);
      END_STATE();
    case 218:
      if (lookahead == 'a')
        ADVANCE(219);
      END_STATE();
    case 219:
      if (lookahead == 't')
        ADVANCE(220);
      END_STATE();
    case 220:
      if (lookahead == 'e')
        ADVANCE(221);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 222:
      if (lookahead == 't')
        ADVANCE(223);
      END_STATE();
    case 223:
      if (lookahead == 'e')
        ADVANCE(224);
      END_STATE();
    case 224:
      if (lookahead == 'c')
        ADVANCE(225);
      END_STATE();
    case 225:
      if (lookahead == 't')
        ADVANCE(226);
      END_STATE();
    case 226:
      if (lookahead == 'e')
        ADVANCE(227);
      END_STATE();
    case 227:
      if (lookahead == 'd')
        ADVANCE(228);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 229:
      if (lookahead == 'b')
        ADVANCE(230);
      END_STATE();
    case 230:
      if (lookahead == 'l')
        ADVANCE(231);
      END_STATE();
    case 231:
      if (lookahead == 'i')
        ADVANCE(232);
      END_STATE();
    case 232:
      if (lookahead == 'c')
        ADVANCE(233);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 234:
      if (lookahead == 'e')
        ADVANCE(235);
      END_STATE();
    case 235:
      if (lookahead == 'a')
        ADVANCE(236);
      if (lookahead == 'f')
        ADVANCE(242);
      if (lookahead == 'm')
        ADVANCE(243);
      if (lookahead == 't')
        ADVANCE(247);
      END_STATE();
    case 236:
      if (lookahead == 'd')
        ADVANCE(237);
      END_STATE();
    case 237:
      if (lookahead == 'o')
        ADVANCE(238);
      END_STATE();
    case 238:
      if (lookahead == 'n')
        ADVANCE(239);
      END_STATE();
    case 239:
      if (lookahead == 'l')
        ADVANCE(240);
      END_STATE();
    case 240:
      if (lookahead == 'y')
        ADVANCE(241);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 243:
      if (lookahead == 'o')
        ADVANCE(244);
      END_STATE();
    case 244:
      if (lookahead == 'v')
        ADVANCE(245);
      END_STATE();
    case 245:
      if (lookahead == 'e')
        ADVANCE(246);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_remove);
      END_STATE();
    case 247:
      if (lookahead == 'u')
        ADVANCE(248);
      END_STATE();
    case 248:
      if (lookahead == 'r')
        ADVANCE(249);
      END_STATE();
    case 249:
      if (lookahead == 'n')
        ADVANCE(250);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 251:
      if (lookahead == 'b')
        ADVANCE(252);
      if (lookahead == 'e')
        ADVANCE(256);
      if (lookahead == 'h')
        ADVANCE(262);
      if (lookahead == 'i')
        ADVANCE(266);
      if (lookahead == 't')
        ADVANCE(271);
      if (lookahead == 'w')
        ADVANCE(283);
      END_STATE();
    case 252:
      if (lookahead == 'y')
        ADVANCE(253);
      END_STATE();
    case 253:
      if (lookahead == 't')
        ADVANCE(254);
      END_STATE();
    case 254:
      if (lookahead == 'e')
        ADVANCE(255);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_sbyte);
      END_STATE();
    case 256:
      if (lookahead == 'a')
        ADVANCE(257);
      if (lookahead == 't')
        ADVANCE(261);
      END_STATE();
    case 257:
      if (lookahead == 'l')
        ADVANCE(258);
      END_STATE();
    case 258:
      if (lookahead == 'e')
        ADVANCE(259);
      END_STATE();
    case 259:
      if (lookahead == 'd')
        ADVANCE(260);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 262:
      if (lookahead == 'o')
        ADVANCE(263);
      END_STATE();
    case 263:
      if (lookahead == 'r')
        ADVANCE(264);
      END_STATE();
    case 264:
      if (lookahead == 't')
        ADVANCE(265);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 266:
      if (lookahead == 'z')
        ADVANCE(267);
      END_STATE();
    case 267:
      if (lookahead == 'e')
        ADVANCE(268);
      END_STATE();
    case 268:
      if (lookahead == 'o')
        ADVANCE(269);
      END_STATE();
    case 269:
      if (lookahead == 'f')
        ADVANCE(270);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 271:
      if (lookahead == 'a')
        ADVANCE(272);
      if (lookahead == 'r')
        ADVANCE(276);
      END_STATE();
    case 272:
      if (lookahead == 't')
        ADVANCE(273);
      END_STATE();
    case 273:
      if (lookahead == 'i')
        ADVANCE(274);
      END_STATE();
    case 274:
      if (lookahead == 'c')
        ADVANCE(275);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 276:
      if (lookahead == 'i')
        ADVANCE(277);
      if (lookahead == 'u')
        ADVANCE(280);
      END_STATE();
    case 277:
      if (lookahead == 'n')
        ADVANCE(278);
      END_STATE();
    case 278:
      if (lookahead == 'g')
        ADVANCE(279);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 280:
      if (lookahead == 'c')
        ADVANCE(281);
      END_STATE();
    case 281:
      if (lookahead == 't')
        ADVANCE(282);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 283:
      if (lookahead == 'i')
        ADVANCE(284);
      END_STATE();
    case 284:
      if (lookahead == 't')
        ADVANCE(285);
      END_STATE();
    case 285:
      if (lookahead == 'c')
        ADVANCE(286);
      END_STATE();
    case 286:
      if (lookahead == 'h')
        ADVANCE(287);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 288:
      if (lookahead == 'h')
        ADVANCE(289);
      if (lookahead == 'r')
        ADVANCE(295);
      if (lookahead == 'y')
        ADVANCE(299);
      END_STATE();
    case 289:
      if (lookahead == 'i')
        ADVANCE(290);
      if (lookahead == 'r')
        ADVANCE(292);
      END_STATE();
    case 290:
      if (lookahead == 's')
        ADVANCE(291);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 292:
      if (lookahead == 'o')
        ADVANCE(293);
      END_STATE();
    case 293:
      if (lookahead == 'w')
        ADVANCE(294);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 295:
      if (lookahead == 'u')
        ADVANCE(296);
      if (lookahead == 'y')
        ADVANCE(298);
      END_STATE();
    case 296:
      if (lookahead == 'e')
        ADVANCE(297);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 299:
      if (lookahead == 'p')
        ADVANCE(300);
      END_STATE();
    case 300:
      if (lookahead == 'e')
        ADVANCE(301);
      END_STATE();
    case 301:
      if (lookahead == 'o')
        ADVANCE(302);
      END_STATE();
    case 302:
      if (lookahead == 'f')
        ADVANCE(303);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 304:
      if (lookahead == 'i')
        ADVANCE(305);
      if (lookahead == 'l')
        ADVANCE(308);
      if (lookahead == 'n')
        ADVANCE(312);
      if (lookahead == 's')
        ADVANCE(324);
      END_STATE();
    case 305:
      if (lookahead == 'n')
        ADVANCE(306);
      END_STATE();
    case 306:
      if (lookahead == 't')
        ADVANCE(307);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_uint);
      END_STATE();
    case 308:
      if (lookahead == 'o')
        ADVANCE(309);
      END_STATE();
    case 309:
      if (lookahead == 'n')
        ADVANCE(310);
      END_STATE();
    case 310:
      if (lookahead == 'g')
        ADVANCE(311);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_ulong);
      END_STATE();
    case 312:
      if (lookahead == 'c')
        ADVANCE(313);
      if (lookahead == 's')
        ADVANCE(320);
      END_STATE();
    case 313:
      if (lookahead == 'h')
        ADVANCE(314);
      END_STATE();
    case 314:
      if (lookahead == 'e')
        ADVANCE(315);
      END_STATE();
    case 315:
      if (lookahead == 'c')
        ADVANCE(316);
      END_STATE();
    case 316:
      if (lookahead == 'k')
        ADVANCE(317);
      END_STATE();
    case 317:
      if (lookahead == 'e')
        ADVANCE(318);
      END_STATE();
    case 318:
      if (lookahead == 'd')
        ADVANCE(319);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_unchecked);
      END_STATE();
    case 320:
      if (lookahead == 'a')
        ADVANCE(321);
      END_STATE();
    case 321:
      if (lookahead == 'f')
        ADVANCE(322);
      END_STATE();
    case 322:
      if (lookahead == 'e')
        ADVANCE(323);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 324:
      if (lookahead == 'h')
        ADVANCE(325);
      if (lookahead == 'i')
        ADVANCE(329);
      END_STATE();
    case 325:
      if (lookahead == 'o')
        ADVANCE(326);
      END_STATE();
    case 326:
      if (lookahead == 'r')
        ADVANCE(327);
      END_STATE();
    case 327:
      if (lookahead == 't')
        ADVANCE(328);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_ushort);
      END_STATE();
    case 329:
      if (lookahead == 'n')
        ADVANCE(330);
      END_STATE();
    case 330:
      if (lookahead == 'g')
        ADVANCE(331);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 332:
      if (lookahead == 'a')
        ADVANCE(333);
      if (lookahead == 'i')
        ADVANCE(335);
      if (lookahead == 'o')
        ADVANCE(341);
      END_STATE();
    case 333:
      if (lookahead == 'r')
        ADVANCE(334);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 335:
      if (lookahead == 'r')
        ADVANCE(336);
      END_STATE();
    case 336:
      if (lookahead == 't')
        ADVANCE(337);
      END_STATE();
    case 337:
      if (lookahead == 'u')
        ADVANCE(338);
      END_STATE();
    case 338:
      if (lookahead == 'a')
        ADVANCE(339);
      END_STATE();
    case 339:
      if (lookahead == 'l')
        ADVANCE(340);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 341:
      if (lookahead == 'i')
        ADVANCE(342);
      if (lookahead == 'l')
        ADVANCE(344);
      END_STATE();
    case 342:
      if (lookahead == 'd')
        ADVANCE(343);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_void_keyword);
      END_STATE();
    case 344:
      if (lookahead == 'a')
        ADVANCE(345);
      END_STATE();
    case 345:
      if (lookahead == 't')
        ADVANCE(346);
      END_STATE();
    case 346:
      if (lookahead == 'i')
        ADVANCE(347);
      END_STATE();
    case 347:
      if (lookahead == 'l')
        ADVANCE(348);
      END_STATE();
    case 348:
      if (lookahead == 'e')
        ADVANCE(349);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 350:
      if (lookahead == 'h')
        ADVANCE(351);
      END_STATE();
    case 351:
      if (lookahead == 'e')
        ADVANCE(352);
      if (lookahead == 'i')
        ADVANCE(356);
      END_STATE();
    case 352:
      if (lookahead == 'n')
        ADVANCE(353);
      if (lookahead == 'r')
        ADVANCE(354);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 354:
      if (lookahead == 'e')
        ADVANCE(355);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 356:
      if (lookahead == 'l')
        ADVANCE(357);
      END_STATE();
    case 357:
      if (lookahead == 'e')
        ADVANCE(358);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 359:
      if (lookahead == 'i')
        ADVANCE(360);
      END_STATE();
    case 360:
      if (lookahead == 'e')
        ADVANCE(361);
      END_STATE();
    case 361:
      if (lookahead == 'l')
        ADVANCE(362);
      END_STATE();
    case 362:
      if (lookahead == 'd')
        ADVANCE(363);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 99},
  [2] = {.lex_state = 101},
  [3] = {.lex_state = 101},
  [4] = {.lex_state = 101},
  [5] = {.lex_state = 101},
  [6] = {.lex_state = 101},
  [7] = {.lex_state = 101},
  [8] = {.lex_state = 101},
  [9] = {.lex_state = 101},
  [10] = {.lex_state = 101},
  [11] = {.lex_state = 101},
  [12] = {.lex_state = 101},
  [13] = {.lex_state = 102},
  [14] = {.lex_state = 101},
  [15] = {.lex_state = 101},
  [16] = {.lex_state = 101},
  [17] = {.lex_state = 101},
  [18] = {.lex_state = 101},
  [19] = {.lex_state = 101},
  [20] = {.lex_state = 101},
  [21] = {.lex_state = 101},
  [22] = {.lex_state = 101},
  [23] = {.lex_state = 101},
  [24] = {.lex_state = 101},
  [25] = {.lex_state = 101},
  [26] = {.lex_state = 101},
  [27] = {.lex_state = 101},
  [28] = {.lex_state = 103},
  [29] = {.lex_state = 105},
  [30] = {.lex_state = 105},
  [31] = {.lex_state = 105},
  [32] = {.lex_state = 105},
  [33] = {.lex_state = 101},
  [34] = {.lex_state = 101},
  [35] = {.lex_state = 101},
  [36] = {.lex_state = 105},
  [37] = {.lex_state = 105},
  [38] = {.lex_state = 105},
  [39] = {.lex_state = 109},
  [40] = {.lex_state = 109},
  [41] = {.lex_state = 109},
  [42] = {.lex_state = 105},
  [43] = {.lex_state = 105},
  [44] = {.lex_state = 110},
  [45] = {.lex_state = 101},
  [46] = {.lex_state = 110},
  [47] = {.lex_state = 101},
  [48] = {.lex_state = 101},
  [49] = {.lex_state = 101},
  [50] = {.lex_state = 101},
  [51] = {.lex_state = 101},
  [52] = {.lex_state = 101},
  [53] = {.lex_state = 101},
  [54] = {.lex_state = 101},
  [55] = {.lex_state = 101},
  [56] = {.lex_state = 101},
  [57] = {.lex_state = 101},
  [58] = {.lex_state = 101},
  [59] = {.lex_state = 101},
  [60] = {.lex_state = 101},
  [61] = {.lex_state = 105},
  [62] = {.lex_state = 105},
  [63] = {.lex_state = 101},
  [64] = {.lex_state = 112},
  [65] = {.lex_state = 101},
  [66] = {.lex_state = 101},
  [67] = {.lex_state = 112},
  [68] = {.lex_state = 105},
  [69] = {.lex_state = 105},
  [70] = {.lex_state = 105},
  [71] = {.lex_state = 101},
  [72] = {.lex_state = 113},
  [73] = {.lex_state = 101},
  [74] = {.lex_state = 101},
  [75] = {.lex_state = 105},
  [76] = {.lex_state = 105},
  [77] = {.lex_state = 105},
  [78] = {.lex_state = 112},
  [79] = {.lex_state = 101},
  [80] = {.lex_state = 105},
  [81] = {.lex_state = 105},
  [82] = {.lex_state = 105},
  [83] = {.lex_state = 101},
  [84] = {.lex_state = 114},
  [85] = {.lex_state = 109},
  [86] = {.lex_state = 113},
  [87] = {.lex_state = 101},
  [88] = {.lex_state = 109},
  [89] = {.lex_state = 112},
  [90] = {.lex_state = 101},
  [91] = {.lex_state = 105},
  [92] = {.lex_state = 105},
  [93] = {.lex_state = 105},
  [94] = {.lex_state = 101},
  [95] = {.lex_state = 101},
  [96] = {.lex_state = 109},
  [97] = {.lex_state = 110},
  [98] = {.lex_state = 101},
  [99] = {.lex_state = 101},
  [100] = {.lex_state = 101},
  [101] = {.lex_state = 105},
  [102] = {.lex_state = 101},
  [103] = {.lex_state = 101},
  [104] = {.lex_state = 101},
  [105] = {.lex_state = 101},
  [106] = {.lex_state = 101},
  [107] = {.lex_state = 101},
  [108] = {.lex_state = 101},
  [109] = {.lex_state = 101},
  [110] = {.lex_state = 101},
  [111] = {.lex_state = 112},
  [112] = {.lex_state = 105},
  [113] = {.lex_state = 105},
  [114] = {.lex_state = 121},
  [115] = {.lex_state = 112},
  [116] = {.lex_state = 113},
  [117] = {.lex_state = 105},
  [118] = {.lex_state = 105},
  [119] = {.lex_state = 105},
  [120] = {.lex_state = 112},
  [121] = {.lex_state = 105},
  [122] = {.lex_state = 105},
  [123] = {.lex_state = 105},
  [124] = {.lex_state = 112},
  [125] = {.lex_state = 105},
  [126] = {.lex_state = 105},
  [127] = {.lex_state = 105},
  [128] = {.lex_state = 114},
  [129] = {.lex_state = 114},
  [130] = {.lex_state = 113},
  [131] = {.lex_state = 113},
  [132] = {.lex_state = 101},
  [133] = {.lex_state = 101},
  [134] = {.lex_state = 101},
  [135] = {.lex_state = 101},
  [136] = {.lex_state = 101},
  [137] = {.lex_state = 101},
  [138] = {.lex_state = 122},
  [139] = {.lex_state = 101},
  [140] = {.lex_state = 101},
  [141] = {.lex_state = 123},
  [142] = {.lex_state = 123},
  [143] = {.lex_state = 101},
  [144] = {.lex_state = 113},
  [145] = {.lex_state = 105},
  [146] = {.lex_state = 101},
  [147] = {.lex_state = 113},
  [148] = {.lex_state = 113},
  [149] = {.lex_state = 125},
  [150] = {.lex_state = 105},
  [151] = {.lex_state = 105},
  [152] = {.lex_state = 113},
  [153] = {.lex_state = 101},
  [154] = {.lex_state = 112},
  [155] = {.lex_state = 101},
  [156] = {.lex_state = 128},
  [157] = {.lex_state = 109},
  [158] = {.lex_state = 109},
  [159] = {.lex_state = 109},
  [160] = {.lex_state = 109},
  [161] = {.lex_state = 101},
  [162] = {.lex_state = 113},
  [163] = {.lex_state = 101},
  [164] = {.lex_state = 101},
  [165] = {.lex_state = 101},
  [166] = {.lex_state = 101},
  [167] = {.lex_state = 112},
  [168] = {.lex_state = 101},
  [169] = {.lex_state = 128},
  [170] = {.lex_state = 129},
  [171] = {.lex_state = 129},
  [172] = {.lex_state = 101},
  [173] = {.lex_state = 101},
  [174] = {.lex_state = 105},
  [175] = {.lex_state = 134},
  [176] = {.lex_state = 105},
  [177] = {.lex_state = 105},
  [178] = {.lex_state = 105},
  [179] = {.lex_state = 105},
  [180] = {.lex_state = 101},
  [181] = {.lex_state = 101},
  [182] = {.lex_state = 109},
  [183] = {.lex_state = 101},
  [184] = {.lex_state = 101},
  [185] = {.lex_state = 101},
  [186] = {.lex_state = 105},
  [187] = {.lex_state = 101},
  [188] = {.lex_state = 101},
  [189] = {.lex_state = 112},
  [190] = {.lex_state = 121},
  [191] = {.lex_state = 112},
  [192] = {.lex_state = 113},
  [193] = {.lex_state = 113},
  [194] = {.lex_state = 113},
  [195] = {.lex_state = 105},
  [196] = {.lex_state = 105},
  [197] = {.lex_state = 113},
  [198] = {.lex_state = 112},
  [199] = {.lex_state = 112},
  [200] = {.lex_state = 105},
  [201] = {.lex_state = 105},
  [202] = {.lex_state = 113},
  [203] = {.lex_state = 112},
  [204] = {.lex_state = 112},
  [205] = {.lex_state = 105},
  [206] = {.lex_state = 105},
  [207] = {.lex_state = 101},
  [208] = {.lex_state = 136},
  [209] = {.lex_state = 114},
  [210] = {.lex_state = 101},
  [211] = {.lex_state = 137},
  [212] = {.lex_state = 101},
  [213] = {.lex_state = 101},
  [214] = {.lex_state = 109},
  [215] = {.lex_state = 109},
  [216] = {.lex_state = 101},
  [217] = {.lex_state = 122},
  [218] = {.lex_state = 105},
  [219] = {.lex_state = 99},
  [220] = {.lex_state = 138},
  [221] = {.lex_state = 123},
  [222] = {.lex_state = 123},
  [223] = {.lex_state = 101},
  [224] = {.lex_state = 101},
  [225] = {.lex_state = 101},
  [226] = {.lex_state = 122},
  [227] = {.lex_state = 101},
  [228] = {.lex_state = 123},
  [229] = {.lex_state = 123},
  [230] = {.lex_state = 105},
  [231] = {.lex_state = 101},
  [232] = {.lex_state = 141},
  [233] = {.lex_state = 113},
  [234] = {.lex_state = 113},
  [235] = {.lex_state = 141},
  [236] = {.lex_state = 141},
  [237] = {.lex_state = 101},
  [238] = {.lex_state = 113},
  [239] = {.lex_state = 101},
  [240] = {.lex_state = 113},
  [241] = {.lex_state = 101},
  [242] = {.lex_state = 113},
  [243] = {.lex_state = 113},
  [244] = {.lex_state = 101},
  [245] = {.lex_state = 101},
  [246] = {.lex_state = 137},
  [247] = {.lex_state = 112},
  [248] = {.lex_state = 101},
  [249] = {.lex_state = 101},
  [250] = {.lex_state = 128},
  [251] = {.lex_state = 101},
  [252] = {.lex_state = 101},
  [253] = {.lex_state = 101},
  [254] = {.lex_state = 101},
  [255] = {.lex_state = 137},
  [256] = {.lex_state = 101},
  [257] = {.lex_state = 122},
  [258] = {.lex_state = 99},
  [259] = {.lex_state = 122},
  [260] = {.lex_state = 101},
  [261] = {.lex_state = 112},
  [262] = {.lex_state = 101},
  [263] = {.lex_state = 101},
  [264] = {.lex_state = 141},
  [265] = {.lex_state = 101},
  [266] = {.lex_state = 113},
  [267] = {.lex_state = 129},
  [268] = {.lex_state = 129},
  [269] = {.lex_state = 101},
  [270] = {.lex_state = 101},
  [271] = {.lex_state = 105},
  [272] = {.lex_state = 101},
  [273] = {.lex_state = 101},
  [274] = {.lex_state = 101},
  [275] = {.lex_state = 101},
  [276] = {.lex_state = 114},
  [277] = {.lex_state = 114},
  [278] = {.lex_state = 101},
  [279] = {.lex_state = 134},
  [280] = {.lex_state = 134},
  [281] = {.lex_state = 137},
  [282] = {.lex_state = 105},
  [283] = {.lex_state = 105},
  [284] = {.lex_state = 105},
  [285] = {.lex_state = 129},
  [286] = {.lex_state = 105},
  [287] = {.lex_state = 105},
  [288] = {.lex_state = 105},
  [289] = {.lex_state = 105},
  [290] = {.lex_state = 105},
  [291] = {.lex_state = 101},
  [292] = {.lex_state = 109},
  [293] = {.lex_state = 112},
  [294] = {.lex_state = 137},
  [295] = {.lex_state = 113},
  [296] = {.lex_state = 113},
  [297] = {.lex_state = 113},
  [298] = {.lex_state = 105},
  [299] = {.lex_state = 137},
  [300] = {.lex_state = 113},
  [301] = {.lex_state = 112},
  [302] = {.lex_state = 112},
  [303] = {.lex_state = 105},
  [304] = {.lex_state = 137},
  [305] = {.lex_state = 113},
  [306] = {.lex_state = 112},
  [307] = {.lex_state = 112},
  [308] = {.lex_state = 105},
  [309] = {.lex_state = 114},
  [310] = {.lex_state = 136},
  [311] = {.lex_state = 114},
  [312] = {.lex_state = 109},
  [313] = {.lex_state = 109},
  [314] = {.lex_state = 105},
  [315] = {.lex_state = 105},
  [316] = {.lex_state = 109},
  [317] = {.lex_state = 105},
  [318] = {.lex_state = 105},
  [319] = {.lex_state = 105},
  [320] = {.lex_state = 123},
  [321] = {.lex_state = 105},
  [322] = {.lex_state = 113},
  [323] = {.lex_state = 134},
  [324] = {.lex_state = 109},
  [325] = {.lex_state = 109},
  [326] = {.lex_state = 109},
  [327] = {.lex_state = 109},
  [328] = {.lex_state = 109},
  [329] = {.lex_state = 141},
  [330] = {.lex_state = 101},
  [331] = {.lex_state = 141},
  [332] = {.lex_state = 101},
  [333] = {.lex_state = 113},
  [334] = {.lex_state = 123},
  [335] = {.lex_state = 101},
  [336] = {.lex_state = 123},
  [337] = {.lex_state = 101},
  [338] = {.lex_state = 101},
  [339] = {.lex_state = 101},
  [340] = {.lex_state = 122},
  [341] = {.lex_state = 123},
  [342] = {.lex_state = 113},
  [343] = {.lex_state = 113},
  [344] = {.lex_state = 141},
  [345] = {.lex_state = 113},
  [346] = {.lex_state = 101},
  [347] = {.lex_state = 101},
  [348] = {.lex_state = 101},
  [349] = {.lex_state = 105},
  [350] = {.lex_state = 105},
  [351] = {.lex_state = 112},
  [352] = {.lex_state = 112},
  [353] = {.lex_state = 112},
  [354] = {.lex_state = 101},
  [355] = {.lex_state = 101},
  [356] = {.lex_state = 101},
  [357] = {.lex_state = 141},
  [358] = {.lex_state = 141},
  [359] = {.lex_state = 141},
  [360] = {.lex_state = 143},
  [361] = {.lex_state = 149},
  [362] = {.lex_state = 143},
  [363] = {.lex_state = 143},
  [364] = {.lex_state = 153},
  [365] = {.lex_state = 156},
  [366] = {.lex_state = 129},
  [367] = {.lex_state = 143},
  [368] = {.lex_state = 141},
  [369] = {.lex_state = 163},
  [370] = {.lex_state = 101},
  [371] = {.lex_state = 164},
  [372] = {.lex_state = 105},
  [373] = {.lex_state = 105},
  [374] = {.lex_state = 105},
  [375] = {.lex_state = 109},
  [376] = {.lex_state = 101},
  [377] = {.lex_state = 141},
  [378] = {.lex_state = 105},
  [379] = {.lex_state = 109},
  [380] = {.lex_state = 109},
  [381] = {.lex_state = 109},
  [382] = {.lex_state = 141},
  [383] = {.lex_state = 105},
  [384] = {.lex_state = 141},
  [385] = {.lex_state = 101},
  [386] = {.lex_state = 129},
  [387] = {.lex_state = 112},
  [388] = {.lex_state = 105},
  [389] = {.lex_state = 101},
  [390] = {.lex_state = 141},
  [391] = {.lex_state = 129},
  [392] = {.lex_state = 109},
  [393] = {.lex_state = 101},
  [394] = {.lex_state = 101},
  [395] = {.lex_state = 101},
  [396] = {.lex_state = 101},
  [397] = {.lex_state = 122},
  [398] = {.lex_state = 101},
  [399] = {.lex_state = 123},
  [400] = {.lex_state = 123},
  [401] = {.lex_state = 105},
  [402] = {.lex_state = 128},
  [403] = {.lex_state = 128},
  [404] = {.lex_state = 109},
  [405] = {.lex_state = 105},
  [406] = {.lex_state = 105},
  [407] = {.lex_state = 128},
  [408] = {.lex_state = 128},
  [409] = {.lex_state = 101},
  [410] = {.lex_state = 122},
  [411] = {.lex_state = 99},
  [412] = {.lex_state = 122},
  [413] = {.lex_state = 105},
  [414] = {.lex_state = 112},
  [415] = {.lex_state = 101},
  [416] = {.lex_state = 122},
  [417] = {.lex_state = 105},
  [418] = {.lex_state = 105},
  [419] = {.lex_state = 134},
  [420] = {.lex_state = 101},
  [421] = {.lex_state = 101},
  [422] = {.lex_state = 101},
  [423] = {.lex_state = 101},
  [424] = {.lex_state = 128},
  [425] = {.lex_state = 141},
  [426] = {.lex_state = 129},
  [427] = {.lex_state = 129},
  [428] = {.lex_state = 129},
  [429] = {.lex_state = 137},
  [430] = {.lex_state = 113},
  [431] = {.lex_state = 129},
  [432] = {.lex_state = 141},
  [433] = {.lex_state = 129},
  [434] = {.lex_state = 109},
  [435] = {.lex_state = 99},
  [436] = {.lex_state = 101},
  [437] = {.lex_state = 114},
  [438] = {.lex_state = 105},
  [439] = {.lex_state = 101},
  [440] = {.lex_state = 101},
  [441] = {.lex_state = 165},
  [442] = {.lex_state = 114},
  [443] = {.lex_state = 114},
  [444] = {.lex_state = 114},
  [445] = {.lex_state = 101},
  [446] = {.lex_state = 101},
  [447] = {.lex_state = 101},
  [448] = {.lex_state = 134},
  [449] = {.lex_state = 105},
  [450] = {.lex_state = 105},
  [451] = {.lex_state = 105},
  [452] = {.lex_state = 129},
  [453] = {.lex_state = 101},
  [454] = {.lex_state = 137},
  [455] = {.lex_state = 105},
  [456] = {.lex_state = 105},
  [457] = {.lex_state = 105},
  [458] = {.lex_state = 105},
  [459] = {.lex_state = 105},
  [460] = {.lex_state = 137},
  [461] = {.lex_state = 113},
  [462] = {.lex_state = 113},
  [463] = {.lex_state = 113},
  [464] = {.lex_state = 137},
  [465] = {.lex_state = 113},
  [466] = {.lex_state = 112},
  [467] = {.lex_state = 112},
  [468] = {.lex_state = 137},
  [469] = {.lex_state = 113},
  [470] = {.lex_state = 112},
  [471] = {.lex_state = 112},
  [472] = {.lex_state = 105},
  [473] = {.lex_state = 109},
  [474] = {.lex_state = 105},
  [475] = {.lex_state = 101},
  [476] = {.lex_state = 113},
  [477] = {.lex_state = 113},
  [478] = {.lex_state = 105},
  [479] = {.lex_state = 141},
  [480] = {.lex_state = 113},
  [481] = {.lex_state = 101},
  [482] = {.lex_state = 123},
  [483] = {.lex_state = 113},
  [484] = {.lex_state = 101},
  [485] = {.lex_state = 109},
  [486] = {.lex_state = 166},
  [487] = {.lex_state = 101},
  [488] = {.lex_state = 134},
  [489] = {.lex_state = 101},
  [490] = {.lex_state = 101},
  [491] = {.lex_state = 141},
  [492] = {.lex_state = 129},
  [493] = {.lex_state = 112},
  [494] = {.lex_state = 129},
  [495] = {.lex_state = 99},
  [496] = {.lex_state = 123},
  [497] = {.lex_state = 123},
  [498] = {.lex_state = 123},
  [499] = {.lex_state = 109},
  [500] = {.lex_state = 105},
  [501] = {.lex_state = 105},
  [502] = {.lex_state = 105},
  [503] = {.lex_state = 113},
  [504] = {.lex_state = 129},
  [505] = {.lex_state = 101},
  [506] = {.lex_state = 112},
  [507] = {.lex_state = 112},
  [508] = {.lex_state = 113},
  [509] = {.lex_state = 112},
  [510] = {.lex_state = 101},
  [511] = {.lex_state = 101},
  [512] = {.lex_state = 101},
  [513] = {.lex_state = 101},
  [514] = {.lex_state = 101},
  [515] = {.lex_state = 101},
  [516] = {.lex_state = 105},
  [517] = {.lex_state = 105},
  [518] = {.lex_state = 101},
  [519] = {.lex_state = 101},
  [520] = {.lex_state = 141},
  [521] = {.lex_state = 134},
  [522] = {.lex_state = 143},
  [523] = {.lex_state = 143},
  [524] = {.lex_state = 141},
  [525] = {.lex_state = 141},
  [526] = {.lex_state = 143},
  [527] = {.lex_state = 143},
  [528] = {.lex_state = 143},
  [529] = {.lex_state = 143},
  [530] = {.lex_state = 153},
  [531] = {.lex_state = 141},
  [532] = {.lex_state = 141},
  [533] = {.lex_state = 141},
  [534] = {.lex_state = 141},
  [535] = {.lex_state = 141},
  [536] = {.lex_state = 141},
  [537] = {.lex_state = 141},
  [538] = {.lex_state = 141},
  [539] = {.lex_state = 141},
  [540] = {.lex_state = 141},
  [541] = {.lex_state = 141},
  [542] = {.lex_state = 101},
  [543] = {.lex_state = 141},
  [544] = {.lex_state = 141},
  [545] = {.lex_state = 105},
  [546] = {.lex_state = 141},
  [547] = {.lex_state = 141},
  [548] = {.lex_state = 141},
  [549] = {.lex_state = 141},
  [550] = {.lex_state = 141},
  [551] = {.lex_state = 105},
  [552] = {.lex_state = 141},
  [553] = {.lex_state = 129},
  [554] = {.lex_state = 141},
  [555] = {.lex_state = 141},
  [556] = {.lex_state = 141},
  [557] = {.lex_state = 141},
  [558] = {.lex_state = 105},
  [559] = {.lex_state = 109},
  [560] = {.lex_state = 109},
  [561] = {.lex_state = 109},
  [562] = {.lex_state = 101},
  [563] = {.lex_state = 141},
  [564] = {.lex_state = 141},
  [565] = {.lex_state = 129},
  [566] = {.lex_state = 105},
  [567] = {.lex_state = 141},
  [568] = {.lex_state = 105},
  [569] = {.lex_state = 141},
  [570] = {.lex_state = 163},
  [571] = {.lex_state = 141},
  [572] = {.lex_state = 123},
  [573] = {.lex_state = 123},
  [574] = {.lex_state = 141},
  [575] = {.lex_state = 113},
  [576] = {.lex_state = 101},
  [577] = {.lex_state = 109},
  [578] = {.lex_state = 101},
  [579] = {.lex_state = 101},
  [580] = {.lex_state = 101},
  [581] = {.lex_state = 122},
  [582] = {.lex_state = 123},
  [583] = {.lex_state = 113},
  [584] = {.lex_state = 141},
  [585] = {.lex_state = 113},
  [586] = {.lex_state = 128},
  [587] = {.lex_state = 101},
  [588] = {.lex_state = 114},
  [589] = {.lex_state = 105},
  [590] = {.lex_state = 112},
  [591] = {.lex_state = 122},
  [592] = {.lex_state = 105},
  [593] = {.lex_state = 105},
  [594] = {.lex_state = 134},
  [595] = {.lex_state = 101},
  [596] = {.lex_state = 112},
  [597] = {.lex_state = 105},
  [598] = {.lex_state = 105},
  [599] = {.lex_state = 109},
  [600] = {.lex_state = 105},
  [601] = {.lex_state = 101},
  [602] = {.lex_state = 112},
  [603] = {.lex_state = 101},
  [604] = {.lex_state = 101},
  [605] = {.lex_state = 122},
  [606] = {.lex_state = 99},
  [607] = {.lex_state = 122},
  [608] = {.lex_state = 128},
  [609] = {.lex_state = 141},
  [610] = {.lex_state = 141},
  [611] = {.lex_state = 141},
  [612] = {.lex_state = 141},
  [613] = {.lex_state = 141},
  [614] = {.lex_state = 141},
  [615] = {.lex_state = 141},
  [616] = {.lex_state = 141},
  [617] = {.lex_state = 141},
  [618] = {.lex_state = 141},
  [619] = {.lex_state = 137},
  [620] = {.lex_state = 129},
  [621] = {.lex_state = 113},
  [622] = {.lex_state = 129},
  [623] = {.lex_state = 134},
  [624] = {.lex_state = 109},
  [625] = {.lex_state = 101},
  [626] = {.lex_state = 165},
  [627] = {.lex_state = 141},
  [628] = {.lex_state = 165},
  [629] = {.lex_state = 165},
  [630] = {.lex_state = 101},
  [631] = {.lex_state = 101},
  [632] = {.lex_state = 109},
  [633] = {.lex_state = 165},
  [634] = {.lex_state = 114},
  [635] = {.lex_state = 114},
  [636] = {.lex_state = 114},
  [637] = {.lex_state = 101},
  [638] = {.lex_state = 101},
  [639] = {.lex_state = 105},
  [640] = {.lex_state = 105},
  [641] = {.lex_state = 105},
  [642] = {.lex_state = 129},
  [643] = {.lex_state = 105},
  [644] = {.lex_state = 105},
  [645] = {.lex_state = 105},
  [646] = {.lex_state = 101},
  [647] = {.lex_state = 137},
  [648] = {.lex_state = 137},
  [649] = {.lex_state = 113},
  [650] = {.lex_state = 113},
  [651] = {.lex_state = 137},
  [652] = {.lex_state = 113},
  [653] = {.lex_state = 112},
  [654] = {.lex_state = 137},
  [655] = {.lex_state = 113},
  [656] = {.lex_state = 112},
  [657] = {.lex_state = 113},
  [658] = {.lex_state = 105},
  [659] = {.lex_state = 113},
  [660] = {.lex_state = 105},
  [661] = {.lex_state = 105},
  [662] = {.lex_state = 105},
  [663] = {.lex_state = 101},
  [664] = {.lex_state = 101},
  [665] = {.lex_state = 101},
  [666] = {.lex_state = 101},
  [667] = {.lex_state = 129},
  [668] = {.lex_state = 123},
  [669] = {.lex_state = 123},
  [670] = {.lex_state = 123},
  [671] = {.lex_state = 166},
  [672] = {.lex_state = 123},
  [673] = {.lex_state = 101},
  [674] = {.lex_state = 166},
  [675] = {.lex_state = 101},
  [676] = {.lex_state = 101},
  [677] = {.lex_state = 101},
  [678] = {.lex_state = 101},
  [679] = {.lex_state = 141},
  [680] = {.lex_state = 141},
  [681] = {.lex_state = 141},
  [682] = {.lex_state = 141},
  [683] = {.lex_state = 141},
  [684] = {.lex_state = 141},
  [685] = {.lex_state = 141},
  [686] = {.lex_state = 141},
  [687] = {.lex_state = 141},
  [688] = {.lex_state = 141},
  [689] = {.lex_state = 167},
  [690] = {.lex_state = 113},
  [691] = {.lex_state = 134},
  [692] = {.lex_state = 109},
  [693] = {.lex_state = 101},
  [694] = {.lex_state = 113},
  [695] = {.lex_state = 113},
  [696] = {.lex_state = 113},
  [697] = {.lex_state = 101},
  [698] = {.lex_state = 101},
  [699] = {.lex_state = 101},
  [700] = {.lex_state = 101},
  [701] = {.lex_state = 112},
  [702] = {.lex_state = 112},
  [703] = {.lex_state = 105},
  [704] = {.lex_state = 105},
  [705] = {.lex_state = 141},
  [706] = {.lex_state = 143},
  [707] = {.lex_state = 141},
  [708] = {.lex_state = 141},
  [709] = {.lex_state = 141},
  [710] = {.lex_state = 141},
  [711] = {.lex_state = 141},
  [712] = {.lex_state = 141},
  [713] = {.lex_state = 141},
  [714] = {.lex_state = 141},
  [715] = {.lex_state = 141},
  [716] = {.lex_state = 143},
  [717] = {.lex_state = 143},
  [718] = {.lex_state = 143},
  [719] = {.lex_state = 143},
  [720] = {.lex_state = 143},
  [721] = {.lex_state = 153},
  [722] = {.lex_state = 143},
  [723] = {.lex_state = 129},
  [724] = {.lex_state = 129},
  [725] = {.lex_state = 143},
  [726] = {.lex_state = 129},
  [727] = {.lex_state = 129},
  [728] = {.lex_state = 129},
  [729] = {.lex_state = 129},
  [730] = {.lex_state = 141},
  [731] = {.lex_state = 164},
  [732] = {.lex_state = 129},
  [733] = {.lex_state = 129},
  [734] = {.lex_state = 105},
  [735] = {.lex_state = 129},
  [736] = {.lex_state = 141},
  [737] = {.lex_state = 141},
  [738] = {.lex_state = 122},
  [739] = {.lex_state = 105},
  [740] = {.lex_state = 141},
  [741] = {.lex_state = 141},
  [742] = {.lex_state = 134},
  [743] = {.lex_state = 129},
  [744] = {.lex_state = 141},
  [745] = {.lex_state = 141},
  [746] = {.lex_state = 134},
  [747] = {.lex_state = 114},
  [748] = {.lex_state = 134},
  [749] = {.lex_state = 114},
  [750] = {.lex_state = 101},
  [751] = {.lex_state = 141},
  [752] = {.lex_state = 141},
  [753] = {.lex_state = 141},
  [754] = {.lex_state = 109},
  [755] = {.lex_state = 141},
  [756] = {.lex_state = 141},
  [757] = {.lex_state = 129},
  [758] = {.lex_state = 105},
  [759] = {.lex_state = 141},
  [760] = {.lex_state = 141},
  [761] = {.lex_state = 101},
  [762] = {.lex_state = 101},
  [763] = {.lex_state = 105},
  [764] = {.lex_state = 109},
  [765] = {.lex_state = 105},
  [766] = {.lex_state = 105},
  [767] = {.lex_state = 105},
  [768] = {.lex_state = 113},
  [769] = {.lex_state = 129},
  [770] = {.lex_state = 128},
  [771] = {.lex_state = 105},
  [772] = {.lex_state = 105},
  [773] = {.lex_state = 112},
  [774] = {.lex_state = 112},
  [775] = {.lex_state = 105},
  [776] = {.lex_state = 105},
  [777] = {.lex_state = 109},
  [778] = {.lex_state = 112},
  [779] = {.lex_state = 101},
  [780] = {.lex_state = 105},
  [781] = {.lex_state = 112},
  [782] = {.lex_state = 105},
  [783] = {.lex_state = 112},
  [784] = {.lex_state = 112},
  [785] = {.lex_state = 101},
  [786] = {.lex_state = 105},
  [787] = {.lex_state = 122},
  [788] = {.lex_state = 134},
  [789] = {.lex_state = 101},
  [790] = {.lex_state = 129},
  [791] = {.lex_state = 129},
  [792] = {.lex_state = 129},
  [793] = {.lex_state = 129},
  [794] = {.lex_state = 129},
  [795] = {.lex_state = 129},
  [796] = {.lex_state = 164},
  [797] = {.lex_state = 129},
  [798] = {.lex_state = 129},
  [799] = {.lex_state = 137},
  [800] = {.lex_state = 113},
  [801] = {.lex_state = 101},
  [802] = {.lex_state = 109},
  [803] = {.lex_state = 141},
  [804] = {.lex_state = 168},
  [805] = {.lex_state = 101},
  [806] = {.lex_state = 114},
  [807] = {.lex_state = 165},
  [808] = {.lex_state = 165},
  [809] = {.lex_state = 114},
  [810] = {.lex_state = 113},
  [811] = {.lex_state = 112},
  [812] = {.lex_state = 112},
  [813] = {.lex_state = 129},
  [814] = {.lex_state = 105},
  [815] = {.lex_state = 105},
  [816] = {.lex_state = 105},
  [817] = {.lex_state = 129},
  [818] = {.lex_state = 137},
  [819] = {.lex_state = 113},
  [820] = {.lex_state = 137},
  [821] = {.lex_state = 113},
  [822] = {.lex_state = 137},
  [823] = {.lex_state = 113},
  [824] = {.lex_state = 113},
  [825] = {.lex_state = 105},
  [826] = {.lex_state = 112},
  [827] = {.lex_state = 112},
  [828] = {.lex_state = 112},
  [829] = {.lex_state = 101},
  [830] = {.lex_state = 101},
  [831] = {.lex_state = 101},
  [832] = {.lex_state = 101},
  [833] = {.lex_state = 105},
  [834] = {.lex_state = 105},
  [835] = {.lex_state = 101},
  [836] = {.lex_state = 141},
  [837] = {.lex_state = 101},
  [838] = {.lex_state = 166},
  [839] = {.lex_state = 166},
  [840] = {.lex_state = 101},
  [841] = {.lex_state = 114},
  [842] = {.lex_state = 109},
  [843] = {.lex_state = 129},
  [844] = {.lex_state = 129},
  [845] = {.lex_state = 129},
  [846] = {.lex_state = 129},
  [847] = {.lex_state = 129},
  [848] = {.lex_state = 129},
  [849] = {.lex_state = 164},
  [850] = {.lex_state = 129},
  [851] = {.lex_state = 129},
  [852] = {.lex_state = 141},
  [853] = {.lex_state = 113},
  [854] = {.lex_state = 109},
  [855] = {.lex_state = 105},
  [856] = {.lex_state = 101},
  [857] = {.lex_state = 101},
  [858] = {.lex_state = 112},
  [859] = {.lex_state = 112},
  [860] = {.lex_state = 134},
  [861] = {.lex_state = 134},
  [862] = {.lex_state = 134},
  [863] = {.lex_state = 134},
  [864] = {.lex_state = 134},
  [865] = {.lex_state = 134},
  [866] = {.lex_state = 164},
  [867] = {.lex_state = 134},
  [868] = {.lex_state = 134},
  [869] = {.lex_state = 143},
  [870] = {.lex_state = 143},
  [871] = {.lex_state = 141},
  [872] = {.lex_state = 141},
  [873] = {.lex_state = 141},
  [874] = {.lex_state = 141},
  [875] = {.lex_state = 141},
  [876] = {.lex_state = 141},
  [877] = {.lex_state = 141},
  [878] = {.lex_state = 141},
  [879] = {.lex_state = 141},
  [880] = {.lex_state = 141},
  [881] = {.lex_state = 141},
  [882] = {.lex_state = 101},
  [883] = {.lex_state = 109},
  [884] = {.lex_state = 141},
  [885] = {.lex_state = 105},
  [886] = {.lex_state = 105},
  [887] = {.lex_state = 141},
  [888] = {.lex_state = 141},
  [889] = {.lex_state = 141},
  [890] = {.lex_state = 141},
  [891] = {.lex_state = 141},
  [892] = {.lex_state = 141},
  [893] = {.lex_state = 105},
  [894] = {.lex_state = 141},
  [895] = {.lex_state = 101},
  [896] = {.lex_state = 134},
  [897] = {.lex_state = 114},
  [898] = {.lex_state = 114},
  [899] = {.lex_state = 141},
  [900] = {.lex_state = 141},
  [901] = {.lex_state = 141},
  [902] = {.lex_state = 123},
  [903] = {.lex_state = 129},
  [904] = {.lex_state = 123},
  [905] = {.lex_state = 123},
  [906] = {.lex_state = 114},
  [907] = {.lex_state = 113},
  [908] = {.lex_state = 109},
  [909] = {.lex_state = 101},
  [910] = {.lex_state = 113},
  [911] = {.lex_state = 113},
  [912] = {.lex_state = 113},
  [913] = {.lex_state = 101},
  [914] = {.lex_state = 128},
  [915] = {.lex_state = 112},
  [916] = {.lex_state = 105},
  [917] = {.lex_state = 105},
  [918] = {.lex_state = 112},
  [919] = {.lex_state = 128},
  [920] = {.lex_state = 101},
  [921] = {.lex_state = 112},
  [922] = {.lex_state = 112},
  [923] = {.lex_state = 105},
  [924] = {.lex_state = 109},
  [925] = {.lex_state = 112},
  [926] = {.lex_state = 141},
  [927] = {.lex_state = 137},
  [928] = {.lex_state = 101},
  [929] = {.lex_state = 109},
  [930] = {.lex_state = 141},
  [931] = {.lex_state = 141},
  [932] = {.lex_state = 141},
  [933] = {.lex_state = 141},
  [934] = {.lex_state = 141},
  [935] = {.lex_state = 141},
  [936] = {.lex_state = 141},
  [937] = {.lex_state = 141},
  [938] = {.lex_state = 141},
  [939] = {.lex_state = 141},
  [940] = {.lex_state = 165},
  [941] = {.lex_state = 113},
  [942] = {.lex_state = 112},
  [943] = {.lex_state = 112},
  [944] = {.lex_state = 113},
  [945] = {.lex_state = 113},
  [946] = {.lex_state = 112},
  [947] = {.lex_state = 112},
  [948] = {.lex_state = 129},
  [949] = {.lex_state = 137},
  [950] = {.lex_state = 137},
  [951] = {.lex_state = 137},
  [952] = {.lex_state = 113},
  [953] = {.lex_state = 113},
  [954] = {.lex_state = 101},
  [955] = {.lex_state = 101},
  [956] = {.lex_state = 112},
  [957] = {.lex_state = 112},
  [958] = {.lex_state = 141},
  [959] = {.lex_state = 166},
  [960] = {.lex_state = 166},
  [961] = {.lex_state = 123},
  [962] = {.lex_state = 101},
  [963] = {.lex_state = 141},
  [964] = {.lex_state = 105},
  [965] = {.lex_state = 129},
  [966] = {.lex_state = 129},
  [967] = {.lex_state = 123},
  [968] = {.lex_state = 105},
  [969] = {.lex_state = 112},
  [970] = {.lex_state = 141},
  [971] = {.lex_state = 143},
  [972] = {.lex_state = 164},
  [973] = {.lex_state = 129},
  [974] = {.lex_state = 164},
  [975] = {.lex_state = 164},
  [976] = {.lex_state = 164},
  [977] = {.lex_state = 164},
  [978] = {.lex_state = 164},
  [979] = {.lex_state = 164},
  [980] = {.lex_state = 164},
  [981] = {.lex_state = 164},
  [982] = {.lex_state = 169},
  [983] = {.lex_state = 141},
  [984] = {.lex_state = 141},
  [985] = {.lex_state = 105},
  [986] = {.lex_state = 141},
  [987] = {.lex_state = 105},
  [988] = {.lex_state = 109},
  [989] = {.lex_state = 109},
  [990] = {.lex_state = 109},
  [991] = {.lex_state = 141},
  [992] = {.lex_state = 112},
  [993] = {.lex_state = 141},
  [994] = {.lex_state = 101},
  [995] = {.lex_state = 141},
  [996] = {.lex_state = 141},
  [997] = {.lex_state = 141},
  [998] = {.lex_state = 114},
  [999] = {.lex_state = 129},
  [1000] = {.lex_state = 129},
  [1001] = {.lex_state = 123},
  [1002] = {.lex_state = 105},
  [1003] = {.lex_state = 101},
  [1004] = {.lex_state = 101},
  [1005] = {.lex_state = 105},
  [1006] = {.lex_state = 101},
  [1007] = {.lex_state = 112},
  [1008] = {.lex_state = 101},
  [1009] = {.lex_state = 101},
  [1010] = {.lex_state = 112},
  [1011] = {.lex_state = 105},
  [1012] = {.lex_state = 105},
  [1013] = {.lex_state = 112},
  [1014] = {.lex_state = 129},
  [1015] = {.lex_state = 168},
  [1016] = {.lex_state = 168},
  [1017] = {.lex_state = 168},
  [1018] = {.lex_state = 168},
  [1019] = {.lex_state = 168},
  [1020] = {.lex_state = 168},
  [1021] = {.lex_state = 164},
  [1022] = {.lex_state = 168},
  [1023] = {.lex_state = 168},
  [1024] = {.lex_state = 113},
  [1025] = {.lex_state = 113},
  [1026] = {.lex_state = 113},
  [1027] = {.lex_state = 137},
  [1028] = {.lex_state = 113},
  [1029] = {.lex_state = 112},
  [1030] = {.lex_state = 112},
  [1031] = {.lex_state = 113},
  [1032] = {.lex_state = 141},
  [1033] = {.lex_state = 141},
  [1034] = {.lex_state = 141},
  [1035] = {.lex_state = 141},
  [1036] = {.lex_state = 141},
  [1037] = {.lex_state = 141},
  [1038] = {.lex_state = 141},
  [1039] = {.lex_state = 141},
  [1040] = {.lex_state = 141},
  [1041] = {.lex_state = 141},
  [1042] = {.lex_state = 101},
  [1043] = {.lex_state = 129},
  [1044] = {.lex_state = 113},
  [1045] = {.lex_state = 113},
  [1046] = {.lex_state = 113},
  [1047] = {.lex_state = 134},
  [1048] = {.lex_state = 141},
  [1049] = {.lex_state = 105},
  [1050] = {.lex_state = 114},
  [1051] = {.lex_state = 134},
  [1052] = {.lex_state = 141},
  [1053] = {.lex_state = 141},
  [1054] = {.lex_state = 141},
  [1055] = {.lex_state = 141},
  [1056] = {.lex_state = 141},
  [1057] = {.lex_state = 141},
  [1058] = {.lex_state = 141},
  [1059] = {.lex_state = 141},
  [1060] = {.lex_state = 105},
  [1061] = {.lex_state = 112},
  [1062] = {.lex_state = 141},
  [1063] = {.lex_state = 105},
  [1064] = {.lex_state = 109},
  [1065] = {.lex_state = 109},
  [1066] = {.lex_state = 109},
  [1067] = {.lex_state = 101},
  [1068] = {.lex_state = 105},
  [1069] = {.lex_state = 141},
  [1070] = {.lex_state = 129},
  [1071] = {.lex_state = 129},
  [1072] = {.lex_state = 105},
  [1073] = {.lex_state = 112},
  [1074] = {.lex_state = 105},
  [1075] = {.lex_state = 112},
  [1076] = {.lex_state = 128},
  [1077] = {.lex_state = 112},
  [1078] = {.lex_state = 112},
  [1079] = {.lex_state = 101},
  [1080] = {.lex_state = 141},
  [1081] = {.lex_state = 137},
  [1082] = {.lex_state = 137},
  [1083] = {.lex_state = 137},
  [1084] = {.lex_state = 113},
  [1085] = {.lex_state = 113},
  [1086] = {.lex_state = 113},
  [1087] = {.lex_state = 137},
  [1088] = {.lex_state = 166},
  [1089] = {.lex_state = 166},
  [1090] = {.lex_state = 166},
  [1091] = {.lex_state = 166},
  [1092] = {.lex_state = 166},
  [1093] = {.lex_state = 166},
  [1094] = {.lex_state = 164},
  [1095] = {.lex_state = 166},
  [1096] = {.lex_state = 166},
  [1097] = {.lex_state = 114},
  [1098] = {.lex_state = 164},
  [1099] = {.lex_state = 105},
  [1100] = {.lex_state = 105},
  [1101] = {.lex_state = 141},
  [1102] = {.lex_state = 134},
  [1103] = {.lex_state = 114},
  [1104] = {.lex_state = 114},
  [1105] = {.lex_state = 141},
  [1106] = {.lex_state = 164},
  [1107] = {.lex_state = 105},
  [1108] = {.lex_state = 141},
  [1109] = {.lex_state = 141},
  [1110] = {.lex_state = 112},
  [1111] = {.lex_state = 164},
  [1112] = {.lex_state = 105},
  [1113] = {.lex_state = 109},
  [1114] = {.lex_state = 109},
  [1115] = {.lex_state = 109},
  [1116] = {.lex_state = 112},
  [1117] = {.lex_state = 141},
  [1118] = {.lex_state = 141},
  [1119] = {.lex_state = 101},
  [1120] = {.lex_state = 141},
  [1121] = {.lex_state = 141},
  [1122] = {.lex_state = 141},
  [1123] = {.lex_state = 141},
  [1124] = {.lex_state = 141},
  [1125] = {.lex_state = 129},
  [1126] = {.lex_state = 129},
  [1127] = {.lex_state = 129},
  [1128] = {.lex_state = 113},
  [1129] = {.lex_state = 113},
  [1130] = {.lex_state = 112},
  [1131] = {.lex_state = 128},
  [1132] = {.lex_state = 112},
  [1133] = {.lex_state = 168},
  [1134] = {.lex_state = 137},
  [1135] = {.lex_state = 137},
  [1136] = {.lex_state = 137},
  [1137] = {.lex_state = 141},
  [1138] = {.lex_state = 123},
  [1139] = {.lex_state = 141},
  [1140] = {.lex_state = 141},
  [1141] = {.lex_state = 141},
  [1142] = {.lex_state = 141},
  [1143] = {.lex_state = 141},
  [1144] = {.lex_state = 141},
  [1145] = {.lex_state = 141},
  [1146] = {.lex_state = 141},
  [1147] = {.lex_state = 141},
  [1148] = {.lex_state = 141},
  [1149] = {.lex_state = 141},
  [1150] = {.lex_state = 101},
  [1151] = {.lex_state = 134},
  [1152] = {.lex_state = 114},
  [1153] = {.lex_state = 114},
  [1154] = {.lex_state = 128},
  [1155] = {.lex_state = 112},
  [1156] = {.lex_state = 166},
  [1157] = {.lex_state = 141},
  [1158] = {.lex_state = 141},
  [1159] = {.lex_state = 134},
  [1160] = {.lex_state = 114},
  [1161] = {.lex_state = 114},
  [1162] = {.lex_state = 101},
  [1163] = {.lex_state = 141},
  [1164] = {.lex_state = 141},
  [1165] = {.lex_state = 141},
  [1166] = {.lex_state = 141},
  [1167] = {.lex_state = 141},
  [1168] = {.lex_state = 141},
  [1169] = {.lex_state = 141},
  [1170] = {.lex_state = 141},
  [1171] = {.lex_state = 101},
  [1172] = {.lex_state = 105},
  [1173] = {.lex_state = 109},
  [1174] = {.lex_state = 109},
  [1175] = {.lex_state = 109},
  [1176] = {.lex_state = 141},
  [1177] = {.lex_state = 141},
  [1178] = {.lex_state = 141},
  [1179] = {.lex_state = 141},
  [1180] = {.lex_state = 141},
  [1181] = {.lex_state = 141},
  [1182] = {.lex_state = 141},
  [1183] = {.lex_state = 141},
  [1184] = {.lex_state = 134},
  [1185] = {.lex_state = 114},
  [1186] = {.lex_state = 114},
  [1187] = {.lex_state = 141},
  [1188] = {.lex_state = 141},
  [1189] = {.lex_state = 141},
  [1190] = {.lex_state = 141},
  [1191] = {.lex_state = 141},
  [1192] = {.lex_state = 141},
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_1] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_decimal] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(3),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_sbyte] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_uint] = ACTIONS(1),
    [anon_sym_ulong] = ACTIONS(1),
    [anon_sym_ushort] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_partial] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_remove] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_implicit] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [sym_void_keyword] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_params] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym__hexadecimal_escape_sequence] = ACTIONS(1),
    [aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1),
    [aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1),
    [anon_sym_BSLASH_SQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_DQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1),
    [anon_sym_BSLASH0] = ACTIONS(1),
    [anon_sym_BSLASHa] = ACTIONS(1),
    [anon_sym_BSLASHb] = ACTIONS(1),
    [anon_sym_BSLASHf] = ACTIONS(1),
    [anon_sym_BSLASHn] = ACTIONS(1),
    [anon_sym_BSLASHr] = ACTIONS(1),
    [anon_sym_BSLASHt] = ACTIONS(1),
    [anon_sym_BSLASHv] = ACTIONS(1),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(3),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1),
    [sym__integer_type_suffix] = ACTIONS(3),
    [sym_null_literal] = ACTIONS(1),
    [sym__real_type_suffix] = ACTIONS(3),
    [sym__exponent_part] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_AT_DQUOTE] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym_comment] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_checked] = ACTIONS(1),
    [anon_sym_unchecked] = ACTIONS(1),
    [anon_sym_lock] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
  },
  [1] = {
    [sym_compilation_unit] = STATE(13),
    [sym__type_declaration] = STATE(19),
    [sym_modifiers] = STATE(14),
    [sym_extern_alias_directive] = STATE(16),
    [sym_using_directive] = STATE(17),
    [sym_namespace_declaration] = STATE(19),
    [sym_class_declaration] = STATE(19),
    [sym_interface_declaration] = STATE(19),
    [sym_struct_declaration] = STATE(19),
    [sym_enum_declaration] = STATE(19),
    [sym_delegate_declaration] = STATE(19),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(18),
    [aux_sym_compilation_unit_repeat1] = STATE(16),
    [aux_sym_compilation_unit_repeat2] = STATE(17),
    [aux_sym_compilation_unit_repeat3] = STATE(18),
    [aux_sym_compilation_unit_repeat4] = STATE(19),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_1] = ACTIONS(7),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(11),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [2] = {
    [sym__type_declaration] = STATE(25),
    [sym_modifiers] = STATE(14),
    [sym_extern_alias_directive] = STATE(22),
    [sym_using_directive] = STATE(23),
    [sym_namespace_declaration] = STATE(25),
    [sym_class_declaration] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_struct_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_delegate_declaration] = STATE(25),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(24),
    [aux_sym_compilation_unit_repeat1] = STATE(22),
    [aux_sym_compilation_unit_repeat2] = STATE(23),
    [aux_sym_compilation_unit_repeat3] = STATE(24),
    [aux_sym_compilation_unit_repeat4] = STATE(25),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(11),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [3] = {
    [anon_sym_abstract] = ACTIONS(35),
    [anon_sym_async] = ACTIONS(35),
    [anon_sym_extern] = ACTIONS(35),
    [anon_sym_internal] = ACTIONS(35),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(35),
    [anon_sym_private] = ACTIONS(35),
    [anon_sym_protected] = ACTIONS(35),
    [anon_sym_public] = ACTIONS(35),
    [anon_sym_readonly] = ACTIONS(35),
    [anon_sym_sealed] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(35),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_virtual] = ACTIONS(35),
    [anon_sym_volatile] = ACTIONS(35),
    [anon_sym_alias] = ACTIONS(37),
    [anon_sym_partial] = ACTIONS(35),
    [anon_sym_class] = ACTIONS(35),
    [anon_sym_struct] = ACTIONS(35),
    [anon_sym_interface] = ACTIONS(35),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_delegate] = ACTIONS(35),
    [sym_comment] = ACTIONS(31),
  },
  [4] = {
    [sym_name_equals] = STATE(27),
    [sym_qualified_name] = STATE(30),
    [sym_alias_qualified_name] = STATE(31),
    [anon_sym_static] = ACTIONS(39),
    [anon_sym_global] = ACTIONS(41),
    [sym_identifier_name] = ACTIONS(43),
    [sym_comment] = ACTIONS(31),
  },
  [5] = {
    [sym_qualified_name] = STATE(32),
    [sym_alias_qualified_name] = STATE(31),
    [anon_sym_global] = ACTIONS(41),
    [sym_identifier_name] = ACTIONS(45),
    [sym_comment] = ACTIONS(31),
  },
  [6] = {
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_struct] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [sym_comment] = ACTIONS(31),
  },
  [7] = {
    [sym_identifier_name] = ACTIONS(53),
    [sym_comment] = ACTIONS(31),
  },
  [8] = {
    [sym_identifier_name] = ACTIONS(55),
    [sym_comment] = ACTIONS(31),
  },
  [9] = {
    [sym_attribute_list] = STATE(40),
    [sym_attribute] = STATE(41),
    [anon_sym_assembly] = ACTIONS(57),
    [anon_sym_module] = ACTIONS(57),
    [sym_identifier_name] = ACTIONS(59),
    [sym_comment] = ACTIONS(31),
  },
  [10] = {
    [sym_identifier_name] = ACTIONS(61),
    [sym_comment] = ACTIONS(31),
  },
  [11] = {
    [sym_identifier_name] = ACTIONS(63),
    [sym_comment] = ACTIONS(31),
  },
  [12] = {
    [sym__type] = STATE(45),
    [sym_predefined_type] = STATE(45),
    [sym_generic_name] = STATE(45),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_void_keyword] = ACTIONS(67),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [13] = {
    [ts_builtin_sym_end] = ACTIONS(71),
    [sym_comment] = ACTIONS(31),
  },
  [14] = {
    [anon_sym_partial] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_struct] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(75),
    [anon_sym_delegate] = ACTIONS(77),
    [sym_comment] = ACTIONS(31),
  },
  [15] = {
    [sym_modifiers] = STATE(50),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_partial] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_struct] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(75),
    [anon_sym_delegate] = ACTIONS(77),
    [sym_comment] = ACTIONS(31),
  },
  [16] = {
    [sym__type_declaration] = STATE(25),
    [sym_modifiers] = STATE(14),
    [sym_extern_alias_directive] = STATE(51),
    [sym_using_directive] = STATE(23),
    [sym_namespace_declaration] = STATE(25),
    [sym_class_declaration] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_struct_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_delegate_declaration] = STATE(25),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(24),
    [aux_sym_compilation_unit_repeat1] = STATE(51),
    [aux_sym_compilation_unit_repeat2] = STATE(23),
    [aux_sym_compilation_unit_repeat3] = STATE(24),
    [aux_sym_compilation_unit_repeat4] = STATE(25),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(11),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [17] = {
    [sym__type_declaration] = STATE(25),
    [sym_modifiers] = STATE(14),
    [sym_using_directive] = STATE(52),
    [sym_namespace_declaration] = STATE(25),
    [sym_class_declaration] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_struct_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_delegate_declaration] = STATE(25),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(24),
    [aux_sym_compilation_unit_repeat2] = STATE(52),
    [aux_sym_compilation_unit_repeat3] = STATE(24),
    [aux_sym_compilation_unit_repeat4] = STATE(25),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [18] = {
    [sym__type_declaration] = STATE(25),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(25),
    [sym_class_declaration] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_struct_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_delegate_declaration] = STATE(25),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(53),
    [aux_sym_compilation_unit_repeat3] = STATE(53),
    [aux_sym_compilation_unit_repeat4] = STATE(25),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [19] = {
    [sym__type_declaration] = STATE(55),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_struct_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_delegate_declaration] = STATE(55),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_compilation_unit_repeat4] = STATE(55),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(33),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [20] = {
    [aux_sym_modifiers_repeat1] = STATE(56),
    [anon_sym_abstract] = ACTIONS(81),
    [anon_sym_async] = ACTIONS(81),
    [anon_sym_extern] = ACTIONS(81),
    [anon_sym_internal] = ACTIONS(81),
    [anon_sym_new] = ACTIONS(81),
    [anon_sym_override] = ACTIONS(81),
    [anon_sym_private] = ACTIONS(81),
    [anon_sym_protected] = ACTIONS(81),
    [anon_sym_public] = ACTIONS(81),
    [anon_sym_readonly] = ACTIONS(81),
    [anon_sym_sealed] = ACTIONS(81),
    [anon_sym_static] = ACTIONS(81),
    [anon_sym_unsafe] = ACTIONS(81),
    [anon_sym_virtual] = ACTIONS(81),
    [anon_sym_volatile] = ACTIONS(81),
    [anon_sym_partial] = ACTIONS(83),
    [anon_sym_class] = ACTIONS(83),
    [anon_sym_struct] = ACTIONS(83),
    [anon_sym_interface] = ACTIONS(83),
    [anon_sym_enum] = ACTIONS(83),
    [anon_sym_delegate] = ACTIONS(83),
    [sym_comment] = ACTIONS(31),
  },
  [21] = {
    [sym__attribute_section] = STATE(57),
    [aux_sym__attributes_repeat1] = STATE(57),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_extern] = ACTIONS(85),
    [anon_sym_internal] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(85),
    [anon_sym_override] = ACTIONS(85),
    [anon_sym_private] = ACTIONS(85),
    [anon_sym_protected] = ACTIONS(85),
    [anon_sym_public] = ACTIONS(85),
    [anon_sym_readonly] = ACTIONS(85),
    [anon_sym_sealed] = ACTIONS(85),
    [anon_sym_static] = ACTIONS(85),
    [anon_sym_unsafe] = ACTIONS(85),
    [anon_sym_virtual] = ACTIONS(85),
    [anon_sym_volatile] = ACTIONS(85),
    [anon_sym_partial] = ACTIONS(85),
    [anon_sym_class] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(85),
    [anon_sym_delegate] = ACTIONS(85),
    [sym_comment] = ACTIONS(31),
  },
  [22] = {
    [sym__type_declaration] = STATE(60),
    [sym_modifiers] = STATE(14),
    [sym_extern_alias_directive] = STATE(51),
    [sym_using_directive] = STATE(58),
    [sym_namespace_declaration] = STATE(60),
    [sym_class_declaration] = STATE(60),
    [sym_interface_declaration] = STATE(60),
    [sym_struct_declaration] = STATE(60),
    [sym_enum_declaration] = STATE(60),
    [sym_delegate_declaration] = STATE(60),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(59),
    [aux_sym_compilation_unit_repeat1] = STATE(51),
    [aux_sym_compilation_unit_repeat2] = STATE(58),
    [aux_sym_compilation_unit_repeat3] = STATE(59),
    [aux_sym_compilation_unit_repeat4] = STATE(60),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(11),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [23] = {
    [sym__type_declaration] = STATE(60),
    [sym_modifiers] = STATE(14),
    [sym_using_directive] = STATE(52),
    [sym_namespace_declaration] = STATE(60),
    [sym_class_declaration] = STATE(60),
    [sym_interface_declaration] = STATE(60),
    [sym_struct_declaration] = STATE(60),
    [sym_enum_declaration] = STATE(60),
    [sym_delegate_declaration] = STATE(60),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(59),
    [aux_sym_compilation_unit_repeat2] = STATE(52),
    [aux_sym_compilation_unit_repeat3] = STATE(59),
    [aux_sym_compilation_unit_repeat4] = STATE(60),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [24] = {
    [sym__type_declaration] = STATE(60),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(60),
    [sym_class_declaration] = STATE(60),
    [sym_interface_declaration] = STATE(60),
    [sym_struct_declaration] = STATE(60),
    [sym_enum_declaration] = STATE(60),
    [sym_delegate_declaration] = STATE(60),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(53),
    [aux_sym_compilation_unit_repeat3] = STATE(53),
    [aux_sym_compilation_unit_repeat4] = STATE(60),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [25] = {
    [sym__type_declaration] = STATE(55),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_struct_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_delegate_declaration] = STATE(55),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_compilation_unit_repeat4] = STATE(55),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [26] = {
    [sym_identifier_name] = ACTIONS(89),
    [sym_comment] = ACTIONS(31),
  },
  [27] = {
    [sym_qualified_name] = STATE(62),
    [sym_alias_qualified_name] = STATE(31),
    [anon_sym_global] = ACTIONS(41),
    [sym_identifier_name] = ACTIONS(91),
    [sym_comment] = ACTIONS(31),
  },
  [28] = {
    [anon_sym_COLON_COLON] = ACTIONS(93),
    [sym_comment] = ACTIONS(31),
  },
  [29] = {
    [anon_sym_SEMI] = ACTIONS(95),
    [anon_sym_EQ] = ACTIONS(97),
    [anon_sym_DOT] = ACTIONS(99),
    [sym_comment] = ACTIONS(31),
  },
  [30] = {
    [anon_sym_SEMI] = ACTIONS(95),
    [anon_sym_DOT] = ACTIONS(99),
    [sym_comment] = ACTIONS(31),
  },
  [31] = {
    [anon_sym_DOT] = ACTIONS(99),
    [sym_comment] = ACTIONS(31),
  },
  [32] = {
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(99),
    [sym_comment] = ACTIONS(31),
  },
  [33] = {
    [sym_identifier_name] = ACTIONS(103),
    [sym_comment] = ACTIONS(31),
  },
  [34] = {
    [sym_identifier_name] = ACTIONS(105),
    [sym_comment] = ACTIONS(31),
  },
  [35] = {
    [sym_identifier_name] = ACTIONS(107),
    [sym_comment] = ACTIONS(31),
  },
  [36] = {
    [sym_type_parameter_list] = STATE(75),
    [sym_class_base] = STATE(76),
    [sym_type_parameter_constraints_clause] = STATE(77),
    [aux_sym_class_declaration_repeat1] = STATE(77),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [37] = {
    [sym_type_parameter_list] = STATE(80),
    [sym_type_parameter_constraints_clause] = STATE(82),
    [sym_struct_interfaces] = STATE(81),
    [aux_sym_class_declaration_repeat1] = STATE(82),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(117),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [38] = {
    [anon_sym_COLON] = ACTIONS(121),
    [sym_comment] = ACTIONS(31),
  },
  [39] = {
    [sym_attribute_argument_list] = STATE(85),
    [anon_sym_COMMA] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_RBRACK] = ACTIONS(123),
    [sym_comment] = ACTIONS(31),
  },
  [40] = {
    [anon_sym_RBRACK] = ACTIONS(127),
    [sym_comment] = ACTIONS(31),
  },
  [41] = {
    [aux_sym_attribute_list_repeat1] = STATE(88),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_comment] = ACTIONS(31),
  },
  [42] = {
    [sym_type_parameter_list] = STATE(91),
    [sym_type_parameter_constraints_clause] = STATE(93),
    [sym_interface_base] = STATE(92),
    [aux_sym_class_declaration_repeat1] = STATE(93),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [43] = {
    [anon_sym_LBRACE] = ACTIONS(137),
    [anon_sym_COLON] = ACTIONS(139),
    [sym_comment] = ACTIONS(31),
  },
  [44] = {
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_GT] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_RPAREN] = ACTIONS(141),
    [anon_sym_this] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_operator] = ACTIONS(143),
    [sym_identifier_name] = ACTIONS(143),
    [sym_comment] = ACTIONS(31),
  },
  [45] = {
    [sym_identifier_name] = ACTIONS(145),
    [sym_comment] = ACTIONS(31),
  },
  [46] = {
    [sym_type_parameter_list] = STATE(97),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_this] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(147),
    [sym_identifier_name] = ACTIONS(149),
    [sym_comment] = ACTIONS(31),
  },
  [47] = {
    [anon_sym_class] = ACTIONS(151),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_interface] = ACTIONS(155),
    [sym_comment] = ACTIONS(31),
  },
  [48] = {
    [sym_identifier_name] = ACTIONS(157),
    [sym_comment] = ACTIONS(31),
  },
  [49] = {
    [sym__type] = STATE(102),
    [sym_predefined_type] = STATE(102),
    [sym_generic_name] = STATE(102),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_void_keyword] = ACTIONS(159),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [50] = {
    [anon_sym_partial] = ACTIONS(161),
    [anon_sym_class] = ACTIONS(151),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_interface] = ACTIONS(155),
    [anon_sym_enum] = ACTIONS(163),
    [anon_sym_delegate] = ACTIONS(165),
    [sym_comment] = ACTIONS(31),
  },
  [51] = {
    [sym_extern_alias_directive] = STATE(51),
    [aux_sym_compilation_unit_repeat1] = STATE(51),
    [ts_builtin_sym_end] = ACTIONS(167),
    [anon_sym_abstract] = ACTIONS(167),
    [anon_sym_async] = ACTIONS(167),
    [anon_sym_extern] = ACTIONS(169),
    [anon_sym_internal] = ACTIONS(167),
    [anon_sym_new] = ACTIONS(167),
    [anon_sym_override] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_readonly] = ACTIONS(167),
    [anon_sym_sealed] = ACTIONS(167),
    [anon_sym_static] = ACTIONS(167),
    [anon_sym_unsafe] = ACTIONS(167),
    [anon_sym_virtual] = ACTIONS(167),
    [anon_sym_volatile] = ACTIONS(167),
    [anon_sym_using] = ACTIONS(167),
    [anon_sym_namespace] = ACTIONS(167),
    [anon_sym_partial] = ACTIONS(167),
    [anon_sym_class] = ACTIONS(167),
    [anon_sym_struct] = ACTIONS(167),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_interface] = ACTIONS(167),
    [anon_sym_enum] = ACTIONS(167),
    [anon_sym_delegate] = ACTIONS(167),
    [sym_comment] = ACTIONS(31),
  },
  [52] = {
    [sym_using_directive] = STATE(52),
    [aux_sym_compilation_unit_repeat2] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(172),
    [anon_sym_abstract] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(172),
    [anon_sym_extern] = ACTIONS(172),
    [anon_sym_internal] = ACTIONS(172),
    [anon_sym_new] = ACTIONS(172),
    [anon_sym_override] = ACTIONS(172),
    [anon_sym_private] = ACTIONS(172),
    [anon_sym_protected] = ACTIONS(172),
    [anon_sym_public] = ACTIONS(172),
    [anon_sym_readonly] = ACTIONS(172),
    [anon_sym_sealed] = ACTIONS(172),
    [anon_sym_static] = ACTIONS(172),
    [anon_sym_unsafe] = ACTIONS(172),
    [anon_sym_virtual] = ACTIONS(172),
    [anon_sym_volatile] = ACTIONS(172),
    [anon_sym_using] = ACTIONS(174),
    [anon_sym_namespace] = ACTIONS(172),
    [anon_sym_partial] = ACTIONS(172),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_struct] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(172),
    [anon_sym_interface] = ACTIONS(172),
    [anon_sym_enum] = ACTIONS(172),
    [anon_sym_delegate] = ACTIONS(172),
    [sym_comment] = ACTIONS(31),
  },
  [53] = {
    [sym__global_attributes] = STATE(53),
    [aux_sym_compilation_unit_repeat3] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(177),
    [anon_sym_abstract] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(177),
    [anon_sym_extern] = ACTIONS(177),
    [anon_sym_internal] = ACTIONS(177),
    [anon_sym_new] = ACTIONS(177),
    [anon_sym_override] = ACTIONS(177),
    [anon_sym_private] = ACTIONS(177),
    [anon_sym_protected] = ACTIONS(177),
    [anon_sym_public] = ACTIONS(177),
    [anon_sym_readonly] = ACTIONS(177),
    [anon_sym_sealed] = ACTIONS(177),
    [anon_sym_static] = ACTIONS(177),
    [anon_sym_unsafe] = ACTIONS(177),
    [anon_sym_virtual] = ACTIONS(177),
    [anon_sym_volatile] = ACTIONS(177),
    [anon_sym_namespace] = ACTIONS(177),
    [anon_sym_partial] = ACTIONS(177),
    [anon_sym_class] = ACTIONS(177),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_LBRACK] = ACTIONS(179),
    [anon_sym_interface] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(177),
    [anon_sym_delegate] = ACTIONS(177),
    [sym_comment] = ACTIONS(31),
  },
  [54] = {
    [sym_attribute_list] = STATE(40),
    [sym_attribute] = STATE(41),
    [sym_identifier_name] = ACTIONS(182),
    [sym_comment] = ACTIONS(31),
  },
  [55] = {
    [sym__type_declaration] = STATE(55),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_struct_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_delegate_declaration] = STATE(55),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_compilation_unit_repeat4] = STATE(55),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(184),
    [anon_sym_abstract] = ACTIONS(186),
    [anon_sym_async] = ACTIONS(186),
    [anon_sym_extern] = ACTIONS(186),
    [anon_sym_internal] = ACTIONS(186),
    [anon_sym_new] = ACTIONS(186),
    [anon_sym_override] = ACTIONS(186),
    [anon_sym_private] = ACTIONS(186),
    [anon_sym_protected] = ACTIONS(186),
    [anon_sym_public] = ACTIONS(186),
    [anon_sym_readonly] = ACTIONS(186),
    [anon_sym_sealed] = ACTIONS(186),
    [anon_sym_static] = ACTIONS(186),
    [anon_sym_unsafe] = ACTIONS(186),
    [anon_sym_virtual] = ACTIONS(186),
    [anon_sym_volatile] = ACTIONS(186),
    [anon_sym_namespace] = ACTIONS(189),
    [anon_sym_partial] = ACTIONS(192),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_struct] = ACTIONS(198),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_interface] = ACTIONS(204),
    [anon_sym_enum] = ACTIONS(207),
    [anon_sym_delegate] = ACTIONS(210),
    [sym_comment] = ACTIONS(31),
  },
  [56] = {
    [aux_sym_modifiers_repeat1] = STATE(56),
    [anon_sym_abstract] = ACTIONS(213),
    [anon_sym_async] = ACTIONS(213),
    [anon_sym_extern] = ACTIONS(213),
    [anon_sym_internal] = ACTIONS(213),
    [anon_sym_new] = ACTIONS(213),
    [anon_sym_override] = ACTIONS(213),
    [anon_sym_private] = ACTIONS(213),
    [anon_sym_protected] = ACTIONS(213),
    [anon_sym_public] = ACTIONS(213),
    [anon_sym_readonly] = ACTIONS(213),
    [anon_sym_sealed] = ACTIONS(213),
    [anon_sym_static] = ACTIONS(213),
    [anon_sym_unsafe] = ACTIONS(213),
    [anon_sym_virtual] = ACTIONS(213),
    [anon_sym_volatile] = ACTIONS(213),
    [anon_sym_partial] = ACTIONS(216),
    [anon_sym_class] = ACTIONS(216),
    [anon_sym_struct] = ACTIONS(216),
    [anon_sym_interface] = ACTIONS(216),
    [anon_sym_enum] = ACTIONS(216),
    [anon_sym_delegate] = ACTIONS(216),
    [sym_comment] = ACTIONS(31),
  },
  [57] = {
    [sym__attribute_section] = STATE(57),
    [aux_sym__attributes_repeat1] = STATE(57),
    [anon_sym_abstract] = ACTIONS(218),
    [anon_sym_async] = ACTIONS(218),
    [anon_sym_extern] = ACTIONS(218),
    [anon_sym_internal] = ACTIONS(218),
    [anon_sym_new] = ACTIONS(218),
    [anon_sym_override] = ACTIONS(218),
    [anon_sym_private] = ACTIONS(218),
    [anon_sym_protected] = ACTIONS(218),
    [anon_sym_public] = ACTIONS(218),
    [anon_sym_readonly] = ACTIONS(218),
    [anon_sym_sealed] = ACTIONS(218),
    [anon_sym_static] = ACTIONS(218),
    [anon_sym_unsafe] = ACTIONS(218),
    [anon_sym_virtual] = ACTIONS(218),
    [anon_sym_volatile] = ACTIONS(218),
    [anon_sym_partial] = ACTIONS(218),
    [anon_sym_class] = ACTIONS(218),
    [anon_sym_struct] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_interface] = ACTIONS(218),
    [anon_sym_enum] = ACTIONS(218),
    [anon_sym_delegate] = ACTIONS(218),
    [sym_comment] = ACTIONS(31),
  },
  [58] = {
    [sym__type_declaration] = STATE(109),
    [sym_modifiers] = STATE(14),
    [sym_using_directive] = STATE(52),
    [sym_namespace_declaration] = STATE(109),
    [sym_class_declaration] = STATE(109),
    [sym_interface_declaration] = STATE(109),
    [sym_struct_declaration] = STATE(109),
    [sym_enum_declaration] = STATE(109),
    [sym_delegate_declaration] = STATE(109),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(108),
    [aux_sym_compilation_unit_repeat2] = STATE(52),
    [aux_sym_compilation_unit_repeat3] = STATE(108),
    [aux_sym_compilation_unit_repeat4] = STATE(109),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(223),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [59] = {
    [sym__type_declaration] = STATE(109),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(109),
    [sym_class_declaration] = STATE(109),
    [sym_interface_declaration] = STATE(109),
    [sym_struct_declaration] = STATE(109),
    [sym_enum_declaration] = STATE(109),
    [sym_delegate_declaration] = STATE(109),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(53),
    [aux_sym_compilation_unit_repeat3] = STATE(53),
    [aux_sym_compilation_unit_repeat4] = STATE(109),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(223),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [60] = {
    [sym__type_declaration] = STATE(55),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_struct_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_delegate_declaration] = STATE(55),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_compilation_unit_repeat4] = STATE(55),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(223),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [61] = {
    [anon_sym_SEMI] = ACTIONS(225),
    [sym_comment] = ACTIONS(31),
  },
  [62] = {
    [anon_sym_SEMI] = ACTIONS(227),
    [anon_sym_DOT] = ACTIONS(99),
    [sym_comment] = ACTIONS(31),
  },
  [63] = {
    [sym_identifier_name] = ACTIONS(229),
    [sym_comment] = ACTIONS(31),
  },
  [64] = {
    [ts_builtin_sym_end] = ACTIONS(231),
    [anon_sym_abstract] = ACTIONS(231),
    [anon_sym_async] = ACTIONS(231),
    [anon_sym_extern] = ACTIONS(231),
    [anon_sym_internal] = ACTIONS(231),
    [anon_sym_new] = ACTIONS(231),
    [anon_sym_override] = ACTIONS(231),
    [anon_sym_private] = ACTIONS(231),
    [anon_sym_protected] = ACTIONS(231),
    [anon_sym_public] = ACTIONS(231),
    [anon_sym_readonly] = ACTIONS(231),
    [anon_sym_sealed] = ACTIONS(231),
    [anon_sym_static] = ACTIONS(231),
    [anon_sym_unsafe] = ACTIONS(231),
    [anon_sym_virtual] = ACTIONS(231),
    [anon_sym_volatile] = ACTIONS(231),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_namespace] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_partial] = ACTIONS(231),
    [anon_sym_class] = ACTIONS(231),
    [anon_sym_struct] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_interface] = ACTIONS(231),
    [anon_sym_enum] = ACTIONS(231),
    [anon_sym_delegate] = ACTIONS(231),
    [sym_comment] = ACTIONS(31),
  },
  [65] = {
    [anon_sym_global] = ACTIONS(233),
    [sym_identifier_name] = ACTIONS(233),
    [sym_comment] = ACTIONS(31),
  },
  [66] = {
    [sym_identifier_name] = ACTIONS(235),
    [sym_comment] = ACTIONS(31),
  },
  [67] = {
    [sym__type_declaration] = STATE(115),
    [sym_modifiers] = STATE(14),
    [sym_using_directive] = STATE(115),
    [sym_namespace_declaration] = STATE(115),
    [sym_class_declaration] = STATE(115),
    [sym_interface_declaration] = STATE(115),
    [sym_struct_declaration] = STATE(115),
    [sym_enum_declaration] = STATE(115),
    [sym_delegate_declaration] = STATE(115),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym_namespace_declaration_repeat1] = STATE(115),
    [aux_sym__attributes_repeat1] = STATE(21),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(237),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [68] = {
    [sym_type_parameter_list] = STATE(117),
    [sym_class_base] = STATE(118),
    [sym_type_parameter_constraints_clause] = STATE(119),
    [aux_sym_class_declaration_repeat1] = STATE(119),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [69] = {
    [sym_type_parameter_list] = STATE(121),
    [sym_type_parameter_constraints_clause] = STATE(123),
    [sym_struct_interfaces] = STATE(122),
    [aux_sym_class_declaration_repeat1] = STATE(123),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [70] = {
    [sym_type_parameter_list] = STATE(125),
    [sym_type_parameter_constraints_clause] = STATE(127),
    [sym_interface_base] = STATE(126),
    [aux_sym_class_declaration_repeat1] = STATE(127),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [71] = {
    [sym__type] = STATE(128),
    [sym_predefined_type] = STATE(128),
    [sym_type_parameter] = STATE(129),
    [sym_generic_name] = STATE(128),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [72] = {
    [sym__type_declaration] = STATE(147),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(147),
    [sym_class_declaration] = STATE(147),
    [sym_indexer_declaration] = STATE(147),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(147),
    [sym_operator_declaration] = STATE(147),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(147),
    [sym_struct_declaration] = STATE(147),
    [sym_enum_declaration] = STATE(147),
    [sym_delegate_declaration] = STATE(147),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(147),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(147),
    [sym_constructor_declaration] = STATE(147),
    [sym_destructor_declaration] = STATE(147),
    [sym_method_declaration] = STATE(147),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(147),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [73] = {
    [anon_sym_object] = ACTIONS(275),
    [anon_sym_string] = ACTIONS(275),
    [anon_sym_dynamic] = ACTIONS(275),
    [sym_identifier_name] = ACTIONS(275),
    [sym_comment] = ACTIONS(31),
  },
  [74] = {
    [sym_identifier_name] = ACTIONS(277),
    [sym_comment] = ACTIONS(31),
  },
  [75] = {
    [sym_class_base] = STATE(118),
    [sym_type_parameter_constraints_clause] = STATE(119),
    [aux_sym_class_declaration_repeat1] = STATE(119),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [76] = {
    [sym_type_parameter_constraints_clause] = STATE(119),
    [aux_sym_class_declaration_repeat1] = STATE(119),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [77] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [78] = {
    [sym__type_declaration] = STATE(154),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(154),
    [sym_class_declaration] = STATE(154),
    [sym_indexer_declaration] = STATE(154),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(154),
    [sym_operator_declaration] = STATE(154),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(154),
    [sym_struct_declaration] = STATE(154),
    [sym_enum_declaration] = STATE(154),
    [sym_delegate_declaration] = STATE(154),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(154),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(154),
    [sym_constructor_declaration] = STATE(154),
    [sym_method_declaration] = STATE(154),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(154),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [79] = {
    [sym_identifier_name] = ACTIONS(281),
    [sym_comment] = ACTIONS(31),
  },
  [80] = {
    [sym_type_parameter_constraints_clause] = STATE(123),
    [sym_struct_interfaces] = STATE(122),
    [aux_sym_class_declaration_repeat1] = STATE(123),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [81] = {
    [sym_type_parameter_constraints_clause] = STATE(123),
    [aux_sym_class_declaration_repeat1] = STATE(123),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [82] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [83] = {
    [sym_attribute_list] = STATE(157),
    [sym_attribute] = STATE(41),
    [sym_identifier_name] = ACTIONS(182),
    [sym_comment] = ACTIONS(31),
  },
  [84] = {
    [anon_sym_RPAREN] = ACTIONS(283),
    [sym_comment] = ACTIONS(31),
  },
  [85] = {
    [anon_sym_COMMA] = ACTIONS(285),
    [anon_sym_RBRACK] = ACTIONS(285),
    [sym_comment] = ACTIONS(31),
  },
  [86] = {
    [anon_sym_bool] = ACTIONS(287),
    [anon_sym_byte] = ACTIONS(287),
    [anon_sym_char] = ACTIONS(287),
    [anon_sym_decimal] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_int] = ACTIONS(287),
    [anon_sym_long] = ACTIONS(287),
    [anon_sym_object] = ACTIONS(287),
    [anon_sym_sbyte] = ACTIONS(287),
    [anon_sym_short] = ACTIONS(287),
    [anon_sym_string] = ACTIONS(287),
    [anon_sym_uint] = ACTIONS(287),
    [anon_sym_ulong] = ACTIONS(287),
    [anon_sym_ushort] = ACTIONS(287),
    [anon_sym_abstract] = ACTIONS(287),
    [anon_sym_async] = ACTIONS(287),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym_internal] = ACTIONS(287),
    [anon_sym_new] = ACTIONS(287),
    [anon_sym_override] = ACTIONS(287),
    [anon_sym_private] = ACTIONS(287),
    [anon_sym_protected] = ACTIONS(287),
    [anon_sym_public] = ACTIONS(287),
    [anon_sym_readonly] = ACTIONS(287),
    [anon_sym_sealed] = ACTIONS(287),
    [anon_sym_static] = ACTIONS(287),
    [anon_sym_unsafe] = ACTIONS(287),
    [anon_sym_virtual] = ACTIONS(287),
    [anon_sym_volatile] = ACTIONS(287),
    [anon_sym_get] = ACTIONS(287),
    [anon_sym_set] = ACTIONS(287),
    [anon_sym_partial] = ACTIONS(287),
    [anon_sym_class] = ACTIONS(287),
    [anon_sym_struct] = ACTIONS(287),
    [anon_sym_this] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_event] = ACTIONS(287),
    [anon_sym_add] = ACTIONS(287),
    [anon_sym_remove] = ACTIONS(287),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_implicit] = ACTIONS(287),
    [anon_sym_explicit] = ACTIONS(287),
    [anon_sym_interface] = ACTIONS(287),
    [anon_sym_enum] = ACTIONS(287),
    [anon_sym_delegate] = ACTIONS(287),
    [sym_void_keyword] = ACTIONS(287),
    [anon_sym_ref] = ACTIONS(287),
    [anon_sym_out] = ACTIONS(287),
    [anon_sym_const] = ACTIONS(287),
    [sym_identifier_name] = ACTIONS(287),
    [sym_comment] = ACTIONS(31),
  },
  [87] = {
    [sym_attribute] = STATE(159),
    [sym_identifier_name] = ACTIONS(182),
    [sym_comment] = ACTIONS(31),
  },
  [88] = {
    [aux_sym_attribute_list_repeat1] = STATE(160),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_RBRACK] = ACTIONS(291),
    [sym_comment] = ACTIONS(31),
  },
  [89] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(167),
    [sym_interface_event_declaration] = STATE(167),
    [sym_interface_property_declaration] = STATE(167),
    [sym_interface_indexer_declaration] = STATE(167),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(167),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [90] = {
    [sym_identifier_name] = ACTIONS(301),
    [sym_comment] = ACTIONS(31),
  },
  [91] = {
    [sym_type_parameter_constraints_clause] = STATE(127),
    [sym_interface_base] = STATE(126),
    [aux_sym_class_declaration_repeat1] = STATE(127),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [92] = {
    [sym_type_parameter_constraints_clause] = STATE(127),
    [aux_sym_class_declaration_repeat1] = STATE(127),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [93] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [94] = {
    [sym_enum_member_declaration] = STATE(171),
    [sym__attributes] = STATE(172),
    [sym__attribute_section] = STATE(173),
    [aux_sym__attributes_repeat1] = STATE(173),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_identifier_name] = ACTIONS(303),
    [sym_comment] = ACTIONS(31),
  },
  [95] = {
    [sym__integral_type] = STATE(174),
    [anon_sym_byte] = ACTIONS(305),
    [anon_sym_char] = ACTIONS(305),
    [anon_sym_int] = ACTIONS(305),
    [anon_sym_long] = ACTIONS(305),
    [anon_sym_sbyte] = ACTIONS(305),
    [anon_sym_short] = ACTIONS(305),
    [anon_sym_uint] = ACTIONS(305),
    [anon_sym_ulong] = ACTIONS(305),
    [anon_sym_ushort] = ACTIONS(305),
    [sym_comment] = ACTIONS(31),
  },
  [96] = {
    [sym_parameter_list] = STATE(176),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [97] = {
    [anon_sym_COMMA] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(309),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(309),
    [anon_sym_this] = ACTIONS(311),
    [anon_sym_LBRACK] = ACTIONS(309),
    [sym_identifier_name] = ACTIONS(311),
    [sym_comment] = ACTIONS(31),
  },
  [98] = {
    [sym_identifier_name] = ACTIONS(313),
    [sym_comment] = ACTIONS(31),
  },
  [99] = {
    [sym_identifier_name] = ACTIONS(315),
    [sym_comment] = ACTIONS(31),
  },
  [100] = {
    [sym_identifier_name] = ACTIONS(317),
    [sym_comment] = ACTIONS(31),
  },
  [101] = {
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_COLON] = ACTIONS(321),
    [sym_comment] = ACTIONS(31),
  },
  [102] = {
    [sym_identifier_name] = ACTIONS(323),
    [sym_comment] = ACTIONS(31),
  },
  [103] = {
    [anon_sym_class] = ACTIONS(325),
    [anon_sym_struct] = ACTIONS(327),
    [anon_sym_interface] = ACTIONS(329),
    [sym_comment] = ACTIONS(31),
  },
  [104] = {
    [sym_identifier_name] = ACTIONS(331),
    [sym_comment] = ACTIONS(31),
  },
  [105] = {
    [sym__type] = STATE(187),
    [sym_predefined_type] = STATE(187),
    [sym_generic_name] = STATE(187),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_void_keyword] = ACTIONS(333),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [106] = {
    [anon_sym_alias] = ACTIONS(37),
    [sym_comment] = ACTIONS(31),
  },
  [107] = {
    [anon_sym_assembly] = ACTIONS(335),
    [anon_sym_module] = ACTIONS(335),
    [sym_comment] = ACTIONS(31),
  },
  [108] = {
    [sym__type_declaration] = STATE(188),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(188),
    [sym_class_declaration] = STATE(188),
    [sym_interface_declaration] = STATE(188),
    [sym_struct_declaration] = STATE(188),
    [sym_enum_declaration] = STATE(188),
    [sym_delegate_declaration] = STATE(188),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [sym__global_attributes] = STATE(53),
    [aux_sym_compilation_unit_repeat3] = STATE(53),
    [aux_sym_compilation_unit_repeat4] = STATE(188),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(337),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [109] = {
    [sym__type_declaration] = STATE(55),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_struct_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_delegate_declaration] = STATE(55),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_compilation_unit_repeat4] = STATE(55),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(337),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(339),
    [anon_sym_async] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(339),
    [anon_sym_internal] = ACTIONS(339),
    [anon_sym_new] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_sealed] = ACTIONS(339),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_unsafe] = ACTIONS(339),
    [anon_sym_virtual] = ACTIONS(339),
    [anon_sym_volatile] = ACTIONS(339),
    [anon_sym_using] = ACTIONS(339),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_partial] = ACTIONS(339),
    [anon_sym_class] = ACTIONS(339),
    [anon_sym_struct] = ACTIONS(339),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_interface] = ACTIONS(339),
    [anon_sym_enum] = ACTIONS(339),
    [anon_sym_delegate] = ACTIONS(339),
    [sym_comment] = ACTIONS(31),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(341),
    [anon_sym_abstract] = ACTIONS(341),
    [anon_sym_async] = ACTIONS(341),
    [anon_sym_extern] = ACTIONS(341),
    [anon_sym_internal] = ACTIONS(341),
    [anon_sym_new] = ACTIONS(341),
    [anon_sym_override] = ACTIONS(341),
    [anon_sym_private] = ACTIONS(341),
    [anon_sym_protected] = ACTIONS(341),
    [anon_sym_public] = ACTIONS(341),
    [anon_sym_readonly] = ACTIONS(341),
    [anon_sym_sealed] = ACTIONS(341),
    [anon_sym_static] = ACTIONS(341),
    [anon_sym_unsafe] = ACTIONS(341),
    [anon_sym_virtual] = ACTIONS(341),
    [anon_sym_volatile] = ACTIONS(341),
    [anon_sym_using] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(341),
    [anon_sym_RBRACE] = ACTIONS(341),
    [anon_sym_partial] = ACTIONS(341),
    [anon_sym_class] = ACTIONS(341),
    [anon_sym_struct] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_interface] = ACTIONS(341),
    [anon_sym_enum] = ACTIONS(341),
    [anon_sym_delegate] = ACTIONS(341),
    [sym_comment] = ACTIONS(31),
  },
  [112] = {
    [anon_sym_DOT] = ACTIONS(343),
    [sym_comment] = ACTIONS(31),
  },
  [113] = {
    [anon_sym_SEMI] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(345),
    [sym_comment] = ACTIONS(31),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(347),
    [anon_sym_abstract] = ACTIONS(347),
    [anon_sym_async] = ACTIONS(347),
    [anon_sym_extern] = ACTIONS(347),
    [anon_sym_internal] = ACTIONS(347),
    [anon_sym_new] = ACTIONS(347),
    [anon_sym_override] = ACTIONS(347),
    [anon_sym_private] = ACTIONS(347),
    [anon_sym_protected] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(347),
    [anon_sym_readonly] = ACTIONS(347),
    [anon_sym_sealed] = ACTIONS(347),
    [anon_sym_static] = ACTIONS(347),
    [anon_sym_unsafe] = ACTIONS(347),
    [anon_sym_virtual] = ACTIONS(347),
    [anon_sym_volatile] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(349),
    [anon_sym_using] = ACTIONS(347),
    [anon_sym_namespace] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_partial] = ACTIONS(347),
    [anon_sym_class] = ACTIONS(347),
    [anon_sym_struct] = ACTIONS(347),
    [anon_sym_LBRACK] = ACTIONS(347),
    [anon_sym_interface] = ACTIONS(347),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_delegate] = ACTIONS(347),
    [sym_comment] = ACTIONS(31),
  },
  [115] = {
    [sym__type_declaration] = STATE(191),
    [sym_modifiers] = STATE(14),
    [sym_using_directive] = STATE(191),
    [sym_namespace_declaration] = STATE(191),
    [sym_class_declaration] = STATE(191),
    [sym_interface_declaration] = STATE(191),
    [sym_struct_declaration] = STATE(191),
    [sym_enum_declaration] = STATE(191),
    [sym_delegate_declaration] = STATE(191),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym_namespace_declaration_repeat1] = STATE(191),
    [aux_sym__attributes_repeat1] = STATE(21),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [116] = {
    [sym__type_declaration] = STATE(193),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(193),
    [sym_class_declaration] = STATE(193),
    [sym_indexer_declaration] = STATE(193),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(193),
    [sym_operator_declaration] = STATE(193),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(193),
    [sym_struct_declaration] = STATE(193),
    [sym_enum_declaration] = STATE(193),
    [sym_delegate_declaration] = STATE(193),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(193),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(193),
    [sym_constructor_declaration] = STATE(193),
    [sym_destructor_declaration] = STATE(193),
    [sym_method_declaration] = STATE(193),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(193),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [117] = {
    [sym_class_base] = STATE(195),
    [sym_type_parameter_constraints_clause] = STATE(196),
    [aux_sym_class_declaration_repeat1] = STATE(196),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [118] = {
    [sym_type_parameter_constraints_clause] = STATE(196),
    [aux_sym_class_declaration_repeat1] = STATE(196),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [119] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [120] = {
    [sym__type_declaration] = STATE(198),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(198),
    [sym_class_declaration] = STATE(198),
    [sym_indexer_declaration] = STATE(198),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(198),
    [sym_operator_declaration] = STATE(198),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(198),
    [sym_struct_declaration] = STATE(198),
    [sym_enum_declaration] = STATE(198),
    [sym_delegate_declaration] = STATE(198),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(198),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(198),
    [sym_constructor_declaration] = STATE(198),
    [sym_method_declaration] = STATE(198),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(198),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(357),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [121] = {
    [sym_type_parameter_constraints_clause] = STATE(201),
    [sym_struct_interfaces] = STATE(200),
    [aux_sym_class_declaration_repeat1] = STATE(201),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [122] = {
    [sym_type_parameter_constraints_clause] = STATE(201),
    [aux_sym_class_declaration_repeat1] = STATE(201),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [123] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [124] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(203),
    [sym_interface_event_declaration] = STATE(203),
    [sym_interface_property_declaration] = STATE(203),
    [sym_interface_indexer_declaration] = STATE(203),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(203),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [125] = {
    [sym_type_parameter_constraints_clause] = STATE(206),
    [sym_interface_base] = STATE(205),
    [aux_sym_class_declaration_repeat1] = STATE(206),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [126] = {
    [sym_type_parameter_constraints_clause] = STATE(206),
    [aux_sym_class_declaration_repeat1] = STATE(206),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [127] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [128] = {
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_GT] = ACTIONS(365),
    [sym_comment] = ACTIONS(31),
  },
  [129] = {
    [aux_sym_type_parameter_list_repeat1] = STATE(209),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_GT] = ACTIONS(369),
    [sym_comment] = ACTIONS(31),
  },
  [130] = {
    [anon_sym_bool] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(371),
    [anon_sym_char] = ACTIONS(371),
    [anon_sym_decimal] = ACTIONS(371),
    [anon_sym_double] = ACTIONS(371),
    [anon_sym_float] = ACTIONS(371),
    [anon_sym_int] = ACTIONS(371),
    [anon_sym_long] = ACTIONS(371),
    [anon_sym_object] = ACTIONS(371),
    [anon_sym_sbyte] = ACTIONS(371),
    [anon_sym_short] = ACTIONS(371),
    [anon_sym_string] = ACTIONS(371),
    [anon_sym_uint] = ACTIONS(371),
    [anon_sym_ulong] = ACTIONS(371),
    [anon_sym_ushort] = ACTIONS(371),
    [anon_sym_abstract] = ACTIONS(371),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_extern] = ACTIONS(371),
    [anon_sym_internal] = ACTIONS(371),
    [anon_sym_new] = ACTIONS(371),
    [anon_sym_override] = ACTIONS(371),
    [anon_sym_private] = ACTIONS(371),
    [anon_sym_protected] = ACTIONS(371),
    [anon_sym_public] = ACTIONS(371),
    [anon_sym_readonly] = ACTIONS(371),
    [anon_sym_sealed] = ACTIONS(371),
    [anon_sym_static] = ACTIONS(371),
    [anon_sym_unsafe] = ACTIONS(371),
    [anon_sym_virtual] = ACTIONS(371),
    [anon_sym_volatile] = ACTIONS(371),
    [anon_sym_partial] = ACTIONS(371),
    [anon_sym_class] = ACTIONS(371),
    [anon_sym_struct] = ACTIONS(371),
    [anon_sym_event] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_implicit] = ACTIONS(371),
    [anon_sym_explicit] = ACTIONS(371),
    [anon_sym_interface] = ACTIONS(371),
    [anon_sym_enum] = ACTIONS(371),
    [anon_sym_delegate] = ACTIONS(371),
    [sym_void_keyword] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(371),
    [sym_identifier_name] = ACTIONS(371),
    [sym_comment] = ACTIONS(31),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(375),
    [anon_sym_bool] = ACTIONS(377),
    [anon_sym_byte] = ACTIONS(377),
    [anon_sym_char] = ACTIONS(377),
    [anon_sym_decimal] = ACTIONS(377),
    [anon_sym_double] = ACTIONS(377),
    [anon_sym_float] = ACTIONS(377),
    [anon_sym_int] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_object] = ACTIONS(377),
    [anon_sym_sbyte] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [anon_sym_string] = ACTIONS(377),
    [anon_sym_uint] = ACTIONS(377),
    [anon_sym_ulong] = ACTIONS(377),
    [anon_sym_ushort] = ACTIONS(377),
    [anon_sym_abstract] = ACTIONS(377),
    [anon_sym_async] = ACTIONS(377),
    [anon_sym_extern] = ACTIONS(377),
    [anon_sym_internal] = ACTIONS(377),
    [anon_sym_new] = ACTIONS(377),
    [anon_sym_override] = ACTIONS(377),
    [anon_sym_private] = ACTIONS(377),
    [anon_sym_protected] = ACTIONS(377),
    [anon_sym_public] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_sealed] = ACTIONS(377),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_unsafe] = ACTIONS(377),
    [anon_sym_virtual] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_using] = ACTIONS(377),
    [anon_sym_namespace] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_partial] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(377),
    [anon_sym_struct] = ACTIONS(377),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_event] = ACTIONS(377),
    [anon_sym_TILDE] = ACTIONS(375),
    [anon_sym_implicit] = ACTIONS(377),
    [anon_sym_explicit] = ACTIONS(377),
    [anon_sym_interface] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_delegate] = ACTIONS(377),
    [sym_void_keyword] = ACTIONS(377),
    [anon_sym_const] = ACTIONS(377),
    [sym_identifier_name] = ACTIONS(377),
    [sym_comment] = ACTIONS(31),
  },
  [132] = {
    [sym__type] = STATE(212),
    [sym_predefined_type] = STATE(212),
    [sym_generic_name] = STATE(212),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_struct] = ACTIONS(383),
    [anon_sym_interface] = ACTIONS(385),
    [sym_void_keyword] = ACTIONS(387),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [133] = {
    [sym__type] = STATE(213),
    [sym_predefined_type] = STATE(213),
    [sym_generic_name] = STATE(213),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [134] = {
    [sym_identifier_name] = ACTIONS(389),
    [sym_comment] = ACTIONS(31),
  },
  [135] = {
    [anon_sym_operator] = ACTIONS(391),
    [sym_comment] = ACTIONS(31),
  },
  [136] = {
    [sym_identifier_name] = ACTIONS(393),
    [sym_comment] = ACTIONS(31),
  },
  [137] = {
    [sym__type] = STATE(216),
    [sym_predefined_type] = STATE(216),
    [sym_generic_name] = STATE(216),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [138] = {
    [sym_type_parameter_list] = STATE(217),
    [sym_parameter_list] = STATE(218),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_this] = ACTIONS(149),
    [anon_sym_operator] = ACTIONS(149),
    [sym_identifier_name] = ACTIONS(149),
    [sym_comment] = ACTIONS(31),
  },
  [139] = {
    [sym_variable_declarator] = STATE(222),
    [anon_sym_this] = ACTIONS(395),
    [anon_sym_operator] = ACTIONS(397),
    [sym_identifier_name] = ACTIONS(399),
    [sym_comment] = ACTIONS(31),
  },
  [140] = {
    [sym__type] = STATE(227),
    [sym_predefined_type] = STATE(227),
    [sym__indexer_declarator] = STATE(228),
    [sym__operator_declarator] = STATE(229),
    [sym__unary_operator_declarator] = STATE(229),
    [sym__binary_operator_declarator] = STATE(229),
    [sym__conversion_operator_declarator] = STATE(229),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_variable_declaration] = STATE(230),
    [sym_generic_name] = STATE(227),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(401),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_struct] = ACTIONS(383),
    [anon_sym_event] = ACTIONS(403),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(385),
    [anon_sym_enum] = ACTIONS(405),
    [anon_sym_delegate] = ACTIONS(407),
    [sym_void_keyword] = ACTIONS(387),
    [anon_sym_const] = ACTIONS(409),
    [sym_identifier_name] = ACTIONS(411),
    [sym_comment] = ACTIONS(31),
  },
  [141] = {
    [sym__indexer_body] = STATE(233),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [sym_comment] = ACTIONS(31),
  },
  [142] = {
    [sym_statement_block] = STATE(234),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_EQ_GT] = ACTIONS(421),
    [sym_comment] = ACTIONS(31),
  },
  [143] = {
    [anon_sym_operator] = ACTIONS(423),
    [sym_comment] = ACTIONS(31),
  },
  [144] = {
    [sym__type] = STATE(227),
    [sym_predefined_type] = STATE(227),
    [sym_modifiers] = STATE(239),
    [sym__indexer_declarator] = STATE(228),
    [sym__operator_declarator] = STATE(229),
    [sym__unary_operator_declarator] = STATE(229),
    [sym__binary_operator_declarator] = STATE(229),
    [sym__conversion_operator_declarator] = STATE(229),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_variable_declaration] = STATE(230),
    [sym_generic_name] = STATE(227),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(425),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_partial] = ACTIONS(401),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_struct] = ACTIONS(383),
    [anon_sym_event] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(385),
    [anon_sym_enum] = ACTIONS(405),
    [anon_sym_delegate] = ACTIONS(407),
    [sym_void_keyword] = ACTIONS(387),
    [anon_sym_const] = ACTIONS(409),
    [sym_identifier_name] = ACTIONS(411),
    [sym_comment] = ACTIONS(31),
  },
  [145] = {
    [anon_sym_SEMI] = ACTIONS(427),
    [sym_comment] = ACTIONS(31),
  },
  [146] = {
    [aux_sym_modifiers_repeat1] = STATE(241),
    [anon_sym_bool] = ACTIONS(429),
    [anon_sym_byte] = ACTIONS(429),
    [anon_sym_char] = ACTIONS(429),
    [anon_sym_decimal] = ACTIONS(429),
    [anon_sym_double] = ACTIONS(429),
    [anon_sym_float] = ACTIONS(429),
    [anon_sym_int] = ACTIONS(429),
    [anon_sym_long] = ACTIONS(429),
    [anon_sym_object] = ACTIONS(429),
    [anon_sym_sbyte] = ACTIONS(429),
    [anon_sym_short] = ACTIONS(429),
    [anon_sym_string] = ACTIONS(429),
    [anon_sym_uint] = ACTIONS(429),
    [anon_sym_ulong] = ACTIONS(429),
    [anon_sym_ushort] = ACTIONS(429),
    [anon_sym_abstract] = ACTIONS(431),
    [anon_sym_async] = ACTIONS(431),
    [anon_sym_extern] = ACTIONS(431),
    [anon_sym_internal] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(431),
    [anon_sym_override] = ACTIONS(431),
    [anon_sym_private] = ACTIONS(431),
    [anon_sym_protected] = ACTIONS(431),
    [anon_sym_public] = ACTIONS(431),
    [anon_sym_readonly] = ACTIONS(431),
    [anon_sym_sealed] = ACTIONS(431),
    [anon_sym_static] = ACTIONS(431),
    [anon_sym_unsafe] = ACTIONS(431),
    [anon_sym_virtual] = ACTIONS(431),
    [anon_sym_volatile] = ACTIONS(431),
    [anon_sym_partial] = ACTIONS(429),
    [anon_sym_class] = ACTIONS(429),
    [anon_sym_struct] = ACTIONS(429),
    [anon_sym_event] = ACTIONS(429),
    [anon_sym_implicit] = ACTIONS(429),
    [anon_sym_explicit] = ACTIONS(429),
    [anon_sym_interface] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(429),
    [anon_sym_delegate] = ACTIONS(429),
    [sym_void_keyword] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(429),
    [sym_identifier_name] = ACTIONS(429),
    [sym_comment] = ACTIONS(31),
  },
  [147] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [148] = {
    [sym__attribute_section] = STATE(243),
    [aux_sym__attributes_repeat1] = STATE(243),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_byte] = ACTIONS(433),
    [anon_sym_char] = ACTIONS(433),
    [anon_sym_decimal] = ACTIONS(433),
    [anon_sym_double] = ACTIONS(433),
    [anon_sym_float] = ACTIONS(433),
    [anon_sym_int] = ACTIONS(433),
    [anon_sym_long] = ACTIONS(433),
    [anon_sym_object] = ACTIONS(433),
    [anon_sym_sbyte] = ACTIONS(433),
    [anon_sym_short] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_uint] = ACTIONS(433),
    [anon_sym_ulong] = ACTIONS(433),
    [anon_sym_ushort] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(433),
    [anon_sym_async] = ACTIONS(433),
    [anon_sym_extern] = ACTIONS(433),
    [anon_sym_internal] = ACTIONS(433),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_override] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_readonly] = ACTIONS(433),
    [anon_sym_sealed] = ACTIONS(433),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_unsafe] = ACTIONS(433),
    [anon_sym_virtual] = ACTIONS(433),
    [anon_sym_volatile] = ACTIONS(433),
    [anon_sym_partial] = ACTIONS(433),
    [anon_sym_class] = ACTIONS(433),
    [anon_sym_struct] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_implicit] = ACTIONS(433),
    [anon_sym_explicit] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(433),
    [anon_sym_enum] = ACTIONS(433),
    [anon_sym_delegate] = ACTIONS(433),
    [sym_void_keyword] = ACTIONS(433),
    [anon_sym_const] = ACTIONS(433),
    [sym_identifier_name] = ACTIONS(433),
    [sym_comment] = ACTIONS(31),
  },
  [149] = {
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_COMMA1] = ACTIONS(437),
    [anon_sym_where] = ACTIONS(435),
    [sym_comment] = ACTIONS(31),
  },
  [150] = {
    [anon_sym_COLON] = ACTIONS(439),
    [sym_comment] = ACTIONS(31),
  },
  [151] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(441),
    [anon_sym_where] = ACTIONS(443),
    [sym_comment] = ACTIONS(31),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(446),
    [anon_sym_bool] = ACTIONS(448),
    [anon_sym_byte] = ACTIONS(448),
    [anon_sym_char] = ACTIONS(448),
    [anon_sym_decimal] = ACTIONS(448),
    [anon_sym_double] = ACTIONS(448),
    [anon_sym_float] = ACTIONS(448),
    [anon_sym_int] = ACTIONS(448),
    [anon_sym_long] = ACTIONS(448),
    [anon_sym_object] = ACTIONS(448),
    [anon_sym_sbyte] = ACTIONS(448),
    [anon_sym_short] = ACTIONS(448),
    [anon_sym_string] = ACTIONS(448),
    [anon_sym_uint] = ACTIONS(448),
    [anon_sym_ulong] = ACTIONS(448),
    [anon_sym_ushort] = ACTIONS(448),
    [anon_sym_abstract] = ACTIONS(448),
    [anon_sym_async] = ACTIONS(448),
    [anon_sym_extern] = ACTIONS(448),
    [anon_sym_internal] = ACTIONS(448),
    [anon_sym_new] = ACTIONS(448),
    [anon_sym_override] = ACTIONS(448),
    [anon_sym_private] = ACTIONS(448),
    [anon_sym_protected] = ACTIONS(448),
    [anon_sym_public] = ACTIONS(448),
    [anon_sym_readonly] = ACTIONS(448),
    [anon_sym_sealed] = ACTIONS(448),
    [anon_sym_static] = ACTIONS(448),
    [anon_sym_unsafe] = ACTIONS(448),
    [anon_sym_virtual] = ACTIONS(448),
    [anon_sym_volatile] = ACTIONS(448),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_using] = ACTIONS(448),
    [anon_sym_namespace] = ACTIONS(448),
    [anon_sym_RBRACE] = ACTIONS(446),
    [anon_sym_partial] = ACTIONS(448),
    [anon_sym_class] = ACTIONS(448),
    [anon_sym_struct] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(446),
    [anon_sym_event] = ACTIONS(448),
    [anon_sym_TILDE] = ACTIONS(446),
    [anon_sym_implicit] = ACTIONS(448),
    [anon_sym_explicit] = ACTIONS(448),
    [anon_sym_interface] = ACTIONS(448),
    [anon_sym_enum] = ACTIONS(448),
    [anon_sym_delegate] = ACTIONS(448),
    [sym_void_keyword] = ACTIONS(448),
    [anon_sym_const] = ACTIONS(448),
    [sym_identifier_name] = ACTIONS(448),
    [sym_comment] = ACTIONS(31),
  },
  [153] = {
    [sym__type] = STATE(227),
    [sym_predefined_type] = STATE(227),
    [sym_modifiers] = STATE(239),
    [sym__indexer_declarator] = STATE(228),
    [sym__operator_declarator] = STATE(229),
    [sym__unary_operator_declarator] = STATE(229),
    [sym__binary_operator_declarator] = STATE(229),
    [sym__conversion_operator_declarator] = STATE(229),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_variable_declaration] = STATE(230),
    [sym_generic_name] = STATE(227),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_partial] = ACTIONS(401),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_struct] = ACTIONS(383),
    [anon_sym_event] = ACTIONS(403),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(385),
    [anon_sym_enum] = ACTIONS(405),
    [anon_sym_delegate] = ACTIONS(407),
    [sym_void_keyword] = ACTIONS(387),
    [anon_sym_const] = ACTIONS(409),
    [sym_identifier_name] = ACTIONS(411),
    [sym_comment] = ACTIONS(31),
  },
  [154] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(357),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [155] = {
    [sym__attribute_section] = STATE(248),
    [aux_sym__attributes_repeat1] = STATE(248),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_byte] = ACTIONS(433),
    [anon_sym_char] = ACTIONS(433),
    [anon_sym_decimal] = ACTIONS(433),
    [anon_sym_double] = ACTIONS(433),
    [anon_sym_float] = ACTIONS(433),
    [anon_sym_int] = ACTIONS(433),
    [anon_sym_long] = ACTIONS(433),
    [anon_sym_object] = ACTIONS(433),
    [anon_sym_sbyte] = ACTIONS(433),
    [anon_sym_short] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_uint] = ACTIONS(433),
    [anon_sym_ulong] = ACTIONS(433),
    [anon_sym_ushort] = ACTIONS(433),
    [anon_sym_abstract] = ACTIONS(433),
    [anon_sym_async] = ACTIONS(433),
    [anon_sym_extern] = ACTIONS(433),
    [anon_sym_internal] = ACTIONS(433),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_override] = ACTIONS(433),
    [anon_sym_private] = ACTIONS(433),
    [anon_sym_protected] = ACTIONS(433),
    [anon_sym_public] = ACTIONS(433),
    [anon_sym_readonly] = ACTIONS(433),
    [anon_sym_sealed] = ACTIONS(433),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_unsafe] = ACTIONS(433),
    [anon_sym_virtual] = ACTIONS(433),
    [anon_sym_volatile] = ACTIONS(433),
    [anon_sym_partial] = ACTIONS(433),
    [anon_sym_class] = ACTIONS(433),
    [anon_sym_struct] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(433),
    [anon_sym_implicit] = ACTIONS(433),
    [anon_sym_explicit] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(433),
    [anon_sym_enum] = ACTIONS(433),
    [anon_sym_delegate] = ACTIONS(433),
    [sym_void_keyword] = ACTIONS(433),
    [anon_sym_const] = ACTIONS(433),
    [sym_identifier_name] = ACTIONS(433),
    [sym_comment] = ACTIONS(31),
  },
  [156] = {
    [aux_sym_class_base_repeat1] = STATE(250),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(454),
    [anon_sym_where] = ACTIONS(454),
    [sym_comment] = ACTIONS(31),
  },
  [157] = {
    [anon_sym_RBRACK] = ACTIONS(456),
    [sym_comment] = ACTIONS(31),
  },
  [158] = {
    [anon_sym_COMMA] = ACTIONS(458),
    [anon_sym_RBRACK] = ACTIONS(458),
    [sym_comment] = ACTIONS(31),
  },
  [159] = {
    [anon_sym_COMMA] = ACTIONS(460),
    [anon_sym_RBRACK] = ACTIONS(460),
    [sym_comment] = ACTIONS(31),
  },
  [160] = {
    [aux_sym_attribute_list_repeat1] = STATE(160),
    [anon_sym_COMMA] = ACTIONS(462),
    [anon_sym_RBRACK] = ACTIONS(460),
    [sym_comment] = ACTIONS(31),
  },
  [161] = {
    [sym__type] = STATE(254),
    [sym_predefined_type] = STATE(254),
    [sym_generic_name] = STATE(254),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_event] = ACTIONS(465),
    [sym_void_keyword] = ACTIONS(467),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(469),
    [anon_sym_bool] = ACTIONS(471),
    [anon_sym_byte] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_decimal] = ACTIONS(471),
    [anon_sym_double] = ACTIONS(471),
    [anon_sym_float] = ACTIONS(471),
    [anon_sym_int] = ACTIONS(471),
    [anon_sym_long] = ACTIONS(471),
    [anon_sym_object] = ACTIONS(471),
    [anon_sym_sbyte] = ACTIONS(471),
    [anon_sym_short] = ACTIONS(471),
    [anon_sym_string] = ACTIONS(471),
    [anon_sym_uint] = ACTIONS(471),
    [anon_sym_ulong] = ACTIONS(471),
    [anon_sym_ushort] = ACTIONS(471),
    [anon_sym_abstract] = ACTIONS(471),
    [anon_sym_async] = ACTIONS(471),
    [anon_sym_extern] = ACTIONS(471),
    [anon_sym_internal] = ACTIONS(471),
    [anon_sym_new] = ACTIONS(471),
    [anon_sym_override] = ACTIONS(471),
    [anon_sym_private] = ACTIONS(471),
    [anon_sym_protected] = ACTIONS(471),
    [anon_sym_public] = ACTIONS(471),
    [anon_sym_readonly] = ACTIONS(471),
    [anon_sym_sealed] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(471),
    [anon_sym_unsafe] = ACTIONS(471),
    [anon_sym_virtual] = ACTIONS(471),
    [anon_sym_volatile] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_using] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(471),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_partial] = ACTIONS(471),
    [anon_sym_class] = ACTIONS(471),
    [anon_sym_struct] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(469),
    [anon_sym_event] = ACTIONS(471),
    [anon_sym_TILDE] = ACTIONS(469),
    [anon_sym_implicit] = ACTIONS(471),
    [anon_sym_explicit] = ACTIONS(471),
    [anon_sym_interface] = ACTIONS(471),
    [anon_sym_enum] = ACTIONS(471),
    [anon_sym_delegate] = ACTIONS(471),
    [sym_void_keyword] = ACTIONS(471),
    [anon_sym_const] = ACTIONS(471),
    [sym_identifier_name] = ACTIONS(471),
    [sym_comment] = ACTIONS(31),
  },
  [163] = {
    [sym__type] = STATE(256),
    [sym_predefined_type] = STATE(256),
    [sym_generic_name] = STATE(256),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [164] = {
    [sym_identifier_name] = ACTIONS(475),
    [sym_comment] = ACTIONS(31),
  },
  [165] = {
    [anon_sym_this] = ACTIONS(477),
    [sym_identifier_name] = ACTIONS(479),
    [sym_comment] = ACTIONS(31),
  },
  [166] = {
    [sym__type] = STATE(254),
    [sym_predefined_type] = STATE(254),
    [sym_generic_name] = STATE(254),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(481),
    [anon_sym_event] = ACTIONS(465),
    [sym_void_keyword] = ACTIONS(467),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [167] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [168] = {
    [sym__attribute_section] = STATE(262),
    [aux_sym__attributes_repeat1] = STATE(262),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_byte] = ACTIONS(433),
    [anon_sym_char] = ACTIONS(433),
    [anon_sym_decimal] = ACTIONS(433),
    [anon_sym_double] = ACTIONS(433),
    [anon_sym_float] = ACTIONS(433),
    [anon_sym_int] = ACTIONS(433),
    [anon_sym_long] = ACTIONS(433),
    [anon_sym_object] = ACTIONS(433),
    [anon_sym_sbyte] = ACTIONS(433),
    [anon_sym_short] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_uint] = ACTIONS(433),
    [anon_sym_ulong] = ACTIONS(433),
    [anon_sym_ushort] = ACTIONS(433),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(433),
    [sym_void_keyword] = ACTIONS(433),
    [sym_identifier_name] = ACTIONS(433),
    [sym_comment] = ACTIONS(31),
  },
  [169] = {
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_where] = ACTIONS(485),
    [sym_comment] = ACTIONS(31),
  },
  [170] = {
    [anon_sym_COMMA] = ACTIONS(487),
    [anon_sym_EQ] = ACTIONS(489),
    [anon_sym_RBRACE] = ACTIONS(487),
    [sym_comment] = ACTIONS(31),
  },
  [171] = {
    [aux_sym_enum_declaration_repeat1] = STATE(267),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(493),
    [sym_comment] = ACTIONS(31),
  },
  [172] = {
    [sym_identifier_name] = ACTIONS(495),
    [sym_comment] = ACTIONS(31),
  },
  [173] = {
    [sym__attribute_section] = STATE(269),
    [aux_sym__attributes_repeat1] = STATE(269),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_identifier_name] = ACTIONS(85),
    [sym_comment] = ACTIONS(31),
  },
  [174] = {
    [anon_sym_LBRACE] = ACTIONS(497),
    [sym_comment] = ACTIONS(31),
  },
  [175] = {
    [sym__type] = STATE(275),
    [sym_predefined_type] = STATE(275),
    [sym__formal_parameter_list] = STATE(276),
    [sym_parameter] = STATE(277),
    [sym_parameter_modifier] = STATE(278),
    [sym_parameter_array] = STATE(276),
    [sym__attributes] = STATE(279),
    [sym__attribute_section] = STATE(280),
    [sym_generic_name] = STATE(275),
    [aux_sym__attributes_repeat1] = STATE(280),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(505),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [176] = {
    [anon_sym_SEMI] = ACTIONS(507),
    [sym_comment] = ACTIONS(31),
  },
  [177] = {
    [sym_type_parameter_list] = STATE(282),
    [sym_class_base] = STATE(195),
    [sym_type_parameter_constraints_clause] = STATE(196),
    [aux_sym_class_declaration_repeat1] = STATE(196),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [178] = {
    [sym_type_parameter_list] = STATE(283),
    [sym_type_parameter_constraints_clause] = STATE(201),
    [sym_struct_interfaces] = STATE(200),
    [aux_sym_class_declaration_repeat1] = STATE(201),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [179] = {
    [sym_type_parameter_list] = STATE(284),
    [sym_type_parameter_constraints_clause] = STATE(206),
    [sym_interface_base] = STATE(205),
    [aux_sym_class_declaration_repeat1] = STATE(206),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [180] = {
    [sym_enum_member_declaration] = STATE(285),
    [sym__attributes] = STATE(172),
    [sym__attribute_section] = STATE(173),
    [aux_sym__attributes_repeat1] = STATE(173),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_identifier_name] = ACTIONS(303),
    [sym_comment] = ACTIONS(31),
  },
  [181] = {
    [sym__integral_type] = STATE(286),
    [anon_sym_byte] = ACTIONS(509),
    [anon_sym_char] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_long] = ACTIONS(509),
    [anon_sym_sbyte] = ACTIONS(509),
    [anon_sym_short] = ACTIONS(509),
    [anon_sym_uint] = ACTIONS(509),
    [anon_sym_ulong] = ACTIONS(509),
    [anon_sym_ushort] = ACTIONS(509),
    [sym_comment] = ACTIONS(31),
  },
  [182] = {
    [sym_parameter_list] = STATE(287),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [183] = {
    [sym_identifier_name] = ACTIONS(511),
    [sym_comment] = ACTIONS(31),
  },
  [184] = {
    [sym_identifier_name] = ACTIONS(513),
    [sym_comment] = ACTIONS(31),
  },
  [185] = {
    [sym_identifier_name] = ACTIONS(515),
    [sym_comment] = ACTIONS(31),
  },
  [186] = {
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COLON] = ACTIONS(517),
    [sym_comment] = ACTIONS(31),
  },
  [187] = {
    [sym_identifier_name] = ACTIONS(519),
    [sym_comment] = ACTIONS(31),
  },
  [188] = {
    [sym__type_declaration] = STATE(55),
    [sym_modifiers] = STATE(14),
    [sym_namespace_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_struct_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_delegate_declaration] = STATE(55),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_compilation_unit_repeat4] = STATE(55),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym__attributes_repeat1] = STATE(21),
    [ts_builtin_sym_end] = ACTIONS(521),
    [anon_sym_abstract] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(9),
    [anon_sym_internal] = ACTIONS(9),
    [anon_sym_new] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_sealed] = ACTIONS(9),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_unsafe] = ACTIONS(9),
    [anon_sym_virtual] = ACTIONS(9),
    [anon_sym_volatile] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_partial] = ACTIONS(17),
    [anon_sym_class] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_interface] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_delegate] = ACTIONS(29),
    [sym_comment] = ACTIONS(31),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(523),
    [anon_sym_abstract] = ACTIONS(523),
    [anon_sym_async] = ACTIONS(523),
    [anon_sym_extern] = ACTIONS(523),
    [anon_sym_internal] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_override] = ACTIONS(523),
    [anon_sym_private] = ACTIONS(523),
    [anon_sym_protected] = ACTIONS(523),
    [anon_sym_public] = ACTIONS(523),
    [anon_sym_readonly] = ACTIONS(523),
    [anon_sym_sealed] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(523),
    [anon_sym_unsafe] = ACTIONS(523),
    [anon_sym_virtual] = ACTIONS(523),
    [anon_sym_volatile] = ACTIONS(523),
    [anon_sym_using] = ACTIONS(523),
    [anon_sym_namespace] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_partial] = ACTIONS(523),
    [anon_sym_class] = ACTIONS(523),
    [anon_sym_struct] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(523),
    [anon_sym_interface] = ACTIONS(523),
    [anon_sym_enum] = ACTIONS(523),
    [anon_sym_delegate] = ACTIONS(523),
    [sym_comment] = ACTIONS(31),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(523),
    [anon_sym_abstract] = ACTIONS(523),
    [anon_sym_async] = ACTIONS(523),
    [anon_sym_extern] = ACTIONS(523),
    [anon_sym_internal] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(523),
    [anon_sym_override] = ACTIONS(523),
    [anon_sym_private] = ACTIONS(523),
    [anon_sym_protected] = ACTIONS(523),
    [anon_sym_public] = ACTIONS(523),
    [anon_sym_readonly] = ACTIONS(523),
    [anon_sym_sealed] = ACTIONS(523),
    [anon_sym_static] = ACTIONS(523),
    [anon_sym_unsafe] = ACTIONS(523),
    [anon_sym_virtual] = ACTIONS(523),
    [anon_sym_volatile] = ACTIONS(523),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_using] = ACTIONS(523),
    [anon_sym_namespace] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_partial] = ACTIONS(523),
    [anon_sym_class] = ACTIONS(523),
    [anon_sym_struct] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(523),
    [anon_sym_interface] = ACTIONS(523),
    [anon_sym_enum] = ACTIONS(523),
    [anon_sym_delegate] = ACTIONS(523),
    [sym_comment] = ACTIONS(31),
  },
  [191] = {
    [sym__type_declaration] = STATE(191),
    [sym_modifiers] = STATE(14),
    [sym_using_directive] = STATE(191),
    [sym_namespace_declaration] = STATE(191),
    [sym_class_declaration] = STATE(191),
    [sym_interface_declaration] = STATE(191),
    [sym_struct_declaration] = STATE(191),
    [sym_enum_declaration] = STATE(191),
    [sym_delegate_declaration] = STATE(191),
    [sym__attributes] = STATE(15),
    [sym__attribute_section] = STATE(21),
    [aux_sym_modifiers_repeat1] = STATE(20),
    [aux_sym_namespace_declaration_repeat1] = STATE(191),
    [aux_sym__attributes_repeat1] = STATE(21),
    [anon_sym_abstract] = ACTIONS(527),
    [anon_sym_async] = ACTIONS(527),
    [anon_sym_extern] = ACTIONS(527),
    [anon_sym_internal] = ACTIONS(527),
    [anon_sym_new] = ACTIONS(527),
    [anon_sym_override] = ACTIONS(527),
    [anon_sym_private] = ACTIONS(527),
    [anon_sym_protected] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(527),
    [anon_sym_readonly] = ACTIONS(527),
    [anon_sym_sealed] = ACTIONS(527),
    [anon_sym_static] = ACTIONS(527),
    [anon_sym_unsafe] = ACTIONS(527),
    [anon_sym_virtual] = ACTIONS(527),
    [anon_sym_volatile] = ACTIONS(527),
    [anon_sym_using] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_partial] = ACTIONS(538),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_struct] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(547),
    [anon_sym_interface] = ACTIONS(550),
    [anon_sym_enum] = ACTIONS(553),
    [anon_sym_delegate] = ACTIONS(556),
    [sym_comment] = ACTIONS(31),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym_bool] = ACTIONS(561),
    [anon_sym_byte] = ACTIONS(561),
    [anon_sym_char] = ACTIONS(561),
    [anon_sym_decimal] = ACTIONS(561),
    [anon_sym_double] = ACTIONS(561),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_int] = ACTIONS(561),
    [anon_sym_long] = ACTIONS(561),
    [anon_sym_object] = ACTIONS(561),
    [anon_sym_sbyte] = ACTIONS(561),
    [anon_sym_short] = ACTIONS(561),
    [anon_sym_string] = ACTIONS(561),
    [anon_sym_uint] = ACTIONS(561),
    [anon_sym_ulong] = ACTIONS(561),
    [anon_sym_ushort] = ACTIONS(561),
    [anon_sym_abstract] = ACTIONS(561),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(561),
    [anon_sym_internal] = ACTIONS(561),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_override] = ACTIONS(561),
    [anon_sym_private] = ACTIONS(561),
    [anon_sym_protected] = ACTIONS(561),
    [anon_sym_public] = ACTIONS(561),
    [anon_sym_readonly] = ACTIONS(561),
    [anon_sym_sealed] = ACTIONS(561),
    [anon_sym_static] = ACTIONS(561),
    [anon_sym_unsafe] = ACTIONS(561),
    [anon_sym_virtual] = ACTIONS(561),
    [anon_sym_volatile] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(563),
    [anon_sym_using] = ACTIONS(561),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_partial] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(561),
    [anon_sym_struct] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_event] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_implicit] = ACTIONS(561),
    [anon_sym_explicit] = ACTIONS(561),
    [anon_sym_interface] = ACTIONS(561),
    [anon_sym_enum] = ACTIONS(561),
    [anon_sym_delegate] = ACTIONS(561),
    [sym_void_keyword] = ACTIONS(561),
    [anon_sym_const] = ACTIONS(561),
    [sym_identifier_name] = ACTIONS(561),
    [sym_comment] = ACTIONS(31),
  },
  [193] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [194] = {
    [sym__type_declaration] = STATE(296),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(296),
    [sym_class_declaration] = STATE(296),
    [sym_indexer_declaration] = STATE(296),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(296),
    [sym_operator_declaration] = STATE(296),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(296),
    [sym_struct_declaration] = STATE(296),
    [sym_enum_declaration] = STATE(296),
    [sym_delegate_declaration] = STATE(296),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(296),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(296),
    [sym_constructor_declaration] = STATE(296),
    [sym_destructor_declaration] = STATE(296),
    [sym_method_declaration] = STATE(296),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(296),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [195] = {
    [sym_type_parameter_constraints_clause] = STATE(298),
    [aux_sym_class_declaration_repeat1] = STATE(298),
    [anon_sym_LBRACE] = ACTIONS(567),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [196] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(567),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym_bool] = ACTIONS(571),
    [anon_sym_byte] = ACTIONS(571),
    [anon_sym_char] = ACTIONS(571),
    [anon_sym_decimal] = ACTIONS(571),
    [anon_sym_double] = ACTIONS(571),
    [anon_sym_float] = ACTIONS(571),
    [anon_sym_int] = ACTIONS(571),
    [anon_sym_long] = ACTIONS(571),
    [anon_sym_object] = ACTIONS(571),
    [anon_sym_sbyte] = ACTIONS(571),
    [anon_sym_short] = ACTIONS(571),
    [anon_sym_string] = ACTIONS(571),
    [anon_sym_uint] = ACTIONS(571),
    [anon_sym_ulong] = ACTIONS(571),
    [anon_sym_ushort] = ACTIONS(571),
    [anon_sym_abstract] = ACTIONS(571),
    [anon_sym_async] = ACTIONS(571),
    [anon_sym_extern] = ACTIONS(571),
    [anon_sym_internal] = ACTIONS(571),
    [anon_sym_new] = ACTIONS(571),
    [anon_sym_override] = ACTIONS(571),
    [anon_sym_private] = ACTIONS(571),
    [anon_sym_protected] = ACTIONS(571),
    [anon_sym_public] = ACTIONS(571),
    [anon_sym_readonly] = ACTIONS(571),
    [anon_sym_sealed] = ACTIONS(571),
    [anon_sym_static] = ACTIONS(571),
    [anon_sym_unsafe] = ACTIONS(571),
    [anon_sym_virtual] = ACTIONS(571),
    [anon_sym_volatile] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_using] = ACTIONS(571),
    [anon_sym_namespace] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_partial] = ACTIONS(571),
    [anon_sym_class] = ACTIONS(571),
    [anon_sym_struct] = ACTIONS(571),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_event] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_implicit] = ACTIONS(571),
    [anon_sym_explicit] = ACTIONS(571),
    [anon_sym_interface] = ACTIONS(571),
    [anon_sym_enum] = ACTIONS(571),
    [anon_sym_delegate] = ACTIONS(571),
    [sym_void_keyword] = ACTIONS(571),
    [anon_sym_const] = ACTIONS(571),
    [sym_identifier_name] = ACTIONS(571),
    [sym_comment] = ACTIONS(31),
  },
  [198] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [199] = {
    [sym__type_declaration] = STATE(301),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(301),
    [sym_class_declaration] = STATE(301),
    [sym_indexer_declaration] = STATE(301),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(301),
    [sym_operator_declaration] = STATE(301),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(301),
    [sym_struct_declaration] = STATE(301),
    [sym_enum_declaration] = STATE(301),
    [sym_delegate_declaration] = STATE(301),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(301),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(301),
    [sym_constructor_declaration] = STATE(301),
    [sym_method_declaration] = STATE(301),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(301),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [200] = {
    [sym_type_parameter_constraints_clause] = STATE(303),
    [aux_sym_class_declaration_repeat1] = STATE(303),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [201] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(579),
    [anon_sym_bool] = ACTIONS(581),
    [anon_sym_byte] = ACTIONS(581),
    [anon_sym_char] = ACTIONS(581),
    [anon_sym_decimal] = ACTIONS(581),
    [anon_sym_double] = ACTIONS(581),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_long] = ACTIONS(581),
    [anon_sym_object] = ACTIONS(581),
    [anon_sym_sbyte] = ACTIONS(581),
    [anon_sym_short] = ACTIONS(581),
    [anon_sym_string] = ACTIONS(581),
    [anon_sym_uint] = ACTIONS(581),
    [anon_sym_ulong] = ACTIONS(581),
    [anon_sym_ushort] = ACTIONS(581),
    [anon_sym_abstract] = ACTIONS(581),
    [anon_sym_async] = ACTIONS(581),
    [anon_sym_extern] = ACTIONS(581),
    [anon_sym_internal] = ACTIONS(581),
    [anon_sym_new] = ACTIONS(581),
    [anon_sym_override] = ACTIONS(581),
    [anon_sym_private] = ACTIONS(581),
    [anon_sym_protected] = ACTIONS(581),
    [anon_sym_public] = ACTIONS(581),
    [anon_sym_readonly] = ACTIONS(581),
    [anon_sym_sealed] = ACTIONS(581),
    [anon_sym_static] = ACTIONS(581),
    [anon_sym_unsafe] = ACTIONS(581),
    [anon_sym_virtual] = ACTIONS(581),
    [anon_sym_volatile] = ACTIONS(581),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_using] = ACTIONS(581),
    [anon_sym_namespace] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_partial] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(581),
    [anon_sym_struct] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_event] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_implicit] = ACTIONS(581),
    [anon_sym_explicit] = ACTIONS(581),
    [anon_sym_interface] = ACTIONS(581),
    [anon_sym_enum] = ACTIONS(581),
    [anon_sym_delegate] = ACTIONS(581),
    [sym_void_keyword] = ACTIONS(581),
    [anon_sym_const] = ACTIONS(581),
    [sym_identifier_name] = ACTIONS(581),
    [sym_comment] = ACTIONS(31),
  },
  [203] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [204] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(306),
    [sym_interface_event_declaration] = STATE(306),
    [sym_interface_property_declaration] = STATE(306),
    [sym_interface_indexer_declaration] = STATE(306),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(306),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [205] = {
    [sym_type_parameter_constraints_clause] = STATE(308),
    [aux_sym_class_declaration_repeat1] = STATE(308),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [206] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [207] = {
    [sym__type] = STATE(128),
    [sym_predefined_type] = STATE(128),
    [sym_type_parameter] = STATE(309),
    [sym_generic_name] = STATE(128),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [208] = {
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_GT] = ACTIONS(589),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COLON] = ACTIONS(589),
    [anon_sym_where] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_this] = ACTIONS(591),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_operator] = ACTIONS(591),
    [sym_identifier_name] = ACTIONS(591),
    [sym_comment] = ACTIONS(31),
  },
  [209] = {
    [aux_sym_type_parameter_list_repeat1] = STATE(311),
    [anon_sym_COMMA] = ACTIONS(367),
    [anon_sym_GT] = ACTIONS(593),
    [sym_comment] = ACTIONS(31),
  },
  [210] = {
    [sym_identifier_name] = ACTIONS(595),
    [sym_comment] = ACTIONS(31),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym_bool] = ACTIONS(561),
    [anon_sym_byte] = ACTIONS(561),
    [anon_sym_char] = ACTIONS(561),
    [anon_sym_decimal] = ACTIONS(561),
    [anon_sym_double] = ACTIONS(561),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_int] = ACTIONS(561),
    [anon_sym_long] = ACTIONS(561),
    [anon_sym_object] = ACTIONS(561),
    [anon_sym_sbyte] = ACTIONS(561),
    [anon_sym_short] = ACTIONS(561),
    [anon_sym_string] = ACTIONS(561),
    [anon_sym_uint] = ACTIONS(561),
    [anon_sym_ulong] = ACTIONS(561),
    [anon_sym_ushort] = ACTIONS(561),
    [anon_sym_abstract] = ACTIONS(561),
    [anon_sym_async] = ACTIONS(561),
    [anon_sym_extern] = ACTIONS(561),
    [anon_sym_internal] = ACTIONS(561),
    [anon_sym_new] = ACTIONS(561),
    [anon_sym_override] = ACTIONS(561),
    [anon_sym_private] = ACTIONS(561),
    [anon_sym_protected] = ACTIONS(561),
    [anon_sym_public] = ACTIONS(561),
    [anon_sym_readonly] = ACTIONS(561),
    [anon_sym_sealed] = ACTIONS(561),
    [anon_sym_static] = ACTIONS(561),
    [anon_sym_unsafe] = ACTIONS(561),
    [anon_sym_virtual] = ACTIONS(561),
    [anon_sym_volatile] = ACTIONS(561),
    [anon_sym_using] = ACTIONS(561),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_partial] = ACTIONS(561),
    [anon_sym_class] = ACTIONS(561),
    [anon_sym_struct] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_event] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_implicit] = ACTIONS(561),
    [anon_sym_explicit] = ACTIONS(561),
    [anon_sym_interface] = ACTIONS(561),
    [anon_sym_enum] = ACTIONS(561),
    [anon_sym_delegate] = ACTIONS(561),
    [sym_void_keyword] = ACTIONS(561),
    [anon_sym_const] = ACTIONS(561),
    [sym_identifier_name] = ACTIONS(561),
    [sym_comment] = ACTIONS(31),
  },
  [212] = {
    [sym_identifier_name] = ACTIONS(597),
    [sym_comment] = ACTIONS(31),
  },
  [213] = {
    [sym_identifier_name] = ACTIONS(599),
    [sym_comment] = ACTIONS(31),
  },
  [214] = {
    [sym_parameter_list] = STATE(315),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [215] = {
    [sym_type_parameter_list] = STATE(316),
    [sym_parameter_list] = STATE(317),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [216] = {
    [sym__constant_declarators] = STATE(319),
    [sym_constant_declarator] = STATE(320),
    [sym_identifier_name] = ACTIONS(601),
    [sym_comment] = ACTIONS(31),
  },
  [217] = {
    [sym_parameter_list] = STATE(321),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_this] = ACTIONS(311),
    [anon_sym_operator] = ACTIONS(311),
    [sym_identifier_name] = ACTIONS(311),
    [sym_comment] = ACTIONS(31),
  },
  [218] = {
    [sym_statement_block] = STATE(322),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [219] = {
    [anon_sym_LBRACK] = ACTIONS(603),
    [sym_comment] = ACTIONS(31),
  },
  [220] = {
    [sym_overloadable_unary_operator] = STATE(327),
    [sym_overloadable_binary_operator] = STATE(328),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_GT] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_TILDE] = ACTIONS(611),
    [anon_sym_PLUS_PLUS] = ACTIONS(611),
    [anon_sym_DASH_DASH] = ACTIONS(611),
    [anon_sym_true] = ACTIONS(611),
    [anon_sym_false] = ACTIONS(611),
    [anon_sym_STAR] = ACTIONS(613),
    [anon_sym_SLASH] = ACTIONS(605),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_CARET] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(613),
    [anon_sym_AMP] = ACTIONS(613),
    [anon_sym_LT_LT] = ACTIONS(613),
    [anon_sym_GT_GT] = ACTIONS(613),
    [anon_sym_EQ_EQ] = ACTIONS(613),
    [anon_sym_BANG_EQ] = ACTIONS(613),
    [anon_sym_GT_EQ] = ACTIONS(613),
    [anon_sym_LT_EQ] = ACTIONS(613),
    [sym_comment] = ACTIONS(31),
  },
  [221] = {
    [sym_type_parameter_list] = STATE(316),
    [sym__property_body] = STATE(333),
    [sym_parameter_list] = STATE(317),
    [sym_equals_value_clause] = STATE(334),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_EQ_GT] = ACTIONS(621),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_DOT] = ACTIONS(623),
    [sym_comment] = ACTIONS(31),
  },
  [222] = {
    [aux_sym_variable_declaration_repeat1] = STATE(336),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(627),
    [sym_comment] = ACTIONS(31),
  },
  [223] = {
    [sym__type] = STATE(337),
    [sym_predefined_type] = STATE(337),
    [sym_generic_name] = STATE(337),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(629),
    [anon_sym_struct] = ACTIONS(631),
    [anon_sym_interface] = ACTIONS(633),
    [sym_void_keyword] = ACTIONS(635),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [224] = {
    [sym__type] = STATE(338),
    [sym_predefined_type] = STATE(338),
    [sym_generic_name] = STATE(338),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [225] = {
    [sym__type] = STATE(339),
    [sym_predefined_type] = STATE(339),
    [sym_generic_name] = STATE(339),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [226] = {
    [sym_type_parameter_list] = STATE(340),
    [sym_parameter_list] = STATE(321),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_this] = ACTIONS(149),
    [anon_sym_operator] = ACTIONS(149),
    [sym_identifier_name] = ACTIONS(149),
    [sym_comment] = ACTIONS(31),
  },
  [227] = {
    [sym_variable_declarator] = STATE(222),
    [anon_sym_this] = ACTIONS(395),
    [anon_sym_operator] = ACTIONS(397),
    [sym_identifier_name] = ACTIONS(637),
    [sym_comment] = ACTIONS(31),
  },
  [228] = {
    [sym__indexer_body] = STATE(342),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [sym_comment] = ACTIONS(31),
  },
  [229] = {
    [sym_statement_block] = STATE(343),
    [anon_sym_SEMI] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_EQ_GT] = ACTIONS(641),
    [sym_comment] = ACTIONS(31),
  },
  [230] = {
    [anon_sym_SEMI] = ACTIONS(643),
    [sym_comment] = ACTIONS(31),
  },
  [231] = {
    [sym__accessor_declarations] = STATE(351),
    [sym_get_accessor_declaration] = STATE(352),
    [sym_set_accessor_declaration] = STATE(353),
    [sym_accessor_modifier] = STATE(354),
    [sym__attributes] = STATE(355),
    [sym__attribute_section] = STATE(356),
    [aux_sym__attributes_repeat1] = STATE(356),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(649),
    [anon_sym_get] = ACTIONS(651),
    [anon_sym_set] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [232] = {
    [sym__expression] = STATE(366),
    [sym_parenthesized_expression] = STATE(366),
    [sym_ternary_expression] = STATE(366),
    [sym_binary_expression] = STATE(366),
    [sym_unary_expression] = STATE(366),
    [sym__literal] = STATE(366),
    [sym_boolean_literal] = STATE(366),
    [sym_character_literal] = STATE(366),
    [sym_integer_literal] = STATE(366),
    [sym_real_literal] = STATE(366),
    [sym_string_literal] = STATE(366),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(671),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(671),
    [sym_comment] = ACTIONS(31),
  },
  [233] = {
    [anon_sym_bool] = ACTIONS(677),
    [anon_sym_byte] = ACTIONS(677),
    [anon_sym_char] = ACTIONS(677),
    [anon_sym_decimal] = ACTIONS(677),
    [anon_sym_double] = ACTIONS(677),
    [anon_sym_float] = ACTIONS(677),
    [anon_sym_int] = ACTIONS(677),
    [anon_sym_long] = ACTIONS(677),
    [anon_sym_object] = ACTIONS(677),
    [anon_sym_sbyte] = ACTIONS(677),
    [anon_sym_short] = ACTIONS(677),
    [anon_sym_string] = ACTIONS(677),
    [anon_sym_uint] = ACTIONS(677),
    [anon_sym_ulong] = ACTIONS(677),
    [anon_sym_ushort] = ACTIONS(677),
    [anon_sym_abstract] = ACTIONS(677),
    [anon_sym_async] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(677),
    [anon_sym_internal] = ACTIONS(677),
    [anon_sym_new] = ACTIONS(677),
    [anon_sym_override] = ACTIONS(677),
    [anon_sym_private] = ACTIONS(677),
    [anon_sym_protected] = ACTIONS(677),
    [anon_sym_public] = ACTIONS(677),
    [anon_sym_readonly] = ACTIONS(677),
    [anon_sym_sealed] = ACTIONS(677),
    [anon_sym_static] = ACTIONS(677),
    [anon_sym_unsafe] = ACTIONS(677),
    [anon_sym_virtual] = ACTIONS(677),
    [anon_sym_volatile] = ACTIONS(677),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_partial] = ACTIONS(677),
    [anon_sym_class] = ACTIONS(677),
    [anon_sym_struct] = ACTIONS(677),
    [anon_sym_LBRACK] = ACTIONS(679),
    [anon_sym_event] = ACTIONS(677),
    [anon_sym_TILDE] = ACTIONS(679),
    [anon_sym_implicit] = ACTIONS(677),
    [anon_sym_explicit] = ACTIONS(677),
    [anon_sym_interface] = ACTIONS(677),
    [anon_sym_enum] = ACTIONS(677),
    [anon_sym_delegate] = ACTIONS(677),
    [sym_void_keyword] = ACTIONS(677),
    [anon_sym_const] = ACTIONS(677),
    [sym_identifier_name] = ACTIONS(677),
    [sym_comment] = ACTIONS(31),
  },
  [234] = {
    [anon_sym_bool] = ACTIONS(681),
    [anon_sym_byte] = ACTIONS(681),
    [anon_sym_char] = ACTIONS(681),
    [anon_sym_decimal] = ACTIONS(681),
    [anon_sym_double] = ACTIONS(681),
    [anon_sym_float] = ACTIONS(681),
    [anon_sym_int] = ACTIONS(681),
    [anon_sym_long] = ACTIONS(681),
    [anon_sym_object] = ACTIONS(681),
    [anon_sym_sbyte] = ACTIONS(681),
    [anon_sym_short] = ACTIONS(681),
    [anon_sym_string] = ACTIONS(681),
    [anon_sym_uint] = ACTIONS(681),
    [anon_sym_ulong] = ACTIONS(681),
    [anon_sym_ushort] = ACTIONS(681),
    [anon_sym_abstract] = ACTIONS(681),
    [anon_sym_async] = ACTIONS(681),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_internal] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(681),
    [anon_sym_override] = ACTIONS(681),
    [anon_sym_private] = ACTIONS(681),
    [anon_sym_protected] = ACTIONS(681),
    [anon_sym_public] = ACTIONS(681),
    [anon_sym_readonly] = ACTIONS(681),
    [anon_sym_sealed] = ACTIONS(681),
    [anon_sym_static] = ACTIONS(681),
    [anon_sym_unsafe] = ACTIONS(681),
    [anon_sym_virtual] = ACTIONS(681),
    [anon_sym_volatile] = ACTIONS(681),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_partial] = ACTIONS(681),
    [anon_sym_class] = ACTIONS(681),
    [anon_sym_struct] = ACTIONS(681),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_event] = ACTIONS(681),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_implicit] = ACTIONS(681),
    [anon_sym_explicit] = ACTIONS(681),
    [anon_sym_interface] = ACTIONS(681),
    [anon_sym_enum] = ACTIONS(681),
    [anon_sym_delegate] = ACTIONS(681),
    [sym_void_keyword] = ACTIONS(681),
    [anon_sym_const] = ACTIONS(681),
    [sym_identifier_name] = ACTIONS(681),
    [sym_comment] = ACTIONS(31),
  },
  [235] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(390),
    [sym_variable_assignment_statement] = STATE(390),
    [sym_statement_block] = STATE(390),
    [sym__statement_list] = STATE(387),
    [sym__labeled_statement] = STATE(390),
    [sym__embedded_statement] = STATE(390),
    [sym_empty_statement] = STATE(390),
    [sym_expression_statement] = STATE(390),
    [sym__selection_statement] = STATE(390),
    [sym__iteration_statement] = STATE(390),
    [sym__jump_statement] = STATE(390),
    [sym_try_statement] = STATE(390),
    [sym_checked_statement] = STATE(390),
    [sym_unchecked_statement] = STATE(390),
    [sym_lock_statement] = STATE(390),
    [sym_yield_statement] = STATE(390),
    [sym_if_statement] = STATE(390),
    [sym_switch_statement] = STATE(390),
    [sym_while_statement] = STATE(390),
    [sym_do_statement] = STATE(390),
    [sym_break_statement] = STATE(390),
    [sym_continue_statement] = STATE(390),
    [sym_return_statement] = STATE(390),
    [sym_throw_statement] = STATE(390),
    [sym_goto_statement] = STATE(390),
    [sym__declaration_statement] = STATE(390),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [aux_sym__statement_list_repeat1] = STATE(390),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(689),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(693),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(701),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(723),
  },
  [236] = {
    [sym__expression] = STATE(391),
    [sym_parenthesized_expression] = STATE(391),
    [sym_ternary_expression] = STATE(391),
    [sym_binary_expression] = STATE(391),
    [sym_unary_expression] = STATE(391),
    [sym__literal] = STATE(391),
    [sym_boolean_literal] = STATE(391),
    [sym_character_literal] = STATE(391),
    [sym_integer_literal] = STATE(391),
    [sym_real_literal] = STATE(391),
    [sym_string_literal] = STATE(391),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(725),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(725),
    [sym_comment] = ACTIONS(31),
  },
  [237] = {
    [sym__type] = STATE(392),
    [sym_predefined_type] = STATE(392),
    [sym_generic_name] = STATE(392),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [238] = {
    [anon_sym_bool] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(371),
    [anon_sym_char] = ACTIONS(371),
    [anon_sym_decimal] = ACTIONS(371),
    [anon_sym_double] = ACTIONS(371),
    [anon_sym_float] = ACTIONS(371),
    [anon_sym_int] = ACTIONS(371),
    [anon_sym_long] = ACTIONS(371),
    [anon_sym_object] = ACTIONS(371),
    [anon_sym_sbyte] = ACTIONS(371),
    [anon_sym_short] = ACTIONS(371),
    [anon_sym_string] = ACTIONS(371),
    [anon_sym_uint] = ACTIONS(371),
    [anon_sym_ulong] = ACTIONS(371),
    [anon_sym_ushort] = ACTIONS(371),
    [anon_sym_abstract] = ACTIONS(371),
    [anon_sym_async] = ACTIONS(371),
    [anon_sym_extern] = ACTIONS(371),
    [anon_sym_internal] = ACTIONS(371),
    [anon_sym_new] = ACTIONS(371),
    [anon_sym_override] = ACTIONS(371),
    [anon_sym_private] = ACTIONS(371),
    [anon_sym_protected] = ACTIONS(371),
    [anon_sym_public] = ACTIONS(371),
    [anon_sym_readonly] = ACTIONS(371),
    [anon_sym_sealed] = ACTIONS(371),
    [anon_sym_static] = ACTIONS(371),
    [anon_sym_unsafe] = ACTIONS(371),
    [anon_sym_virtual] = ACTIONS(371),
    [anon_sym_volatile] = ACTIONS(371),
    [anon_sym_partial] = ACTIONS(371),
    [anon_sym_class] = ACTIONS(371),
    [anon_sym_struct] = ACTIONS(371),
    [anon_sym_event] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_implicit] = ACTIONS(371),
    [anon_sym_explicit] = ACTIONS(371),
    [anon_sym_interface] = ACTIONS(371),
    [anon_sym_enum] = ACTIONS(371),
    [anon_sym_delegate] = ACTIONS(371),
    [sym_void_keyword] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(371),
    [sym_identifier_name] = ACTIONS(371),
    [sym_comment] = ACTIONS(31),
  },
  [239] = {
    [sym__type] = STATE(398),
    [sym_predefined_type] = STATE(398),
    [sym__indexer_declarator] = STATE(399),
    [sym__operator_declarator] = STATE(400),
    [sym__unary_operator_declarator] = STATE(400),
    [sym__binary_operator_declarator] = STATE(400),
    [sym__conversion_operator_declarator] = STATE(400),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_variable_declaration] = STATE(401),
    [sym_generic_name] = STATE(398),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_partial] = ACTIONS(729),
    [anon_sym_class] = ACTIONS(629),
    [anon_sym_struct] = ACTIONS(631),
    [anon_sym_event] = ACTIONS(731),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(633),
    [anon_sym_enum] = ACTIONS(733),
    [anon_sym_delegate] = ACTIONS(735),
    [sym_void_keyword] = ACTIONS(635),
    [anon_sym_const] = ACTIONS(737),
    [sym_identifier_name] = ACTIONS(739),
    [sym_comment] = ACTIONS(31),
  },
  [240] = {
    [anon_sym_bool] = ACTIONS(741),
    [anon_sym_byte] = ACTIONS(741),
    [anon_sym_char] = ACTIONS(741),
    [anon_sym_decimal] = ACTIONS(741),
    [anon_sym_double] = ACTIONS(741),
    [anon_sym_float] = ACTIONS(741),
    [anon_sym_int] = ACTIONS(741),
    [anon_sym_long] = ACTIONS(741),
    [anon_sym_object] = ACTIONS(741),
    [anon_sym_sbyte] = ACTIONS(741),
    [anon_sym_short] = ACTIONS(741),
    [anon_sym_string] = ACTIONS(741),
    [anon_sym_uint] = ACTIONS(741),
    [anon_sym_ulong] = ACTIONS(741),
    [anon_sym_ushort] = ACTIONS(741),
    [anon_sym_abstract] = ACTIONS(741),
    [anon_sym_async] = ACTIONS(741),
    [anon_sym_extern] = ACTIONS(741),
    [anon_sym_internal] = ACTIONS(741),
    [anon_sym_new] = ACTIONS(741),
    [anon_sym_override] = ACTIONS(741),
    [anon_sym_private] = ACTIONS(741),
    [anon_sym_protected] = ACTIONS(741),
    [anon_sym_public] = ACTIONS(741),
    [anon_sym_readonly] = ACTIONS(741),
    [anon_sym_sealed] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(741),
    [anon_sym_unsafe] = ACTIONS(741),
    [anon_sym_virtual] = ACTIONS(741),
    [anon_sym_volatile] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_partial] = ACTIONS(741),
    [anon_sym_class] = ACTIONS(741),
    [anon_sym_struct] = ACTIONS(741),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_event] = ACTIONS(741),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_implicit] = ACTIONS(741),
    [anon_sym_explicit] = ACTIONS(741),
    [anon_sym_interface] = ACTIONS(741),
    [anon_sym_enum] = ACTIONS(741),
    [anon_sym_delegate] = ACTIONS(741),
    [sym_void_keyword] = ACTIONS(741),
    [anon_sym_const] = ACTIONS(741),
    [sym_identifier_name] = ACTIONS(741),
    [sym_comment] = ACTIONS(31),
  },
  [241] = {
    [aux_sym_modifiers_repeat1] = STATE(241),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_byte] = ACTIONS(745),
    [anon_sym_char] = ACTIONS(745),
    [anon_sym_decimal] = ACTIONS(745),
    [anon_sym_double] = ACTIONS(745),
    [anon_sym_float] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_long] = ACTIONS(745),
    [anon_sym_object] = ACTIONS(745),
    [anon_sym_sbyte] = ACTIONS(745),
    [anon_sym_short] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_uint] = ACTIONS(745),
    [anon_sym_ulong] = ACTIONS(745),
    [anon_sym_ushort] = ACTIONS(745),
    [anon_sym_abstract] = ACTIONS(747),
    [anon_sym_async] = ACTIONS(747),
    [anon_sym_extern] = ACTIONS(747),
    [anon_sym_internal] = ACTIONS(747),
    [anon_sym_new] = ACTIONS(747),
    [anon_sym_override] = ACTIONS(747),
    [anon_sym_private] = ACTIONS(747),
    [anon_sym_protected] = ACTIONS(747),
    [anon_sym_public] = ACTIONS(747),
    [anon_sym_readonly] = ACTIONS(747),
    [anon_sym_sealed] = ACTIONS(747),
    [anon_sym_static] = ACTIONS(747),
    [anon_sym_unsafe] = ACTIONS(747),
    [anon_sym_virtual] = ACTIONS(747),
    [anon_sym_volatile] = ACTIONS(747),
    [anon_sym_partial] = ACTIONS(745),
    [anon_sym_class] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_event] = ACTIONS(745),
    [anon_sym_implicit] = ACTIONS(745),
    [anon_sym_explicit] = ACTIONS(745),
    [anon_sym_interface] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_delegate] = ACTIONS(745),
    [sym_void_keyword] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(745),
    [sym_identifier_name] = ACTIONS(745),
    [sym_comment] = ACTIONS(31),
  },
  [242] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(750),
    [anon_sym_char] = ACTIONS(750),
    [anon_sym_decimal] = ACTIONS(750),
    [anon_sym_double] = ACTIONS(750),
    [anon_sym_float] = ACTIONS(750),
    [anon_sym_int] = ACTIONS(750),
    [anon_sym_long] = ACTIONS(750),
    [anon_sym_object] = ACTIONS(750),
    [anon_sym_sbyte] = ACTIONS(750),
    [anon_sym_short] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_uint] = ACTIONS(750),
    [anon_sym_ulong] = ACTIONS(750),
    [anon_sym_ushort] = ACTIONS(750),
    [anon_sym_abstract] = ACTIONS(753),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_extern] = ACTIONS(756),
    [anon_sym_internal] = ACTIONS(753),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_override] = ACTIONS(753),
    [anon_sym_private] = ACTIONS(753),
    [anon_sym_protected] = ACTIONS(753),
    [anon_sym_public] = ACTIONS(753),
    [anon_sym_readonly] = ACTIONS(753),
    [anon_sym_sealed] = ACTIONS(753),
    [anon_sym_static] = ACTIONS(753),
    [anon_sym_unsafe] = ACTIONS(753),
    [anon_sym_virtual] = ACTIONS(753),
    [anon_sym_volatile] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_partial] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(764),
    [anon_sym_struct] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(770),
    [anon_sym_event] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_implicit] = ACTIONS(779),
    [anon_sym_explicit] = ACTIONS(779),
    [anon_sym_interface] = ACTIONS(782),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_delegate] = ACTIONS(788),
    [sym_void_keyword] = ACTIONS(791),
    [anon_sym_const] = ACTIONS(794),
    [sym_identifier_name] = ACTIONS(797),
    [sym_comment] = ACTIONS(31),
  },
  [243] = {
    [sym__attribute_section] = STATE(243),
    [aux_sym__attributes_repeat1] = STATE(243),
    [anon_sym_bool] = ACTIONS(800),
    [anon_sym_byte] = ACTIONS(800),
    [anon_sym_char] = ACTIONS(800),
    [anon_sym_decimal] = ACTIONS(800),
    [anon_sym_double] = ACTIONS(800),
    [anon_sym_float] = ACTIONS(800),
    [anon_sym_int] = ACTIONS(800),
    [anon_sym_long] = ACTIONS(800),
    [anon_sym_object] = ACTIONS(800),
    [anon_sym_sbyte] = ACTIONS(800),
    [anon_sym_short] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_uint] = ACTIONS(800),
    [anon_sym_ulong] = ACTIONS(800),
    [anon_sym_ushort] = ACTIONS(800),
    [anon_sym_abstract] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_extern] = ACTIONS(800),
    [anon_sym_internal] = ACTIONS(800),
    [anon_sym_new] = ACTIONS(800),
    [anon_sym_override] = ACTIONS(800),
    [anon_sym_private] = ACTIONS(800),
    [anon_sym_protected] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(800),
    [anon_sym_readonly] = ACTIONS(800),
    [anon_sym_sealed] = ACTIONS(800),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_unsafe] = ACTIONS(800),
    [anon_sym_virtual] = ACTIONS(800),
    [anon_sym_volatile] = ACTIONS(800),
    [anon_sym_partial] = ACTIONS(800),
    [anon_sym_class] = ACTIONS(800),
    [anon_sym_struct] = ACTIONS(800),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_event] = ACTIONS(800),
    [anon_sym_TILDE] = ACTIONS(218),
    [anon_sym_implicit] = ACTIONS(800),
    [anon_sym_explicit] = ACTIONS(800),
    [anon_sym_interface] = ACTIONS(800),
    [anon_sym_enum] = ACTIONS(800),
    [anon_sym_delegate] = ACTIONS(800),
    [sym_void_keyword] = ACTIONS(800),
    [anon_sym_const] = ACTIONS(800),
    [sym_identifier_name] = ACTIONS(800),
    [sym_comment] = ACTIONS(31),
  },
  [244] = {
    [sym_identifier_name] = ACTIONS(802),
    [sym_comment] = ACTIONS(31),
  },
  [245] = {
    [sym_type_parameter_constraints] = STATE(405),
    [sym_constructor_constraint] = STATE(406),
    [anon_sym_object] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_new] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(804),
    [anon_sym_dynamic] = ACTIONS(804),
    [anon_sym_struct] = ACTIONS(804),
    [sym_identifier_name] = ACTIONS(804),
    [sym_comment] = ACTIONS(31),
  },
  [246] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym_bool] = ACTIONS(571),
    [anon_sym_byte] = ACTIONS(571),
    [anon_sym_char] = ACTIONS(571),
    [anon_sym_decimal] = ACTIONS(571),
    [anon_sym_double] = ACTIONS(571),
    [anon_sym_float] = ACTIONS(571),
    [anon_sym_int] = ACTIONS(571),
    [anon_sym_long] = ACTIONS(571),
    [anon_sym_object] = ACTIONS(571),
    [anon_sym_sbyte] = ACTIONS(571),
    [anon_sym_short] = ACTIONS(571),
    [anon_sym_string] = ACTIONS(571),
    [anon_sym_uint] = ACTIONS(571),
    [anon_sym_ulong] = ACTIONS(571),
    [anon_sym_ushort] = ACTIONS(571),
    [anon_sym_abstract] = ACTIONS(571),
    [anon_sym_async] = ACTIONS(571),
    [anon_sym_extern] = ACTIONS(571),
    [anon_sym_internal] = ACTIONS(571),
    [anon_sym_new] = ACTIONS(571),
    [anon_sym_override] = ACTIONS(571),
    [anon_sym_private] = ACTIONS(571),
    [anon_sym_protected] = ACTIONS(571),
    [anon_sym_public] = ACTIONS(571),
    [anon_sym_readonly] = ACTIONS(571),
    [anon_sym_sealed] = ACTIONS(571),
    [anon_sym_static] = ACTIONS(571),
    [anon_sym_unsafe] = ACTIONS(571),
    [anon_sym_virtual] = ACTIONS(571),
    [anon_sym_volatile] = ACTIONS(571),
    [anon_sym_using] = ACTIONS(571),
    [anon_sym_namespace] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_partial] = ACTIONS(571),
    [anon_sym_class] = ACTIONS(571),
    [anon_sym_struct] = ACTIONS(571),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_event] = ACTIONS(571),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_implicit] = ACTIONS(571),
    [anon_sym_explicit] = ACTIONS(571),
    [anon_sym_interface] = ACTIONS(571),
    [anon_sym_enum] = ACTIONS(571),
    [anon_sym_delegate] = ACTIONS(571),
    [sym_void_keyword] = ACTIONS(571),
    [anon_sym_const] = ACTIONS(571),
    [sym_identifier_name] = ACTIONS(571),
    [sym_comment] = ACTIONS(31),
  },
  [247] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(808),
    [anon_sym_byte] = ACTIONS(808),
    [anon_sym_char] = ACTIONS(808),
    [anon_sym_decimal] = ACTIONS(808),
    [anon_sym_double] = ACTIONS(808),
    [anon_sym_float] = ACTIONS(808),
    [anon_sym_int] = ACTIONS(808),
    [anon_sym_long] = ACTIONS(808),
    [anon_sym_object] = ACTIONS(808),
    [anon_sym_sbyte] = ACTIONS(808),
    [anon_sym_short] = ACTIONS(808),
    [anon_sym_string] = ACTIONS(808),
    [anon_sym_uint] = ACTIONS(808),
    [anon_sym_ulong] = ACTIONS(808),
    [anon_sym_ushort] = ACTIONS(808),
    [anon_sym_abstract] = ACTIONS(811),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_extern] = ACTIONS(811),
    [anon_sym_internal] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(811),
    [anon_sym_override] = ACTIONS(811),
    [anon_sym_private] = ACTIONS(811),
    [anon_sym_protected] = ACTIONS(811),
    [anon_sym_public] = ACTIONS(811),
    [anon_sym_readonly] = ACTIONS(811),
    [anon_sym_sealed] = ACTIONS(811),
    [anon_sym_static] = ACTIONS(811),
    [anon_sym_unsafe] = ACTIONS(811),
    [anon_sym_virtual] = ACTIONS(811),
    [anon_sym_volatile] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_partial] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_struct] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_event] = ACTIONS(828),
    [anon_sym_implicit] = ACTIONS(831),
    [anon_sym_explicit] = ACTIONS(831),
    [anon_sym_interface] = ACTIONS(834),
    [anon_sym_enum] = ACTIONS(837),
    [anon_sym_delegate] = ACTIONS(840),
    [sym_void_keyword] = ACTIONS(843),
    [anon_sym_const] = ACTIONS(846),
    [sym_identifier_name] = ACTIONS(849),
    [sym_comment] = ACTIONS(31),
  },
  [248] = {
    [sym__attribute_section] = STATE(248),
    [aux_sym__attributes_repeat1] = STATE(248),
    [anon_sym_bool] = ACTIONS(800),
    [anon_sym_byte] = ACTIONS(800),
    [anon_sym_char] = ACTIONS(800),
    [anon_sym_decimal] = ACTIONS(800),
    [anon_sym_double] = ACTIONS(800),
    [anon_sym_float] = ACTIONS(800),
    [anon_sym_int] = ACTIONS(800),
    [anon_sym_long] = ACTIONS(800),
    [anon_sym_object] = ACTIONS(800),
    [anon_sym_sbyte] = ACTIONS(800),
    [anon_sym_short] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_uint] = ACTIONS(800),
    [anon_sym_ulong] = ACTIONS(800),
    [anon_sym_ushort] = ACTIONS(800),
    [anon_sym_abstract] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_extern] = ACTIONS(800),
    [anon_sym_internal] = ACTIONS(800),
    [anon_sym_new] = ACTIONS(800),
    [anon_sym_override] = ACTIONS(800),
    [anon_sym_private] = ACTIONS(800),
    [anon_sym_protected] = ACTIONS(800),
    [anon_sym_public] = ACTIONS(800),
    [anon_sym_readonly] = ACTIONS(800),
    [anon_sym_sealed] = ACTIONS(800),
    [anon_sym_static] = ACTIONS(800),
    [anon_sym_unsafe] = ACTIONS(800),
    [anon_sym_virtual] = ACTIONS(800),
    [anon_sym_volatile] = ACTIONS(800),
    [anon_sym_partial] = ACTIONS(800),
    [anon_sym_class] = ACTIONS(800),
    [anon_sym_struct] = ACTIONS(800),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_event] = ACTIONS(800),
    [anon_sym_implicit] = ACTIONS(800),
    [anon_sym_explicit] = ACTIONS(800),
    [anon_sym_interface] = ACTIONS(800),
    [anon_sym_enum] = ACTIONS(800),
    [anon_sym_delegate] = ACTIONS(800),
    [sym_void_keyword] = ACTIONS(800),
    [anon_sym_const] = ACTIONS(800),
    [sym_identifier_name] = ACTIONS(800),
    [sym_comment] = ACTIONS(31),
  },
  [249] = {
    [sym_identifier_name] = ACTIONS(852),
    [sym_comment] = ACTIONS(31),
  },
  [250] = {
    [aux_sym_class_base_repeat1] = STATE(408),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(854),
    [anon_sym_where] = ACTIONS(854),
    [sym_comment] = ACTIONS(31),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(856),
    [anon_sym_abstract] = ACTIONS(856),
    [anon_sym_async] = ACTIONS(856),
    [anon_sym_extern] = ACTIONS(856),
    [anon_sym_internal] = ACTIONS(856),
    [anon_sym_new] = ACTIONS(856),
    [anon_sym_override] = ACTIONS(856),
    [anon_sym_private] = ACTIONS(856),
    [anon_sym_protected] = ACTIONS(856),
    [anon_sym_public] = ACTIONS(856),
    [anon_sym_readonly] = ACTIONS(856),
    [anon_sym_sealed] = ACTIONS(856),
    [anon_sym_static] = ACTIONS(856),
    [anon_sym_unsafe] = ACTIONS(856),
    [anon_sym_virtual] = ACTIONS(856),
    [anon_sym_volatile] = ACTIONS(856),
    [anon_sym_namespace] = ACTIONS(856),
    [anon_sym_partial] = ACTIONS(856),
    [anon_sym_class] = ACTIONS(856),
    [anon_sym_struct] = ACTIONS(856),
    [anon_sym_LBRACK] = ACTIONS(856),
    [anon_sym_interface] = ACTIONS(856),
    [anon_sym_enum] = ACTIONS(856),
    [anon_sym_delegate] = ACTIONS(856),
    [sym_comment] = ACTIONS(31),
  },
  [252] = {
    [sym__type] = STATE(409),
    [sym_predefined_type] = STATE(409),
    [sym_generic_name] = STATE(409),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [253] = {
    [sym_identifier_name] = ACTIONS(858),
    [sym_comment] = ACTIONS(31),
  },
  [254] = {
    [anon_sym_this] = ACTIONS(860),
    [sym_identifier_name] = ACTIONS(862),
    [sym_comment] = ACTIONS(31),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(579),
    [anon_sym_bool] = ACTIONS(581),
    [anon_sym_byte] = ACTIONS(581),
    [anon_sym_char] = ACTIONS(581),
    [anon_sym_decimal] = ACTIONS(581),
    [anon_sym_double] = ACTIONS(581),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_long] = ACTIONS(581),
    [anon_sym_object] = ACTIONS(581),
    [anon_sym_sbyte] = ACTIONS(581),
    [anon_sym_short] = ACTIONS(581),
    [anon_sym_string] = ACTIONS(581),
    [anon_sym_uint] = ACTIONS(581),
    [anon_sym_ulong] = ACTIONS(581),
    [anon_sym_ushort] = ACTIONS(581),
    [anon_sym_abstract] = ACTIONS(581),
    [anon_sym_async] = ACTIONS(581),
    [anon_sym_extern] = ACTIONS(581),
    [anon_sym_internal] = ACTIONS(581),
    [anon_sym_new] = ACTIONS(581),
    [anon_sym_override] = ACTIONS(581),
    [anon_sym_private] = ACTIONS(581),
    [anon_sym_protected] = ACTIONS(581),
    [anon_sym_public] = ACTIONS(581),
    [anon_sym_readonly] = ACTIONS(581),
    [anon_sym_sealed] = ACTIONS(581),
    [anon_sym_static] = ACTIONS(581),
    [anon_sym_unsafe] = ACTIONS(581),
    [anon_sym_virtual] = ACTIONS(581),
    [anon_sym_volatile] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(581),
    [anon_sym_namespace] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_partial] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(581),
    [anon_sym_struct] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(579),
    [anon_sym_event] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(579),
    [anon_sym_implicit] = ACTIONS(581),
    [anon_sym_explicit] = ACTIONS(581),
    [anon_sym_interface] = ACTIONS(581),
    [anon_sym_enum] = ACTIONS(581),
    [anon_sym_delegate] = ACTIONS(581),
    [sym_void_keyword] = ACTIONS(581),
    [anon_sym_const] = ACTIONS(581),
    [sym_identifier_name] = ACTIONS(581),
    [sym_comment] = ACTIONS(31),
  },
  [256] = {
    [sym_identifier_name] = ACTIONS(864),
    [sym_comment] = ACTIONS(31),
  },
  [257] = {
    [sym_type_parameter_list] = STATE(416),
    [sym_type_parameter_constraints_clause] = STATE(418),
    [sym_parameter_list] = STATE(417),
    [aux_sym_class_declaration_repeat1] = STATE(418),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(866),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [258] = {
    [anon_sym_LBRACK] = ACTIONS(870),
    [sym_comment] = ACTIONS(31),
  },
  [259] = {
    [sym_type_parameter_list] = STATE(416),
    [sym_type_parameter_constraints_clause] = STATE(418),
    [sym_parameter_list] = STATE(417),
    [aux_sym_class_declaration_repeat1] = STATE(418),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(866),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [260] = {
    [sym__type] = STATE(423),
    [sym_predefined_type] = STATE(423),
    [sym_generic_name] = STATE(423),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_event] = ACTIONS(874),
    [sym_void_keyword] = ACTIONS(876),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [261] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(878),
    [anon_sym_byte] = ACTIONS(878),
    [anon_sym_char] = ACTIONS(878),
    [anon_sym_decimal] = ACTIONS(878),
    [anon_sym_double] = ACTIONS(878),
    [anon_sym_float] = ACTIONS(878),
    [anon_sym_int] = ACTIONS(878),
    [anon_sym_long] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_sbyte] = ACTIONS(878),
    [anon_sym_short] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_uint] = ACTIONS(878),
    [anon_sym_ulong] = ACTIONS(878),
    [anon_sym_ushort] = ACTIONS(878),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(884),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_event] = ACTIONS(889),
    [sym_void_keyword] = ACTIONS(892),
    [sym_identifier_name] = ACTIONS(895),
    [sym_comment] = ACTIONS(31),
  },
  [262] = {
    [sym__attribute_section] = STATE(262),
    [aux_sym__attributes_repeat1] = STATE(262),
    [anon_sym_bool] = ACTIONS(800),
    [anon_sym_byte] = ACTIONS(800),
    [anon_sym_char] = ACTIONS(800),
    [anon_sym_decimal] = ACTIONS(800),
    [anon_sym_double] = ACTIONS(800),
    [anon_sym_float] = ACTIONS(800),
    [anon_sym_int] = ACTIONS(800),
    [anon_sym_long] = ACTIONS(800),
    [anon_sym_object] = ACTIONS(800),
    [anon_sym_sbyte] = ACTIONS(800),
    [anon_sym_short] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_uint] = ACTIONS(800),
    [anon_sym_ulong] = ACTIONS(800),
    [anon_sym_ushort] = ACTIONS(800),
    [anon_sym_new] = ACTIONS(800),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_event] = ACTIONS(800),
    [sym_void_keyword] = ACTIONS(800),
    [sym_identifier_name] = ACTIONS(800),
    [sym_comment] = ACTIONS(31),
  },
  [263] = {
    [sym_identifier_name] = ACTIONS(898),
    [sym_comment] = ACTIONS(31),
  },
  [264] = {
    [sym__expression] = STATE(426),
    [sym_constant_expression] = STATE(427),
    [sym_parenthesized_expression] = STATE(426),
    [sym_ternary_expression] = STATE(426),
    [sym_binary_expression] = STATE(426),
    [sym_unary_expression] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [sym_character_literal] = STATE(426),
    [sym_integer_literal] = STATE(426),
    [sym_real_literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(904),
    [sym_comment] = ACTIONS(31),
  },
  [265] = {
    [sym_enum_member_declaration] = STATE(428),
    [sym__attributes] = STATE(172),
    [sym__attribute_section] = STATE(173),
    [aux_sym__attributes_repeat1] = STATE(173),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_identifier_name] = ACTIONS(303),
    [sym_comment] = ACTIONS(31),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(906),
    [anon_sym_bool] = ACTIONS(908),
    [anon_sym_byte] = ACTIONS(908),
    [anon_sym_char] = ACTIONS(908),
    [anon_sym_decimal] = ACTIONS(908),
    [anon_sym_double] = ACTIONS(908),
    [anon_sym_float] = ACTIONS(908),
    [anon_sym_int] = ACTIONS(908),
    [anon_sym_long] = ACTIONS(908),
    [anon_sym_object] = ACTIONS(908),
    [anon_sym_sbyte] = ACTIONS(908),
    [anon_sym_short] = ACTIONS(908),
    [anon_sym_string] = ACTIONS(908),
    [anon_sym_uint] = ACTIONS(908),
    [anon_sym_ulong] = ACTIONS(908),
    [anon_sym_ushort] = ACTIONS(908),
    [anon_sym_abstract] = ACTIONS(908),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_extern] = ACTIONS(908),
    [anon_sym_internal] = ACTIONS(908),
    [anon_sym_new] = ACTIONS(908),
    [anon_sym_override] = ACTIONS(908),
    [anon_sym_private] = ACTIONS(908),
    [anon_sym_protected] = ACTIONS(908),
    [anon_sym_public] = ACTIONS(908),
    [anon_sym_readonly] = ACTIONS(908),
    [anon_sym_sealed] = ACTIONS(908),
    [anon_sym_static] = ACTIONS(908),
    [anon_sym_unsafe] = ACTIONS(908),
    [anon_sym_virtual] = ACTIONS(908),
    [anon_sym_volatile] = ACTIONS(908),
    [anon_sym_SEMI] = ACTIONS(910),
    [anon_sym_using] = ACTIONS(908),
    [anon_sym_namespace] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(906),
    [anon_sym_partial] = ACTIONS(908),
    [anon_sym_class] = ACTIONS(908),
    [anon_sym_struct] = ACTIONS(908),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_event] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_implicit] = ACTIONS(908),
    [anon_sym_explicit] = ACTIONS(908),
    [anon_sym_interface] = ACTIONS(908),
    [anon_sym_enum] = ACTIONS(908),
    [anon_sym_delegate] = ACTIONS(908),
    [sym_void_keyword] = ACTIONS(908),
    [anon_sym_const] = ACTIONS(908),
    [sym_identifier_name] = ACTIONS(908),
    [sym_comment] = ACTIONS(31),
  },
  [267] = {
    [aux_sym_enum_declaration_repeat1] = STATE(431),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(912),
    [sym_comment] = ACTIONS(31),
  },
  [268] = {
    [anon_sym_COMMA] = ACTIONS(914),
    [anon_sym_EQ] = ACTIONS(916),
    [anon_sym_RBRACE] = ACTIONS(914),
    [sym_comment] = ACTIONS(31),
  },
  [269] = {
    [sym__attribute_section] = STATE(269),
    [aux_sym__attributes_repeat1] = STATE(269),
    [anon_sym_LBRACK] = ACTIONS(220),
    [sym_identifier_name] = ACTIONS(218),
    [sym_comment] = ACTIONS(31),
  },
  [270] = {
    [sym_enum_member_declaration] = STATE(433),
    [sym__attributes] = STATE(172),
    [sym__attribute_section] = STATE(173),
    [aux_sym__attributes_repeat1] = STATE(173),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_identifier_name] = ACTIONS(303),
    [sym_comment] = ACTIONS(31),
  },
  [271] = {
    [anon_sym_SEMI] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(918),
    [anon_sym_where] = ACTIONS(918),
    [sym_comment] = ACTIONS(31),
  },
  [272] = {
    [anon_sym_bool] = ACTIONS(920),
    [anon_sym_byte] = ACTIONS(920),
    [anon_sym_char] = ACTIONS(920),
    [anon_sym_decimal] = ACTIONS(920),
    [anon_sym_double] = ACTIONS(920),
    [anon_sym_float] = ACTIONS(920),
    [anon_sym_int] = ACTIONS(920),
    [anon_sym_long] = ACTIONS(920),
    [anon_sym_object] = ACTIONS(920),
    [anon_sym_sbyte] = ACTIONS(920),
    [anon_sym_short] = ACTIONS(920),
    [anon_sym_string] = ACTIONS(920),
    [anon_sym_uint] = ACTIONS(920),
    [anon_sym_ulong] = ACTIONS(920),
    [anon_sym_ushort] = ACTIONS(920),
    [sym_identifier_name] = ACTIONS(920),
    [sym_comment] = ACTIONS(31),
  },
  [273] = {
    [sym_attribute_list] = STATE(434),
    [sym_attribute] = STATE(41),
    [sym_identifier_name] = ACTIONS(182),
    [sym_comment] = ACTIONS(31),
  },
  [274] = {
    [sym__type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_array_type] = STATE(436),
    [sym_generic_name] = STATE(435),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [275] = {
    [sym_identifier_name] = ACTIONS(922),
    [sym_comment] = ACTIONS(31),
  },
  [276] = {
    [anon_sym_RPAREN] = ACTIONS(924),
    [sym_comment] = ACTIONS(31),
  },
  [277] = {
    [sym_parameter_array] = STATE(441),
    [sym__attributes] = STATE(442),
    [sym__attribute_section] = STATE(444),
    [aux_sym__formal_parameter_list_repeat1] = STATE(443),
    [aux_sym__attributes_repeat1] = STATE(444),
    [anon_sym_COMMA] = ACTIONS(926),
    [anon_sym_RPAREN] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_params] = ACTIONS(932),
    [sym_comment] = ACTIONS(31),
  },
  [278] = {
    [sym__type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_generic_name] = STATE(445),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [279] = {
    [sym__type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_parameter_modifier] = STATE(447),
    [sym_generic_name] = STATE(445),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(934),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [280] = {
    [sym__attribute_section] = STATE(448),
    [aux_sym__attributes_repeat1] = STATE(448),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_byte] = ACTIONS(433),
    [anon_sym_char] = ACTIONS(433),
    [anon_sym_decimal] = ACTIONS(433),
    [anon_sym_double] = ACTIONS(433),
    [anon_sym_float] = ACTIONS(433),
    [anon_sym_int] = ACTIONS(433),
    [anon_sym_long] = ACTIONS(433),
    [anon_sym_object] = ACTIONS(433),
    [anon_sym_sbyte] = ACTIONS(433),
    [anon_sym_short] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_uint] = ACTIONS(433),
    [anon_sym_ulong] = ACTIONS(433),
    [anon_sym_ushort] = ACTIONS(433),
    [anon_sym_this] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_ref] = ACTIONS(433),
    [anon_sym_out] = ACTIONS(433),
    [anon_sym_params] = ACTIONS(433),
    [sym_identifier_name] = ACTIONS(433),
    [sym_comment] = ACTIONS(31),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(936),
    [anon_sym_bool] = ACTIONS(938),
    [anon_sym_byte] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_decimal] = ACTIONS(938),
    [anon_sym_double] = ACTIONS(938),
    [anon_sym_float] = ACTIONS(938),
    [anon_sym_int] = ACTIONS(938),
    [anon_sym_long] = ACTIONS(938),
    [anon_sym_object] = ACTIONS(938),
    [anon_sym_sbyte] = ACTIONS(938),
    [anon_sym_short] = ACTIONS(938),
    [anon_sym_string] = ACTIONS(938),
    [anon_sym_uint] = ACTIONS(938),
    [anon_sym_ulong] = ACTIONS(938),
    [anon_sym_ushort] = ACTIONS(938),
    [anon_sym_abstract] = ACTIONS(938),
    [anon_sym_async] = ACTIONS(938),
    [anon_sym_extern] = ACTIONS(938),
    [anon_sym_internal] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(938),
    [anon_sym_override] = ACTIONS(938),
    [anon_sym_private] = ACTIONS(938),
    [anon_sym_protected] = ACTIONS(938),
    [anon_sym_public] = ACTIONS(938),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_sealed] = ACTIONS(938),
    [anon_sym_static] = ACTIONS(938),
    [anon_sym_unsafe] = ACTIONS(938),
    [anon_sym_virtual] = ACTIONS(938),
    [anon_sym_volatile] = ACTIONS(938),
    [anon_sym_using] = ACTIONS(938),
    [anon_sym_namespace] = ACTIONS(938),
    [anon_sym_RBRACE] = ACTIONS(936),
    [anon_sym_partial] = ACTIONS(938),
    [anon_sym_class] = ACTIONS(938),
    [anon_sym_struct] = ACTIONS(938),
    [anon_sym_LBRACK] = ACTIONS(936),
    [anon_sym_event] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_implicit] = ACTIONS(938),
    [anon_sym_explicit] = ACTIONS(938),
    [anon_sym_interface] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_delegate] = ACTIONS(938),
    [sym_void_keyword] = ACTIONS(938),
    [anon_sym_const] = ACTIONS(938),
    [sym_identifier_name] = ACTIONS(938),
    [sym_comment] = ACTIONS(31),
  },
  [282] = {
    [sym_class_base] = STATE(449),
    [sym_type_parameter_constraints_clause] = STATE(298),
    [aux_sym_class_declaration_repeat1] = STATE(298),
    [anon_sym_LBRACE] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [283] = {
    [sym_type_parameter_constraints_clause] = STATE(303),
    [sym_struct_interfaces] = STATE(450),
    [aux_sym_class_declaration_repeat1] = STATE(303),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [284] = {
    [sym_type_parameter_constraints_clause] = STATE(308),
    [sym_interface_base] = STATE(451),
    [aux_sym_class_declaration_repeat1] = STATE(308),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [285] = {
    [aux_sym_enum_declaration_repeat1] = STATE(452),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(912),
    [sym_comment] = ACTIONS(31),
  },
  [286] = {
    [anon_sym_LBRACE] = ACTIONS(940),
    [sym_comment] = ACTIONS(31),
  },
  [287] = {
    [anon_sym_SEMI] = ACTIONS(942),
    [sym_comment] = ACTIONS(31),
  },
  [288] = {
    [sym_type_parameter_list] = STATE(455),
    [sym_class_base] = STATE(449),
    [sym_type_parameter_constraints_clause] = STATE(298),
    [aux_sym_class_declaration_repeat1] = STATE(298),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [289] = {
    [sym_type_parameter_list] = STATE(456),
    [sym_type_parameter_constraints_clause] = STATE(303),
    [sym_struct_interfaces] = STATE(450),
    [aux_sym_class_declaration_repeat1] = STATE(303),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [290] = {
    [sym_type_parameter_list] = STATE(457),
    [sym_type_parameter_constraints_clause] = STATE(308),
    [sym_interface_base] = STATE(451),
    [aux_sym_class_declaration_repeat1] = STATE(308),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [291] = {
    [sym__integral_type] = STATE(458),
    [anon_sym_byte] = ACTIONS(944),
    [anon_sym_char] = ACTIONS(944),
    [anon_sym_int] = ACTIONS(944),
    [anon_sym_long] = ACTIONS(944),
    [anon_sym_sbyte] = ACTIONS(944),
    [anon_sym_short] = ACTIONS(944),
    [anon_sym_uint] = ACTIONS(944),
    [anon_sym_ulong] = ACTIONS(944),
    [anon_sym_ushort] = ACTIONS(944),
    [sym_comment] = ACTIONS(31),
  },
  [292] = {
    [sym_parameter_list] = STATE(459),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(946),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_async] = ACTIONS(946),
    [anon_sym_extern] = ACTIONS(946),
    [anon_sym_internal] = ACTIONS(946),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_override] = ACTIONS(946),
    [anon_sym_private] = ACTIONS(946),
    [anon_sym_protected] = ACTIONS(946),
    [anon_sym_public] = ACTIONS(946),
    [anon_sym_readonly] = ACTIONS(946),
    [anon_sym_sealed] = ACTIONS(946),
    [anon_sym_static] = ACTIONS(946),
    [anon_sym_unsafe] = ACTIONS(946),
    [anon_sym_virtual] = ACTIONS(946),
    [anon_sym_volatile] = ACTIONS(946),
    [anon_sym_using] = ACTIONS(946),
    [anon_sym_namespace] = ACTIONS(946),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_partial] = ACTIONS(946),
    [anon_sym_class] = ACTIONS(946),
    [anon_sym_struct] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(946),
    [anon_sym_interface] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_delegate] = ACTIONS(946),
    [sym_comment] = ACTIONS(31),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(948),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_byte] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_decimal] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_object] = ACTIONS(950),
    [anon_sym_sbyte] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(950),
    [anon_sym_ulong] = ACTIONS(950),
    [anon_sym_ushort] = ACTIONS(950),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym_internal] = ACTIONS(950),
    [anon_sym_new] = ACTIONS(950),
    [anon_sym_override] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_readonly] = ACTIONS(950),
    [anon_sym_sealed] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_unsafe] = ACTIONS(950),
    [anon_sym_virtual] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_using] = ACTIONS(950),
    [anon_sym_namespace] = ACTIONS(950),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_partial] = ACTIONS(950),
    [anon_sym_class] = ACTIONS(950),
    [anon_sym_struct] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_event] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_implicit] = ACTIONS(950),
    [anon_sym_explicit] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_delegate] = ACTIONS(950),
    [sym_void_keyword] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [sym_identifier_name] = ACTIONS(950),
    [sym_comment] = ACTIONS(31),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(948),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_byte] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_decimal] = ACTIONS(950),
    [anon_sym_double] = ACTIONS(950),
    [anon_sym_float] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(950),
    [anon_sym_long] = ACTIONS(950),
    [anon_sym_object] = ACTIONS(950),
    [anon_sym_sbyte] = ACTIONS(950),
    [anon_sym_short] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(950),
    [anon_sym_ulong] = ACTIONS(950),
    [anon_sym_ushort] = ACTIONS(950),
    [anon_sym_abstract] = ACTIONS(950),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym_internal] = ACTIONS(950),
    [anon_sym_new] = ACTIONS(950),
    [anon_sym_override] = ACTIONS(950),
    [anon_sym_private] = ACTIONS(950),
    [anon_sym_protected] = ACTIONS(950),
    [anon_sym_public] = ACTIONS(950),
    [anon_sym_readonly] = ACTIONS(950),
    [anon_sym_sealed] = ACTIONS(950),
    [anon_sym_static] = ACTIONS(950),
    [anon_sym_unsafe] = ACTIONS(950),
    [anon_sym_virtual] = ACTIONS(950),
    [anon_sym_volatile] = ACTIONS(950),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_using] = ACTIONS(950),
    [anon_sym_namespace] = ACTIONS(950),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_partial] = ACTIONS(950),
    [anon_sym_class] = ACTIONS(950),
    [anon_sym_struct] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_event] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_implicit] = ACTIONS(950),
    [anon_sym_explicit] = ACTIONS(950),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_delegate] = ACTIONS(950),
    [sym_void_keyword] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [sym_identifier_name] = ACTIONS(950),
    [sym_comment] = ACTIONS(31),
  },
  [296] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [297] = {
    [sym__type_declaration] = STATE(462),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(462),
    [sym_class_declaration] = STATE(462),
    [sym_indexer_declaration] = STATE(462),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(462),
    [sym_operator_declaration] = STATE(462),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(462),
    [sym_struct_declaration] = STATE(462),
    [sym_enum_declaration] = STATE(462),
    [sym_delegate_declaration] = STATE(462),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(462),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(462),
    [sym_constructor_declaration] = STATE(462),
    [sym_destructor_declaration] = STATE(462),
    [sym_method_declaration] = STATE(462),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(462),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [298] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(960),
    [anon_sym_byte] = ACTIONS(960),
    [anon_sym_char] = ACTIONS(960),
    [anon_sym_decimal] = ACTIONS(960),
    [anon_sym_double] = ACTIONS(960),
    [anon_sym_float] = ACTIONS(960),
    [anon_sym_int] = ACTIONS(960),
    [anon_sym_long] = ACTIONS(960),
    [anon_sym_object] = ACTIONS(960),
    [anon_sym_sbyte] = ACTIONS(960),
    [anon_sym_short] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_uint] = ACTIONS(960),
    [anon_sym_ulong] = ACTIONS(960),
    [anon_sym_ushort] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_extern] = ACTIONS(960),
    [anon_sym_internal] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_override] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_readonly] = ACTIONS(960),
    [anon_sym_sealed] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_unsafe] = ACTIONS(960),
    [anon_sym_virtual] = ACTIONS(960),
    [anon_sym_volatile] = ACTIONS(960),
    [anon_sym_using] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_partial] = ACTIONS(960),
    [anon_sym_class] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(958),
    [anon_sym_event] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_implicit] = ACTIONS(960),
    [anon_sym_explicit] = ACTIONS(960),
    [anon_sym_interface] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_delegate] = ACTIONS(960),
    [sym_void_keyword] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [sym_identifier_name] = ACTIONS(960),
    [sym_comment] = ACTIONS(31),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(960),
    [anon_sym_byte] = ACTIONS(960),
    [anon_sym_char] = ACTIONS(960),
    [anon_sym_decimal] = ACTIONS(960),
    [anon_sym_double] = ACTIONS(960),
    [anon_sym_float] = ACTIONS(960),
    [anon_sym_int] = ACTIONS(960),
    [anon_sym_long] = ACTIONS(960),
    [anon_sym_object] = ACTIONS(960),
    [anon_sym_sbyte] = ACTIONS(960),
    [anon_sym_short] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_uint] = ACTIONS(960),
    [anon_sym_ulong] = ACTIONS(960),
    [anon_sym_ushort] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_extern] = ACTIONS(960),
    [anon_sym_internal] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(960),
    [anon_sym_override] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_readonly] = ACTIONS(960),
    [anon_sym_sealed] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_unsafe] = ACTIONS(960),
    [anon_sym_virtual] = ACTIONS(960),
    [anon_sym_volatile] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(962),
    [anon_sym_using] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_partial] = ACTIONS(960),
    [anon_sym_class] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(958),
    [anon_sym_event] = ACTIONS(960),
    [anon_sym_TILDE] = ACTIONS(958),
    [anon_sym_implicit] = ACTIONS(960),
    [anon_sym_explicit] = ACTIONS(960),
    [anon_sym_interface] = ACTIONS(960),
    [anon_sym_enum] = ACTIONS(960),
    [anon_sym_delegate] = ACTIONS(960),
    [sym_void_keyword] = ACTIONS(960),
    [anon_sym_const] = ACTIONS(960),
    [sym_identifier_name] = ACTIONS(960),
    [sym_comment] = ACTIONS(31),
  },
  [301] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [302] = {
    [sym__type_declaration] = STATE(466),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(466),
    [sym_class_declaration] = STATE(466),
    [sym_indexer_declaration] = STATE(466),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(466),
    [sym_operator_declaration] = STATE(466),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(466),
    [sym_struct_declaration] = STATE(466),
    [sym_enum_declaration] = STATE(466),
    [sym_delegate_declaration] = STATE(466),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(466),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(466),
    [sym_constructor_declaration] = STATE(466),
    [sym_method_declaration] = STATE(466),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(466),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [303] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [anon_sym_bool] = ACTIONS(970),
    [anon_sym_byte] = ACTIONS(970),
    [anon_sym_char] = ACTIONS(970),
    [anon_sym_decimal] = ACTIONS(970),
    [anon_sym_double] = ACTIONS(970),
    [anon_sym_float] = ACTIONS(970),
    [anon_sym_int] = ACTIONS(970),
    [anon_sym_long] = ACTIONS(970),
    [anon_sym_object] = ACTIONS(970),
    [anon_sym_sbyte] = ACTIONS(970),
    [anon_sym_short] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_uint] = ACTIONS(970),
    [anon_sym_ulong] = ACTIONS(970),
    [anon_sym_ushort] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_extern] = ACTIONS(970),
    [anon_sym_internal] = ACTIONS(970),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_override] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_readonly] = ACTIONS(970),
    [anon_sym_sealed] = ACTIONS(970),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_unsafe] = ACTIONS(970),
    [anon_sym_virtual] = ACTIONS(970),
    [anon_sym_volatile] = ACTIONS(970),
    [anon_sym_using] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_partial] = ACTIONS(970),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_struct] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_event] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_implicit] = ACTIONS(970),
    [anon_sym_explicit] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_delegate] = ACTIONS(970),
    [sym_void_keyword] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [sym_identifier_name] = ACTIONS(970),
    [sym_comment] = ACTIONS(31),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [anon_sym_bool] = ACTIONS(970),
    [anon_sym_byte] = ACTIONS(970),
    [anon_sym_char] = ACTIONS(970),
    [anon_sym_decimal] = ACTIONS(970),
    [anon_sym_double] = ACTIONS(970),
    [anon_sym_float] = ACTIONS(970),
    [anon_sym_int] = ACTIONS(970),
    [anon_sym_long] = ACTIONS(970),
    [anon_sym_object] = ACTIONS(970),
    [anon_sym_sbyte] = ACTIONS(970),
    [anon_sym_short] = ACTIONS(970),
    [anon_sym_string] = ACTIONS(970),
    [anon_sym_uint] = ACTIONS(970),
    [anon_sym_ulong] = ACTIONS(970),
    [anon_sym_ushort] = ACTIONS(970),
    [anon_sym_abstract] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_extern] = ACTIONS(970),
    [anon_sym_internal] = ACTIONS(970),
    [anon_sym_new] = ACTIONS(970),
    [anon_sym_override] = ACTIONS(970),
    [anon_sym_private] = ACTIONS(970),
    [anon_sym_protected] = ACTIONS(970),
    [anon_sym_public] = ACTIONS(970),
    [anon_sym_readonly] = ACTIONS(970),
    [anon_sym_sealed] = ACTIONS(970),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_unsafe] = ACTIONS(970),
    [anon_sym_virtual] = ACTIONS(970),
    [anon_sym_volatile] = ACTIONS(970),
    [anon_sym_SEMI] = ACTIONS(972),
    [anon_sym_using] = ACTIONS(970),
    [anon_sym_namespace] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_partial] = ACTIONS(970),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_struct] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_event] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_implicit] = ACTIONS(970),
    [anon_sym_explicit] = ACTIONS(970),
    [anon_sym_interface] = ACTIONS(970),
    [anon_sym_enum] = ACTIONS(970),
    [anon_sym_delegate] = ACTIONS(970),
    [sym_void_keyword] = ACTIONS(970),
    [anon_sym_const] = ACTIONS(970),
    [sym_identifier_name] = ACTIONS(970),
    [sym_comment] = ACTIONS(31),
  },
  [306] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [307] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(470),
    [sym_interface_event_declaration] = STATE(470),
    [sym_interface_property_declaration] = STATE(470),
    [sym_interface_indexer_declaration] = STATE(470),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(470),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [308] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [309] = {
    [anon_sym_COMMA] = ACTIONS(978),
    [anon_sym_GT] = ACTIONS(978),
    [sym_comment] = ACTIONS(31),
  },
  [310] = {
    [anon_sym_COMMA] = ACTIONS(980),
    [anon_sym_GT] = ACTIONS(980),
    [anon_sym_SEMI] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(980),
    [anon_sym_COLON] = ACTIONS(980),
    [anon_sym_where] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(980),
    [anon_sym_RPAREN] = ACTIONS(980),
    [anon_sym_this] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(980),
    [anon_sym_operator] = ACTIONS(982),
    [sym_identifier_name] = ACTIONS(982),
    [sym_comment] = ACTIONS(31),
  },
  [311] = {
    [aux_sym_type_parameter_list_repeat1] = STATE(311),
    [anon_sym_COMMA] = ACTIONS(984),
    [anon_sym_GT] = ACTIONS(978),
    [sym_comment] = ACTIONS(31),
  },
  [312] = {
    [sym_parameter_list] = STATE(472),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [313] = {
    [sym_type_parameter_list] = STATE(473),
    [sym_parameter_list] = STATE(474),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [314] = {
    [anon_sym_LBRACE] = ACTIONS(987),
    [sym_comment] = ACTIONS(31),
  },
  [315] = {
    [sym_statement_block] = STATE(476),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [316] = {
    [sym_parameter_list] = STATE(474),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [317] = {
    [sym_type_parameter_constraints_clause] = STATE(478),
    [sym_statement_block] = STATE(477),
    [aux_sym_class_declaration_repeat1] = STATE(478),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [318] = {
    [anon_sym_EQ] = ACTIONS(989),
    [sym_comment] = ACTIONS(31),
  },
  [319] = {
    [anon_sym_SEMI] = ACTIONS(991),
    [sym_comment] = ACTIONS(31),
  },
  [320] = {
    [aux_sym__constant_declarators_repeat1] = STATE(482),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(995),
    [sym_comment] = ACTIONS(31),
  },
  [321] = {
    [sym_statement_block] = STATE(483),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [322] = {
    [anon_sym_bool] = ACTIONS(997),
    [anon_sym_byte] = ACTIONS(997),
    [anon_sym_char] = ACTIONS(997),
    [anon_sym_decimal] = ACTIONS(997),
    [anon_sym_double] = ACTIONS(997),
    [anon_sym_float] = ACTIONS(997),
    [anon_sym_int] = ACTIONS(997),
    [anon_sym_long] = ACTIONS(997),
    [anon_sym_object] = ACTIONS(997),
    [anon_sym_sbyte] = ACTIONS(997),
    [anon_sym_short] = ACTIONS(997),
    [anon_sym_string] = ACTIONS(997),
    [anon_sym_uint] = ACTIONS(997),
    [anon_sym_ulong] = ACTIONS(997),
    [anon_sym_ushort] = ACTIONS(997),
    [anon_sym_abstract] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_extern] = ACTIONS(997),
    [anon_sym_internal] = ACTIONS(997),
    [anon_sym_new] = ACTIONS(997),
    [anon_sym_override] = ACTIONS(997),
    [anon_sym_private] = ACTIONS(997),
    [anon_sym_protected] = ACTIONS(997),
    [anon_sym_public] = ACTIONS(997),
    [anon_sym_readonly] = ACTIONS(997),
    [anon_sym_sealed] = ACTIONS(997),
    [anon_sym_static] = ACTIONS(997),
    [anon_sym_unsafe] = ACTIONS(997),
    [anon_sym_virtual] = ACTIONS(997),
    [anon_sym_volatile] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_partial] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_struct] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_event] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_implicit] = ACTIONS(997),
    [anon_sym_explicit] = ACTIONS(997),
    [anon_sym_interface] = ACTIONS(997),
    [anon_sym_enum] = ACTIONS(997),
    [anon_sym_delegate] = ACTIONS(997),
    [sym_void_keyword] = ACTIONS(997),
    [anon_sym_const] = ACTIONS(997),
    [sym_identifier_name] = ACTIONS(997),
    [sym_comment] = ACTIONS(31),
  },
  [323] = {
    [sym__type] = STATE(484),
    [sym_predefined_type] = STATE(484),
    [sym__formal_parameter_list] = STATE(485),
    [sym_parameter] = STATE(486),
    [sym_parameter_modifier] = STATE(487),
    [sym_parameter_array] = STATE(485),
    [sym__attributes] = STATE(488),
    [sym__attribute_section] = STATE(280),
    [sym_generic_name] = STATE(484),
    [aux_sym__attributes_repeat1] = STATE(280),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(505),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [324] = {
    [anon_sym_LPAREN] = ACTIONS(1001),
    [sym_comment] = ACTIONS(31),
  },
  [325] = {
    [anon_sym_LPAREN] = ACTIONS(1003),
    [sym_comment] = ACTIONS(31),
  },
  [326] = {
    [anon_sym_LPAREN] = ACTIONS(1006),
    [sym_comment] = ACTIONS(31),
  },
  [327] = {
    [anon_sym_LPAREN] = ACTIONS(1008),
    [sym_comment] = ACTIONS(31),
  },
  [328] = {
    [anon_sym_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(31),
  },
  [329] = {
    [sym__expression] = STATE(492),
    [sym_parenthesized_expression] = STATE(492),
    [sym_ternary_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_unary_expression] = STATE(492),
    [sym__literal] = STATE(492),
    [sym_boolean_literal] = STATE(492),
    [sym_character_literal] = STATE(492),
    [sym_integer_literal] = STATE(492),
    [sym_real_literal] = STATE(492),
    [sym_string_literal] = STATE(492),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1016),
    [sym_comment] = ACTIONS(31),
  },
  [330] = {
    [sym__accessor_declarations] = STATE(493),
    [sym_get_accessor_declaration] = STATE(352),
    [sym_set_accessor_declaration] = STATE(353),
    [sym_accessor_modifier] = STATE(354),
    [sym__attributes] = STATE(355),
    [sym__attribute_section] = STATE(356),
    [aux_sym__attributes_repeat1] = STATE(356),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(649),
    [anon_sym_get] = ACTIONS(651),
    [anon_sym_set] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [331] = {
    [sym__expression] = STATE(494),
    [sym_parenthesized_expression] = STATE(494),
    [sym_ternary_expression] = STATE(494),
    [sym_binary_expression] = STATE(494),
    [sym_unary_expression] = STATE(494),
    [sym__literal] = STATE(494),
    [sym_boolean_literal] = STATE(494),
    [sym_character_literal] = STATE(494),
    [sym_integer_literal] = STATE(494),
    [sym_real_literal] = STATE(494),
    [sym_string_literal] = STATE(494),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1018),
    [sym_comment] = ACTIONS(31),
  },
  [332] = {
    [anon_sym_this] = ACTIONS(1020),
    [sym_comment] = ACTIONS(31),
  },
  [333] = {
    [anon_sym_bool] = ACTIONS(1022),
    [anon_sym_byte] = ACTIONS(1022),
    [anon_sym_char] = ACTIONS(1022),
    [anon_sym_decimal] = ACTIONS(1022),
    [anon_sym_double] = ACTIONS(1022),
    [anon_sym_float] = ACTIONS(1022),
    [anon_sym_int] = ACTIONS(1022),
    [anon_sym_long] = ACTIONS(1022),
    [anon_sym_object] = ACTIONS(1022),
    [anon_sym_sbyte] = ACTIONS(1022),
    [anon_sym_short] = ACTIONS(1022),
    [anon_sym_string] = ACTIONS(1022),
    [anon_sym_uint] = ACTIONS(1022),
    [anon_sym_ulong] = ACTIONS(1022),
    [anon_sym_ushort] = ACTIONS(1022),
    [anon_sym_abstract] = ACTIONS(1022),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_extern] = ACTIONS(1022),
    [anon_sym_internal] = ACTIONS(1022),
    [anon_sym_new] = ACTIONS(1022),
    [anon_sym_override] = ACTIONS(1022),
    [anon_sym_private] = ACTIONS(1022),
    [anon_sym_protected] = ACTIONS(1022),
    [anon_sym_public] = ACTIONS(1022),
    [anon_sym_readonly] = ACTIONS(1022),
    [anon_sym_sealed] = ACTIONS(1022),
    [anon_sym_static] = ACTIONS(1022),
    [anon_sym_unsafe] = ACTIONS(1022),
    [anon_sym_virtual] = ACTIONS(1022),
    [anon_sym_volatile] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1024),
    [anon_sym_partial] = ACTIONS(1022),
    [anon_sym_class] = ACTIONS(1022),
    [anon_sym_struct] = ACTIONS(1022),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_event] = ACTIONS(1022),
    [anon_sym_TILDE] = ACTIONS(1024),
    [anon_sym_implicit] = ACTIONS(1022),
    [anon_sym_explicit] = ACTIONS(1022),
    [anon_sym_interface] = ACTIONS(1022),
    [anon_sym_enum] = ACTIONS(1022),
    [anon_sym_delegate] = ACTIONS(1022),
    [sym_void_keyword] = ACTIONS(1022),
    [anon_sym_const] = ACTIONS(1022),
    [sym_identifier_name] = ACTIONS(1022),
    [sym_comment] = ACTIONS(31),
  },
  [334] = {
    [anon_sym_COMMA] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [sym_comment] = ACTIONS(31),
  },
  [335] = {
    [sym_variable_declarator] = STATE(497),
    [sym_identifier_name] = ACTIONS(1028),
    [sym_comment] = ACTIONS(31),
  },
  [336] = {
    [aux_sym_variable_declaration_repeat1] = STATE(498),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(1030),
    [sym_comment] = ACTIONS(31),
  },
  [337] = {
    [sym_identifier_name] = ACTIONS(1032),
    [sym_comment] = ACTIONS(31),
  },
  [338] = {
    [sym_identifier_name] = ACTIONS(1034),
    [sym_comment] = ACTIONS(31),
  },
  [339] = {
    [sym__constant_declarators] = STATE(501),
    [sym_constant_declarator] = STATE(320),
    [sym_identifier_name] = ACTIONS(601),
    [sym_comment] = ACTIONS(31),
  },
  [340] = {
    [sym_parameter_list] = STATE(502),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_this] = ACTIONS(311),
    [anon_sym_operator] = ACTIONS(311),
    [sym_identifier_name] = ACTIONS(311),
    [sym_comment] = ACTIONS(31),
  },
  [341] = {
    [sym_type_parameter_list] = STATE(473),
    [sym__property_body] = STATE(503),
    [sym_parameter_list] = STATE(474),
    [sym_equals_value_clause] = STATE(334),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_EQ_GT] = ACTIONS(621),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_DOT] = ACTIONS(623),
    [sym_comment] = ACTIONS(31),
  },
  [342] = {
    [anon_sym_bool] = ACTIONS(1036),
    [anon_sym_byte] = ACTIONS(1036),
    [anon_sym_char] = ACTIONS(1036),
    [anon_sym_decimal] = ACTIONS(1036),
    [anon_sym_double] = ACTIONS(1036),
    [anon_sym_float] = ACTIONS(1036),
    [anon_sym_int] = ACTIONS(1036),
    [anon_sym_long] = ACTIONS(1036),
    [anon_sym_object] = ACTIONS(1036),
    [anon_sym_sbyte] = ACTIONS(1036),
    [anon_sym_short] = ACTIONS(1036),
    [anon_sym_string] = ACTIONS(1036),
    [anon_sym_uint] = ACTIONS(1036),
    [anon_sym_ulong] = ACTIONS(1036),
    [anon_sym_ushort] = ACTIONS(1036),
    [anon_sym_abstract] = ACTIONS(1036),
    [anon_sym_async] = ACTIONS(1036),
    [anon_sym_extern] = ACTIONS(1036),
    [anon_sym_internal] = ACTIONS(1036),
    [anon_sym_new] = ACTIONS(1036),
    [anon_sym_override] = ACTIONS(1036),
    [anon_sym_private] = ACTIONS(1036),
    [anon_sym_protected] = ACTIONS(1036),
    [anon_sym_public] = ACTIONS(1036),
    [anon_sym_readonly] = ACTIONS(1036),
    [anon_sym_sealed] = ACTIONS(1036),
    [anon_sym_static] = ACTIONS(1036),
    [anon_sym_unsafe] = ACTIONS(1036),
    [anon_sym_virtual] = ACTIONS(1036),
    [anon_sym_volatile] = ACTIONS(1036),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [anon_sym_partial] = ACTIONS(1036),
    [anon_sym_class] = ACTIONS(1036),
    [anon_sym_struct] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(1038),
    [anon_sym_event] = ACTIONS(1036),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_implicit] = ACTIONS(1036),
    [anon_sym_explicit] = ACTIONS(1036),
    [anon_sym_interface] = ACTIONS(1036),
    [anon_sym_enum] = ACTIONS(1036),
    [anon_sym_delegate] = ACTIONS(1036),
    [sym_void_keyword] = ACTIONS(1036),
    [anon_sym_const] = ACTIONS(1036),
    [sym_identifier_name] = ACTIONS(1036),
    [sym_comment] = ACTIONS(31),
  },
  [343] = {
    [anon_sym_bool] = ACTIONS(1040),
    [anon_sym_byte] = ACTIONS(1040),
    [anon_sym_char] = ACTIONS(1040),
    [anon_sym_decimal] = ACTIONS(1040),
    [anon_sym_double] = ACTIONS(1040),
    [anon_sym_float] = ACTIONS(1040),
    [anon_sym_int] = ACTIONS(1040),
    [anon_sym_long] = ACTIONS(1040),
    [anon_sym_object] = ACTIONS(1040),
    [anon_sym_sbyte] = ACTIONS(1040),
    [anon_sym_short] = ACTIONS(1040),
    [anon_sym_string] = ACTIONS(1040),
    [anon_sym_uint] = ACTIONS(1040),
    [anon_sym_ulong] = ACTIONS(1040),
    [anon_sym_ushort] = ACTIONS(1040),
    [anon_sym_abstract] = ACTIONS(1040),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_extern] = ACTIONS(1040),
    [anon_sym_internal] = ACTIONS(1040),
    [anon_sym_new] = ACTIONS(1040),
    [anon_sym_override] = ACTIONS(1040),
    [anon_sym_private] = ACTIONS(1040),
    [anon_sym_protected] = ACTIONS(1040),
    [anon_sym_public] = ACTIONS(1040),
    [anon_sym_readonly] = ACTIONS(1040),
    [anon_sym_sealed] = ACTIONS(1040),
    [anon_sym_static] = ACTIONS(1040),
    [anon_sym_unsafe] = ACTIONS(1040),
    [anon_sym_virtual] = ACTIONS(1040),
    [anon_sym_volatile] = ACTIONS(1040),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_partial] = ACTIONS(1040),
    [anon_sym_class] = ACTIONS(1040),
    [anon_sym_struct] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1042),
    [anon_sym_event] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_implicit] = ACTIONS(1040),
    [anon_sym_explicit] = ACTIONS(1040),
    [anon_sym_interface] = ACTIONS(1040),
    [anon_sym_enum] = ACTIONS(1040),
    [anon_sym_delegate] = ACTIONS(1040),
    [sym_void_keyword] = ACTIONS(1040),
    [anon_sym_const] = ACTIONS(1040),
    [sym_identifier_name] = ACTIONS(1040),
    [sym_comment] = ACTIONS(31),
  },
  [344] = {
    [sym__expression] = STATE(504),
    [sym_parenthesized_expression] = STATE(504),
    [sym_ternary_expression] = STATE(504),
    [sym_binary_expression] = STATE(504),
    [sym_unary_expression] = STATE(504),
    [sym__literal] = STATE(504),
    [sym_boolean_literal] = STATE(504),
    [sym_character_literal] = STATE(504),
    [sym_integer_literal] = STATE(504),
    [sym_real_literal] = STATE(504),
    [sym_string_literal] = STATE(504),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1044),
    [sym_comment] = ACTIONS(31),
  },
  [345] = {
    [anon_sym_bool] = ACTIONS(1046),
    [anon_sym_byte] = ACTIONS(1046),
    [anon_sym_char] = ACTIONS(1046),
    [anon_sym_decimal] = ACTIONS(1046),
    [anon_sym_double] = ACTIONS(1046),
    [anon_sym_float] = ACTIONS(1046),
    [anon_sym_int] = ACTIONS(1046),
    [anon_sym_long] = ACTIONS(1046),
    [anon_sym_object] = ACTIONS(1046),
    [anon_sym_sbyte] = ACTIONS(1046),
    [anon_sym_short] = ACTIONS(1046),
    [anon_sym_string] = ACTIONS(1046),
    [anon_sym_uint] = ACTIONS(1046),
    [anon_sym_ulong] = ACTIONS(1046),
    [anon_sym_ushort] = ACTIONS(1046),
    [anon_sym_abstract] = ACTIONS(1046),
    [anon_sym_async] = ACTIONS(1046),
    [anon_sym_extern] = ACTIONS(1046),
    [anon_sym_internal] = ACTIONS(1046),
    [anon_sym_new] = ACTIONS(1046),
    [anon_sym_override] = ACTIONS(1046),
    [anon_sym_private] = ACTIONS(1046),
    [anon_sym_protected] = ACTIONS(1046),
    [anon_sym_public] = ACTIONS(1046),
    [anon_sym_readonly] = ACTIONS(1046),
    [anon_sym_sealed] = ACTIONS(1046),
    [anon_sym_static] = ACTIONS(1046),
    [anon_sym_unsafe] = ACTIONS(1046),
    [anon_sym_virtual] = ACTIONS(1046),
    [anon_sym_volatile] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1048),
    [anon_sym_partial] = ACTIONS(1046),
    [anon_sym_class] = ACTIONS(1046),
    [anon_sym_struct] = ACTIONS(1046),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_event] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_implicit] = ACTIONS(1046),
    [anon_sym_explicit] = ACTIONS(1046),
    [anon_sym_interface] = ACTIONS(1046),
    [anon_sym_enum] = ACTIONS(1046),
    [anon_sym_delegate] = ACTIONS(1046),
    [sym_void_keyword] = ACTIONS(1046),
    [anon_sym_const] = ACTIONS(1046),
    [sym_identifier_name] = ACTIONS(1046),
    [sym_comment] = ACTIONS(31),
  },
  [346] = {
    [anon_sym_protected] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(1052),
    [anon_sym_set] = ACTIONS(1052),
    [sym_comment] = ACTIONS(31),
  },
  [347] = {
    [anon_sym_get] = ACTIONS(1052),
    [anon_sym_set] = ACTIONS(1052),
    [sym_comment] = ACTIONS(31),
  },
  [348] = {
    [anon_sym_internal] = ACTIONS(1050),
    [anon_sym_get] = ACTIONS(1052),
    [anon_sym_set] = ACTIONS(1052),
    [sym_comment] = ACTIONS(31),
  },
  [349] = {
    [sym_statement_block] = STATE(506),
    [anon_sym_SEMI] = ACTIONS(1054),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [350] = {
    [sym_statement_block] = STATE(507),
    [anon_sym_SEMI] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [351] = {
    [anon_sym_RBRACE] = ACTIONS(1058),
    [sym_comment] = ACTIONS(31),
  },
  [352] = {
    [sym_set_accessor_declaration] = STATE(509),
    [sym_accessor_modifier] = STATE(510),
    [sym__attributes] = STATE(511),
    [sym__attribute_section] = STATE(512),
    [aux_sym__attributes_repeat1] = STATE(512),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(649),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_set] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [353] = {
    [sym_get_accessor_declaration] = STATE(509),
    [sym_accessor_modifier] = STATE(513),
    [sym__attributes] = STATE(514),
    [sym__attribute_section] = STATE(515),
    [aux_sym__attributes_repeat1] = STATE(515),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(649),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_get] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [354] = {
    [anon_sym_get] = ACTIONS(1062),
    [anon_sym_set] = ACTIONS(1064),
    [sym_comment] = ACTIONS(31),
  },
  [355] = {
    [sym_accessor_modifier] = STATE(518),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(649),
    [anon_sym_get] = ACTIONS(1062),
    [anon_sym_set] = ACTIONS(1064),
    [sym_comment] = ACTIONS(31),
  },
  [356] = {
    [sym__attribute_section] = STATE(519),
    [aux_sym__attributes_repeat1] = STATE(519),
    [anon_sym_internal] = ACTIONS(85),
    [anon_sym_private] = ACTIONS(85),
    [anon_sym_protected] = ACTIONS(85),
    [anon_sym_get] = ACTIONS(85),
    [anon_sym_set] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [357] = {
    [sym__expression] = STATE(521),
    [sym_parenthesized_expression] = STATE(521),
    [sym_ternary_expression] = STATE(521),
    [sym_binary_expression] = STATE(521),
    [sym_unary_expression] = STATE(521),
    [sym__literal] = STATE(521),
    [sym_boolean_literal] = STATE(521),
    [sym_character_literal] = STATE(521),
    [sym_integer_literal] = STATE(521),
    [sym_real_literal] = STATE(521),
    [sym_string_literal] = STATE(521),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1070),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1070),
    [sym_comment] = ACTIONS(31),
  },
  [358] = {
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1072),
    [sym_comment] = ACTIONS(31),
  },
  [359] = {
    [sym__expression] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_ternary_expression] = STATE(523),
    [sym_binary_expression] = STATE(523),
    [sym_unary_expression] = STATE(523),
    [sym__literal] = STATE(523),
    [sym_boolean_literal] = STATE(523),
    [sym_character_literal] = STATE(523),
    [sym_integer_literal] = STATE(523),
    [sym_real_literal] = STATE(523),
    [sym_string_literal] = STATE(523),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1074),
    [sym_comment] = ACTIONS(31),
  },
  [360] = {
    [anon_sym_LT] = ACTIONS(1076),
    [anon_sym_COMMA] = ACTIONS(1078),
    [anon_sym_GT] = ACTIONS(1076),
    [anon_sym_SEMI] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [anon_sym_COLON] = ACTIONS(1078),
    [anon_sym_RPAREN] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_RBRACK] = ACTIONS(1078),
    [anon_sym_PLUS] = ACTIONS(1078),
    [anon_sym_DASH] = ACTIONS(1078),
    [anon_sym_STAR] = ACTIONS(1078),
    [anon_sym_SLASH] = ACTIONS(1076),
    [anon_sym_PERCENT] = ACTIONS(1078),
    [anon_sym_CARET] = ACTIONS(1078),
    [anon_sym_PIPE] = ACTIONS(1076),
    [anon_sym_AMP] = ACTIONS(1076),
    [anon_sym_LT_LT] = ACTIONS(1078),
    [anon_sym_GT_GT] = ACTIONS(1078),
    [anon_sym_EQ_EQ] = ACTIONS(1078),
    [anon_sym_BANG_EQ] = ACTIONS(1078),
    [anon_sym_GT_EQ] = ACTIONS(1078),
    [anon_sym_LT_EQ] = ACTIONS(1078),
    [anon_sym_params] = ACTIONS(1078),
    [anon_sym_QMARK] = ACTIONS(1078),
    [anon_sym_AMP_AMP] = ACTIONS(1078),
    [anon_sym_PIPE_PIPE] = ACTIONS(1078),
    [sym_comment] = ACTIONS(31),
  },
  [361] = {
    [sym__unicode_escape_sequence] = STATE(524),
    [sym__simple_escape_sequence] = STATE(524),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_RBRACK_SLASH] = ACTIONS(1080),
    [sym__hexadecimal_escape_sequence] = ACTIONS(1080),
    [aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1080),
    [aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1080),
    [anon_sym_BSLASH_SQUOTE] = ACTIONS(1080),
    [anon_sym_BSLASH_DQUOTE] = ACTIONS(1080),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1080),
    [anon_sym_BSLASH0] = ACTIONS(1080),
    [anon_sym_BSLASHa] = ACTIONS(1080),
    [anon_sym_BSLASHb] = ACTIONS(1080),
    [anon_sym_BSLASHf] = ACTIONS(1080),
    [anon_sym_BSLASHn] = ACTIONS(1080),
    [anon_sym_BSLASHr] = ACTIONS(1080),
    [anon_sym_BSLASHt] = ACTIONS(1080),
    [anon_sym_BSLASHv] = ACTIONS(1080),
    [sym_comment] = ACTIONS(1082),
  },
  [362] = {
    [anon_sym_LT] = ACTIONS(1084),
    [anon_sym_COMMA] = ACTIONS(1086),
    [anon_sym_GT] = ACTIONS(1084),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_COLON] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1086),
    [anon_sym_DOT] = ACTIONS(1088),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1086),
    [anon_sym_CARET] = ACTIONS(1086),
    [anon_sym_PIPE] = ACTIONS(1084),
    [anon_sym_AMP] = ACTIONS(1084),
    [anon_sym_LT_LT] = ACTIONS(1086),
    [anon_sym_GT_GT] = ACTIONS(1086),
    [anon_sym_EQ_EQ] = ACTIONS(1086),
    [anon_sym_BANG_EQ] = ACTIONS(1086),
    [anon_sym_GT_EQ] = ACTIONS(1086),
    [anon_sym_LT_EQ] = ACTIONS(1086),
    [anon_sym_params] = ACTIONS(1086),
    [anon_sym_QMARK] = ACTIONS(1086),
    [anon_sym_AMP_AMP] = ACTIONS(1086),
    [anon_sym_PIPE_PIPE] = ACTIONS(1086),
    [sym__integer_type_suffix] = ACTIONS(1090),
    [sym__real_type_suffix] = ACTIONS(1092),
    [sym__exponent_part] = ACTIONS(1094),
    [sym_comment] = ACTIONS(31),
  },
  [363] = {
    [anon_sym_LT] = ACTIONS(1084),
    [anon_sym_COMMA] = ACTIONS(1086),
    [anon_sym_GT] = ACTIONS(1084),
    [anon_sym_SEMI] = ACTIONS(1086),
    [anon_sym_RBRACE] = ACTIONS(1086),
    [anon_sym_COLON] = ACTIONS(1086),
    [anon_sym_RPAREN] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1086),
    [anon_sym_RBRACK] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1086),
    [anon_sym_SLASH] = ACTIONS(1084),
    [anon_sym_PERCENT] = ACTIONS(1086),
    [anon_sym_CARET] = ACTIONS(1086),
    [anon_sym_PIPE] = ACTIONS(1084),
    [anon_sym_AMP] = ACTIONS(1084),
    [anon_sym_LT_LT] = ACTIONS(1086),
    [anon_sym_GT_GT] = ACTIONS(1086),
    [anon_sym_EQ_EQ] = ACTIONS(1086),
    [anon_sym_BANG_EQ] = ACTIONS(1086),
    [anon_sym_GT_EQ] = ACTIONS(1086),
    [anon_sym_LT_EQ] = ACTIONS(1086),
    [anon_sym_params] = ACTIONS(1086),
    [anon_sym_QMARK] = ACTIONS(1086),
    [anon_sym_AMP_AMP] = ACTIONS(1086),
    [anon_sym_PIPE_PIPE] = ACTIONS(1086),
    [sym__integer_type_suffix] = ACTIONS(1090),
    [sym_comment] = ACTIONS(31),
  },
  [364] = {
    [sym__unicode_escape_sequence] = STATE(530),
    [sym__simple_escape_sequence] = STATE(530),
    [sym__regular_string_literal_character] = STATE(530),
    [aux_sym__regular_string_literal_repeat1] = STATE(530),
    [sym__hexadecimal_escape_sequence] = ACTIONS(1096),
    [aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1096),
    [aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1096),
    [anon_sym_BSLASH_SQUOTE] = ACTIONS(1096),
    [anon_sym_BSLASH_DQUOTE] = ACTIONS(1096),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1096),
    [anon_sym_BSLASH0] = ACTIONS(1096),
    [anon_sym_BSLASHa] = ACTIONS(1096),
    [anon_sym_BSLASHb] = ACTIONS(1096),
    [anon_sym_BSLASHf] = ACTIONS(1096),
    [anon_sym_BSLASHn] = ACTIONS(1096),
    [anon_sym_BSLASHr] = ACTIONS(1096),
    [anon_sym_BSLASHt] = ACTIONS(1096),
    [anon_sym_BSLASHv] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1098),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH] = ACTIONS(1096),
    [sym_comment] = ACTIONS(1082),
  },
  [365] = {
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_RBRACK_STAR_SLASH] = ACTIONS(1100),
    [sym_comment] = ACTIONS(1082),
  },
  [366] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [367] = {
    [anon_sym_LT] = ACTIONS(1128),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_GT] = ACTIONS(1128),
    [anon_sym_SEMI] = ACTIONS(1130),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [anon_sym_COLON] = ACTIONS(1130),
    [anon_sym_RPAREN] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1130),
    [anon_sym_RBRACK] = ACTIONS(1130),
    [anon_sym_PLUS] = ACTIONS(1130),
    [anon_sym_DASH] = ACTIONS(1130),
    [anon_sym_STAR] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(1128),
    [anon_sym_PERCENT] = ACTIONS(1130),
    [anon_sym_CARET] = ACTIONS(1130),
    [anon_sym_PIPE] = ACTIONS(1128),
    [anon_sym_AMP] = ACTIONS(1128),
    [anon_sym_LT_LT] = ACTIONS(1130),
    [anon_sym_GT_GT] = ACTIONS(1130),
    [anon_sym_EQ_EQ] = ACTIONS(1130),
    [anon_sym_BANG_EQ] = ACTIONS(1130),
    [anon_sym_GT_EQ] = ACTIONS(1130),
    [anon_sym_LT_EQ] = ACTIONS(1130),
    [anon_sym_params] = ACTIONS(1130),
    [anon_sym_QMARK] = ACTIONS(1130),
    [anon_sym_AMP_AMP] = ACTIONS(1130),
    [anon_sym_PIPE_PIPE] = ACTIONS(1130),
    [sym_comment] = ACTIONS(31),
  },
  [368] = {
    [anon_sym_bool] = ACTIONS(1132),
    [anon_sym_byte] = ACTIONS(1132),
    [anon_sym_char] = ACTIONS(1132),
    [anon_sym_decimal] = ACTIONS(1132),
    [anon_sym_double] = ACTIONS(1132),
    [anon_sym_float] = ACTIONS(1132),
    [anon_sym_int] = ACTIONS(1132),
    [anon_sym_long] = ACTIONS(1132),
    [anon_sym_object] = ACTIONS(1132),
    [anon_sym_sbyte] = ACTIONS(1132),
    [anon_sym_short] = ACTIONS(1132),
    [anon_sym_string] = ACTIONS(1132),
    [anon_sym_uint] = ACTIONS(1132),
    [anon_sym_ulong] = ACTIONS(1132),
    [anon_sym_ushort] = ACTIONS(1132),
    [anon_sym_SEMI] = ACTIONS(1134),
    [anon_sym_LBRACE] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1134),
    [anon_sym_DOT] = ACTIONS(1134),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_BANG] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1134),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_true] = ACTIONS(1132),
    [anon_sym_false] = ACTIONS(1132),
    [anon_sym_const] = ACTIONS(1132),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_sizeof] = ACTIONS(1132),
    [anon_sym_SQUOTE] = ACTIONS(1134),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1132),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1134),
    [sym_null_literal] = ACTIONS(1132),
    [anon_sym_DQUOTE] = ACTIONS(1134),
    [anon_sym_AT_DQUOTE] = ACTIONS(1134),
    [sym_identifier_name] = ACTIONS(1132),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1132),
    [anon_sym_checked] = ACTIONS(1132),
    [anon_sym_unchecked] = ACTIONS(1132),
    [anon_sym_lock] = ACTIONS(1132),
    [anon_sym_yield] = ACTIONS(1132),
    [anon_sym_return] = ACTIONS(1132),
    [anon_sym_break] = ACTIONS(1132),
    [anon_sym_if] = ACTIONS(1132),
    [anon_sym_else] = ACTIONS(1132),
    [anon_sym_switch] = ACTIONS(1132),
    [anon_sym_case] = ACTIONS(1132),
    [anon_sym_default] = ACTIONS(1132),
    [anon_sym_while] = ACTIONS(1132),
    [anon_sym_do] = ACTIONS(1132),
    [anon_sym_continue] = ACTIONS(1132),
    [anon_sym_throw] = ACTIONS(1132),
    [anon_sym_goto] = ACTIONS(1132),
    [anon_sym_var] = ACTIONS(1132),
  },
  [369] = {
    [anon_sym_bool] = ACTIONS(1136),
    [anon_sym_byte] = ACTIONS(1136),
    [anon_sym_char] = ACTIONS(1136),
    [anon_sym_decimal] = ACTIONS(1136),
    [anon_sym_double] = ACTIONS(1136),
    [anon_sym_float] = ACTIONS(1136),
    [anon_sym_int] = ACTIONS(1136),
    [anon_sym_long] = ACTIONS(1136),
    [anon_sym_object] = ACTIONS(1136),
    [anon_sym_sbyte] = ACTIONS(1136),
    [anon_sym_short] = ACTIONS(1136),
    [anon_sym_string] = ACTIONS(1136),
    [anon_sym_uint] = ACTIONS(1136),
    [anon_sym_ulong] = ACTIONS(1136),
    [anon_sym_ushort] = ACTIONS(1136),
    [anon_sym_abstract] = ACTIONS(1136),
    [anon_sym_async] = ACTIONS(1136),
    [anon_sym_extern] = ACTIONS(1136),
    [anon_sym_internal] = ACTIONS(1136),
    [anon_sym_new] = ACTIONS(1136),
    [anon_sym_override] = ACTIONS(1136),
    [anon_sym_private] = ACTIONS(1136),
    [anon_sym_protected] = ACTIONS(1136),
    [anon_sym_public] = ACTIONS(1136),
    [anon_sym_readonly] = ACTIONS(1136),
    [anon_sym_sealed] = ACTIONS(1136),
    [anon_sym_static] = ACTIONS(1136),
    [anon_sym_unsafe] = ACTIONS(1136),
    [anon_sym_virtual] = ACTIONS(1136),
    [anon_sym_volatile] = ACTIONS(1136),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [anon_sym_get] = ACTIONS(1136),
    [anon_sym_set] = ACTIONS(1136),
    [anon_sym_partial] = ACTIONS(1136),
    [anon_sym_class] = ACTIONS(1136),
    [anon_sym_struct] = ACTIONS(1136),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_DOT] = ACTIONS(1138),
    [anon_sym_event] = ACTIONS(1136),
    [anon_sym_add] = ACTIONS(1136),
    [anon_sym_remove] = ACTIONS(1136),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_BANG] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_true] = ACTIONS(1136),
    [anon_sym_false] = ACTIONS(1136),
    [anon_sym_implicit] = ACTIONS(1136),
    [anon_sym_explicit] = ACTIONS(1136),
    [anon_sym_interface] = ACTIONS(1136),
    [anon_sym_enum] = ACTIONS(1136),
    [anon_sym_delegate] = ACTIONS(1136),
    [sym_void_keyword] = ACTIONS(1136),
    [anon_sym_const] = ACTIONS(1136),
    [anon_sym_typeof] = ACTIONS(1136),
    [anon_sym_sizeof] = ACTIONS(1136),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1136),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1138),
    [sym_null_literal] = ACTIONS(1136),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [anon_sym_AT_DQUOTE] = ACTIONS(1138),
    [sym_identifier_name] = ACTIONS(1136),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1136),
    [anon_sym_catch] = ACTIONS(1136),
    [anon_sym_finally] = ACTIONS(1136),
    [anon_sym_checked] = ACTIONS(1136),
    [anon_sym_unchecked] = ACTIONS(1136),
    [anon_sym_lock] = ACTIONS(1136),
    [anon_sym_yield] = ACTIONS(1136),
    [anon_sym_return] = ACTIONS(1136),
    [anon_sym_break] = ACTIONS(1136),
    [anon_sym_if] = ACTIONS(1136),
    [anon_sym_else] = ACTIONS(1136),
    [anon_sym_switch] = ACTIONS(1136),
    [anon_sym_case] = ACTIONS(1136),
    [anon_sym_default] = ACTIONS(1136),
    [anon_sym_while] = ACTIONS(1136),
    [anon_sym_do] = ACTIONS(1136),
    [anon_sym_continue] = ACTIONS(1136),
    [anon_sym_throw] = ACTIONS(1136),
    [anon_sym_goto] = ACTIONS(1136),
    [anon_sym_var] = ACTIONS(1136),
  },
  [370] = {
    [sym__type] = STATE(542),
    [sym_predefined_type] = STATE(542),
    [sym_generic_name] = STATE(542),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [371] = {
    [sym_type_parameter_list] = STATE(97),
    [sym_equals_value_clause] = STATE(545),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [sym_identifier_name] = ACTIONS(147),
    [sym_comment] = ACTIONS(31),
  },
  [372] = {
    [sym_statement_block] = STATE(546),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [373] = {
    [sym_statement_block] = STATE(547),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [374] = {
    [sym_statement_block] = STATE(548),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [375] = {
    [anon_sym_LPAREN] = ACTIONS(1151),
    [sym_comment] = ACTIONS(31),
  },
  [376] = {
    [sym_comment] = ACTIONS(31),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1155),
  },
  [377] = {
    [sym__expression] = STATE(553),
    [sym_parenthesized_expression] = STATE(553),
    [sym_ternary_expression] = STATE(553),
    [sym_binary_expression] = STATE(553),
    [sym_unary_expression] = STATE(553),
    [sym__literal] = STATE(553),
    [sym_boolean_literal] = STATE(553),
    [sym_character_literal] = STATE(553),
    [sym_integer_literal] = STATE(553),
    [sym_real_literal] = STATE(553),
    [sym_string_literal] = STATE(553),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1159),
    [sym_comment] = ACTIONS(31),
  },
  [378] = {
    [anon_sym_SEMI] = ACTIONS(1161),
    [sym_comment] = ACTIONS(31),
  },
  [379] = {
    [anon_sym_LPAREN] = ACTIONS(1163),
    [sym_comment] = ACTIONS(31),
  },
  [380] = {
    [anon_sym_LPAREN] = ACTIONS(1165),
    [sym_comment] = ACTIONS(31),
  },
  [381] = {
    [anon_sym_LPAREN] = ACTIONS(1167),
    [sym_comment] = ACTIONS(31),
  },
  [382] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(562),
    [sym__embedded_statement] = STATE(562),
    [sym_empty_statement] = STATE(562),
    [sym_expression_statement] = STATE(562),
    [sym__selection_statement] = STATE(562),
    [sym__iteration_statement] = STATE(562),
    [sym__jump_statement] = STATE(562),
    [sym_try_statement] = STATE(562),
    [sym_checked_statement] = STATE(562),
    [sym_unchecked_statement] = STATE(562),
    [sym_lock_statement] = STATE(562),
    [sym_yield_statement] = STATE(562),
    [sym_if_statement] = STATE(562),
    [sym_switch_statement] = STATE(562),
    [sym_while_statement] = STATE(562),
    [sym_do_statement] = STATE(562),
    [sym_break_statement] = STATE(562),
    [sym_continue_statement] = STATE(562),
    [sym_return_statement] = STATE(562),
    [sym_throw_statement] = STATE(562),
    [sym_goto_statement] = STATE(562),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(1175),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [383] = {
    [anon_sym_SEMI] = ACTIONS(1177),
    [sym_comment] = ACTIONS(31),
  },
  [384] = {
    [sym__expression] = STATE(565),
    [sym_parenthesized_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym__literal] = STATE(565),
    [sym_boolean_literal] = STATE(565),
    [sym_character_literal] = STATE(565),
    [sym_integer_literal] = STATE(565),
    [sym_real_literal] = STATE(565),
    [sym_string_literal] = STATE(565),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_SEMI] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1181),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1181),
    [sym_comment] = ACTIONS(31),
  },
  [385] = {
    [sym_identifier_name] = ACTIONS(1183),
    [sym_comment] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(1185),
    [anon_sym_default] = ACTIONS(1187),
  },
  [386] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [387] = {
    [anon_sym_RBRACE] = ACTIONS(1191),
    [sym_comment] = ACTIONS(31),
  },
  [388] = {
    [anon_sym_SEMI] = ACTIONS(1193),
    [sym_comment] = ACTIONS(31),
  },
  [389] = {
    [sym__local_variable_declarators] = STATE(573),
    [sym_local_variable_declarator] = STATE(573),
    [sym_identifier_name] = ACTIONS(1195),
    [sym_comment] = ACTIONS(31),
  },
  [390] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(574),
    [sym_variable_assignment_statement] = STATE(574),
    [sym_statement_block] = STATE(574),
    [sym__labeled_statement] = STATE(574),
    [sym__embedded_statement] = STATE(574),
    [sym_empty_statement] = STATE(574),
    [sym_expression_statement] = STATE(574),
    [sym__selection_statement] = STATE(574),
    [sym__iteration_statement] = STATE(574),
    [sym__jump_statement] = STATE(574),
    [sym_try_statement] = STATE(574),
    [sym_checked_statement] = STATE(574),
    [sym_unchecked_statement] = STATE(574),
    [sym_lock_statement] = STATE(574),
    [sym_yield_statement] = STATE(574),
    [sym_if_statement] = STATE(574),
    [sym_switch_statement] = STATE(574),
    [sym_while_statement] = STATE(574),
    [sym_do_statement] = STATE(574),
    [sym_break_statement] = STATE(574),
    [sym_continue_statement] = STATE(574),
    [sym_return_statement] = STATE(574),
    [sym_throw_statement] = STATE(574),
    [sym_goto_statement] = STATE(574),
    [sym__declaration_statement] = STATE(574),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [aux_sym__statement_list_repeat1] = STATE(574),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(689),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(693),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(701),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(723),
  },
  [391] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [392] = {
    [anon_sym_LPAREN] = ACTIONS(1201),
    [sym_comment] = ACTIONS(31),
  },
  [393] = {
    [sym_identifier_name] = ACTIONS(1203),
    [sym_comment] = ACTIONS(31),
  },
  [394] = {
    [sym__type] = STATE(578),
    [sym_predefined_type] = STATE(578),
    [sym_generic_name] = STATE(578),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1207),
    [anon_sym_interface] = ACTIONS(1209),
    [sym_void_keyword] = ACTIONS(1211),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [395] = {
    [sym__type] = STATE(579),
    [sym_predefined_type] = STATE(579),
    [sym_generic_name] = STATE(579),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [396] = {
    [sym__type] = STATE(580),
    [sym_predefined_type] = STATE(580),
    [sym_generic_name] = STATE(580),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [397] = {
    [sym_type_parameter_list] = STATE(581),
    [sym_parameter_list] = STATE(502),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_this] = ACTIONS(149),
    [anon_sym_operator] = ACTIONS(149),
    [sym_identifier_name] = ACTIONS(149),
    [sym_comment] = ACTIONS(31),
  },
  [398] = {
    [sym_variable_declarator] = STATE(222),
    [anon_sym_this] = ACTIONS(395),
    [anon_sym_operator] = ACTIONS(397),
    [sym_identifier_name] = ACTIONS(1213),
    [sym_comment] = ACTIONS(31),
  },
  [399] = {
    [sym__indexer_body] = STATE(583),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [sym_comment] = ACTIONS(31),
  },
  [400] = {
    [sym_statement_block] = STATE(575),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_EQ_GT] = ACTIONS(1215),
    [sym_comment] = ACTIONS(31),
  },
  [401] = {
    [anon_sym_SEMI] = ACTIONS(1217),
    [sym_comment] = ACTIONS(31),
  },
  [402] = {
    [aux_sym_class_base_repeat1] = STATE(586),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_where] = ACTIONS(1219),
    [sym_comment] = ACTIONS(31),
  },
  [403] = {
    [anon_sym_COMMA] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_where] = ACTIONS(1223),
    [sym_comment] = ACTIONS(31),
  },
  [404] = {
    [anon_sym_LPAREN] = ACTIONS(1225),
    [sym_comment] = ACTIONS(31),
  },
  [405] = {
    [anon_sym_SEMI] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(1227),
    [sym_comment] = ACTIONS(31),
  },
  [406] = {
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_where] = ACTIONS(1223),
    [sym_comment] = ACTIONS(31),
  },
  [407] = {
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_where] = ACTIONS(1229),
    [sym_comment] = ACTIONS(31),
  },
  [408] = {
    [aux_sym_class_base_repeat1] = STATE(408),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_where] = ACTIONS(1229),
    [sym_comment] = ACTIONS(31),
  },
  [409] = {
    [sym_identifier_name] = ACTIONS(1234),
    [sym_comment] = ACTIONS(31),
  },
  [410] = {
    [sym_type_parameter_list] = STATE(591),
    [sym_type_parameter_constraints_clause] = STATE(593),
    [sym_parameter_list] = STATE(592),
    [aux_sym_class_declaration_repeat1] = STATE(593),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [411] = {
    [anon_sym_LBRACK] = ACTIONS(1238),
    [sym_comment] = ACTIONS(31),
  },
  [412] = {
    [sym_type_parameter_list] = STATE(591),
    [sym_type_parameter_constraints_clause] = STATE(593),
    [sym_parameter_list] = STATE(592),
    [aux_sym_class_declaration_repeat1] = STATE(593),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1240),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [413] = {
    [anon_sym_SEMI] = ACTIONS(1242),
    [sym_comment] = ACTIONS(31),
  },
  [414] = {
    [anon_sym_bool] = ACTIONS(1244),
    [anon_sym_byte] = ACTIONS(1244),
    [anon_sym_char] = ACTIONS(1244),
    [anon_sym_decimal] = ACTIONS(1244),
    [anon_sym_double] = ACTIONS(1244),
    [anon_sym_float] = ACTIONS(1244),
    [anon_sym_int] = ACTIONS(1244),
    [anon_sym_long] = ACTIONS(1244),
    [anon_sym_object] = ACTIONS(1244),
    [anon_sym_sbyte] = ACTIONS(1244),
    [anon_sym_short] = ACTIONS(1244),
    [anon_sym_string] = ACTIONS(1244),
    [anon_sym_uint] = ACTIONS(1244),
    [anon_sym_ulong] = ACTIONS(1244),
    [anon_sym_ushort] = ACTIONS(1244),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_event] = ACTIONS(1244),
    [sym_void_keyword] = ACTIONS(1244),
    [sym_identifier_name] = ACTIONS(1244),
    [sym_comment] = ACTIONS(31),
  },
  [415] = {
    [sym_identifier_name] = ACTIONS(1248),
    [sym_comment] = ACTIONS(31),
  },
  [416] = {
    [sym_type_parameter_constraints_clause] = STATE(593),
    [sym_parameter_list] = STATE(592),
    [aux_sym_class_declaration_repeat1] = STATE(593),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [417] = {
    [sym_type_parameter_constraints_clause] = STATE(593),
    [aux_sym_class_declaration_repeat1] = STATE(593),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [418] = {
    [sym_type_parameter_constraints_clause] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(598),
    [anon_sym_SEMI] = ACTIONS(1236),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [419] = {
    [sym__type] = STATE(484),
    [sym_predefined_type] = STATE(484),
    [sym__formal_parameter_list] = STATE(599),
    [sym_parameter] = STATE(486),
    [sym_parameter_modifier] = STATE(487),
    [sym_parameter_array] = STATE(599),
    [sym__attributes] = STATE(488),
    [sym__attribute_section] = STATE(280),
    [sym_generic_name] = STATE(484),
    [aux_sym__attributes_repeat1] = STATE(280),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(505),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [420] = {
    [sym_interface_accessor] = STATE(602),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(602),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [421] = {
    [sym__type] = STATE(604),
    [sym_predefined_type] = STATE(604),
    [sym_generic_name] = STATE(604),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [422] = {
    [sym_identifier_name] = ACTIONS(1252),
    [sym_comment] = ACTIONS(31),
  },
  [423] = {
    [anon_sym_this] = ACTIONS(1254),
    [sym_identifier_name] = ACTIONS(1256),
    [sym_comment] = ACTIONS(31),
  },
  [424] = {
    [aux_sym_class_base_repeat1] = STATE(608),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_where] = ACTIONS(1258),
    [sym_comment] = ACTIONS(31),
  },
  [425] = {
    [sym__expression] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_ternary_expression] = STATE(523),
    [sym_binary_expression] = STATE(523),
    [sym_unary_expression] = STATE(523),
    [sym__literal] = STATE(523),
    [sym_boolean_literal] = STATE(523),
    [sym_character_literal] = STATE(523),
    [sym_integer_literal] = STATE(523),
    [sym_real_literal] = STATE(523),
    [sym_string_literal] = STATE(523),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1074),
    [sym_comment] = ACTIONS(31),
  },
  [426] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1262),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1282),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1286),
    [sym_comment] = ACTIONS(31),
  },
  [427] = {
    [anon_sym_COMMA] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(31),
  },
  [428] = {
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [sym_comment] = ACTIONS(31),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [anon_sym_bool] = ACTIONS(1294),
    [anon_sym_byte] = ACTIONS(1294),
    [anon_sym_char] = ACTIONS(1294),
    [anon_sym_decimal] = ACTIONS(1294),
    [anon_sym_double] = ACTIONS(1294),
    [anon_sym_float] = ACTIONS(1294),
    [anon_sym_int] = ACTIONS(1294),
    [anon_sym_long] = ACTIONS(1294),
    [anon_sym_object] = ACTIONS(1294),
    [anon_sym_sbyte] = ACTIONS(1294),
    [anon_sym_short] = ACTIONS(1294),
    [anon_sym_string] = ACTIONS(1294),
    [anon_sym_uint] = ACTIONS(1294),
    [anon_sym_ulong] = ACTIONS(1294),
    [anon_sym_ushort] = ACTIONS(1294),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_extern] = ACTIONS(1294),
    [anon_sym_internal] = ACTIONS(1294),
    [anon_sym_new] = ACTIONS(1294),
    [anon_sym_override] = ACTIONS(1294),
    [anon_sym_private] = ACTIONS(1294),
    [anon_sym_protected] = ACTIONS(1294),
    [anon_sym_public] = ACTIONS(1294),
    [anon_sym_readonly] = ACTIONS(1294),
    [anon_sym_sealed] = ACTIONS(1294),
    [anon_sym_static] = ACTIONS(1294),
    [anon_sym_unsafe] = ACTIONS(1294),
    [anon_sym_virtual] = ACTIONS(1294),
    [anon_sym_volatile] = ACTIONS(1294),
    [anon_sym_using] = ACTIONS(1294),
    [anon_sym_namespace] = ACTIONS(1294),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_partial] = ACTIONS(1294),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_struct] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_event] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_implicit] = ACTIONS(1294),
    [anon_sym_explicit] = ACTIONS(1294),
    [anon_sym_interface] = ACTIONS(1294),
    [anon_sym_enum] = ACTIONS(1294),
    [anon_sym_delegate] = ACTIONS(1294),
    [sym_void_keyword] = ACTIONS(1294),
    [anon_sym_const] = ACTIONS(1294),
    [sym_identifier_name] = ACTIONS(1294),
    [sym_comment] = ACTIONS(31),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [anon_sym_bool] = ACTIONS(1294),
    [anon_sym_byte] = ACTIONS(1294),
    [anon_sym_char] = ACTIONS(1294),
    [anon_sym_decimal] = ACTIONS(1294),
    [anon_sym_double] = ACTIONS(1294),
    [anon_sym_float] = ACTIONS(1294),
    [anon_sym_int] = ACTIONS(1294),
    [anon_sym_long] = ACTIONS(1294),
    [anon_sym_object] = ACTIONS(1294),
    [anon_sym_sbyte] = ACTIONS(1294),
    [anon_sym_short] = ACTIONS(1294),
    [anon_sym_string] = ACTIONS(1294),
    [anon_sym_uint] = ACTIONS(1294),
    [anon_sym_ulong] = ACTIONS(1294),
    [anon_sym_ushort] = ACTIONS(1294),
    [anon_sym_abstract] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_extern] = ACTIONS(1294),
    [anon_sym_internal] = ACTIONS(1294),
    [anon_sym_new] = ACTIONS(1294),
    [anon_sym_override] = ACTIONS(1294),
    [anon_sym_private] = ACTIONS(1294),
    [anon_sym_protected] = ACTIONS(1294),
    [anon_sym_public] = ACTIONS(1294),
    [anon_sym_readonly] = ACTIONS(1294),
    [anon_sym_sealed] = ACTIONS(1294),
    [anon_sym_static] = ACTIONS(1294),
    [anon_sym_unsafe] = ACTIONS(1294),
    [anon_sym_virtual] = ACTIONS(1294),
    [anon_sym_volatile] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1296),
    [anon_sym_using] = ACTIONS(1294),
    [anon_sym_namespace] = ACTIONS(1294),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_partial] = ACTIONS(1294),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_struct] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_event] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_implicit] = ACTIONS(1294),
    [anon_sym_explicit] = ACTIONS(1294),
    [anon_sym_interface] = ACTIONS(1294),
    [anon_sym_enum] = ACTIONS(1294),
    [anon_sym_delegate] = ACTIONS(1294),
    [sym_void_keyword] = ACTIONS(1294),
    [anon_sym_const] = ACTIONS(1294),
    [sym_identifier_name] = ACTIONS(1294),
    [sym_comment] = ACTIONS(31),
  },
  [431] = {
    [aux_sym_enum_declaration_repeat1] = STATE(431),
    [anon_sym_COMMA] = ACTIONS(1298),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [sym_comment] = ACTIONS(31),
  },
  [432] = {
    [sym__expression] = STATE(426),
    [sym_constant_expression] = STATE(620),
    [sym_parenthesized_expression] = STATE(426),
    [sym_ternary_expression] = STATE(426),
    [sym_binary_expression] = STATE(426),
    [sym_unary_expression] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [sym_character_literal] = STATE(426),
    [sym_integer_literal] = STATE(426),
    [sym_real_literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(904),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(904),
    [sym_comment] = ACTIONS(31),
  },
  [433] = {
    [aux_sym_enum_declaration_repeat1] = STATE(622),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [sym_comment] = ACTIONS(31),
  },
  [434] = {
    [anon_sym_RBRACK] = ACTIONS(1303),
    [sym_comment] = ACTIONS(31),
  },
  [435] = {
    [sym_array_rank_specifier] = STATE(625),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [sym_comment] = ACTIONS(31),
  },
  [436] = {
    [sym_identifier_name] = ACTIONS(1307),
    [sym_comment] = ACTIONS(31),
  },
  [437] = {
    [sym_default_argument] = STATE(628),
    [anon_sym_COMMA] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_RPAREN] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [anon_sym_params] = ACTIONS(1309),
    [sym_comment] = ACTIONS(31),
  },
  [438] = {
    [anon_sym_SEMI] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1313),
    [anon_sym_where] = ACTIONS(1313),
    [sym_comment] = ACTIONS(31),
  },
  [439] = {
    [sym__type] = STATE(275),
    [sym_predefined_type] = STATE(275),
    [sym_parameter] = STATE(629),
    [sym_parameter_modifier] = STATE(278),
    [sym__attributes] = STATE(630),
    [sym__attribute_section] = STATE(631),
    [sym_generic_name] = STATE(275),
    [aux_sym__attributes_repeat1] = STATE(631),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [440] = {
    [sym_attribute_list] = STATE(632),
    [sym_attribute] = STATE(41),
    [sym_identifier_name] = ACTIONS(182),
    [sym_comment] = ACTIONS(31),
  },
  [441] = {
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [sym_comment] = ACTIONS(31),
  },
  [442] = {
    [anon_sym_params] = ACTIONS(1317),
    [sym_comment] = ACTIONS(31),
  },
  [443] = {
    [sym_parameter_array] = STATE(633),
    [sym__attributes] = STATE(442),
    [sym__attribute_section] = STATE(444),
    [aux_sym__formal_parameter_list_repeat1] = STATE(634),
    [aux_sym__attributes_repeat1] = STATE(444),
    [anon_sym_COMMA] = ACTIONS(926),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_params] = ACTIONS(932),
    [sym_comment] = ACTIONS(31),
  },
  [444] = {
    [sym__attribute_section] = STATE(635),
    [aux_sym__attributes_repeat1] = STATE(635),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_params] = ACTIONS(85),
    [sym_comment] = ACTIONS(31),
  },
  [445] = {
    [sym_identifier_name] = ACTIONS(1319),
    [sym_comment] = ACTIONS(31),
  },
  [446] = {
    [sym__type] = STATE(435),
    [sym_predefined_type] = STATE(435),
    [sym_array_type] = STATE(637),
    [sym_generic_name] = STATE(435),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [447] = {
    [sym__type] = STATE(638),
    [sym_predefined_type] = STATE(638),
    [sym_generic_name] = STATE(638),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [448] = {
    [sym__attribute_section] = STATE(448),
    [aux_sym__attributes_repeat1] = STATE(448),
    [anon_sym_bool] = ACTIONS(800),
    [anon_sym_byte] = ACTIONS(800),
    [anon_sym_char] = ACTIONS(800),
    [anon_sym_decimal] = ACTIONS(800),
    [anon_sym_double] = ACTIONS(800),
    [anon_sym_float] = ACTIONS(800),
    [anon_sym_int] = ACTIONS(800),
    [anon_sym_long] = ACTIONS(800),
    [anon_sym_object] = ACTIONS(800),
    [anon_sym_sbyte] = ACTIONS(800),
    [anon_sym_short] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_uint] = ACTIONS(800),
    [anon_sym_ulong] = ACTIONS(800),
    [anon_sym_ushort] = ACTIONS(800),
    [anon_sym_this] = ACTIONS(800),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(800),
    [anon_sym_out] = ACTIONS(800),
    [anon_sym_params] = ACTIONS(800),
    [sym_identifier_name] = ACTIONS(800),
    [sym_comment] = ACTIONS(31),
  },
  [449] = {
    [sym_type_parameter_constraints_clause] = STATE(639),
    [aux_sym_class_declaration_repeat1] = STATE(639),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [450] = {
    [sym_type_parameter_constraints_clause] = STATE(640),
    [aux_sym_class_declaration_repeat1] = STATE(640),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [451] = {
    [sym_type_parameter_constraints_clause] = STATE(641),
    [aux_sym_class_declaration_repeat1] = STATE(641),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [452] = {
    [aux_sym_enum_declaration_repeat1] = STATE(431),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [sym_comment] = ACTIONS(31),
  },
  [453] = {
    [sym_enum_member_declaration] = STATE(642),
    [sym__attributes] = STATE(172),
    [sym__attribute_section] = STATE(173),
    [aux_sym__attributes_repeat1] = STATE(173),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_identifier_name] = ACTIONS(303),
    [sym_comment] = ACTIONS(31),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(1324),
    [anon_sym_bool] = ACTIONS(1326),
    [anon_sym_byte] = ACTIONS(1326),
    [anon_sym_char] = ACTIONS(1326),
    [anon_sym_decimal] = ACTIONS(1326),
    [anon_sym_double] = ACTIONS(1326),
    [anon_sym_float] = ACTIONS(1326),
    [anon_sym_int] = ACTIONS(1326),
    [anon_sym_long] = ACTIONS(1326),
    [anon_sym_object] = ACTIONS(1326),
    [anon_sym_sbyte] = ACTIONS(1326),
    [anon_sym_short] = ACTIONS(1326),
    [anon_sym_string] = ACTIONS(1326),
    [anon_sym_uint] = ACTIONS(1326),
    [anon_sym_ulong] = ACTIONS(1326),
    [anon_sym_ushort] = ACTIONS(1326),
    [anon_sym_abstract] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_extern] = ACTIONS(1326),
    [anon_sym_internal] = ACTIONS(1326),
    [anon_sym_new] = ACTIONS(1326),
    [anon_sym_override] = ACTIONS(1326),
    [anon_sym_private] = ACTIONS(1326),
    [anon_sym_protected] = ACTIONS(1326),
    [anon_sym_public] = ACTIONS(1326),
    [anon_sym_readonly] = ACTIONS(1326),
    [anon_sym_sealed] = ACTIONS(1326),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_unsafe] = ACTIONS(1326),
    [anon_sym_virtual] = ACTIONS(1326),
    [anon_sym_volatile] = ACTIONS(1326),
    [anon_sym_using] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1326),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_partial] = ACTIONS(1326),
    [anon_sym_class] = ACTIONS(1326),
    [anon_sym_struct] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_event] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_implicit] = ACTIONS(1326),
    [anon_sym_explicit] = ACTIONS(1326),
    [anon_sym_interface] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [anon_sym_delegate] = ACTIONS(1326),
    [sym_void_keyword] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [sym_identifier_name] = ACTIONS(1326),
    [sym_comment] = ACTIONS(31),
  },
  [455] = {
    [sym_class_base] = STATE(643),
    [sym_type_parameter_constraints_clause] = STATE(639),
    [aux_sym_class_declaration_repeat1] = STATE(639),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [456] = {
    [sym_type_parameter_constraints_clause] = STATE(640),
    [sym_struct_interfaces] = STATE(644),
    [aux_sym_class_declaration_repeat1] = STATE(640),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [457] = {
    [sym_type_parameter_constraints_clause] = STATE(641),
    [sym_interface_base] = STATE(645),
    [aux_sym_class_declaration_repeat1] = STATE(641),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [458] = {
    [anon_sym_LBRACE] = ACTIONS(1328),
    [sym_comment] = ACTIONS(31),
  },
  [459] = {
    [anon_sym_SEMI] = ACTIONS(1330),
    [sym_comment] = ACTIONS(31),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1332),
    [anon_sym_bool] = ACTIONS(1334),
    [anon_sym_byte] = ACTIONS(1334),
    [anon_sym_char] = ACTIONS(1334),
    [anon_sym_decimal] = ACTIONS(1334),
    [anon_sym_double] = ACTIONS(1334),
    [anon_sym_float] = ACTIONS(1334),
    [anon_sym_int] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_object] = ACTIONS(1334),
    [anon_sym_sbyte] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [anon_sym_string] = ACTIONS(1334),
    [anon_sym_uint] = ACTIONS(1334),
    [anon_sym_ulong] = ACTIONS(1334),
    [anon_sym_ushort] = ACTIONS(1334),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_async] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_internal] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_override] = ACTIONS(1334),
    [anon_sym_private] = ACTIONS(1334),
    [anon_sym_protected] = ACTIONS(1334),
    [anon_sym_public] = ACTIONS(1334),
    [anon_sym_readonly] = ACTIONS(1334),
    [anon_sym_sealed] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_unsafe] = ACTIONS(1334),
    [anon_sym_virtual] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym_using] = ACTIONS(1334),
    [anon_sym_namespace] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_partial] = ACTIONS(1334),
    [anon_sym_class] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_event] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_implicit] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_interface] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_delegate] = ACTIONS(1334),
    [sym_void_keyword] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [sym_identifier_name] = ACTIONS(1334),
    [sym_comment] = ACTIONS(31),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(1332),
    [anon_sym_bool] = ACTIONS(1334),
    [anon_sym_byte] = ACTIONS(1334),
    [anon_sym_char] = ACTIONS(1334),
    [anon_sym_decimal] = ACTIONS(1334),
    [anon_sym_double] = ACTIONS(1334),
    [anon_sym_float] = ACTIONS(1334),
    [anon_sym_int] = ACTIONS(1334),
    [anon_sym_long] = ACTIONS(1334),
    [anon_sym_object] = ACTIONS(1334),
    [anon_sym_sbyte] = ACTIONS(1334),
    [anon_sym_short] = ACTIONS(1334),
    [anon_sym_string] = ACTIONS(1334),
    [anon_sym_uint] = ACTIONS(1334),
    [anon_sym_ulong] = ACTIONS(1334),
    [anon_sym_ushort] = ACTIONS(1334),
    [anon_sym_abstract] = ACTIONS(1334),
    [anon_sym_async] = ACTIONS(1334),
    [anon_sym_extern] = ACTIONS(1334),
    [anon_sym_internal] = ACTIONS(1334),
    [anon_sym_new] = ACTIONS(1334),
    [anon_sym_override] = ACTIONS(1334),
    [anon_sym_private] = ACTIONS(1334),
    [anon_sym_protected] = ACTIONS(1334),
    [anon_sym_public] = ACTIONS(1334),
    [anon_sym_readonly] = ACTIONS(1334),
    [anon_sym_sealed] = ACTIONS(1334),
    [anon_sym_static] = ACTIONS(1334),
    [anon_sym_unsafe] = ACTIONS(1334),
    [anon_sym_virtual] = ACTIONS(1334),
    [anon_sym_volatile] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_using] = ACTIONS(1334),
    [anon_sym_namespace] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_partial] = ACTIONS(1334),
    [anon_sym_class] = ACTIONS(1334),
    [anon_sym_struct] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_event] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_implicit] = ACTIONS(1334),
    [anon_sym_explicit] = ACTIONS(1334),
    [anon_sym_interface] = ACTIONS(1334),
    [anon_sym_enum] = ACTIONS(1334),
    [anon_sym_delegate] = ACTIONS(1334),
    [sym_void_keyword] = ACTIONS(1334),
    [anon_sym_const] = ACTIONS(1334),
    [sym_identifier_name] = ACTIONS(1334),
    [sym_comment] = ACTIONS(31),
  },
  [462] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [463] = {
    [sym__type_declaration] = STATE(650),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(650),
    [sym_class_declaration] = STATE(650),
    [sym_indexer_declaration] = STATE(650),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(650),
    [sym_operator_declaration] = STATE(650),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(650),
    [sym_struct_declaration] = STATE(650),
    [sym_enum_declaration] = STATE(650),
    [sym_delegate_declaration] = STATE(650),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(650),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(650),
    [sym_constructor_declaration] = STATE(650),
    [sym_destructor_declaration] = STATE(650),
    [sym_method_declaration] = STATE(650),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(650),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(1340),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_byte] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_decimal] = ACTIONS(1342),
    [anon_sym_double] = ACTIONS(1342),
    [anon_sym_float] = ACTIONS(1342),
    [anon_sym_int] = ACTIONS(1342),
    [anon_sym_long] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_sbyte] = ACTIONS(1342),
    [anon_sym_short] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_uint] = ACTIONS(1342),
    [anon_sym_ulong] = ACTIONS(1342),
    [anon_sym_ushort] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym_internal] = ACTIONS(1342),
    [anon_sym_new] = ACTIONS(1342),
    [anon_sym_override] = ACTIONS(1342),
    [anon_sym_private] = ACTIONS(1342),
    [anon_sym_protected] = ACTIONS(1342),
    [anon_sym_public] = ACTIONS(1342),
    [anon_sym_readonly] = ACTIONS(1342),
    [anon_sym_sealed] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_virtual] = ACTIONS(1342),
    [anon_sym_volatile] = ACTIONS(1342),
    [anon_sym_using] = ACTIONS(1342),
    [anon_sym_namespace] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [anon_sym_partial] = ACTIONS(1342),
    [anon_sym_class] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_LBRACK] = ACTIONS(1340),
    [anon_sym_event] = ACTIONS(1342),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_implicit] = ACTIONS(1342),
    [anon_sym_explicit] = ACTIONS(1342),
    [anon_sym_interface] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_delegate] = ACTIONS(1342),
    [sym_void_keyword] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [sym_identifier_name] = ACTIONS(1342),
    [sym_comment] = ACTIONS(31),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(1340),
    [anon_sym_bool] = ACTIONS(1342),
    [anon_sym_byte] = ACTIONS(1342),
    [anon_sym_char] = ACTIONS(1342),
    [anon_sym_decimal] = ACTIONS(1342),
    [anon_sym_double] = ACTIONS(1342),
    [anon_sym_float] = ACTIONS(1342),
    [anon_sym_int] = ACTIONS(1342),
    [anon_sym_long] = ACTIONS(1342),
    [anon_sym_object] = ACTIONS(1342),
    [anon_sym_sbyte] = ACTIONS(1342),
    [anon_sym_short] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_uint] = ACTIONS(1342),
    [anon_sym_ulong] = ACTIONS(1342),
    [anon_sym_ushort] = ACTIONS(1342),
    [anon_sym_abstract] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_extern] = ACTIONS(1342),
    [anon_sym_internal] = ACTIONS(1342),
    [anon_sym_new] = ACTIONS(1342),
    [anon_sym_override] = ACTIONS(1342),
    [anon_sym_private] = ACTIONS(1342),
    [anon_sym_protected] = ACTIONS(1342),
    [anon_sym_public] = ACTIONS(1342),
    [anon_sym_readonly] = ACTIONS(1342),
    [anon_sym_sealed] = ACTIONS(1342),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_unsafe] = ACTIONS(1342),
    [anon_sym_virtual] = ACTIONS(1342),
    [anon_sym_volatile] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_using] = ACTIONS(1342),
    [anon_sym_namespace] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [anon_sym_partial] = ACTIONS(1342),
    [anon_sym_class] = ACTIONS(1342),
    [anon_sym_struct] = ACTIONS(1342),
    [anon_sym_LBRACK] = ACTIONS(1340),
    [anon_sym_event] = ACTIONS(1342),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_implicit] = ACTIONS(1342),
    [anon_sym_explicit] = ACTIONS(1342),
    [anon_sym_interface] = ACTIONS(1342),
    [anon_sym_enum] = ACTIONS(1342),
    [anon_sym_delegate] = ACTIONS(1342),
    [sym_void_keyword] = ACTIONS(1342),
    [anon_sym_const] = ACTIONS(1342),
    [sym_identifier_name] = ACTIONS(1342),
    [sym_comment] = ACTIONS(31),
  },
  [466] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [467] = {
    [sym__type_declaration] = STATE(653),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(653),
    [sym_class_declaration] = STATE(653),
    [sym_indexer_declaration] = STATE(653),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(653),
    [sym_operator_declaration] = STATE(653),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(653),
    [sym_struct_declaration] = STATE(653),
    [sym_enum_declaration] = STATE(653),
    [sym_delegate_declaration] = STATE(653),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(653),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(653),
    [sym_constructor_declaration] = STATE(653),
    [sym_method_declaration] = STATE(653),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(653),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1348),
    [anon_sym_bool] = ACTIONS(1350),
    [anon_sym_byte] = ACTIONS(1350),
    [anon_sym_char] = ACTIONS(1350),
    [anon_sym_decimal] = ACTIONS(1350),
    [anon_sym_double] = ACTIONS(1350),
    [anon_sym_float] = ACTIONS(1350),
    [anon_sym_int] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_object] = ACTIONS(1350),
    [anon_sym_sbyte] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_string] = ACTIONS(1350),
    [anon_sym_uint] = ACTIONS(1350),
    [anon_sym_ulong] = ACTIONS(1350),
    [anon_sym_ushort] = ACTIONS(1350),
    [anon_sym_abstract] = ACTIONS(1350),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym_internal] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(1350),
    [anon_sym_override] = ACTIONS(1350),
    [anon_sym_private] = ACTIONS(1350),
    [anon_sym_protected] = ACTIONS(1350),
    [anon_sym_public] = ACTIONS(1350),
    [anon_sym_readonly] = ACTIONS(1350),
    [anon_sym_sealed] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1350),
    [anon_sym_virtual] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_using] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_partial] = ACTIONS(1350),
    [anon_sym_class] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_event] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_implicit] = ACTIONS(1350),
    [anon_sym_explicit] = ACTIONS(1350),
    [anon_sym_interface] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_delegate] = ACTIONS(1350),
    [sym_void_keyword] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [sym_identifier_name] = ACTIONS(1350),
    [sym_comment] = ACTIONS(31),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(1348),
    [anon_sym_bool] = ACTIONS(1350),
    [anon_sym_byte] = ACTIONS(1350),
    [anon_sym_char] = ACTIONS(1350),
    [anon_sym_decimal] = ACTIONS(1350),
    [anon_sym_double] = ACTIONS(1350),
    [anon_sym_float] = ACTIONS(1350),
    [anon_sym_int] = ACTIONS(1350),
    [anon_sym_long] = ACTIONS(1350),
    [anon_sym_object] = ACTIONS(1350),
    [anon_sym_sbyte] = ACTIONS(1350),
    [anon_sym_short] = ACTIONS(1350),
    [anon_sym_string] = ACTIONS(1350),
    [anon_sym_uint] = ACTIONS(1350),
    [anon_sym_ulong] = ACTIONS(1350),
    [anon_sym_ushort] = ACTIONS(1350),
    [anon_sym_abstract] = ACTIONS(1350),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_extern] = ACTIONS(1350),
    [anon_sym_internal] = ACTIONS(1350),
    [anon_sym_new] = ACTIONS(1350),
    [anon_sym_override] = ACTIONS(1350),
    [anon_sym_private] = ACTIONS(1350),
    [anon_sym_protected] = ACTIONS(1350),
    [anon_sym_public] = ACTIONS(1350),
    [anon_sym_readonly] = ACTIONS(1350),
    [anon_sym_sealed] = ACTIONS(1350),
    [anon_sym_static] = ACTIONS(1350),
    [anon_sym_unsafe] = ACTIONS(1350),
    [anon_sym_virtual] = ACTIONS(1350),
    [anon_sym_volatile] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1352),
    [anon_sym_using] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_partial] = ACTIONS(1350),
    [anon_sym_class] = ACTIONS(1350),
    [anon_sym_struct] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_event] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_implicit] = ACTIONS(1350),
    [anon_sym_explicit] = ACTIONS(1350),
    [anon_sym_interface] = ACTIONS(1350),
    [anon_sym_enum] = ACTIONS(1350),
    [anon_sym_delegate] = ACTIONS(1350),
    [sym_void_keyword] = ACTIONS(1350),
    [anon_sym_const] = ACTIONS(1350),
    [sym_identifier_name] = ACTIONS(1350),
    [sym_comment] = ACTIONS(31),
  },
  [470] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [471] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(656),
    [sym_interface_event_declaration] = STATE(656),
    [sym_interface_property_declaration] = STATE(656),
    [sym_interface_indexer_declaration] = STATE(656),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(656),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [472] = {
    [sym_statement_block] = STATE(657),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [473] = {
    [sym_parameter_list] = STATE(658),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [474] = {
    [sym_type_parameter_constraints_clause] = STATE(660),
    [sym_statement_block] = STATE(659),
    [aux_sym_class_declaration_repeat1] = STATE(660),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [475] = {
    [sym_add_accessor_declaration] = STATE(663),
    [sym_remove_accessor_declaration] = STATE(664),
    [sym__attributes] = STATE(665),
    [sym__attribute_section] = STATE(666),
    [aux_sym__attributes_repeat1] = STATE(666),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(1356),
    [anon_sym_remove] = ACTIONS(1358),
    [sym_comment] = ACTIONS(31),
  },
  [476] = {
    [anon_sym_bool] = ACTIONS(1360),
    [anon_sym_byte] = ACTIONS(1360),
    [anon_sym_char] = ACTIONS(1360),
    [anon_sym_decimal] = ACTIONS(1360),
    [anon_sym_double] = ACTIONS(1360),
    [anon_sym_float] = ACTIONS(1360),
    [anon_sym_int] = ACTIONS(1360),
    [anon_sym_long] = ACTIONS(1360),
    [anon_sym_object] = ACTIONS(1360),
    [anon_sym_sbyte] = ACTIONS(1360),
    [anon_sym_short] = ACTIONS(1360),
    [anon_sym_string] = ACTIONS(1360),
    [anon_sym_uint] = ACTIONS(1360),
    [anon_sym_ulong] = ACTIONS(1360),
    [anon_sym_ushort] = ACTIONS(1360),
    [anon_sym_abstract] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_extern] = ACTIONS(1360),
    [anon_sym_internal] = ACTIONS(1360),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_override] = ACTIONS(1360),
    [anon_sym_private] = ACTIONS(1360),
    [anon_sym_protected] = ACTIONS(1360),
    [anon_sym_public] = ACTIONS(1360),
    [anon_sym_readonly] = ACTIONS(1360),
    [anon_sym_sealed] = ACTIONS(1360),
    [anon_sym_static] = ACTIONS(1360),
    [anon_sym_unsafe] = ACTIONS(1360),
    [anon_sym_virtual] = ACTIONS(1360),
    [anon_sym_volatile] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [anon_sym_partial] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(1360),
    [anon_sym_struct] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_event] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_implicit] = ACTIONS(1360),
    [anon_sym_explicit] = ACTIONS(1360),
    [anon_sym_interface] = ACTIONS(1360),
    [anon_sym_enum] = ACTIONS(1360),
    [anon_sym_delegate] = ACTIONS(1360),
    [sym_void_keyword] = ACTIONS(1360),
    [anon_sym_const] = ACTIONS(1360),
    [sym_identifier_name] = ACTIONS(1360),
    [sym_comment] = ACTIONS(31),
  },
  [477] = {
    [anon_sym_bool] = ACTIONS(1364),
    [anon_sym_byte] = ACTIONS(1364),
    [anon_sym_char] = ACTIONS(1364),
    [anon_sym_decimal] = ACTIONS(1364),
    [anon_sym_double] = ACTIONS(1364),
    [anon_sym_float] = ACTIONS(1364),
    [anon_sym_int] = ACTIONS(1364),
    [anon_sym_long] = ACTIONS(1364),
    [anon_sym_object] = ACTIONS(1364),
    [anon_sym_sbyte] = ACTIONS(1364),
    [anon_sym_short] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [anon_sym_uint] = ACTIONS(1364),
    [anon_sym_ulong] = ACTIONS(1364),
    [anon_sym_ushort] = ACTIONS(1364),
    [anon_sym_abstract] = ACTIONS(1364),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_extern] = ACTIONS(1364),
    [anon_sym_internal] = ACTIONS(1364),
    [anon_sym_new] = ACTIONS(1364),
    [anon_sym_override] = ACTIONS(1364),
    [anon_sym_private] = ACTIONS(1364),
    [anon_sym_protected] = ACTIONS(1364),
    [anon_sym_public] = ACTIONS(1364),
    [anon_sym_readonly] = ACTIONS(1364),
    [anon_sym_sealed] = ACTIONS(1364),
    [anon_sym_static] = ACTIONS(1364),
    [anon_sym_unsafe] = ACTIONS(1364),
    [anon_sym_virtual] = ACTIONS(1364),
    [anon_sym_volatile] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_partial] = ACTIONS(1364),
    [anon_sym_class] = ACTIONS(1364),
    [anon_sym_struct] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_event] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_implicit] = ACTIONS(1364),
    [anon_sym_explicit] = ACTIONS(1364),
    [anon_sym_interface] = ACTIONS(1364),
    [anon_sym_enum] = ACTIONS(1364),
    [anon_sym_delegate] = ACTIONS(1364),
    [sym_void_keyword] = ACTIONS(1364),
    [anon_sym_const] = ACTIONS(1364),
    [sym_identifier_name] = ACTIONS(1364),
    [sym_comment] = ACTIONS(31),
  },
  [478] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [sym_statement_block] = STATE(659),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [479] = {
    [sym__expression] = STATE(667),
    [sym_constant_expression] = STATE(668),
    [sym_parenthesized_expression] = STATE(667),
    [sym_ternary_expression] = STATE(667),
    [sym_binary_expression] = STATE(667),
    [sym_unary_expression] = STATE(667),
    [sym__literal] = STATE(667),
    [sym_boolean_literal] = STATE(667),
    [sym_character_literal] = STATE(667),
    [sym_integer_literal] = STATE(667),
    [sym_real_literal] = STATE(667),
    [sym_string_literal] = STATE(667),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1368),
    [sym_comment] = ACTIONS(31),
  },
  [480] = {
    [anon_sym_bool] = ACTIONS(1370),
    [anon_sym_byte] = ACTIONS(1370),
    [anon_sym_char] = ACTIONS(1370),
    [anon_sym_decimal] = ACTIONS(1370),
    [anon_sym_double] = ACTIONS(1370),
    [anon_sym_float] = ACTIONS(1370),
    [anon_sym_int] = ACTIONS(1370),
    [anon_sym_long] = ACTIONS(1370),
    [anon_sym_object] = ACTIONS(1370),
    [anon_sym_sbyte] = ACTIONS(1370),
    [anon_sym_short] = ACTIONS(1370),
    [anon_sym_string] = ACTIONS(1370),
    [anon_sym_uint] = ACTIONS(1370),
    [anon_sym_ulong] = ACTIONS(1370),
    [anon_sym_ushort] = ACTIONS(1370),
    [anon_sym_abstract] = ACTIONS(1370),
    [anon_sym_async] = ACTIONS(1370),
    [anon_sym_extern] = ACTIONS(1370),
    [anon_sym_internal] = ACTIONS(1370),
    [anon_sym_new] = ACTIONS(1370),
    [anon_sym_override] = ACTIONS(1370),
    [anon_sym_private] = ACTIONS(1370),
    [anon_sym_protected] = ACTIONS(1370),
    [anon_sym_public] = ACTIONS(1370),
    [anon_sym_readonly] = ACTIONS(1370),
    [anon_sym_sealed] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1370),
    [anon_sym_unsafe] = ACTIONS(1370),
    [anon_sym_virtual] = ACTIONS(1370),
    [anon_sym_volatile] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_partial] = ACTIONS(1370),
    [anon_sym_class] = ACTIONS(1370),
    [anon_sym_struct] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_event] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_implicit] = ACTIONS(1370),
    [anon_sym_explicit] = ACTIONS(1370),
    [anon_sym_interface] = ACTIONS(1370),
    [anon_sym_enum] = ACTIONS(1370),
    [anon_sym_delegate] = ACTIONS(1370),
    [sym_void_keyword] = ACTIONS(1370),
    [anon_sym_const] = ACTIONS(1370),
    [sym_identifier_name] = ACTIONS(1370),
    [sym_comment] = ACTIONS(31),
  },
  [481] = {
    [sym_constant_declarator] = STATE(669),
    [sym_identifier_name] = ACTIONS(601),
    [sym_comment] = ACTIONS(31),
  },
  [482] = {
    [aux_sym__constant_declarators_repeat1] = STATE(670),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(1374),
    [sym_comment] = ACTIONS(31),
  },
  [483] = {
    [anon_sym_bool] = ACTIONS(1376),
    [anon_sym_byte] = ACTIONS(1376),
    [anon_sym_char] = ACTIONS(1376),
    [anon_sym_decimal] = ACTIONS(1376),
    [anon_sym_double] = ACTIONS(1376),
    [anon_sym_float] = ACTIONS(1376),
    [anon_sym_int] = ACTIONS(1376),
    [anon_sym_long] = ACTIONS(1376),
    [anon_sym_object] = ACTIONS(1376),
    [anon_sym_sbyte] = ACTIONS(1376),
    [anon_sym_short] = ACTIONS(1376),
    [anon_sym_string] = ACTIONS(1376),
    [anon_sym_uint] = ACTIONS(1376),
    [anon_sym_ulong] = ACTIONS(1376),
    [anon_sym_ushort] = ACTIONS(1376),
    [anon_sym_abstract] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1376),
    [anon_sym_extern] = ACTIONS(1376),
    [anon_sym_internal] = ACTIONS(1376),
    [anon_sym_new] = ACTIONS(1376),
    [anon_sym_override] = ACTIONS(1376),
    [anon_sym_private] = ACTIONS(1376),
    [anon_sym_protected] = ACTIONS(1376),
    [anon_sym_public] = ACTIONS(1376),
    [anon_sym_readonly] = ACTIONS(1376),
    [anon_sym_sealed] = ACTIONS(1376),
    [anon_sym_static] = ACTIONS(1376),
    [anon_sym_unsafe] = ACTIONS(1376),
    [anon_sym_virtual] = ACTIONS(1376),
    [anon_sym_volatile] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [anon_sym_partial] = ACTIONS(1376),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_struct] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1378),
    [anon_sym_event] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1378),
    [anon_sym_implicit] = ACTIONS(1376),
    [anon_sym_explicit] = ACTIONS(1376),
    [anon_sym_interface] = ACTIONS(1376),
    [anon_sym_enum] = ACTIONS(1376),
    [anon_sym_delegate] = ACTIONS(1376),
    [sym_void_keyword] = ACTIONS(1376),
    [anon_sym_const] = ACTIONS(1376),
    [sym_identifier_name] = ACTIONS(1376),
    [sym_comment] = ACTIONS(31),
  },
  [484] = {
    [sym_identifier_name] = ACTIONS(1380),
    [sym_comment] = ACTIONS(31),
  },
  [485] = {
    [anon_sym_RBRACK] = ACTIONS(1382),
    [sym_comment] = ACTIONS(31),
  },
  [486] = {
    [sym_parameter_array] = STATE(441),
    [sym__attributes] = STATE(442),
    [sym__attribute_section] = STATE(444),
    [aux_sym__formal_parameter_list_repeat1] = STATE(674),
    [aux_sym__attributes_repeat1] = STATE(444),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_RBRACK] = ACTIONS(928),
    [anon_sym_params] = ACTIONS(932),
    [sym_comment] = ACTIONS(31),
  },
  [487] = {
    [sym__type] = STATE(675),
    [sym_predefined_type] = STATE(675),
    [sym_generic_name] = STATE(675),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [488] = {
    [sym__type] = STATE(675),
    [sym_predefined_type] = STATE(675),
    [sym_parameter_modifier] = STATE(676),
    [sym_generic_name] = STATE(675),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(934),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [489] = {
    [sym__type] = STATE(677),
    [sym_predefined_type] = STATE(677),
    [sym_generic_name] = STATE(677),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [490] = {
    [sym__type] = STATE(678),
    [sym_predefined_type] = STATE(678),
    [sym_generic_name] = STATE(678),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [491] = {
    [sym__expression] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_ternary_expression] = STATE(523),
    [sym_binary_expression] = STATE(523),
    [sym_unary_expression] = STATE(523),
    [sym__literal] = STATE(523),
    [sym_boolean_literal] = STATE(523),
    [sym_character_literal] = STATE(523),
    [sym_integer_literal] = STATE(523),
    [sym_real_literal] = STATE(523),
    [sym_string_literal] = STATE(523),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1074),
    [sym_comment] = ACTIONS(31),
  },
  [492] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1412),
    [sym_comment] = ACTIONS(31),
  },
  [493] = {
    [anon_sym_RBRACE] = ACTIONS(1414),
    [sym_comment] = ACTIONS(31),
  },
  [494] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [495] = {
    [anon_sym_LBRACK] = ACTIONS(1418),
    [sym_comment] = ACTIONS(31),
  },
  [496] = {
    [sym_equals_value_clause] = STATE(334),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_EQ] = ACTIONS(1420),
    [sym_comment] = ACTIONS(31),
  },
  [497] = {
    [anon_sym_COMMA] = ACTIONS(1422),
    [anon_sym_SEMI] = ACTIONS(1422),
    [sym_comment] = ACTIONS(31),
  },
  [498] = {
    [aux_sym_variable_declaration_repeat1] = STATE(498),
    [anon_sym_COMMA] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1422),
    [sym_comment] = ACTIONS(31),
  },
  [499] = {
    [sym_type_parameter_list] = STATE(692),
    [sym_parameter_list] = STATE(658),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [500] = {
    [anon_sym_LBRACE] = ACTIONS(1427),
    [sym_comment] = ACTIONS(31),
  },
  [501] = {
    [anon_sym_SEMI] = ACTIONS(1429),
    [sym_comment] = ACTIONS(31),
  },
  [502] = {
    [sym_statement_block] = STATE(695),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [503] = {
    [anon_sym_bool] = ACTIONS(1431),
    [anon_sym_byte] = ACTIONS(1431),
    [anon_sym_char] = ACTIONS(1431),
    [anon_sym_decimal] = ACTIONS(1431),
    [anon_sym_double] = ACTIONS(1431),
    [anon_sym_float] = ACTIONS(1431),
    [anon_sym_int] = ACTIONS(1431),
    [anon_sym_long] = ACTIONS(1431),
    [anon_sym_object] = ACTIONS(1431),
    [anon_sym_sbyte] = ACTIONS(1431),
    [anon_sym_short] = ACTIONS(1431),
    [anon_sym_string] = ACTIONS(1431),
    [anon_sym_uint] = ACTIONS(1431),
    [anon_sym_ulong] = ACTIONS(1431),
    [anon_sym_ushort] = ACTIONS(1431),
    [anon_sym_abstract] = ACTIONS(1431),
    [anon_sym_async] = ACTIONS(1431),
    [anon_sym_extern] = ACTIONS(1431),
    [anon_sym_internal] = ACTIONS(1431),
    [anon_sym_new] = ACTIONS(1431),
    [anon_sym_override] = ACTIONS(1431),
    [anon_sym_private] = ACTIONS(1431),
    [anon_sym_protected] = ACTIONS(1431),
    [anon_sym_public] = ACTIONS(1431),
    [anon_sym_readonly] = ACTIONS(1431),
    [anon_sym_sealed] = ACTIONS(1431),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_unsafe] = ACTIONS(1431),
    [anon_sym_virtual] = ACTIONS(1431),
    [anon_sym_volatile] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_partial] = ACTIONS(1431),
    [anon_sym_class] = ACTIONS(1431),
    [anon_sym_struct] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_event] = ACTIONS(1431),
    [anon_sym_TILDE] = ACTIONS(1433),
    [anon_sym_implicit] = ACTIONS(1431),
    [anon_sym_explicit] = ACTIONS(1431),
    [anon_sym_interface] = ACTIONS(1431),
    [anon_sym_enum] = ACTIONS(1431),
    [anon_sym_delegate] = ACTIONS(1431),
    [sym_void_keyword] = ACTIONS(1431),
    [anon_sym_const] = ACTIONS(1431),
    [sym_identifier_name] = ACTIONS(1431),
    [sym_comment] = ACTIONS(31),
  },
  [504] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [505] = {
    [anon_sym_get] = ACTIONS(1437),
    [anon_sym_set] = ACTIONS(1437),
    [sym_comment] = ACTIONS(31),
  },
  [506] = {
    [anon_sym_internal] = ACTIONS(1439),
    [anon_sym_private] = ACTIONS(1439),
    [anon_sym_protected] = ACTIONS(1439),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [anon_sym_set] = ACTIONS(1439),
    [anon_sym_LBRACK] = ACTIONS(1439),
    [sym_comment] = ACTIONS(31),
  },
  [507] = {
    [anon_sym_internal] = ACTIONS(1441),
    [anon_sym_private] = ACTIONS(1441),
    [anon_sym_protected] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_get] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [sym_comment] = ACTIONS(31),
  },
  [508] = {
    [anon_sym_bool] = ACTIONS(1443),
    [anon_sym_byte] = ACTIONS(1443),
    [anon_sym_char] = ACTIONS(1443),
    [anon_sym_decimal] = ACTIONS(1443),
    [anon_sym_double] = ACTIONS(1443),
    [anon_sym_float] = ACTIONS(1443),
    [anon_sym_int] = ACTIONS(1443),
    [anon_sym_long] = ACTIONS(1443),
    [anon_sym_object] = ACTIONS(1443),
    [anon_sym_sbyte] = ACTIONS(1443),
    [anon_sym_short] = ACTIONS(1443),
    [anon_sym_string] = ACTIONS(1443),
    [anon_sym_uint] = ACTIONS(1443),
    [anon_sym_ulong] = ACTIONS(1443),
    [anon_sym_ushort] = ACTIONS(1443),
    [anon_sym_abstract] = ACTIONS(1443),
    [anon_sym_async] = ACTIONS(1443),
    [anon_sym_extern] = ACTIONS(1443),
    [anon_sym_internal] = ACTIONS(1443),
    [anon_sym_new] = ACTIONS(1443),
    [anon_sym_override] = ACTIONS(1443),
    [anon_sym_private] = ACTIONS(1443),
    [anon_sym_protected] = ACTIONS(1443),
    [anon_sym_public] = ACTIONS(1443),
    [anon_sym_readonly] = ACTIONS(1443),
    [anon_sym_sealed] = ACTIONS(1443),
    [anon_sym_static] = ACTIONS(1443),
    [anon_sym_unsafe] = ACTIONS(1443),
    [anon_sym_virtual] = ACTIONS(1443),
    [anon_sym_volatile] = ACTIONS(1443),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_partial] = ACTIONS(1443),
    [anon_sym_class] = ACTIONS(1443),
    [anon_sym_struct] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_event] = ACTIONS(1443),
    [anon_sym_TILDE] = ACTIONS(1445),
    [anon_sym_implicit] = ACTIONS(1443),
    [anon_sym_explicit] = ACTIONS(1443),
    [anon_sym_interface] = ACTIONS(1443),
    [anon_sym_enum] = ACTIONS(1443),
    [anon_sym_delegate] = ACTIONS(1443),
    [sym_void_keyword] = ACTIONS(1443),
    [anon_sym_const] = ACTIONS(1443),
    [sym_identifier_name] = ACTIONS(1443),
    [sym_comment] = ACTIONS(31),
  },
  [509] = {
    [anon_sym_RBRACE] = ACTIONS(1447),
    [sym_comment] = ACTIONS(31),
  },
  [510] = {
    [anon_sym_set] = ACTIONS(1064),
    [sym_comment] = ACTIONS(31),
  },
  [511] = {
    [sym_accessor_modifier] = STATE(697),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(649),
    [anon_sym_set] = ACTIONS(1064),
    [sym_comment] = ACTIONS(31),
  },
  [512] = {
    [sym__attribute_section] = STATE(698),
    [aux_sym__attributes_repeat1] = STATE(698),
    [anon_sym_internal] = ACTIONS(85),
    [anon_sym_private] = ACTIONS(85),
    [anon_sym_protected] = ACTIONS(85),
    [anon_sym_set] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [513] = {
    [anon_sym_get] = ACTIONS(1062),
    [sym_comment] = ACTIONS(31),
  },
  [514] = {
    [sym_accessor_modifier] = STATE(699),
    [anon_sym_internal] = ACTIONS(645),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(649),
    [anon_sym_get] = ACTIONS(1062),
    [sym_comment] = ACTIONS(31),
  },
  [515] = {
    [sym__attribute_section] = STATE(700),
    [aux_sym__attributes_repeat1] = STATE(700),
    [anon_sym_internal] = ACTIONS(85),
    [anon_sym_private] = ACTIONS(85),
    [anon_sym_protected] = ACTIONS(85),
    [anon_sym_get] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [516] = {
    [sym_statement_block] = STATE(701),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [517] = {
    [sym_statement_block] = STATE(702),
    [anon_sym_SEMI] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [518] = {
    [anon_sym_get] = ACTIONS(1453),
    [anon_sym_set] = ACTIONS(1455),
    [sym_comment] = ACTIONS(31),
  },
  [519] = {
    [sym__attribute_section] = STATE(519),
    [aux_sym__attributes_repeat1] = STATE(519),
    [anon_sym_internal] = ACTIONS(218),
    [anon_sym_private] = ACTIONS(218),
    [anon_sym_protected] = ACTIONS(218),
    [anon_sym_get] = ACTIONS(218),
    [anon_sym_set] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(220),
    [sym_comment] = ACTIONS(31),
  },
  [520] = {
    [sym__expression] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_ternary_expression] = STATE(523),
    [sym_binary_expression] = STATE(523),
    [sym_unary_expression] = STATE(523),
    [sym__literal] = STATE(523),
    [sym_boolean_literal] = STATE(523),
    [sym_character_literal] = STATE(523),
    [sym_integer_literal] = STATE(523),
    [sym_real_literal] = STATE(523),
    [sym_string_literal] = STATE(523),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1074),
    [sym_comment] = ACTIONS(31),
  },
  [521] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [522] = {
    [anon_sym_LT] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_COLON] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_RBRACK] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(1485),
    [anon_sym_LT_LT] = ACTIONS(1487),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_GT_EQ] = ACTIONS(1487),
    [anon_sym_LT_EQ] = ACTIONS(1487),
    [anon_sym_params] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1487),
    [anon_sym_AMP_AMP] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE] = ACTIONS(1487),
    [sym__real_type_suffix] = ACTIONS(1489),
    [sym__exponent_part] = ACTIONS(1491),
    [sym_comment] = ACTIONS(31),
  },
  [523] = {
    [anon_sym_LT] = ACTIONS(1493),
    [anon_sym_COMMA] = ACTIONS(1495),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1495),
    [anon_sym_RBRACE] = ACTIONS(1495),
    [anon_sym_COLON] = ACTIONS(1495),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1495),
    [anon_sym_RBRACK] = ACTIONS(1495),
    [anon_sym_PLUS] = ACTIONS(1495),
    [anon_sym_DASH] = ACTIONS(1495),
    [anon_sym_STAR] = ACTIONS(1495),
    [anon_sym_SLASH] = ACTIONS(1493),
    [anon_sym_PERCENT] = ACTIONS(1495),
    [anon_sym_CARET] = ACTIONS(1495),
    [anon_sym_PIPE] = ACTIONS(1493),
    [anon_sym_AMP] = ACTIONS(1493),
    [anon_sym_LT_LT] = ACTIONS(1495),
    [anon_sym_GT_GT] = ACTIONS(1495),
    [anon_sym_EQ_EQ] = ACTIONS(1495),
    [anon_sym_BANG_EQ] = ACTIONS(1495),
    [anon_sym_GT_EQ] = ACTIONS(1495),
    [anon_sym_LT_EQ] = ACTIONS(1495),
    [anon_sym_params] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(1495),
    [anon_sym_AMP_AMP] = ACTIONS(1495),
    [anon_sym_PIPE_PIPE] = ACTIONS(1495),
    [sym_comment] = ACTIONS(31),
  },
  [524] = {
    [anon_sym_SQUOTE] = ACTIONS(1497),
    [sym_comment] = ACTIONS(31),
  },
  [525] = {
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1499),
    [sym_comment] = ACTIONS(31),
  },
  [526] = {
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_GT] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym_RBRACE] = ACTIONS(1503),
    [anon_sym_COLON] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1503),
    [anon_sym_LBRACK] = ACTIONS(1503),
    [anon_sym_RBRACK] = ACTIONS(1503),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_DASH] = ACTIONS(1503),
    [anon_sym_STAR] = ACTIONS(1503),
    [anon_sym_SLASH] = ACTIONS(1501),
    [anon_sym_PERCENT] = ACTIONS(1503),
    [anon_sym_CARET] = ACTIONS(1503),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(1503),
    [anon_sym_GT_GT] = ACTIONS(1503),
    [anon_sym_EQ_EQ] = ACTIONS(1503),
    [anon_sym_BANG_EQ] = ACTIONS(1503),
    [anon_sym_GT_EQ] = ACTIONS(1503),
    [anon_sym_LT_EQ] = ACTIONS(1503),
    [anon_sym_params] = ACTIONS(1503),
    [anon_sym_QMARK] = ACTIONS(1503),
    [anon_sym_AMP_AMP] = ACTIONS(1503),
    [anon_sym_PIPE_PIPE] = ACTIONS(1503),
    [sym_comment] = ACTIONS(31),
  },
  [527] = {
    [anon_sym_LT] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_COLON] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_RBRACK] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(1485),
    [anon_sym_LT_LT] = ACTIONS(1487),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_GT_EQ] = ACTIONS(1487),
    [anon_sym_LT_EQ] = ACTIONS(1487),
    [anon_sym_params] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1487),
    [anon_sym_AMP_AMP] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE] = ACTIONS(1487),
    [sym_comment] = ACTIONS(31),
  },
  [528] = {
    [anon_sym_LT] = ACTIONS(1485),
    [anon_sym_COMMA] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_COLON] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_RBRACK] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1485),
    [anon_sym_PERCENT] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1485),
    [anon_sym_AMP] = ACTIONS(1485),
    [anon_sym_LT_LT] = ACTIONS(1487),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_GT_EQ] = ACTIONS(1487),
    [anon_sym_LT_EQ] = ACTIONS(1487),
    [anon_sym_params] = ACTIONS(1487),
    [anon_sym_QMARK] = ACTIONS(1487),
    [anon_sym_AMP_AMP] = ACTIONS(1487),
    [anon_sym_PIPE_PIPE] = ACTIONS(1487),
    [sym__real_type_suffix] = ACTIONS(1489),
    [sym_comment] = ACTIONS(31),
  },
  [529] = {
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_COMMA] = ACTIONS(1507),
    [anon_sym_GT] = ACTIONS(1505),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_RBRACE] = ACTIONS(1507),
    [anon_sym_COLON] = ACTIONS(1507),
    [anon_sym_RPAREN] = ACTIONS(1507),
    [anon_sym_LBRACK] = ACTIONS(1507),
    [anon_sym_RBRACK] = ACTIONS(1507),
    [anon_sym_PLUS] = ACTIONS(1507),
    [anon_sym_DASH] = ACTIONS(1507),
    [anon_sym_STAR] = ACTIONS(1507),
    [anon_sym_SLASH] = ACTIONS(1505),
    [anon_sym_PERCENT] = ACTIONS(1507),
    [anon_sym_CARET] = ACTIONS(1507),
    [anon_sym_PIPE] = ACTIONS(1505),
    [anon_sym_AMP] = ACTIONS(1505),
    [anon_sym_LT_LT] = ACTIONS(1507),
    [anon_sym_GT_GT] = ACTIONS(1507),
    [anon_sym_EQ_EQ] = ACTIONS(1507),
    [anon_sym_BANG_EQ] = ACTIONS(1507),
    [anon_sym_GT_EQ] = ACTIONS(1507),
    [anon_sym_LT_EQ] = ACTIONS(1507),
    [anon_sym_params] = ACTIONS(1507),
    [anon_sym_QMARK] = ACTIONS(1507),
    [anon_sym_AMP_AMP] = ACTIONS(1507),
    [anon_sym_PIPE_PIPE] = ACTIONS(1507),
    [sym_comment] = ACTIONS(31),
  },
  [530] = {
    [sym__unicode_escape_sequence] = STATE(721),
    [sym__simple_escape_sequence] = STATE(721),
    [sym__regular_string_literal_character] = STATE(721),
    [aux_sym__regular_string_literal_repeat1] = STATE(721),
    [sym__hexadecimal_escape_sequence] = ACTIONS(1509),
    [aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1509),
    [aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1509),
    [anon_sym_BSLASH_SQUOTE] = ACTIONS(1509),
    [anon_sym_BSLASH_DQUOTE] = ACTIONS(1509),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1509),
    [anon_sym_BSLASH0] = ACTIONS(1509),
    [anon_sym_BSLASHa] = ACTIONS(1509),
    [anon_sym_BSLASHb] = ACTIONS(1509),
    [anon_sym_BSLASHf] = ACTIONS(1509),
    [anon_sym_BSLASHn] = ACTIONS(1509),
    [anon_sym_BSLASHr] = ACTIONS(1509),
    [anon_sym_BSLASHt] = ACTIONS(1509),
    [anon_sym_BSLASHv] = ACTIONS(1509),
    [anon_sym_DQUOTE] = ACTIONS(1511),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH] = ACTIONS(1509),
    [sym_comment] = ACTIONS(1082),
  },
  [531] = {
    [anon_sym_DQUOTE] = ACTIONS(1513),
    [sym_comment] = ACTIONS(31),
  },
  [532] = {
    [sym__expression] = STATE(723),
    [sym_parenthesized_expression] = STATE(723),
    [sym_ternary_expression] = STATE(723),
    [sym_binary_expression] = STATE(723),
    [sym_unary_expression] = STATE(723),
    [sym__literal] = STATE(723),
    [sym_boolean_literal] = STATE(723),
    [sym_character_literal] = STATE(723),
    [sym_integer_literal] = STATE(723),
    [sym_real_literal] = STATE(723),
    [sym_string_literal] = STATE(723),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1515),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1515),
    [sym_comment] = ACTIONS(31),
  },
  [533] = {
    [sym__expression] = STATE(724),
    [sym_parenthesized_expression] = STATE(724),
    [sym_ternary_expression] = STATE(724),
    [sym_binary_expression] = STATE(724),
    [sym_unary_expression] = STATE(724),
    [sym__literal] = STATE(724),
    [sym_boolean_literal] = STATE(724),
    [sym_character_literal] = STATE(724),
    [sym_integer_literal] = STATE(724),
    [sym_real_literal] = STATE(724),
    [sym_string_literal] = STATE(724),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1517),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1517),
    [sym_comment] = ACTIONS(31),
  },
  [534] = {
    [sym__expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym__literal] = STATE(725),
    [sym_boolean_literal] = STATE(725),
    [sym_character_literal] = STATE(725),
    [sym_integer_literal] = STATE(725),
    [sym_real_literal] = STATE(725),
    [sym_string_literal] = STATE(725),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1519),
    [sym_comment] = ACTIONS(31),
  },
  [535] = {
    [sym__expression] = STATE(726),
    [sym_parenthesized_expression] = STATE(726),
    [sym_ternary_expression] = STATE(726),
    [sym_binary_expression] = STATE(726),
    [sym_unary_expression] = STATE(726),
    [sym__literal] = STATE(726),
    [sym_boolean_literal] = STATE(726),
    [sym_character_literal] = STATE(726),
    [sym_integer_literal] = STATE(726),
    [sym_real_literal] = STATE(726),
    [sym_string_literal] = STATE(726),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1521),
    [sym_comment] = ACTIONS(31),
  },
  [536] = {
    [sym__expression] = STATE(727),
    [sym_parenthesized_expression] = STATE(727),
    [sym_ternary_expression] = STATE(727),
    [sym_binary_expression] = STATE(727),
    [sym_unary_expression] = STATE(727),
    [sym__literal] = STATE(727),
    [sym_boolean_literal] = STATE(727),
    [sym_character_literal] = STATE(727),
    [sym_integer_literal] = STATE(727),
    [sym_real_literal] = STATE(727),
    [sym_string_literal] = STATE(727),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1523),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1523),
    [sym_comment] = ACTIONS(31),
  },
  [537] = {
    [sym__expression] = STATE(728),
    [sym_parenthesized_expression] = STATE(728),
    [sym_ternary_expression] = STATE(728),
    [sym_binary_expression] = STATE(728),
    [sym_unary_expression] = STATE(728),
    [sym__literal] = STATE(728),
    [sym_boolean_literal] = STATE(728),
    [sym_character_literal] = STATE(728),
    [sym_integer_literal] = STATE(728),
    [sym_real_literal] = STATE(728),
    [sym_string_literal] = STATE(728),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1525),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1525),
    [sym_comment] = ACTIONS(31),
  },
  [538] = {
    [sym__expression] = STATE(729),
    [sym_parenthesized_expression] = STATE(729),
    [sym_ternary_expression] = STATE(729),
    [sym_binary_expression] = STATE(729),
    [sym_unary_expression] = STATE(729),
    [sym__literal] = STATE(729),
    [sym_boolean_literal] = STATE(729),
    [sym_character_literal] = STATE(729),
    [sym_integer_literal] = STATE(729),
    [sym_real_literal] = STATE(729),
    [sym_string_literal] = STATE(729),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1527),
    [sym_comment] = ACTIONS(31),
  },
  [539] = {
    [sym__expression] = STATE(731),
    [sym_parenthesized_expression] = STATE(731),
    [sym_ternary_expression] = STATE(731),
    [sym_binary_expression] = STATE(731),
    [sym_unary_expression] = STATE(731),
    [sym__literal] = STATE(731),
    [sym_boolean_literal] = STATE(731),
    [sym_character_literal] = STATE(731),
    [sym_integer_literal] = STATE(731),
    [sym_real_literal] = STATE(731),
    [sym_string_literal] = STATE(731),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1533),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1533),
    [sym_comment] = ACTIONS(31),
  },
  [540] = {
    [sym__expression] = STATE(732),
    [sym_parenthesized_expression] = STATE(732),
    [sym_ternary_expression] = STATE(732),
    [sym_binary_expression] = STATE(732),
    [sym_unary_expression] = STATE(732),
    [sym__literal] = STATE(732),
    [sym_boolean_literal] = STATE(732),
    [sym_character_literal] = STATE(732),
    [sym_integer_literal] = STATE(732),
    [sym_real_literal] = STATE(732),
    [sym_string_literal] = STATE(732),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1535),
    [sym_comment] = ACTIONS(31),
  },
  [541] = {
    [sym__expression] = STATE(733),
    [sym_parenthesized_expression] = STATE(733),
    [sym_ternary_expression] = STATE(733),
    [sym_binary_expression] = STATE(733),
    [sym_unary_expression] = STATE(733),
    [sym__literal] = STATE(733),
    [sym_boolean_literal] = STATE(733),
    [sym_character_literal] = STATE(733),
    [sym_integer_literal] = STATE(733),
    [sym_real_literal] = STATE(733),
    [sym_string_literal] = STATE(733),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1537),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1537),
    [sym_comment] = ACTIONS(31),
  },
  [542] = {
    [sym__constant_declarators] = STATE(734),
    [sym_constant_declarator] = STATE(320),
    [sym_identifier_name] = ACTIONS(601),
    [sym_comment] = ACTIONS(31),
  },
  [543] = {
    [sym__expression] = STATE(735),
    [sym_parenthesized_expression] = STATE(735),
    [sym_ternary_expression] = STATE(735),
    [sym_binary_expression] = STATE(735),
    [sym_unary_expression] = STATE(735),
    [sym__literal] = STATE(735),
    [sym_boolean_literal] = STATE(735),
    [sym_character_literal] = STATE(735),
    [sym_integer_literal] = STATE(735),
    [sym_real_literal] = STATE(735),
    [sym_string_literal] = STATE(735),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1539),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1539),
    [sym_comment] = ACTIONS(31),
  },
  [544] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(736),
    [sym_variable_assignment_statement] = STATE(736),
    [sym_statement_block] = STATE(736),
    [sym__labeled_statement] = STATE(736),
    [sym__embedded_statement] = STATE(736),
    [sym_empty_statement] = STATE(736),
    [sym_expression_statement] = STATE(736),
    [sym__selection_statement] = STATE(736),
    [sym__iteration_statement] = STATE(736),
    [sym__jump_statement] = STATE(736),
    [sym_try_statement] = STATE(736),
    [sym_checked_statement] = STATE(736),
    [sym_unchecked_statement] = STATE(736),
    [sym_lock_statement] = STATE(736),
    [sym_yield_statement] = STATE(736),
    [sym_if_statement] = STATE(736),
    [sym_switch_statement] = STATE(736),
    [sym_while_statement] = STATE(736),
    [sym_do_statement] = STATE(736),
    [sym_break_statement] = STATE(736),
    [sym_continue_statement] = STATE(736),
    [sym_return_statement] = STATE(736),
    [sym_throw_statement] = STATE(736),
    [sym_goto_statement] = STATE(736),
    [sym__declaration_statement] = STATE(736),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(689),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(693),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(701),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(723),
  },
  [545] = {
    [anon_sym_SEMI] = ACTIONS(1541),
    [sym_comment] = ACTIONS(31),
  },
  [546] = {
    [sym_catch_clause] = STATE(741),
    [sym_finally_clause] = STATE(740),
    [aux_sym_try_statement_repeat1] = STATE(741),
    [anon_sym_bool] = ACTIONS(1543),
    [anon_sym_byte] = ACTIONS(1543),
    [anon_sym_char] = ACTIONS(1543),
    [anon_sym_decimal] = ACTIONS(1543),
    [anon_sym_double] = ACTIONS(1543),
    [anon_sym_float] = ACTIONS(1543),
    [anon_sym_int] = ACTIONS(1543),
    [anon_sym_long] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [anon_sym_sbyte] = ACTIONS(1543),
    [anon_sym_short] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_uint] = ACTIONS(1543),
    [anon_sym_ulong] = ACTIONS(1543),
    [anon_sym_ushort] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_DOT] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(1543),
    [anon_sym_false] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(1543),
    [anon_sym_typeof] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1543),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1545),
    [sym_null_literal] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [anon_sym_AT_DQUOTE] = ACTIONS(1545),
    [sym_identifier_name] = ACTIONS(1543),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1543),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(1543),
    [anon_sym_unchecked] = ACTIONS(1543),
    [anon_sym_lock] = ACTIONS(1543),
    [anon_sym_yield] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1543),
    [anon_sym_break] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_switch] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_do] = ACTIONS(1543),
    [anon_sym_continue] = ACTIONS(1543),
    [anon_sym_throw] = ACTIONS(1543),
    [anon_sym_goto] = ACTIONS(1543),
    [anon_sym_var] = ACTIONS(1543),
  },
  [547] = {
    [anon_sym_bool] = ACTIONS(1551),
    [anon_sym_byte] = ACTIONS(1551),
    [anon_sym_char] = ACTIONS(1551),
    [anon_sym_decimal] = ACTIONS(1551),
    [anon_sym_double] = ACTIONS(1551),
    [anon_sym_float] = ACTIONS(1551),
    [anon_sym_int] = ACTIONS(1551),
    [anon_sym_long] = ACTIONS(1551),
    [anon_sym_object] = ACTIONS(1551),
    [anon_sym_sbyte] = ACTIONS(1551),
    [anon_sym_short] = ACTIONS(1551),
    [anon_sym_string] = ACTIONS(1551),
    [anon_sym_uint] = ACTIONS(1551),
    [anon_sym_ulong] = ACTIONS(1551),
    [anon_sym_ushort] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1553),
    [anon_sym_RBRACE] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1553),
    [anon_sym_DOT] = ACTIONS(1553),
    [anon_sym_PLUS] = ACTIONS(1551),
    [anon_sym_DASH] = ACTIONS(1551),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(1551),
    [anon_sym_false] = ACTIONS(1551),
    [anon_sym_const] = ACTIONS(1551),
    [anon_sym_typeof] = ACTIONS(1551),
    [anon_sym_sizeof] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1553),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1551),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1553),
    [sym_null_literal] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1553),
    [anon_sym_AT_DQUOTE] = ACTIONS(1553),
    [sym_identifier_name] = ACTIONS(1551),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1551),
    [anon_sym_checked] = ACTIONS(1551),
    [anon_sym_unchecked] = ACTIONS(1551),
    [anon_sym_lock] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_else] = ACTIONS(1551),
    [anon_sym_switch] = ACTIONS(1551),
    [anon_sym_case] = ACTIONS(1551),
    [anon_sym_default] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_do] = ACTIONS(1551),
    [anon_sym_continue] = ACTIONS(1551),
    [anon_sym_throw] = ACTIONS(1551),
    [anon_sym_goto] = ACTIONS(1551),
    [anon_sym_var] = ACTIONS(1551),
  },
  [548] = {
    [anon_sym_bool] = ACTIONS(1555),
    [anon_sym_byte] = ACTIONS(1555),
    [anon_sym_char] = ACTIONS(1555),
    [anon_sym_decimal] = ACTIONS(1555),
    [anon_sym_double] = ACTIONS(1555),
    [anon_sym_float] = ACTIONS(1555),
    [anon_sym_int] = ACTIONS(1555),
    [anon_sym_long] = ACTIONS(1555),
    [anon_sym_object] = ACTIONS(1555),
    [anon_sym_sbyte] = ACTIONS(1555),
    [anon_sym_short] = ACTIONS(1555),
    [anon_sym_string] = ACTIONS(1555),
    [anon_sym_uint] = ACTIONS(1555),
    [anon_sym_ulong] = ACTIONS(1555),
    [anon_sym_ushort] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1557),
    [anon_sym_RBRACE] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1557),
    [anon_sym_DOT] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_BANG] = ACTIONS(1557),
    [anon_sym_TILDE] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1557),
    [anon_sym_DASH_DASH] = ACTIONS(1557),
    [anon_sym_true] = ACTIONS(1555),
    [anon_sym_false] = ACTIONS(1555),
    [anon_sym_const] = ACTIONS(1555),
    [anon_sym_typeof] = ACTIONS(1555),
    [anon_sym_sizeof] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1557),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1555),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1557),
    [sym_null_literal] = ACTIONS(1555),
    [anon_sym_DQUOTE] = ACTIONS(1557),
    [anon_sym_AT_DQUOTE] = ACTIONS(1557),
    [sym_identifier_name] = ACTIONS(1555),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1555),
    [anon_sym_checked] = ACTIONS(1555),
    [anon_sym_unchecked] = ACTIONS(1555),
    [anon_sym_lock] = ACTIONS(1555),
    [anon_sym_yield] = ACTIONS(1555),
    [anon_sym_return] = ACTIONS(1555),
    [anon_sym_break] = ACTIONS(1555),
    [anon_sym_if] = ACTIONS(1555),
    [anon_sym_else] = ACTIONS(1555),
    [anon_sym_switch] = ACTIONS(1555),
    [anon_sym_case] = ACTIONS(1555),
    [anon_sym_default] = ACTIONS(1555),
    [anon_sym_while] = ACTIONS(1555),
    [anon_sym_do] = ACTIONS(1555),
    [anon_sym_continue] = ACTIONS(1555),
    [anon_sym_throw] = ACTIONS(1555),
    [anon_sym_goto] = ACTIONS(1555),
    [anon_sym_var] = ACTIONS(1555),
  },
  [549] = {
    [sym__expression] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym_ternary_expression] = STATE(742),
    [sym_binary_expression] = STATE(742),
    [sym_unary_expression] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_boolean_literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_integer_literal] = STATE(742),
    [sym_real_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1559),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1559),
    [sym_comment] = ACTIONS(31),
  },
  [550] = {
    [sym__expression] = STATE(743),
    [sym_parenthesized_expression] = STATE(743),
    [sym_ternary_expression] = STATE(743),
    [sym_binary_expression] = STATE(743),
    [sym_unary_expression] = STATE(743),
    [sym__literal] = STATE(743),
    [sym_boolean_literal] = STATE(743),
    [sym_character_literal] = STATE(743),
    [sym_integer_literal] = STATE(743),
    [sym_real_literal] = STATE(743),
    [sym_string_literal] = STATE(743),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1561),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1561),
    [sym_comment] = ACTIONS(31),
  },
  [551] = {
    [anon_sym_SEMI] = ACTIONS(1563),
    [sym_comment] = ACTIONS(31),
  },
  [552] = {
    [anon_sym_bool] = ACTIONS(1565),
    [anon_sym_byte] = ACTIONS(1565),
    [anon_sym_char] = ACTIONS(1565),
    [anon_sym_decimal] = ACTIONS(1565),
    [anon_sym_double] = ACTIONS(1565),
    [anon_sym_float] = ACTIONS(1565),
    [anon_sym_int] = ACTIONS(1565),
    [anon_sym_long] = ACTIONS(1565),
    [anon_sym_object] = ACTIONS(1565),
    [anon_sym_sbyte] = ACTIONS(1565),
    [anon_sym_short] = ACTIONS(1565),
    [anon_sym_string] = ACTIONS(1565),
    [anon_sym_uint] = ACTIONS(1565),
    [anon_sym_ulong] = ACTIONS(1565),
    [anon_sym_ushort] = ACTIONS(1565),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(1567),
    [anon_sym_RBRACE] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1567),
    [anon_sym_DOT] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1567),
    [anon_sym_DASH_DASH] = ACTIONS(1567),
    [anon_sym_true] = ACTIONS(1565),
    [anon_sym_false] = ACTIONS(1565),
    [anon_sym_const] = ACTIONS(1565),
    [anon_sym_typeof] = ACTIONS(1565),
    [anon_sym_sizeof] = ACTIONS(1565),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1565),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1567),
    [sym_null_literal] = ACTIONS(1565),
    [anon_sym_DQUOTE] = ACTIONS(1567),
    [anon_sym_AT_DQUOTE] = ACTIONS(1567),
    [sym_identifier_name] = ACTIONS(1565),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1565),
    [anon_sym_checked] = ACTIONS(1565),
    [anon_sym_unchecked] = ACTIONS(1565),
    [anon_sym_lock] = ACTIONS(1565),
    [anon_sym_yield] = ACTIONS(1565),
    [anon_sym_return] = ACTIONS(1565),
    [anon_sym_break] = ACTIONS(1565),
    [anon_sym_if] = ACTIONS(1565),
    [anon_sym_else] = ACTIONS(1565),
    [anon_sym_switch] = ACTIONS(1565),
    [anon_sym_case] = ACTIONS(1565),
    [anon_sym_default] = ACTIONS(1565),
    [anon_sym_while] = ACTIONS(1565),
    [anon_sym_do] = ACTIONS(1565),
    [anon_sym_continue] = ACTIONS(1565),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_goto] = ACTIONS(1565),
    [anon_sym_var] = ACTIONS(1565),
  },
  [553] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [554] = {
    [anon_sym_bool] = ACTIONS(1571),
    [anon_sym_byte] = ACTIONS(1571),
    [anon_sym_char] = ACTIONS(1571),
    [anon_sym_decimal] = ACTIONS(1571),
    [anon_sym_double] = ACTIONS(1571),
    [anon_sym_float] = ACTIONS(1571),
    [anon_sym_int] = ACTIONS(1571),
    [anon_sym_long] = ACTIONS(1571),
    [anon_sym_object] = ACTIONS(1571),
    [anon_sym_sbyte] = ACTIONS(1571),
    [anon_sym_short] = ACTIONS(1571),
    [anon_sym_string] = ACTIONS(1571),
    [anon_sym_uint] = ACTIONS(1571),
    [anon_sym_ulong] = ACTIONS(1571),
    [anon_sym_ushort] = ACTIONS(1571),
    [anon_sym_SEMI] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1573),
    [anon_sym_RBRACE] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_DOT] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1571),
    [anon_sym_DASH] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [anon_sym_PLUS_PLUS] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1573),
    [anon_sym_true] = ACTIONS(1571),
    [anon_sym_false] = ACTIONS(1571),
    [anon_sym_const] = ACTIONS(1571),
    [anon_sym_typeof] = ACTIONS(1571),
    [anon_sym_sizeof] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1571),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1573),
    [sym_null_literal] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_AT_DQUOTE] = ACTIONS(1573),
    [sym_identifier_name] = ACTIONS(1571),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1571),
    [anon_sym_checked] = ACTIONS(1571),
    [anon_sym_unchecked] = ACTIONS(1571),
    [anon_sym_lock] = ACTIONS(1571),
    [anon_sym_yield] = ACTIONS(1571),
    [anon_sym_return] = ACTIONS(1571),
    [anon_sym_break] = ACTIONS(1571),
    [anon_sym_if] = ACTIONS(1571),
    [anon_sym_else] = ACTIONS(1571),
    [anon_sym_switch] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1571),
    [anon_sym_default] = ACTIONS(1571),
    [anon_sym_while] = ACTIONS(1571),
    [anon_sym_do] = ACTIONS(1571),
    [anon_sym_continue] = ACTIONS(1571),
    [anon_sym_throw] = ACTIONS(1571),
    [anon_sym_goto] = ACTIONS(1571),
    [anon_sym_var] = ACTIONS(1571),
  },
  [555] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(747),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [556] = {
    [sym__expression] = STATE(748),
    [sym_parenthesized_expression] = STATE(748),
    [sym_ternary_expression] = STATE(748),
    [sym_binary_expression] = STATE(748),
    [sym_unary_expression] = STATE(748),
    [sym__literal] = STATE(748),
    [sym_boolean_literal] = STATE(748),
    [sym_character_literal] = STATE(748),
    [sym_integer_literal] = STATE(748),
    [sym_real_literal] = STATE(748),
    [sym_string_literal] = STATE(748),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1577),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1577),
    [sym_comment] = ACTIONS(31),
  },
  [557] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(749),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [558] = {
    [sym_statement_block] = STATE(750),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [559] = {
    [anon_sym_LPAREN] = ACTIONS(1579),
    [sym_comment] = ACTIONS(31),
  },
  [560] = {
    [anon_sym_LPAREN] = ACTIONS(1581),
    [sym_comment] = ACTIONS(31),
  },
  [561] = {
    [anon_sym_LPAREN] = ACTIONS(1583),
    [sym_comment] = ACTIONS(31),
  },
  [562] = {
    [sym_comment] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(1585),
  },
  [563] = {
    [anon_sym_bool] = ACTIONS(1587),
    [anon_sym_byte] = ACTIONS(1587),
    [anon_sym_char] = ACTIONS(1587),
    [anon_sym_decimal] = ACTIONS(1587),
    [anon_sym_double] = ACTIONS(1587),
    [anon_sym_float] = ACTIONS(1587),
    [anon_sym_int] = ACTIONS(1587),
    [anon_sym_long] = ACTIONS(1587),
    [anon_sym_object] = ACTIONS(1587),
    [anon_sym_sbyte] = ACTIONS(1587),
    [anon_sym_short] = ACTIONS(1587),
    [anon_sym_string] = ACTIONS(1587),
    [anon_sym_uint] = ACTIONS(1587),
    [anon_sym_ulong] = ACTIONS(1587),
    [anon_sym_ushort] = ACTIONS(1587),
    [anon_sym_SEMI] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(1589),
    [anon_sym_RBRACE] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_DOT] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(1587),
    [anon_sym_false] = ACTIONS(1587),
    [anon_sym_const] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(1587),
    [anon_sym_sizeof] = ACTIONS(1587),
    [anon_sym_SQUOTE] = ACTIONS(1589),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1587),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1589),
    [sym_null_literal] = ACTIONS(1587),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_AT_DQUOTE] = ACTIONS(1589),
    [sym_identifier_name] = ACTIONS(1587),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1587),
    [anon_sym_checked] = ACTIONS(1587),
    [anon_sym_unchecked] = ACTIONS(1587),
    [anon_sym_lock] = ACTIONS(1587),
    [anon_sym_yield] = ACTIONS(1587),
    [anon_sym_return] = ACTIONS(1587),
    [anon_sym_break] = ACTIONS(1587),
    [anon_sym_if] = ACTIONS(1587),
    [anon_sym_else] = ACTIONS(1587),
    [anon_sym_switch] = ACTIONS(1587),
    [anon_sym_case] = ACTIONS(1587),
    [anon_sym_default] = ACTIONS(1587),
    [anon_sym_while] = ACTIONS(1587),
    [anon_sym_do] = ACTIONS(1587),
    [anon_sym_continue] = ACTIONS(1587),
    [anon_sym_throw] = ACTIONS(1587),
    [anon_sym_goto] = ACTIONS(1587),
    [anon_sym_var] = ACTIONS(1587),
  },
  [564] = {
    [anon_sym_bool] = ACTIONS(1591),
    [anon_sym_byte] = ACTIONS(1591),
    [anon_sym_char] = ACTIONS(1591),
    [anon_sym_decimal] = ACTIONS(1591),
    [anon_sym_double] = ACTIONS(1591),
    [anon_sym_float] = ACTIONS(1591),
    [anon_sym_int] = ACTIONS(1591),
    [anon_sym_long] = ACTIONS(1591),
    [anon_sym_object] = ACTIONS(1591),
    [anon_sym_sbyte] = ACTIONS(1591),
    [anon_sym_short] = ACTIONS(1591),
    [anon_sym_string] = ACTIONS(1591),
    [anon_sym_uint] = ACTIONS(1591),
    [anon_sym_ulong] = ACTIONS(1591),
    [anon_sym_ushort] = ACTIONS(1591),
    [anon_sym_SEMI] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1593),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [anon_sym_LPAREN] = ACTIONS(1593),
    [anon_sym_DOT] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_TILDE] = ACTIONS(1593),
    [anon_sym_PLUS_PLUS] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1593),
    [anon_sym_true] = ACTIONS(1591),
    [anon_sym_false] = ACTIONS(1591),
    [anon_sym_const] = ACTIONS(1591),
    [anon_sym_typeof] = ACTIONS(1591),
    [anon_sym_sizeof] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1591),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1593),
    [sym_null_literal] = ACTIONS(1591),
    [anon_sym_DQUOTE] = ACTIONS(1593),
    [anon_sym_AT_DQUOTE] = ACTIONS(1593),
    [sym_identifier_name] = ACTIONS(1591),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1591),
    [anon_sym_checked] = ACTIONS(1591),
    [anon_sym_unchecked] = ACTIONS(1591),
    [anon_sym_lock] = ACTIONS(1591),
    [anon_sym_yield] = ACTIONS(1591),
    [anon_sym_return] = ACTIONS(1591),
    [anon_sym_break] = ACTIONS(1591),
    [anon_sym_if] = ACTIONS(1591),
    [anon_sym_else] = ACTIONS(1591),
    [anon_sym_switch] = ACTIONS(1591),
    [anon_sym_case] = ACTIONS(1591),
    [anon_sym_default] = ACTIONS(1591),
    [anon_sym_while] = ACTIONS(1591),
    [anon_sym_do] = ACTIONS(1591),
    [anon_sym_continue] = ACTIONS(1591),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_goto] = ACTIONS(1591),
    [anon_sym_var] = ACTIONS(1591),
  },
  [565] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [566] = {
    [anon_sym_SEMI] = ACTIONS(1597),
    [sym_comment] = ACTIONS(31),
  },
  [567] = {
    [sym__expression] = STATE(757),
    [sym_constant_expression] = STATE(758),
    [sym_parenthesized_expression] = STATE(757),
    [sym_ternary_expression] = STATE(757),
    [sym_binary_expression] = STATE(757),
    [sym_unary_expression] = STATE(757),
    [sym__literal] = STATE(757),
    [sym_boolean_literal] = STATE(757),
    [sym_character_literal] = STATE(757),
    [sym_integer_literal] = STATE(757),
    [sym_real_literal] = STATE(757),
    [sym_string_literal] = STATE(757),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1599),
    [sym_comment] = ACTIONS(31),
  },
  [568] = {
    [anon_sym_SEMI] = ACTIONS(1601),
    [sym_comment] = ACTIONS(31),
  },
  [569] = {
    [anon_sym_bool] = ACTIONS(1603),
    [anon_sym_byte] = ACTIONS(1603),
    [anon_sym_char] = ACTIONS(1603),
    [anon_sym_decimal] = ACTIONS(1603),
    [anon_sym_double] = ACTIONS(1603),
    [anon_sym_float] = ACTIONS(1603),
    [anon_sym_int] = ACTIONS(1603),
    [anon_sym_long] = ACTIONS(1603),
    [anon_sym_object] = ACTIONS(1603),
    [anon_sym_sbyte] = ACTIONS(1603),
    [anon_sym_short] = ACTIONS(1603),
    [anon_sym_string] = ACTIONS(1603),
    [anon_sym_uint] = ACTIONS(1603),
    [anon_sym_ulong] = ACTIONS(1603),
    [anon_sym_ushort] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1605),
    [anon_sym_RBRACE] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1605),
    [anon_sym_DOT] = ACTIONS(1605),
    [anon_sym_PLUS] = ACTIONS(1603),
    [anon_sym_DASH] = ACTIONS(1603),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1605),
    [anon_sym_true] = ACTIONS(1603),
    [anon_sym_false] = ACTIONS(1603),
    [anon_sym_const] = ACTIONS(1603),
    [anon_sym_typeof] = ACTIONS(1603),
    [anon_sym_sizeof] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1605),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1603),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1605),
    [sym_null_literal] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [anon_sym_AT_DQUOTE] = ACTIONS(1605),
    [sym_identifier_name] = ACTIONS(1603),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1603),
    [anon_sym_checked] = ACTIONS(1603),
    [anon_sym_unchecked] = ACTIONS(1603),
    [anon_sym_lock] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1603),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1603),
    [anon_sym_if] = ACTIONS(1603),
    [anon_sym_else] = ACTIONS(1603),
    [anon_sym_switch] = ACTIONS(1603),
    [anon_sym_case] = ACTIONS(1603),
    [anon_sym_default] = ACTIONS(1603),
    [anon_sym_while] = ACTIONS(1603),
    [anon_sym_do] = ACTIONS(1603),
    [anon_sym_continue] = ACTIONS(1603),
    [anon_sym_throw] = ACTIONS(1603),
    [anon_sym_goto] = ACTIONS(1603),
    [anon_sym_var] = ACTIONS(1603),
  },
  [570] = {
    [anon_sym_bool] = ACTIONS(1607),
    [anon_sym_byte] = ACTIONS(1607),
    [anon_sym_char] = ACTIONS(1607),
    [anon_sym_decimal] = ACTIONS(1607),
    [anon_sym_double] = ACTIONS(1607),
    [anon_sym_float] = ACTIONS(1607),
    [anon_sym_int] = ACTIONS(1607),
    [anon_sym_long] = ACTIONS(1607),
    [anon_sym_object] = ACTIONS(1607),
    [anon_sym_sbyte] = ACTIONS(1607),
    [anon_sym_short] = ACTIONS(1607),
    [anon_sym_string] = ACTIONS(1607),
    [anon_sym_uint] = ACTIONS(1607),
    [anon_sym_ulong] = ACTIONS(1607),
    [anon_sym_ushort] = ACTIONS(1607),
    [anon_sym_abstract] = ACTIONS(1607),
    [anon_sym_async] = ACTIONS(1607),
    [anon_sym_extern] = ACTIONS(1607),
    [anon_sym_internal] = ACTIONS(1607),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_override] = ACTIONS(1607),
    [anon_sym_private] = ACTIONS(1607),
    [anon_sym_protected] = ACTIONS(1607),
    [anon_sym_public] = ACTIONS(1607),
    [anon_sym_readonly] = ACTIONS(1607),
    [anon_sym_sealed] = ACTIONS(1607),
    [anon_sym_static] = ACTIONS(1607),
    [anon_sym_unsafe] = ACTIONS(1607),
    [anon_sym_virtual] = ACTIONS(1607),
    [anon_sym_volatile] = ACTIONS(1607),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1607),
    [anon_sym_set] = ACTIONS(1607),
    [anon_sym_partial] = ACTIONS(1607),
    [anon_sym_class] = ACTIONS(1607),
    [anon_sym_struct] = ACTIONS(1607),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_DOT] = ACTIONS(1609),
    [anon_sym_event] = ACTIONS(1607),
    [anon_sym_add] = ACTIONS(1607),
    [anon_sym_remove] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1607),
    [anon_sym_DASH] = ACTIONS(1607),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_TILDE] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_DASH_DASH] = ACTIONS(1609),
    [anon_sym_true] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(1607),
    [anon_sym_implicit] = ACTIONS(1607),
    [anon_sym_explicit] = ACTIONS(1607),
    [anon_sym_interface] = ACTIONS(1607),
    [anon_sym_enum] = ACTIONS(1607),
    [anon_sym_delegate] = ACTIONS(1607),
    [sym_void_keyword] = ACTIONS(1607),
    [anon_sym_const] = ACTIONS(1607),
    [anon_sym_typeof] = ACTIONS(1607),
    [anon_sym_sizeof] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1609),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1607),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1609),
    [sym_null_literal] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1609),
    [anon_sym_AT_DQUOTE] = ACTIONS(1609),
    [sym_identifier_name] = ACTIONS(1607),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1607),
    [anon_sym_catch] = ACTIONS(1607),
    [anon_sym_finally] = ACTIONS(1607),
    [anon_sym_checked] = ACTIONS(1607),
    [anon_sym_unchecked] = ACTIONS(1607),
    [anon_sym_lock] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1607),
    [anon_sym_return] = ACTIONS(1607),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_if] = ACTIONS(1607),
    [anon_sym_else] = ACTIONS(1607),
    [anon_sym_switch] = ACTIONS(1607),
    [anon_sym_case] = ACTIONS(1607),
    [anon_sym_default] = ACTIONS(1607),
    [anon_sym_while] = ACTIONS(1607),
    [anon_sym_do] = ACTIONS(1607),
    [anon_sym_continue] = ACTIONS(1607),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_goto] = ACTIONS(1607),
    [anon_sym_var] = ACTIONS(1607),
  },
  [571] = {
    [anon_sym_bool] = ACTIONS(1611),
    [anon_sym_byte] = ACTIONS(1611),
    [anon_sym_char] = ACTIONS(1611),
    [anon_sym_decimal] = ACTIONS(1611),
    [anon_sym_double] = ACTIONS(1611),
    [anon_sym_float] = ACTIONS(1611),
    [anon_sym_int] = ACTIONS(1611),
    [anon_sym_long] = ACTIONS(1611),
    [anon_sym_object] = ACTIONS(1611),
    [anon_sym_sbyte] = ACTIONS(1611),
    [anon_sym_short] = ACTIONS(1611),
    [anon_sym_string] = ACTIONS(1611),
    [anon_sym_uint] = ACTIONS(1611),
    [anon_sym_ulong] = ACTIONS(1611),
    [anon_sym_ushort] = ACTIONS(1611),
    [anon_sym_SEMI] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_RBRACE] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_DOT] = ACTIONS(1613),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_true] = ACTIONS(1611),
    [anon_sym_false] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1611),
    [anon_sym_sizeof] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1611),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1613),
    [sym_null_literal] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_AT_DQUOTE] = ACTIONS(1613),
    [sym_identifier_name] = ACTIONS(1611),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1611),
    [anon_sym_checked] = ACTIONS(1611),
    [anon_sym_unchecked] = ACTIONS(1611),
    [anon_sym_lock] = ACTIONS(1611),
    [anon_sym_yield] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_do] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_throw] = ACTIONS(1611),
    [anon_sym_goto] = ACTIONS(1611),
    [anon_sym_var] = ACTIONS(1611),
  },
  [572] = {
    [anon_sym_COMMA] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1615),
    [anon_sym_EQ] = ACTIONS(1617),
    [sym_comment] = ACTIONS(31),
  },
  [573] = {
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_SEMI] = ACTIONS(1621),
    [sym_comment] = ACTIONS(31),
  },
  [574] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(574),
    [sym_variable_assignment_statement] = STATE(574),
    [sym_statement_block] = STATE(574),
    [sym__labeled_statement] = STATE(574),
    [sym__embedded_statement] = STATE(574),
    [sym_empty_statement] = STATE(574),
    [sym_expression_statement] = STATE(574),
    [sym__selection_statement] = STATE(574),
    [sym__iteration_statement] = STATE(574),
    [sym__jump_statement] = STATE(574),
    [sym_try_statement] = STATE(574),
    [sym_checked_statement] = STATE(574),
    [sym_unchecked_statement] = STATE(574),
    [sym_lock_statement] = STATE(574),
    [sym_yield_statement] = STATE(574),
    [sym_if_statement] = STATE(574),
    [sym_switch_statement] = STATE(574),
    [sym_while_statement] = STATE(574),
    [sym_do_statement] = STATE(574),
    [sym_break_statement] = STATE(574),
    [sym_continue_statement] = STATE(574),
    [sym_return_statement] = STATE(574),
    [sym_throw_statement] = STATE(574),
    [sym_goto_statement] = STATE(574),
    [sym__declaration_statement] = STATE(574),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [aux_sym__statement_list_repeat1] = STATE(574),
    [anon_sym_bool] = ACTIONS(1623),
    [anon_sym_byte] = ACTIONS(1623),
    [anon_sym_char] = ACTIONS(1623),
    [anon_sym_decimal] = ACTIONS(1623),
    [anon_sym_double] = ACTIONS(1623),
    [anon_sym_float] = ACTIONS(1623),
    [anon_sym_int] = ACTIONS(1623),
    [anon_sym_long] = ACTIONS(1623),
    [anon_sym_object] = ACTIONS(1623),
    [anon_sym_sbyte] = ACTIONS(1623),
    [anon_sym_short] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_uint] = ACTIONS(1623),
    [anon_sym_ulong] = ACTIONS(1623),
    [anon_sym_ushort] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1626),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_DOT] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1643),
    [anon_sym_TILDE] = ACTIONS(1643),
    [anon_sym_PLUS_PLUS] = ACTIONS(1643),
    [anon_sym_DASH_DASH] = ACTIONS(1643),
    [anon_sym_true] = ACTIONS(1646),
    [anon_sym_false] = ACTIONS(1646),
    [anon_sym_const] = ACTIONS(1649),
    [anon_sym_typeof] = ACTIONS(1640),
    [anon_sym_sizeof] = ACTIONS(1640),
    [anon_sym_SQUOTE] = ACTIONS(1652),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1655),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1658),
    [sym_null_literal] = ACTIONS(1661),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_AT_DQUOTE] = ACTIONS(1667),
    [sym_identifier_name] = ACTIONS(1670),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1673),
    [anon_sym_checked] = ACTIONS(1676),
    [anon_sym_unchecked] = ACTIONS(1679),
    [anon_sym_lock] = ACTIONS(1682),
    [anon_sym_yield] = ACTIONS(1685),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1691),
    [anon_sym_if] = ACTIONS(1694),
    [anon_sym_switch] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1700),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_continue] = ACTIONS(1706),
    [anon_sym_throw] = ACTIONS(1709),
    [anon_sym_goto] = ACTIONS(1712),
    [anon_sym_var] = ACTIONS(1715),
  },
  [575] = {
    [anon_sym_bool] = ACTIONS(1718),
    [anon_sym_byte] = ACTIONS(1718),
    [anon_sym_char] = ACTIONS(1718),
    [anon_sym_decimal] = ACTIONS(1718),
    [anon_sym_double] = ACTIONS(1718),
    [anon_sym_float] = ACTIONS(1718),
    [anon_sym_int] = ACTIONS(1718),
    [anon_sym_long] = ACTIONS(1718),
    [anon_sym_object] = ACTIONS(1718),
    [anon_sym_sbyte] = ACTIONS(1718),
    [anon_sym_short] = ACTIONS(1718),
    [anon_sym_string] = ACTIONS(1718),
    [anon_sym_uint] = ACTIONS(1718),
    [anon_sym_ulong] = ACTIONS(1718),
    [anon_sym_ushort] = ACTIONS(1718),
    [anon_sym_abstract] = ACTIONS(1718),
    [anon_sym_async] = ACTIONS(1718),
    [anon_sym_extern] = ACTIONS(1718),
    [anon_sym_internal] = ACTIONS(1718),
    [anon_sym_new] = ACTIONS(1718),
    [anon_sym_override] = ACTIONS(1718),
    [anon_sym_private] = ACTIONS(1718),
    [anon_sym_protected] = ACTIONS(1718),
    [anon_sym_public] = ACTIONS(1718),
    [anon_sym_readonly] = ACTIONS(1718),
    [anon_sym_sealed] = ACTIONS(1718),
    [anon_sym_static] = ACTIONS(1718),
    [anon_sym_unsafe] = ACTIONS(1718),
    [anon_sym_virtual] = ACTIONS(1718),
    [anon_sym_volatile] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1720),
    [anon_sym_partial] = ACTIONS(1718),
    [anon_sym_class] = ACTIONS(1718),
    [anon_sym_struct] = ACTIONS(1718),
    [anon_sym_LBRACK] = ACTIONS(1720),
    [anon_sym_event] = ACTIONS(1718),
    [anon_sym_TILDE] = ACTIONS(1720),
    [anon_sym_implicit] = ACTIONS(1718),
    [anon_sym_explicit] = ACTIONS(1718),
    [anon_sym_interface] = ACTIONS(1718),
    [anon_sym_enum] = ACTIONS(1718),
    [anon_sym_delegate] = ACTIONS(1718),
    [sym_void_keyword] = ACTIONS(1718),
    [anon_sym_const] = ACTIONS(1718),
    [sym_identifier_name] = ACTIONS(1718),
    [sym_comment] = ACTIONS(31),
  },
  [576] = {
    [sym__type] = STATE(762),
    [sym_predefined_type] = STATE(762),
    [sym_generic_name] = STATE(762),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [577] = {
    [sym_parameter_list] = STATE(763),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [578] = {
    [sym_identifier_name] = ACTIONS(1722),
    [sym_comment] = ACTIONS(31),
  },
  [579] = {
    [sym_identifier_name] = ACTIONS(1724),
    [sym_comment] = ACTIONS(31),
  },
  [580] = {
    [sym__constant_declarators] = STATE(766),
    [sym_constant_declarator] = STATE(320),
    [sym_identifier_name] = ACTIONS(601),
    [sym_comment] = ACTIONS(31),
  },
  [581] = {
    [sym_parameter_list] = STATE(767),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_this] = ACTIONS(311),
    [anon_sym_operator] = ACTIONS(311),
    [sym_identifier_name] = ACTIONS(311),
    [sym_comment] = ACTIONS(31),
  },
  [582] = {
    [sym_type_parameter_list] = STATE(692),
    [sym__property_body] = STATE(768),
    [sym_parameter_list] = STATE(658),
    [sym_equals_value_clause] = STATE(334),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(615),
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_EQ_GT] = ACTIONS(621),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_DOT] = ACTIONS(623),
    [sym_comment] = ACTIONS(31),
  },
  [583] = {
    [anon_sym_bool] = ACTIONS(1726),
    [anon_sym_byte] = ACTIONS(1726),
    [anon_sym_char] = ACTIONS(1726),
    [anon_sym_decimal] = ACTIONS(1726),
    [anon_sym_double] = ACTIONS(1726),
    [anon_sym_float] = ACTIONS(1726),
    [anon_sym_int] = ACTIONS(1726),
    [anon_sym_long] = ACTIONS(1726),
    [anon_sym_object] = ACTIONS(1726),
    [anon_sym_sbyte] = ACTIONS(1726),
    [anon_sym_short] = ACTIONS(1726),
    [anon_sym_string] = ACTIONS(1726),
    [anon_sym_uint] = ACTIONS(1726),
    [anon_sym_ulong] = ACTIONS(1726),
    [anon_sym_ushort] = ACTIONS(1726),
    [anon_sym_abstract] = ACTIONS(1726),
    [anon_sym_async] = ACTIONS(1726),
    [anon_sym_extern] = ACTIONS(1726),
    [anon_sym_internal] = ACTIONS(1726),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_override] = ACTIONS(1726),
    [anon_sym_private] = ACTIONS(1726),
    [anon_sym_protected] = ACTIONS(1726),
    [anon_sym_public] = ACTIONS(1726),
    [anon_sym_readonly] = ACTIONS(1726),
    [anon_sym_sealed] = ACTIONS(1726),
    [anon_sym_static] = ACTIONS(1726),
    [anon_sym_unsafe] = ACTIONS(1726),
    [anon_sym_virtual] = ACTIONS(1726),
    [anon_sym_volatile] = ACTIONS(1726),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_partial] = ACTIONS(1726),
    [anon_sym_class] = ACTIONS(1726),
    [anon_sym_struct] = ACTIONS(1726),
    [anon_sym_LBRACK] = ACTIONS(1728),
    [anon_sym_event] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1728),
    [anon_sym_implicit] = ACTIONS(1726),
    [anon_sym_explicit] = ACTIONS(1726),
    [anon_sym_interface] = ACTIONS(1726),
    [anon_sym_enum] = ACTIONS(1726),
    [anon_sym_delegate] = ACTIONS(1726),
    [sym_void_keyword] = ACTIONS(1726),
    [anon_sym_const] = ACTIONS(1726),
    [sym_identifier_name] = ACTIONS(1726),
    [sym_comment] = ACTIONS(31),
  },
  [584] = {
    [sym__expression] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_ternary_expression] = STATE(769),
    [sym_binary_expression] = STATE(769),
    [sym_unary_expression] = STATE(769),
    [sym__literal] = STATE(769),
    [sym_boolean_literal] = STATE(769),
    [sym_character_literal] = STATE(769),
    [sym_integer_literal] = STATE(769),
    [sym_real_literal] = STATE(769),
    [sym_string_literal] = STATE(769),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1730),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1730),
    [sym_comment] = ACTIONS(31),
  },
  [585] = {
    [anon_sym_bool] = ACTIONS(1732),
    [anon_sym_byte] = ACTIONS(1732),
    [anon_sym_char] = ACTIONS(1732),
    [anon_sym_decimal] = ACTIONS(1732),
    [anon_sym_double] = ACTIONS(1732),
    [anon_sym_float] = ACTIONS(1732),
    [anon_sym_int] = ACTIONS(1732),
    [anon_sym_long] = ACTIONS(1732),
    [anon_sym_object] = ACTIONS(1732),
    [anon_sym_sbyte] = ACTIONS(1732),
    [anon_sym_short] = ACTIONS(1732),
    [anon_sym_string] = ACTIONS(1732),
    [anon_sym_uint] = ACTIONS(1732),
    [anon_sym_ulong] = ACTIONS(1732),
    [anon_sym_ushort] = ACTIONS(1732),
    [anon_sym_abstract] = ACTIONS(1732),
    [anon_sym_async] = ACTIONS(1732),
    [anon_sym_extern] = ACTIONS(1732),
    [anon_sym_internal] = ACTIONS(1732),
    [anon_sym_new] = ACTIONS(1732),
    [anon_sym_override] = ACTIONS(1732),
    [anon_sym_private] = ACTIONS(1732),
    [anon_sym_protected] = ACTIONS(1732),
    [anon_sym_public] = ACTIONS(1732),
    [anon_sym_readonly] = ACTIONS(1732),
    [anon_sym_sealed] = ACTIONS(1732),
    [anon_sym_static] = ACTIONS(1732),
    [anon_sym_unsafe] = ACTIONS(1732),
    [anon_sym_virtual] = ACTIONS(1732),
    [anon_sym_volatile] = ACTIONS(1732),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_partial] = ACTIONS(1732),
    [anon_sym_class] = ACTIONS(1732),
    [anon_sym_struct] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1734),
    [anon_sym_event] = ACTIONS(1732),
    [anon_sym_TILDE] = ACTIONS(1734),
    [anon_sym_implicit] = ACTIONS(1732),
    [anon_sym_explicit] = ACTIONS(1732),
    [anon_sym_interface] = ACTIONS(1732),
    [anon_sym_enum] = ACTIONS(1732),
    [anon_sym_delegate] = ACTIONS(1732),
    [sym_void_keyword] = ACTIONS(1732),
    [anon_sym_const] = ACTIONS(1732),
    [sym_identifier_name] = ACTIONS(1732),
    [sym_comment] = ACTIONS(31),
  },
  [586] = {
    [aux_sym_class_base_repeat1] = STATE(408),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(1736),
    [anon_sym_where] = ACTIONS(1736),
    [sym_comment] = ACTIONS(31),
  },
  [587] = {
    [sym_constructor_constraint] = STATE(771),
    [anon_sym_new] = ACTIONS(806),
    [sym_identifier_name] = ACTIONS(1738),
    [sym_comment] = ACTIONS(31),
  },
  [588] = {
    [anon_sym_RPAREN] = ACTIONS(1740),
    [sym_comment] = ACTIONS(31),
  },
  [589] = {
    [anon_sym_SEMI] = ACTIONS(1742),
    [sym_comment] = ACTIONS(31),
  },
  [590] = {
    [anon_sym_bool] = ACTIONS(1744),
    [anon_sym_byte] = ACTIONS(1744),
    [anon_sym_char] = ACTIONS(1744),
    [anon_sym_decimal] = ACTIONS(1744),
    [anon_sym_double] = ACTIONS(1744),
    [anon_sym_float] = ACTIONS(1744),
    [anon_sym_int] = ACTIONS(1744),
    [anon_sym_long] = ACTIONS(1744),
    [anon_sym_object] = ACTIONS(1744),
    [anon_sym_sbyte] = ACTIONS(1744),
    [anon_sym_short] = ACTIONS(1744),
    [anon_sym_string] = ACTIONS(1744),
    [anon_sym_uint] = ACTIONS(1744),
    [anon_sym_ulong] = ACTIONS(1744),
    [anon_sym_ushort] = ACTIONS(1744),
    [anon_sym_new] = ACTIONS(1744),
    [anon_sym_RBRACE] = ACTIONS(1746),
    [anon_sym_LBRACK] = ACTIONS(1746),
    [anon_sym_event] = ACTIONS(1744),
    [sym_void_keyword] = ACTIONS(1744),
    [sym_identifier_name] = ACTIONS(1744),
    [sym_comment] = ACTIONS(31),
  },
  [591] = {
    [sym_type_parameter_constraints_clause] = STATE(776),
    [sym_parameter_list] = STATE(775),
    [aux_sym_class_declaration_repeat1] = STATE(776),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [592] = {
    [sym_type_parameter_constraints_clause] = STATE(776),
    [aux_sym_class_declaration_repeat1] = STATE(776),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [593] = {
    [sym_type_parameter_constraints_clause] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(598),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [594] = {
    [sym__type] = STATE(484),
    [sym_predefined_type] = STATE(484),
    [sym__formal_parameter_list] = STATE(777),
    [sym_parameter] = STATE(486),
    [sym_parameter_modifier] = STATE(487),
    [sym_parameter_array] = STATE(777),
    [sym__attributes] = STATE(488),
    [sym__attribute_section] = STATE(280),
    [sym_generic_name] = STATE(484),
    [aux_sym__attributes_repeat1] = STATE(280),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(505),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [595] = {
    [sym_interface_accessor] = STATE(778),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(778),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [596] = {
    [anon_sym_bool] = ACTIONS(1750),
    [anon_sym_byte] = ACTIONS(1750),
    [anon_sym_char] = ACTIONS(1750),
    [anon_sym_decimal] = ACTIONS(1750),
    [anon_sym_double] = ACTIONS(1750),
    [anon_sym_float] = ACTIONS(1750),
    [anon_sym_int] = ACTIONS(1750),
    [anon_sym_long] = ACTIONS(1750),
    [anon_sym_object] = ACTIONS(1750),
    [anon_sym_sbyte] = ACTIONS(1750),
    [anon_sym_short] = ACTIONS(1750),
    [anon_sym_string] = ACTIONS(1750),
    [anon_sym_uint] = ACTIONS(1750),
    [anon_sym_ulong] = ACTIONS(1750),
    [anon_sym_ushort] = ACTIONS(1750),
    [anon_sym_new] = ACTIONS(1750),
    [anon_sym_RBRACE] = ACTIONS(1752),
    [anon_sym_LBRACK] = ACTIONS(1752),
    [anon_sym_event] = ACTIONS(1750),
    [sym_void_keyword] = ACTIONS(1750),
    [sym_identifier_name] = ACTIONS(1750),
    [sym_comment] = ACTIONS(31),
  },
  [597] = {
    [anon_sym_COLON] = ACTIONS(1754),
    [sym_comment] = ACTIONS(31),
  },
  [598] = {
    [sym_type_parameter_constraints_clause] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(598),
    [anon_sym_SEMI] = ACTIONS(441),
    [anon_sym_where] = ACTIONS(1756),
    [sym_comment] = ACTIONS(31),
  },
  [599] = {
    [anon_sym_RBRACK] = ACTIONS(1759),
    [sym_comment] = ACTIONS(31),
  },
  [600] = {
    [anon_sym_SEMI] = ACTIONS(1761),
    [sym_comment] = ACTIONS(31),
  },
  [601] = {
    [anon_sym_get] = ACTIONS(1763),
    [anon_sym_set] = ACTIONS(1763),
    [sym_comment] = ACTIONS(31),
  },
  [602] = {
    [sym_interface_accessor] = STATE(784),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(784),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_RBRACE] = ACTIONS(1765),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [603] = {
    [sym__attribute_section] = STATE(785),
    [aux_sym__attributes_repeat1] = STATE(785),
    [anon_sym_get] = ACTIONS(85),
    [anon_sym_set] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [604] = {
    [sym_identifier_name] = ACTIONS(1767),
    [sym_comment] = ACTIONS(31),
  },
  [605] = {
    [sym_type_parameter_list] = STATE(787),
    [sym_type_parameter_constraints_clause] = STATE(776),
    [sym_parameter_list] = STATE(775),
    [aux_sym_class_declaration_repeat1] = STATE(776),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [606] = {
    [anon_sym_LBRACK] = ACTIONS(1769),
    [sym_comment] = ACTIONS(31),
  },
  [607] = {
    [sym_type_parameter_list] = STATE(787),
    [sym_type_parameter_constraints_clause] = STATE(776),
    [sym_parameter_list] = STATE(775),
    [aux_sym_class_declaration_repeat1] = STATE(776),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1748),
    [anon_sym_LBRACE] = ACTIONS(1771),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [608] = {
    [aux_sym_class_base_repeat1] = STATE(408),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_LBRACE] = ACTIONS(1773),
    [anon_sym_where] = ACTIONS(1773),
    [sym_comment] = ACTIONS(31),
  },
  [609] = {
    [sym__expression] = STATE(790),
    [sym_parenthesized_expression] = STATE(790),
    [sym_ternary_expression] = STATE(790),
    [sym_binary_expression] = STATE(790),
    [sym_unary_expression] = STATE(790),
    [sym__literal] = STATE(790),
    [sym_boolean_literal] = STATE(790),
    [sym_character_literal] = STATE(790),
    [sym_integer_literal] = STATE(790),
    [sym_real_literal] = STATE(790),
    [sym_string_literal] = STATE(790),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1775),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1775),
    [sym_comment] = ACTIONS(31),
  },
  [610] = {
    [sym__expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_ternary_expression] = STATE(791),
    [sym_binary_expression] = STATE(791),
    [sym_unary_expression] = STATE(791),
    [sym__literal] = STATE(791),
    [sym_boolean_literal] = STATE(791),
    [sym_character_literal] = STATE(791),
    [sym_integer_literal] = STATE(791),
    [sym_real_literal] = STATE(791),
    [sym_string_literal] = STATE(791),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1777),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1777),
    [sym_comment] = ACTIONS(31),
  },
  [611] = {
    [sym__expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym__literal] = STATE(725),
    [sym_boolean_literal] = STATE(725),
    [sym_character_literal] = STATE(725),
    [sym_integer_literal] = STATE(725),
    [sym_real_literal] = STATE(725),
    [sym_string_literal] = STATE(725),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1519),
    [sym_comment] = ACTIONS(31),
  },
  [612] = {
    [sym__expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(792),
    [sym_ternary_expression] = STATE(792),
    [sym_binary_expression] = STATE(792),
    [sym_unary_expression] = STATE(792),
    [sym__literal] = STATE(792),
    [sym_boolean_literal] = STATE(792),
    [sym_character_literal] = STATE(792),
    [sym_integer_literal] = STATE(792),
    [sym_real_literal] = STATE(792),
    [sym_string_literal] = STATE(792),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1779),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1779),
    [sym_comment] = ACTIONS(31),
  },
  [613] = {
    [sym__expression] = STATE(793),
    [sym_parenthesized_expression] = STATE(793),
    [sym_ternary_expression] = STATE(793),
    [sym_binary_expression] = STATE(793),
    [sym_unary_expression] = STATE(793),
    [sym__literal] = STATE(793),
    [sym_boolean_literal] = STATE(793),
    [sym_character_literal] = STATE(793),
    [sym_integer_literal] = STATE(793),
    [sym_real_literal] = STATE(793),
    [sym_string_literal] = STATE(793),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1781),
    [sym_comment] = ACTIONS(31),
  },
  [614] = {
    [sym__expression] = STATE(794),
    [sym_parenthesized_expression] = STATE(794),
    [sym_ternary_expression] = STATE(794),
    [sym_binary_expression] = STATE(794),
    [sym_unary_expression] = STATE(794),
    [sym__literal] = STATE(794),
    [sym_boolean_literal] = STATE(794),
    [sym_character_literal] = STATE(794),
    [sym_integer_literal] = STATE(794),
    [sym_real_literal] = STATE(794),
    [sym_string_literal] = STATE(794),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1783),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1783),
    [sym_comment] = ACTIONS(31),
  },
  [615] = {
    [sym__expression] = STATE(795),
    [sym_parenthesized_expression] = STATE(795),
    [sym_ternary_expression] = STATE(795),
    [sym_binary_expression] = STATE(795),
    [sym_unary_expression] = STATE(795),
    [sym__literal] = STATE(795),
    [sym_boolean_literal] = STATE(795),
    [sym_character_literal] = STATE(795),
    [sym_integer_literal] = STATE(795),
    [sym_real_literal] = STATE(795),
    [sym_string_literal] = STATE(795),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1785),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1785),
    [sym_comment] = ACTIONS(31),
  },
  [616] = {
    [sym__expression] = STATE(796),
    [sym_parenthesized_expression] = STATE(796),
    [sym_ternary_expression] = STATE(796),
    [sym_binary_expression] = STATE(796),
    [sym_unary_expression] = STATE(796),
    [sym__literal] = STATE(796),
    [sym_boolean_literal] = STATE(796),
    [sym_character_literal] = STATE(796),
    [sym_integer_literal] = STATE(796),
    [sym_real_literal] = STATE(796),
    [sym_string_literal] = STATE(796),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1787),
    [sym_comment] = ACTIONS(31),
  },
  [617] = {
    [sym__expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_ternary_expression] = STATE(797),
    [sym_binary_expression] = STATE(797),
    [sym_unary_expression] = STATE(797),
    [sym__literal] = STATE(797),
    [sym_boolean_literal] = STATE(797),
    [sym_character_literal] = STATE(797),
    [sym_integer_literal] = STATE(797),
    [sym_real_literal] = STATE(797),
    [sym_string_literal] = STATE(797),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1789),
    [sym_comment] = ACTIONS(31),
  },
  [618] = {
    [sym__expression] = STATE(798),
    [sym_parenthesized_expression] = STATE(798),
    [sym_ternary_expression] = STATE(798),
    [sym_binary_expression] = STATE(798),
    [sym_unary_expression] = STATE(798),
    [sym__literal] = STATE(798),
    [sym_boolean_literal] = STATE(798),
    [sym_character_literal] = STATE(798),
    [sym_integer_literal] = STATE(798),
    [sym_real_literal] = STATE(798),
    [sym_string_literal] = STATE(798),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1791),
    [sym_comment] = ACTIONS(31),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(1793),
    [anon_sym_bool] = ACTIONS(1795),
    [anon_sym_byte] = ACTIONS(1795),
    [anon_sym_char] = ACTIONS(1795),
    [anon_sym_decimal] = ACTIONS(1795),
    [anon_sym_double] = ACTIONS(1795),
    [anon_sym_float] = ACTIONS(1795),
    [anon_sym_int] = ACTIONS(1795),
    [anon_sym_long] = ACTIONS(1795),
    [anon_sym_object] = ACTIONS(1795),
    [anon_sym_sbyte] = ACTIONS(1795),
    [anon_sym_short] = ACTIONS(1795),
    [anon_sym_string] = ACTIONS(1795),
    [anon_sym_uint] = ACTIONS(1795),
    [anon_sym_ulong] = ACTIONS(1795),
    [anon_sym_ushort] = ACTIONS(1795),
    [anon_sym_abstract] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1795),
    [anon_sym_internal] = ACTIONS(1795),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_override] = ACTIONS(1795),
    [anon_sym_private] = ACTIONS(1795),
    [anon_sym_protected] = ACTIONS(1795),
    [anon_sym_public] = ACTIONS(1795),
    [anon_sym_readonly] = ACTIONS(1795),
    [anon_sym_sealed] = ACTIONS(1795),
    [anon_sym_static] = ACTIONS(1795),
    [anon_sym_unsafe] = ACTIONS(1795),
    [anon_sym_virtual] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym_using] = ACTIONS(1795),
    [anon_sym_namespace] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(1793),
    [anon_sym_partial] = ACTIONS(1795),
    [anon_sym_class] = ACTIONS(1795),
    [anon_sym_struct] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(1793),
    [anon_sym_event] = ACTIONS(1795),
    [anon_sym_TILDE] = ACTIONS(1793),
    [anon_sym_implicit] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_interface] = ACTIONS(1795),
    [anon_sym_enum] = ACTIONS(1795),
    [anon_sym_delegate] = ACTIONS(1795),
    [sym_void_keyword] = ACTIONS(1795),
    [anon_sym_const] = ACTIONS(1795),
    [sym_identifier_name] = ACTIONS(1795),
    [sym_comment] = ACTIONS(31),
  },
  [620] = {
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_RBRACE] = ACTIONS(1797),
    [sym_comment] = ACTIONS(31),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(1793),
    [anon_sym_bool] = ACTIONS(1795),
    [anon_sym_byte] = ACTIONS(1795),
    [anon_sym_char] = ACTIONS(1795),
    [anon_sym_decimal] = ACTIONS(1795),
    [anon_sym_double] = ACTIONS(1795),
    [anon_sym_float] = ACTIONS(1795),
    [anon_sym_int] = ACTIONS(1795),
    [anon_sym_long] = ACTIONS(1795),
    [anon_sym_object] = ACTIONS(1795),
    [anon_sym_sbyte] = ACTIONS(1795),
    [anon_sym_short] = ACTIONS(1795),
    [anon_sym_string] = ACTIONS(1795),
    [anon_sym_uint] = ACTIONS(1795),
    [anon_sym_ulong] = ACTIONS(1795),
    [anon_sym_ushort] = ACTIONS(1795),
    [anon_sym_abstract] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1795),
    [anon_sym_internal] = ACTIONS(1795),
    [anon_sym_new] = ACTIONS(1795),
    [anon_sym_override] = ACTIONS(1795),
    [anon_sym_private] = ACTIONS(1795),
    [anon_sym_protected] = ACTIONS(1795),
    [anon_sym_public] = ACTIONS(1795),
    [anon_sym_readonly] = ACTIONS(1795),
    [anon_sym_sealed] = ACTIONS(1795),
    [anon_sym_static] = ACTIONS(1795),
    [anon_sym_unsafe] = ACTIONS(1795),
    [anon_sym_virtual] = ACTIONS(1795),
    [anon_sym_volatile] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_using] = ACTIONS(1795),
    [anon_sym_namespace] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(1793),
    [anon_sym_partial] = ACTIONS(1795),
    [anon_sym_class] = ACTIONS(1795),
    [anon_sym_struct] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(1793),
    [anon_sym_event] = ACTIONS(1795),
    [anon_sym_TILDE] = ACTIONS(1793),
    [anon_sym_implicit] = ACTIONS(1795),
    [anon_sym_explicit] = ACTIONS(1795),
    [anon_sym_interface] = ACTIONS(1795),
    [anon_sym_enum] = ACTIONS(1795),
    [anon_sym_delegate] = ACTIONS(1795),
    [sym_void_keyword] = ACTIONS(1795),
    [anon_sym_const] = ACTIONS(1795),
    [sym_identifier_name] = ACTIONS(1795),
    [sym_comment] = ACTIONS(31),
  },
  [622] = {
    [aux_sym_enum_declaration_repeat1] = STATE(431),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(1801),
    [sym_comment] = ACTIONS(31),
  },
  [623] = {
    [anon_sym_bool] = ACTIONS(287),
    [anon_sym_byte] = ACTIONS(287),
    [anon_sym_char] = ACTIONS(287),
    [anon_sym_decimal] = ACTIONS(287),
    [anon_sym_double] = ACTIONS(287),
    [anon_sym_float] = ACTIONS(287),
    [anon_sym_int] = ACTIONS(287),
    [anon_sym_long] = ACTIONS(287),
    [anon_sym_object] = ACTIONS(287),
    [anon_sym_sbyte] = ACTIONS(287),
    [anon_sym_short] = ACTIONS(287),
    [anon_sym_string] = ACTIONS(287),
    [anon_sym_uint] = ACTIONS(287),
    [anon_sym_ulong] = ACTIONS(287),
    [anon_sym_ushort] = ACTIONS(287),
    [anon_sym_this] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_ref] = ACTIONS(287),
    [anon_sym_out] = ACTIONS(287),
    [anon_sym_params] = ACTIONS(287),
    [sym_identifier_name] = ACTIONS(287),
    [sym_comment] = ACTIONS(31),
  },
  [624] = {
    [aux_sym_array_rank_specifier_repeat1] = STATE(802),
    [anon_sym_COMMA] = ACTIONS(1803),
    [anon_sym_RBRACK] = ACTIONS(1805),
    [sym_comment] = ACTIONS(31),
  },
  [625] = {
    [sym_identifier_name] = ACTIONS(1807),
    [sym_comment] = ACTIONS(31),
  },
  [626] = {
    [anon_sym_RPAREN] = ACTIONS(1809),
    [anon_sym_RBRACK] = ACTIONS(1809),
    [sym_comment] = ACTIONS(31),
  },
  [627] = {
    [sym__expression] = STATE(804),
    [sym_parenthesized_expression] = STATE(804),
    [sym_ternary_expression] = STATE(804),
    [sym_binary_expression] = STATE(804),
    [sym_unary_expression] = STATE(804),
    [sym__literal] = STATE(804),
    [sym_boolean_literal] = STATE(804),
    [sym_character_literal] = STATE(804),
    [sym_integer_literal] = STATE(804),
    [sym_real_literal] = STATE(804),
    [sym_string_literal] = STATE(804),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1815),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1815),
    [sym_comment] = ACTIONS(31),
  },
  [628] = {
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_RPAREN] = ACTIONS(1817),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [anon_sym_RBRACK] = ACTIONS(1817),
    [anon_sym_params] = ACTIONS(1817),
    [sym_comment] = ACTIONS(31),
  },
  [629] = {
    [anon_sym_COMMA] = ACTIONS(1819),
    [anon_sym_RPAREN] = ACTIONS(1819),
    [anon_sym_LBRACK] = ACTIONS(1819),
    [anon_sym_RBRACK] = ACTIONS(1819),
    [anon_sym_params] = ACTIONS(1819),
    [sym_comment] = ACTIONS(31),
  },
  [630] = {
    [sym__type] = STATE(445),
    [sym_predefined_type] = STATE(445),
    [sym_parameter_modifier] = STATE(447),
    [sym_generic_name] = STATE(445),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [631] = {
    [sym__attribute_section] = STATE(805),
    [aux_sym__attributes_repeat1] = STATE(805),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_byte] = ACTIONS(433),
    [anon_sym_char] = ACTIONS(433),
    [anon_sym_decimal] = ACTIONS(433),
    [anon_sym_double] = ACTIONS(433),
    [anon_sym_float] = ACTIONS(433),
    [anon_sym_int] = ACTIONS(433),
    [anon_sym_long] = ACTIONS(433),
    [anon_sym_object] = ACTIONS(433),
    [anon_sym_sbyte] = ACTIONS(433),
    [anon_sym_short] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_uint] = ACTIONS(433),
    [anon_sym_ulong] = ACTIONS(433),
    [anon_sym_ushort] = ACTIONS(433),
    [anon_sym_this] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_ref] = ACTIONS(433),
    [anon_sym_out] = ACTIONS(433),
    [sym_identifier_name] = ACTIONS(433),
    [sym_comment] = ACTIONS(31),
  },
  [632] = {
    [anon_sym_RBRACK] = ACTIONS(1821),
    [sym_comment] = ACTIONS(31),
  },
  [633] = {
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_RBRACK] = ACTIONS(1823),
    [sym_comment] = ACTIONS(31),
  },
  [634] = {
    [aux_sym__formal_parameter_list_repeat1] = STATE(634),
    [anon_sym_COMMA] = ACTIONS(1825),
    [anon_sym_RPAREN] = ACTIONS(1819),
    [anon_sym_LBRACK] = ACTIONS(1819),
    [anon_sym_params] = ACTIONS(1819),
    [sym_comment] = ACTIONS(31),
  },
  [635] = {
    [sym__attribute_section] = STATE(635),
    [aux_sym__attributes_repeat1] = STATE(635),
    [anon_sym_LBRACK] = ACTIONS(1828),
    [anon_sym_params] = ACTIONS(218),
    [sym_comment] = ACTIONS(31),
  },
  [636] = {
    [sym_default_argument] = STATE(807),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_RPAREN] = ACTIONS(1817),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [anon_sym_params] = ACTIONS(1817),
    [sym_comment] = ACTIONS(31),
  },
  [637] = {
    [sym_identifier_name] = ACTIONS(1831),
    [sym_comment] = ACTIONS(31),
  },
  [638] = {
    [sym_identifier_name] = ACTIONS(1833),
    [sym_comment] = ACTIONS(31),
  },
  [639] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [640] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [641] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [642] = {
    [aux_sym_enum_declaration_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(1801),
    [sym_comment] = ACTIONS(31),
  },
  [643] = {
    [sym_type_parameter_constraints_clause] = STATE(814),
    [aux_sym_class_declaration_repeat1] = STATE(814),
    [anon_sym_LBRACE] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [644] = {
    [sym_type_parameter_constraints_clause] = STATE(815),
    [aux_sym_class_declaration_repeat1] = STATE(815),
    [anon_sym_LBRACE] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [645] = {
    [sym_type_parameter_constraints_clause] = STATE(816),
    [aux_sym_class_declaration_repeat1] = STATE(816),
    [anon_sym_LBRACE] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [646] = {
    [sym_enum_member_declaration] = STATE(817),
    [sym__attributes] = STATE(172),
    [sym__attribute_section] = STATE(173),
    [aux_sym__attributes_repeat1] = STATE(173),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_identifier_name] = ACTIONS(303),
    [sym_comment] = ACTIONS(31),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(1841),
    [anon_sym_bool] = ACTIONS(1843),
    [anon_sym_byte] = ACTIONS(1843),
    [anon_sym_char] = ACTIONS(1843),
    [anon_sym_decimal] = ACTIONS(1843),
    [anon_sym_double] = ACTIONS(1843),
    [anon_sym_float] = ACTIONS(1843),
    [anon_sym_int] = ACTIONS(1843),
    [anon_sym_long] = ACTIONS(1843),
    [anon_sym_object] = ACTIONS(1843),
    [anon_sym_sbyte] = ACTIONS(1843),
    [anon_sym_short] = ACTIONS(1843),
    [anon_sym_string] = ACTIONS(1843),
    [anon_sym_uint] = ACTIONS(1843),
    [anon_sym_ulong] = ACTIONS(1843),
    [anon_sym_ushort] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_extern] = ACTIONS(1843),
    [anon_sym_internal] = ACTIONS(1843),
    [anon_sym_new] = ACTIONS(1843),
    [anon_sym_override] = ACTIONS(1843),
    [anon_sym_private] = ACTIONS(1843),
    [anon_sym_protected] = ACTIONS(1843),
    [anon_sym_public] = ACTIONS(1843),
    [anon_sym_readonly] = ACTIONS(1843),
    [anon_sym_sealed] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_unsafe] = ACTIONS(1843),
    [anon_sym_virtual] = ACTIONS(1843),
    [anon_sym_volatile] = ACTIONS(1843),
    [anon_sym_using] = ACTIONS(1843),
    [anon_sym_namespace] = ACTIONS(1843),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_partial] = ACTIONS(1843),
    [anon_sym_class] = ACTIONS(1843),
    [anon_sym_struct] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [anon_sym_event] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1841),
    [anon_sym_implicit] = ACTIONS(1843),
    [anon_sym_explicit] = ACTIONS(1843),
    [anon_sym_interface] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [anon_sym_delegate] = ACTIONS(1843),
    [sym_void_keyword] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [sym_identifier_name] = ACTIONS(1843),
    [sym_comment] = ACTIONS(31),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(1845),
    [anon_sym_bool] = ACTIONS(1847),
    [anon_sym_byte] = ACTIONS(1847),
    [anon_sym_char] = ACTIONS(1847),
    [anon_sym_decimal] = ACTIONS(1847),
    [anon_sym_double] = ACTIONS(1847),
    [anon_sym_float] = ACTIONS(1847),
    [anon_sym_int] = ACTIONS(1847),
    [anon_sym_long] = ACTIONS(1847),
    [anon_sym_object] = ACTIONS(1847),
    [anon_sym_sbyte] = ACTIONS(1847),
    [anon_sym_short] = ACTIONS(1847),
    [anon_sym_string] = ACTIONS(1847),
    [anon_sym_uint] = ACTIONS(1847),
    [anon_sym_ulong] = ACTIONS(1847),
    [anon_sym_ushort] = ACTIONS(1847),
    [anon_sym_abstract] = ACTIONS(1847),
    [anon_sym_async] = ACTIONS(1847),
    [anon_sym_extern] = ACTIONS(1847),
    [anon_sym_internal] = ACTIONS(1847),
    [anon_sym_new] = ACTIONS(1847),
    [anon_sym_override] = ACTIONS(1847),
    [anon_sym_private] = ACTIONS(1847),
    [anon_sym_protected] = ACTIONS(1847),
    [anon_sym_public] = ACTIONS(1847),
    [anon_sym_readonly] = ACTIONS(1847),
    [anon_sym_sealed] = ACTIONS(1847),
    [anon_sym_static] = ACTIONS(1847),
    [anon_sym_unsafe] = ACTIONS(1847),
    [anon_sym_virtual] = ACTIONS(1847),
    [anon_sym_volatile] = ACTIONS(1847),
    [anon_sym_using] = ACTIONS(1847),
    [anon_sym_namespace] = ACTIONS(1847),
    [anon_sym_RBRACE] = ACTIONS(1845),
    [anon_sym_partial] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1847),
    [anon_sym_struct] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [anon_sym_event] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1845),
    [anon_sym_implicit] = ACTIONS(1847),
    [anon_sym_explicit] = ACTIONS(1847),
    [anon_sym_interface] = ACTIONS(1847),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_delegate] = ACTIONS(1847),
    [sym_void_keyword] = ACTIONS(1847),
    [anon_sym_const] = ACTIONS(1847),
    [sym_identifier_name] = ACTIONS(1847),
    [sym_comment] = ACTIONS(31),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(1845),
    [anon_sym_bool] = ACTIONS(1847),
    [anon_sym_byte] = ACTIONS(1847),
    [anon_sym_char] = ACTIONS(1847),
    [anon_sym_decimal] = ACTIONS(1847),
    [anon_sym_double] = ACTIONS(1847),
    [anon_sym_float] = ACTIONS(1847),
    [anon_sym_int] = ACTIONS(1847),
    [anon_sym_long] = ACTIONS(1847),
    [anon_sym_object] = ACTIONS(1847),
    [anon_sym_sbyte] = ACTIONS(1847),
    [anon_sym_short] = ACTIONS(1847),
    [anon_sym_string] = ACTIONS(1847),
    [anon_sym_uint] = ACTIONS(1847),
    [anon_sym_ulong] = ACTIONS(1847),
    [anon_sym_ushort] = ACTIONS(1847),
    [anon_sym_abstract] = ACTIONS(1847),
    [anon_sym_async] = ACTIONS(1847),
    [anon_sym_extern] = ACTIONS(1847),
    [anon_sym_internal] = ACTIONS(1847),
    [anon_sym_new] = ACTIONS(1847),
    [anon_sym_override] = ACTIONS(1847),
    [anon_sym_private] = ACTIONS(1847),
    [anon_sym_protected] = ACTIONS(1847),
    [anon_sym_public] = ACTIONS(1847),
    [anon_sym_readonly] = ACTIONS(1847),
    [anon_sym_sealed] = ACTIONS(1847),
    [anon_sym_static] = ACTIONS(1847),
    [anon_sym_unsafe] = ACTIONS(1847),
    [anon_sym_virtual] = ACTIONS(1847),
    [anon_sym_volatile] = ACTIONS(1847),
    [anon_sym_SEMI] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1847),
    [anon_sym_namespace] = ACTIONS(1847),
    [anon_sym_RBRACE] = ACTIONS(1845),
    [anon_sym_partial] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1847),
    [anon_sym_struct] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [anon_sym_event] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1845),
    [anon_sym_implicit] = ACTIONS(1847),
    [anon_sym_explicit] = ACTIONS(1847),
    [anon_sym_interface] = ACTIONS(1847),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_delegate] = ACTIONS(1847),
    [sym_void_keyword] = ACTIONS(1847),
    [anon_sym_const] = ACTIONS(1847),
    [sym_identifier_name] = ACTIONS(1847),
    [sym_comment] = ACTIONS(31),
  },
  [650] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(1853),
    [anon_sym_bool] = ACTIONS(1855),
    [anon_sym_byte] = ACTIONS(1855),
    [anon_sym_char] = ACTIONS(1855),
    [anon_sym_decimal] = ACTIONS(1855),
    [anon_sym_double] = ACTIONS(1855),
    [anon_sym_float] = ACTIONS(1855),
    [anon_sym_int] = ACTIONS(1855),
    [anon_sym_long] = ACTIONS(1855),
    [anon_sym_object] = ACTIONS(1855),
    [anon_sym_sbyte] = ACTIONS(1855),
    [anon_sym_short] = ACTIONS(1855),
    [anon_sym_string] = ACTIONS(1855),
    [anon_sym_uint] = ACTIONS(1855),
    [anon_sym_ulong] = ACTIONS(1855),
    [anon_sym_ushort] = ACTIONS(1855),
    [anon_sym_abstract] = ACTIONS(1855),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_extern] = ACTIONS(1855),
    [anon_sym_internal] = ACTIONS(1855),
    [anon_sym_new] = ACTIONS(1855),
    [anon_sym_override] = ACTIONS(1855),
    [anon_sym_private] = ACTIONS(1855),
    [anon_sym_protected] = ACTIONS(1855),
    [anon_sym_public] = ACTIONS(1855),
    [anon_sym_readonly] = ACTIONS(1855),
    [anon_sym_sealed] = ACTIONS(1855),
    [anon_sym_static] = ACTIONS(1855),
    [anon_sym_unsafe] = ACTIONS(1855),
    [anon_sym_virtual] = ACTIONS(1855),
    [anon_sym_volatile] = ACTIONS(1855),
    [anon_sym_using] = ACTIONS(1855),
    [anon_sym_namespace] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_partial] = ACTIONS(1855),
    [anon_sym_class] = ACTIONS(1855),
    [anon_sym_struct] = ACTIONS(1855),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_event] = ACTIONS(1855),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_implicit] = ACTIONS(1855),
    [anon_sym_explicit] = ACTIONS(1855),
    [anon_sym_interface] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1855),
    [anon_sym_delegate] = ACTIONS(1855),
    [sym_void_keyword] = ACTIONS(1855),
    [anon_sym_const] = ACTIONS(1855),
    [sym_identifier_name] = ACTIONS(1855),
    [sym_comment] = ACTIONS(31),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(1853),
    [anon_sym_bool] = ACTIONS(1855),
    [anon_sym_byte] = ACTIONS(1855),
    [anon_sym_char] = ACTIONS(1855),
    [anon_sym_decimal] = ACTIONS(1855),
    [anon_sym_double] = ACTIONS(1855),
    [anon_sym_float] = ACTIONS(1855),
    [anon_sym_int] = ACTIONS(1855),
    [anon_sym_long] = ACTIONS(1855),
    [anon_sym_object] = ACTIONS(1855),
    [anon_sym_sbyte] = ACTIONS(1855),
    [anon_sym_short] = ACTIONS(1855),
    [anon_sym_string] = ACTIONS(1855),
    [anon_sym_uint] = ACTIONS(1855),
    [anon_sym_ulong] = ACTIONS(1855),
    [anon_sym_ushort] = ACTIONS(1855),
    [anon_sym_abstract] = ACTIONS(1855),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_extern] = ACTIONS(1855),
    [anon_sym_internal] = ACTIONS(1855),
    [anon_sym_new] = ACTIONS(1855),
    [anon_sym_override] = ACTIONS(1855),
    [anon_sym_private] = ACTIONS(1855),
    [anon_sym_protected] = ACTIONS(1855),
    [anon_sym_public] = ACTIONS(1855),
    [anon_sym_readonly] = ACTIONS(1855),
    [anon_sym_sealed] = ACTIONS(1855),
    [anon_sym_static] = ACTIONS(1855),
    [anon_sym_unsafe] = ACTIONS(1855),
    [anon_sym_virtual] = ACTIONS(1855),
    [anon_sym_volatile] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1855),
    [anon_sym_namespace] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_partial] = ACTIONS(1855),
    [anon_sym_class] = ACTIONS(1855),
    [anon_sym_struct] = ACTIONS(1855),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [anon_sym_event] = ACTIONS(1855),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_implicit] = ACTIONS(1855),
    [anon_sym_explicit] = ACTIONS(1855),
    [anon_sym_interface] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1855),
    [anon_sym_delegate] = ACTIONS(1855),
    [sym_void_keyword] = ACTIONS(1855),
    [anon_sym_const] = ACTIONS(1855),
    [sym_identifier_name] = ACTIONS(1855),
    [sym_comment] = ACTIONS(31),
  },
  [653] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(1861),
    [anon_sym_bool] = ACTIONS(1863),
    [anon_sym_byte] = ACTIONS(1863),
    [anon_sym_char] = ACTIONS(1863),
    [anon_sym_decimal] = ACTIONS(1863),
    [anon_sym_double] = ACTIONS(1863),
    [anon_sym_float] = ACTIONS(1863),
    [anon_sym_int] = ACTIONS(1863),
    [anon_sym_long] = ACTIONS(1863),
    [anon_sym_object] = ACTIONS(1863),
    [anon_sym_sbyte] = ACTIONS(1863),
    [anon_sym_short] = ACTIONS(1863),
    [anon_sym_string] = ACTIONS(1863),
    [anon_sym_uint] = ACTIONS(1863),
    [anon_sym_ulong] = ACTIONS(1863),
    [anon_sym_ushort] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1863),
    [anon_sym_async] = ACTIONS(1863),
    [anon_sym_extern] = ACTIONS(1863),
    [anon_sym_internal] = ACTIONS(1863),
    [anon_sym_new] = ACTIONS(1863),
    [anon_sym_override] = ACTIONS(1863),
    [anon_sym_private] = ACTIONS(1863),
    [anon_sym_protected] = ACTIONS(1863),
    [anon_sym_public] = ACTIONS(1863),
    [anon_sym_readonly] = ACTIONS(1863),
    [anon_sym_sealed] = ACTIONS(1863),
    [anon_sym_static] = ACTIONS(1863),
    [anon_sym_unsafe] = ACTIONS(1863),
    [anon_sym_virtual] = ACTIONS(1863),
    [anon_sym_volatile] = ACTIONS(1863),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_namespace] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_partial] = ACTIONS(1863),
    [anon_sym_class] = ACTIONS(1863),
    [anon_sym_struct] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [anon_sym_event] = ACTIONS(1863),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_implicit] = ACTIONS(1863),
    [anon_sym_explicit] = ACTIONS(1863),
    [anon_sym_interface] = ACTIONS(1863),
    [anon_sym_enum] = ACTIONS(1863),
    [anon_sym_delegate] = ACTIONS(1863),
    [sym_void_keyword] = ACTIONS(1863),
    [anon_sym_const] = ACTIONS(1863),
    [sym_identifier_name] = ACTIONS(1863),
    [sym_comment] = ACTIONS(31),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(1861),
    [anon_sym_bool] = ACTIONS(1863),
    [anon_sym_byte] = ACTIONS(1863),
    [anon_sym_char] = ACTIONS(1863),
    [anon_sym_decimal] = ACTIONS(1863),
    [anon_sym_double] = ACTIONS(1863),
    [anon_sym_float] = ACTIONS(1863),
    [anon_sym_int] = ACTIONS(1863),
    [anon_sym_long] = ACTIONS(1863),
    [anon_sym_object] = ACTIONS(1863),
    [anon_sym_sbyte] = ACTIONS(1863),
    [anon_sym_short] = ACTIONS(1863),
    [anon_sym_string] = ACTIONS(1863),
    [anon_sym_uint] = ACTIONS(1863),
    [anon_sym_ulong] = ACTIONS(1863),
    [anon_sym_ushort] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1863),
    [anon_sym_async] = ACTIONS(1863),
    [anon_sym_extern] = ACTIONS(1863),
    [anon_sym_internal] = ACTIONS(1863),
    [anon_sym_new] = ACTIONS(1863),
    [anon_sym_override] = ACTIONS(1863),
    [anon_sym_private] = ACTIONS(1863),
    [anon_sym_protected] = ACTIONS(1863),
    [anon_sym_public] = ACTIONS(1863),
    [anon_sym_readonly] = ACTIONS(1863),
    [anon_sym_sealed] = ACTIONS(1863),
    [anon_sym_static] = ACTIONS(1863),
    [anon_sym_unsafe] = ACTIONS(1863),
    [anon_sym_virtual] = ACTIONS(1863),
    [anon_sym_volatile] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_namespace] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_partial] = ACTIONS(1863),
    [anon_sym_class] = ACTIONS(1863),
    [anon_sym_struct] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [anon_sym_event] = ACTIONS(1863),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_implicit] = ACTIONS(1863),
    [anon_sym_explicit] = ACTIONS(1863),
    [anon_sym_interface] = ACTIONS(1863),
    [anon_sym_enum] = ACTIONS(1863),
    [anon_sym_delegate] = ACTIONS(1863),
    [sym_void_keyword] = ACTIONS(1863),
    [anon_sym_const] = ACTIONS(1863),
    [sym_identifier_name] = ACTIONS(1863),
    [sym_comment] = ACTIONS(31),
  },
  [656] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [657] = {
    [anon_sym_bool] = ACTIONS(1869),
    [anon_sym_byte] = ACTIONS(1869),
    [anon_sym_char] = ACTIONS(1869),
    [anon_sym_decimal] = ACTIONS(1869),
    [anon_sym_double] = ACTIONS(1869),
    [anon_sym_float] = ACTIONS(1869),
    [anon_sym_int] = ACTIONS(1869),
    [anon_sym_long] = ACTIONS(1869),
    [anon_sym_object] = ACTIONS(1869),
    [anon_sym_sbyte] = ACTIONS(1869),
    [anon_sym_short] = ACTIONS(1869),
    [anon_sym_string] = ACTIONS(1869),
    [anon_sym_uint] = ACTIONS(1869),
    [anon_sym_ulong] = ACTIONS(1869),
    [anon_sym_ushort] = ACTIONS(1869),
    [anon_sym_abstract] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(1869),
    [anon_sym_extern] = ACTIONS(1869),
    [anon_sym_internal] = ACTIONS(1869),
    [anon_sym_new] = ACTIONS(1869),
    [anon_sym_override] = ACTIONS(1869),
    [anon_sym_private] = ACTIONS(1869),
    [anon_sym_protected] = ACTIONS(1869),
    [anon_sym_public] = ACTIONS(1869),
    [anon_sym_readonly] = ACTIONS(1869),
    [anon_sym_sealed] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(1869),
    [anon_sym_unsafe] = ACTIONS(1869),
    [anon_sym_virtual] = ACTIONS(1869),
    [anon_sym_volatile] = ACTIONS(1869),
    [anon_sym_RBRACE] = ACTIONS(1871),
    [anon_sym_partial] = ACTIONS(1869),
    [anon_sym_class] = ACTIONS(1869),
    [anon_sym_struct] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [anon_sym_event] = ACTIONS(1869),
    [anon_sym_TILDE] = ACTIONS(1871),
    [anon_sym_implicit] = ACTIONS(1869),
    [anon_sym_explicit] = ACTIONS(1869),
    [anon_sym_interface] = ACTIONS(1869),
    [anon_sym_enum] = ACTIONS(1869),
    [anon_sym_delegate] = ACTIONS(1869),
    [sym_void_keyword] = ACTIONS(1869),
    [anon_sym_const] = ACTIONS(1869),
    [sym_identifier_name] = ACTIONS(1869),
    [sym_comment] = ACTIONS(31),
  },
  [658] = {
    [sym_type_parameter_constraints_clause] = STATE(825),
    [sym_statement_block] = STATE(824),
    [aux_sym_class_declaration_repeat1] = STATE(825),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [659] = {
    [anon_sym_bool] = ACTIONS(1873),
    [anon_sym_byte] = ACTIONS(1873),
    [anon_sym_char] = ACTIONS(1873),
    [anon_sym_decimal] = ACTIONS(1873),
    [anon_sym_double] = ACTIONS(1873),
    [anon_sym_float] = ACTIONS(1873),
    [anon_sym_int] = ACTIONS(1873),
    [anon_sym_long] = ACTIONS(1873),
    [anon_sym_object] = ACTIONS(1873),
    [anon_sym_sbyte] = ACTIONS(1873),
    [anon_sym_short] = ACTIONS(1873),
    [anon_sym_string] = ACTIONS(1873),
    [anon_sym_uint] = ACTIONS(1873),
    [anon_sym_ulong] = ACTIONS(1873),
    [anon_sym_ushort] = ACTIONS(1873),
    [anon_sym_abstract] = ACTIONS(1873),
    [anon_sym_async] = ACTIONS(1873),
    [anon_sym_extern] = ACTIONS(1873),
    [anon_sym_internal] = ACTIONS(1873),
    [anon_sym_new] = ACTIONS(1873),
    [anon_sym_override] = ACTIONS(1873),
    [anon_sym_private] = ACTIONS(1873),
    [anon_sym_protected] = ACTIONS(1873),
    [anon_sym_public] = ACTIONS(1873),
    [anon_sym_readonly] = ACTIONS(1873),
    [anon_sym_sealed] = ACTIONS(1873),
    [anon_sym_static] = ACTIONS(1873),
    [anon_sym_unsafe] = ACTIONS(1873),
    [anon_sym_virtual] = ACTIONS(1873),
    [anon_sym_volatile] = ACTIONS(1873),
    [anon_sym_RBRACE] = ACTIONS(1875),
    [anon_sym_partial] = ACTIONS(1873),
    [anon_sym_class] = ACTIONS(1873),
    [anon_sym_struct] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(1875),
    [anon_sym_event] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1875),
    [anon_sym_implicit] = ACTIONS(1873),
    [anon_sym_explicit] = ACTIONS(1873),
    [anon_sym_interface] = ACTIONS(1873),
    [anon_sym_enum] = ACTIONS(1873),
    [anon_sym_delegate] = ACTIONS(1873),
    [sym_void_keyword] = ACTIONS(1873),
    [anon_sym_const] = ACTIONS(1873),
    [sym_identifier_name] = ACTIONS(1873),
    [sym_comment] = ACTIONS(31),
  },
  [660] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [sym_statement_block] = STATE(824),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [661] = {
    [sym_statement_block] = STATE(826),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [662] = {
    [sym_statement_block] = STATE(827),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [663] = {
    [sym_remove_accessor_declaration] = STATE(828),
    [sym__attributes] = STATE(829),
    [sym__attribute_section] = STATE(830),
    [aux_sym__attributes_repeat1] = STATE(830),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_remove] = ACTIONS(1358),
    [sym_comment] = ACTIONS(31),
  },
  [664] = {
    [sym_add_accessor_declaration] = STATE(828),
    [sym__attributes] = STATE(831),
    [sym__attribute_section] = STATE(832),
    [aux_sym__attributes_repeat1] = STATE(832),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(1356),
    [sym_comment] = ACTIONS(31),
  },
  [665] = {
    [anon_sym_add] = ACTIONS(1877),
    [anon_sym_remove] = ACTIONS(1879),
    [sym_comment] = ACTIONS(31),
  },
  [666] = {
    [sym__attribute_section] = STATE(835),
    [aux_sym__attributes_repeat1] = STATE(835),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(85),
    [anon_sym_remove] = ACTIONS(85),
    [sym_comment] = ACTIONS(31),
  },
  [667] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1262),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1412),
    [sym_comment] = ACTIONS(31),
  },
  [668] = {
    [anon_sym_COMMA] = ACTIONS(1881),
    [anon_sym_SEMI] = ACTIONS(1881),
    [sym_comment] = ACTIONS(31),
  },
  [669] = {
    [anon_sym_COMMA] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1883),
    [sym_comment] = ACTIONS(31),
  },
  [670] = {
    [aux_sym__constant_declarators_repeat1] = STATE(670),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_SEMI] = ACTIONS(1883),
    [sym_comment] = ACTIONS(31),
  },
  [671] = {
    [sym_default_argument] = STATE(628),
    [anon_sym_COMMA] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1888),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [anon_sym_RBRACK] = ACTIONS(1309),
    [anon_sym_params] = ACTIONS(1309),
    [sym_comment] = ACTIONS(31),
  },
  [672] = {
    [anon_sym_LBRACE] = ACTIONS(1890),
    [anon_sym_EQ_GT] = ACTIONS(1890),
    [sym_comment] = ACTIONS(31),
  },
  [673] = {
    [sym__type] = STATE(484),
    [sym_predefined_type] = STATE(484),
    [sym_parameter] = STATE(629),
    [sym_parameter_modifier] = STATE(487),
    [sym__attributes] = STATE(837),
    [sym__attribute_section] = STATE(631),
    [sym_generic_name] = STATE(484),
    [aux_sym__attributes_repeat1] = STATE(631),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [674] = {
    [sym_parameter_array] = STATE(633),
    [sym__attributes] = STATE(442),
    [sym__attribute_section] = STATE(444),
    [aux_sym__formal_parameter_list_repeat1] = STATE(838),
    [aux_sym__attributes_repeat1] = STATE(444),
    [anon_sym_COMMA] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(930),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [anon_sym_params] = ACTIONS(932),
    [sym_comment] = ACTIONS(31),
  },
  [675] = {
    [sym_identifier_name] = ACTIONS(1892),
    [sym_comment] = ACTIONS(31),
  },
  [676] = {
    [sym__type] = STATE(840),
    [sym_predefined_type] = STATE(840),
    [sym_generic_name] = STATE(840),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [677] = {
    [sym_identifier_name] = ACTIONS(1894),
    [sym_comment] = ACTIONS(31),
  },
  [678] = {
    [sym_identifier_name] = ACTIONS(1896),
    [sym_comment] = ACTIONS(31),
  },
  [679] = {
    [sym__expression] = STATE(843),
    [sym_parenthesized_expression] = STATE(843),
    [sym_ternary_expression] = STATE(843),
    [sym_binary_expression] = STATE(843),
    [sym_unary_expression] = STATE(843),
    [sym__literal] = STATE(843),
    [sym_boolean_literal] = STATE(843),
    [sym_character_literal] = STATE(843),
    [sym_integer_literal] = STATE(843),
    [sym_real_literal] = STATE(843),
    [sym_string_literal] = STATE(843),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1898),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1898),
    [sym_comment] = ACTIONS(31),
  },
  [680] = {
    [sym__expression] = STATE(844),
    [sym_parenthesized_expression] = STATE(844),
    [sym_ternary_expression] = STATE(844),
    [sym_binary_expression] = STATE(844),
    [sym_unary_expression] = STATE(844),
    [sym__literal] = STATE(844),
    [sym_boolean_literal] = STATE(844),
    [sym_character_literal] = STATE(844),
    [sym_integer_literal] = STATE(844),
    [sym_real_literal] = STATE(844),
    [sym_string_literal] = STATE(844),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1900),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1900),
    [sym_comment] = ACTIONS(31),
  },
  [681] = {
    [sym__expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym__literal] = STATE(725),
    [sym_boolean_literal] = STATE(725),
    [sym_character_literal] = STATE(725),
    [sym_integer_literal] = STATE(725),
    [sym_real_literal] = STATE(725),
    [sym_string_literal] = STATE(725),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1519),
    [sym_comment] = ACTIONS(31),
  },
  [682] = {
    [sym__expression] = STATE(845),
    [sym_parenthesized_expression] = STATE(845),
    [sym_ternary_expression] = STATE(845),
    [sym_binary_expression] = STATE(845),
    [sym_unary_expression] = STATE(845),
    [sym__literal] = STATE(845),
    [sym_boolean_literal] = STATE(845),
    [sym_character_literal] = STATE(845),
    [sym_integer_literal] = STATE(845),
    [sym_real_literal] = STATE(845),
    [sym_string_literal] = STATE(845),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1902),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1902),
    [sym_comment] = ACTIONS(31),
  },
  [683] = {
    [sym__expression] = STATE(846),
    [sym_parenthesized_expression] = STATE(846),
    [sym_ternary_expression] = STATE(846),
    [sym_binary_expression] = STATE(846),
    [sym_unary_expression] = STATE(846),
    [sym__literal] = STATE(846),
    [sym_boolean_literal] = STATE(846),
    [sym_character_literal] = STATE(846),
    [sym_integer_literal] = STATE(846),
    [sym_real_literal] = STATE(846),
    [sym_string_literal] = STATE(846),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1904),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1904),
    [sym_comment] = ACTIONS(31),
  },
  [684] = {
    [sym__expression] = STATE(847),
    [sym_parenthesized_expression] = STATE(847),
    [sym_ternary_expression] = STATE(847),
    [sym_binary_expression] = STATE(847),
    [sym_unary_expression] = STATE(847),
    [sym__literal] = STATE(847),
    [sym_boolean_literal] = STATE(847),
    [sym_character_literal] = STATE(847),
    [sym_integer_literal] = STATE(847),
    [sym_real_literal] = STATE(847),
    [sym_string_literal] = STATE(847),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1906),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1906),
    [sym_comment] = ACTIONS(31),
  },
  [685] = {
    [sym__expression] = STATE(848),
    [sym_parenthesized_expression] = STATE(848),
    [sym_ternary_expression] = STATE(848),
    [sym_binary_expression] = STATE(848),
    [sym_unary_expression] = STATE(848),
    [sym__literal] = STATE(848),
    [sym_boolean_literal] = STATE(848),
    [sym_character_literal] = STATE(848),
    [sym_integer_literal] = STATE(848),
    [sym_real_literal] = STATE(848),
    [sym_string_literal] = STATE(848),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1908),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1908),
    [sym_comment] = ACTIONS(31),
  },
  [686] = {
    [sym__expression] = STATE(849),
    [sym_parenthesized_expression] = STATE(849),
    [sym_ternary_expression] = STATE(849),
    [sym_binary_expression] = STATE(849),
    [sym_unary_expression] = STATE(849),
    [sym__literal] = STATE(849),
    [sym_boolean_literal] = STATE(849),
    [sym_character_literal] = STATE(849),
    [sym_integer_literal] = STATE(849),
    [sym_real_literal] = STATE(849),
    [sym_string_literal] = STATE(849),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1910),
    [sym_comment] = ACTIONS(31),
  },
  [687] = {
    [sym__expression] = STATE(850),
    [sym_parenthesized_expression] = STATE(850),
    [sym_ternary_expression] = STATE(850),
    [sym_binary_expression] = STATE(850),
    [sym_unary_expression] = STATE(850),
    [sym__literal] = STATE(850),
    [sym_boolean_literal] = STATE(850),
    [sym_character_literal] = STATE(850),
    [sym_integer_literal] = STATE(850),
    [sym_real_literal] = STATE(850),
    [sym_string_literal] = STATE(850),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1912),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1912),
    [sym_comment] = ACTIONS(31),
  },
  [688] = {
    [sym__expression] = STATE(851),
    [sym_parenthesized_expression] = STATE(851),
    [sym_ternary_expression] = STATE(851),
    [sym_binary_expression] = STATE(851),
    [sym_unary_expression] = STATE(851),
    [sym__literal] = STATE(851),
    [sym_boolean_literal] = STATE(851),
    [sym_character_literal] = STATE(851),
    [sym_integer_literal] = STATE(851),
    [sym_real_literal] = STATE(851),
    [sym_string_literal] = STATE(851),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1914),
    [sym_comment] = ACTIONS(31),
  },
  [689] = {
    [sym__property_initializer] = STATE(853),
    [anon_sym_bool] = ACTIONS(1916),
    [anon_sym_byte] = ACTIONS(1916),
    [anon_sym_char] = ACTIONS(1916),
    [anon_sym_decimal] = ACTIONS(1916),
    [anon_sym_double] = ACTIONS(1916),
    [anon_sym_float] = ACTIONS(1916),
    [anon_sym_int] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_object] = ACTIONS(1916),
    [anon_sym_sbyte] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_string] = ACTIONS(1916),
    [anon_sym_uint] = ACTIONS(1916),
    [anon_sym_ulong] = ACTIONS(1916),
    [anon_sym_ushort] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1916),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym_internal] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_override] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_readonly] = ACTIONS(1916),
    [anon_sym_sealed] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_unsafe] = ACTIONS(1916),
    [anon_sym_virtual] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_EQ] = ACTIONS(1918),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_partial] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_event] = ACTIONS(1916),
    [anon_sym_TILDE] = ACTIONS(1920),
    [anon_sym_implicit] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_interface] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_delegate] = ACTIONS(1916),
    [sym_void_keyword] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [sym_identifier_name] = ACTIONS(1916),
    [sym_comment] = ACTIONS(31),
  },
  [690] = {
    [anon_sym_bool] = ACTIONS(1916),
    [anon_sym_byte] = ACTIONS(1916),
    [anon_sym_char] = ACTIONS(1916),
    [anon_sym_decimal] = ACTIONS(1916),
    [anon_sym_double] = ACTIONS(1916),
    [anon_sym_float] = ACTIONS(1916),
    [anon_sym_int] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_object] = ACTIONS(1916),
    [anon_sym_sbyte] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_string] = ACTIONS(1916),
    [anon_sym_uint] = ACTIONS(1916),
    [anon_sym_ulong] = ACTIONS(1916),
    [anon_sym_ushort] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1916),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym_internal] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_override] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_readonly] = ACTIONS(1916),
    [anon_sym_sealed] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_unsafe] = ACTIONS(1916),
    [anon_sym_virtual] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1920),
    [anon_sym_partial] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_event] = ACTIONS(1916),
    [anon_sym_TILDE] = ACTIONS(1920),
    [anon_sym_implicit] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_interface] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_delegate] = ACTIONS(1916),
    [sym_void_keyword] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [sym_identifier_name] = ACTIONS(1916),
    [sym_comment] = ACTIONS(31),
  },
  [691] = {
    [sym__type] = STATE(484),
    [sym_predefined_type] = STATE(484),
    [sym__formal_parameter_list] = STATE(854),
    [sym_parameter] = STATE(486),
    [sym_parameter_modifier] = STATE(487),
    [sym_parameter_array] = STATE(854),
    [sym__attributes] = STATE(488),
    [sym__attribute_section] = STATE(280),
    [sym_generic_name] = STATE(484),
    [aux_sym__attributes_repeat1] = STATE(280),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(505),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [692] = {
    [sym_parameter_list] = STATE(855),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [693] = {
    [sym_add_accessor_declaration] = STATE(856),
    [sym_remove_accessor_declaration] = STATE(857),
    [sym__attributes] = STATE(665),
    [sym__attribute_section] = STATE(666),
    [aux_sym__attributes_repeat1] = STATE(666),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(1356),
    [anon_sym_remove] = ACTIONS(1358),
    [sym_comment] = ACTIONS(31),
  },
  [694] = {
    [anon_sym_bool] = ACTIONS(1922),
    [anon_sym_byte] = ACTIONS(1922),
    [anon_sym_char] = ACTIONS(1922),
    [anon_sym_decimal] = ACTIONS(1922),
    [anon_sym_double] = ACTIONS(1922),
    [anon_sym_float] = ACTIONS(1922),
    [anon_sym_int] = ACTIONS(1922),
    [anon_sym_long] = ACTIONS(1922),
    [anon_sym_object] = ACTIONS(1922),
    [anon_sym_sbyte] = ACTIONS(1922),
    [anon_sym_short] = ACTIONS(1922),
    [anon_sym_string] = ACTIONS(1922),
    [anon_sym_uint] = ACTIONS(1922),
    [anon_sym_ulong] = ACTIONS(1922),
    [anon_sym_ushort] = ACTIONS(1922),
    [anon_sym_abstract] = ACTIONS(1922),
    [anon_sym_async] = ACTIONS(1922),
    [anon_sym_extern] = ACTIONS(1922),
    [anon_sym_internal] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_override] = ACTIONS(1922),
    [anon_sym_private] = ACTIONS(1922),
    [anon_sym_protected] = ACTIONS(1922),
    [anon_sym_public] = ACTIONS(1922),
    [anon_sym_readonly] = ACTIONS(1922),
    [anon_sym_sealed] = ACTIONS(1922),
    [anon_sym_static] = ACTIONS(1922),
    [anon_sym_unsafe] = ACTIONS(1922),
    [anon_sym_virtual] = ACTIONS(1922),
    [anon_sym_volatile] = ACTIONS(1922),
    [anon_sym_RBRACE] = ACTIONS(1924),
    [anon_sym_partial] = ACTIONS(1922),
    [anon_sym_class] = ACTIONS(1922),
    [anon_sym_struct] = ACTIONS(1922),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_event] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1924),
    [anon_sym_implicit] = ACTIONS(1922),
    [anon_sym_explicit] = ACTIONS(1922),
    [anon_sym_interface] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1922),
    [anon_sym_delegate] = ACTIONS(1922),
    [sym_void_keyword] = ACTIONS(1922),
    [anon_sym_const] = ACTIONS(1922),
    [sym_identifier_name] = ACTIONS(1922),
    [sym_comment] = ACTIONS(31),
  },
  [695] = {
    [anon_sym_bool] = ACTIONS(1926),
    [anon_sym_byte] = ACTIONS(1926),
    [anon_sym_char] = ACTIONS(1926),
    [anon_sym_decimal] = ACTIONS(1926),
    [anon_sym_double] = ACTIONS(1926),
    [anon_sym_float] = ACTIONS(1926),
    [anon_sym_int] = ACTIONS(1926),
    [anon_sym_long] = ACTIONS(1926),
    [anon_sym_object] = ACTIONS(1926),
    [anon_sym_sbyte] = ACTIONS(1926),
    [anon_sym_short] = ACTIONS(1926),
    [anon_sym_string] = ACTIONS(1926),
    [anon_sym_uint] = ACTIONS(1926),
    [anon_sym_ulong] = ACTIONS(1926),
    [anon_sym_ushort] = ACTIONS(1926),
    [anon_sym_abstract] = ACTIONS(1926),
    [anon_sym_async] = ACTIONS(1926),
    [anon_sym_extern] = ACTIONS(1926),
    [anon_sym_internal] = ACTIONS(1926),
    [anon_sym_new] = ACTIONS(1926),
    [anon_sym_override] = ACTIONS(1926),
    [anon_sym_private] = ACTIONS(1926),
    [anon_sym_protected] = ACTIONS(1926),
    [anon_sym_public] = ACTIONS(1926),
    [anon_sym_readonly] = ACTIONS(1926),
    [anon_sym_sealed] = ACTIONS(1926),
    [anon_sym_static] = ACTIONS(1926),
    [anon_sym_unsafe] = ACTIONS(1926),
    [anon_sym_virtual] = ACTIONS(1926),
    [anon_sym_volatile] = ACTIONS(1926),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_partial] = ACTIONS(1926),
    [anon_sym_class] = ACTIONS(1926),
    [anon_sym_struct] = ACTIONS(1926),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_event] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1928),
    [anon_sym_implicit] = ACTIONS(1926),
    [anon_sym_explicit] = ACTIONS(1926),
    [anon_sym_interface] = ACTIONS(1926),
    [anon_sym_enum] = ACTIONS(1926),
    [anon_sym_delegate] = ACTIONS(1926),
    [sym_void_keyword] = ACTIONS(1926),
    [anon_sym_const] = ACTIONS(1926),
    [sym_identifier_name] = ACTIONS(1926),
    [sym_comment] = ACTIONS(31),
  },
  [696] = {
    [anon_sym_bool] = ACTIONS(1930),
    [anon_sym_byte] = ACTIONS(1930),
    [anon_sym_char] = ACTIONS(1930),
    [anon_sym_decimal] = ACTIONS(1930),
    [anon_sym_double] = ACTIONS(1930),
    [anon_sym_float] = ACTIONS(1930),
    [anon_sym_int] = ACTIONS(1930),
    [anon_sym_long] = ACTIONS(1930),
    [anon_sym_object] = ACTIONS(1930),
    [anon_sym_sbyte] = ACTIONS(1930),
    [anon_sym_short] = ACTIONS(1930),
    [anon_sym_string] = ACTIONS(1930),
    [anon_sym_uint] = ACTIONS(1930),
    [anon_sym_ulong] = ACTIONS(1930),
    [anon_sym_ushort] = ACTIONS(1930),
    [anon_sym_abstract] = ACTIONS(1930),
    [anon_sym_async] = ACTIONS(1930),
    [anon_sym_extern] = ACTIONS(1930),
    [anon_sym_internal] = ACTIONS(1930),
    [anon_sym_new] = ACTIONS(1930),
    [anon_sym_override] = ACTIONS(1930),
    [anon_sym_private] = ACTIONS(1930),
    [anon_sym_protected] = ACTIONS(1930),
    [anon_sym_public] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1930),
    [anon_sym_sealed] = ACTIONS(1930),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_unsafe] = ACTIONS(1930),
    [anon_sym_virtual] = ACTIONS(1930),
    [anon_sym_volatile] = ACTIONS(1930),
    [anon_sym_RBRACE] = ACTIONS(1932),
    [anon_sym_partial] = ACTIONS(1930),
    [anon_sym_class] = ACTIONS(1930),
    [anon_sym_struct] = ACTIONS(1930),
    [anon_sym_LBRACK] = ACTIONS(1932),
    [anon_sym_event] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1932),
    [anon_sym_implicit] = ACTIONS(1930),
    [anon_sym_explicit] = ACTIONS(1930),
    [anon_sym_interface] = ACTIONS(1930),
    [anon_sym_enum] = ACTIONS(1930),
    [anon_sym_delegate] = ACTIONS(1930),
    [sym_void_keyword] = ACTIONS(1930),
    [anon_sym_const] = ACTIONS(1930),
    [sym_identifier_name] = ACTIONS(1930),
    [sym_comment] = ACTIONS(31),
  },
  [697] = {
    [anon_sym_set] = ACTIONS(1455),
    [sym_comment] = ACTIONS(31),
  },
  [698] = {
    [sym__attribute_section] = STATE(698),
    [aux_sym__attributes_repeat1] = STATE(698),
    [anon_sym_internal] = ACTIONS(218),
    [anon_sym_private] = ACTIONS(218),
    [anon_sym_protected] = ACTIONS(218),
    [anon_sym_set] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(220),
    [sym_comment] = ACTIONS(31),
  },
  [699] = {
    [anon_sym_get] = ACTIONS(1453),
    [sym_comment] = ACTIONS(31),
  },
  [700] = {
    [sym__attribute_section] = STATE(700),
    [aux_sym__attributes_repeat1] = STATE(700),
    [anon_sym_internal] = ACTIONS(218),
    [anon_sym_private] = ACTIONS(218),
    [anon_sym_protected] = ACTIONS(218),
    [anon_sym_get] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(220),
    [sym_comment] = ACTIONS(31),
  },
  [701] = {
    [anon_sym_internal] = ACTIONS(1934),
    [anon_sym_private] = ACTIONS(1934),
    [anon_sym_protected] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_set] = ACTIONS(1934),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [sym_comment] = ACTIONS(31),
  },
  [702] = {
    [anon_sym_internal] = ACTIONS(1936),
    [anon_sym_private] = ACTIONS(1936),
    [anon_sym_protected] = ACTIONS(1936),
    [anon_sym_RBRACE] = ACTIONS(1936),
    [anon_sym_get] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1936),
    [sym_comment] = ACTIONS(31),
  },
  [703] = {
    [sym_statement_block] = STATE(858),
    [anon_sym_SEMI] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [704] = {
    [sym_statement_block] = STATE(859),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [705] = {
    [sym__expression] = STATE(860),
    [sym_parenthesized_expression] = STATE(860),
    [sym_ternary_expression] = STATE(860),
    [sym_binary_expression] = STATE(860),
    [sym_unary_expression] = STATE(860),
    [sym__literal] = STATE(860),
    [sym_boolean_literal] = STATE(860),
    [sym_character_literal] = STATE(860),
    [sym_integer_literal] = STATE(860),
    [sym_real_literal] = STATE(860),
    [sym_string_literal] = STATE(860),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1942),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1942),
    [sym_comment] = ACTIONS(31),
  },
  [706] = {
    [anon_sym_LT] = ACTIONS(1944),
    [anon_sym_COMMA] = ACTIONS(1946),
    [anon_sym_GT] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1946),
    [anon_sym_RBRACE] = ACTIONS(1946),
    [anon_sym_COLON] = ACTIONS(1946),
    [anon_sym_RPAREN] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_RBRACK] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1944),
    [anon_sym_PERCENT] = ACTIONS(1946),
    [anon_sym_CARET] = ACTIONS(1946),
    [anon_sym_PIPE] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1944),
    [anon_sym_LT_LT] = ACTIONS(1946),
    [anon_sym_GT_GT] = ACTIONS(1946),
    [anon_sym_EQ_EQ] = ACTIONS(1946),
    [anon_sym_BANG_EQ] = ACTIONS(1946),
    [anon_sym_GT_EQ] = ACTIONS(1946),
    [anon_sym_LT_EQ] = ACTIONS(1946),
    [anon_sym_params] = ACTIONS(1946),
    [anon_sym_QMARK] = ACTIONS(1946),
    [anon_sym_AMP_AMP] = ACTIONS(1946),
    [anon_sym_PIPE_PIPE] = ACTIONS(1946),
    [sym_comment] = ACTIONS(31),
  },
  [707] = {
    [sym__expression] = STATE(861),
    [sym_parenthesized_expression] = STATE(861),
    [sym_ternary_expression] = STATE(861),
    [sym_binary_expression] = STATE(861),
    [sym_unary_expression] = STATE(861),
    [sym__literal] = STATE(861),
    [sym_boolean_literal] = STATE(861),
    [sym_character_literal] = STATE(861),
    [sym_integer_literal] = STATE(861),
    [sym_real_literal] = STATE(861),
    [sym_string_literal] = STATE(861),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1948),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1948),
    [sym_comment] = ACTIONS(31),
  },
  [708] = {
    [sym__expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym__literal] = STATE(725),
    [sym_boolean_literal] = STATE(725),
    [sym_character_literal] = STATE(725),
    [sym_integer_literal] = STATE(725),
    [sym_real_literal] = STATE(725),
    [sym_string_literal] = STATE(725),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1519),
    [sym_comment] = ACTIONS(31),
  },
  [709] = {
    [sym__expression] = STATE(862),
    [sym_parenthesized_expression] = STATE(862),
    [sym_ternary_expression] = STATE(862),
    [sym_binary_expression] = STATE(862),
    [sym_unary_expression] = STATE(862),
    [sym__literal] = STATE(862),
    [sym_boolean_literal] = STATE(862),
    [sym_character_literal] = STATE(862),
    [sym_integer_literal] = STATE(862),
    [sym_real_literal] = STATE(862),
    [sym_string_literal] = STATE(862),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1950),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1950),
    [sym_comment] = ACTIONS(31),
  },
  [710] = {
    [sym__expression] = STATE(863),
    [sym_parenthesized_expression] = STATE(863),
    [sym_ternary_expression] = STATE(863),
    [sym_binary_expression] = STATE(863),
    [sym_unary_expression] = STATE(863),
    [sym__literal] = STATE(863),
    [sym_boolean_literal] = STATE(863),
    [sym_character_literal] = STATE(863),
    [sym_integer_literal] = STATE(863),
    [sym_real_literal] = STATE(863),
    [sym_string_literal] = STATE(863),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1952),
    [sym_comment] = ACTIONS(31),
  },
  [711] = {
    [sym__expression] = STATE(864),
    [sym_parenthesized_expression] = STATE(864),
    [sym_ternary_expression] = STATE(864),
    [sym_binary_expression] = STATE(864),
    [sym_unary_expression] = STATE(864),
    [sym__literal] = STATE(864),
    [sym_boolean_literal] = STATE(864),
    [sym_character_literal] = STATE(864),
    [sym_integer_literal] = STATE(864),
    [sym_real_literal] = STATE(864),
    [sym_string_literal] = STATE(864),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1954),
    [sym_comment] = ACTIONS(31),
  },
  [712] = {
    [sym__expression] = STATE(865),
    [sym_parenthesized_expression] = STATE(865),
    [sym_ternary_expression] = STATE(865),
    [sym_binary_expression] = STATE(865),
    [sym_unary_expression] = STATE(865),
    [sym__literal] = STATE(865),
    [sym_boolean_literal] = STATE(865),
    [sym_character_literal] = STATE(865),
    [sym_integer_literal] = STATE(865),
    [sym_real_literal] = STATE(865),
    [sym_string_literal] = STATE(865),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1956),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1956),
    [sym_comment] = ACTIONS(31),
  },
  [713] = {
    [sym__expression] = STATE(866),
    [sym_parenthesized_expression] = STATE(866),
    [sym_ternary_expression] = STATE(866),
    [sym_binary_expression] = STATE(866),
    [sym_unary_expression] = STATE(866),
    [sym__literal] = STATE(866),
    [sym_boolean_literal] = STATE(866),
    [sym_character_literal] = STATE(866),
    [sym_integer_literal] = STATE(866),
    [sym_real_literal] = STATE(866),
    [sym_string_literal] = STATE(866),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1958),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1958),
    [sym_comment] = ACTIONS(31),
  },
  [714] = {
    [sym__expression] = STATE(867),
    [sym_parenthesized_expression] = STATE(867),
    [sym_ternary_expression] = STATE(867),
    [sym_binary_expression] = STATE(867),
    [sym_unary_expression] = STATE(867),
    [sym__literal] = STATE(867),
    [sym_boolean_literal] = STATE(867),
    [sym_character_literal] = STATE(867),
    [sym_integer_literal] = STATE(867),
    [sym_real_literal] = STATE(867),
    [sym_string_literal] = STATE(867),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1960),
    [sym_comment] = ACTIONS(31),
  },
  [715] = {
    [sym__expression] = STATE(868),
    [sym_parenthesized_expression] = STATE(868),
    [sym_ternary_expression] = STATE(868),
    [sym_binary_expression] = STATE(868),
    [sym_unary_expression] = STATE(868),
    [sym__literal] = STATE(868),
    [sym_boolean_literal] = STATE(868),
    [sym_character_literal] = STATE(868),
    [sym_integer_literal] = STATE(868),
    [sym_real_literal] = STATE(868),
    [sym_string_literal] = STATE(868),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1962),
    [sym_comment] = ACTIONS(31),
  },
  [716] = {
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [anon_sym_RBRACK] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_params] = ACTIONS(1966),
    [anon_sym_QMARK] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1966),
    [sym_comment] = ACTIONS(31),
  },
  [717] = {
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [anon_sym_RBRACK] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_params] = ACTIONS(1966),
    [anon_sym_QMARK] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1966),
    [sym__real_type_suffix] = ACTIONS(1968),
    [sym_comment] = ACTIONS(31),
  },
  [718] = {
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_GT] = ACTIONS(1970),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_RBRACE] = ACTIONS(1972),
    [anon_sym_COLON] = ACTIONS(1972),
    [anon_sym_RPAREN] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_RBRACK] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_SLASH] = ACTIONS(1970),
    [anon_sym_PERCENT] = ACTIONS(1972),
    [anon_sym_CARET] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1970),
    [anon_sym_LT_LT] = ACTIONS(1972),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_EQ_EQ] = ACTIONS(1972),
    [anon_sym_BANG_EQ] = ACTIONS(1972),
    [anon_sym_GT_EQ] = ACTIONS(1972),
    [anon_sym_LT_EQ] = ACTIONS(1972),
    [anon_sym_params] = ACTIONS(1972),
    [anon_sym_QMARK] = ACTIONS(1972),
    [anon_sym_AMP_AMP] = ACTIONS(1972),
    [anon_sym_PIPE_PIPE] = ACTIONS(1972),
    [sym_comment] = ACTIONS(31),
  },
  [719] = {
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [anon_sym_RBRACK] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_GT_GT] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_params] = ACTIONS(1966),
    [anon_sym_QMARK] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1966),
    [sym__real_type_suffix] = ACTIONS(1968),
    [sym__exponent_part] = ACTIONS(1974),
    [sym_comment] = ACTIONS(31),
  },
  [720] = {
    [anon_sym_LT] = ACTIONS(1976),
    [anon_sym_COMMA] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1978),
    [anon_sym_COLON] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1978),
    [anon_sym_LBRACK] = ACTIONS(1978),
    [anon_sym_RBRACK] = ACTIONS(1978),
    [anon_sym_PLUS] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_SLASH] = ACTIONS(1976),
    [anon_sym_PERCENT] = ACTIONS(1978),
    [anon_sym_CARET] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1976),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym_LT_LT] = ACTIONS(1978),
    [anon_sym_GT_GT] = ACTIONS(1978),
    [anon_sym_EQ_EQ] = ACTIONS(1978),
    [anon_sym_BANG_EQ] = ACTIONS(1978),
    [anon_sym_GT_EQ] = ACTIONS(1978),
    [anon_sym_LT_EQ] = ACTIONS(1978),
    [anon_sym_params] = ACTIONS(1978),
    [anon_sym_QMARK] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_PIPE_PIPE] = ACTIONS(1978),
    [sym_comment] = ACTIONS(31),
  },
  [721] = {
    [sym__unicode_escape_sequence] = STATE(721),
    [sym__simple_escape_sequence] = STATE(721),
    [sym__regular_string_literal_character] = STATE(721),
    [aux_sym__regular_string_literal_repeat1] = STATE(721),
    [sym__hexadecimal_escape_sequence] = ACTIONS(1980),
    [aux_sym_SLASH_BSLASH_BSLASHu_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1980),
    [aux_sym_SLASH_BSLASH_BSLASHU_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_SLASH] = ACTIONS(1980),
    [anon_sym_BSLASH_SQUOTE] = ACTIONS(1980),
    [anon_sym_BSLASH_DQUOTE] = ACTIONS(1980),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1980),
    [anon_sym_BSLASH0] = ACTIONS(1980),
    [anon_sym_BSLASHa] = ACTIONS(1980),
    [anon_sym_BSLASHb] = ACTIONS(1980),
    [anon_sym_BSLASHf] = ACTIONS(1980),
    [anon_sym_BSLASHn] = ACTIONS(1980),
    [anon_sym_BSLASHr] = ACTIONS(1980),
    [anon_sym_BSLASHt] = ACTIONS(1980),
    [anon_sym_BSLASHv] = ACTIONS(1980),
    [anon_sym_DQUOTE] = ACTIONS(1983),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_SLASH] = ACTIONS(1980),
    [sym_comment] = ACTIONS(1082),
  },
  [722] = {
    [anon_sym_LT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1985),
    [anon_sym_SEMI] = ACTIONS(1987),
    [anon_sym_RBRACE] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_RPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_RBRACK] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1985),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_PIPE] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1987),
    [anon_sym_BANG_EQ] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_params] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1987),
    [anon_sym_AMP_AMP] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1987),
    [sym_comment] = ACTIONS(31),
  },
  [723] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [724] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [725] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1989),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [726] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [727] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [728] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [729] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [730] = {
    [sym__expression] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_ternary_expression] = STATE(523),
    [sym_binary_expression] = STATE(523),
    [sym_unary_expression] = STATE(523),
    [sym__literal] = STATE(523),
    [sym_boolean_literal] = STATE(523),
    [sym_character_literal] = STATE(523),
    [sym_integer_literal] = STATE(523),
    [sym_real_literal] = STATE(523),
    [sym_string_literal] = STATE(523),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1074),
    [sym_comment] = ACTIONS(31),
  },
  [731] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [732] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [733] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [734] = {
    [anon_sym_SEMI] = ACTIONS(2021),
    [sym_comment] = ACTIONS(31),
  },
  [735] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [736] = {
    [anon_sym_bool] = ACTIONS(2023),
    [anon_sym_byte] = ACTIONS(2023),
    [anon_sym_char] = ACTIONS(2023),
    [anon_sym_decimal] = ACTIONS(2023),
    [anon_sym_double] = ACTIONS(2023),
    [anon_sym_float] = ACTIONS(2023),
    [anon_sym_int] = ACTIONS(2023),
    [anon_sym_long] = ACTIONS(2023),
    [anon_sym_object] = ACTIONS(2023),
    [anon_sym_sbyte] = ACTIONS(2023),
    [anon_sym_short] = ACTIONS(2023),
    [anon_sym_string] = ACTIONS(2023),
    [anon_sym_uint] = ACTIONS(2023),
    [anon_sym_ulong] = ACTIONS(2023),
    [anon_sym_ushort] = ACTIONS(2023),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_LBRACE] = ACTIONS(2025),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_DOT] = ACTIONS(2025),
    [anon_sym_PLUS] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2025),
    [anon_sym_TILDE] = ACTIONS(2025),
    [anon_sym_PLUS_PLUS] = ACTIONS(2025),
    [anon_sym_DASH_DASH] = ACTIONS(2025),
    [anon_sym_true] = ACTIONS(2023),
    [anon_sym_false] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2023),
    [anon_sym_typeof] = ACTIONS(2023),
    [anon_sym_sizeof] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2025),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2023),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2025),
    [sym_null_literal] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2025),
    [anon_sym_AT_DQUOTE] = ACTIONS(2025),
    [sym_identifier_name] = ACTIONS(2023),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2023),
    [anon_sym_checked] = ACTIONS(2023),
    [anon_sym_unchecked] = ACTIONS(2023),
    [anon_sym_lock] = ACTIONS(2023),
    [anon_sym_yield] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2023),
    [anon_sym_break] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(2023),
    [anon_sym_switch] = ACTIONS(2023),
    [anon_sym_case] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(2023),
    [anon_sym_while] = ACTIONS(2023),
    [anon_sym_do] = ACTIONS(2023),
    [anon_sym_continue] = ACTIONS(2023),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_goto] = ACTIONS(2023),
    [anon_sym_var] = ACTIONS(2023),
  },
  [737] = {
    [anon_sym_bool] = ACTIONS(2027),
    [anon_sym_byte] = ACTIONS(2027),
    [anon_sym_char] = ACTIONS(2027),
    [anon_sym_decimal] = ACTIONS(2027),
    [anon_sym_double] = ACTIONS(2027),
    [anon_sym_float] = ACTIONS(2027),
    [anon_sym_int] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_object] = ACTIONS(2027),
    [anon_sym_sbyte] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_string] = ACTIONS(2027),
    [anon_sym_uint] = ACTIONS(2027),
    [anon_sym_ulong] = ACTIONS(2027),
    [anon_sym_ushort] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_DOT] = ACTIONS(2029),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(2027),
    [anon_sym_false] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_typeof] = ACTIONS(2027),
    [anon_sym_sizeof] = ACTIONS(2027),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2027),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2029),
    [sym_null_literal] = ACTIONS(2027),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_AT_DQUOTE] = ACTIONS(2029),
    [sym_identifier_name] = ACTIONS(2027),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_checked] = ACTIONS(2027),
    [anon_sym_unchecked] = ACTIONS(2027),
    [anon_sym_lock] = ACTIONS(2027),
    [anon_sym_yield] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_case] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_goto] = ACTIONS(2027),
    [anon_sym_var] = ACTIONS(2027),
  },
  [738] = {
    [sym_statement_block] = STATE(884),
    [sym__exception_specifier] = STATE(885),
    [sym__exception_filter] = STATE(886),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(2031),
    [sym_comment] = ACTIONS(31),
    [anon_sym_when] = ACTIONS(2033),
  },
  [739] = {
    [sym_statement_block] = STATE(887),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [740] = {
    [anon_sym_bool] = ACTIONS(2035),
    [anon_sym_byte] = ACTIONS(2035),
    [anon_sym_char] = ACTIONS(2035),
    [anon_sym_decimal] = ACTIONS(2035),
    [anon_sym_double] = ACTIONS(2035),
    [anon_sym_float] = ACTIONS(2035),
    [anon_sym_int] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_object] = ACTIONS(2035),
    [anon_sym_sbyte] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_string] = ACTIONS(2035),
    [anon_sym_uint] = ACTIONS(2035),
    [anon_sym_ulong] = ACTIONS(2035),
    [anon_sym_ushort] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_typeof] = ACTIONS(2035),
    [anon_sym_sizeof] = ACTIONS(2035),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2035),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2037),
    [sym_null_literal] = ACTIONS(2035),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_AT_DQUOTE] = ACTIONS(2037),
    [sym_identifier_name] = ACTIONS(2035),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2035),
    [anon_sym_checked] = ACTIONS(2035),
    [anon_sym_unchecked] = ACTIONS(2035),
    [anon_sym_lock] = ACTIONS(2035),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_else] = ACTIONS(2035),
    [anon_sym_switch] = ACTIONS(2035),
    [anon_sym_case] = ACTIONS(2035),
    [anon_sym_default] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_do] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_throw] = ACTIONS(2035),
    [anon_sym_goto] = ACTIONS(2035),
    [anon_sym_var] = ACTIONS(2035),
  },
  [741] = {
    [sym_catch_clause] = STATE(889),
    [sym_finally_clause] = STATE(888),
    [aux_sym_try_statement_repeat1] = STATE(889),
    [anon_sym_bool] = ACTIONS(2035),
    [anon_sym_byte] = ACTIONS(2035),
    [anon_sym_char] = ACTIONS(2035),
    [anon_sym_decimal] = ACTIONS(2035),
    [anon_sym_double] = ACTIONS(2035),
    [anon_sym_float] = ACTIONS(2035),
    [anon_sym_int] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_object] = ACTIONS(2035),
    [anon_sym_sbyte] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_string] = ACTIONS(2035),
    [anon_sym_uint] = ACTIONS(2035),
    [anon_sym_ulong] = ACTIONS(2035),
    [anon_sym_ushort] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_typeof] = ACTIONS(2035),
    [anon_sym_sizeof] = ACTIONS(2035),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2035),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2037),
    [sym_null_literal] = ACTIONS(2035),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_AT_DQUOTE] = ACTIONS(2037),
    [sym_identifier_name] = ACTIONS(2035),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2035),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(2035),
    [anon_sym_unchecked] = ACTIONS(2035),
    [anon_sym_lock] = ACTIONS(2035),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_switch] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_do] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_throw] = ACTIONS(2035),
    [anon_sym_goto] = ACTIONS(2035),
    [anon_sym_var] = ACTIONS(2035),
  },
  [742] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2039),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [743] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(2041),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [744] = {
    [anon_sym_bool] = ACTIONS(2043),
    [anon_sym_byte] = ACTIONS(2043),
    [anon_sym_char] = ACTIONS(2043),
    [anon_sym_decimal] = ACTIONS(2043),
    [anon_sym_double] = ACTIONS(2043),
    [anon_sym_float] = ACTIONS(2043),
    [anon_sym_int] = ACTIONS(2043),
    [anon_sym_long] = ACTIONS(2043),
    [anon_sym_object] = ACTIONS(2043),
    [anon_sym_sbyte] = ACTIONS(2043),
    [anon_sym_short] = ACTIONS(2043),
    [anon_sym_string] = ACTIONS(2043),
    [anon_sym_uint] = ACTIONS(2043),
    [anon_sym_ulong] = ACTIONS(2043),
    [anon_sym_ushort] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(2045),
    [anon_sym_DOT] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(2043),
    [anon_sym_false] = ACTIONS(2043),
    [anon_sym_const] = ACTIONS(2043),
    [anon_sym_typeof] = ACTIONS(2043),
    [anon_sym_sizeof] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2043),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2045),
    [sym_null_literal] = ACTIONS(2043),
    [anon_sym_DQUOTE] = ACTIONS(2045),
    [anon_sym_AT_DQUOTE] = ACTIONS(2045),
    [sym_identifier_name] = ACTIONS(2043),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2043),
    [anon_sym_checked] = ACTIONS(2043),
    [anon_sym_unchecked] = ACTIONS(2043),
    [anon_sym_lock] = ACTIONS(2043),
    [anon_sym_yield] = ACTIONS(2043),
    [anon_sym_return] = ACTIONS(2043),
    [anon_sym_break] = ACTIONS(2043),
    [anon_sym_if] = ACTIONS(2043),
    [anon_sym_else] = ACTIONS(2043),
    [anon_sym_switch] = ACTIONS(2043),
    [anon_sym_case] = ACTIONS(2043),
    [anon_sym_default] = ACTIONS(2043),
    [anon_sym_while] = ACTIONS(2043),
    [anon_sym_do] = ACTIONS(2043),
    [anon_sym_continue] = ACTIONS(2043),
    [anon_sym_throw] = ACTIONS(2043),
    [anon_sym_goto] = ACTIONS(2043),
    [anon_sym_var] = ACTIONS(2043),
  },
  [745] = {
    [anon_sym_bool] = ACTIONS(2047),
    [anon_sym_byte] = ACTIONS(2047),
    [anon_sym_char] = ACTIONS(2047),
    [anon_sym_decimal] = ACTIONS(2047),
    [anon_sym_double] = ACTIONS(2047),
    [anon_sym_float] = ACTIONS(2047),
    [anon_sym_int] = ACTIONS(2047),
    [anon_sym_long] = ACTIONS(2047),
    [anon_sym_object] = ACTIONS(2047),
    [anon_sym_sbyte] = ACTIONS(2047),
    [anon_sym_short] = ACTIONS(2047),
    [anon_sym_string] = ACTIONS(2047),
    [anon_sym_uint] = ACTIONS(2047),
    [anon_sym_ulong] = ACTIONS(2047),
    [anon_sym_ushort] = ACTIONS(2047),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(2049),
    [anon_sym_DOT] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2047),
    [anon_sym_DASH] = ACTIONS(2047),
    [anon_sym_BANG] = ACTIONS(2049),
    [anon_sym_TILDE] = ACTIONS(2049),
    [anon_sym_PLUS_PLUS] = ACTIONS(2049),
    [anon_sym_DASH_DASH] = ACTIONS(2049),
    [anon_sym_true] = ACTIONS(2047),
    [anon_sym_false] = ACTIONS(2047),
    [anon_sym_const] = ACTIONS(2047),
    [anon_sym_typeof] = ACTIONS(2047),
    [anon_sym_sizeof] = ACTIONS(2047),
    [anon_sym_SQUOTE] = ACTIONS(2049),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2047),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2049),
    [sym_null_literal] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2049),
    [anon_sym_AT_DQUOTE] = ACTIONS(2049),
    [sym_identifier_name] = ACTIONS(2047),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2047),
    [anon_sym_checked] = ACTIONS(2047),
    [anon_sym_unchecked] = ACTIONS(2047),
    [anon_sym_lock] = ACTIONS(2047),
    [anon_sym_yield] = ACTIONS(2047),
    [anon_sym_return] = ACTIONS(2047),
    [anon_sym_break] = ACTIONS(2047),
    [anon_sym_if] = ACTIONS(2047),
    [anon_sym_else] = ACTIONS(2047),
    [anon_sym_switch] = ACTIONS(2047),
    [anon_sym_case] = ACTIONS(2047),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_while] = ACTIONS(2047),
    [anon_sym_do] = ACTIONS(2047),
    [anon_sym_continue] = ACTIONS(2047),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_goto] = ACTIONS(2047),
    [anon_sym_var] = ACTIONS(2047),
  },
  [746] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2051),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [747] = {
    [anon_sym_RPAREN] = ACTIONS(2053),
    [sym_comment] = ACTIONS(31),
  },
  [748] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2055),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [749] = {
    [anon_sym_RPAREN] = ACTIONS(2057),
    [sym_comment] = ACTIONS(31),
  },
  [750] = {
    [sym_catch_clause] = STATE(895),
    [sym_finally_clause] = STATE(740),
    [aux_sym_try_statement_repeat1] = STATE(895),
    [sym_comment] = ACTIONS(31),
    [anon_sym_catch] = ACTIONS(2059),
    [anon_sym_finally] = ACTIONS(2061),
    [anon_sym_while] = ACTIONS(1545),
  },
  [751] = {
    [sym__expression] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym_ternary_expression] = STATE(896),
    [sym_binary_expression] = STATE(896),
    [sym_unary_expression] = STATE(896),
    [sym__literal] = STATE(896),
    [sym_boolean_literal] = STATE(896),
    [sym_character_literal] = STATE(896),
    [sym_integer_literal] = STATE(896),
    [sym_real_literal] = STATE(896),
    [sym_string_literal] = STATE(896),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2063),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2063),
    [sym_comment] = ACTIONS(31),
  },
  [752] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(897),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [753] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(898),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [754] = {
    [anon_sym_LPAREN] = ACTIONS(2065),
    [sym_comment] = ACTIONS(31),
  },
  [755] = {
    [anon_sym_bool] = ACTIONS(2067),
    [anon_sym_byte] = ACTIONS(2067),
    [anon_sym_char] = ACTIONS(2067),
    [anon_sym_decimal] = ACTIONS(2067),
    [anon_sym_double] = ACTIONS(2067),
    [anon_sym_float] = ACTIONS(2067),
    [anon_sym_int] = ACTIONS(2067),
    [anon_sym_long] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [anon_sym_sbyte] = ACTIONS(2067),
    [anon_sym_short] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_uint] = ACTIONS(2067),
    [anon_sym_ulong] = ACTIONS(2067),
    [anon_sym_ushort] = ACTIONS(2067),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_DOT] = ACTIONS(2069),
    [anon_sym_PLUS] = ACTIONS(2067),
    [anon_sym_DASH] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_PLUS_PLUS] = ACTIONS(2069),
    [anon_sym_DASH_DASH] = ACTIONS(2069),
    [anon_sym_true] = ACTIONS(2067),
    [anon_sym_false] = ACTIONS(2067),
    [anon_sym_const] = ACTIONS(2067),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_sizeof] = ACTIONS(2067),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2067),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2069),
    [sym_null_literal] = ACTIONS(2067),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_AT_DQUOTE] = ACTIONS(2069),
    [sym_identifier_name] = ACTIONS(2067),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2067),
    [anon_sym_checked] = ACTIONS(2067),
    [anon_sym_unchecked] = ACTIONS(2067),
    [anon_sym_lock] = ACTIONS(2067),
    [anon_sym_yield] = ACTIONS(2067),
    [anon_sym_return] = ACTIONS(2067),
    [anon_sym_break] = ACTIONS(2067),
    [anon_sym_if] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2067),
    [anon_sym_switch] = ACTIONS(2067),
    [anon_sym_case] = ACTIONS(2067),
    [anon_sym_default] = ACTIONS(2067),
    [anon_sym_while] = ACTIONS(2067),
    [anon_sym_do] = ACTIONS(2067),
    [anon_sym_continue] = ACTIONS(2067),
    [anon_sym_throw] = ACTIONS(2067),
    [anon_sym_goto] = ACTIONS(2067),
    [anon_sym_var] = ACTIONS(2067),
  },
  [756] = {
    [anon_sym_bool] = ACTIONS(2071),
    [anon_sym_byte] = ACTIONS(2071),
    [anon_sym_char] = ACTIONS(2071),
    [anon_sym_decimal] = ACTIONS(2071),
    [anon_sym_double] = ACTIONS(2071),
    [anon_sym_float] = ACTIONS(2071),
    [anon_sym_int] = ACTIONS(2071),
    [anon_sym_long] = ACTIONS(2071),
    [anon_sym_object] = ACTIONS(2071),
    [anon_sym_sbyte] = ACTIONS(2071),
    [anon_sym_short] = ACTIONS(2071),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_uint] = ACTIONS(2071),
    [anon_sym_ulong] = ACTIONS(2071),
    [anon_sym_ushort] = ACTIONS(2071),
    [anon_sym_SEMI] = ACTIONS(2073),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_LPAREN] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(2073),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2073),
    [anon_sym_DASH_DASH] = ACTIONS(2073),
    [anon_sym_true] = ACTIONS(2071),
    [anon_sym_false] = ACTIONS(2071),
    [anon_sym_const] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(2071),
    [anon_sym_sizeof] = ACTIONS(2071),
    [anon_sym_SQUOTE] = ACTIONS(2073),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2071),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2073),
    [sym_null_literal] = ACTIONS(2071),
    [anon_sym_DQUOTE] = ACTIONS(2073),
    [anon_sym_AT_DQUOTE] = ACTIONS(2073),
    [sym_identifier_name] = ACTIONS(2071),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2071),
    [anon_sym_checked] = ACTIONS(2071),
    [anon_sym_unchecked] = ACTIONS(2071),
    [anon_sym_lock] = ACTIONS(2071),
    [anon_sym_yield] = ACTIONS(2071),
    [anon_sym_return] = ACTIONS(2071),
    [anon_sym_break] = ACTIONS(2071),
    [anon_sym_if] = ACTIONS(2071),
    [anon_sym_else] = ACTIONS(2071),
    [anon_sym_switch] = ACTIONS(2071),
    [anon_sym_case] = ACTIONS(2071),
    [anon_sym_default] = ACTIONS(2071),
    [anon_sym_while] = ACTIONS(2071),
    [anon_sym_do] = ACTIONS(2071),
    [anon_sym_continue] = ACTIONS(2071),
    [anon_sym_throw] = ACTIONS(2071),
    [anon_sym_goto] = ACTIONS(2071),
    [anon_sym_var] = ACTIONS(2071),
  },
  [757] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1262),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [758] = {
    [anon_sym_SEMI] = ACTIONS(2075),
    [sym_comment] = ACTIONS(31),
  },
  [759] = {
    [anon_sym_bool] = ACTIONS(2077),
    [anon_sym_byte] = ACTIONS(2077),
    [anon_sym_char] = ACTIONS(2077),
    [anon_sym_decimal] = ACTIONS(2077),
    [anon_sym_double] = ACTIONS(2077),
    [anon_sym_float] = ACTIONS(2077),
    [anon_sym_int] = ACTIONS(2077),
    [anon_sym_long] = ACTIONS(2077),
    [anon_sym_object] = ACTIONS(2077),
    [anon_sym_sbyte] = ACTIONS(2077),
    [anon_sym_short] = ACTIONS(2077),
    [anon_sym_string] = ACTIONS(2077),
    [anon_sym_uint] = ACTIONS(2077),
    [anon_sym_ulong] = ACTIONS(2077),
    [anon_sym_ushort] = ACTIONS(2077),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2079),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_LPAREN] = ACTIONS(2079),
    [anon_sym_DOT] = ACTIONS(2079),
    [anon_sym_PLUS] = ACTIONS(2077),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [anon_sym_PLUS_PLUS] = ACTIONS(2079),
    [anon_sym_DASH_DASH] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(2077),
    [anon_sym_false] = ACTIONS(2077),
    [anon_sym_const] = ACTIONS(2077),
    [anon_sym_typeof] = ACTIONS(2077),
    [anon_sym_sizeof] = ACTIONS(2077),
    [anon_sym_SQUOTE] = ACTIONS(2079),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2077),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2079),
    [sym_null_literal] = ACTIONS(2077),
    [anon_sym_DQUOTE] = ACTIONS(2079),
    [anon_sym_AT_DQUOTE] = ACTIONS(2079),
    [sym_identifier_name] = ACTIONS(2077),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2077),
    [anon_sym_checked] = ACTIONS(2077),
    [anon_sym_unchecked] = ACTIONS(2077),
    [anon_sym_lock] = ACTIONS(2077),
    [anon_sym_yield] = ACTIONS(2077),
    [anon_sym_return] = ACTIONS(2077),
    [anon_sym_break] = ACTIONS(2077),
    [anon_sym_if] = ACTIONS(2077),
    [anon_sym_else] = ACTIONS(2077),
    [anon_sym_switch] = ACTIONS(2077),
    [anon_sym_case] = ACTIONS(2077),
    [anon_sym_default] = ACTIONS(2077),
    [anon_sym_while] = ACTIONS(2077),
    [anon_sym_do] = ACTIONS(2077),
    [anon_sym_continue] = ACTIONS(2077),
    [anon_sym_throw] = ACTIONS(2077),
    [anon_sym_goto] = ACTIONS(2077),
    [anon_sym_var] = ACTIONS(2077),
  },
  [760] = {
    [sym_array_initalizer] = STATE(902),
    [sym__expression] = STATE(903),
    [sym_parenthesized_expression] = STATE(903),
    [sym_ternary_expression] = STATE(903),
    [sym_binary_expression] = STATE(903),
    [sym_unary_expression] = STATE(903),
    [sym__literal] = STATE(903),
    [sym_boolean_literal] = STATE(903),
    [sym_character_literal] = STATE(903),
    [sym_integer_literal] = STATE(903),
    [sym_real_literal] = STATE(903),
    [sym_string_literal] = STATE(903),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_local_variable_initializer] = STATE(904),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2083),
    [sym_comment] = ACTIONS(31),
  },
  [761] = {
    [sym_local_variable_declarator] = STATE(905),
    [sym_identifier_name] = ACTIONS(1195),
    [sym_comment] = ACTIONS(31),
  },
  [762] = {
    [sym_identifier_name] = ACTIONS(2085),
    [sym_comment] = ACTIONS(31),
  },
  [763] = {
    [sym_statement_block] = STATE(907),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [764] = {
    [sym_type_parameter_list] = STATE(908),
    [sym_parameter_list] = STATE(855),
    [anon_sym_LT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [765] = {
    [anon_sym_LBRACE] = ACTIONS(2087),
    [sym_comment] = ACTIONS(31),
  },
  [766] = {
    [anon_sym_SEMI] = ACTIONS(2089),
    [sym_comment] = ACTIONS(31),
  },
  [767] = {
    [sym_statement_block] = STATE(911),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [768] = {
    [anon_sym_bool] = ACTIONS(2091),
    [anon_sym_byte] = ACTIONS(2091),
    [anon_sym_char] = ACTIONS(2091),
    [anon_sym_decimal] = ACTIONS(2091),
    [anon_sym_double] = ACTIONS(2091),
    [anon_sym_float] = ACTIONS(2091),
    [anon_sym_int] = ACTIONS(2091),
    [anon_sym_long] = ACTIONS(2091),
    [anon_sym_object] = ACTIONS(2091),
    [anon_sym_sbyte] = ACTIONS(2091),
    [anon_sym_short] = ACTIONS(2091),
    [anon_sym_string] = ACTIONS(2091),
    [anon_sym_uint] = ACTIONS(2091),
    [anon_sym_ulong] = ACTIONS(2091),
    [anon_sym_ushort] = ACTIONS(2091),
    [anon_sym_abstract] = ACTIONS(2091),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_extern] = ACTIONS(2091),
    [anon_sym_internal] = ACTIONS(2091),
    [anon_sym_new] = ACTIONS(2091),
    [anon_sym_override] = ACTIONS(2091),
    [anon_sym_private] = ACTIONS(2091),
    [anon_sym_protected] = ACTIONS(2091),
    [anon_sym_public] = ACTIONS(2091),
    [anon_sym_readonly] = ACTIONS(2091),
    [anon_sym_sealed] = ACTIONS(2091),
    [anon_sym_static] = ACTIONS(2091),
    [anon_sym_unsafe] = ACTIONS(2091),
    [anon_sym_virtual] = ACTIONS(2091),
    [anon_sym_volatile] = ACTIONS(2091),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_partial] = ACTIONS(2091),
    [anon_sym_class] = ACTIONS(2091),
    [anon_sym_struct] = ACTIONS(2091),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [anon_sym_event] = ACTIONS(2091),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_implicit] = ACTIONS(2091),
    [anon_sym_explicit] = ACTIONS(2091),
    [anon_sym_interface] = ACTIONS(2091),
    [anon_sym_enum] = ACTIONS(2091),
    [anon_sym_delegate] = ACTIONS(2091),
    [sym_void_keyword] = ACTIONS(2091),
    [anon_sym_const] = ACTIONS(2091),
    [sym_identifier_name] = ACTIONS(2091),
    [sym_comment] = ACTIONS(31),
  },
  [769] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [770] = {
    [aux_sym_class_base_repeat1] = STATE(914),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_where] = ACTIONS(2099),
    [sym_comment] = ACTIONS(31),
  },
  [771] = {
    [anon_sym_SEMI] = ACTIONS(2099),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_where] = ACTIONS(2099),
    [sym_comment] = ACTIONS(31),
  },
  [772] = {
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_LBRACE] = ACTIONS(2101),
    [anon_sym_where] = ACTIONS(2101),
    [sym_comment] = ACTIONS(31),
  },
  [773] = {
    [anon_sym_bool] = ACTIONS(2103),
    [anon_sym_byte] = ACTIONS(2103),
    [anon_sym_char] = ACTIONS(2103),
    [anon_sym_decimal] = ACTIONS(2103),
    [anon_sym_double] = ACTIONS(2103),
    [anon_sym_float] = ACTIONS(2103),
    [anon_sym_int] = ACTIONS(2103),
    [anon_sym_long] = ACTIONS(2103),
    [anon_sym_object] = ACTIONS(2103),
    [anon_sym_sbyte] = ACTIONS(2103),
    [anon_sym_short] = ACTIONS(2103),
    [anon_sym_string] = ACTIONS(2103),
    [anon_sym_uint] = ACTIONS(2103),
    [anon_sym_ulong] = ACTIONS(2103),
    [anon_sym_ushort] = ACTIONS(2103),
    [anon_sym_new] = ACTIONS(2103),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_event] = ACTIONS(2103),
    [sym_void_keyword] = ACTIONS(2103),
    [sym_identifier_name] = ACTIONS(2103),
    [sym_comment] = ACTIONS(31),
  },
  [774] = {
    [anon_sym_bool] = ACTIONS(2107),
    [anon_sym_byte] = ACTIONS(2107),
    [anon_sym_char] = ACTIONS(2107),
    [anon_sym_decimal] = ACTIONS(2107),
    [anon_sym_double] = ACTIONS(2107),
    [anon_sym_float] = ACTIONS(2107),
    [anon_sym_int] = ACTIONS(2107),
    [anon_sym_long] = ACTIONS(2107),
    [anon_sym_object] = ACTIONS(2107),
    [anon_sym_sbyte] = ACTIONS(2107),
    [anon_sym_short] = ACTIONS(2107),
    [anon_sym_string] = ACTIONS(2107),
    [anon_sym_uint] = ACTIONS(2107),
    [anon_sym_ulong] = ACTIONS(2107),
    [anon_sym_ushort] = ACTIONS(2107),
    [anon_sym_new] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2109),
    [anon_sym_event] = ACTIONS(2107),
    [sym_void_keyword] = ACTIONS(2107),
    [sym_identifier_name] = ACTIONS(2107),
    [sym_comment] = ACTIONS(31),
  },
  [775] = {
    [sym_type_parameter_constraints_clause] = STATE(916),
    [aux_sym_class_declaration_repeat1] = STATE(916),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [776] = {
    [sym_type_parameter_constraints_clause] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(598),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [777] = {
    [anon_sym_RBRACK] = ACTIONS(2113),
    [sym_comment] = ACTIONS(31),
  },
  [778] = {
    [sym_interface_accessor] = STATE(784),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(784),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [779] = {
    [sym_type_parameter_constraints] = STATE(405),
    [sym_constructor_constraint] = STATE(406),
    [anon_sym_object] = ACTIONS(2117),
    [anon_sym_string] = ACTIONS(2117),
    [anon_sym_new] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(2117),
    [anon_sym_dynamic] = ACTIONS(2117),
    [anon_sym_struct] = ACTIONS(2117),
    [sym_identifier_name] = ACTIONS(2117),
    [sym_comment] = ACTIONS(31),
  },
  [780] = {
    [anon_sym_LBRACE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(31),
  },
  [781] = {
    [anon_sym_RBRACE] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2121),
    [sym_comment] = ACTIONS(31),
  },
  [782] = {
    [anon_sym_SEMI] = ACTIONS(2123),
    [sym_comment] = ACTIONS(31),
  },
  [783] = {
    [anon_sym_bool] = ACTIONS(2125),
    [anon_sym_byte] = ACTIONS(2125),
    [anon_sym_char] = ACTIONS(2125),
    [anon_sym_decimal] = ACTIONS(2125),
    [anon_sym_double] = ACTIONS(2125),
    [anon_sym_float] = ACTIONS(2125),
    [anon_sym_int] = ACTIONS(2125),
    [anon_sym_long] = ACTIONS(2125),
    [anon_sym_object] = ACTIONS(2125),
    [anon_sym_sbyte] = ACTIONS(2125),
    [anon_sym_short] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_uint] = ACTIONS(2125),
    [anon_sym_ulong] = ACTIONS(2125),
    [anon_sym_ushort] = ACTIONS(2125),
    [anon_sym_new] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2127),
    [anon_sym_LBRACK] = ACTIONS(2127),
    [anon_sym_event] = ACTIONS(2125),
    [sym_void_keyword] = ACTIONS(2125),
    [sym_identifier_name] = ACTIONS(2125),
    [sym_comment] = ACTIONS(31),
  },
  [784] = {
    [sym_interface_accessor] = STATE(784),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(784),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_get] = ACTIONS(2131),
    [anon_sym_set] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [sym_comment] = ACTIONS(31),
  },
  [785] = {
    [sym__attribute_section] = STATE(785),
    [aux_sym__attributes_repeat1] = STATE(785),
    [anon_sym_get] = ACTIONS(218),
    [anon_sym_set] = ACTIONS(218),
    [anon_sym_LBRACK] = ACTIONS(220),
    [sym_comment] = ACTIONS(31),
  },
  [786] = {
    [anon_sym_SEMI] = ACTIONS(2137),
    [sym_comment] = ACTIONS(31),
  },
  [787] = {
    [sym_type_parameter_constraints_clause] = STATE(916),
    [sym_parameter_list] = STATE(923),
    [aux_sym_class_declaration_repeat1] = STATE(916),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_where] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [788] = {
    [sym__type] = STATE(484),
    [sym_predefined_type] = STATE(484),
    [sym__formal_parameter_list] = STATE(924),
    [sym_parameter] = STATE(486),
    [sym_parameter_modifier] = STATE(487),
    [sym_parameter_array] = STATE(924),
    [sym__attributes] = STATE(488),
    [sym__attribute_section] = STATE(280),
    [sym_generic_name] = STATE(484),
    [aux_sym__attributes_repeat1] = STATE(280),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [anon_sym_params] = ACTIONS(505),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [789] = {
    [sym_interface_accessor] = STATE(925),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(925),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [790] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [791] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [792] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [793] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [794] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [795] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [796] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [797] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [798] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [799] = {
    [ts_builtin_sym_end] = ACTIONS(2141),
    [anon_sym_bool] = ACTIONS(2143),
    [anon_sym_byte] = ACTIONS(2143),
    [anon_sym_char] = ACTIONS(2143),
    [anon_sym_decimal] = ACTIONS(2143),
    [anon_sym_double] = ACTIONS(2143),
    [anon_sym_float] = ACTIONS(2143),
    [anon_sym_int] = ACTIONS(2143),
    [anon_sym_long] = ACTIONS(2143),
    [anon_sym_object] = ACTIONS(2143),
    [anon_sym_sbyte] = ACTIONS(2143),
    [anon_sym_short] = ACTIONS(2143),
    [anon_sym_string] = ACTIONS(2143),
    [anon_sym_uint] = ACTIONS(2143),
    [anon_sym_ulong] = ACTIONS(2143),
    [anon_sym_ushort] = ACTIONS(2143),
    [anon_sym_abstract] = ACTIONS(2143),
    [anon_sym_async] = ACTIONS(2143),
    [anon_sym_extern] = ACTIONS(2143),
    [anon_sym_internal] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2143),
    [anon_sym_override] = ACTIONS(2143),
    [anon_sym_private] = ACTIONS(2143),
    [anon_sym_protected] = ACTIONS(2143),
    [anon_sym_public] = ACTIONS(2143),
    [anon_sym_readonly] = ACTIONS(2143),
    [anon_sym_sealed] = ACTIONS(2143),
    [anon_sym_static] = ACTIONS(2143),
    [anon_sym_unsafe] = ACTIONS(2143),
    [anon_sym_virtual] = ACTIONS(2143),
    [anon_sym_volatile] = ACTIONS(2143),
    [anon_sym_using] = ACTIONS(2143),
    [anon_sym_namespace] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_partial] = ACTIONS(2143),
    [anon_sym_class] = ACTIONS(2143),
    [anon_sym_struct] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(2141),
    [anon_sym_event] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_implicit] = ACTIONS(2143),
    [anon_sym_explicit] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2143),
    [anon_sym_enum] = ACTIONS(2143),
    [anon_sym_delegate] = ACTIONS(2143),
    [sym_void_keyword] = ACTIONS(2143),
    [anon_sym_const] = ACTIONS(2143),
    [sym_identifier_name] = ACTIONS(2143),
    [sym_comment] = ACTIONS(31),
  },
  [800] = {
    [ts_builtin_sym_end] = ACTIONS(2141),
    [anon_sym_bool] = ACTIONS(2143),
    [anon_sym_byte] = ACTIONS(2143),
    [anon_sym_char] = ACTIONS(2143),
    [anon_sym_decimal] = ACTIONS(2143),
    [anon_sym_double] = ACTIONS(2143),
    [anon_sym_float] = ACTIONS(2143),
    [anon_sym_int] = ACTIONS(2143),
    [anon_sym_long] = ACTIONS(2143),
    [anon_sym_object] = ACTIONS(2143),
    [anon_sym_sbyte] = ACTIONS(2143),
    [anon_sym_short] = ACTIONS(2143),
    [anon_sym_string] = ACTIONS(2143),
    [anon_sym_uint] = ACTIONS(2143),
    [anon_sym_ulong] = ACTIONS(2143),
    [anon_sym_ushort] = ACTIONS(2143),
    [anon_sym_abstract] = ACTIONS(2143),
    [anon_sym_async] = ACTIONS(2143),
    [anon_sym_extern] = ACTIONS(2143),
    [anon_sym_internal] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2143),
    [anon_sym_override] = ACTIONS(2143),
    [anon_sym_private] = ACTIONS(2143),
    [anon_sym_protected] = ACTIONS(2143),
    [anon_sym_public] = ACTIONS(2143),
    [anon_sym_readonly] = ACTIONS(2143),
    [anon_sym_sealed] = ACTIONS(2143),
    [anon_sym_static] = ACTIONS(2143),
    [anon_sym_unsafe] = ACTIONS(2143),
    [anon_sym_virtual] = ACTIONS(2143),
    [anon_sym_volatile] = ACTIONS(2143),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2143),
    [anon_sym_namespace] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_partial] = ACTIONS(2143),
    [anon_sym_class] = ACTIONS(2143),
    [anon_sym_struct] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(2141),
    [anon_sym_event] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_implicit] = ACTIONS(2143),
    [anon_sym_explicit] = ACTIONS(2143),
    [anon_sym_interface] = ACTIONS(2143),
    [anon_sym_enum] = ACTIONS(2143),
    [anon_sym_delegate] = ACTIONS(2143),
    [sym_void_keyword] = ACTIONS(2143),
    [anon_sym_const] = ACTIONS(2143),
    [sym_identifier_name] = ACTIONS(2143),
    [sym_comment] = ACTIONS(31),
  },
  [801] = {
    [sym_identifier_name] = ACTIONS(2147),
    [sym_comment] = ACTIONS(31),
  },
  [802] = {
    [aux_sym_array_rank_specifier_repeat1] = STATE(929),
    [anon_sym_COMMA] = ACTIONS(2149),
    [anon_sym_RBRACK] = ACTIONS(2151),
    [sym_comment] = ACTIONS(31),
  },
  [803] = {
    [sym__expression] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_ternary_expression] = STATE(523),
    [sym_binary_expression] = STATE(523),
    [sym_unary_expression] = STATE(523),
    [sym__literal] = STATE(523),
    [sym_boolean_literal] = STATE(523),
    [sym_character_literal] = STATE(523),
    [sym_integer_literal] = STATE(523),
    [sym_real_literal] = STATE(523),
    [sym_string_literal] = STATE(523),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1074),
    [sym_comment] = ACTIONS(31),
  },
  [804] = {
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_params] = ACTIONS(2155),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2177),
    [anon_sym_PIPE_PIPE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(31),
  },
  [805] = {
    [sym__attribute_section] = STATE(805),
    [aux_sym__attributes_repeat1] = STATE(805),
    [anon_sym_bool] = ACTIONS(800),
    [anon_sym_byte] = ACTIONS(800),
    [anon_sym_char] = ACTIONS(800),
    [anon_sym_decimal] = ACTIONS(800),
    [anon_sym_double] = ACTIONS(800),
    [anon_sym_float] = ACTIONS(800),
    [anon_sym_int] = ACTIONS(800),
    [anon_sym_long] = ACTIONS(800),
    [anon_sym_object] = ACTIONS(800),
    [anon_sym_sbyte] = ACTIONS(800),
    [anon_sym_short] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_uint] = ACTIONS(800),
    [anon_sym_ulong] = ACTIONS(800),
    [anon_sym_ushort] = ACTIONS(800),
    [anon_sym_this] = ACTIONS(800),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_ref] = ACTIONS(800),
    [anon_sym_out] = ACTIONS(800),
    [sym_identifier_name] = ACTIONS(800),
    [sym_comment] = ACTIONS(31),
  },
  [806] = {
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_params] = ACTIONS(289),
    [sym_comment] = ACTIONS(31),
  },
  [807] = {
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_RBRACK] = ACTIONS(2181),
    [anon_sym_params] = ACTIONS(2181),
    [sym_comment] = ACTIONS(31),
  },
  [808] = {
    [anon_sym_RPAREN] = ACTIONS(2183),
    [anon_sym_RBRACK] = ACTIONS(2183),
    [sym_comment] = ACTIONS(31),
  },
  [809] = {
    [sym_default_argument] = STATE(940),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_params] = ACTIONS(2181),
    [sym_comment] = ACTIONS(31),
  },
  [810] = {
    [sym__type_declaration] = STATE(941),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(941),
    [sym_class_declaration] = STATE(941),
    [sym_indexer_declaration] = STATE(941),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(941),
    [sym_operator_declaration] = STATE(941),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(941),
    [sym_struct_declaration] = STATE(941),
    [sym_enum_declaration] = STATE(941),
    [sym_delegate_declaration] = STATE(941),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(941),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(941),
    [sym_constructor_declaration] = STATE(941),
    [sym_destructor_declaration] = STATE(941),
    [sym_method_declaration] = STATE(941),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(941),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [811] = {
    [sym__type_declaration] = STATE(942),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(942),
    [sym_class_declaration] = STATE(942),
    [sym_indexer_declaration] = STATE(942),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(942),
    [sym_operator_declaration] = STATE(942),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(942),
    [sym_struct_declaration] = STATE(942),
    [sym_enum_declaration] = STATE(942),
    [sym_delegate_declaration] = STATE(942),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(942),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(942),
    [sym_constructor_declaration] = STATE(942),
    [sym_method_declaration] = STATE(942),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(942),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [812] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(943),
    [sym_interface_event_declaration] = STATE(943),
    [sym_interface_property_declaration] = STATE(943),
    [sym_interface_indexer_declaration] = STATE(943),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(943),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [813] = {
    [aux_sym_enum_declaration_repeat1] = STATE(431),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [sym_comment] = ACTIONS(31),
  },
  [814] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [815] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [816] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(2191),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [817] = {
    [aux_sym_enum_declaration_repeat1] = STATE(948),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(2185),
    [sym_comment] = ACTIONS(31),
  },
  [818] = {
    [ts_builtin_sym_end] = ACTIONS(2193),
    [anon_sym_bool] = ACTIONS(2195),
    [anon_sym_byte] = ACTIONS(2195),
    [anon_sym_char] = ACTIONS(2195),
    [anon_sym_decimal] = ACTIONS(2195),
    [anon_sym_double] = ACTIONS(2195),
    [anon_sym_float] = ACTIONS(2195),
    [anon_sym_int] = ACTIONS(2195),
    [anon_sym_long] = ACTIONS(2195),
    [anon_sym_object] = ACTIONS(2195),
    [anon_sym_sbyte] = ACTIONS(2195),
    [anon_sym_short] = ACTIONS(2195),
    [anon_sym_string] = ACTIONS(2195),
    [anon_sym_uint] = ACTIONS(2195),
    [anon_sym_ulong] = ACTIONS(2195),
    [anon_sym_ushort] = ACTIONS(2195),
    [anon_sym_abstract] = ACTIONS(2195),
    [anon_sym_async] = ACTIONS(2195),
    [anon_sym_extern] = ACTIONS(2195),
    [anon_sym_internal] = ACTIONS(2195),
    [anon_sym_new] = ACTIONS(2195),
    [anon_sym_override] = ACTIONS(2195),
    [anon_sym_private] = ACTIONS(2195),
    [anon_sym_protected] = ACTIONS(2195),
    [anon_sym_public] = ACTIONS(2195),
    [anon_sym_readonly] = ACTIONS(2195),
    [anon_sym_sealed] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2195),
    [anon_sym_unsafe] = ACTIONS(2195),
    [anon_sym_virtual] = ACTIONS(2195),
    [anon_sym_volatile] = ACTIONS(2195),
    [anon_sym_using] = ACTIONS(2195),
    [anon_sym_namespace] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_partial] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2195),
    [anon_sym_struct] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_event] = ACTIONS(2195),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_implicit] = ACTIONS(2195),
    [anon_sym_explicit] = ACTIONS(2195),
    [anon_sym_interface] = ACTIONS(2195),
    [anon_sym_enum] = ACTIONS(2195),
    [anon_sym_delegate] = ACTIONS(2195),
    [sym_void_keyword] = ACTIONS(2195),
    [anon_sym_const] = ACTIONS(2195),
    [sym_identifier_name] = ACTIONS(2195),
    [sym_comment] = ACTIONS(31),
  },
  [819] = {
    [ts_builtin_sym_end] = ACTIONS(2193),
    [anon_sym_bool] = ACTIONS(2195),
    [anon_sym_byte] = ACTIONS(2195),
    [anon_sym_char] = ACTIONS(2195),
    [anon_sym_decimal] = ACTIONS(2195),
    [anon_sym_double] = ACTIONS(2195),
    [anon_sym_float] = ACTIONS(2195),
    [anon_sym_int] = ACTIONS(2195),
    [anon_sym_long] = ACTIONS(2195),
    [anon_sym_object] = ACTIONS(2195),
    [anon_sym_sbyte] = ACTIONS(2195),
    [anon_sym_short] = ACTIONS(2195),
    [anon_sym_string] = ACTIONS(2195),
    [anon_sym_uint] = ACTIONS(2195),
    [anon_sym_ulong] = ACTIONS(2195),
    [anon_sym_ushort] = ACTIONS(2195),
    [anon_sym_abstract] = ACTIONS(2195),
    [anon_sym_async] = ACTIONS(2195),
    [anon_sym_extern] = ACTIONS(2195),
    [anon_sym_internal] = ACTIONS(2195),
    [anon_sym_new] = ACTIONS(2195),
    [anon_sym_override] = ACTIONS(2195),
    [anon_sym_private] = ACTIONS(2195),
    [anon_sym_protected] = ACTIONS(2195),
    [anon_sym_public] = ACTIONS(2195),
    [anon_sym_readonly] = ACTIONS(2195),
    [anon_sym_sealed] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2195),
    [anon_sym_unsafe] = ACTIONS(2195),
    [anon_sym_virtual] = ACTIONS(2195),
    [anon_sym_volatile] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2195),
    [anon_sym_namespace] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_partial] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2195),
    [anon_sym_struct] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_event] = ACTIONS(2195),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_implicit] = ACTIONS(2195),
    [anon_sym_explicit] = ACTIONS(2195),
    [anon_sym_interface] = ACTIONS(2195),
    [anon_sym_enum] = ACTIONS(2195),
    [anon_sym_delegate] = ACTIONS(2195),
    [sym_void_keyword] = ACTIONS(2195),
    [anon_sym_const] = ACTIONS(2195),
    [sym_identifier_name] = ACTIONS(2195),
    [sym_comment] = ACTIONS(31),
  },
  [820] = {
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_bool] = ACTIONS(2201),
    [anon_sym_byte] = ACTIONS(2201),
    [anon_sym_char] = ACTIONS(2201),
    [anon_sym_decimal] = ACTIONS(2201),
    [anon_sym_double] = ACTIONS(2201),
    [anon_sym_float] = ACTIONS(2201),
    [anon_sym_int] = ACTIONS(2201),
    [anon_sym_long] = ACTIONS(2201),
    [anon_sym_object] = ACTIONS(2201),
    [anon_sym_sbyte] = ACTIONS(2201),
    [anon_sym_short] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_uint] = ACTIONS(2201),
    [anon_sym_ulong] = ACTIONS(2201),
    [anon_sym_ushort] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_extern] = ACTIONS(2201),
    [anon_sym_internal] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_sealed] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_unsafe] = ACTIONS(2201),
    [anon_sym_virtual] = ACTIONS(2201),
    [anon_sym_volatile] = ACTIONS(2201),
    [anon_sym_using] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_partial] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_struct] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_event] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_implicit] = ACTIONS(2201),
    [anon_sym_explicit] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_delegate] = ACTIONS(2201),
    [sym_void_keyword] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [sym_identifier_name] = ACTIONS(2201),
    [sym_comment] = ACTIONS(31),
  },
  [821] = {
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_bool] = ACTIONS(2201),
    [anon_sym_byte] = ACTIONS(2201),
    [anon_sym_char] = ACTIONS(2201),
    [anon_sym_decimal] = ACTIONS(2201),
    [anon_sym_double] = ACTIONS(2201),
    [anon_sym_float] = ACTIONS(2201),
    [anon_sym_int] = ACTIONS(2201),
    [anon_sym_long] = ACTIONS(2201),
    [anon_sym_object] = ACTIONS(2201),
    [anon_sym_sbyte] = ACTIONS(2201),
    [anon_sym_short] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_uint] = ACTIONS(2201),
    [anon_sym_ulong] = ACTIONS(2201),
    [anon_sym_ushort] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_extern] = ACTIONS(2201),
    [anon_sym_internal] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_sealed] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_unsafe] = ACTIONS(2201),
    [anon_sym_virtual] = ACTIONS(2201),
    [anon_sym_volatile] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_partial] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_struct] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_event] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_implicit] = ACTIONS(2201),
    [anon_sym_explicit] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_delegate] = ACTIONS(2201),
    [sym_void_keyword] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [sym_identifier_name] = ACTIONS(2201),
    [sym_comment] = ACTIONS(31),
  },
  [822] = {
    [ts_builtin_sym_end] = ACTIONS(2205),
    [anon_sym_bool] = ACTIONS(2207),
    [anon_sym_byte] = ACTIONS(2207),
    [anon_sym_char] = ACTIONS(2207),
    [anon_sym_decimal] = ACTIONS(2207),
    [anon_sym_double] = ACTIONS(2207),
    [anon_sym_float] = ACTIONS(2207),
    [anon_sym_int] = ACTIONS(2207),
    [anon_sym_long] = ACTIONS(2207),
    [anon_sym_object] = ACTIONS(2207),
    [anon_sym_sbyte] = ACTIONS(2207),
    [anon_sym_short] = ACTIONS(2207),
    [anon_sym_string] = ACTIONS(2207),
    [anon_sym_uint] = ACTIONS(2207),
    [anon_sym_ulong] = ACTIONS(2207),
    [anon_sym_ushort] = ACTIONS(2207),
    [anon_sym_abstract] = ACTIONS(2207),
    [anon_sym_async] = ACTIONS(2207),
    [anon_sym_extern] = ACTIONS(2207),
    [anon_sym_internal] = ACTIONS(2207),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_override] = ACTIONS(2207),
    [anon_sym_private] = ACTIONS(2207),
    [anon_sym_protected] = ACTIONS(2207),
    [anon_sym_public] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2207),
    [anon_sym_sealed] = ACTIONS(2207),
    [anon_sym_static] = ACTIONS(2207),
    [anon_sym_unsafe] = ACTIONS(2207),
    [anon_sym_virtual] = ACTIONS(2207),
    [anon_sym_volatile] = ACTIONS(2207),
    [anon_sym_using] = ACTIONS(2207),
    [anon_sym_namespace] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_partial] = ACTIONS(2207),
    [anon_sym_class] = ACTIONS(2207),
    [anon_sym_struct] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_event] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_implicit] = ACTIONS(2207),
    [anon_sym_explicit] = ACTIONS(2207),
    [anon_sym_interface] = ACTIONS(2207),
    [anon_sym_enum] = ACTIONS(2207),
    [anon_sym_delegate] = ACTIONS(2207),
    [sym_void_keyword] = ACTIONS(2207),
    [anon_sym_const] = ACTIONS(2207),
    [sym_identifier_name] = ACTIONS(2207),
    [sym_comment] = ACTIONS(31),
  },
  [823] = {
    [ts_builtin_sym_end] = ACTIONS(2205),
    [anon_sym_bool] = ACTIONS(2207),
    [anon_sym_byte] = ACTIONS(2207),
    [anon_sym_char] = ACTIONS(2207),
    [anon_sym_decimal] = ACTIONS(2207),
    [anon_sym_double] = ACTIONS(2207),
    [anon_sym_float] = ACTIONS(2207),
    [anon_sym_int] = ACTIONS(2207),
    [anon_sym_long] = ACTIONS(2207),
    [anon_sym_object] = ACTIONS(2207),
    [anon_sym_sbyte] = ACTIONS(2207),
    [anon_sym_short] = ACTIONS(2207),
    [anon_sym_string] = ACTIONS(2207),
    [anon_sym_uint] = ACTIONS(2207),
    [anon_sym_ulong] = ACTIONS(2207),
    [anon_sym_ushort] = ACTIONS(2207),
    [anon_sym_abstract] = ACTIONS(2207),
    [anon_sym_async] = ACTIONS(2207),
    [anon_sym_extern] = ACTIONS(2207),
    [anon_sym_internal] = ACTIONS(2207),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_override] = ACTIONS(2207),
    [anon_sym_private] = ACTIONS(2207),
    [anon_sym_protected] = ACTIONS(2207),
    [anon_sym_public] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2207),
    [anon_sym_sealed] = ACTIONS(2207),
    [anon_sym_static] = ACTIONS(2207),
    [anon_sym_unsafe] = ACTIONS(2207),
    [anon_sym_virtual] = ACTIONS(2207),
    [anon_sym_volatile] = ACTIONS(2207),
    [anon_sym_SEMI] = ACTIONS(2209),
    [anon_sym_using] = ACTIONS(2207),
    [anon_sym_namespace] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_partial] = ACTIONS(2207),
    [anon_sym_class] = ACTIONS(2207),
    [anon_sym_struct] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_event] = ACTIONS(2207),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_implicit] = ACTIONS(2207),
    [anon_sym_explicit] = ACTIONS(2207),
    [anon_sym_interface] = ACTIONS(2207),
    [anon_sym_enum] = ACTIONS(2207),
    [anon_sym_delegate] = ACTIONS(2207),
    [sym_void_keyword] = ACTIONS(2207),
    [anon_sym_const] = ACTIONS(2207),
    [sym_identifier_name] = ACTIONS(2207),
    [sym_comment] = ACTIONS(31),
  },
  [824] = {
    [anon_sym_bool] = ACTIONS(2211),
    [anon_sym_byte] = ACTIONS(2211),
    [anon_sym_char] = ACTIONS(2211),
    [anon_sym_decimal] = ACTIONS(2211),
    [anon_sym_double] = ACTIONS(2211),
    [anon_sym_float] = ACTIONS(2211),
    [anon_sym_int] = ACTIONS(2211),
    [anon_sym_long] = ACTIONS(2211),
    [anon_sym_object] = ACTIONS(2211),
    [anon_sym_sbyte] = ACTIONS(2211),
    [anon_sym_short] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_uint] = ACTIONS(2211),
    [anon_sym_ulong] = ACTIONS(2211),
    [anon_sym_ushort] = ACTIONS(2211),
    [anon_sym_abstract] = ACTIONS(2211),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_extern] = ACTIONS(2211),
    [anon_sym_internal] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_sealed] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_unsafe] = ACTIONS(2211),
    [anon_sym_virtual] = ACTIONS(2211),
    [anon_sym_volatile] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_partial] = ACTIONS(2211),
    [anon_sym_class] = ACTIONS(2211),
    [anon_sym_struct] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2213),
    [anon_sym_event] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_implicit] = ACTIONS(2211),
    [anon_sym_explicit] = ACTIONS(2211),
    [anon_sym_interface] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2211),
    [anon_sym_delegate] = ACTIONS(2211),
    [sym_void_keyword] = ACTIONS(2211),
    [anon_sym_const] = ACTIONS(2211),
    [sym_identifier_name] = ACTIONS(2211),
    [sym_comment] = ACTIONS(31),
  },
  [825] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [sym_statement_block] = STATE(952),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [826] = {
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_remove] = ACTIONS(2215),
    [sym_comment] = ACTIONS(31),
  },
  [827] = {
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [anon_sym_add] = ACTIONS(2217),
    [sym_comment] = ACTIONS(31),
  },
  [828] = {
    [anon_sym_RBRACE] = ACTIONS(2219),
    [sym_comment] = ACTIONS(31),
  },
  [829] = {
    [anon_sym_remove] = ACTIONS(1879),
    [sym_comment] = ACTIONS(31),
  },
  [830] = {
    [sym__attribute_section] = STATE(954),
    [aux_sym__attributes_repeat1] = STATE(954),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_remove] = ACTIONS(85),
    [sym_comment] = ACTIONS(31),
  },
  [831] = {
    [anon_sym_add] = ACTIONS(1877),
    [sym_comment] = ACTIONS(31),
  },
  [832] = {
    [sym__attribute_section] = STATE(955),
    [aux_sym__attributes_repeat1] = STATE(955),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(85),
    [sym_comment] = ACTIONS(31),
  },
  [833] = {
    [sym_statement_block] = STATE(956),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [834] = {
    [sym_statement_block] = STATE(957),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [835] = {
    [sym__attribute_section] = STATE(835),
    [aux_sym__attributes_repeat1] = STATE(835),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_add] = ACTIONS(218),
    [anon_sym_remove] = ACTIONS(218),
    [sym_comment] = ACTIONS(31),
  },
  [836] = {
    [sym__expression] = STATE(959),
    [sym_parenthesized_expression] = STATE(959),
    [sym_ternary_expression] = STATE(959),
    [sym_binary_expression] = STATE(959),
    [sym_unary_expression] = STATE(959),
    [sym__literal] = STATE(959),
    [sym_boolean_literal] = STATE(959),
    [sym_character_literal] = STATE(959),
    [sym_integer_literal] = STATE(959),
    [sym_real_literal] = STATE(959),
    [sym_string_literal] = STATE(959),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2225),
    [sym_comment] = ACTIONS(31),
  },
  [837] = {
    [sym__type] = STATE(675),
    [sym_predefined_type] = STATE(675),
    [sym_parameter_modifier] = STATE(676),
    [sym_generic_name] = STATE(675),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_this] = ACTIONS(501),
    [anon_sym_ref] = ACTIONS(501),
    [anon_sym_out] = ACTIONS(501),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [838] = {
    [aux_sym__formal_parameter_list_repeat1] = STATE(838),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(1819),
    [anon_sym_RBRACK] = ACTIONS(1819),
    [anon_sym_params] = ACTIONS(1819),
    [sym_comment] = ACTIONS(31),
  },
  [839] = {
    [sym_default_argument] = STATE(807),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1888),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [anon_sym_RBRACK] = ACTIONS(1817),
    [anon_sym_params] = ACTIONS(1817),
    [sym_comment] = ACTIONS(31),
  },
  [840] = {
    [sym_identifier_name] = ACTIONS(2230),
    [sym_comment] = ACTIONS(31),
  },
  [841] = {
    [anon_sym_RPAREN] = ACTIONS(2232),
    [sym_comment] = ACTIONS(31),
  },
  [842] = {
    [anon_sym_COMMA] = ACTIONS(2234),
    [sym_comment] = ACTIONS(31),
  },
  [843] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [844] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [845] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [846] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [847] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [848] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [849] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [850] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [851] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [852] = {
    [sym_variable_initializer] = STATE(964),
    [sym_array_initalizer] = STATE(965),
    [sym__expression] = STATE(966),
    [sym_parenthesized_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym__literal] = STATE(966),
    [sym_boolean_literal] = STATE(966),
    [sym_character_literal] = STATE(966),
    [sym_integer_literal] = STATE(966),
    [sym_real_literal] = STATE(966),
    [sym_string_literal] = STATE(966),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2238),
    [sym_comment] = ACTIONS(31),
  },
  [853] = {
    [anon_sym_bool] = ACTIONS(2240),
    [anon_sym_byte] = ACTIONS(2240),
    [anon_sym_char] = ACTIONS(2240),
    [anon_sym_decimal] = ACTIONS(2240),
    [anon_sym_double] = ACTIONS(2240),
    [anon_sym_float] = ACTIONS(2240),
    [anon_sym_int] = ACTIONS(2240),
    [anon_sym_long] = ACTIONS(2240),
    [anon_sym_object] = ACTIONS(2240),
    [anon_sym_sbyte] = ACTIONS(2240),
    [anon_sym_short] = ACTIONS(2240),
    [anon_sym_string] = ACTIONS(2240),
    [anon_sym_uint] = ACTIONS(2240),
    [anon_sym_ulong] = ACTIONS(2240),
    [anon_sym_ushort] = ACTIONS(2240),
    [anon_sym_abstract] = ACTIONS(2240),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_extern] = ACTIONS(2240),
    [anon_sym_internal] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [anon_sym_private] = ACTIONS(2240),
    [anon_sym_protected] = ACTIONS(2240),
    [anon_sym_public] = ACTIONS(2240),
    [anon_sym_readonly] = ACTIONS(2240),
    [anon_sym_sealed] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_unsafe] = ACTIONS(2240),
    [anon_sym_virtual] = ACTIONS(2240),
    [anon_sym_volatile] = ACTIONS(2240),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_partial] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_struct] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_event] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_implicit] = ACTIONS(2240),
    [anon_sym_explicit] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
    [anon_sym_delegate] = ACTIONS(2240),
    [sym_void_keyword] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [sym_identifier_name] = ACTIONS(2240),
    [sym_comment] = ACTIONS(31),
  },
  [854] = {
    [anon_sym_RBRACK] = ACTIONS(2244),
    [sym_comment] = ACTIONS(31),
  },
  [855] = {
    [sym_type_parameter_constraints_clause] = STATE(968),
    [sym_statement_block] = STATE(952),
    [aux_sym_class_declaration_repeat1] = STATE(968),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [856] = {
    [sym_remove_accessor_declaration] = STATE(969),
    [sym__attributes] = STATE(829),
    [sym__attribute_section] = STATE(830),
    [aux_sym__attributes_repeat1] = STATE(830),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_remove] = ACTIONS(1358),
    [sym_comment] = ACTIONS(31),
  },
  [857] = {
    [sym_add_accessor_declaration] = STATE(969),
    [sym__attributes] = STATE(831),
    [sym__attribute_section] = STATE(832),
    [aux_sym__attributes_repeat1] = STATE(832),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(1356),
    [sym_comment] = ACTIONS(31),
  },
  [858] = {
    [anon_sym_internal] = ACTIONS(2246),
    [anon_sym_private] = ACTIONS(2246),
    [anon_sym_protected] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_set] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [sym_comment] = ACTIONS(31),
  },
  [859] = {
    [anon_sym_internal] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2248),
    [sym_comment] = ACTIONS(31),
  },
  [860] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [861] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [862] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [863] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [864] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [865] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [866] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [867] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [868] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [869] = {
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2254),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2254),
    [anon_sym_params] = ACTIONS(2254),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [sym_comment] = ACTIONS(31),
  },
  [870] = {
    [anon_sym_LT] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_GT] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2254),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_PERCENT] = ACTIONS(2254),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_LT_LT] = ACTIONS(2254),
    [anon_sym_GT_GT] = ACTIONS(2254),
    [anon_sym_EQ_EQ] = ACTIONS(2254),
    [anon_sym_BANG_EQ] = ACTIONS(2254),
    [anon_sym_GT_EQ] = ACTIONS(2254),
    [anon_sym_LT_EQ] = ACTIONS(2254),
    [anon_sym_params] = ACTIONS(2254),
    [anon_sym_QMARK] = ACTIONS(2254),
    [anon_sym_AMP_AMP] = ACTIONS(2254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2254),
    [sym__real_type_suffix] = ACTIONS(2256),
    [sym_comment] = ACTIONS(31),
  },
  [871] = {
    [sym__expression] = STATE(972),
    [sym_parenthesized_expression] = STATE(972),
    [sym_ternary_expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym__literal] = STATE(972),
    [sym_boolean_literal] = STATE(972),
    [sym_character_literal] = STATE(972),
    [sym_integer_literal] = STATE(972),
    [sym_real_literal] = STATE(972),
    [sym_string_literal] = STATE(972),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2258),
    [sym_comment] = ACTIONS(31),
  },
  [872] = {
    [sym__expression] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_ternary_expression] = STATE(973),
    [sym_binary_expression] = STATE(973),
    [sym_unary_expression] = STATE(973),
    [sym__literal] = STATE(973),
    [sym_boolean_literal] = STATE(973),
    [sym_character_literal] = STATE(973),
    [sym_integer_literal] = STATE(973),
    [sym_real_literal] = STATE(973),
    [sym_string_literal] = STATE(973),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2260),
    [sym_comment] = ACTIONS(31),
  },
  [873] = {
    [sym__expression] = STATE(974),
    [sym_parenthesized_expression] = STATE(974),
    [sym_ternary_expression] = STATE(974),
    [sym_binary_expression] = STATE(974),
    [sym_unary_expression] = STATE(974),
    [sym__literal] = STATE(974),
    [sym_boolean_literal] = STATE(974),
    [sym_character_literal] = STATE(974),
    [sym_integer_literal] = STATE(974),
    [sym_real_literal] = STATE(974),
    [sym_string_literal] = STATE(974),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2262),
    [sym_comment] = ACTIONS(31),
  },
  [874] = {
    [sym__expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym__literal] = STATE(725),
    [sym_boolean_literal] = STATE(725),
    [sym_character_literal] = STATE(725),
    [sym_integer_literal] = STATE(725),
    [sym_real_literal] = STATE(725),
    [sym_string_literal] = STATE(725),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1519),
    [sym_comment] = ACTIONS(31),
  },
  [875] = {
    [sym__expression] = STATE(975),
    [sym_parenthesized_expression] = STATE(975),
    [sym_ternary_expression] = STATE(975),
    [sym_binary_expression] = STATE(975),
    [sym_unary_expression] = STATE(975),
    [sym__literal] = STATE(975),
    [sym_boolean_literal] = STATE(975),
    [sym_character_literal] = STATE(975),
    [sym_integer_literal] = STATE(975),
    [sym_real_literal] = STATE(975),
    [sym_string_literal] = STATE(975),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2264),
    [sym_comment] = ACTIONS(31),
  },
  [876] = {
    [sym__expression] = STATE(976),
    [sym_parenthesized_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym__literal] = STATE(976),
    [sym_boolean_literal] = STATE(976),
    [sym_character_literal] = STATE(976),
    [sym_integer_literal] = STATE(976),
    [sym_real_literal] = STATE(976),
    [sym_string_literal] = STATE(976),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2266),
    [sym_comment] = ACTIONS(31),
  },
  [877] = {
    [sym__expression] = STATE(977),
    [sym_parenthesized_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym__literal] = STATE(977),
    [sym_boolean_literal] = STATE(977),
    [sym_character_literal] = STATE(977),
    [sym_integer_literal] = STATE(977),
    [sym_real_literal] = STATE(977),
    [sym_string_literal] = STATE(977),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2268),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2268),
    [sym_comment] = ACTIONS(31),
  },
  [878] = {
    [sym__expression] = STATE(978),
    [sym_parenthesized_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym__literal] = STATE(978),
    [sym_boolean_literal] = STATE(978),
    [sym_character_literal] = STATE(978),
    [sym_integer_literal] = STATE(978),
    [sym_real_literal] = STATE(978),
    [sym_string_literal] = STATE(978),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2270),
    [sym_comment] = ACTIONS(31),
  },
  [879] = {
    [sym__expression] = STATE(979),
    [sym_parenthesized_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym__literal] = STATE(979),
    [sym_boolean_literal] = STATE(979),
    [sym_character_literal] = STATE(979),
    [sym_integer_literal] = STATE(979),
    [sym_real_literal] = STATE(979),
    [sym_string_literal] = STATE(979),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2272),
    [sym_comment] = ACTIONS(31),
  },
  [880] = {
    [sym__expression] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym_ternary_expression] = STATE(980),
    [sym_binary_expression] = STATE(980),
    [sym_unary_expression] = STATE(980),
    [sym__literal] = STATE(980),
    [sym_boolean_literal] = STATE(980),
    [sym_character_literal] = STATE(980),
    [sym_integer_literal] = STATE(980),
    [sym_real_literal] = STATE(980),
    [sym_string_literal] = STATE(980),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2274),
    [sym_comment] = ACTIONS(31),
  },
  [881] = {
    [sym__expression] = STATE(981),
    [sym_parenthesized_expression] = STATE(981),
    [sym_ternary_expression] = STATE(981),
    [sym_binary_expression] = STATE(981),
    [sym_unary_expression] = STATE(981),
    [sym__literal] = STATE(981),
    [sym_boolean_literal] = STATE(981),
    [sym_character_literal] = STATE(981),
    [sym_integer_literal] = STATE(981),
    [sym_real_literal] = STATE(981),
    [sym_string_literal] = STATE(981),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2276),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2276),
    [sym_comment] = ACTIONS(31),
  },
  [882] = {
    [sym__type] = STATE(982),
    [sym_predefined_type] = STATE(982),
    [sym_generic_name] = STATE(982),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [883] = {
    [anon_sym_LPAREN] = ACTIONS(2278),
    [sym_comment] = ACTIONS(31),
  },
  [884] = {
    [anon_sym_bool] = ACTIONS(2280),
    [anon_sym_byte] = ACTIONS(2280),
    [anon_sym_char] = ACTIONS(2280),
    [anon_sym_decimal] = ACTIONS(2280),
    [anon_sym_double] = ACTIONS(2280),
    [anon_sym_float] = ACTIONS(2280),
    [anon_sym_int] = ACTIONS(2280),
    [anon_sym_long] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_sbyte] = ACTIONS(2280),
    [anon_sym_short] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_uint] = ACTIONS(2280),
    [anon_sym_ulong] = ACTIONS(2280),
    [anon_sym_ushort] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2282),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_true] = ACTIONS(2280),
    [anon_sym_false] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2280),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2282),
    [sym_null_literal] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [anon_sym_AT_DQUOTE] = ACTIONS(2282),
    [sym_identifier_name] = ACTIONS(2280),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_catch] = ACTIONS(2280),
    [anon_sym_finally] = ACTIONS(2280),
    [anon_sym_checked] = ACTIONS(2280),
    [anon_sym_unchecked] = ACTIONS(2280),
    [anon_sym_lock] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
  },
  [885] = {
    [sym_statement_block] = STATE(984),
    [sym__exception_filter] = STATE(985),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
    [anon_sym_when] = ACTIONS(2033),
  },
  [886] = {
    [sym_statement_block] = STATE(984),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [887] = {
    [anon_sym_bool] = ACTIONS(2284),
    [anon_sym_byte] = ACTIONS(2284),
    [anon_sym_char] = ACTIONS(2284),
    [anon_sym_decimal] = ACTIONS(2284),
    [anon_sym_double] = ACTIONS(2284),
    [anon_sym_float] = ACTIONS(2284),
    [anon_sym_int] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_object] = ACTIONS(2284),
    [anon_sym_sbyte] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_string] = ACTIONS(2284),
    [anon_sym_uint] = ACTIONS(2284),
    [anon_sym_ulong] = ACTIONS(2284),
    [anon_sym_ushort] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2286),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_true] = ACTIONS(2284),
    [anon_sym_false] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_typeof] = ACTIONS(2284),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2284),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2286),
    [sym_null_literal] = ACTIONS(2284),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_AT_DQUOTE] = ACTIONS(2286),
    [sym_identifier_name] = ACTIONS(2284),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_checked] = ACTIONS(2284),
    [anon_sym_unchecked] = ACTIONS(2284),
    [anon_sym_lock] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym_var] = ACTIONS(2284),
  },
  [888] = {
    [anon_sym_bool] = ACTIONS(2288),
    [anon_sym_byte] = ACTIONS(2288),
    [anon_sym_char] = ACTIONS(2288),
    [anon_sym_decimal] = ACTIONS(2288),
    [anon_sym_double] = ACTIONS(2288),
    [anon_sym_float] = ACTIONS(2288),
    [anon_sym_int] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_sbyte] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_uint] = ACTIONS(2288),
    [anon_sym_ulong] = ACTIONS(2288),
    [anon_sym_ushort] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2290),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_true] = ACTIONS(2288),
    [anon_sym_false] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2288),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2290),
    [sym_null_literal] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [anon_sym_AT_DQUOTE] = ACTIONS(2290),
    [sym_identifier_name] = ACTIONS(2288),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_checked] = ACTIONS(2288),
    [anon_sym_unchecked] = ACTIONS(2288),
    [anon_sym_lock] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
  },
  [889] = {
    [sym_catch_clause] = STATE(889),
    [aux_sym_try_statement_repeat1] = STATE(889),
    [anon_sym_bool] = ACTIONS(2292),
    [anon_sym_byte] = ACTIONS(2292),
    [anon_sym_char] = ACTIONS(2292),
    [anon_sym_decimal] = ACTIONS(2292),
    [anon_sym_double] = ACTIONS(2292),
    [anon_sym_float] = ACTIONS(2292),
    [anon_sym_int] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_sbyte] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_uint] = ACTIONS(2292),
    [anon_sym_ulong] = ACTIONS(2292),
    [anon_sym_ushort] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2292),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2294),
    [sym_null_literal] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_AT_DQUOTE] = ACTIONS(2294),
    [sym_identifier_name] = ACTIONS(2292),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_catch] = ACTIONS(2296),
    [anon_sym_finally] = ACTIONS(2292),
    [anon_sym_checked] = ACTIONS(2292),
    [anon_sym_unchecked] = ACTIONS(2292),
    [anon_sym_lock] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
  },
  [890] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(986),
    [sym__embedded_statement] = STATE(986),
    [sym_empty_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym__selection_statement] = STATE(986),
    [sym__iteration_statement] = STATE(986),
    [sym__jump_statement] = STATE(986),
    [sym_try_statement] = STATE(986),
    [sym_checked_statement] = STATE(986),
    [sym_unchecked_statement] = STATE(986),
    [sym_lock_statement] = STATE(986),
    [sym_yield_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_throw_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(701),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [891] = {
    [anon_sym_bool] = ACTIONS(2299),
    [anon_sym_byte] = ACTIONS(2299),
    [anon_sym_char] = ACTIONS(2299),
    [anon_sym_decimal] = ACTIONS(2299),
    [anon_sym_double] = ACTIONS(2299),
    [anon_sym_float] = ACTIONS(2299),
    [anon_sym_int] = ACTIONS(2299),
    [anon_sym_long] = ACTIONS(2299),
    [anon_sym_object] = ACTIONS(2299),
    [anon_sym_sbyte] = ACTIONS(2299),
    [anon_sym_short] = ACTIONS(2299),
    [anon_sym_string] = ACTIONS(2299),
    [anon_sym_uint] = ACTIONS(2299),
    [anon_sym_ulong] = ACTIONS(2299),
    [anon_sym_ushort] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2299),
    [anon_sym_DASH] = ACTIONS(2299),
    [anon_sym_BANG] = ACTIONS(2301),
    [anon_sym_TILDE] = ACTIONS(2301),
    [anon_sym_PLUS_PLUS] = ACTIONS(2301),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_true] = ACTIONS(2299),
    [anon_sym_false] = ACTIONS(2299),
    [anon_sym_const] = ACTIONS(2299),
    [anon_sym_typeof] = ACTIONS(2299),
    [anon_sym_sizeof] = ACTIONS(2299),
    [anon_sym_SQUOTE] = ACTIONS(2301),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2299),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2301),
    [sym_null_literal] = ACTIONS(2299),
    [anon_sym_DQUOTE] = ACTIONS(2301),
    [anon_sym_AT_DQUOTE] = ACTIONS(2301),
    [sym_identifier_name] = ACTIONS(2299),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2299),
    [anon_sym_checked] = ACTIONS(2299),
    [anon_sym_unchecked] = ACTIONS(2299),
    [anon_sym_lock] = ACTIONS(2299),
    [anon_sym_yield] = ACTIONS(2299),
    [anon_sym_return] = ACTIONS(2299),
    [anon_sym_break] = ACTIONS(2299),
    [anon_sym_if] = ACTIONS(2299),
    [anon_sym_else] = ACTIONS(2299),
    [anon_sym_switch] = ACTIONS(2299),
    [anon_sym_case] = ACTIONS(2299),
    [anon_sym_default] = ACTIONS(2299),
    [anon_sym_while] = ACTIONS(2299),
    [anon_sym_do] = ACTIONS(2299),
    [anon_sym_continue] = ACTIONS(2299),
    [anon_sym_throw] = ACTIONS(2299),
    [anon_sym_goto] = ACTIONS(2299),
    [anon_sym_var] = ACTIONS(2299),
  },
  [892] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(991),
    [sym__embedded_statement] = STATE(991),
    [sym_empty_statement] = STATE(991),
    [sym_expression_statement] = STATE(991),
    [sym__selection_statement] = STATE(991),
    [sym__iteration_statement] = STATE(991),
    [sym__jump_statement] = STATE(991),
    [sym_try_statement] = STATE(991),
    [sym_checked_statement] = STATE(991),
    [sym_unchecked_statement] = STATE(991),
    [sym_lock_statement] = STATE(991),
    [sym_yield_statement] = STATE(991),
    [sym_if_statement] = STATE(991),
    [sym_switch_statement] = STATE(991),
    [sym_while_statement] = STATE(991),
    [sym_do_statement] = STATE(991),
    [sym_break_statement] = STATE(991),
    [sym_continue_statement] = STATE(991),
    [sym_return_statement] = STATE(991),
    [sym_throw_statement] = STATE(991),
    [sym_goto_statement] = STATE(991),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2303),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2305),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [893] = {
    [anon_sym_LBRACE] = ACTIONS(2311),
    [sym_comment] = ACTIONS(31),
  },
  [894] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(993),
    [sym__embedded_statement] = STATE(993),
    [sym_empty_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym__selection_statement] = STATE(993),
    [sym__iteration_statement] = STATE(993),
    [sym__jump_statement] = STATE(993),
    [sym_try_statement] = STATE(993),
    [sym_checked_statement] = STATE(993),
    [sym_unchecked_statement] = STATE(993),
    [sym_lock_statement] = STATE(993),
    [sym_yield_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_throw_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(701),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [895] = {
    [sym_catch_clause] = STATE(994),
    [sym_finally_clause] = STATE(888),
    [aux_sym_try_statement_repeat1] = STATE(994),
    [sym_comment] = ACTIONS(31),
    [anon_sym_catch] = ACTIONS(2059),
    [anon_sym_finally] = ACTIONS(2061),
    [anon_sym_while] = ACTIONS(2037),
  },
  [896] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [897] = {
    [anon_sym_RPAREN] = ACTIONS(2315),
    [sym_comment] = ACTIONS(31),
  },
  [898] = {
    [anon_sym_RPAREN] = ACTIONS(2317),
    [sym_comment] = ACTIONS(31),
  },
  [899] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(998),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [900] = {
    [anon_sym_bool] = ACTIONS(2319),
    [anon_sym_byte] = ACTIONS(2319),
    [anon_sym_char] = ACTIONS(2319),
    [anon_sym_decimal] = ACTIONS(2319),
    [anon_sym_double] = ACTIONS(2319),
    [anon_sym_float] = ACTIONS(2319),
    [anon_sym_int] = ACTIONS(2319),
    [anon_sym_long] = ACTIONS(2319),
    [anon_sym_object] = ACTIONS(2319),
    [anon_sym_sbyte] = ACTIONS(2319),
    [anon_sym_short] = ACTIONS(2319),
    [anon_sym_string] = ACTIONS(2319),
    [anon_sym_uint] = ACTIONS(2319),
    [anon_sym_ulong] = ACTIONS(2319),
    [anon_sym_ushort] = ACTIONS(2319),
    [anon_sym_SEMI] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_RBRACE] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_DOT] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_BANG] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2321),
    [anon_sym_DASH_DASH] = ACTIONS(2321),
    [anon_sym_true] = ACTIONS(2319),
    [anon_sym_false] = ACTIONS(2319),
    [anon_sym_const] = ACTIONS(2319),
    [anon_sym_typeof] = ACTIONS(2319),
    [anon_sym_sizeof] = ACTIONS(2319),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2319),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2321),
    [sym_null_literal] = ACTIONS(2319),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_AT_DQUOTE] = ACTIONS(2321),
    [sym_identifier_name] = ACTIONS(2319),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2319),
    [anon_sym_checked] = ACTIONS(2319),
    [anon_sym_unchecked] = ACTIONS(2319),
    [anon_sym_lock] = ACTIONS(2319),
    [anon_sym_yield] = ACTIONS(2319),
    [anon_sym_return] = ACTIONS(2319),
    [anon_sym_break] = ACTIONS(2319),
    [anon_sym_if] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2319),
    [anon_sym_switch] = ACTIONS(2319),
    [anon_sym_case] = ACTIONS(2319),
    [anon_sym_default] = ACTIONS(2319),
    [anon_sym_while] = ACTIONS(2319),
    [anon_sym_do] = ACTIONS(2319),
    [anon_sym_continue] = ACTIONS(2319),
    [anon_sym_throw] = ACTIONS(2319),
    [anon_sym_goto] = ACTIONS(2319),
    [anon_sym_var] = ACTIONS(2319),
  },
  [901] = {
    [sym_variable_initializer] = STATE(999),
    [sym_array_initalizer] = STATE(965),
    [sym__expression] = STATE(1000),
    [sym_parenthesized_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym__literal] = STATE(1000),
    [sym_boolean_literal] = STATE(1000),
    [sym_character_literal] = STATE(1000),
    [sym_integer_literal] = STATE(1000),
    [sym_real_literal] = STATE(1000),
    [sym_string_literal] = STATE(1000),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2323),
    [sym_comment] = ACTIONS(31),
  },
  [902] = {
    [anon_sym_COMMA] = ACTIONS(2325),
    [anon_sym_SEMI] = ACTIONS(2325),
    [sym_comment] = ACTIONS(31),
  },
  [903] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(2325),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(2325),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1412),
    [sym_comment] = ACTIONS(31),
  },
  [904] = {
    [anon_sym_COMMA] = ACTIONS(2327),
    [anon_sym_SEMI] = ACTIONS(2327),
    [sym_comment] = ACTIONS(31),
  },
  [905] = {
    [anon_sym_COMMA] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2329),
    [sym_comment] = ACTIONS(31),
  },
  [906] = {
    [anon_sym_RPAREN] = ACTIONS(2331),
    [sym_comment] = ACTIONS(31),
  },
  [907] = {
    [anon_sym_bool] = ACTIONS(2333),
    [anon_sym_byte] = ACTIONS(2333),
    [anon_sym_char] = ACTIONS(2333),
    [anon_sym_decimal] = ACTIONS(2333),
    [anon_sym_double] = ACTIONS(2333),
    [anon_sym_float] = ACTIONS(2333),
    [anon_sym_int] = ACTIONS(2333),
    [anon_sym_long] = ACTIONS(2333),
    [anon_sym_object] = ACTIONS(2333),
    [anon_sym_sbyte] = ACTIONS(2333),
    [anon_sym_short] = ACTIONS(2333),
    [anon_sym_string] = ACTIONS(2333),
    [anon_sym_uint] = ACTIONS(2333),
    [anon_sym_ulong] = ACTIONS(2333),
    [anon_sym_ushort] = ACTIONS(2333),
    [anon_sym_abstract] = ACTIONS(2333),
    [anon_sym_async] = ACTIONS(2333),
    [anon_sym_extern] = ACTIONS(2333),
    [anon_sym_internal] = ACTIONS(2333),
    [anon_sym_new] = ACTIONS(2333),
    [anon_sym_override] = ACTIONS(2333),
    [anon_sym_private] = ACTIONS(2333),
    [anon_sym_protected] = ACTIONS(2333),
    [anon_sym_public] = ACTIONS(2333),
    [anon_sym_readonly] = ACTIONS(2333),
    [anon_sym_sealed] = ACTIONS(2333),
    [anon_sym_static] = ACTIONS(2333),
    [anon_sym_unsafe] = ACTIONS(2333),
    [anon_sym_virtual] = ACTIONS(2333),
    [anon_sym_volatile] = ACTIONS(2333),
    [anon_sym_RBRACE] = ACTIONS(2335),
    [anon_sym_partial] = ACTIONS(2333),
    [anon_sym_class] = ACTIONS(2333),
    [anon_sym_struct] = ACTIONS(2333),
    [anon_sym_LBRACK] = ACTIONS(2335),
    [anon_sym_event] = ACTIONS(2333),
    [anon_sym_TILDE] = ACTIONS(2335),
    [anon_sym_implicit] = ACTIONS(2333),
    [anon_sym_explicit] = ACTIONS(2333),
    [anon_sym_interface] = ACTIONS(2333),
    [anon_sym_enum] = ACTIONS(2333),
    [anon_sym_delegate] = ACTIONS(2333),
    [sym_void_keyword] = ACTIONS(2333),
    [anon_sym_const] = ACTIONS(2333),
    [sym_identifier_name] = ACTIONS(2333),
    [sym_comment] = ACTIONS(31),
  },
  [908] = {
    [sym_parameter_list] = STATE(1002),
    [anon_sym_LPAREN] = ACTIONS(307),
    [sym_comment] = ACTIONS(31),
  },
  [909] = {
    [sym_add_accessor_declaration] = STATE(1003),
    [sym_remove_accessor_declaration] = STATE(1004),
    [sym__attributes] = STATE(665),
    [sym__attribute_section] = STATE(666),
    [aux_sym__attributes_repeat1] = STATE(666),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(1356),
    [anon_sym_remove] = ACTIONS(1358),
    [sym_comment] = ACTIONS(31),
  },
  [910] = {
    [anon_sym_bool] = ACTIONS(2337),
    [anon_sym_byte] = ACTIONS(2337),
    [anon_sym_char] = ACTIONS(2337),
    [anon_sym_decimal] = ACTIONS(2337),
    [anon_sym_double] = ACTIONS(2337),
    [anon_sym_float] = ACTIONS(2337),
    [anon_sym_int] = ACTIONS(2337),
    [anon_sym_long] = ACTIONS(2337),
    [anon_sym_object] = ACTIONS(2337),
    [anon_sym_sbyte] = ACTIONS(2337),
    [anon_sym_short] = ACTIONS(2337),
    [anon_sym_string] = ACTIONS(2337),
    [anon_sym_uint] = ACTIONS(2337),
    [anon_sym_ulong] = ACTIONS(2337),
    [anon_sym_ushort] = ACTIONS(2337),
    [anon_sym_abstract] = ACTIONS(2337),
    [anon_sym_async] = ACTIONS(2337),
    [anon_sym_extern] = ACTIONS(2337),
    [anon_sym_internal] = ACTIONS(2337),
    [anon_sym_new] = ACTIONS(2337),
    [anon_sym_override] = ACTIONS(2337),
    [anon_sym_private] = ACTIONS(2337),
    [anon_sym_protected] = ACTIONS(2337),
    [anon_sym_public] = ACTIONS(2337),
    [anon_sym_readonly] = ACTIONS(2337),
    [anon_sym_sealed] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2337),
    [anon_sym_unsafe] = ACTIONS(2337),
    [anon_sym_virtual] = ACTIONS(2337),
    [anon_sym_volatile] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2339),
    [anon_sym_partial] = ACTIONS(2337),
    [anon_sym_class] = ACTIONS(2337),
    [anon_sym_struct] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2339),
    [anon_sym_event] = ACTIONS(2337),
    [anon_sym_TILDE] = ACTIONS(2339),
    [anon_sym_implicit] = ACTIONS(2337),
    [anon_sym_explicit] = ACTIONS(2337),
    [anon_sym_interface] = ACTIONS(2337),
    [anon_sym_enum] = ACTIONS(2337),
    [anon_sym_delegate] = ACTIONS(2337),
    [sym_void_keyword] = ACTIONS(2337),
    [anon_sym_const] = ACTIONS(2337),
    [sym_identifier_name] = ACTIONS(2337),
    [sym_comment] = ACTIONS(31),
  },
  [911] = {
    [anon_sym_bool] = ACTIONS(2341),
    [anon_sym_byte] = ACTIONS(2341),
    [anon_sym_char] = ACTIONS(2341),
    [anon_sym_decimal] = ACTIONS(2341),
    [anon_sym_double] = ACTIONS(2341),
    [anon_sym_float] = ACTIONS(2341),
    [anon_sym_int] = ACTIONS(2341),
    [anon_sym_long] = ACTIONS(2341),
    [anon_sym_object] = ACTIONS(2341),
    [anon_sym_sbyte] = ACTIONS(2341),
    [anon_sym_short] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_uint] = ACTIONS(2341),
    [anon_sym_ulong] = ACTIONS(2341),
    [anon_sym_ushort] = ACTIONS(2341),
    [anon_sym_abstract] = ACTIONS(2341),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_extern] = ACTIONS(2341),
    [anon_sym_internal] = ACTIONS(2341),
    [anon_sym_new] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_sealed] = ACTIONS(2341),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_unsafe] = ACTIONS(2341),
    [anon_sym_virtual] = ACTIONS(2341),
    [anon_sym_volatile] = ACTIONS(2341),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [anon_sym_partial] = ACTIONS(2341),
    [anon_sym_class] = ACTIONS(2341),
    [anon_sym_struct] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2343),
    [anon_sym_event] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_implicit] = ACTIONS(2341),
    [anon_sym_explicit] = ACTIONS(2341),
    [anon_sym_interface] = ACTIONS(2341),
    [anon_sym_enum] = ACTIONS(2341),
    [anon_sym_delegate] = ACTIONS(2341),
    [sym_void_keyword] = ACTIONS(2341),
    [anon_sym_const] = ACTIONS(2341),
    [sym_identifier_name] = ACTIONS(2341),
    [sym_comment] = ACTIONS(31),
  },
  [912] = {
    [anon_sym_bool] = ACTIONS(2345),
    [anon_sym_byte] = ACTIONS(2345),
    [anon_sym_char] = ACTIONS(2345),
    [anon_sym_decimal] = ACTIONS(2345),
    [anon_sym_double] = ACTIONS(2345),
    [anon_sym_float] = ACTIONS(2345),
    [anon_sym_int] = ACTIONS(2345),
    [anon_sym_long] = ACTIONS(2345),
    [anon_sym_object] = ACTIONS(2345),
    [anon_sym_sbyte] = ACTIONS(2345),
    [anon_sym_short] = ACTIONS(2345),
    [anon_sym_string] = ACTIONS(2345),
    [anon_sym_uint] = ACTIONS(2345),
    [anon_sym_ulong] = ACTIONS(2345),
    [anon_sym_ushort] = ACTIONS(2345),
    [anon_sym_abstract] = ACTIONS(2345),
    [anon_sym_async] = ACTIONS(2345),
    [anon_sym_extern] = ACTIONS(2345),
    [anon_sym_internal] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(2345),
    [anon_sym_override] = ACTIONS(2345),
    [anon_sym_private] = ACTIONS(2345),
    [anon_sym_protected] = ACTIONS(2345),
    [anon_sym_public] = ACTIONS(2345),
    [anon_sym_readonly] = ACTIONS(2345),
    [anon_sym_sealed] = ACTIONS(2345),
    [anon_sym_static] = ACTIONS(2345),
    [anon_sym_unsafe] = ACTIONS(2345),
    [anon_sym_virtual] = ACTIONS(2345),
    [anon_sym_volatile] = ACTIONS(2345),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_partial] = ACTIONS(2345),
    [anon_sym_class] = ACTIONS(2345),
    [anon_sym_struct] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_event] = ACTIONS(2345),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_implicit] = ACTIONS(2345),
    [anon_sym_explicit] = ACTIONS(2345),
    [anon_sym_interface] = ACTIONS(2345),
    [anon_sym_enum] = ACTIONS(2345),
    [anon_sym_delegate] = ACTIONS(2345),
    [sym_void_keyword] = ACTIONS(2345),
    [anon_sym_const] = ACTIONS(2345),
    [sym_identifier_name] = ACTIONS(2345),
    [sym_comment] = ACTIONS(31),
  },
  [913] = {
    [sym_constructor_constraint] = STATE(1005),
    [anon_sym_new] = ACTIONS(806),
    [sym_identifier_name] = ACTIONS(2349),
    [sym_comment] = ACTIONS(31),
  },
  [914] = {
    [aux_sym_class_base_repeat1] = STATE(408),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2353),
    [anon_sym_where] = ACTIONS(2353),
    [sym_comment] = ACTIONS(31),
  },
  [915] = {
    [anon_sym_bool] = ACTIONS(2355),
    [anon_sym_byte] = ACTIONS(2355),
    [anon_sym_char] = ACTIONS(2355),
    [anon_sym_decimal] = ACTIONS(2355),
    [anon_sym_double] = ACTIONS(2355),
    [anon_sym_float] = ACTIONS(2355),
    [anon_sym_int] = ACTIONS(2355),
    [anon_sym_long] = ACTIONS(2355),
    [anon_sym_object] = ACTIONS(2355),
    [anon_sym_sbyte] = ACTIONS(2355),
    [anon_sym_short] = ACTIONS(2355),
    [anon_sym_string] = ACTIONS(2355),
    [anon_sym_uint] = ACTIONS(2355),
    [anon_sym_ulong] = ACTIONS(2355),
    [anon_sym_ushort] = ACTIONS(2355),
    [anon_sym_new] = ACTIONS(2355),
    [anon_sym_RBRACE] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2357),
    [anon_sym_event] = ACTIONS(2355),
    [sym_void_keyword] = ACTIONS(2355),
    [sym_identifier_name] = ACTIONS(2355),
    [sym_comment] = ACTIONS(31),
  },
  [916] = {
    [sym_type_parameter_constraints_clause] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(598),
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [917] = {
    [anon_sym_LBRACE] = ACTIONS(2361),
    [sym_comment] = ACTIONS(31),
  },
  [918] = {
    [anon_sym_bool] = ACTIONS(2363),
    [anon_sym_byte] = ACTIONS(2363),
    [anon_sym_char] = ACTIONS(2363),
    [anon_sym_decimal] = ACTIONS(2363),
    [anon_sym_double] = ACTIONS(2363),
    [anon_sym_float] = ACTIONS(2363),
    [anon_sym_int] = ACTIONS(2363),
    [anon_sym_long] = ACTIONS(2363),
    [anon_sym_object] = ACTIONS(2363),
    [anon_sym_sbyte] = ACTIONS(2363),
    [anon_sym_short] = ACTIONS(2363),
    [anon_sym_string] = ACTIONS(2363),
    [anon_sym_uint] = ACTIONS(2363),
    [anon_sym_ulong] = ACTIONS(2363),
    [anon_sym_ushort] = ACTIONS(2363),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_LBRACK] = ACTIONS(2365),
    [anon_sym_event] = ACTIONS(2363),
    [sym_void_keyword] = ACTIONS(2363),
    [sym_identifier_name] = ACTIONS(2363),
    [sym_comment] = ACTIONS(31),
  },
  [919] = {
    [anon_sym_COMMA] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_where] = ACTIONS(1223),
    [sym_comment] = ACTIONS(31),
  },
  [920] = {
    [sym_interface_accessor] = STATE(1010),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(1010),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [921] = {
    [anon_sym_RBRACE] = ACTIONS(2369),
    [anon_sym_get] = ACTIONS(2369),
    [anon_sym_set] = ACTIONS(2369),
    [anon_sym_LBRACK] = ACTIONS(2369),
    [sym_comment] = ACTIONS(31),
  },
  [922] = {
    [anon_sym_bool] = ACTIONS(2371),
    [anon_sym_byte] = ACTIONS(2371),
    [anon_sym_char] = ACTIONS(2371),
    [anon_sym_decimal] = ACTIONS(2371),
    [anon_sym_double] = ACTIONS(2371),
    [anon_sym_float] = ACTIONS(2371),
    [anon_sym_int] = ACTIONS(2371),
    [anon_sym_long] = ACTIONS(2371),
    [anon_sym_object] = ACTIONS(2371),
    [anon_sym_sbyte] = ACTIONS(2371),
    [anon_sym_short] = ACTIONS(2371),
    [anon_sym_string] = ACTIONS(2371),
    [anon_sym_uint] = ACTIONS(2371),
    [anon_sym_ulong] = ACTIONS(2371),
    [anon_sym_ushort] = ACTIONS(2371),
    [anon_sym_new] = ACTIONS(2371),
    [anon_sym_RBRACE] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_event] = ACTIONS(2371),
    [sym_void_keyword] = ACTIONS(2371),
    [sym_identifier_name] = ACTIONS(2371),
    [sym_comment] = ACTIONS(31),
  },
  [923] = {
    [sym_type_parameter_constraints_clause] = STATE(1011),
    [aux_sym_class_declaration_repeat1] = STATE(1011),
    [anon_sym_SEMI] = ACTIONS(2359),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [924] = {
    [anon_sym_RBRACK] = ACTIONS(2375),
    [sym_comment] = ACTIONS(31),
  },
  [925] = {
    [sym_interface_accessor] = STATE(784),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(784),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [926] = {
    [sym__expression] = STATE(1014),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym__literal] = STATE(1014),
    [sym_boolean_literal] = STATE(1014),
    [sym_character_literal] = STATE(1014),
    [sym_integer_literal] = STATE(1014),
    [sym_real_literal] = STATE(1014),
    [sym_string_literal] = STATE(1014),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2379),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2379),
    [sym_comment] = ACTIONS(31),
  },
  [927] = {
    [ts_builtin_sym_end] = ACTIONS(2381),
    [anon_sym_bool] = ACTIONS(2383),
    [anon_sym_byte] = ACTIONS(2383),
    [anon_sym_char] = ACTIONS(2383),
    [anon_sym_decimal] = ACTIONS(2383),
    [anon_sym_double] = ACTIONS(2383),
    [anon_sym_float] = ACTIONS(2383),
    [anon_sym_int] = ACTIONS(2383),
    [anon_sym_long] = ACTIONS(2383),
    [anon_sym_object] = ACTIONS(2383),
    [anon_sym_sbyte] = ACTIONS(2383),
    [anon_sym_short] = ACTIONS(2383),
    [anon_sym_string] = ACTIONS(2383),
    [anon_sym_uint] = ACTIONS(2383),
    [anon_sym_ulong] = ACTIONS(2383),
    [anon_sym_ushort] = ACTIONS(2383),
    [anon_sym_abstract] = ACTIONS(2383),
    [anon_sym_async] = ACTIONS(2383),
    [anon_sym_extern] = ACTIONS(2383),
    [anon_sym_internal] = ACTIONS(2383),
    [anon_sym_new] = ACTIONS(2383),
    [anon_sym_override] = ACTIONS(2383),
    [anon_sym_private] = ACTIONS(2383),
    [anon_sym_protected] = ACTIONS(2383),
    [anon_sym_public] = ACTIONS(2383),
    [anon_sym_readonly] = ACTIONS(2383),
    [anon_sym_sealed] = ACTIONS(2383),
    [anon_sym_static] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_virtual] = ACTIONS(2383),
    [anon_sym_volatile] = ACTIONS(2383),
    [anon_sym_using] = ACTIONS(2383),
    [anon_sym_namespace] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2381),
    [anon_sym_partial] = ACTIONS(2383),
    [anon_sym_class] = ACTIONS(2383),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_event] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_implicit] = ACTIONS(2383),
    [anon_sym_explicit] = ACTIONS(2383),
    [anon_sym_interface] = ACTIONS(2383),
    [anon_sym_enum] = ACTIONS(2383),
    [anon_sym_delegate] = ACTIONS(2383),
    [sym_void_keyword] = ACTIONS(2383),
    [anon_sym_const] = ACTIONS(2383),
    [sym_identifier_name] = ACTIONS(2383),
    [sym_comment] = ACTIONS(31),
  },
  [928] = {
    [sym_identifier_name] = ACTIONS(2385),
    [sym_comment] = ACTIONS(31),
  },
  [929] = {
    [aux_sym_array_rank_specifier_repeat1] = STATE(929),
    [anon_sym_COMMA] = ACTIONS(2387),
    [anon_sym_RBRACK] = ACTIONS(2390),
    [sym_comment] = ACTIONS(31),
  },
  [930] = {
    [sym__expression] = STATE(1015),
    [sym_parenthesized_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym__literal] = STATE(1015),
    [sym_boolean_literal] = STATE(1015),
    [sym_character_literal] = STATE(1015),
    [sym_integer_literal] = STATE(1015),
    [sym_real_literal] = STATE(1015),
    [sym_string_literal] = STATE(1015),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2392),
    [sym_comment] = ACTIONS(31),
  },
  [931] = {
    [sym__expression] = STATE(1016),
    [sym_parenthesized_expression] = STATE(1016),
    [sym_ternary_expression] = STATE(1016),
    [sym_binary_expression] = STATE(1016),
    [sym_unary_expression] = STATE(1016),
    [sym__literal] = STATE(1016),
    [sym_boolean_literal] = STATE(1016),
    [sym_character_literal] = STATE(1016),
    [sym_integer_literal] = STATE(1016),
    [sym_real_literal] = STATE(1016),
    [sym_string_literal] = STATE(1016),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2394),
    [sym_comment] = ACTIONS(31),
  },
  [932] = {
    [sym__expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym__literal] = STATE(725),
    [sym_boolean_literal] = STATE(725),
    [sym_character_literal] = STATE(725),
    [sym_integer_literal] = STATE(725),
    [sym_real_literal] = STATE(725),
    [sym_string_literal] = STATE(725),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1519),
    [sym_comment] = ACTIONS(31),
  },
  [933] = {
    [sym__expression] = STATE(1017),
    [sym_parenthesized_expression] = STATE(1017),
    [sym_ternary_expression] = STATE(1017),
    [sym_binary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym__literal] = STATE(1017),
    [sym_boolean_literal] = STATE(1017),
    [sym_character_literal] = STATE(1017),
    [sym_integer_literal] = STATE(1017),
    [sym_real_literal] = STATE(1017),
    [sym_string_literal] = STATE(1017),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2396),
    [sym_comment] = ACTIONS(31),
  },
  [934] = {
    [sym__expression] = STATE(1018),
    [sym_parenthesized_expression] = STATE(1018),
    [sym_ternary_expression] = STATE(1018),
    [sym_binary_expression] = STATE(1018),
    [sym_unary_expression] = STATE(1018),
    [sym__literal] = STATE(1018),
    [sym_boolean_literal] = STATE(1018),
    [sym_character_literal] = STATE(1018),
    [sym_integer_literal] = STATE(1018),
    [sym_real_literal] = STATE(1018),
    [sym_string_literal] = STATE(1018),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2398),
    [sym_comment] = ACTIONS(31),
  },
  [935] = {
    [sym__expression] = STATE(1019),
    [sym_parenthesized_expression] = STATE(1019),
    [sym_ternary_expression] = STATE(1019),
    [sym_binary_expression] = STATE(1019),
    [sym_unary_expression] = STATE(1019),
    [sym__literal] = STATE(1019),
    [sym_boolean_literal] = STATE(1019),
    [sym_character_literal] = STATE(1019),
    [sym_integer_literal] = STATE(1019),
    [sym_real_literal] = STATE(1019),
    [sym_string_literal] = STATE(1019),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2400),
    [sym_comment] = ACTIONS(31),
  },
  [936] = {
    [sym__expression] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym_ternary_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_unary_expression] = STATE(1020),
    [sym__literal] = STATE(1020),
    [sym_boolean_literal] = STATE(1020),
    [sym_character_literal] = STATE(1020),
    [sym_integer_literal] = STATE(1020),
    [sym_real_literal] = STATE(1020),
    [sym_string_literal] = STATE(1020),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2402),
    [sym_comment] = ACTIONS(31),
  },
  [937] = {
    [sym__expression] = STATE(1021),
    [sym_parenthesized_expression] = STATE(1021),
    [sym_ternary_expression] = STATE(1021),
    [sym_binary_expression] = STATE(1021),
    [sym_unary_expression] = STATE(1021),
    [sym__literal] = STATE(1021),
    [sym_boolean_literal] = STATE(1021),
    [sym_character_literal] = STATE(1021),
    [sym_integer_literal] = STATE(1021),
    [sym_real_literal] = STATE(1021),
    [sym_string_literal] = STATE(1021),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2404),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2404),
    [sym_comment] = ACTIONS(31),
  },
  [938] = {
    [sym__expression] = STATE(1022),
    [sym_parenthesized_expression] = STATE(1022),
    [sym_ternary_expression] = STATE(1022),
    [sym_binary_expression] = STATE(1022),
    [sym_unary_expression] = STATE(1022),
    [sym__literal] = STATE(1022),
    [sym_boolean_literal] = STATE(1022),
    [sym_character_literal] = STATE(1022),
    [sym_integer_literal] = STATE(1022),
    [sym_real_literal] = STATE(1022),
    [sym_string_literal] = STATE(1022),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2406),
    [sym_comment] = ACTIONS(31),
  },
  [939] = {
    [sym__expression] = STATE(1023),
    [sym_parenthesized_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym__literal] = STATE(1023),
    [sym_boolean_literal] = STATE(1023),
    [sym_character_literal] = STATE(1023),
    [sym_integer_literal] = STATE(1023),
    [sym_real_literal] = STATE(1023),
    [sym_string_literal] = STATE(1023),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2408),
    [sym_comment] = ACTIONS(31),
  },
  [940] = {
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_RPAREN] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_RBRACK] = ACTIONS(2410),
    [anon_sym_params] = ACTIONS(2410),
    [sym_comment] = ACTIONS(31),
  },
  [941] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [942] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [943] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [944] = {
    [ts_builtin_sym_end] = ACTIONS(2381),
    [anon_sym_bool] = ACTIONS(2383),
    [anon_sym_byte] = ACTIONS(2383),
    [anon_sym_char] = ACTIONS(2383),
    [anon_sym_decimal] = ACTIONS(2383),
    [anon_sym_double] = ACTIONS(2383),
    [anon_sym_float] = ACTIONS(2383),
    [anon_sym_int] = ACTIONS(2383),
    [anon_sym_long] = ACTIONS(2383),
    [anon_sym_object] = ACTIONS(2383),
    [anon_sym_sbyte] = ACTIONS(2383),
    [anon_sym_short] = ACTIONS(2383),
    [anon_sym_string] = ACTIONS(2383),
    [anon_sym_uint] = ACTIONS(2383),
    [anon_sym_ulong] = ACTIONS(2383),
    [anon_sym_ushort] = ACTIONS(2383),
    [anon_sym_abstract] = ACTIONS(2383),
    [anon_sym_async] = ACTIONS(2383),
    [anon_sym_extern] = ACTIONS(2383),
    [anon_sym_internal] = ACTIONS(2383),
    [anon_sym_new] = ACTIONS(2383),
    [anon_sym_override] = ACTIONS(2383),
    [anon_sym_private] = ACTIONS(2383),
    [anon_sym_protected] = ACTIONS(2383),
    [anon_sym_public] = ACTIONS(2383),
    [anon_sym_readonly] = ACTIONS(2383),
    [anon_sym_sealed] = ACTIONS(2383),
    [anon_sym_static] = ACTIONS(2383),
    [anon_sym_unsafe] = ACTIONS(2383),
    [anon_sym_virtual] = ACTIONS(2383),
    [anon_sym_volatile] = ACTIONS(2383),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2383),
    [anon_sym_namespace] = ACTIONS(2383),
    [anon_sym_RBRACE] = ACTIONS(2381),
    [anon_sym_partial] = ACTIONS(2383),
    [anon_sym_class] = ACTIONS(2383),
    [anon_sym_struct] = ACTIONS(2383),
    [anon_sym_LBRACK] = ACTIONS(2381),
    [anon_sym_event] = ACTIONS(2383),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_implicit] = ACTIONS(2383),
    [anon_sym_explicit] = ACTIONS(2383),
    [anon_sym_interface] = ACTIONS(2383),
    [anon_sym_enum] = ACTIONS(2383),
    [anon_sym_delegate] = ACTIONS(2383),
    [sym_void_keyword] = ACTIONS(2383),
    [anon_sym_const] = ACTIONS(2383),
    [sym_identifier_name] = ACTIONS(2383),
    [sym_comment] = ACTIONS(31),
  },
  [945] = {
    [sym__type_declaration] = STATE(1028),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(1028),
    [sym_class_declaration] = STATE(1028),
    [sym_indexer_declaration] = STATE(1028),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(1028),
    [sym_operator_declaration] = STATE(1028),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(1028),
    [sym_struct_declaration] = STATE(1028),
    [sym_enum_declaration] = STATE(1028),
    [sym_delegate_declaration] = STATE(1028),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(1028),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(1028),
    [sym_constructor_declaration] = STATE(1028),
    [sym_destructor_declaration] = STATE(1028),
    [sym_method_declaration] = STATE(1028),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(1028),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [946] = {
    [sym__type_declaration] = STATE(1029),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(1029),
    [sym_class_declaration] = STATE(1029),
    [sym_indexer_declaration] = STATE(1029),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(1029),
    [sym_operator_declaration] = STATE(1029),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(1029),
    [sym_struct_declaration] = STATE(1029),
    [sym_enum_declaration] = STATE(1029),
    [sym_delegate_declaration] = STATE(1029),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(1029),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(1029),
    [sym_constructor_declaration] = STATE(1029),
    [sym_method_declaration] = STATE(1029),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(1029),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [947] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(1030),
    [sym_interface_event_declaration] = STATE(1030),
    [sym_interface_property_declaration] = STATE(1030),
    [sym_interface_indexer_declaration] = STATE(1030),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(1030),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [948] = {
    [aux_sym_enum_declaration_repeat1] = STATE(431),
    [anon_sym_COMMA] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(31),
  },
  [949] = {
    [ts_builtin_sym_end] = ACTIONS(2422),
    [anon_sym_bool] = ACTIONS(2424),
    [anon_sym_byte] = ACTIONS(2424),
    [anon_sym_char] = ACTIONS(2424),
    [anon_sym_decimal] = ACTIONS(2424),
    [anon_sym_double] = ACTIONS(2424),
    [anon_sym_float] = ACTIONS(2424),
    [anon_sym_int] = ACTIONS(2424),
    [anon_sym_long] = ACTIONS(2424),
    [anon_sym_object] = ACTIONS(2424),
    [anon_sym_sbyte] = ACTIONS(2424),
    [anon_sym_short] = ACTIONS(2424),
    [anon_sym_string] = ACTIONS(2424),
    [anon_sym_uint] = ACTIONS(2424),
    [anon_sym_ulong] = ACTIONS(2424),
    [anon_sym_ushort] = ACTIONS(2424),
    [anon_sym_abstract] = ACTIONS(2424),
    [anon_sym_async] = ACTIONS(2424),
    [anon_sym_extern] = ACTIONS(2424),
    [anon_sym_internal] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2424),
    [anon_sym_override] = ACTIONS(2424),
    [anon_sym_private] = ACTIONS(2424),
    [anon_sym_protected] = ACTIONS(2424),
    [anon_sym_public] = ACTIONS(2424),
    [anon_sym_readonly] = ACTIONS(2424),
    [anon_sym_sealed] = ACTIONS(2424),
    [anon_sym_static] = ACTIONS(2424),
    [anon_sym_unsafe] = ACTIONS(2424),
    [anon_sym_virtual] = ACTIONS(2424),
    [anon_sym_volatile] = ACTIONS(2424),
    [anon_sym_using] = ACTIONS(2424),
    [anon_sym_namespace] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_partial] = ACTIONS(2424),
    [anon_sym_class] = ACTIONS(2424),
    [anon_sym_struct] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_event] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2422),
    [anon_sym_implicit] = ACTIONS(2424),
    [anon_sym_explicit] = ACTIONS(2424),
    [anon_sym_interface] = ACTIONS(2424),
    [anon_sym_enum] = ACTIONS(2424),
    [anon_sym_delegate] = ACTIONS(2424),
    [sym_void_keyword] = ACTIONS(2424),
    [anon_sym_const] = ACTIONS(2424),
    [sym_identifier_name] = ACTIONS(2424),
    [sym_comment] = ACTIONS(31),
  },
  [950] = {
    [ts_builtin_sym_end] = ACTIONS(2426),
    [anon_sym_bool] = ACTIONS(2428),
    [anon_sym_byte] = ACTIONS(2428),
    [anon_sym_char] = ACTIONS(2428),
    [anon_sym_decimal] = ACTIONS(2428),
    [anon_sym_double] = ACTIONS(2428),
    [anon_sym_float] = ACTIONS(2428),
    [anon_sym_int] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_object] = ACTIONS(2428),
    [anon_sym_sbyte] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_uint] = ACTIONS(2428),
    [anon_sym_ulong] = ACTIONS(2428),
    [anon_sym_ushort] = ACTIONS(2428),
    [anon_sym_abstract] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym_internal] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_private] = ACTIONS(2428),
    [anon_sym_protected] = ACTIONS(2428),
    [anon_sym_public] = ACTIONS(2428),
    [anon_sym_readonly] = ACTIONS(2428),
    [anon_sym_sealed] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_unsafe] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_partial] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_event] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_implicit] = ACTIONS(2428),
    [anon_sym_explicit] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_delegate] = ACTIONS(2428),
    [sym_void_keyword] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [sym_identifier_name] = ACTIONS(2428),
    [sym_comment] = ACTIONS(31),
  },
  [951] = {
    [ts_builtin_sym_end] = ACTIONS(2430),
    [anon_sym_bool] = ACTIONS(2432),
    [anon_sym_byte] = ACTIONS(2432),
    [anon_sym_char] = ACTIONS(2432),
    [anon_sym_decimal] = ACTIONS(2432),
    [anon_sym_double] = ACTIONS(2432),
    [anon_sym_float] = ACTIONS(2432),
    [anon_sym_int] = ACTIONS(2432),
    [anon_sym_long] = ACTIONS(2432),
    [anon_sym_object] = ACTIONS(2432),
    [anon_sym_sbyte] = ACTIONS(2432),
    [anon_sym_short] = ACTIONS(2432),
    [anon_sym_string] = ACTIONS(2432),
    [anon_sym_uint] = ACTIONS(2432),
    [anon_sym_ulong] = ACTIONS(2432),
    [anon_sym_ushort] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_extern] = ACTIONS(2432),
    [anon_sym_internal] = ACTIONS(2432),
    [anon_sym_new] = ACTIONS(2432),
    [anon_sym_override] = ACTIONS(2432),
    [anon_sym_private] = ACTIONS(2432),
    [anon_sym_protected] = ACTIONS(2432),
    [anon_sym_public] = ACTIONS(2432),
    [anon_sym_readonly] = ACTIONS(2432),
    [anon_sym_sealed] = ACTIONS(2432),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_unsafe] = ACTIONS(2432),
    [anon_sym_virtual] = ACTIONS(2432),
    [anon_sym_volatile] = ACTIONS(2432),
    [anon_sym_using] = ACTIONS(2432),
    [anon_sym_namespace] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_partial] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2432),
    [anon_sym_struct] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_event] = ACTIONS(2432),
    [anon_sym_TILDE] = ACTIONS(2430),
    [anon_sym_implicit] = ACTIONS(2432),
    [anon_sym_explicit] = ACTIONS(2432),
    [anon_sym_interface] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
    [anon_sym_delegate] = ACTIONS(2432),
    [sym_void_keyword] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [sym_identifier_name] = ACTIONS(2432),
    [sym_comment] = ACTIONS(31),
  },
  [952] = {
    [anon_sym_bool] = ACTIONS(2434),
    [anon_sym_byte] = ACTIONS(2434),
    [anon_sym_char] = ACTIONS(2434),
    [anon_sym_decimal] = ACTIONS(2434),
    [anon_sym_double] = ACTIONS(2434),
    [anon_sym_float] = ACTIONS(2434),
    [anon_sym_int] = ACTIONS(2434),
    [anon_sym_long] = ACTIONS(2434),
    [anon_sym_object] = ACTIONS(2434),
    [anon_sym_sbyte] = ACTIONS(2434),
    [anon_sym_short] = ACTIONS(2434),
    [anon_sym_string] = ACTIONS(2434),
    [anon_sym_uint] = ACTIONS(2434),
    [anon_sym_ulong] = ACTIONS(2434),
    [anon_sym_ushort] = ACTIONS(2434),
    [anon_sym_abstract] = ACTIONS(2434),
    [anon_sym_async] = ACTIONS(2434),
    [anon_sym_extern] = ACTIONS(2434),
    [anon_sym_internal] = ACTIONS(2434),
    [anon_sym_new] = ACTIONS(2434),
    [anon_sym_override] = ACTIONS(2434),
    [anon_sym_private] = ACTIONS(2434),
    [anon_sym_protected] = ACTIONS(2434),
    [anon_sym_public] = ACTIONS(2434),
    [anon_sym_readonly] = ACTIONS(2434),
    [anon_sym_sealed] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2434),
    [anon_sym_unsafe] = ACTIONS(2434),
    [anon_sym_virtual] = ACTIONS(2434),
    [anon_sym_volatile] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_partial] = ACTIONS(2434),
    [anon_sym_class] = ACTIONS(2434),
    [anon_sym_struct] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_event] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2436),
    [anon_sym_implicit] = ACTIONS(2434),
    [anon_sym_explicit] = ACTIONS(2434),
    [anon_sym_interface] = ACTIONS(2434),
    [anon_sym_enum] = ACTIONS(2434),
    [anon_sym_delegate] = ACTIONS(2434),
    [sym_void_keyword] = ACTIONS(2434),
    [anon_sym_const] = ACTIONS(2434),
    [sym_identifier_name] = ACTIONS(2434),
    [sym_comment] = ACTIONS(31),
  },
  [953] = {
    [anon_sym_bool] = ACTIONS(2438),
    [anon_sym_byte] = ACTIONS(2438),
    [anon_sym_char] = ACTIONS(2438),
    [anon_sym_decimal] = ACTIONS(2438),
    [anon_sym_double] = ACTIONS(2438),
    [anon_sym_float] = ACTIONS(2438),
    [anon_sym_int] = ACTIONS(2438),
    [anon_sym_long] = ACTIONS(2438),
    [anon_sym_object] = ACTIONS(2438),
    [anon_sym_sbyte] = ACTIONS(2438),
    [anon_sym_short] = ACTIONS(2438),
    [anon_sym_string] = ACTIONS(2438),
    [anon_sym_uint] = ACTIONS(2438),
    [anon_sym_ulong] = ACTIONS(2438),
    [anon_sym_ushort] = ACTIONS(2438),
    [anon_sym_abstract] = ACTIONS(2438),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_extern] = ACTIONS(2438),
    [anon_sym_internal] = ACTIONS(2438),
    [anon_sym_new] = ACTIONS(2438),
    [anon_sym_override] = ACTIONS(2438),
    [anon_sym_private] = ACTIONS(2438),
    [anon_sym_protected] = ACTIONS(2438),
    [anon_sym_public] = ACTIONS(2438),
    [anon_sym_readonly] = ACTIONS(2438),
    [anon_sym_sealed] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2438),
    [anon_sym_unsafe] = ACTIONS(2438),
    [anon_sym_virtual] = ACTIONS(2438),
    [anon_sym_volatile] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_partial] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2438),
    [anon_sym_struct] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_event] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2440),
    [anon_sym_implicit] = ACTIONS(2438),
    [anon_sym_explicit] = ACTIONS(2438),
    [anon_sym_interface] = ACTIONS(2438),
    [anon_sym_enum] = ACTIONS(2438),
    [anon_sym_delegate] = ACTIONS(2438),
    [sym_void_keyword] = ACTIONS(2438),
    [anon_sym_const] = ACTIONS(2438),
    [sym_identifier_name] = ACTIONS(2438),
    [sym_comment] = ACTIONS(31),
  },
  [954] = {
    [sym__attribute_section] = STATE(954),
    [aux_sym__attributes_repeat1] = STATE(954),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_remove] = ACTIONS(218),
    [sym_comment] = ACTIONS(31),
  },
  [955] = {
    [sym__attribute_section] = STATE(955),
    [aux_sym__attributes_repeat1] = STATE(955),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_add] = ACTIONS(218),
    [sym_comment] = ACTIONS(31),
  },
  [956] = {
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_remove] = ACTIONS(2442),
    [sym_comment] = ACTIONS(31),
  },
  [957] = {
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_add] = ACTIONS(2444),
    [sym_comment] = ACTIONS(31),
  },
  [958] = {
    [sym__expression] = STATE(523),
    [sym_parenthesized_expression] = STATE(523),
    [sym_ternary_expression] = STATE(523),
    [sym_binary_expression] = STATE(523),
    [sym_unary_expression] = STATE(523),
    [sym__literal] = STATE(523),
    [sym_boolean_literal] = STATE(523),
    [sym_character_literal] = STATE(523),
    [sym_integer_literal] = STATE(523),
    [sym_real_literal] = STATE(523),
    [sym_string_literal] = STATE(523),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1074),
    [sym_comment] = ACTIONS(31),
  },
  [959] = {
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_RBRACK] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_params] = ACTIONS(2155),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [sym_comment] = ACTIONS(31),
  },
  [960] = {
    [sym_default_argument] = STATE(940),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_EQ] = ACTIONS(1888),
    [anon_sym_LBRACK] = ACTIONS(2181),
    [anon_sym_RBRACK] = ACTIONS(2181),
    [anon_sym_params] = ACTIONS(2181),
    [sym_comment] = ACTIONS(31),
  },
  [961] = {
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_EQ_GT] = ACTIONS(2472),
    [sym_comment] = ACTIONS(31),
  },
  [962] = {
    [sym__type] = STATE(1042),
    [sym_predefined_type] = STATE(1042),
    [sym_generic_name] = STATE(1042),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [963] = {
    [sym__expression] = STATE(1043),
    [sym_parenthesized_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym__literal] = STATE(1043),
    [sym_boolean_literal] = STATE(1043),
    [sym_character_literal] = STATE(1043),
    [sym_integer_literal] = STATE(1043),
    [sym_real_literal] = STATE(1043),
    [sym_string_literal] = STATE(1043),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1012),
    [anon_sym_DASH] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1014),
    [anon_sym_PLUS_PLUS] = ACTIONS(1014),
    [anon_sym_DASH_DASH] = ACTIONS(1014),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1012),
    [anon_sym_sizeof] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2474),
    [sym_comment] = ACTIONS(31),
  },
  [964] = {
    [anon_sym_SEMI] = ACTIONS(2476),
    [sym_comment] = ACTIONS(31),
  },
  [965] = {
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [sym_comment] = ACTIONS(31),
  },
  [966] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [967] = {
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_EQ_GT] = ACTIONS(2480),
    [sym_comment] = ACTIONS(31),
  },
  [968] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [sym_statement_block] = STATE(1045),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [969] = {
    [anon_sym_RBRACE] = ACTIONS(2482),
    [sym_comment] = ACTIONS(31),
  },
  [970] = {
    [sym__expression] = STATE(1047),
    [sym_parenthesized_expression] = STATE(1047),
    [sym_ternary_expression] = STATE(1047),
    [sym_binary_expression] = STATE(1047),
    [sym_unary_expression] = STATE(1047),
    [sym__literal] = STATE(1047),
    [sym_boolean_literal] = STATE(1047),
    [sym_character_literal] = STATE(1047),
    [sym_integer_literal] = STATE(1047),
    [sym_real_literal] = STATE(1047),
    [sym_string_literal] = STATE(1047),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2484),
    [sym_comment] = ACTIONS(31),
  },
  [971] = {
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_LT_LT] = ACTIONS(2488),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_EQ_EQ] = ACTIONS(2488),
    [anon_sym_BANG_EQ] = ACTIONS(2488),
    [anon_sym_GT_EQ] = ACTIONS(2488),
    [anon_sym_LT_EQ] = ACTIONS(2488),
    [anon_sym_params] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(31),
  },
  [972] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [973] = {
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_STAR] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1108),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_CARET] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1114),
    [anon_sym_LT_LT] = ACTIONS(1116),
    [anon_sym_GT_GT] = ACTIONS(1116),
    [anon_sym_EQ_EQ] = ACTIONS(1118),
    [anon_sym_BANG_EQ] = ACTIONS(1118),
    [anon_sym_GT_EQ] = ACTIONS(1120),
    [anon_sym_LT_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1122),
    [anon_sym_AMP_AMP] = ACTIONS(1124),
    [anon_sym_PIPE_PIPE] = ACTIONS(1126),
    [sym_comment] = ACTIONS(31),
  },
  [974] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [975] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [976] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [977] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [978] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [979] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [980] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [981] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [982] = {
    [anon_sym_RPAREN] = ACTIONS(2494),
    [sym_identifier_name] = ACTIONS(2496),
    [sym_comment] = ACTIONS(31),
  },
  [983] = {
    [sym__expression] = STATE(1051),
    [sym_parenthesized_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym__literal] = STATE(1051),
    [sym_boolean_literal] = STATE(1051),
    [sym_character_literal] = STATE(1051),
    [sym_integer_literal] = STATE(1051),
    [sym_real_literal] = STATE(1051),
    [sym_string_literal] = STATE(1051),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2498),
    [sym_comment] = ACTIONS(31),
  },
  [984] = {
    [anon_sym_bool] = ACTIONS(2500),
    [anon_sym_byte] = ACTIONS(2500),
    [anon_sym_char] = ACTIONS(2500),
    [anon_sym_decimal] = ACTIONS(2500),
    [anon_sym_double] = ACTIONS(2500),
    [anon_sym_float] = ACTIONS(2500),
    [anon_sym_int] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_object] = ACTIONS(2500),
    [anon_sym_sbyte] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_string] = ACTIONS(2500),
    [anon_sym_uint] = ACTIONS(2500),
    [anon_sym_ulong] = ACTIONS(2500),
    [anon_sym_ushort] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_true] = ACTIONS(2500),
    [anon_sym_false] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_typeof] = ACTIONS(2500),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2500),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2502),
    [sym_null_literal] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_AT_DQUOTE] = ACTIONS(2502),
    [sym_identifier_name] = ACTIONS(2500),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_catch] = ACTIONS(2500),
    [anon_sym_finally] = ACTIONS(2500),
    [anon_sym_checked] = ACTIONS(2500),
    [anon_sym_unchecked] = ACTIONS(2500),
    [anon_sym_lock] = ACTIONS(2500),
    [anon_sym_yield] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym_var] = ACTIONS(2500),
  },
  [985] = {
    [sym_statement_block] = STATE(1052),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [986] = {
    [anon_sym_bool] = ACTIONS(2504),
    [anon_sym_byte] = ACTIONS(2504),
    [anon_sym_char] = ACTIONS(2504),
    [anon_sym_decimal] = ACTIONS(2504),
    [anon_sym_double] = ACTIONS(2504),
    [anon_sym_float] = ACTIONS(2504),
    [anon_sym_int] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_object] = ACTIONS(2504),
    [anon_sym_sbyte] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_string] = ACTIONS(2504),
    [anon_sym_uint] = ACTIONS(2504),
    [anon_sym_ulong] = ACTIONS(2504),
    [anon_sym_ushort] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_true] = ACTIONS(2504),
    [anon_sym_false] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2504),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2504),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2506),
    [sym_null_literal] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_AT_DQUOTE] = ACTIONS(2506),
    [sym_identifier_name] = ACTIONS(2504),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_checked] = ACTIONS(2504),
    [anon_sym_unchecked] = ACTIONS(2504),
    [anon_sym_lock] = ACTIONS(2504),
    [anon_sym_yield] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym_var] = ACTIONS(2504),
  },
  [987] = {
    [sym_statement_block] = STATE(1053),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [988] = {
    [anon_sym_LPAREN] = ACTIONS(2508),
    [sym_comment] = ACTIONS(31),
  },
  [989] = {
    [anon_sym_LPAREN] = ACTIONS(2510),
    [sym_comment] = ACTIONS(31),
  },
  [990] = {
    [anon_sym_LPAREN] = ACTIONS(2512),
    [sym_comment] = ACTIONS(31),
  },
  [991] = {
    [anon_sym_bool] = ACTIONS(2514),
    [anon_sym_byte] = ACTIONS(2514),
    [anon_sym_char] = ACTIONS(2514),
    [anon_sym_decimal] = ACTIONS(2514),
    [anon_sym_double] = ACTIONS(2514),
    [anon_sym_float] = ACTIONS(2514),
    [anon_sym_int] = ACTIONS(2514),
    [anon_sym_long] = ACTIONS(2514),
    [anon_sym_object] = ACTIONS(2514),
    [anon_sym_sbyte] = ACTIONS(2514),
    [anon_sym_short] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_uint] = ACTIONS(2514),
    [anon_sym_ulong] = ACTIONS(2514),
    [anon_sym_ushort] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_DOT] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_true] = ACTIONS(2514),
    [anon_sym_false] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2514),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2516),
    [sym_null_literal] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [sym_identifier_name] = ACTIONS(2514),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_checked] = ACTIONS(2514),
    [anon_sym_unchecked] = ACTIONS(2514),
    [anon_sym_lock] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_goto] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
  },
  [992] = {
    [sym_switch_section] = STATE(1061),
    [sym_switch_label] = STATE(1062),
    [aux_sym_switch_statement_repeat1] = STATE(1061),
    [aux_sym_switch_section_repeat1] = STATE(1062),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [sym_comment] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2524),
  },
  [993] = {
    [anon_sym_bool] = ACTIONS(2526),
    [anon_sym_byte] = ACTIONS(2526),
    [anon_sym_char] = ACTIONS(2526),
    [anon_sym_decimal] = ACTIONS(2526),
    [anon_sym_double] = ACTIONS(2526),
    [anon_sym_float] = ACTIONS(2526),
    [anon_sym_int] = ACTIONS(2526),
    [anon_sym_long] = ACTIONS(2526),
    [anon_sym_object] = ACTIONS(2526),
    [anon_sym_sbyte] = ACTIONS(2526),
    [anon_sym_short] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_uint] = ACTIONS(2526),
    [anon_sym_ulong] = ACTIONS(2526),
    [anon_sym_ushort] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_LBRACE] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2528),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_DOT] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2528),
    [anon_sym_TILDE] = ACTIONS(2528),
    [anon_sym_PLUS_PLUS] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2528),
    [anon_sym_true] = ACTIONS(2526),
    [anon_sym_false] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_typeof] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2526),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2528),
    [sym_null_literal] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2528),
    [anon_sym_AT_DQUOTE] = ACTIONS(2528),
    [sym_identifier_name] = ACTIONS(2526),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_checked] = ACTIONS(2526),
    [anon_sym_unchecked] = ACTIONS(2526),
    [anon_sym_lock] = ACTIONS(2526),
    [anon_sym_yield] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_break] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2526),
    [anon_sym_switch] = ACTIONS(2526),
    [anon_sym_case] = ACTIONS(2526),
    [anon_sym_default] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_continue] = ACTIONS(2526),
    [anon_sym_throw] = ACTIONS(2526),
    [anon_sym_goto] = ACTIONS(2526),
    [anon_sym_var] = ACTIONS(2526),
  },
  [994] = {
    [sym_catch_clause] = STATE(994),
    [aux_sym_try_statement_repeat1] = STATE(994),
    [sym_comment] = ACTIONS(31),
    [anon_sym_catch] = ACTIONS(2530),
    [anon_sym_finally] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2294),
  },
  [995] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(986),
    [sym__embedded_statement] = STATE(986),
    [sym_empty_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym__selection_statement] = STATE(986),
    [sym__iteration_statement] = STATE(986),
    [sym__jump_statement] = STATE(986),
    [sym_try_statement] = STATE(986),
    [sym_checked_statement] = STATE(986),
    [sym_unchecked_statement] = STATE(986),
    [sym_lock_statement] = STATE(986),
    [sym_yield_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_throw_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(1175),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [996] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1067),
    [sym__embedded_statement] = STATE(1067),
    [sym_empty_statement] = STATE(1067),
    [sym_expression_statement] = STATE(1067),
    [sym__selection_statement] = STATE(1067),
    [sym__iteration_statement] = STATE(1067),
    [sym__jump_statement] = STATE(1067),
    [sym_try_statement] = STATE(1067),
    [sym_checked_statement] = STATE(1067),
    [sym_unchecked_statement] = STATE(1067),
    [sym_lock_statement] = STATE(1067),
    [sym_yield_statement] = STATE(1067),
    [sym_if_statement] = STATE(1067),
    [sym_switch_statement] = STATE(1067),
    [sym_while_statement] = STATE(1067),
    [sym_do_statement] = STATE(1067),
    [sym_break_statement] = STATE(1067),
    [sym_continue_statement] = STATE(1067),
    [sym_return_statement] = STATE(1067),
    [sym_throw_statement] = STATE(1067),
    [sym_goto_statement] = STATE(1067),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2533),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2535),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2539),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [997] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(993),
    [sym__embedded_statement] = STATE(993),
    [sym_empty_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym__selection_statement] = STATE(993),
    [sym__iteration_statement] = STATE(993),
    [sym__jump_statement] = STATE(993),
    [sym_try_statement] = STATE(993),
    [sym_checked_statement] = STATE(993),
    [sym_unchecked_statement] = STATE(993),
    [sym_lock_statement] = STATE(993),
    [sym_yield_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_throw_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(1175),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [998] = {
    [anon_sym_RPAREN] = ACTIONS(2541),
    [sym_comment] = ACTIONS(31),
  },
  [999] = {
    [aux_sym_array_initalizer_repeat1] = STATE(1071),
    [anon_sym_COMMA] = ACTIONS(2543),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [sym_comment] = ACTIONS(31),
  },
  [1000] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1282),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1286),
    [sym_comment] = ACTIONS(31),
  },
  [1001] = {
    [anon_sym_SEMI] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(2547),
    [sym_comment] = ACTIONS(31),
  },
  [1002] = {
    [sym_type_parameter_constraints_clause] = STATE(1072),
    [sym_statement_block] = STATE(1045),
    [aux_sym_class_declaration_repeat1] = STATE(1072),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [1003] = {
    [sym_remove_accessor_declaration] = STATE(1073),
    [sym__attributes] = STATE(829),
    [sym__attribute_section] = STATE(830),
    [aux_sym__attributes_repeat1] = STATE(830),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_remove] = ACTIONS(1358),
    [sym_comment] = ACTIONS(31),
  },
  [1004] = {
    [sym_add_accessor_declaration] = STATE(1073),
    [sym__attributes] = STATE(831),
    [sym__attribute_section] = STATE(832),
    [aux_sym__attributes_repeat1] = STATE(832),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_add] = ACTIONS(1356),
    [sym_comment] = ACTIONS(31),
  },
  [1005] = {
    [anon_sym_SEMI] = ACTIONS(2549),
    [anon_sym_LBRACE] = ACTIONS(2549),
    [anon_sym_where] = ACTIONS(2549),
    [sym_comment] = ACTIONS(31),
  },
  [1006] = {
    [sym_constructor_constraint] = STATE(1074),
    [anon_sym_new] = ACTIONS(806),
    [sym_identifier_name] = ACTIONS(2349),
    [sym_comment] = ACTIONS(31),
  },
  [1007] = {
    [anon_sym_bool] = ACTIONS(2551),
    [anon_sym_byte] = ACTIONS(2551),
    [anon_sym_char] = ACTIONS(2551),
    [anon_sym_decimal] = ACTIONS(2551),
    [anon_sym_double] = ACTIONS(2551),
    [anon_sym_float] = ACTIONS(2551),
    [anon_sym_int] = ACTIONS(2551),
    [anon_sym_long] = ACTIONS(2551),
    [anon_sym_object] = ACTIONS(2551),
    [anon_sym_sbyte] = ACTIONS(2551),
    [anon_sym_short] = ACTIONS(2551),
    [anon_sym_string] = ACTIONS(2551),
    [anon_sym_uint] = ACTIONS(2551),
    [anon_sym_ulong] = ACTIONS(2551),
    [anon_sym_ushort] = ACTIONS(2551),
    [anon_sym_new] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_event] = ACTIONS(2551),
    [sym_void_keyword] = ACTIONS(2551),
    [sym_identifier_name] = ACTIONS(2551),
    [sym_comment] = ACTIONS(31),
  },
  [1008] = {
    [sym_interface_accessor] = STATE(1075),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(1075),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [1009] = {
    [sym_constructor_constraint] = STATE(771),
    [anon_sym_new] = ACTIONS(806),
    [sym_identifier_name] = ACTIONS(2555),
    [sym_comment] = ACTIONS(31),
  },
  [1010] = {
    [sym_interface_accessor] = STATE(784),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(784),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_RBRACE] = ACTIONS(2557),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [1011] = {
    [sym_type_parameter_constraints_clause] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(598),
    [anon_sym_SEMI] = ACTIONS(2559),
    [anon_sym_where] = ACTIONS(868),
    [sym_comment] = ACTIONS(31),
  },
  [1012] = {
    [anon_sym_LBRACE] = ACTIONS(2561),
    [sym_comment] = ACTIONS(31),
  },
  [1013] = {
    [anon_sym_bool] = ACTIONS(2563),
    [anon_sym_byte] = ACTIONS(2563),
    [anon_sym_char] = ACTIONS(2563),
    [anon_sym_decimal] = ACTIONS(2563),
    [anon_sym_double] = ACTIONS(2563),
    [anon_sym_float] = ACTIONS(2563),
    [anon_sym_int] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_object] = ACTIONS(2563),
    [anon_sym_sbyte] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_string] = ACTIONS(2563),
    [anon_sym_uint] = ACTIONS(2563),
    [anon_sym_ulong] = ACTIONS(2563),
    [anon_sym_ushort] = ACTIONS(2563),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_RBRACE] = ACTIONS(2565),
    [anon_sym_LBRACK] = ACTIONS(2565),
    [anon_sym_event] = ACTIONS(2563),
    [sym_void_keyword] = ACTIONS(2563),
    [sym_identifier_name] = ACTIONS(2563),
    [sym_comment] = ACTIONS(31),
  },
  [1014] = {
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_SLASH] = ACTIONS(1268),
    [anon_sym_PERCENT] = ACTIONS(1266),
    [anon_sym_CARET] = ACTIONS(1270),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1274),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(1276),
    [anon_sym_EQ_EQ] = ACTIONS(1278),
    [anon_sym_BANG_EQ] = ACTIONS(1278),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_QMARK] = ACTIONS(1282),
    [anon_sym_AMP_AMP] = ACTIONS(1284),
    [anon_sym_PIPE_PIPE] = ACTIONS(1286),
    [sym_comment] = ACTIONS(31),
  },
  [1015] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1016] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1017] = {
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1018] = {
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1019] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1020] = {
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1021] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [1022] = {
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1023] = {
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(2177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1024] = {
    [ts_builtin_sym_end] = ACTIONS(2422),
    [anon_sym_bool] = ACTIONS(2424),
    [anon_sym_byte] = ACTIONS(2424),
    [anon_sym_char] = ACTIONS(2424),
    [anon_sym_decimal] = ACTIONS(2424),
    [anon_sym_double] = ACTIONS(2424),
    [anon_sym_float] = ACTIONS(2424),
    [anon_sym_int] = ACTIONS(2424),
    [anon_sym_long] = ACTIONS(2424),
    [anon_sym_object] = ACTIONS(2424),
    [anon_sym_sbyte] = ACTIONS(2424),
    [anon_sym_short] = ACTIONS(2424),
    [anon_sym_string] = ACTIONS(2424),
    [anon_sym_uint] = ACTIONS(2424),
    [anon_sym_ulong] = ACTIONS(2424),
    [anon_sym_ushort] = ACTIONS(2424),
    [anon_sym_abstract] = ACTIONS(2424),
    [anon_sym_async] = ACTIONS(2424),
    [anon_sym_extern] = ACTIONS(2424),
    [anon_sym_internal] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2424),
    [anon_sym_override] = ACTIONS(2424),
    [anon_sym_private] = ACTIONS(2424),
    [anon_sym_protected] = ACTIONS(2424),
    [anon_sym_public] = ACTIONS(2424),
    [anon_sym_readonly] = ACTIONS(2424),
    [anon_sym_sealed] = ACTIONS(2424),
    [anon_sym_static] = ACTIONS(2424),
    [anon_sym_unsafe] = ACTIONS(2424),
    [anon_sym_virtual] = ACTIONS(2424),
    [anon_sym_volatile] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym_using] = ACTIONS(2424),
    [anon_sym_namespace] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_partial] = ACTIONS(2424),
    [anon_sym_class] = ACTIONS(2424),
    [anon_sym_struct] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_event] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2422),
    [anon_sym_implicit] = ACTIONS(2424),
    [anon_sym_explicit] = ACTIONS(2424),
    [anon_sym_interface] = ACTIONS(2424),
    [anon_sym_enum] = ACTIONS(2424),
    [anon_sym_delegate] = ACTIONS(2424),
    [sym_void_keyword] = ACTIONS(2424),
    [anon_sym_const] = ACTIONS(2424),
    [sym_identifier_name] = ACTIONS(2424),
    [sym_comment] = ACTIONS(31),
  },
  [1025] = {
    [ts_builtin_sym_end] = ACTIONS(2426),
    [anon_sym_bool] = ACTIONS(2428),
    [anon_sym_byte] = ACTIONS(2428),
    [anon_sym_char] = ACTIONS(2428),
    [anon_sym_decimal] = ACTIONS(2428),
    [anon_sym_double] = ACTIONS(2428),
    [anon_sym_float] = ACTIONS(2428),
    [anon_sym_int] = ACTIONS(2428),
    [anon_sym_long] = ACTIONS(2428),
    [anon_sym_object] = ACTIONS(2428),
    [anon_sym_sbyte] = ACTIONS(2428),
    [anon_sym_short] = ACTIONS(2428),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_uint] = ACTIONS(2428),
    [anon_sym_ulong] = ACTIONS(2428),
    [anon_sym_ushort] = ACTIONS(2428),
    [anon_sym_abstract] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2428),
    [anon_sym_extern] = ACTIONS(2428),
    [anon_sym_internal] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_private] = ACTIONS(2428),
    [anon_sym_protected] = ACTIONS(2428),
    [anon_sym_public] = ACTIONS(2428),
    [anon_sym_readonly] = ACTIONS(2428),
    [anon_sym_sealed] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_unsafe] = ACTIONS(2428),
    [anon_sym_virtual] = ACTIONS(2428),
    [anon_sym_volatile] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_using] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_partial] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_struct] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_event] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_implicit] = ACTIONS(2428),
    [anon_sym_explicit] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
    [anon_sym_delegate] = ACTIONS(2428),
    [sym_void_keyword] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [sym_identifier_name] = ACTIONS(2428),
    [sym_comment] = ACTIONS(31),
  },
  [1026] = {
    [ts_builtin_sym_end] = ACTIONS(2430),
    [anon_sym_bool] = ACTIONS(2432),
    [anon_sym_byte] = ACTIONS(2432),
    [anon_sym_char] = ACTIONS(2432),
    [anon_sym_decimal] = ACTIONS(2432),
    [anon_sym_double] = ACTIONS(2432),
    [anon_sym_float] = ACTIONS(2432),
    [anon_sym_int] = ACTIONS(2432),
    [anon_sym_long] = ACTIONS(2432),
    [anon_sym_object] = ACTIONS(2432),
    [anon_sym_sbyte] = ACTIONS(2432),
    [anon_sym_short] = ACTIONS(2432),
    [anon_sym_string] = ACTIONS(2432),
    [anon_sym_uint] = ACTIONS(2432),
    [anon_sym_ulong] = ACTIONS(2432),
    [anon_sym_ushort] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_extern] = ACTIONS(2432),
    [anon_sym_internal] = ACTIONS(2432),
    [anon_sym_new] = ACTIONS(2432),
    [anon_sym_override] = ACTIONS(2432),
    [anon_sym_private] = ACTIONS(2432),
    [anon_sym_protected] = ACTIONS(2432),
    [anon_sym_public] = ACTIONS(2432),
    [anon_sym_readonly] = ACTIONS(2432),
    [anon_sym_sealed] = ACTIONS(2432),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_unsafe] = ACTIONS(2432),
    [anon_sym_virtual] = ACTIONS(2432),
    [anon_sym_volatile] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2573),
    [anon_sym_using] = ACTIONS(2432),
    [anon_sym_namespace] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_partial] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2432),
    [anon_sym_struct] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_event] = ACTIONS(2432),
    [anon_sym_TILDE] = ACTIONS(2430),
    [anon_sym_implicit] = ACTIONS(2432),
    [anon_sym_explicit] = ACTIONS(2432),
    [anon_sym_interface] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
    [anon_sym_delegate] = ACTIONS(2432),
    [sym_void_keyword] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [sym_identifier_name] = ACTIONS(2432),
    [sym_comment] = ACTIONS(31),
  },
  [1027] = {
    [ts_builtin_sym_end] = ACTIONS(2575),
    [anon_sym_bool] = ACTIONS(2577),
    [anon_sym_byte] = ACTIONS(2577),
    [anon_sym_char] = ACTIONS(2577),
    [anon_sym_decimal] = ACTIONS(2577),
    [anon_sym_double] = ACTIONS(2577),
    [anon_sym_float] = ACTIONS(2577),
    [anon_sym_int] = ACTIONS(2577),
    [anon_sym_long] = ACTIONS(2577),
    [anon_sym_object] = ACTIONS(2577),
    [anon_sym_sbyte] = ACTIONS(2577),
    [anon_sym_short] = ACTIONS(2577),
    [anon_sym_string] = ACTIONS(2577),
    [anon_sym_uint] = ACTIONS(2577),
    [anon_sym_ulong] = ACTIONS(2577),
    [anon_sym_ushort] = ACTIONS(2577),
    [anon_sym_abstract] = ACTIONS(2577),
    [anon_sym_async] = ACTIONS(2577),
    [anon_sym_extern] = ACTIONS(2577),
    [anon_sym_internal] = ACTIONS(2577),
    [anon_sym_new] = ACTIONS(2577),
    [anon_sym_override] = ACTIONS(2577),
    [anon_sym_private] = ACTIONS(2577),
    [anon_sym_protected] = ACTIONS(2577),
    [anon_sym_public] = ACTIONS(2577),
    [anon_sym_readonly] = ACTIONS(2577),
    [anon_sym_sealed] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2577),
    [anon_sym_unsafe] = ACTIONS(2577),
    [anon_sym_virtual] = ACTIONS(2577),
    [anon_sym_volatile] = ACTIONS(2577),
    [anon_sym_using] = ACTIONS(2577),
    [anon_sym_namespace] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2575),
    [anon_sym_partial] = ACTIONS(2577),
    [anon_sym_class] = ACTIONS(2577),
    [anon_sym_struct] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2575),
    [anon_sym_event] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_implicit] = ACTIONS(2577),
    [anon_sym_explicit] = ACTIONS(2577),
    [anon_sym_interface] = ACTIONS(2577),
    [anon_sym_enum] = ACTIONS(2577),
    [anon_sym_delegate] = ACTIONS(2577),
    [sym_void_keyword] = ACTIONS(2577),
    [anon_sym_const] = ACTIONS(2577),
    [sym_identifier_name] = ACTIONS(2577),
    [sym_comment] = ACTIONS(31),
  },
  [1028] = {
    [sym__type_declaration] = STATE(242),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(242),
    [sym_class_declaration] = STATE(242),
    [sym_indexer_declaration] = STATE(242),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(242),
    [sym_operator_declaration] = STATE(242),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(242),
    [sym_struct_declaration] = STATE(242),
    [sym_enum_declaration] = STATE(242),
    [sym_delegate_declaration] = STATE(242),
    [sym__attributes] = STATE(144),
    [sym__attribute_section] = STATE(148),
    [sym_field_declaration] = STATE(242),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(242),
    [sym_constructor_declaration] = STATE(242),
    [sym_destructor_declaration] = STATE(242),
    [sym_method_declaration] = STATE(242),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_class_declaration_repeat2] = STATE(242),
    [aux_sym__attributes_repeat1] = STATE(148),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(247),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(2579),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_TILDE] = ACTIONS(259),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [1029] = {
    [sym__type_declaration] = STATE(247),
    [sym__type] = STATE(139),
    [sym_predefined_type] = STATE(139),
    [sym_modifiers] = STATE(140),
    [sym_property_declaration] = STATE(247),
    [sym_class_declaration] = STATE(247),
    [sym_indexer_declaration] = STATE(247),
    [sym__indexer_declarator] = STATE(141),
    [sym_event_declaration] = STATE(247),
    [sym_operator_declaration] = STATE(247),
    [sym__operator_declarator] = STATE(142),
    [sym__unary_operator_declarator] = STATE(142),
    [sym__binary_operator_declarator] = STATE(142),
    [sym__conversion_operator_declarator] = STATE(142),
    [sym_overloadable_conversion_operator] = STATE(143),
    [sym_interface_declaration] = STATE(247),
    [sym_struct_declaration] = STATE(247),
    [sym_enum_declaration] = STATE(247),
    [sym_delegate_declaration] = STATE(247),
    [sym__attributes] = STATE(153),
    [sym__attribute_section] = STATE(155),
    [sym_field_declaration] = STATE(247),
    [sym_variable_declaration] = STATE(145),
    [sym_generic_name] = STATE(139),
    [sym_constant_declaration] = STATE(247),
    [sym_constructor_declaration] = STATE(247),
    [sym_method_declaration] = STATE(247),
    [aux_sym_modifiers_repeat1] = STATE(146),
    [aux_sym_struct_declaration_repeat1] = STATE(247),
    [aux_sym__attributes_repeat1] = STATE(155),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_abstract] = ACTIONS(245),
    [anon_sym_async] = ACTIONS(245),
    [anon_sym_extern] = ACTIONS(245),
    [anon_sym_internal] = ACTIONS(245),
    [anon_sym_new] = ACTIONS(245),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_private] = ACTIONS(245),
    [anon_sym_protected] = ACTIONS(245),
    [anon_sym_public] = ACTIONS(245),
    [anon_sym_readonly] = ACTIONS(245),
    [anon_sym_sealed] = ACTIONS(245),
    [anon_sym_static] = ACTIONS(245),
    [anon_sym_unsafe] = ACTIONS(245),
    [anon_sym_virtual] = ACTIONS(245),
    [anon_sym_volatile] = ACTIONS(245),
    [anon_sym_RBRACE] = ACTIONS(2581),
    [anon_sym_partial] = ACTIONS(251),
    [anon_sym_class] = ACTIONS(253),
    [anon_sym_struct] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(257),
    [anon_sym_implicit] = ACTIONS(261),
    [anon_sym_explicit] = ACTIONS(261),
    [anon_sym_interface] = ACTIONS(263),
    [anon_sym_enum] = ACTIONS(265),
    [anon_sym_delegate] = ACTIONS(267),
    [sym_void_keyword] = ACTIONS(269),
    [anon_sym_const] = ACTIONS(271),
    [sym_identifier_name] = ACTIONS(273),
    [sym_comment] = ACTIONS(31),
  },
  [1030] = {
    [sym__type] = STATE(165),
    [sym_predefined_type] = STATE(165),
    [sym_interface_method_declaration] = STATE(261),
    [sym_interface_event_declaration] = STATE(261),
    [sym_interface_property_declaration] = STATE(261),
    [sym_interface_indexer_declaration] = STATE(261),
    [sym__attributes] = STATE(166),
    [sym__attribute_section] = STATE(168),
    [sym_generic_name] = STATE(165),
    [aux_sym_interface_declaration_repeat1] = STATE(261),
    [aux_sym__attributes_repeat1] = STATE(168),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(2583),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_event] = ACTIONS(297),
    [sym_void_keyword] = ACTIONS(299),
    [sym_identifier_name] = ACTIONS(69),
    [sym_comment] = ACTIONS(31),
  },
  [1031] = {
    [ts_builtin_sym_end] = ACTIONS(2575),
    [anon_sym_bool] = ACTIONS(2577),
    [anon_sym_byte] = ACTIONS(2577),
    [anon_sym_char] = ACTIONS(2577),
    [anon_sym_decimal] = ACTIONS(2577),
    [anon_sym_double] = ACTIONS(2577),
    [anon_sym_float] = ACTIONS(2577),
    [anon_sym_int] = ACTIONS(2577),
    [anon_sym_long] = ACTIONS(2577),
    [anon_sym_object] = ACTIONS(2577),
    [anon_sym_sbyte] = ACTIONS(2577),
    [anon_sym_short] = ACTIONS(2577),
    [anon_sym_string] = ACTIONS(2577),
    [anon_sym_uint] = ACTIONS(2577),
    [anon_sym_ulong] = ACTIONS(2577),
    [anon_sym_ushort] = ACTIONS(2577),
    [anon_sym_abstract] = ACTIONS(2577),
    [anon_sym_async] = ACTIONS(2577),
    [anon_sym_extern] = ACTIONS(2577),
    [anon_sym_internal] = ACTIONS(2577),
    [anon_sym_new] = ACTIONS(2577),
    [anon_sym_override] = ACTIONS(2577),
    [anon_sym_private] = ACTIONS(2577),
    [anon_sym_protected] = ACTIONS(2577),
    [anon_sym_public] = ACTIONS(2577),
    [anon_sym_readonly] = ACTIONS(2577),
    [anon_sym_sealed] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2577),
    [anon_sym_unsafe] = ACTIONS(2577),
    [anon_sym_virtual] = ACTIONS(2577),
    [anon_sym_volatile] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2585),
    [anon_sym_using] = ACTIONS(2577),
    [anon_sym_namespace] = ACTIONS(2577),
    [anon_sym_RBRACE] = ACTIONS(2575),
    [anon_sym_partial] = ACTIONS(2577),
    [anon_sym_class] = ACTIONS(2577),
    [anon_sym_struct] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2575),
    [anon_sym_event] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_implicit] = ACTIONS(2577),
    [anon_sym_explicit] = ACTIONS(2577),
    [anon_sym_interface] = ACTIONS(2577),
    [anon_sym_enum] = ACTIONS(2577),
    [anon_sym_delegate] = ACTIONS(2577),
    [sym_void_keyword] = ACTIONS(2577),
    [anon_sym_const] = ACTIONS(2577),
    [sym_identifier_name] = ACTIONS(2577),
    [sym_comment] = ACTIONS(31),
  },
  [1032] = {
    [sym__expression] = STATE(1088),
    [sym_parenthesized_expression] = STATE(1088),
    [sym_ternary_expression] = STATE(1088),
    [sym_binary_expression] = STATE(1088),
    [sym_unary_expression] = STATE(1088),
    [sym__literal] = STATE(1088),
    [sym_boolean_literal] = STATE(1088),
    [sym_character_literal] = STATE(1088),
    [sym_integer_literal] = STATE(1088),
    [sym_real_literal] = STATE(1088),
    [sym_string_literal] = STATE(1088),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2587),
    [sym_comment] = ACTIONS(31),
  },
  [1033] = {
    [sym__expression] = STATE(1089),
    [sym_parenthesized_expression] = STATE(1089),
    [sym_ternary_expression] = STATE(1089),
    [sym_binary_expression] = STATE(1089),
    [sym_unary_expression] = STATE(1089),
    [sym__literal] = STATE(1089),
    [sym_boolean_literal] = STATE(1089),
    [sym_character_literal] = STATE(1089),
    [sym_integer_literal] = STATE(1089),
    [sym_real_literal] = STATE(1089),
    [sym_string_literal] = STATE(1089),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2589),
    [sym_comment] = ACTIONS(31),
  },
  [1034] = {
    [sym__expression] = STATE(725),
    [sym_parenthesized_expression] = STATE(725),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym__literal] = STATE(725),
    [sym_boolean_literal] = STATE(725),
    [sym_character_literal] = STATE(725),
    [sym_integer_literal] = STATE(725),
    [sym_real_literal] = STATE(725),
    [sym_string_literal] = STATE(725),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1519),
    [sym_comment] = ACTIONS(31),
  },
  [1035] = {
    [sym__expression] = STATE(1090),
    [sym_parenthesized_expression] = STATE(1090),
    [sym_ternary_expression] = STATE(1090),
    [sym_binary_expression] = STATE(1090),
    [sym_unary_expression] = STATE(1090),
    [sym__literal] = STATE(1090),
    [sym_boolean_literal] = STATE(1090),
    [sym_character_literal] = STATE(1090),
    [sym_integer_literal] = STATE(1090),
    [sym_real_literal] = STATE(1090),
    [sym_string_literal] = STATE(1090),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2591),
    [sym_comment] = ACTIONS(31),
  },
  [1036] = {
    [sym__expression] = STATE(1091),
    [sym_parenthesized_expression] = STATE(1091),
    [sym_ternary_expression] = STATE(1091),
    [sym_binary_expression] = STATE(1091),
    [sym_unary_expression] = STATE(1091),
    [sym__literal] = STATE(1091),
    [sym_boolean_literal] = STATE(1091),
    [sym_character_literal] = STATE(1091),
    [sym_integer_literal] = STATE(1091),
    [sym_real_literal] = STATE(1091),
    [sym_string_literal] = STATE(1091),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2593),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2593),
    [sym_comment] = ACTIONS(31),
  },
  [1037] = {
    [sym__expression] = STATE(1092),
    [sym_parenthesized_expression] = STATE(1092),
    [sym_ternary_expression] = STATE(1092),
    [sym_binary_expression] = STATE(1092),
    [sym_unary_expression] = STATE(1092),
    [sym__literal] = STATE(1092),
    [sym_boolean_literal] = STATE(1092),
    [sym_character_literal] = STATE(1092),
    [sym_integer_literal] = STATE(1092),
    [sym_real_literal] = STATE(1092),
    [sym_string_literal] = STATE(1092),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2595),
    [sym_comment] = ACTIONS(31),
  },
  [1038] = {
    [sym__expression] = STATE(1093),
    [sym_parenthesized_expression] = STATE(1093),
    [sym_ternary_expression] = STATE(1093),
    [sym_binary_expression] = STATE(1093),
    [sym_unary_expression] = STATE(1093),
    [sym__literal] = STATE(1093),
    [sym_boolean_literal] = STATE(1093),
    [sym_character_literal] = STATE(1093),
    [sym_integer_literal] = STATE(1093),
    [sym_real_literal] = STATE(1093),
    [sym_string_literal] = STATE(1093),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2597),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2597),
    [sym_comment] = ACTIONS(31),
  },
  [1039] = {
    [sym__expression] = STATE(1094),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_ternary_expression] = STATE(1094),
    [sym_binary_expression] = STATE(1094),
    [sym_unary_expression] = STATE(1094),
    [sym__literal] = STATE(1094),
    [sym_boolean_literal] = STATE(1094),
    [sym_character_literal] = STATE(1094),
    [sym_integer_literal] = STATE(1094),
    [sym_real_literal] = STATE(1094),
    [sym_string_literal] = STATE(1094),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2599),
    [sym_comment] = ACTIONS(31),
  },
  [1040] = {
    [sym__expression] = STATE(1095),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_ternary_expression] = STATE(1095),
    [sym_binary_expression] = STATE(1095),
    [sym_unary_expression] = STATE(1095),
    [sym__literal] = STATE(1095),
    [sym_boolean_literal] = STATE(1095),
    [sym_character_literal] = STATE(1095),
    [sym_integer_literal] = STATE(1095),
    [sym_real_literal] = STATE(1095),
    [sym_string_literal] = STATE(1095),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2601),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2601),
    [sym_comment] = ACTIONS(31),
  },
  [1041] = {
    [sym__expression] = STATE(1096),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_ternary_expression] = STATE(1096),
    [sym_binary_expression] = STATE(1096),
    [sym_unary_expression] = STATE(1096),
    [sym__literal] = STATE(1096),
    [sym_boolean_literal] = STATE(1096),
    [sym_character_literal] = STATE(1096),
    [sym_integer_literal] = STATE(1096),
    [sym_real_literal] = STATE(1096),
    [sym_string_literal] = STATE(1096),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2603),
    [sym_comment] = ACTIONS(31),
  },
  [1042] = {
    [sym_identifier_name] = ACTIONS(2605),
    [sym_comment] = ACTIONS(31),
  },
  [1043] = {
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_STAR] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_GT_EQ] = ACTIONS(1406),
    [anon_sym_LT_EQ] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1408),
    [anon_sym_AMP_AMP] = ACTIONS(1410),
    [anon_sym_PIPE_PIPE] = ACTIONS(1412),
    [sym_comment] = ACTIONS(31),
  },
  [1044] = {
    [anon_sym_bool] = ACTIONS(2607),
    [anon_sym_byte] = ACTIONS(2607),
    [anon_sym_char] = ACTIONS(2607),
    [anon_sym_decimal] = ACTIONS(2607),
    [anon_sym_double] = ACTIONS(2607),
    [anon_sym_float] = ACTIONS(2607),
    [anon_sym_int] = ACTIONS(2607),
    [anon_sym_long] = ACTIONS(2607),
    [anon_sym_object] = ACTIONS(2607),
    [anon_sym_sbyte] = ACTIONS(2607),
    [anon_sym_short] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_uint] = ACTIONS(2607),
    [anon_sym_ulong] = ACTIONS(2607),
    [anon_sym_ushort] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2607),
    [anon_sym_async] = ACTIONS(2607),
    [anon_sym_extern] = ACTIONS(2607),
    [anon_sym_internal] = ACTIONS(2607),
    [anon_sym_new] = ACTIONS(2607),
    [anon_sym_override] = ACTIONS(2607),
    [anon_sym_private] = ACTIONS(2607),
    [anon_sym_protected] = ACTIONS(2607),
    [anon_sym_public] = ACTIONS(2607),
    [anon_sym_readonly] = ACTIONS(2607),
    [anon_sym_sealed] = ACTIONS(2607),
    [anon_sym_static] = ACTIONS(2607),
    [anon_sym_unsafe] = ACTIONS(2607),
    [anon_sym_virtual] = ACTIONS(2607),
    [anon_sym_volatile] = ACTIONS(2607),
    [anon_sym_RBRACE] = ACTIONS(2609),
    [anon_sym_partial] = ACTIONS(2607),
    [anon_sym_class] = ACTIONS(2607),
    [anon_sym_struct] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_event] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2609),
    [anon_sym_implicit] = ACTIONS(2607),
    [anon_sym_explicit] = ACTIONS(2607),
    [anon_sym_interface] = ACTIONS(2607),
    [anon_sym_enum] = ACTIONS(2607),
    [anon_sym_delegate] = ACTIONS(2607),
    [sym_void_keyword] = ACTIONS(2607),
    [anon_sym_const] = ACTIONS(2607),
    [sym_identifier_name] = ACTIONS(2607),
    [sym_comment] = ACTIONS(31),
  },
  [1045] = {
    [anon_sym_bool] = ACTIONS(2611),
    [anon_sym_byte] = ACTIONS(2611),
    [anon_sym_char] = ACTIONS(2611),
    [anon_sym_decimal] = ACTIONS(2611),
    [anon_sym_double] = ACTIONS(2611),
    [anon_sym_float] = ACTIONS(2611),
    [anon_sym_int] = ACTIONS(2611),
    [anon_sym_long] = ACTIONS(2611),
    [anon_sym_object] = ACTIONS(2611),
    [anon_sym_sbyte] = ACTIONS(2611),
    [anon_sym_short] = ACTIONS(2611),
    [anon_sym_string] = ACTIONS(2611),
    [anon_sym_uint] = ACTIONS(2611),
    [anon_sym_ulong] = ACTIONS(2611),
    [anon_sym_ushort] = ACTIONS(2611),
    [anon_sym_abstract] = ACTIONS(2611),
    [anon_sym_async] = ACTIONS(2611),
    [anon_sym_extern] = ACTIONS(2611),
    [anon_sym_internal] = ACTIONS(2611),
    [anon_sym_new] = ACTIONS(2611),
    [anon_sym_override] = ACTIONS(2611),
    [anon_sym_private] = ACTIONS(2611),
    [anon_sym_protected] = ACTIONS(2611),
    [anon_sym_public] = ACTIONS(2611),
    [anon_sym_readonly] = ACTIONS(2611),
    [anon_sym_sealed] = ACTIONS(2611),
    [anon_sym_static] = ACTIONS(2611),
    [anon_sym_unsafe] = ACTIONS(2611),
    [anon_sym_virtual] = ACTIONS(2611),
    [anon_sym_volatile] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [anon_sym_partial] = ACTIONS(2611),
    [anon_sym_class] = ACTIONS(2611),
    [anon_sym_struct] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_event] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2613),
    [anon_sym_implicit] = ACTIONS(2611),
    [anon_sym_explicit] = ACTIONS(2611),
    [anon_sym_interface] = ACTIONS(2611),
    [anon_sym_enum] = ACTIONS(2611),
    [anon_sym_delegate] = ACTIONS(2611),
    [sym_void_keyword] = ACTIONS(2611),
    [anon_sym_const] = ACTIONS(2611),
    [sym_identifier_name] = ACTIONS(2611),
    [sym_comment] = ACTIONS(31),
  },
  [1046] = {
    [anon_sym_bool] = ACTIONS(2615),
    [anon_sym_byte] = ACTIONS(2615),
    [anon_sym_char] = ACTIONS(2615),
    [anon_sym_decimal] = ACTIONS(2615),
    [anon_sym_double] = ACTIONS(2615),
    [anon_sym_float] = ACTIONS(2615),
    [anon_sym_int] = ACTIONS(2615),
    [anon_sym_long] = ACTIONS(2615),
    [anon_sym_object] = ACTIONS(2615),
    [anon_sym_sbyte] = ACTIONS(2615),
    [anon_sym_short] = ACTIONS(2615),
    [anon_sym_string] = ACTIONS(2615),
    [anon_sym_uint] = ACTIONS(2615),
    [anon_sym_ulong] = ACTIONS(2615),
    [anon_sym_ushort] = ACTIONS(2615),
    [anon_sym_abstract] = ACTIONS(2615),
    [anon_sym_async] = ACTIONS(2615),
    [anon_sym_extern] = ACTIONS(2615),
    [anon_sym_internal] = ACTIONS(2615),
    [anon_sym_new] = ACTIONS(2615),
    [anon_sym_override] = ACTIONS(2615),
    [anon_sym_private] = ACTIONS(2615),
    [anon_sym_protected] = ACTIONS(2615),
    [anon_sym_public] = ACTIONS(2615),
    [anon_sym_readonly] = ACTIONS(2615),
    [anon_sym_sealed] = ACTIONS(2615),
    [anon_sym_static] = ACTIONS(2615),
    [anon_sym_unsafe] = ACTIONS(2615),
    [anon_sym_virtual] = ACTIONS(2615),
    [anon_sym_volatile] = ACTIONS(2615),
    [anon_sym_RBRACE] = ACTIONS(2617),
    [anon_sym_partial] = ACTIONS(2615),
    [anon_sym_class] = ACTIONS(2615),
    [anon_sym_struct] = ACTIONS(2615),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_event] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2617),
    [anon_sym_implicit] = ACTIONS(2615),
    [anon_sym_explicit] = ACTIONS(2615),
    [anon_sym_interface] = ACTIONS(2615),
    [anon_sym_enum] = ACTIONS(2615),
    [anon_sym_delegate] = ACTIONS(2615),
    [sym_void_keyword] = ACTIONS(2615),
    [anon_sym_const] = ACTIONS(2615),
    [sym_identifier_name] = ACTIONS(2615),
    [sym_comment] = ACTIONS(31),
  },
  [1047] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [1048] = {
    [sym__expression] = STATE(1098),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym__literal] = STATE(1098),
    [sym_boolean_literal] = STATE(1098),
    [sym_character_literal] = STATE(1098),
    [sym_integer_literal] = STATE(1098),
    [sym_real_literal] = STATE(1098),
    [sym_string_literal] = STATE(1098),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2619),
    [sym_comment] = ACTIONS(31),
  },
  [1049] = {
    [anon_sym_LBRACE] = ACTIONS(2621),
    [sym_comment] = ACTIONS(31),
    [anon_sym_when] = ACTIONS(2621),
  },
  [1050] = {
    [anon_sym_RPAREN] = ACTIONS(2623),
    [sym_comment] = ACTIONS(31),
  },
  [1051] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [1052] = {
    [anon_sym_bool] = ACTIONS(2627),
    [anon_sym_byte] = ACTIONS(2627),
    [anon_sym_char] = ACTIONS(2627),
    [anon_sym_decimal] = ACTIONS(2627),
    [anon_sym_double] = ACTIONS(2627),
    [anon_sym_float] = ACTIONS(2627),
    [anon_sym_int] = ACTIONS(2627),
    [anon_sym_long] = ACTIONS(2627),
    [anon_sym_object] = ACTIONS(2627),
    [anon_sym_sbyte] = ACTIONS(2627),
    [anon_sym_short] = ACTIONS(2627),
    [anon_sym_string] = ACTIONS(2627),
    [anon_sym_uint] = ACTIONS(2627),
    [anon_sym_ulong] = ACTIONS(2627),
    [anon_sym_ushort] = ACTIONS(2627),
    [anon_sym_SEMI] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2629),
    [anon_sym_RBRACE] = ACTIONS(2629),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_DOT] = ACTIONS(2629),
    [anon_sym_PLUS] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2629),
    [anon_sym_TILDE] = ACTIONS(2629),
    [anon_sym_PLUS_PLUS] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2629),
    [anon_sym_true] = ACTIONS(2627),
    [anon_sym_false] = ACTIONS(2627),
    [anon_sym_const] = ACTIONS(2627),
    [anon_sym_typeof] = ACTIONS(2627),
    [anon_sym_sizeof] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2629),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2627),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2629),
    [sym_null_literal] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2629),
    [anon_sym_AT_DQUOTE] = ACTIONS(2629),
    [sym_identifier_name] = ACTIONS(2627),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2627),
    [anon_sym_catch] = ACTIONS(2627),
    [anon_sym_finally] = ACTIONS(2627),
    [anon_sym_checked] = ACTIONS(2627),
    [anon_sym_unchecked] = ACTIONS(2627),
    [anon_sym_lock] = ACTIONS(2627),
    [anon_sym_yield] = ACTIONS(2627),
    [anon_sym_return] = ACTIONS(2627),
    [anon_sym_break] = ACTIONS(2627),
    [anon_sym_if] = ACTIONS(2627),
    [anon_sym_else] = ACTIONS(2627),
    [anon_sym_switch] = ACTIONS(2627),
    [anon_sym_case] = ACTIONS(2627),
    [anon_sym_default] = ACTIONS(2627),
    [anon_sym_while] = ACTIONS(2627),
    [anon_sym_do] = ACTIONS(2627),
    [anon_sym_continue] = ACTIONS(2627),
    [anon_sym_throw] = ACTIONS(2627),
    [anon_sym_goto] = ACTIONS(2627),
    [anon_sym_var] = ACTIONS(2627),
  },
  [1053] = {
    [sym_catch_clause] = STATE(1101),
    [sym_finally_clause] = STATE(740),
    [aux_sym_try_statement_repeat1] = STATE(1101),
    [anon_sym_bool] = ACTIONS(1543),
    [anon_sym_byte] = ACTIONS(1543),
    [anon_sym_char] = ACTIONS(1543),
    [anon_sym_decimal] = ACTIONS(1543),
    [anon_sym_double] = ACTIONS(1543),
    [anon_sym_float] = ACTIONS(1543),
    [anon_sym_int] = ACTIONS(1543),
    [anon_sym_long] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [anon_sym_sbyte] = ACTIONS(1543),
    [anon_sym_short] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_uint] = ACTIONS(1543),
    [anon_sym_ulong] = ACTIONS(1543),
    [anon_sym_ushort] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_DOT] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(1543),
    [anon_sym_false] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(1543),
    [anon_sym_typeof] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1543),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1545),
    [sym_null_literal] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [anon_sym_AT_DQUOTE] = ACTIONS(1545),
    [sym_identifier_name] = ACTIONS(1543),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1543),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(1543),
    [anon_sym_unchecked] = ACTIONS(1543),
    [anon_sym_lock] = ACTIONS(1543),
    [anon_sym_yield] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1543),
    [anon_sym_break] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_else] = ACTIONS(1543),
    [anon_sym_switch] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_do] = ACTIONS(1543),
    [anon_sym_continue] = ACTIONS(1543),
    [anon_sym_throw] = ACTIONS(1543),
    [anon_sym_goto] = ACTIONS(1543),
    [anon_sym_var] = ACTIONS(1543),
  },
  [1054] = {
    [sym__expression] = STATE(1102),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_ternary_expression] = STATE(1102),
    [sym_binary_expression] = STATE(1102),
    [sym_unary_expression] = STATE(1102),
    [sym__literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_character_literal] = STATE(1102),
    [sym_integer_literal] = STATE(1102),
    [sym_real_literal] = STATE(1102),
    [sym_string_literal] = STATE(1102),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2631),
    [sym_comment] = ACTIONS(31),
  },
  [1055] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1103),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1056] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1104),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1057] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1105),
    [sym__embedded_statement] = STATE(1105),
    [sym_empty_statement] = STATE(1105),
    [sym_expression_statement] = STATE(1105),
    [sym__selection_statement] = STATE(1105),
    [sym__iteration_statement] = STATE(1105),
    [sym__jump_statement] = STATE(1105),
    [sym_try_statement] = STATE(1105),
    [sym_checked_statement] = STATE(1105),
    [sym_unchecked_statement] = STATE(1105),
    [sym_lock_statement] = STATE(1105),
    [sym_yield_statement] = STATE(1105),
    [sym_if_statement] = STATE(1105),
    [sym_switch_statement] = STATE(1105),
    [sym_while_statement] = STATE(1105),
    [sym_do_statement] = STATE(1105),
    [sym_break_statement] = STATE(1105),
    [sym_continue_statement] = STATE(1105),
    [sym_return_statement] = STATE(1105),
    [sym_throw_statement] = STATE(1105),
    [sym_goto_statement] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(701),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1058] = {
    [anon_sym_bool] = ACTIONS(2633),
    [anon_sym_byte] = ACTIONS(2633),
    [anon_sym_char] = ACTIONS(2633),
    [anon_sym_decimal] = ACTIONS(2633),
    [anon_sym_double] = ACTIONS(2633),
    [anon_sym_float] = ACTIONS(2633),
    [anon_sym_int] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_object] = ACTIONS(2633),
    [anon_sym_sbyte] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_string] = ACTIONS(2633),
    [anon_sym_uint] = ACTIONS(2633),
    [anon_sym_ulong] = ACTIONS(2633),
    [anon_sym_ushort] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_RBRACE] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(2635),
    [anon_sym_DOT] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2635),
    [anon_sym_DASH_DASH] = ACTIONS(2635),
    [anon_sym_true] = ACTIONS(2633),
    [anon_sym_false] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2633),
    [anon_sym_sizeof] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2635),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2633),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2635),
    [sym_null_literal] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2635),
    [anon_sym_AT_DQUOTE] = ACTIONS(2635),
    [sym_identifier_name] = ACTIONS(2633),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2633),
    [anon_sym_checked] = ACTIONS(2633),
    [anon_sym_unchecked] = ACTIONS(2633),
    [anon_sym_lock] = ACTIONS(2633),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_else] = ACTIONS(2633),
    [anon_sym_switch] = ACTIONS(2633),
    [anon_sym_case] = ACTIONS(2633),
    [anon_sym_default] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_do] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_throw] = ACTIONS(2633),
    [anon_sym_goto] = ACTIONS(2633),
    [anon_sym_var] = ACTIONS(2633),
  },
  [1059] = {
    [sym__expression] = STATE(1106),
    [sym_constant_expression] = STATE(1107),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_ternary_expression] = STATE(1106),
    [sym_binary_expression] = STATE(1106),
    [sym_unary_expression] = STATE(1106),
    [sym__literal] = STATE(1106),
    [sym_boolean_literal] = STATE(1106),
    [sym_character_literal] = STATE(1106),
    [sym_integer_literal] = STATE(1106),
    [sym_real_literal] = STATE(1106),
    [sym_string_literal] = STATE(1106),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1531),
    [anon_sym_TILDE] = ACTIONS(1531),
    [anon_sym_PLUS_PLUS] = ACTIONS(1531),
    [anon_sym_DASH_DASH] = ACTIONS(1531),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1529),
    [anon_sym_sizeof] = ACTIONS(1529),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2637),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2637),
    [sym_comment] = ACTIONS(31),
  },
  [1060] = {
    [anon_sym_COLON] = ACTIONS(2639),
    [sym_comment] = ACTIONS(31),
  },
  [1061] = {
    [sym_switch_section] = STATE(1110),
    [sym_switch_label] = STATE(1062),
    [aux_sym_switch_statement_repeat1] = STATE(1110),
    [aux_sym_switch_section_repeat1] = STATE(1062),
    [anon_sym_RBRACE] = ACTIONS(2641),
    [sym_comment] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2524),
  },
  [1062] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(1117),
    [sym_variable_assignment_statement] = STATE(1117),
    [sym_statement_block] = STATE(1117),
    [sym__statement_list] = STATE(1116),
    [sym__labeled_statement] = STATE(1117),
    [sym__embedded_statement] = STATE(1117),
    [sym_empty_statement] = STATE(1117),
    [sym_expression_statement] = STATE(1117),
    [sym__selection_statement] = STATE(1117),
    [sym__iteration_statement] = STATE(1117),
    [sym__jump_statement] = STATE(1117),
    [sym_try_statement] = STATE(1117),
    [sym_checked_statement] = STATE(1117),
    [sym_unchecked_statement] = STATE(1117),
    [sym_lock_statement] = STATE(1117),
    [sym_yield_statement] = STATE(1117),
    [sym_if_statement] = STATE(1117),
    [sym_switch_statement] = STATE(1117),
    [sym_switch_label] = STATE(1118),
    [sym_while_statement] = STATE(1117),
    [sym_do_statement] = STATE(1117),
    [sym_break_statement] = STATE(1117),
    [sym_continue_statement] = STATE(1117),
    [sym_return_statement] = STATE(1117),
    [sym_throw_statement] = STATE(1117),
    [sym_goto_statement] = STATE(1117),
    [sym__declaration_statement] = STATE(1117),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [aux_sym__statement_list_repeat1] = STATE(1117),
    [aux_sym_switch_section_repeat1] = STATE(1118),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(689),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2643),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(723),
  },
  [1063] = {
    [sym_statement_block] = STATE(1119),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [1064] = {
    [anon_sym_LPAREN] = ACTIONS(2657),
    [sym_comment] = ACTIONS(31),
  },
  [1065] = {
    [anon_sym_LPAREN] = ACTIONS(2659),
    [sym_comment] = ACTIONS(31),
  },
  [1066] = {
    [anon_sym_LPAREN] = ACTIONS(2661),
    [sym_comment] = ACTIONS(31),
  },
  [1067] = {
    [sym_comment] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(2663),
    [anon_sym_while] = ACTIONS(2516),
  },
  [1068] = {
    [anon_sym_SEMI] = ACTIONS(2665),
    [sym_comment] = ACTIONS(31),
  },
  [1069] = {
    [sym_variable_initializer] = STATE(1125),
    [sym_array_initalizer] = STATE(965),
    [sym__expression] = STATE(1000),
    [sym_parenthesized_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym__literal] = STATE(1000),
    [sym_boolean_literal] = STATE(1000),
    [sym_character_literal] = STATE(1000),
    [sym_integer_literal] = STATE(1000),
    [sym_real_literal] = STATE(1000),
    [sym_string_literal] = STATE(1000),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(902),
    [anon_sym_PLUS_PLUS] = ACTIONS(902),
    [anon_sym_DASH_DASH] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(900),
    [anon_sym_sizeof] = ACTIONS(900),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2323),
    [sym_comment] = ACTIONS(31),
  },
  [1070] = {
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [sym_comment] = ACTIONS(31),
  },
  [1071] = {
    [aux_sym_array_initalizer_repeat1] = STATE(1127),
    [anon_sym_COMMA] = ACTIONS(2543),
    [anon_sym_RBRACE] = ACTIONS(2669),
    [sym_comment] = ACTIONS(31),
  },
  [1072] = {
    [sym_type_parameter_constraints_clause] = STATE(151),
    [sym_statement_block] = STATE(1128),
    [aux_sym_class_declaration_repeat1] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_where] = ACTIONS(115),
    [sym_comment] = ACTIONS(31),
  },
  [1073] = {
    [anon_sym_RBRACE] = ACTIONS(2671),
    [sym_comment] = ACTIONS(31),
  },
  [1074] = {
    [anon_sym_SEMI] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_where] = ACTIONS(2673),
    [sym_comment] = ACTIONS(31),
  },
  [1075] = {
    [sym_interface_accessor] = STATE(784),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(784),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [1076] = {
    [aux_sym_class_base_repeat1] = STATE(1131),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(2099),
    [anon_sym_where] = ACTIONS(2099),
    [sym_comment] = ACTIONS(31),
  },
  [1077] = {
    [anon_sym_bool] = ACTIONS(2677),
    [anon_sym_byte] = ACTIONS(2677),
    [anon_sym_char] = ACTIONS(2677),
    [anon_sym_decimal] = ACTIONS(2677),
    [anon_sym_double] = ACTIONS(2677),
    [anon_sym_float] = ACTIONS(2677),
    [anon_sym_int] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_object] = ACTIONS(2677),
    [anon_sym_sbyte] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_string] = ACTIONS(2677),
    [anon_sym_uint] = ACTIONS(2677),
    [anon_sym_ulong] = ACTIONS(2677),
    [anon_sym_ushort] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2679),
    [anon_sym_event] = ACTIONS(2677),
    [sym_void_keyword] = ACTIONS(2677),
    [sym_identifier_name] = ACTIONS(2677),
    [sym_comment] = ACTIONS(31),
  },
  [1078] = {
    [anon_sym_bool] = ACTIONS(2681),
    [anon_sym_byte] = ACTIONS(2681),
    [anon_sym_char] = ACTIONS(2681),
    [anon_sym_decimal] = ACTIONS(2681),
    [anon_sym_double] = ACTIONS(2681),
    [anon_sym_float] = ACTIONS(2681),
    [anon_sym_int] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_object] = ACTIONS(2681),
    [anon_sym_sbyte] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_string] = ACTIONS(2681),
    [anon_sym_uint] = ACTIONS(2681),
    [anon_sym_ulong] = ACTIONS(2681),
    [anon_sym_ushort] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_event] = ACTIONS(2681),
    [sym_void_keyword] = ACTIONS(2681),
    [sym_identifier_name] = ACTIONS(2681),
    [sym_comment] = ACTIONS(31),
  },
  [1079] = {
    [sym_interface_accessor] = STATE(1132),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(1132),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [1080] = {
    [sym__expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_ternary_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym__literal] = STATE(1133),
    [sym_boolean_literal] = STATE(1133),
    [sym_character_literal] = STATE(1133),
    [sym_integer_literal] = STATE(1133),
    [sym_real_literal] = STATE(1133),
    [sym_string_literal] = STATE(1133),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1813),
    [anon_sym_TILDE] = ACTIONS(1813),
    [anon_sym_PLUS_PLUS] = ACTIONS(1813),
    [anon_sym_DASH_DASH] = ACTIONS(1813),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1811),
    [anon_sym_sizeof] = ACTIONS(1811),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2685),
    [sym_comment] = ACTIONS(31),
  },
  [1081] = {
    [ts_builtin_sym_end] = ACTIONS(2687),
    [anon_sym_bool] = ACTIONS(2689),
    [anon_sym_byte] = ACTIONS(2689),
    [anon_sym_char] = ACTIONS(2689),
    [anon_sym_decimal] = ACTIONS(2689),
    [anon_sym_double] = ACTIONS(2689),
    [anon_sym_float] = ACTIONS(2689),
    [anon_sym_int] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_object] = ACTIONS(2689),
    [anon_sym_sbyte] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_string] = ACTIONS(2689),
    [anon_sym_uint] = ACTIONS(2689),
    [anon_sym_ulong] = ACTIONS(2689),
    [anon_sym_ushort] = ACTIONS(2689),
    [anon_sym_abstract] = ACTIONS(2689),
    [anon_sym_async] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym_internal] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_override] = ACTIONS(2689),
    [anon_sym_private] = ACTIONS(2689),
    [anon_sym_protected] = ACTIONS(2689),
    [anon_sym_public] = ACTIONS(2689),
    [anon_sym_readonly] = ACTIONS(2689),
    [anon_sym_sealed] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_unsafe] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_partial] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_event] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_implicit] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_interface] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_delegate] = ACTIONS(2689),
    [sym_void_keyword] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [sym_identifier_name] = ACTIONS(2689),
    [sym_comment] = ACTIONS(31),
  },
  [1082] = {
    [ts_builtin_sym_end] = ACTIONS(2691),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_byte] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym_decimal] = ACTIONS(2693),
    [anon_sym_double] = ACTIONS(2693),
    [anon_sym_float] = ACTIONS(2693),
    [anon_sym_int] = ACTIONS(2693),
    [anon_sym_long] = ACTIONS(2693),
    [anon_sym_object] = ACTIONS(2693),
    [anon_sym_sbyte] = ACTIONS(2693),
    [anon_sym_short] = ACTIONS(2693),
    [anon_sym_string] = ACTIONS(2693),
    [anon_sym_uint] = ACTIONS(2693),
    [anon_sym_ulong] = ACTIONS(2693),
    [anon_sym_ushort] = ACTIONS(2693),
    [anon_sym_abstract] = ACTIONS(2693),
    [anon_sym_async] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym_internal] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_override] = ACTIONS(2693),
    [anon_sym_private] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(2693),
    [anon_sym_public] = ACTIONS(2693),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_sealed] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2693),
    [anon_sym_virtual] = ACTIONS(2693),
    [anon_sym_volatile] = ACTIONS(2693),
    [anon_sym_using] = ACTIONS(2693),
    [anon_sym_namespace] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_partial] = ACTIONS(2693),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_event] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_implicit] = ACTIONS(2693),
    [anon_sym_explicit] = ACTIONS(2693),
    [anon_sym_interface] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_delegate] = ACTIONS(2693),
    [sym_void_keyword] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [sym_identifier_name] = ACTIONS(2693),
    [sym_comment] = ACTIONS(31),
  },
  [1083] = {
    [ts_builtin_sym_end] = ACTIONS(2695),
    [anon_sym_bool] = ACTIONS(2697),
    [anon_sym_byte] = ACTIONS(2697),
    [anon_sym_char] = ACTIONS(2697),
    [anon_sym_decimal] = ACTIONS(2697),
    [anon_sym_double] = ACTIONS(2697),
    [anon_sym_float] = ACTIONS(2697),
    [anon_sym_int] = ACTIONS(2697),
    [anon_sym_long] = ACTIONS(2697),
    [anon_sym_object] = ACTIONS(2697),
    [anon_sym_sbyte] = ACTIONS(2697),
    [anon_sym_short] = ACTIONS(2697),
    [anon_sym_string] = ACTIONS(2697),
    [anon_sym_uint] = ACTIONS(2697),
    [anon_sym_ulong] = ACTIONS(2697),
    [anon_sym_ushort] = ACTIONS(2697),
    [anon_sym_abstract] = ACTIONS(2697),
    [anon_sym_async] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym_internal] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_override] = ACTIONS(2697),
    [anon_sym_private] = ACTIONS(2697),
    [anon_sym_protected] = ACTIONS(2697),
    [anon_sym_public] = ACTIONS(2697),
    [anon_sym_readonly] = ACTIONS(2697),
    [anon_sym_sealed] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_virtual] = ACTIONS(2697),
    [anon_sym_volatile] = ACTIONS(2697),
    [anon_sym_using] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_partial] = ACTIONS(2697),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_event] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_implicit] = ACTIONS(2697),
    [anon_sym_explicit] = ACTIONS(2697),
    [anon_sym_interface] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_delegate] = ACTIONS(2697),
    [sym_void_keyword] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [sym_identifier_name] = ACTIONS(2697),
    [sym_comment] = ACTIONS(31),
  },
  [1084] = {
    [ts_builtin_sym_end] = ACTIONS(2687),
    [anon_sym_bool] = ACTIONS(2689),
    [anon_sym_byte] = ACTIONS(2689),
    [anon_sym_char] = ACTIONS(2689),
    [anon_sym_decimal] = ACTIONS(2689),
    [anon_sym_double] = ACTIONS(2689),
    [anon_sym_float] = ACTIONS(2689),
    [anon_sym_int] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_object] = ACTIONS(2689),
    [anon_sym_sbyte] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_string] = ACTIONS(2689),
    [anon_sym_uint] = ACTIONS(2689),
    [anon_sym_ulong] = ACTIONS(2689),
    [anon_sym_ushort] = ACTIONS(2689),
    [anon_sym_abstract] = ACTIONS(2689),
    [anon_sym_async] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym_internal] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_override] = ACTIONS(2689),
    [anon_sym_private] = ACTIONS(2689),
    [anon_sym_protected] = ACTIONS(2689),
    [anon_sym_public] = ACTIONS(2689),
    [anon_sym_readonly] = ACTIONS(2689),
    [anon_sym_sealed] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_unsafe] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_partial] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2687),
    [anon_sym_event] = ACTIONS(2689),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_implicit] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_interface] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_delegate] = ACTIONS(2689),
    [sym_void_keyword] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [sym_identifier_name] = ACTIONS(2689),
    [sym_comment] = ACTIONS(31),
  },
  [1085] = {
    [ts_builtin_sym_end] = ACTIONS(2691),
    [anon_sym_bool] = ACTIONS(2693),
    [anon_sym_byte] = ACTIONS(2693),
    [anon_sym_char] = ACTIONS(2693),
    [anon_sym_decimal] = ACTIONS(2693),
    [anon_sym_double] = ACTIONS(2693),
    [anon_sym_float] = ACTIONS(2693),
    [anon_sym_int] = ACTIONS(2693),
    [anon_sym_long] = ACTIONS(2693),
    [anon_sym_object] = ACTIONS(2693),
    [anon_sym_sbyte] = ACTIONS(2693),
    [anon_sym_short] = ACTIONS(2693),
    [anon_sym_string] = ACTIONS(2693),
    [anon_sym_uint] = ACTIONS(2693),
    [anon_sym_ulong] = ACTIONS(2693),
    [anon_sym_ushort] = ACTIONS(2693),
    [anon_sym_abstract] = ACTIONS(2693),
    [anon_sym_async] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym_internal] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_override] = ACTIONS(2693),
    [anon_sym_private] = ACTIONS(2693),
    [anon_sym_protected] = ACTIONS(2693),
    [anon_sym_public] = ACTIONS(2693),
    [anon_sym_readonly] = ACTIONS(2693),
    [anon_sym_sealed] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_unsafe] = ACTIONS(2693),
    [anon_sym_virtual] = ACTIONS(2693),
    [anon_sym_volatile] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2693),
    [anon_sym_namespace] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_partial] = ACTIONS(2693),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2691),
    [anon_sym_event] = ACTIONS(2693),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_implicit] = ACTIONS(2693),
    [anon_sym_explicit] = ACTIONS(2693),
    [anon_sym_interface] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_delegate] = ACTIONS(2693),
    [sym_void_keyword] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [sym_identifier_name] = ACTIONS(2693),
    [sym_comment] = ACTIONS(31),
  },
  [1086] = {
    [ts_builtin_sym_end] = ACTIONS(2695),
    [anon_sym_bool] = ACTIONS(2697),
    [anon_sym_byte] = ACTIONS(2697),
    [anon_sym_char] = ACTIONS(2697),
    [anon_sym_decimal] = ACTIONS(2697),
    [anon_sym_double] = ACTIONS(2697),
    [anon_sym_float] = ACTIONS(2697),
    [anon_sym_int] = ACTIONS(2697),
    [anon_sym_long] = ACTIONS(2697),
    [anon_sym_object] = ACTIONS(2697),
    [anon_sym_sbyte] = ACTIONS(2697),
    [anon_sym_short] = ACTIONS(2697),
    [anon_sym_string] = ACTIONS(2697),
    [anon_sym_uint] = ACTIONS(2697),
    [anon_sym_ulong] = ACTIONS(2697),
    [anon_sym_ushort] = ACTIONS(2697),
    [anon_sym_abstract] = ACTIONS(2697),
    [anon_sym_async] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym_internal] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_override] = ACTIONS(2697),
    [anon_sym_private] = ACTIONS(2697),
    [anon_sym_protected] = ACTIONS(2697),
    [anon_sym_public] = ACTIONS(2697),
    [anon_sym_readonly] = ACTIONS(2697),
    [anon_sym_sealed] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_unsafe] = ACTIONS(2697),
    [anon_sym_virtual] = ACTIONS(2697),
    [anon_sym_volatile] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_using] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_partial] = ACTIONS(2697),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2695),
    [anon_sym_event] = ACTIONS(2697),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_implicit] = ACTIONS(2697),
    [anon_sym_explicit] = ACTIONS(2697),
    [anon_sym_interface] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_delegate] = ACTIONS(2697),
    [sym_void_keyword] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [sym_identifier_name] = ACTIONS(2697),
    [sym_comment] = ACTIONS(31),
  },
  [1087] = {
    [ts_builtin_sym_end] = ACTIONS(2705),
    [anon_sym_bool] = ACTIONS(2707),
    [anon_sym_byte] = ACTIONS(2707),
    [anon_sym_char] = ACTIONS(2707),
    [anon_sym_decimal] = ACTIONS(2707),
    [anon_sym_double] = ACTIONS(2707),
    [anon_sym_float] = ACTIONS(2707),
    [anon_sym_int] = ACTIONS(2707),
    [anon_sym_long] = ACTIONS(2707),
    [anon_sym_object] = ACTIONS(2707),
    [anon_sym_sbyte] = ACTIONS(2707),
    [anon_sym_short] = ACTIONS(2707),
    [anon_sym_string] = ACTIONS(2707),
    [anon_sym_uint] = ACTIONS(2707),
    [anon_sym_ulong] = ACTIONS(2707),
    [anon_sym_ushort] = ACTIONS(2707),
    [anon_sym_abstract] = ACTIONS(2707),
    [anon_sym_async] = ACTIONS(2707),
    [anon_sym_extern] = ACTIONS(2707),
    [anon_sym_internal] = ACTIONS(2707),
    [anon_sym_new] = ACTIONS(2707),
    [anon_sym_override] = ACTIONS(2707),
    [anon_sym_private] = ACTIONS(2707),
    [anon_sym_protected] = ACTIONS(2707),
    [anon_sym_public] = ACTIONS(2707),
    [anon_sym_readonly] = ACTIONS(2707),
    [anon_sym_sealed] = ACTIONS(2707),
    [anon_sym_static] = ACTIONS(2707),
    [anon_sym_unsafe] = ACTIONS(2707),
    [anon_sym_virtual] = ACTIONS(2707),
    [anon_sym_volatile] = ACTIONS(2707),
    [anon_sym_using] = ACTIONS(2707),
    [anon_sym_namespace] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [anon_sym_partial] = ACTIONS(2707),
    [anon_sym_class] = ACTIONS(2707),
    [anon_sym_struct] = ACTIONS(2707),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_event] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2705),
    [anon_sym_implicit] = ACTIONS(2707),
    [anon_sym_explicit] = ACTIONS(2707),
    [anon_sym_interface] = ACTIONS(2707),
    [anon_sym_enum] = ACTIONS(2707),
    [anon_sym_delegate] = ACTIONS(2707),
    [sym_void_keyword] = ACTIONS(2707),
    [anon_sym_const] = ACTIONS(2707),
    [sym_identifier_name] = ACTIONS(2707),
    [sym_comment] = ACTIONS(31),
  },
  [1088] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1089] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1090] = {
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1091] = {
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1092] = {
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1093] = {
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(1991),
    [anon_sym_BANG_EQ] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1094] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [1095] = {
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1096] = {
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_params] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1991),
    [sym_comment] = ACTIONS(31),
  },
  [1097] = {
    [anon_sym_RPAREN] = ACTIONS(2711),
    [sym_comment] = ACTIONS(31),
  },
  [1098] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [1099] = {
    [anon_sym_LBRACE] = ACTIONS(2713),
    [sym_comment] = ACTIONS(31),
    [anon_sym_when] = ACTIONS(2713),
  },
  [1100] = {
    [anon_sym_LBRACE] = ACTIONS(2715),
    [sym_comment] = ACTIONS(31),
  },
  [1101] = {
    [sym_catch_clause] = STATE(1139),
    [sym_finally_clause] = STATE(888),
    [aux_sym_try_statement_repeat1] = STATE(1139),
    [anon_sym_bool] = ACTIONS(2035),
    [anon_sym_byte] = ACTIONS(2035),
    [anon_sym_char] = ACTIONS(2035),
    [anon_sym_decimal] = ACTIONS(2035),
    [anon_sym_double] = ACTIONS(2035),
    [anon_sym_float] = ACTIONS(2035),
    [anon_sym_int] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_object] = ACTIONS(2035),
    [anon_sym_sbyte] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_string] = ACTIONS(2035),
    [anon_sym_uint] = ACTIONS(2035),
    [anon_sym_ulong] = ACTIONS(2035),
    [anon_sym_ushort] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_typeof] = ACTIONS(2035),
    [anon_sym_sizeof] = ACTIONS(2035),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2035),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2037),
    [sym_null_literal] = ACTIONS(2035),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_AT_DQUOTE] = ACTIONS(2037),
    [sym_identifier_name] = ACTIONS(2035),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2035),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(2035),
    [anon_sym_unchecked] = ACTIONS(2035),
    [anon_sym_lock] = ACTIONS(2035),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_else] = ACTIONS(2035),
    [anon_sym_switch] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_do] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_throw] = ACTIONS(2035),
    [anon_sym_goto] = ACTIONS(2035),
    [anon_sym_var] = ACTIONS(2035),
  },
  [1102] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [1103] = {
    [anon_sym_RPAREN] = ACTIONS(2719),
    [sym_comment] = ACTIONS(31),
  },
  [1104] = {
    [anon_sym_RPAREN] = ACTIONS(2721),
    [sym_comment] = ACTIONS(31),
  },
  [1105] = {
    [anon_sym_bool] = ACTIONS(2723),
    [anon_sym_byte] = ACTIONS(2723),
    [anon_sym_char] = ACTIONS(2723),
    [anon_sym_decimal] = ACTIONS(2723),
    [anon_sym_double] = ACTIONS(2723),
    [anon_sym_float] = ACTIONS(2723),
    [anon_sym_int] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_object] = ACTIONS(2723),
    [anon_sym_sbyte] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_string] = ACTIONS(2723),
    [anon_sym_uint] = ACTIONS(2723),
    [anon_sym_ulong] = ACTIONS(2723),
    [anon_sym_ushort] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_LPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_true] = ACTIONS(2723),
    [anon_sym_false] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_typeof] = ACTIONS(2723),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2723),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2725),
    [sym_null_literal] = ACTIONS(2723),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [anon_sym_AT_DQUOTE] = ACTIONS(2725),
    [sym_identifier_name] = ACTIONS(2723),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_checked] = ACTIONS(2723),
    [anon_sym_unchecked] = ACTIONS(2723),
    [anon_sym_lock] = ACTIONS(2723),
    [anon_sym_yield] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym_var] = ACTIONS(2723),
  },
  [1106] = {
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1262),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(2001),
    [anon_sym_PERCENT] = ACTIONS(1999),
    [anon_sym_CARET] = ACTIONS(2003),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG_EQ] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_AMP_AMP] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [sym_comment] = ACTIONS(31),
  },
  [1107] = {
    [anon_sym_COLON] = ACTIONS(2727),
    [sym_comment] = ACTIONS(31),
  },
  [1108] = {
    [anon_sym_bool] = ACTIONS(2729),
    [anon_sym_byte] = ACTIONS(2729),
    [anon_sym_char] = ACTIONS(2729),
    [anon_sym_decimal] = ACTIONS(2729),
    [anon_sym_double] = ACTIONS(2729),
    [anon_sym_float] = ACTIONS(2729),
    [anon_sym_int] = ACTIONS(2729),
    [anon_sym_long] = ACTIONS(2729),
    [anon_sym_object] = ACTIONS(2729),
    [anon_sym_sbyte] = ACTIONS(2729),
    [anon_sym_short] = ACTIONS(2729),
    [anon_sym_string] = ACTIONS(2729),
    [anon_sym_uint] = ACTIONS(2729),
    [anon_sym_ulong] = ACTIONS(2729),
    [anon_sym_ushort] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2731),
    [anon_sym_LPAREN] = ACTIONS(2731),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2731),
    [anon_sym_TILDE] = ACTIONS(2731),
    [anon_sym_PLUS_PLUS] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2731),
    [anon_sym_true] = ACTIONS(2729),
    [anon_sym_false] = ACTIONS(2729),
    [anon_sym_const] = ACTIONS(2729),
    [anon_sym_typeof] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2731),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2729),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2731),
    [sym_null_literal] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2731),
    [anon_sym_AT_DQUOTE] = ACTIONS(2731),
    [sym_identifier_name] = ACTIONS(2729),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2729),
    [anon_sym_checked] = ACTIONS(2729),
    [anon_sym_unchecked] = ACTIONS(2729),
    [anon_sym_lock] = ACTIONS(2729),
    [anon_sym_yield] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(2729),
    [anon_sym_break] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2729),
    [anon_sym_switch] = ACTIONS(2729),
    [anon_sym_case] = ACTIONS(2729),
    [anon_sym_default] = ACTIONS(2729),
    [anon_sym_while] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2729),
    [anon_sym_continue] = ACTIONS(2729),
    [anon_sym_throw] = ACTIONS(2729),
    [anon_sym_goto] = ACTIONS(2729),
    [anon_sym_var] = ACTIONS(2729),
  },
  [1109] = {
    [anon_sym_bool] = ACTIONS(2733),
    [anon_sym_byte] = ACTIONS(2733),
    [anon_sym_char] = ACTIONS(2733),
    [anon_sym_decimal] = ACTIONS(2733),
    [anon_sym_double] = ACTIONS(2733),
    [anon_sym_float] = ACTIONS(2733),
    [anon_sym_int] = ACTIONS(2733),
    [anon_sym_long] = ACTIONS(2733),
    [anon_sym_object] = ACTIONS(2733),
    [anon_sym_sbyte] = ACTIONS(2733),
    [anon_sym_short] = ACTIONS(2733),
    [anon_sym_string] = ACTIONS(2733),
    [anon_sym_uint] = ACTIONS(2733),
    [anon_sym_ulong] = ACTIONS(2733),
    [anon_sym_ushort] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2735),
    [anon_sym_RBRACE] = ACTIONS(2735),
    [anon_sym_LPAREN] = ACTIONS(2735),
    [anon_sym_DOT] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2735),
    [anon_sym_TILDE] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_true] = ACTIONS(2733),
    [anon_sym_false] = ACTIONS(2733),
    [anon_sym_const] = ACTIONS(2733),
    [anon_sym_typeof] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2735),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2733),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2735),
    [sym_null_literal] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2735),
    [anon_sym_AT_DQUOTE] = ACTIONS(2735),
    [sym_identifier_name] = ACTIONS(2733),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2733),
    [anon_sym_checked] = ACTIONS(2733),
    [anon_sym_unchecked] = ACTIONS(2733),
    [anon_sym_lock] = ACTIONS(2733),
    [anon_sym_yield] = ACTIONS(2733),
    [anon_sym_return] = ACTIONS(2733),
    [anon_sym_break] = ACTIONS(2733),
    [anon_sym_if] = ACTIONS(2733),
    [anon_sym_else] = ACTIONS(2733),
    [anon_sym_switch] = ACTIONS(2733),
    [anon_sym_case] = ACTIONS(2733),
    [anon_sym_default] = ACTIONS(2733),
    [anon_sym_while] = ACTIONS(2733),
    [anon_sym_do] = ACTIONS(2733),
    [anon_sym_continue] = ACTIONS(2733),
    [anon_sym_throw] = ACTIONS(2733),
    [anon_sym_goto] = ACTIONS(2733),
    [anon_sym_var] = ACTIONS(2733),
  },
  [1110] = {
    [sym_switch_section] = STATE(1110),
    [sym_switch_label] = STATE(1062),
    [aux_sym_switch_statement_repeat1] = STATE(1110),
    [aux_sym_switch_section_repeat1] = STATE(1062),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [sym_comment] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2742),
  },
  [1111] = {
    [sym_type_parameter_list] = STATE(97),
    [sym_equals_value_clause] = STATE(545),
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_COLON] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [sym_identifier_name] = ACTIONS(147),
    [sym_comment] = ACTIONS(31),
  },
  [1112] = {
    [sym_statement_block] = STATE(1145),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [1113] = {
    [anon_sym_LPAREN] = ACTIONS(2747),
    [sym_comment] = ACTIONS(31),
  },
  [1114] = {
    [anon_sym_LPAREN] = ACTIONS(2749),
    [sym_comment] = ACTIONS(31),
  },
  [1115] = {
    [anon_sym_LPAREN] = ACTIONS(2751),
    [sym_comment] = ACTIONS(31),
  },
  [1116] = {
    [anon_sym_RBRACE] = ACTIONS(2753),
    [sym_comment] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(2753),
    [anon_sym_default] = ACTIONS(2753),
  },
  [1117] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(1149),
    [sym_variable_assignment_statement] = STATE(1149),
    [sym_statement_block] = STATE(1149),
    [sym__labeled_statement] = STATE(1149),
    [sym__embedded_statement] = STATE(1149),
    [sym_empty_statement] = STATE(1149),
    [sym_expression_statement] = STATE(1149),
    [sym__selection_statement] = STATE(1149),
    [sym__iteration_statement] = STATE(1149),
    [sym__jump_statement] = STATE(1149),
    [sym_try_statement] = STATE(1149),
    [sym_checked_statement] = STATE(1149),
    [sym_unchecked_statement] = STATE(1149),
    [sym_lock_statement] = STATE(1149),
    [sym_yield_statement] = STATE(1149),
    [sym_if_statement] = STATE(1149),
    [sym_switch_statement] = STATE(1149),
    [sym_while_statement] = STATE(1149),
    [sym_do_statement] = STATE(1149),
    [sym_break_statement] = STATE(1149),
    [sym_continue_statement] = STATE(1149),
    [sym_return_statement] = STATE(1149),
    [sym_throw_statement] = STATE(1149),
    [sym_goto_statement] = STATE(1149),
    [sym__declaration_statement] = STATE(1149),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [aux_sym__statement_list_repeat1] = STATE(1149),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(689),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2643),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(723),
  },
  [1118] = {
    [sym_switch_label] = STATE(1118),
    [aux_sym_switch_section_repeat1] = STATE(1118),
    [anon_sym_bool] = ACTIONS(2757),
    [anon_sym_byte] = ACTIONS(2757),
    [anon_sym_char] = ACTIONS(2757),
    [anon_sym_decimal] = ACTIONS(2757),
    [anon_sym_double] = ACTIONS(2757),
    [anon_sym_float] = ACTIONS(2757),
    [anon_sym_int] = ACTIONS(2757),
    [anon_sym_long] = ACTIONS(2757),
    [anon_sym_object] = ACTIONS(2757),
    [anon_sym_sbyte] = ACTIONS(2757),
    [anon_sym_short] = ACTIONS(2757),
    [anon_sym_string] = ACTIONS(2757),
    [anon_sym_uint] = ACTIONS(2757),
    [anon_sym_ulong] = ACTIONS(2757),
    [anon_sym_ushort] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_LPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2759),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2759),
    [anon_sym_true] = ACTIONS(2757),
    [anon_sym_false] = ACTIONS(2757),
    [anon_sym_const] = ACTIONS(2757),
    [anon_sym_typeof] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2759),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2757),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2759),
    [sym_null_literal] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2759),
    [anon_sym_AT_DQUOTE] = ACTIONS(2759),
    [sym_identifier_name] = ACTIONS(2757),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2757),
    [anon_sym_checked] = ACTIONS(2757),
    [anon_sym_unchecked] = ACTIONS(2757),
    [anon_sym_lock] = ACTIONS(2757),
    [anon_sym_yield] = ACTIONS(2757),
    [anon_sym_return] = ACTIONS(2757),
    [anon_sym_break] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_switch] = ACTIONS(2757),
    [anon_sym_case] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2757),
    [anon_sym_do] = ACTIONS(2757),
    [anon_sym_continue] = ACTIONS(2757),
    [anon_sym_throw] = ACTIONS(2757),
    [anon_sym_goto] = ACTIONS(2757),
    [anon_sym_var] = ACTIONS(2757),
  },
  [1119] = {
    [sym_catch_clause] = STATE(1150),
    [sym_finally_clause] = STATE(740),
    [aux_sym_try_statement_repeat1] = STATE(1150),
    [sym_comment] = ACTIONS(31),
    [anon_sym_catch] = ACTIONS(2059),
    [anon_sym_finally] = ACTIONS(2061),
    [anon_sym_else] = ACTIONS(1545),
    [anon_sym_while] = ACTIONS(1545),
  },
  [1120] = {
    [sym__expression] = STATE(1151),
    [sym_parenthesized_expression] = STATE(1151),
    [sym_ternary_expression] = STATE(1151),
    [sym_binary_expression] = STATE(1151),
    [sym_unary_expression] = STATE(1151),
    [sym__literal] = STATE(1151),
    [sym_boolean_literal] = STATE(1151),
    [sym_character_literal] = STATE(1151),
    [sym_integer_literal] = STATE(1151),
    [sym_real_literal] = STATE(1151),
    [sym_string_literal] = STATE(1151),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2767),
    [sym_comment] = ACTIONS(31),
  },
  [1121] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1122] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1153),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1123] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1105),
    [sym__embedded_statement] = STATE(1105),
    [sym_empty_statement] = STATE(1105),
    [sym_expression_statement] = STATE(1105),
    [sym__selection_statement] = STATE(1105),
    [sym__iteration_statement] = STATE(1105),
    [sym__jump_statement] = STATE(1105),
    [sym_try_statement] = STATE(1105),
    [sym_checked_statement] = STATE(1105),
    [sym_unchecked_statement] = STATE(1105),
    [sym_lock_statement] = STATE(1105),
    [sym_yield_statement] = STATE(1105),
    [sym_if_statement] = STATE(1105),
    [sym_switch_statement] = STATE(1105),
    [sym_while_statement] = STATE(1105),
    [sym_do_statement] = STATE(1105),
    [sym_break_statement] = STATE(1105),
    [sym_continue_statement] = STATE(1105),
    [sym_return_statement] = STATE(1105),
    [sym_throw_statement] = STATE(1105),
    [sym_goto_statement] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(1175),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1124] = {
    [anon_sym_bool] = ACTIONS(2769),
    [anon_sym_byte] = ACTIONS(2769),
    [anon_sym_char] = ACTIONS(2769),
    [anon_sym_decimal] = ACTIONS(2769),
    [anon_sym_double] = ACTIONS(2769),
    [anon_sym_float] = ACTIONS(2769),
    [anon_sym_int] = ACTIONS(2769),
    [anon_sym_long] = ACTIONS(2769),
    [anon_sym_object] = ACTIONS(2769),
    [anon_sym_sbyte] = ACTIONS(2769),
    [anon_sym_short] = ACTIONS(2769),
    [anon_sym_string] = ACTIONS(2769),
    [anon_sym_uint] = ACTIONS(2769),
    [anon_sym_ulong] = ACTIONS(2769),
    [anon_sym_ushort] = ACTIONS(2769),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_DOT] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2771),
    [anon_sym_TILDE] = ACTIONS(2771),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_true] = ACTIONS(2769),
    [anon_sym_false] = ACTIONS(2769),
    [anon_sym_const] = ACTIONS(2769),
    [anon_sym_typeof] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2771),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2769),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2771),
    [sym_null_literal] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2771),
    [anon_sym_AT_DQUOTE] = ACTIONS(2771),
    [sym_identifier_name] = ACTIONS(2769),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2769),
    [anon_sym_checked] = ACTIONS(2769),
    [anon_sym_unchecked] = ACTIONS(2769),
    [anon_sym_lock] = ACTIONS(2769),
    [anon_sym_yield] = ACTIONS(2769),
    [anon_sym_return] = ACTIONS(2769),
    [anon_sym_break] = ACTIONS(2769),
    [anon_sym_if] = ACTIONS(2769),
    [anon_sym_else] = ACTIONS(2769),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_case] = ACTIONS(2769),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_while] = ACTIONS(2769),
    [anon_sym_do] = ACTIONS(2769),
    [anon_sym_continue] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(2769),
    [anon_sym_goto] = ACTIONS(2769),
    [anon_sym_var] = ACTIONS(2769),
  },
  [1125] = {
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [sym_comment] = ACTIONS(31),
  },
  [1126] = {
    [anon_sym_COMMA] = ACTIONS(2775),
    [anon_sym_SEMI] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2775),
    [sym_comment] = ACTIONS(31),
  },
  [1127] = {
    [aux_sym_array_initalizer_repeat1] = STATE(1127),
    [anon_sym_COMMA] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [sym_comment] = ACTIONS(31),
  },
  [1128] = {
    [anon_sym_bool] = ACTIONS(2780),
    [anon_sym_byte] = ACTIONS(2780),
    [anon_sym_char] = ACTIONS(2780),
    [anon_sym_decimal] = ACTIONS(2780),
    [anon_sym_double] = ACTIONS(2780),
    [anon_sym_float] = ACTIONS(2780),
    [anon_sym_int] = ACTIONS(2780),
    [anon_sym_long] = ACTIONS(2780),
    [anon_sym_object] = ACTIONS(2780),
    [anon_sym_sbyte] = ACTIONS(2780),
    [anon_sym_short] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_uint] = ACTIONS(2780),
    [anon_sym_ulong] = ACTIONS(2780),
    [anon_sym_ushort] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_extern] = ACTIONS(2780),
    [anon_sym_internal] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_override] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_readonly] = ACTIONS(2780),
    [anon_sym_sealed] = ACTIONS(2780),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_unsafe] = ACTIONS(2780),
    [anon_sym_virtual] = ACTIONS(2780),
    [anon_sym_volatile] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_partial] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_struct] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_event] = ACTIONS(2780),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_implicit] = ACTIONS(2780),
    [anon_sym_explicit] = ACTIONS(2780),
    [anon_sym_interface] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
    [anon_sym_delegate] = ACTIONS(2780),
    [sym_void_keyword] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [sym_identifier_name] = ACTIONS(2780),
    [sym_comment] = ACTIONS(31),
  },
  [1129] = {
    [anon_sym_bool] = ACTIONS(2784),
    [anon_sym_byte] = ACTIONS(2784),
    [anon_sym_char] = ACTIONS(2784),
    [anon_sym_decimal] = ACTIONS(2784),
    [anon_sym_double] = ACTIONS(2784),
    [anon_sym_float] = ACTIONS(2784),
    [anon_sym_int] = ACTIONS(2784),
    [anon_sym_long] = ACTIONS(2784),
    [anon_sym_object] = ACTIONS(2784),
    [anon_sym_sbyte] = ACTIONS(2784),
    [anon_sym_short] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_uint] = ACTIONS(2784),
    [anon_sym_ulong] = ACTIONS(2784),
    [anon_sym_ushort] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_extern] = ACTIONS(2784),
    [anon_sym_internal] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_override] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_readonly] = ACTIONS(2784),
    [anon_sym_sealed] = ACTIONS(2784),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_unsafe] = ACTIONS(2784),
    [anon_sym_virtual] = ACTIONS(2784),
    [anon_sym_volatile] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_partial] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_struct] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_event] = ACTIONS(2784),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_implicit] = ACTIONS(2784),
    [anon_sym_explicit] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [anon_sym_delegate] = ACTIONS(2784),
    [sym_void_keyword] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [sym_identifier_name] = ACTIONS(2784),
    [sym_comment] = ACTIONS(31),
  },
  [1130] = {
    [anon_sym_bool] = ACTIONS(2788),
    [anon_sym_byte] = ACTIONS(2788),
    [anon_sym_char] = ACTIONS(2788),
    [anon_sym_decimal] = ACTIONS(2788),
    [anon_sym_double] = ACTIONS(2788),
    [anon_sym_float] = ACTIONS(2788),
    [anon_sym_int] = ACTIONS(2788),
    [anon_sym_long] = ACTIONS(2788),
    [anon_sym_object] = ACTIONS(2788),
    [anon_sym_sbyte] = ACTIONS(2788),
    [anon_sym_short] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_uint] = ACTIONS(2788),
    [anon_sym_ulong] = ACTIONS(2788),
    [anon_sym_ushort] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_event] = ACTIONS(2788),
    [sym_void_keyword] = ACTIONS(2788),
    [sym_identifier_name] = ACTIONS(2788),
    [sym_comment] = ACTIONS(31),
  },
  [1131] = {
    [aux_sym_class_base_repeat1] = STATE(1154),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_where] = ACTIONS(2353),
    [sym_comment] = ACTIONS(31),
  },
  [1132] = {
    [sym_interface_accessor] = STATE(784),
    [sym__attributes] = STATE(601),
    [sym__attribute_section] = STATE(603),
    [aux_sym_interface_property_declaration_repeat1] = STATE(784),
    [aux_sym__attributes_repeat1] = STATE(603),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(79),
    [sym_comment] = ACTIONS(31),
  },
  [1133] = {
    [anon_sym_LT] = ACTIONS(2153),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2153),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2161),
    [anon_sym_PERCENT] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2163),
    [anon_sym_PIPE] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_GT_EQ] = ACTIONS(2173),
    [anon_sym_LT_EQ] = ACTIONS(2173),
    [anon_sym_params] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2175),
    [anon_sym_AMP_AMP] = ACTIONS(2177),
    [anon_sym_PIPE_PIPE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(31),
  },
  [1134] = {
    [ts_builtin_sym_end] = ACTIONS(2794),
    [anon_sym_bool] = ACTIONS(2796),
    [anon_sym_byte] = ACTIONS(2796),
    [anon_sym_char] = ACTIONS(2796),
    [anon_sym_decimal] = ACTIONS(2796),
    [anon_sym_double] = ACTIONS(2796),
    [anon_sym_float] = ACTIONS(2796),
    [anon_sym_int] = ACTIONS(2796),
    [anon_sym_long] = ACTIONS(2796),
    [anon_sym_object] = ACTIONS(2796),
    [anon_sym_sbyte] = ACTIONS(2796),
    [anon_sym_short] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_uint] = ACTIONS(2796),
    [anon_sym_ulong] = ACTIONS(2796),
    [anon_sym_ushort] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_extern] = ACTIONS(2796),
    [anon_sym_internal] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_override] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_readonly] = ACTIONS(2796),
    [anon_sym_sealed] = ACTIONS(2796),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_unsafe] = ACTIONS(2796),
    [anon_sym_virtual] = ACTIONS(2796),
    [anon_sym_volatile] = ACTIONS(2796),
    [anon_sym_using] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_partial] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_struct] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_event] = ACTIONS(2796),
    [anon_sym_TILDE] = ACTIONS(2794),
    [anon_sym_implicit] = ACTIONS(2796),
    [anon_sym_explicit] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [anon_sym_delegate] = ACTIONS(2796),
    [sym_void_keyword] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [sym_identifier_name] = ACTIONS(2796),
    [sym_comment] = ACTIONS(31),
  },
  [1135] = {
    [ts_builtin_sym_end] = ACTIONS(2798),
    [anon_sym_bool] = ACTIONS(2800),
    [anon_sym_byte] = ACTIONS(2800),
    [anon_sym_char] = ACTIONS(2800),
    [anon_sym_decimal] = ACTIONS(2800),
    [anon_sym_double] = ACTIONS(2800),
    [anon_sym_float] = ACTIONS(2800),
    [anon_sym_int] = ACTIONS(2800),
    [anon_sym_long] = ACTIONS(2800),
    [anon_sym_object] = ACTIONS(2800),
    [anon_sym_sbyte] = ACTIONS(2800),
    [anon_sym_short] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_uint] = ACTIONS(2800),
    [anon_sym_ulong] = ACTIONS(2800),
    [anon_sym_ushort] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_extern] = ACTIONS(2800),
    [anon_sym_internal] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_override] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_readonly] = ACTIONS(2800),
    [anon_sym_sealed] = ACTIONS(2800),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_unsafe] = ACTIONS(2800),
    [anon_sym_virtual] = ACTIONS(2800),
    [anon_sym_volatile] = ACTIONS(2800),
    [anon_sym_using] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_partial] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_struct] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_event] = ACTIONS(2800),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_implicit] = ACTIONS(2800),
    [anon_sym_explicit] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [anon_sym_delegate] = ACTIONS(2800),
    [sym_void_keyword] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [sym_identifier_name] = ACTIONS(2800),
    [sym_comment] = ACTIONS(31),
  },
  [1136] = {
    [ts_builtin_sym_end] = ACTIONS(2802),
    [anon_sym_bool] = ACTIONS(2804),
    [anon_sym_byte] = ACTIONS(2804),
    [anon_sym_char] = ACTIONS(2804),
    [anon_sym_decimal] = ACTIONS(2804),
    [anon_sym_double] = ACTIONS(2804),
    [anon_sym_float] = ACTIONS(2804),
    [anon_sym_int] = ACTIONS(2804),
    [anon_sym_long] = ACTIONS(2804),
    [anon_sym_object] = ACTIONS(2804),
    [anon_sym_sbyte] = ACTIONS(2804),
    [anon_sym_short] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_uint] = ACTIONS(2804),
    [anon_sym_ulong] = ACTIONS(2804),
    [anon_sym_ushort] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_extern] = ACTIONS(2804),
    [anon_sym_internal] = ACTIONS(2804),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_override] = ACTIONS(2804),
    [anon_sym_private] = ACTIONS(2804),
    [anon_sym_protected] = ACTIONS(2804),
    [anon_sym_public] = ACTIONS(2804),
    [anon_sym_readonly] = ACTIONS(2804),
    [anon_sym_sealed] = ACTIONS(2804),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_unsafe] = ACTIONS(2804),
    [anon_sym_virtual] = ACTIONS(2804),
    [anon_sym_volatile] = ACTIONS(2804),
    [anon_sym_using] = ACTIONS(2804),
    [anon_sym_namespace] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_partial] = ACTIONS(2804),
    [anon_sym_class] = ACTIONS(2804),
    [anon_sym_struct] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_event] = ACTIONS(2804),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_implicit] = ACTIONS(2804),
    [anon_sym_explicit] = ACTIONS(2804),
    [anon_sym_interface] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
    [anon_sym_delegate] = ACTIONS(2804),
    [sym_void_keyword] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [sym_identifier_name] = ACTIONS(2804),
    [sym_comment] = ACTIONS(31),
  },
  [1137] = {
    [sym__expression] = STATE(1156),
    [sym_parenthesized_expression] = STATE(1156),
    [sym_ternary_expression] = STATE(1156),
    [sym_binary_expression] = STATE(1156),
    [sym_unary_expression] = STATE(1156),
    [sym__literal] = STATE(1156),
    [sym_boolean_literal] = STATE(1156),
    [sym_character_literal] = STATE(1156),
    [sym_integer_literal] = STATE(1156),
    [sym_real_literal] = STATE(1156),
    [sym_string_literal] = STATE(1156),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(2221),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2806),
    [sym_comment] = ACTIONS(31),
  },
  [1138] = {
    [anon_sym_SEMI] = ACTIONS(2808),
    [anon_sym_LBRACE] = ACTIONS(2808),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [sym_comment] = ACTIONS(31),
  },
  [1139] = {
    [sym_catch_clause] = STATE(1139),
    [aux_sym_try_statement_repeat1] = STATE(1139),
    [anon_sym_bool] = ACTIONS(2292),
    [anon_sym_byte] = ACTIONS(2292),
    [anon_sym_char] = ACTIONS(2292),
    [anon_sym_decimal] = ACTIONS(2292),
    [anon_sym_double] = ACTIONS(2292),
    [anon_sym_float] = ACTIONS(2292),
    [anon_sym_int] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_sbyte] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_uint] = ACTIONS(2292),
    [anon_sym_ulong] = ACTIONS(2292),
    [anon_sym_ushort] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2292),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2294),
    [sym_null_literal] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_AT_DQUOTE] = ACTIONS(2294),
    [sym_identifier_name] = ACTIONS(2292),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_catch] = ACTIONS(2296),
    [anon_sym_finally] = ACTIONS(2292),
    [anon_sym_checked] = ACTIONS(2292),
    [anon_sym_unchecked] = ACTIONS(2292),
    [anon_sym_lock] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
  },
  [1140] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(986),
    [sym__embedded_statement] = STATE(986),
    [sym_empty_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym__selection_statement] = STATE(986),
    [sym__iteration_statement] = STATE(986),
    [sym__jump_statement] = STATE(986),
    [sym_try_statement] = STATE(986),
    [sym_checked_statement] = STATE(986),
    [sym_unchecked_statement] = STATE(986),
    [sym_lock_statement] = STATE(986),
    [sym_yield_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_throw_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2303),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2305),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1141] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1157),
    [sym__embedded_statement] = STATE(1157),
    [sym_empty_statement] = STATE(1157),
    [sym_expression_statement] = STATE(1157),
    [sym__selection_statement] = STATE(1157),
    [sym__iteration_statement] = STATE(1157),
    [sym__jump_statement] = STATE(1157),
    [sym_try_statement] = STATE(1157),
    [sym_checked_statement] = STATE(1157),
    [sym_unchecked_statement] = STATE(1157),
    [sym_lock_statement] = STATE(1157),
    [sym_yield_statement] = STATE(1157),
    [sym_if_statement] = STATE(1157),
    [sym_switch_statement] = STATE(1157),
    [sym_while_statement] = STATE(1157),
    [sym_do_statement] = STATE(1157),
    [sym_break_statement] = STATE(1157),
    [sym_continue_statement] = STATE(1157),
    [sym_return_statement] = STATE(1157),
    [sym_throw_statement] = STATE(1157),
    [sym_goto_statement] = STATE(1157),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2303),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2305),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1142] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(993),
    [sym__embedded_statement] = STATE(993),
    [sym_empty_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym__selection_statement] = STATE(993),
    [sym__iteration_statement] = STATE(993),
    [sym__jump_statement] = STATE(993),
    [sym_try_statement] = STATE(993),
    [sym_checked_statement] = STATE(993),
    [sym_unchecked_statement] = STATE(993),
    [sym_lock_statement] = STATE(993),
    [sym_yield_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_throw_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2303),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2305),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1143] = {
    [anon_sym_bool] = ACTIONS(2810),
    [anon_sym_byte] = ACTIONS(2810),
    [anon_sym_char] = ACTIONS(2810),
    [anon_sym_decimal] = ACTIONS(2810),
    [anon_sym_double] = ACTIONS(2810),
    [anon_sym_float] = ACTIONS(2810),
    [anon_sym_int] = ACTIONS(2810),
    [anon_sym_long] = ACTIONS(2810),
    [anon_sym_object] = ACTIONS(2810),
    [anon_sym_sbyte] = ACTIONS(2810),
    [anon_sym_short] = ACTIONS(2810),
    [anon_sym_string] = ACTIONS(2810),
    [anon_sym_uint] = ACTIONS(2810),
    [anon_sym_ulong] = ACTIONS(2810),
    [anon_sym_ushort] = ACTIONS(2810),
    [anon_sym_SEMI] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2810),
    [anon_sym_DASH] = ACTIONS(2810),
    [anon_sym_BANG] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2812),
    [anon_sym_DASH_DASH] = ACTIONS(2812),
    [anon_sym_true] = ACTIONS(2810),
    [anon_sym_false] = ACTIONS(2810),
    [anon_sym_const] = ACTIONS(2810),
    [anon_sym_typeof] = ACTIONS(2810),
    [anon_sym_sizeof] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2812),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2810),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2812),
    [sym_null_literal] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [anon_sym_AT_DQUOTE] = ACTIONS(2812),
    [sym_identifier_name] = ACTIONS(2810),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2810),
    [anon_sym_checked] = ACTIONS(2810),
    [anon_sym_unchecked] = ACTIONS(2810),
    [anon_sym_lock] = ACTIONS(2810),
    [anon_sym_yield] = ACTIONS(2810),
    [anon_sym_return] = ACTIONS(2810),
    [anon_sym_break] = ACTIONS(2810),
    [anon_sym_if] = ACTIONS(2810),
    [anon_sym_switch] = ACTIONS(2810),
    [anon_sym_case] = ACTIONS(2810),
    [anon_sym_default] = ACTIONS(2810),
    [anon_sym_while] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_continue] = ACTIONS(2810),
    [anon_sym_throw] = ACTIONS(2810),
    [anon_sym_goto] = ACTIONS(2810),
    [anon_sym_var] = ACTIONS(2810),
  },
  [1144] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(736),
    [sym_variable_assignment_statement] = STATE(736),
    [sym_statement_block] = STATE(736),
    [sym__labeled_statement] = STATE(736),
    [sym__embedded_statement] = STATE(736),
    [sym_empty_statement] = STATE(736),
    [sym_expression_statement] = STATE(736),
    [sym__selection_statement] = STATE(736),
    [sym__iteration_statement] = STATE(736),
    [sym__jump_statement] = STATE(736),
    [sym_try_statement] = STATE(736),
    [sym_checked_statement] = STATE(736),
    [sym_unchecked_statement] = STATE(736),
    [sym_lock_statement] = STATE(736),
    [sym_yield_statement] = STATE(736),
    [sym_if_statement] = STATE(736),
    [sym_switch_statement] = STATE(736),
    [sym_while_statement] = STATE(736),
    [sym_do_statement] = STATE(736),
    [sym_break_statement] = STATE(736),
    [sym_continue_statement] = STATE(736),
    [sym_return_statement] = STATE(736),
    [sym_throw_statement] = STATE(736),
    [sym_goto_statement] = STATE(736),
    [sym__declaration_statement] = STATE(736),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [anon_sym_bool] = ACTIONS(65),
    [anon_sym_byte] = ACTIONS(65),
    [anon_sym_char] = ACTIONS(65),
    [anon_sym_decimal] = ACTIONS(65),
    [anon_sym_double] = ACTIONS(65),
    [anon_sym_float] = ACTIONS(65),
    [anon_sym_int] = ACTIONS(65),
    [anon_sym_long] = ACTIONS(65),
    [anon_sym_object] = ACTIONS(65),
    [anon_sym_sbyte] = ACTIONS(65),
    [anon_sym_short] = ACTIONS(65),
    [anon_sym_string] = ACTIONS(65),
    [anon_sym_uint] = ACTIONS(65),
    [anon_sym_ulong] = ACTIONS(65),
    [anon_sym_ushort] = ACTIONS(65),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(689),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2643),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(723),
  },
  [1145] = {
    [sym_catch_clause] = STATE(1158),
    [sym_finally_clause] = STATE(740),
    [aux_sym_try_statement_repeat1] = STATE(1158),
    [anon_sym_bool] = ACTIONS(1543),
    [anon_sym_byte] = ACTIONS(1543),
    [anon_sym_char] = ACTIONS(1543),
    [anon_sym_decimal] = ACTIONS(1543),
    [anon_sym_double] = ACTIONS(1543),
    [anon_sym_float] = ACTIONS(1543),
    [anon_sym_int] = ACTIONS(1543),
    [anon_sym_long] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [anon_sym_sbyte] = ACTIONS(1543),
    [anon_sym_short] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_uint] = ACTIONS(1543),
    [anon_sym_ulong] = ACTIONS(1543),
    [anon_sym_ushort] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_DOT] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(1543),
    [anon_sym_false] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(1543),
    [anon_sym_typeof] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1543),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1545),
    [sym_null_literal] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [anon_sym_AT_DQUOTE] = ACTIONS(1545),
    [sym_identifier_name] = ACTIONS(1543),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1543),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(1543),
    [anon_sym_unchecked] = ACTIONS(1543),
    [anon_sym_lock] = ACTIONS(1543),
    [anon_sym_yield] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1543),
    [anon_sym_break] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_switch] = ACTIONS(1543),
    [anon_sym_case] = ACTIONS(1543),
    [anon_sym_default] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_do] = ACTIONS(1543),
    [anon_sym_continue] = ACTIONS(1543),
    [anon_sym_throw] = ACTIONS(1543),
    [anon_sym_goto] = ACTIONS(1543),
    [anon_sym_var] = ACTIONS(1543),
  },
  [1146] = {
    [sym__expression] = STATE(1159),
    [sym_parenthesized_expression] = STATE(1159),
    [sym_ternary_expression] = STATE(1159),
    [sym_binary_expression] = STATE(1159),
    [sym_unary_expression] = STATE(1159),
    [sym__literal] = STATE(1159),
    [sym_boolean_literal] = STATE(1159),
    [sym_character_literal] = STATE(1159),
    [sym_integer_literal] = STATE(1159),
    [sym_real_literal] = STATE(1159),
    [sym_string_literal] = STATE(1159),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2814),
    [sym_comment] = ACTIONS(31),
  },
  [1147] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1160),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1148] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1161),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1149] = {
    [sym__type] = STATE(389),
    [sym_predefined_type] = STATE(389),
    [sym_generic_name] = STATE(389),
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym__statement] = STATE(1149),
    [sym_variable_assignment_statement] = STATE(1149),
    [sym_statement_block] = STATE(1149),
    [sym__labeled_statement] = STATE(1149),
    [sym__embedded_statement] = STATE(1149),
    [sym_empty_statement] = STATE(1149),
    [sym_expression_statement] = STATE(1149),
    [sym__selection_statement] = STATE(1149),
    [sym__iteration_statement] = STATE(1149),
    [sym__jump_statement] = STATE(1149),
    [sym_try_statement] = STATE(1149),
    [sym_checked_statement] = STATE(1149),
    [sym_unchecked_statement] = STATE(1149),
    [sym_lock_statement] = STATE(1149),
    [sym_yield_statement] = STATE(1149),
    [sym_if_statement] = STATE(1149),
    [sym_switch_statement] = STATE(1149),
    [sym_while_statement] = STATE(1149),
    [sym_do_statement] = STATE(1149),
    [sym_break_statement] = STATE(1149),
    [sym_continue_statement] = STATE(1149),
    [sym_return_statement] = STATE(1149),
    [sym_throw_statement] = STATE(1149),
    [sym_goto_statement] = STATE(1149),
    [sym__declaration_statement] = STATE(1149),
    [sym_local_variable_declaration] = STATE(388),
    [sym__local_variable_type] = STATE(389),
    [sym_local_constant_declaration] = STATE(388),
    [aux_sym__statement_list_repeat1] = STATE(1149),
    [anon_sym_bool] = ACTIONS(1623),
    [anon_sym_byte] = ACTIONS(1623),
    [anon_sym_char] = ACTIONS(1623),
    [anon_sym_decimal] = ACTIONS(1623),
    [anon_sym_double] = ACTIONS(1623),
    [anon_sym_float] = ACTIONS(1623),
    [anon_sym_int] = ACTIONS(1623),
    [anon_sym_long] = ACTIONS(1623),
    [anon_sym_object] = ACTIONS(1623),
    [anon_sym_sbyte] = ACTIONS(1623),
    [anon_sym_short] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_uint] = ACTIONS(1623),
    [anon_sym_ulong] = ACTIONS(1623),
    [anon_sym_ushort] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1626),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_LPAREN] = ACTIONS(1634),
    [anon_sym_DOT] = ACTIONS(1637),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1643),
    [anon_sym_TILDE] = ACTIONS(1643),
    [anon_sym_PLUS_PLUS] = ACTIONS(1643),
    [anon_sym_DASH_DASH] = ACTIONS(1643),
    [anon_sym_true] = ACTIONS(1646),
    [anon_sym_false] = ACTIONS(1646),
    [anon_sym_const] = ACTIONS(1649),
    [anon_sym_typeof] = ACTIONS(1640),
    [anon_sym_sizeof] = ACTIONS(1640),
    [anon_sym_SQUOTE] = ACTIONS(1652),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1655),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1658),
    [sym_null_literal] = ACTIONS(1661),
    [anon_sym_DQUOTE] = ACTIONS(1664),
    [anon_sym_AT_DQUOTE] = ACTIONS(1667),
    [sym_identifier_name] = ACTIONS(2816),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2819),
    [anon_sym_checked] = ACTIONS(1676),
    [anon_sym_unchecked] = ACTIONS(1679),
    [anon_sym_lock] = ACTIONS(2822),
    [anon_sym_yield] = ACTIONS(1685),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1691),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_switch] = ACTIONS(1697),
    [anon_sym_case] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_continue] = ACTIONS(1706),
    [anon_sym_throw] = ACTIONS(1709),
    [anon_sym_goto] = ACTIONS(1712),
    [anon_sym_var] = ACTIONS(1715),
  },
  [1150] = {
    [sym_catch_clause] = STATE(1162),
    [sym_finally_clause] = STATE(888),
    [aux_sym_try_statement_repeat1] = STATE(1162),
    [sym_comment] = ACTIONS(31),
    [anon_sym_catch] = ACTIONS(2059),
    [anon_sym_finally] = ACTIONS(2061),
    [anon_sym_else] = ACTIONS(2037),
    [anon_sym_while] = ACTIONS(2037),
  },
  [1151] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [1152] = {
    [anon_sym_RPAREN] = ACTIONS(2835),
    [sym_comment] = ACTIONS(31),
  },
  [1153] = {
    [anon_sym_RPAREN] = ACTIONS(2837),
    [sym_comment] = ACTIONS(31),
  },
  [1154] = {
    [aux_sym_class_base_repeat1] = STATE(1154),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_where] = ACTIONS(1229),
    [sym_comment] = ACTIONS(31),
  },
  [1155] = {
    [anon_sym_bool] = ACTIONS(2839),
    [anon_sym_byte] = ACTIONS(2839),
    [anon_sym_char] = ACTIONS(2839),
    [anon_sym_decimal] = ACTIONS(2839),
    [anon_sym_double] = ACTIONS(2839),
    [anon_sym_float] = ACTIONS(2839),
    [anon_sym_int] = ACTIONS(2839),
    [anon_sym_long] = ACTIONS(2839),
    [anon_sym_object] = ACTIONS(2839),
    [anon_sym_sbyte] = ACTIONS(2839),
    [anon_sym_short] = ACTIONS(2839),
    [anon_sym_string] = ACTIONS(2839),
    [anon_sym_uint] = ACTIONS(2839),
    [anon_sym_ulong] = ACTIONS(2839),
    [anon_sym_ushort] = ACTIONS(2839),
    [anon_sym_new] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2841),
    [anon_sym_event] = ACTIONS(2839),
    [sym_void_keyword] = ACTIONS(2839),
    [sym_identifier_name] = ACTIONS(2839),
    [sym_comment] = ACTIONS(31),
  },
  [1156] = {
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_params] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [sym_comment] = ACTIONS(31),
  },
  [1157] = {
    [anon_sym_bool] = ACTIONS(2514),
    [anon_sym_byte] = ACTIONS(2514),
    [anon_sym_char] = ACTIONS(2514),
    [anon_sym_decimal] = ACTIONS(2514),
    [anon_sym_double] = ACTIONS(2514),
    [anon_sym_float] = ACTIONS(2514),
    [anon_sym_int] = ACTIONS(2514),
    [anon_sym_long] = ACTIONS(2514),
    [anon_sym_object] = ACTIONS(2514),
    [anon_sym_sbyte] = ACTIONS(2514),
    [anon_sym_short] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_uint] = ACTIONS(2514),
    [anon_sym_ulong] = ACTIONS(2514),
    [anon_sym_ushort] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_DOT] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_true] = ACTIONS(2514),
    [anon_sym_false] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2514),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2516),
    [sym_null_literal] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [sym_identifier_name] = ACTIONS(2514),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_checked] = ACTIONS(2514),
    [anon_sym_unchecked] = ACTIONS(2514),
    [anon_sym_lock] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2843),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_goto] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
  },
  [1158] = {
    [sym_catch_clause] = STATE(1167),
    [sym_finally_clause] = STATE(888),
    [aux_sym_try_statement_repeat1] = STATE(1167),
    [anon_sym_bool] = ACTIONS(2035),
    [anon_sym_byte] = ACTIONS(2035),
    [anon_sym_char] = ACTIONS(2035),
    [anon_sym_decimal] = ACTIONS(2035),
    [anon_sym_double] = ACTIONS(2035),
    [anon_sym_float] = ACTIONS(2035),
    [anon_sym_int] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_object] = ACTIONS(2035),
    [anon_sym_sbyte] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_string] = ACTIONS(2035),
    [anon_sym_uint] = ACTIONS(2035),
    [anon_sym_ulong] = ACTIONS(2035),
    [anon_sym_ushort] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_typeof] = ACTIONS(2035),
    [anon_sym_sizeof] = ACTIONS(2035),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2035),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2037),
    [sym_null_literal] = ACTIONS(2035),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_AT_DQUOTE] = ACTIONS(2037),
    [sym_identifier_name] = ACTIONS(2035),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2035),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(2035),
    [anon_sym_unchecked] = ACTIONS(2035),
    [anon_sym_lock] = ACTIONS(2035),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_switch] = ACTIONS(2035),
    [anon_sym_case] = ACTIONS(2035),
    [anon_sym_default] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_do] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_throw] = ACTIONS(2035),
    [anon_sym_goto] = ACTIONS(2035),
    [anon_sym_var] = ACTIONS(2035),
  },
  [1159] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [1160] = {
    [anon_sym_RPAREN] = ACTIONS(2848),
    [sym_comment] = ACTIONS(31),
  },
  [1161] = {
    [anon_sym_RPAREN] = ACTIONS(2850),
    [sym_comment] = ACTIONS(31),
  },
  [1162] = {
    [sym_catch_clause] = STATE(1162),
    [aux_sym_try_statement_repeat1] = STATE(1162),
    [sym_comment] = ACTIONS(31),
    [anon_sym_catch] = ACTIONS(2530),
    [anon_sym_finally] = ACTIONS(2294),
    [anon_sym_else] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2294),
  },
  [1163] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(986),
    [sym__embedded_statement] = STATE(986),
    [sym_empty_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym__selection_statement] = STATE(986),
    [sym__iteration_statement] = STATE(986),
    [sym__jump_statement] = STATE(986),
    [sym_try_statement] = STATE(986),
    [sym_checked_statement] = STATE(986),
    [sym_unchecked_statement] = STATE(986),
    [sym_lock_statement] = STATE(986),
    [sym_yield_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_throw_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2533),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2535),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2539),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1164] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1171),
    [sym__embedded_statement] = STATE(1171),
    [sym_empty_statement] = STATE(1171),
    [sym_expression_statement] = STATE(1171),
    [sym__selection_statement] = STATE(1171),
    [sym__iteration_statement] = STATE(1171),
    [sym__jump_statement] = STATE(1171),
    [sym_try_statement] = STATE(1171),
    [sym_checked_statement] = STATE(1171),
    [sym_unchecked_statement] = STATE(1171),
    [sym_lock_statement] = STATE(1171),
    [sym_yield_statement] = STATE(1171),
    [sym_if_statement] = STATE(1171),
    [sym_switch_statement] = STATE(1171),
    [sym_while_statement] = STATE(1171),
    [sym_do_statement] = STATE(1171),
    [sym_break_statement] = STATE(1171),
    [sym_continue_statement] = STATE(1171),
    [sym_return_statement] = STATE(1171),
    [sym_throw_statement] = STATE(1171),
    [sym_goto_statement] = STATE(1171),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2533),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2535),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2539),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1165] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(993),
    [sym__embedded_statement] = STATE(993),
    [sym_empty_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym__selection_statement] = STATE(993),
    [sym__iteration_statement] = STATE(993),
    [sym__jump_statement] = STATE(993),
    [sym_try_statement] = STATE(993),
    [sym_checked_statement] = STATE(993),
    [sym_unchecked_statement] = STATE(993),
    [sym_lock_statement] = STATE(993),
    [sym_yield_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_throw_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2533),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2535),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2539),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1166] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1105),
    [sym__embedded_statement] = STATE(1105),
    [sym_empty_statement] = STATE(1105),
    [sym_expression_statement] = STATE(1105),
    [sym__selection_statement] = STATE(1105),
    [sym__iteration_statement] = STATE(1105),
    [sym__jump_statement] = STATE(1105),
    [sym_try_statement] = STATE(1105),
    [sym_checked_statement] = STATE(1105),
    [sym_unchecked_statement] = STATE(1105),
    [sym_lock_statement] = STATE(1105),
    [sym_yield_statement] = STATE(1105),
    [sym_if_statement] = STATE(1105),
    [sym_switch_statement] = STATE(1105),
    [sym_while_statement] = STATE(1105),
    [sym_do_statement] = STATE(1105),
    [sym_break_statement] = STATE(1105),
    [sym_continue_statement] = STATE(1105),
    [sym_return_statement] = STATE(1105),
    [sym_throw_statement] = STATE(1105),
    [sym_goto_statement] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2303),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2305),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1167] = {
    [sym_catch_clause] = STATE(1167),
    [aux_sym_try_statement_repeat1] = STATE(1167),
    [anon_sym_bool] = ACTIONS(2292),
    [anon_sym_byte] = ACTIONS(2292),
    [anon_sym_char] = ACTIONS(2292),
    [anon_sym_decimal] = ACTIONS(2292),
    [anon_sym_double] = ACTIONS(2292),
    [anon_sym_float] = ACTIONS(2292),
    [anon_sym_int] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_sbyte] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_uint] = ACTIONS(2292),
    [anon_sym_ulong] = ACTIONS(2292),
    [anon_sym_ushort] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2292),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2294),
    [sym_null_literal] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_AT_DQUOTE] = ACTIONS(2294),
    [sym_identifier_name] = ACTIONS(2292),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_catch] = ACTIONS(2296),
    [anon_sym_finally] = ACTIONS(2292),
    [anon_sym_checked] = ACTIONS(2292),
    [anon_sym_unchecked] = ACTIONS(2292),
    [anon_sym_lock] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
  },
  [1168] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(986),
    [sym__embedded_statement] = STATE(986),
    [sym_empty_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym__selection_statement] = STATE(986),
    [sym__iteration_statement] = STATE(986),
    [sym__jump_statement] = STATE(986),
    [sym_try_statement] = STATE(986),
    [sym_checked_statement] = STATE(986),
    [sym_unchecked_statement] = STATE(986),
    [sym_lock_statement] = STATE(986),
    [sym_yield_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_throw_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1169] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1176),
    [sym__embedded_statement] = STATE(1176),
    [sym_empty_statement] = STATE(1176),
    [sym_expression_statement] = STATE(1176),
    [sym__selection_statement] = STATE(1176),
    [sym__iteration_statement] = STATE(1176),
    [sym__jump_statement] = STATE(1176),
    [sym_try_statement] = STATE(1176),
    [sym_checked_statement] = STATE(1176),
    [sym_unchecked_statement] = STATE(1176),
    [sym_lock_statement] = STATE(1176),
    [sym_yield_statement] = STATE(1176),
    [sym_if_statement] = STATE(1176),
    [sym_switch_statement] = STATE(1176),
    [sym_while_statement] = STATE(1176),
    [sym_do_statement] = STATE(1176),
    [sym_break_statement] = STATE(1176),
    [sym_continue_statement] = STATE(1176),
    [sym_return_statement] = STATE(1176),
    [sym_throw_statement] = STATE(1176),
    [sym_goto_statement] = STATE(1176),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2854),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2858),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1170] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(993),
    [sym__embedded_statement] = STATE(993),
    [sym_empty_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym__selection_statement] = STATE(993),
    [sym__iteration_statement] = STATE(993),
    [sym__jump_statement] = STATE(993),
    [sym_try_statement] = STATE(993),
    [sym_checked_statement] = STATE(993),
    [sym_unchecked_statement] = STATE(993),
    [sym_lock_statement] = STATE(993),
    [sym_yield_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_throw_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1171] = {
    [sym_comment] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2516),
  },
  [1172] = {
    [sym_statement_block] = STATE(1178),
    [anon_sym_LBRACE] = ACTIONS(419),
    [sym_comment] = ACTIONS(31),
  },
  [1173] = {
    [anon_sym_LPAREN] = ACTIONS(2863),
    [sym_comment] = ACTIONS(31),
  },
  [1174] = {
    [anon_sym_LPAREN] = ACTIONS(2865),
    [sym_comment] = ACTIONS(31),
  },
  [1175] = {
    [anon_sym_LPAREN] = ACTIONS(2867),
    [sym_comment] = ACTIONS(31),
  },
  [1176] = {
    [anon_sym_bool] = ACTIONS(2514),
    [anon_sym_byte] = ACTIONS(2514),
    [anon_sym_char] = ACTIONS(2514),
    [anon_sym_decimal] = ACTIONS(2514),
    [anon_sym_double] = ACTIONS(2514),
    [anon_sym_float] = ACTIONS(2514),
    [anon_sym_int] = ACTIONS(2514),
    [anon_sym_long] = ACTIONS(2514),
    [anon_sym_object] = ACTIONS(2514),
    [anon_sym_sbyte] = ACTIONS(2514),
    [anon_sym_short] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_uint] = ACTIONS(2514),
    [anon_sym_ulong] = ACTIONS(2514),
    [anon_sym_ushort] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_DOT] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_true] = ACTIONS(2514),
    [anon_sym_false] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2514),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2516),
    [sym_null_literal] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [sym_identifier_name] = ACTIONS(2514),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_checked] = ACTIONS(2514),
    [anon_sym_unchecked] = ACTIONS(2514),
    [anon_sym_lock] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_case] = ACTIONS(2514),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_goto] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
  },
  [1177] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1105),
    [sym__embedded_statement] = STATE(1105),
    [sym_empty_statement] = STATE(1105),
    [sym_expression_statement] = STATE(1105),
    [sym__selection_statement] = STATE(1105),
    [sym__iteration_statement] = STATE(1105),
    [sym__jump_statement] = STATE(1105),
    [sym_try_statement] = STATE(1105),
    [sym_checked_statement] = STATE(1105),
    [sym_unchecked_statement] = STATE(1105),
    [sym_lock_statement] = STATE(1105),
    [sym_yield_statement] = STATE(1105),
    [sym_if_statement] = STATE(1105),
    [sym_switch_statement] = STATE(1105),
    [sym_while_statement] = STATE(1105),
    [sym_do_statement] = STATE(1105),
    [sym_break_statement] = STATE(1105),
    [sym_continue_statement] = STATE(1105),
    [sym_return_statement] = STATE(1105),
    [sym_throw_statement] = STATE(1105),
    [sym_goto_statement] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2533),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2535),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2539),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1178] = {
    [sym_catch_clause] = STATE(1183),
    [sym_finally_clause] = STATE(740),
    [aux_sym_try_statement_repeat1] = STATE(1183),
    [anon_sym_bool] = ACTIONS(1543),
    [anon_sym_byte] = ACTIONS(1543),
    [anon_sym_char] = ACTIONS(1543),
    [anon_sym_decimal] = ACTIONS(1543),
    [anon_sym_double] = ACTIONS(1543),
    [anon_sym_float] = ACTIONS(1543),
    [anon_sym_int] = ACTIONS(1543),
    [anon_sym_long] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [anon_sym_sbyte] = ACTIONS(1543),
    [anon_sym_short] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_uint] = ACTIONS(1543),
    [anon_sym_ulong] = ACTIONS(1543),
    [anon_sym_ushort] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_DOT] = ACTIONS(1545),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(1543),
    [anon_sym_false] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(1543),
    [anon_sym_typeof] = ACTIONS(1543),
    [anon_sym_sizeof] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1545),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(1543),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(1545),
    [sym_null_literal] = ACTIONS(1543),
    [anon_sym_DQUOTE] = ACTIONS(1545),
    [anon_sym_AT_DQUOTE] = ACTIONS(1545),
    [sym_identifier_name] = ACTIONS(1543),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(1543),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(1543),
    [anon_sym_unchecked] = ACTIONS(1543),
    [anon_sym_lock] = ACTIONS(1543),
    [anon_sym_yield] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1543),
    [anon_sym_break] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_else] = ACTIONS(1543),
    [anon_sym_switch] = ACTIONS(1543),
    [anon_sym_case] = ACTIONS(1543),
    [anon_sym_default] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_do] = ACTIONS(1543),
    [anon_sym_continue] = ACTIONS(1543),
    [anon_sym_throw] = ACTIONS(1543),
    [anon_sym_goto] = ACTIONS(1543),
    [anon_sym_var] = ACTIONS(1543),
  },
  [1179] = {
    [sym__expression] = STATE(1184),
    [sym_parenthesized_expression] = STATE(1184),
    [sym_ternary_expression] = STATE(1184),
    [sym_binary_expression] = STATE(1184),
    [sym_unary_expression] = STATE(1184),
    [sym__literal] = STATE(1184),
    [sym_boolean_literal] = STATE(1184),
    [sym_character_literal] = STATE(1184),
    [sym_integer_literal] = STATE(1184),
    [sym_real_literal] = STATE(1184),
    [sym_string_literal] = STATE(1184),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(2871),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(2871),
    [sym_comment] = ACTIONS(31),
  },
  [1180] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1185),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1181] = {
    [sym__expression] = STATE(746),
    [sym_boolean_expression] = STATE(1186),
    [sym_parenthesized_expression] = STATE(746),
    [sym_ternary_expression] = STATE(746),
    [sym_binary_expression] = STATE(746),
    [sym_unary_expression] = STATE(746),
    [sym__literal] = STATE(746),
    [sym_boolean_literal] = STATE(746),
    [sym_character_literal] = STATE(746),
    [sym_integer_literal] = STATE(746),
    [sym_real_literal] = STATE(746),
    [sym_string_literal] = STATE(746),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(1066),
    [anon_sym_sizeof] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(1575),
    [sym_comment] = ACTIONS(31),
  },
  [1182] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1105),
    [sym__embedded_statement] = STATE(1105),
    [sym_empty_statement] = STATE(1105),
    [sym_expression_statement] = STATE(1105),
    [sym__selection_statement] = STATE(1105),
    [sym__iteration_statement] = STATE(1105),
    [sym__jump_statement] = STATE(1105),
    [sym_try_statement] = STATE(1105),
    [sym_checked_statement] = STATE(1105),
    [sym_unchecked_statement] = STATE(1105),
    [sym_lock_statement] = STATE(1105),
    [sym_yield_statement] = STATE(1105),
    [sym_if_statement] = STATE(1105),
    [sym_switch_statement] = STATE(1105),
    [sym_while_statement] = STATE(1105),
    [sym_do_statement] = STATE(1105),
    [sym_break_statement] = STATE(1105),
    [sym_continue_statement] = STATE(1105),
    [sym_return_statement] = STATE(1105),
    [sym_throw_statement] = STATE(1105),
    [sym_goto_statement] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2647),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2655),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1183] = {
    [sym_catch_clause] = STATE(1187),
    [sym_finally_clause] = STATE(888),
    [aux_sym_try_statement_repeat1] = STATE(1187),
    [anon_sym_bool] = ACTIONS(2035),
    [anon_sym_byte] = ACTIONS(2035),
    [anon_sym_char] = ACTIONS(2035),
    [anon_sym_decimal] = ACTIONS(2035),
    [anon_sym_double] = ACTIONS(2035),
    [anon_sym_float] = ACTIONS(2035),
    [anon_sym_int] = ACTIONS(2035),
    [anon_sym_long] = ACTIONS(2035),
    [anon_sym_object] = ACTIONS(2035),
    [anon_sym_sbyte] = ACTIONS(2035),
    [anon_sym_short] = ACTIONS(2035),
    [anon_sym_string] = ACTIONS(2035),
    [anon_sym_uint] = ACTIONS(2035),
    [anon_sym_ulong] = ACTIONS(2035),
    [anon_sym_ushort] = ACTIONS(2035),
    [anon_sym_SEMI] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(2037),
    [anon_sym_PLUS] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_BANG] = ACTIONS(2037),
    [anon_sym_TILDE] = ACTIONS(2037),
    [anon_sym_PLUS_PLUS] = ACTIONS(2037),
    [anon_sym_DASH_DASH] = ACTIONS(2037),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [anon_sym_const] = ACTIONS(2035),
    [anon_sym_typeof] = ACTIONS(2035),
    [anon_sym_sizeof] = ACTIONS(2035),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2035),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2037),
    [sym_null_literal] = ACTIONS(2035),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [anon_sym_AT_DQUOTE] = ACTIONS(2037),
    [sym_identifier_name] = ACTIONS(2035),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2035),
    [anon_sym_catch] = ACTIONS(1547),
    [anon_sym_finally] = ACTIONS(1549),
    [anon_sym_checked] = ACTIONS(2035),
    [anon_sym_unchecked] = ACTIONS(2035),
    [anon_sym_lock] = ACTIONS(2035),
    [anon_sym_yield] = ACTIONS(2035),
    [anon_sym_return] = ACTIONS(2035),
    [anon_sym_break] = ACTIONS(2035),
    [anon_sym_if] = ACTIONS(2035),
    [anon_sym_else] = ACTIONS(2035),
    [anon_sym_switch] = ACTIONS(2035),
    [anon_sym_case] = ACTIONS(2035),
    [anon_sym_default] = ACTIONS(2035),
    [anon_sym_while] = ACTIONS(2035),
    [anon_sym_do] = ACTIONS(2035),
    [anon_sym_continue] = ACTIONS(2035),
    [anon_sym_throw] = ACTIONS(2035),
    [anon_sym_goto] = ACTIONS(2035),
    [anon_sym_var] = ACTIONS(2035),
  },
  [1184] = {
    [anon_sym_LT] = ACTIONS(1457),
    [anon_sym_GT] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(2873),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_SLASH] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_CARET] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_LT_LT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_GT_EQ] = ACTIONS(1477),
    [anon_sym_LT_EQ] = ACTIONS(1477),
    [anon_sym_QMARK] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1483),
    [sym_comment] = ACTIONS(31),
  },
  [1185] = {
    [anon_sym_RPAREN] = ACTIONS(2875),
    [sym_comment] = ACTIONS(31),
  },
  [1186] = {
    [anon_sym_RPAREN] = ACTIONS(2877),
    [sym_comment] = ACTIONS(31),
  },
  [1187] = {
    [sym_catch_clause] = STATE(1187),
    [aux_sym_try_statement_repeat1] = STATE(1187),
    [anon_sym_bool] = ACTIONS(2292),
    [anon_sym_byte] = ACTIONS(2292),
    [anon_sym_char] = ACTIONS(2292),
    [anon_sym_decimal] = ACTIONS(2292),
    [anon_sym_double] = ACTIONS(2292),
    [anon_sym_float] = ACTIONS(2292),
    [anon_sym_int] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_sbyte] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_uint] = ACTIONS(2292),
    [anon_sym_ulong] = ACTIONS(2292),
    [anon_sym_ushort] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2292),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2294),
    [sym_null_literal] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_AT_DQUOTE] = ACTIONS(2294),
    [sym_identifier_name] = ACTIONS(2292),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_catch] = ACTIONS(2296),
    [anon_sym_finally] = ACTIONS(2292),
    [anon_sym_checked] = ACTIONS(2292),
    [anon_sym_unchecked] = ACTIONS(2292),
    [anon_sym_lock] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
  },
  [1188] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(986),
    [sym__embedded_statement] = STATE(986),
    [sym_empty_statement] = STATE(986),
    [sym_expression_statement] = STATE(986),
    [sym__selection_statement] = STATE(986),
    [sym__iteration_statement] = STATE(986),
    [sym__jump_statement] = STATE(986),
    [sym_try_statement] = STATE(986),
    [sym_checked_statement] = STATE(986),
    [sym_unchecked_statement] = STATE(986),
    [sym_lock_statement] = STATE(986),
    [sym_yield_statement] = STATE(986),
    [sym_if_statement] = STATE(986),
    [sym_switch_statement] = STATE(986),
    [sym_while_statement] = STATE(986),
    [sym_do_statement] = STATE(986),
    [sym_break_statement] = STATE(986),
    [sym_continue_statement] = STATE(986),
    [sym_return_statement] = STATE(986),
    [sym_throw_statement] = STATE(986),
    [sym_goto_statement] = STATE(986),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2854),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2858),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1189] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1191),
    [sym__embedded_statement] = STATE(1191),
    [sym_empty_statement] = STATE(1191),
    [sym_expression_statement] = STATE(1191),
    [sym__selection_statement] = STATE(1191),
    [sym__iteration_statement] = STATE(1191),
    [sym__jump_statement] = STATE(1191),
    [sym_try_statement] = STATE(1191),
    [sym_checked_statement] = STATE(1191),
    [sym_unchecked_statement] = STATE(1191),
    [sym_lock_statement] = STATE(1191),
    [sym_yield_statement] = STATE(1191),
    [sym_if_statement] = STATE(1191),
    [sym_switch_statement] = STATE(1191),
    [sym_while_statement] = STATE(1191),
    [sym_do_statement] = STATE(1191),
    [sym_break_statement] = STATE(1191),
    [sym_continue_statement] = STATE(1191),
    [sym_return_statement] = STATE(1191),
    [sym_throw_statement] = STATE(1191),
    [sym_goto_statement] = STATE(1191),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2854),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2858),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1190] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(993),
    [sym__embedded_statement] = STATE(993),
    [sym_empty_statement] = STATE(993),
    [sym_expression_statement] = STATE(993),
    [sym__selection_statement] = STATE(993),
    [sym__iteration_statement] = STATE(993),
    [sym__jump_statement] = STATE(993),
    [sym_try_statement] = STATE(993),
    [sym_checked_statement] = STATE(993),
    [sym_unchecked_statement] = STATE(993),
    [sym_lock_statement] = STATE(993),
    [sym_yield_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_switch_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_do_statement] = STATE(993),
    [sym_break_statement] = STATE(993),
    [sym_continue_statement] = STATE(993),
    [sym_return_statement] = STATE(993),
    [sym_throw_statement] = STATE(993),
    [sym_goto_statement] = STATE(993),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2854),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2858),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
  [1191] = {
    [anon_sym_bool] = ACTIONS(2514),
    [anon_sym_byte] = ACTIONS(2514),
    [anon_sym_char] = ACTIONS(2514),
    [anon_sym_decimal] = ACTIONS(2514),
    [anon_sym_double] = ACTIONS(2514),
    [anon_sym_float] = ACTIONS(2514),
    [anon_sym_int] = ACTIONS(2514),
    [anon_sym_long] = ACTIONS(2514),
    [anon_sym_object] = ACTIONS(2514),
    [anon_sym_sbyte] = ACTIONS(2514),
    [anon_sym_short] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_uint] = ACTIONS(2514),
    [anon_sym_ulong] = ACTIONS(2514),
    [anon_sym_ushort] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_DOT] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_true] = ACTIONS(2514),
    [anon_sym_false] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(2514),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(2516),
    [sym_null_literal] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_AT_DQUOTE] = ACTIONS(2516),
    [sym_identifier_name] = ACTIONS(2514),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_checked] = ACTIONS(2514),
    [anon_sym_unchecked] = ACTIONS(2514),
    [anon_sym_lock] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_case] = ACTIONS(2514),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_goto] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
  },
  [1192] = {
    [sym__expression] = STATE(386),
    [sym_parenthesized_expression] = STATE(386),
    [sym_ternary_expression] = STATE(386),
    [sym_binary_expression] = STATE(386),
    [sym_unary_expression] = STATE(386),
    [sym__literal] = STATE(386),
    [sym_boolean_literal] = STATE(386),
    [sym_character_literal] = STATE(386),
    [sym_integer_literal] = STATE(386),
    [sym_real_literal] = STATE(386),
    [sym_string_literal] = STATE(386),
    [sym__regular_string_literal] = STATE(367),
    [sym__verbatim_string_literal] = STATE(367),
    [sym_statement_block] = STATE(1105),
    [sym__embedded_statement] = STATE(1105),
    [sym_empty_statement] = STATE(1105),
    [sym_expression_statement] = STATE(1105),
    [sym__selection_statement] = STATE(1105),
    [sym__iteration_statement] = STATE(1105),
    [sym__jump_statement] = STATE(1105),
    [sym_try_statement] = STATE(1105),
    [sym_checked_statement] = STATE(1105),
    [sym_unchecked_statement] = STATE(1105),
    [sym_lock_statement] = STATE(1105),
    [sym_yield_statement] = STATE(1105),
    [sym_if_statement] = STATE(1105),
    [sym_switch_statement] = STATE(1105),
    [sym_while_statement] = STATE(1105),
    [sym_do_statement] = STATE(1105),
    [sym_break_statement] = STATE(1105),
    [sym_continue_statement] = STATE(1105),
    [sym_return_statement] = STATE(1105),
    [sym_throw_statement] = STATE(1105),
    [sym_goto_statement] = STATE(1105),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(655),
    [anon_sym_DOT] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(663),
    [anon_sym_false] = ACTIONS(663),
    [anon_sym_typeof] = ACTIONS(659),
    [anon_sym_sizeof] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(665),
    [aux_sym_SLASH_LBRACK0_DASH9_RBRACK_PLUS_SLASH] = ACTIONS(667),
    [aux_sym_SLASH0x_LBRACK0_DASH9a_DASHfA_DASHF_RBRACK_PLUS_SLASH] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_DQUOTE] = ACTIONS(673),
    [anon_sym_AT_DQUOTE] = ACTIONS(675),
    [sym_identifier_name] = ACTIONS(691),
    [sym_comment] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_checked] = ACTIONS(697),
    [anon_sym_unchecked] = ACTIONS(699),
    [anon_sym_lock] = ACTIONS(2854),
    [anon_sym_yield] = ACTIONS(703),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(707),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(2858),
    [anon_sym_do] = ACTIONS(715),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(719),
    [anon_sym_goto] = ACTIONS(721),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_compilation_unit, 0),
  [7] = {.count = 1, .reusable = true}, SHIFT(2),
  [9] = {.count = 1, .reusable = true}, SHIFT(20),
  [11] = {.count = 1, .reusable = true}, SHIFT(3),
  [13] = {.count = 1, .reusable = true}, SHIFT(4),
  [15] = {.count = 1, .reusable = true}, SHIFT(5),
  [17] = {.count = 1, .reusable = true}, SHIFT(6),
  [19] = {.count = 1, .reusable = true}, SHIFT(7),
  [21] = {.count = 1, .reusable = true}, SHIFT(8),
  [23] = {.count = 1, .reusable = true}, SHIFT(9),
  [25] = {.count = 1, .reusable = true}, SHIFT(10),
  [27] = {.count = 1, .reusable = true}, SHIFT(11),
  [29] = {.count = 1, .reusable = true}, SHIFT(12),
  [31] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [33] = {.count = 1, .reusable = true}, REDUCE(sym_compilation_unit, 1),
  [35] = {.count = 1, .reusable = true}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [37] = {.count = 1, .reusable = true}, SHIFT(26),
  [39] = {.count = 1, .reusable = false}, SHIFT(27),
  [41] = {.count = 1, .reusable = false}, SHIFT(28),
  [43] = {.count = 1, .reusable = false}, SHIFT(29),
  [45] = {.count = 1, .reusable = false}, SHIFT(32),
  [47] = {.count = 1, .reusable = true}, SHIFT(33),
  [49] = {.count = 1, .reusable = true}, SHIFT(34),
  [51] = {.count = 1, .reusable = true}, SHIFT(35),
  [53] = {.count = 1, .reusable = true}, SHIFT(36),
  [55] = {.count = 1, .reusable = true}, SHIFT(37),
  [57] = {.count = 1, .reusable = false}, SHIFT(38),
  [59] = {.count = 1, .reusable = false}, SHIFT(39),
  [61] = {.count = 1, .reusable = true}, SHIFT(42),
  [63] = {.count = 1, .reusable = true}, SHIFT(43),
  [65] = {.count = 1, .reusable = false}, SHIFT(44),
  [67] = {.count = 1, .reusable = false}, SHIFT(45),
  [69] = {.count = 1, .reusable = false}, SHIFT(46),
  [71] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [73] = {.count = 1, .reusable = true}, SHIFT(47),
  [75] = {.count = 1, .reusable = true}, SHIFT(48),
  [77] = {.count = 1, .reusable = true}, SHIFT(49),
  [79] = {.count = 1, .reusable = true}, SHIFT(54),
  [81] = {.count = 1, .reusable = true}, SHIFT(56),
  [83] = {.count = 1, .reusable = true}, REDUCE(sym_modifiers, 1),
  [85] = {.count = 1, .reusable = true}, REDUCE(sym__attributes, 1),
  [87] = {.count = 1, .reusable = true}, REDUCE(sym_compilation_unit, 2),
  [89] = {.count = 1, .reusable = true}, SHIFT(61),
  [91] = {.count = 1, .reusable = false}, SHIFT(62),
  [93] = {.count = 1, .reusable = true}, SHIFT(63),
  [95] = {.count = 1, .reusable = true}, SHIFT(64),
  [97] = {.count = 1, .reusable = true}, SHIFT(65),
  [99] = {.count = 1, .reusable = true}, SHIFT(66),
  [101] = {.count = 1, .reusable = true}, SHIFT(67),
  [103] = {.count = 1, .reusable = true}, SHIFT(68),
  [105] = {.count = 1, .reusable = true}, SHIFT(69),
  [107] = {.count = 1, .reusable = true}, SHIFT(70),
  [109] = {.count = 1, .reusable = true}, SHIFT(71),
  [111] = {.count = 1, .reusable = true}, SHIFT(72),
  [113] = {.count = 1, .reusable = true}, SHIFT(73),
  [115] = {.count = 1, .reusable = true}, SHIFT(74),
  [117] = {.count = 1, .reusable = true}, SHIFT(78),
  [119] = {.count = 1, .reusable = true}, SHIFT(79),
  [121] = {.count = 1, .reusable = true}, SHIFT(83),
  [123] = {.count = 1, .reusable = true}, REDUCE(sym_attribute, 1),
  [125] = {.count = 1, .reusable = true}, SHIFT(84),
  [127] = {.count = 1, .reusable = true}, SHIFT(86),
  [129] = {.count = 1, .reusable = true}, SHIFT(87),
  [131] = {.count = 1, .reusable = true}, REDUCE(sym_attribute_list, 1),
  [133] = {.count = 1, .reusable = true}, SHIFT(89),
  [135] = {.count = 1, .reusable = true}, SHIFT(90),
  [137] = {.count = 1, .reusable = true}, SHIFT(94),
  [139] = {.count = 1, .reusable = true}, SHIFT(95),
  [141] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [143] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [145] = {.count = 1, .reusable = true}, SHIFT(96),
  [147] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [149] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [151] = {.count = 1, .reusable = true}, SHIFT(98),
  [153] = {.count = 1, .reusable = true}, SHIFT(99),
  [155] = {.count = 1, .reusable = true}, SHIFT(100),
  [157] = {.count = 1, .reusable = true}, SHIFT(101),
  [159] = {.count = 1, .reusable = false}, SHIFT(102),
  [161] = {.count = 1, .reusable = true}, SHIFT(103),
  [163] = {.count = 1, .reusable = true}, SHIFT(104),
  [165] = {.count = 1, .reusable = true}, SHIFT(105),
  [167] = {.count = 1, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat1, 2),
  [169] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat1, 2), SHIFT_REPEAT(106),
  [172] = {.count = 1, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat2, 2),
  [174] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat2, 2), SHIFT_REPEAT(4),
  [177] = {.count = 1, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat3, 2),
  [179] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat3, 2), SHIFT_REPEAT(107),
  [182] = {.count = 1, .reusable = true}, SHIFT(39),
  [184] = {.count = 1, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2),
  [186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(20),
  [189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(5),
  [192] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6),
  [195] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(7),
  [198] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(8),
  [201] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(54),
  [204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(10),
  [207] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(11),
  [210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(12),
  [213] = {.count = 2, .reusable = true}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(56),
  [216] = {.count = 1, .reusable = true}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [218] = {.count = 1, .reusable = true}, REDUCE(aux_sym__attributes_repeat1, 2),
  [220] = {.count = 2, .reusable = true}, REDUCE(aux_sym__attributes_repeat1, 2), SHIFT_REPEAT(54),
  [223] = {.count = 1, .reusable = true}, REDUCE(sym_compilation_unit, 3),
  [225] = {.count = 1, .reusable = true}, SHIFT(110),
  [227] = {.count = 1, .reusable = true}, SHIFT(111),
  [229] = {.count = 1, .reusable = true}, SHIFT(112),
  [231] = {.count = 1, .reusable = true}, REDUCE(sym_using_directive, 3),
  [233] = {.count = 1, .reusable = false}, REDUCE(sym_name_equals, 2),
  [235] = {.count = 1, .reusable = true}, SHIFT(113),
  [237] = {.count = 1, .reusable = true}, SHIFT(114),
  [239] = {.count = 1, .reusable = true}, SHIFT(116),
  [241] = {.count = 1, .reusable = true}, SHIFT(120),
  [243] = {.count = 1, .reusable = true}, SHIFT(124),
  [245] = {.count = 1, .reusable = false}, SHIFT(146),
  [247] = {.count = 1, .reusable = false}, SHIFT(130),
  [249] = {.count = 1, .reusable = true}, SHIFT(131),
  [251] = {.count = 1, .reusable = false}, SHIFT(132),
  [253] = {.count = 1, .reusable = false}, SHIFT(7),
  [255] = {.count = 1, .reusable = false}, SHIFT(8),
  [257] = {.count = 1, .reusable = false}, SHIFT(133),
  [259] = {.count = 1, .reusable = true}, SHIFT(134),
  [261] = {.count = 1, .reusable = false}, SHIFT(135),
  [263] = {.count = 1, .reusable = false}, SHIFT(10),
  [265] = {.count = 1, .reusable = false}, SHIFT(11),
  [267] = {.count = 1, .reusable = false}, SHIFT(12),
  [269] = {.count = 1, .reusable = false}, SHIFT(136),
  [271] = {.count = 1, .reusable = false}, SHIFT(137),
  [273] = {.count = 1, .reusable = false}, SHIFT(138),
  [275] = {.count = 1, .reusable = false}, SHIFT(149),
  [277] = {.count = 1, .reusable = true}, SHIFT(150),
  [279] = {.count = 1, .reusable = true}, SHIFT(152),
  [281] = {.count = 1, .reusable = true}, SHIFT(156),
  [283] = {.count = 1, .reusable = true}, SHIFT(158),
  [285] = {.count = 1, .reusable = true}, REDUCE(sym_attribute, 2),
  [287] = {.count = 1, .reusable = false}, REDUCE(sym__attribute_section, 3),
  [289] = {.count = 1, .reusable = true}, REDUCE(sym__attribute_section, 3),
  [291] = {.count = 1, .reusable = true}, REDUCE(sym_attribute_list, 2),
  [293] = {.count = 1, .reusable = false}, SHIFT(161),
  [295] = {.count = 1, .reusable = true}, SHIFT(162),
  [297] = {.count = 1, .reusable = false}, SHIFT(163),
  [299] = {.count = 1, .reusable = false}, SHIFT(164),
  [301] = {.count = 1, .reusable = true}, SHIFT(169),
  [303] = {.count = 1, .reusable = true}, SHIFT(170),
  [305] = {.count = 1, .reusable = true}, SHIFT(174),
  [307] = {.count = 1, .reusable = true}, SHIFT(175),
  [309] = {.count = 1, .reusable = true}, REDUCE(sym_generic_name, 2),
  [311] = {.count = 1, .reusable = false}, REDUCE(sym_generic_name, 2),
  [313] = {.count = 1, .reusable = true}, SHIFT(177),
  [315] = {.count = 1, .reusable = true}, SHIFT(178),
  [317] = {.count = 1, .reusable = true}, SHIFT(179),
  [319] = {.count = 1, .reusable = true}, SHIFT(180),
  [321] = {.count = 1, .reusable = true}, SHIFT(181),
  [323] = {.count = 1, .reusable = true}, SHIFT(182),
  [325] = {.count = 1, .reusable = true}, SHIFT(183),
  [327] = {.count = 1, .reusable = true}, SHIFT(184),
  [329] = {.count = 1, .reusable = true}, SHIFT(185),
  [331] = {.count = 1, .reusable = true}, SHIFT(186),
  [333] = {.count = 1, .reusable = false}, SHIFT(187),
  [335] = {.count = 1, .reusable = true}, SHIFT(38),
  [337] = {.count = 1, .reusable = true}, REDUCE(sym_compilation_unit, 4),
  [339] = {.count = 1, .reusable = true}, REDUCE(sym_extern_alias_directive, 4),
  [341] = {.count = 1, .reusable = true}, REDUCE(sym_using_directive, 4),
  [343] = {.count = 1, .reusable = true}, REDUCE(sym_alias_qualified_name, 3),
  [345] = {.count = 1, .reusable = true}, REDUCE(sym_qualified_name, 3),
  [347] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_declaration, 4),
  [349] = {.count = 1, .reusable = true}, SHIFT(189),
  [351] = {.count = 1, .reusable = true}, SHIFT(190),
  [353] = {.count = 1, .reusable = true}, SHIFT(192),
  [355] = {.count = 1, .reusable = true}, SHIFT(194),
  [357] = {.count = 1, .reusable = true}, SHIFT(197),
  [359] = {.count = 1, .reusable = true}, SHIFT(199),
  [361] = {.count = 1, .reusable = true}, SHIFT(202),
  [363] = {.count = 1, .reusable = true}, SHIFT(204),
  [365] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1),
  [367] = {.count = 1, .reusable = true}, SHIFT(207),
  [369] = {.count = 1, .reusable = true}, SHIFT(208),
  [371] = {.count = 1, .reusable = false}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [373] = {.count = 1, .reusable = true}, SHIFT(210),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4),
  [377] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4),
  [379] = {.count = 1, .reusable = true}, SHIFT(211),
  [381] = {.count = 1, .reusable = false}, SHIFT(33),
  [383] = {.count = 1, .reusable = false}, SHIFT(34),
  [385] = {.count = 1, .reusable = false}, SHIFT(35),
  [387] = {.count = 1, .reusable = false}, SHIFT(212),
  [389] = {.count = 1, .reusable = true}, SHIFT(214),
  [391] = {.count = 1, .reusable = true}, REDUCE(sym_overloadable_conversion_operator, 1),
  [393] = {.count = 1, .reusable = true}, SHIFT(215),
  [395] = {.count = 1, .reusable = false}, SHIFT(219),
  [397] = {.count = 1, .reusable = false}, SHIFT(220),
  [399] = {.count = 1, .reusable = false}, SHIFT(221),
  [401] = {.count = 1, .reusable = false}, SHIFT(223),
  [403] = {.count = 1, .reusable = false}, SHIFT(224),
  [405] = {.count = 1, .reusable = false}, SHIFT(48),
  [407] = {.count = 1, .reusable = false}, SHIFT(49),
  [409] = {.count = 1, .reusable = false}, SHIFT(225),
  [411] = {.count = 1, .reusable = false}, SHIFT(226),
  [413] = {.count = 1, .reusable = true}, SHIFT(231),
  [415] = {.count = 1, .reusable = true}, SHIFT(232),
  [417] = {.count = 1, .reusable = true}, SHIFT(234),
  [419] = {.count = 1, .reusable = true}, SHIFT(235),
  [421] = {.count = 1, .reusable = true}, SHIFT(236),
  [423] = {.count = 1, .reusable = true}, SHIFT(237),
  [425] = {.count = 1, .reusable = false}, SHIFT(238),
  [427] = {.count = 1, .reusable = true}, SHIFT(240),
  [429] = {.count = 1, .reusable = false}, REDUCE(sym_modifiers, 1),
  [431] = {.count = 1, .reusable = false}, SHIFT(241),
  [433] = {.count = 1, .reusable = false}, REDUCE(sym__attributes, 1),
  [435] = {.count = 1, .reusable = true}, REDUCE(sym_class_base, 2),
  [437] = {.count = 1, .reusable = true}, SHIFT(244),
  [439] = {.count = 1, .reusable = true}, SHIFT(245),
  [441] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_declaration_repeat1, 2),
  [443] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_declaration_repeat1, 2), SHIFT_REPEAT(74),
  [446] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 4),
  [448] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 4),
  [450] = {.count = 1, .reusable = true}, SHIFT(246),
  [452] = {.count = 1, .reusable = true}, SHIFT(249),
  [454] = {.count = 1, .reusable = true}, REDUCE(sym_struct_interfaces, 2),
  [456] = {.count = 1, .reusable = true}, SHIFT(251),
  [458] = {.count = 1, .reusable = true}, REDUCE(sym_attribute_argument_list, 2),
  [460] = {.count = 1, .reusable = true}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [462] = {.count = 2, .reusable = true}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(87),
  [465] = {.count = 1, .reusable = false}, SHIFT(252),
  [467] = {.count = 1, .reusable = false}, SHIFT(253),
  [469] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4),
  [471] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4),
  [473] = {.count = 1, .reusable = true}, SHIFT(255),
  [475] = {.count = 1, .reusable = true}, SHIFT(257),
  [477] = {.count = 1, .reusable = false}, SHIFT(258),
  [479] = {.count = 1, .reusable = false}, SHIFT(259),
  [481] = {.count = 1, .reusable = false}, SHIFT(260),
  [483] = {.count = 1, .reusable = true}, SHIFT(263),
  [485] = {.count = 1, .reusable = true}, REDUCE(sym_interface_base, 2),
  [487] = {.count = 1, .reusable = true}, REDUCE(sym_enum_member_declaration, 1),
  [489] = {.count = 1, .reusable = true}, SHIFT(264),
  [491] = {.count = 1, .reusable = true}, SHIFT(265),
  [493] = {.count = 1, .reusable = true}, SHIFT(266),
  [495] = {.count = 1, .reusable = true}, SHIFT(268),
  [497] = {.count = 1, .reusable = true}, SHIFT(270),
  [499] = {.count = 1, .reusable = true}, SHIFT(271),
  [501] = {.count = 1, .reusable = false}, SHIFT(272),
  [503] = {.count = 1, .reusable = true}, SHIFT(273),
  [505] = {.count = 1, .reusable = false}, SHIFT(274),
  [507] = {.count = 1, .reusable = true}, SHIFT(281),
  [509] = {.count = 1, .reusable = true}, SHIFT(286),
  [511] = {.count = 1, .reusable = true}, SHIFT(288),
  [513] = {.count = 1, .reusable = true}, SHIFT(289),
  [515] = {.count = 1, .reusable = true}, SHIFT(290),
  [517] = {.count = 1, .reusable = true}, SHIFT(291),
  [519] = {.count = 1, .reusable = true}, SHIFT(292),
  [521] = {.count = 1, .reusable = true}, REDUCE(sym_compilation_unit, 5),
  [523] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_declaration, 5),
  [525] = {.count = 1, .reusable = true}, SHIFT(293),
  [527] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(20),
  [530] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(4),
  [533] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(5),
  [536] = {.count = 1, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2),
  [538] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(6),
  [541] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(7),
  [544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(8),
  [547] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(54),
  [550] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(10),
  [553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(11),
  [556] = {.count = 2, .reusable = true}, REDUCE(aux_sym_namespace_declaration_repeat1, 2), SHIFT_REPEAT(12),
  [559] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5),
  [561] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5),
  [563] = {.count = 1, .reusable = true}, SHIFT(294),
  [565] = {.count = 1, .reusable = true}, SHIFT(295),
  [567] = {.count = 1, .reusable = true}, SHIFT(297),
  [569] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 5),
  [571] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 5),
  [573] = {.count = 1, .reusable = true}, SHIFT(299),
  [575] = {.count = 1, .reusable = true}, SHIFT(300),
  [577] = {.count = 1, .reusable = true}, SHIFT(302),
  [579] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5),
  [581] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5),
  [583] = {.count = 1, .reusable = true}, SHIFT(304),
  [585] = {.count = 1, .reusable = true}, SHIFT(305),
  [587] = {.count = 1, .reusable = true}, SHIFT(307),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_list, 3),
  [591] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameter_list, 3),
  [593] = {.count = 1, .reusable = true}, SHIFT(310),
  [595] = {.count = 1, .reusable = true}, SHIFT(312),
  [597] = {.count = 1, .reusable = true}, SHIFT(313),
  [599] = {.count = 1, .reusable = true}, SHIFT(314),
  [601] = {.count = 1, .reusable = true}, SHIFT(318),
  [603] = {.count = 1, .reusable = true}, SHIFT(323),
  [605] = {.count = 1, .reusable = false}, SHIFT(324),
  [607] = {.count = 1, .reusable = false}, SHIFT(325),
  [609] = {.count = 1, .reusable = false}, SHIFT(326),
  [611] = {.count = 1, .reusable = true}, SHIFT(326),
  [613] = {.count = 1, .reusable = true}, SHIFT(324),
  [615] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1),
  [617] = {.count = 1, .reusable = false}, SHIFT(329),
  [619] = {.count = 1, .reusable = true}, SHIFT(330),
  [621] = {.count = 1, .reusable = true}, SHIFT(331),
  [623] = {.count = 1, .reusable = true}, SHIFT(332),
  [625] = {.count = 1, .reusable = true}, SHIFT(335),
  [627] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 2),
  [629] = {.count = 1, .reusable = false}, SHIFT(98),
  [631] = {.count = 1, .reusable = false}, SHIFT(99),
  [633] = {.count = 1, .reusable = false}, SHIFT(100),
  [635] = {.count = 1, .reusable = false}, SHIFT(337),
  [637] = {.count = 1, .reusable = false}, SHIFT(341),
  [639] = {.count = 1, .reusable = true}, SHIFT(343),
  [641] = {.count = 1, .reusable = true}, SHIFT(344),
  [643] = {.count = 1, .reusable = true}, SHIFT(345),
  [645] = {.count = 1, .reusable = true}, SHIFT(346),
  [647] = {.count = 1, .reusable = true}, SHIFT(347),
  [649] = {.count = 1, .reusable = true}, SHIFT(348),
  [651] = {.count = 1, .reusable = true}, SHIFT(349),
  [653] = {.count = 1, .reusable = true}, SHIFT(350),
  [655] = {.count = 1, .reusable = true}, SHIFT(357),
  [657] = {.count = 1, .reusable = true}, SHIFT(358),
  [659] = {.count = 1, .reusable = false}, SHIFT(359),
  [661] = {.count = 1, .reusable = true}, SHIFT(359),
  [663] = {.count = 1, .reusable = false}, SHIFT(360),
  [665] = {.count = 1, .reusable = true}, SHIFT(361),
  [667] = {.count = 1, .reusable = false}, SHIFT(362),
  [669] = {.count = 1, .reusable = true}, SHIFT(363),
  [671] = {.count = 1, .reusable = false}, SHIFT(366),
  [673] = {.count = 1, .reusable = true}, SHIFT(364),
  [675] = {.count = 1, .reusable = true}, SHIFT(365),
  [677] = {.count = 1, .reusable = false}, REDUCE(sym_indexer_declaration, 2),
  [679] = {.count = 1, .reusable = true}, REDUCE(sym_indexer_declaration, 2),
  [681] = {.count = 1, .reusable = false}, REDUCE(sym_operator_declaration, 2),
  [683] = {.count = 1, .reusable = true}, REDUCE(sym_operator_declaration, 2),
  [685] = {.count = 1, .reusable = true}, SHIFT(368),
  [687] = {.count = 1, .reusable = true}, SHIFT(369),
  [689] = {.count = 1, .reusable = false}, SHIFT(370),
  [691] = {.count = 1, .reusable = false}, SHIFT(386),
  [693] = {.count = 1, .reusable = false}, SHIFT(371),
  [695] = {.count = 1, .reusable = false}, SHIFT(372),
  [697] = {.count = 1, .reusable = false}, SHIFT(373),
  [699] = {.count = 1, .reusable = false}, SHIFT(374),
  [701] = {.count = 1, .reusable = false}, SHIFT(375),
  [703] = {.count = 1, .reusable = false}, SHIFT(376),
  [705] = {.count = 1, .reusable = false}, SHIFT(377),
  [707] = {.count = 1, .reusable = false}, SHIFT(378),
  [709] = {.count = 1, .reusable = false}, SHIFT(379),
  [711] = {.count = 1, .reusable = false}, SHIFT(380),
  [713] = {.count = 1, .reusable = false}, SHIFT(381),
  [715] = {.count = 1, .reusable = false}, SHIFT(382),
  [717] = {.count = 1, .reusable = false}, SHIFT(383),
  [719] = {.count = 1, .reusable = false}, SHIFT(384),
  [721] = {.count = 1, .reusable = false}, SHIFT(385),
  [723] = {.count = 1, .reusable = false}, SHIFT(389),
  [725] = {.count = 1, .reusable = false}, SHIFT(391),
  [727] = {.count = 1, .reusable = true}, SHIFT(393),
  [729] = {.count = 1, .reusable = false}, SHIFT(394),
  [731] = {.count = 1, .reusable = false}, SHIFT(395),
  [733] = {.count = 1, .reusable = false}, SHIFT(104),
  [735] = {.count = 1, .reusable = false}, SHIFT(105),
  [737] = {.count = 1, .reusable = false}, SHIFT(396),
  [739] = {.count = 1, .reusable = false}, SHIFT(397),
  [741] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 2),
  [743] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 2),
  [745] = {.count = 1, .reusable = false}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [747] = {.count = 2, .reusable = false}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(241),
  [750] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(44),
  [753] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(146),
  [756] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(130),
  [759] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_declaration_repeat2, 2),
  [761] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(132),
  [764] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(7),
  [767] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(8),
  [770] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(54),
  [773] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(133),
  [776] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(134),
  [779] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(135),
  [782] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(10),
  [785] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(11),
  [788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(12),
  [791] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(136),
  [794] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(137),
  [797] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_declaration_repeat2, 2), SHIFT_REPEAT(138),
  [800] = {.count = 1, .reusable = false}, REDUCE(aux_sym__attributes_repeat1, 2),
  [802] = {.count = 1, .reusable = true}, SHIFT(402),
  [804] = {.count = 1, .reusable = false}, SHIFT(403),
  [806] = {.count = 1, .reusable = false}, SHIFT(404),
  [808] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(44),
  [811] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(146),
  [814] = {.count = 1, .reusable = true}, REDUCE(aux_sym_struct_declaration_repeat1, 2),
  [816] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(132),
  [819] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(7),
  [822] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(8),
  [825] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(54),
  [828] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(133),
  [831] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(135),
  [834] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(10),
  [837] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(11),
  [840] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(12),
  [843] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(136),
  [846] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(137),
  [849] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_declaration_repeat1, 2), SHIFT_REPEAT(138),
  [852] = {.count = 1, .reusable = true}, SHIFT(407),
  [854] = {.count = 1, .reusable = true}, REDUCE(sym_struct_interfaces, 3),
  [856] = {.count = 1, .reusable = true}, REDUCE(sym__global_attributes, 5),
  [858] = {.count = 1, .reusable = true}, SHIFT(410),
  [860] = {.count = 1, .reusable = false}, SHIFT(411),
  [862] = {.count = 1, .reusable = false}, SHIFT(412),
  [864] = {.count = 1, .reusable = true}, SHIFT(413),
  [866] = {.count = 1, .reusable = true}, SHIFT(414),
  [868] = {.count = 1, .reusable = true}, SHIFT(415),
  [870] = {.count = 1, .reusable = true}, SHIFT(419),
  [872] = {.count = 1, .reusable = true}, SHIFT(420),
  [874] = {.count = 1, .reusable = false}, SHIFT(421),
  [876] = {.count = 1, .reusable = false}, SHIFT(422),
  [878] = {.count = 2, .reusable = false}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(44),
  [881] = {.count = 2, .reusable = false}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(161),
  [884] = {.count = 1, .reusable = true}, REDUCE(aux_sym_interface_declaration_repeat1, 2),
  [886] = {.count = 2, .reusable = true}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(54),
  [889] = {.count = 2, .reusable = false}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(163),
  [892] = {.count = 2, .reusable = false}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(164),
  [895] = {.count = 2, .reusable = false}, REDUCE(aux_sym_interface_declaration_repeat1, 2), SHIFT_REPEAT(46),
  [898] = {.count = 1, .reusable = true}, SHIFT(424),
  [900] = {.count = 1, .reusable = false}, SHIFT(425),
  [902] = {.count = 1, .reusable = true}, SHIFT(425),
  [904] = {.count = 1, .reusable = false}, SHIFT(426),
  [906] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 5),
  [908] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 5),
  [910] = {.count = 1, .reusable = true}, SHIFT(429),
  [912] = {.count = 1, .reusable = true}, SHIFT(430),
  [914] = {.count = 1, .reusable = true}, REDUCE(sym_enum_member_declaration, 2),
  [916] = {.count = 1, .reusable = true}, SHIFT(432),
  [918] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 2),
  [920] = {.count = 1, .reusable = false}, REDUCE(sym_parameter_modifier, 1),
  [922] = {.count = 1, .reusable = true}, SHIFT(437),
  [924] = {.count = 1, .reusable = true}, SHIFT(438),
  [926] = {.count = 1, .reusable = true}, SHIFT(439),
  [928] = {.count = 1, .reusable = true}, REDUCE(sym__formal_parameter_list, 1),
  [930] = {.count = 1, .reusable = true}, SHIFT(440),
  [932] = {.count = 1, .reusable = true}, SHIFT(274),
  [934] = {.count = 1, .reusable = false}, SHIFT(446),
  [936] = {.count = 1, .reusable = true}, REDUCE(sym_delegate_declaration, 5),
  [938] = {.count = 1, .reusable = false}, REDUCE(sym_delegate_declaration, 5),
  [940] = {.count = 1, .reusable = true}, SHIFT(453),
  [942] = {.count = 1, .reusable = true}, SHIFT(454),
  [944] = {.count = 1, .reusable = true}, SHIFT(458),
  [946] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_declaration, 6),
  [948] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6),
  [950] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6),
  [952] = {.count = 1, .reusable = true}, SHIFT(460),
  [954] = {.count = 1, .reusable = true}, SHIFT(461),
  [956] = {.count = 1, .reusable = true}, SHIFT(463),
  [958] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 6),
  [960] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 6),
  [962] = {.count = 1, .reusable = true}, SHIFT(464),
  [964] = {.count = 1, .reusable = true}, SHIFT(465),
  [966] = {.count = 1, .reusable = true}, SHIFT(467),
  [968] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 6),
  [970] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 6),
  [972] = {.count = 1, .reusable = true}, SHIFT(468),
  [974] = {.count = 1, .reusable = true}, SHIFT(469),
  [976] = {.count = 1, .reusable = true}, SHIFT(471),
  [978] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameter_list_repeat1, 2),
  [980] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_list, 4),
  [982] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameter_list, 4),
  [984] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameter_list_repeat1, 2), SHIFT_REPEAT(207),
  [987] = {.count = 1, .reusable = true}, SHIFT(475),
  [989] = {.count = 1, .reusable = true}, SHIFT(479),
  [991] = {.count = 1, .reusable = true}, SHIFT(480),
  [993] = {.count = 1, .reusable = true}, SHIFT(481),
  [995] = {.count = 1, .reusable = true}, REDUCE(sym__constant_declarators, 1),
  [997] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_declaration, 3),
  [999] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_declaration, 3),
  [1001] = {.count = 1, .reusable = true}, REDUCE(sym_overloadable_binary_operator, 1),
  [1003] = {.count = 2, .reusable = true}, REDUCE(sym_overloadable_unary_operator, 1), REDUCE(sym_overloadable_binary_operator, 1),
  [1006] = {.count = 1, .reusable = true}, REDUCE(sym_overloadable_unary_operator, 1),
  [1008] = {.count = 1, .reusable = true}, SHIFT(489),
  [1010] = {.count = 1, .reusable = true}, SHIFT(490),
  [1012] = {.count = 1, .reusable = false}, SHIFT(491),
  [1014] = {.count = 1, .reusable = true}, SHIFT(491),
  [1016] = {.count = 1, .reusable = false}, SHIFT(492),
  [1018] = {.count = 1, .reusable = false}, SHIFT(494),
  [1020] = {.count = 1, .reusable = true}, SHIFT(495),
  [1022] = {.count = 1, .reusable = false}, REDUCE(sym_property_declaration, 3),
  [1024] = {.count = 1, .reusable = true}, REDUCE(sym_property_declaration, 3),
  [1026] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2),
  [1028] = {.count = 1, .reusable = true}, SHIFT(496),
  [1030] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [1032] = {.count = 1, .reusable = true}, SHIFT(499),
  [1034] = {.count = 1, .reusable = true}, SHIFT(500),
  [1036] = {.count = 1, .reusable = false}, REDUCE(sym_indexer_declaration, 3),
  [1038] = {.count = 1, .reusable = true}, REDUCE(sym_indexer_declaration, 3),
  [1040] = {.count = 1, .reusable = false}, REDUCE(sym_operator_declaration, 3),
  [1042] = {.count = 1, .reusable = true}, REDUCE(sym_operator_declaration, 3),
  [1044] = {.count = 1, .reusable = false}, SHIFT(504),
  [1046] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 3),
  [1048] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 3),
  [1050] = {.count = 1, .reusable = true}, SHIFT(505),
  [1052] = {.count = 1, .reusable = true}, REDUCE(sym_accessor_modifier, 1),
  [1054] = {.count = 1, .reusable = true}, SHIFT(506),
  [1056] = {.count = 1, .reusable = true}, SHIFT(507),
  [1058] = {.count = 1, .reusable = true}, SHIFT(508),
  [1060] = {.count = 1, .reusable = true}, REDUCE(sym__accessor_declarations, 1),
  [1062] = {.count = 1, .reusable = true}, SHIFT(516),
  [1064] = {.count = 1, .reusable = true}, SHIFT(517),
  [1066] = {.count = 1, .reusable = false}, SHIFT(520),
  [1068] = {.count = 1, .reusable = true}, SHIFT(520),
  [1070] = {.count = 1, .reusable = false}, SHIFT(521),
  [1072] = {.count = 1, .reusable = true}, SHIFT(522),
  [1074] = {.count = 1, .reusable = false}, SHIFT(523),
  [1076] = {.count = 1, .reusable = false}, REDUCE(sym_boolean_literal, 1),
  [1078] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_literal, 1),
  [1080] = {.count = 1, .reusable = false}, SHIFT(524),
  [1082] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [1084] = {.count = 1, .reusable = false}, REDUCE(sym_integer_literal, 1),
  [1086] = {.count = 1, .reusable = true}, REDUCE(sym_integer_literal, 1),
  [1088] = {.count = 1, .reusable = true}, SHIFT(525),
  [1090] = {.count = 1, .reusable = true}, SHIFT(526),
  [1092] = {.count = 1, .reusable = true}, SHIFT(527),
  [1094] = {.count = 1, .reusable = true}, SHIFT(528),
  [1096] = {.count = 1, .reusable = false}, SHIFT(530),
  [1098] = {.count = 1, .reusable = false}, SHIFT(529),
  [1100] = {.count = 1, .reusable = false}, SHIFT(531),
  [1102] = {.count = 1, .reusable = false}, SHIFT(532),
  [1104] = {.count = 1, .reusable = true}, SHIFT(533),
  [1106] = {.count = 1, .reusable = true}, SHIFT(534),
  [1108] = {.count = 1, .reusable = false}, SHIFT(534),
  [1110] = {.count = 1, .reusable = true}, SHIFT(535),
  [1112] = {.count = 1, .reusable = false}, SHIFT(535),
  [1114] = {.count = 1, .reusable = false}, SHIFT(536),
  [1116] = {.count = 1, .reusable = true}, SHIFT(537),
  [1118] = {.count = 1, .reusable = true}, SHIFT(538),
  [1120] = {.count = 1, .reusable = true}, SHIFT(532),
  [1122] = {.count = 1, .reusable = true}, SHIFT(539),
  [1124] = {.count = 1, .reusable = true}, SHIFT(540),
  [1126] = {.count = 1, .reusable = true}, SHIFT(541),
  [1128] = {.count = 1, .reusable = false}, REDUCE(sym_string_literal, 1),
  [1130] = {.count = 1, .reusable = true}, REDUCE(sym_string_literal, 1),
  [1132] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [1134] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [1136] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1138] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1140] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(71),
  [1143] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1147] = {.count = 1, .reusable = false}, SHIFT(543),
  [1149] = {.count = 1, .reusable = true}, SHIFT(544),
  [1151] = {.count = 1, .reusable = true}, SHIFT(549),
  [1153] = {.count = 1, .reusable = true}, SHIFT(550),
  [1155] = {.count = 1, .reusable = true}, SHIFT(551),
  [1157] = {.count = 1, .reusable = true}, SHIFT(552),
  [1159] = {.count = 1, .reusable = false}, SHIFT(553),
  [1161] = {.count = 1, .reusable = true}, SHIFT(554),
  [1163] = {.count = 1, .reusable = true}, SHIFT(555),
  [1165] = {.count = 1, .reusable = true}, SHIFT(556),
  [1167] = {.count = 1, .reusable = true}, SHIFT(557),
  [1169] = {.count = 1, .reusable = false}, SHIFT(558),
  [1171] = {.count = 1, .reusable = false}, SHIFT(559),
  [1173] = {.count = 1, .reusable = false}, SHIFT(560),
  [1175] = {.count = 1, .reusable = false}, SHIFT(561),
  [1177] = {.count = 1, .reusable = true}, SHIFT(563),
  [1179] = {.count = 1, .reusable = true}, SHIFT(564),
  [1181] = {.count = 1, .reusable = false}, SHIFT(565),
  [1183] = {.count = 1, .reusable = false}, SHIFT(566),
  [1185] = {.count = 1, .reusable = false}, SHIFT(567),
  [1187] = {.count = 1, .reusable = false}, SHIFT(568),
  [1189] = {.count = 1, .reusable = true}, SHIFT(569),
  [1191] = {.count = 1, .reusable = true}, SHIFT(570),
  [1193] = {.count = 1, .reusable = true}, SHIFT(571),
  [1195] = {.count = 1, .reusable = true}, SHIFT(572),
  [1197] = {.count = 1, .reusable = true}, REDUCE(sym__statement_list, 1),
  [1199] = {.count = 1, .reusable = true}, SHIFT(575),
  [1201] = {.count = 1, .reusable = true}, SHIFT(576),
  [1203] = {.count = 1, .reusable = true}, SHIFT(577),
  [1205] = {.count = 1, .reusable = false}, SHIFT(183),
  [1207] = {.count = 1, .reusable = false}, SHIFT(184),
  [1209] = {.count = 1, .reusable = false}, SHIFT(185),
  [1211] = {.count = 1, .reusable = false}, SHIFT(578),
  [1213] = {.count = 1, .reusable = false}, SHIFT(582),
  [1215] = {.count = 1, .reusable = true}, SHIFT(584),
  [1217] = {.count = 1, .reusable = true}, SHIFT(585),
  [1219] = {.count = 1, .reusable = true}, REDUCE(sym_class_base, 4),
  [1221] = {.count = 1, .reusable = true}, SHIFT(587),
  [1223] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_constraints, 1),
  [1225] = {.count = 1, .reusable = true}, SHIFT(588),
  [1227] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_constraints_clause, 4),
  [1229] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_base_repeat1, 2),
  [1231] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_base_repeat1, 2), SHIFT_REPEAT(249),
  [1234] = {.count = 1, .reusable = true}, SHIFT(589),
  [1236] = {.count = 1, .reusable = true}, SHIFT(590),
  [1238] = {.count = 1, .reusable = true}, SHIFT(594),
  [1240] = {.count = 1, .reusable = true}, SHIFT(595),
  [1242] = {.count = 1, .reusable = true}, SHIFT(596),
  [1244] = {.count = 1, .reusable = false}, REDUCE(sym_interface_method_declaration, 3),
  [1246] = {.count = 1, .reusable = true}, REDUCE(sym_interface_method_declaration, 3),
  [1248] = {.count = 1, .reusable = true}, SHIFT(597),
  [1250] = {.count = 1, .reusable = true}, SHIFT(600),
  [1252] = {.count = 1, .reusable = true}, SHIFT(605),
  [1254] = {.count = 1, .reusable = false}, SHIFT(606),
  [1256] = {.count = 1, .reusable = false}, SHIFT(607),
  [1258] = {.count = 1, .reusable = true}, REDUCE(sym_interface_base, 4),
  [1260] = {.count = 1, .reusable = false}, SHIFT(609),
  [1262] = {.count = 1, .reusable = true}, REDUCE(sym_constant_expression, 1),
  [1264] = {.count = 1, .reusable = true}, SHIFT(610),
  [1266] = {.count = 1, .reusable = true}, SHIFT(611),
  [1268] = {.count = 1, .reusable = false}, SHIFT(611),
  [1270] = {.count = 1, .reusable = true}, SHIFT(612),
  [1272] = {.count = 1, .reusable = false}, SHIFT(612),
  [1274] = {.count = 1, .reusable = false}, SHIFT(613),
  [1276] = {.count = 1, .reusable = true}, SHIFT(614),
  [1278] = {.count = 1, .reusable = true}, SHIFT(615),
  [1280] = {.count = 1, .reusable = true}, SHIFT(609),
  [1282] = {.count = 1, .reusable = true}, SHIFT(616),
  [1284] = {.count = 1, .reusable = true}, SHIFT(617),
  [1286] = {.count = 1, .reusable = true}, SHIFT(618),
  [1288] = {.count = 1, .reusable = true}, REDUCE(sym_enum_member_declaration, 3),
  [1290] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_declaration_repeat1, 2),
  [1292] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 6),
  [1294] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 6),
  [1296] = {.count = 1, .reusable = true}, SHIFT(619),
  [1298] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_declaration_repeat1, 2), SHIFT_REPEAT(265),
  [1301] = {.count = 1, .reusable = true}, SHIFT(621),
  [1303] = {.count = 1, .reusable = true}, SHIFT(623),
  [1305] = {.count = 1, .reusable = true}, SHIFT(624),
  [1307] = {.count = 1, .reusable = true}, SHIFT(626),
  [1309] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 2),
  [1311] = {.count = 1, .reusable = true}, SHIFT(627),
  [1313] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_list, 3),
  [1315] = {.count = 1, .reusable = true}, REDUCE(sym__formal_parameter_list, 2),
  [1317] = {.count = 1, .reusable = true}, SHIFT(446),
  [1319] = {.count = 1, .reusable = true}, SHIFT(636),
  [1321] = {.count = 2, .reusable = true}, REDUCE(aux_sym__attributes_repeat1, 2), SHIFT_REPEAT(273),
  [1324] = {.count = 1, .reusable = true}, REDUCE(sym_delegate_declaration, 6),
  [1326] = {.count = 1, .reusable = false}, REDUCE(sym_delegate_declaration, 6),
  [1328] = {.count = 1, .reusable = true}, SHIFT(646),
  [1330] = {.count = 1, .reusable = true}, SHIFT(647),
  [1332] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7),
  [1334] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7),
  [1336] = {.count = 1, .reusable = true}, SHIFT(648),
  [1338] = {.count = 1, .reusable = true}, SHIFT(649),
  [1340] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 7),
  [1342] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 7),
  [1344] = {.count = 1, .reusable = true}, SHIFT(651),
  [1346] = {.count = 1, .reusable = true}, SHIFT(652),
  [1348] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 7),
  [1350] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 7),
  [1352] = {.count = 1, .reusable = true}, SHIFT(654),
  [1354] = {.count = 1, .reusable = true}, SHIFT(655),
  [1356] = {.count = 1, .reusable = true}, SHIFT(661),
  [1358] = {.count = 1, .reusable = true}, SHIFT(662),
  [1360] = {.count = 1, .reusable = false}, REDUCE(sym_destructor_declaration, 4),
  [1362] = {.count = 1, .reusable = true}, REDUCE(sym_destructor_declaration, 4),
  [1364] = {.count = 1, .reusable = false}, REDUCE(sym_method_declaration, 4),
  [1366] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 4),
  [1368] = {.count = 1, .reusable = false}, SHIFT(667),
  [1370] = {.count = 1, .reusable = false}, REDUCE(sym_constant_declaration, 4),
  [1372] = {.count = 1, .reusable = true}, REDUCE(sym_constant_declaration, 4),
  [1374] = {.count = 1, .reusable = true}, REDUCE(sym__constant_declarators, 2),
  [1376] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_declaration, 4),
  [1378] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_declaration, 4),
  [1380] = {.count = 1, .reusable = true}, SHIFT(671),
  [1382] = {.count = 1, .reusable = true}, SHIFT(672),
  [1384] = {.count = 1, .reusable = true}, SHIFT(673),
  [1386] = {.count = 1, .reusable = false}, SHIFT(679),
  [1388] = {.count = 1, .reusable = true}, REDUCE(sym_equals_value_clause, 2),
  [1390] = {.count = 1, .reusable = true}, SHIFT(680),
  [1392] = {.count = 1, .reusable = true}, SHIFT(681),
  [1394] = {.count = 1, .reusable = false}, SHIFT(681),
  [1396] = {.count = 1, .reusable = true}, SHIFT(682),
  [1398] = {.count = 1, .reusable = false}, SHIFT(682),
  [1400] = {.count = 1, .reusable = false}, SHIFT(683),
  [1402] = {.count = 1, .reusable = true}, SHIFT(684),
  [1404] = {.count = 1, .reusable = true}, SHIFT(685),
  [1406] = {.count = 1, .reusable = true}, SHIFT(679),
  [1408] = {.count = 1, .reusable = true}, SHIFT(686),
  [1410] = {.count = 1, .reusable = true}, SHIFT(687),
  [1412] = {.count = 1, .reusable = true}, SHIFT(688),
  [1414] = {.count = 1, .reusable = true}, SHIFT(689),
  [1416] = {.count = 1, .reusable = true}, SHIFT(690),
  [1418] = {.count = 1, .reusable = true}, SHIFT(691),
  [1420] = {.count = 1, .reusable = true}, SHIFT(329),
  [1422] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [1424] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(335),
  [1427] = {.count = 1, .reusable = true}, SHIFT(693),
  [1429] = {.count = 1, .reusable = true}, SHIFT(694),
  [1431] = {.count = 1, .reusable = false}, REDUCE(sym_property_declaration, 4),
  [1433] = {.count = 1, .reusable = true}, REDUCE(sym_property_declaration, 4),
  [1435] = {.count = 1, .reusable = true}, SHIFT(696),
  [1437] = {.count = 1, .reusable = true}, REDUCE(sym_accessor_modifier, 2),
  [1439] = {.count = 1, .reusable = true}, REDUCE(sym_get_accessor_declaration, 2),
  [1441] = {.count = 1, .reusable = true}, REDUCE(sym_set_accessor_declaration, 2),
  [1443] = {.count = 1, .reusable = false}, REDUCE(sym__indexer_body, 3),
  [1445] = {.count = 1, .reusable = true}, REDUCE(sym__indexer_body, 3),
  [1447] = {.count = 1, .reusable = true}, REDUCE(sym__accessor_declarations, 2),
  [1449] = {.count = 1, .reusable = true}, SHIFT(701),
  [1451] = {.count = 1, .reusable = true}, SHIFT(702),
  [1453] = {.count = 1, .reusable = true}, SHIFT(703),
  [1455] = {.count = 1, .reusable = true}, SHIFT(704),
  [1457] = {.count = 1, .reusable = false}, SHIFT(705),
  [1459] = {.count = 1, .reusable = true}, SHIFT(706),
  [1461] = {.count = 1, .reusable = true}, SHIFT(707),
  [1463] = {.count = 1, .reusable = true}, SHIFT(708),
  [1465] = {.count = 1, .reusable = false}, SHIFT(708),
  [1467] = {.count = 1, .reusable = true}, SHIFT(709),
  [1469] = {.count = 1, .reusable = false}, SHIFT(709),
  [1471] = {.count = 1, .reusable = false}, SHIFT(710),
  [1473] = {.count = 1, .reusable = true}, SHIFT(711),
  [1475] = {.count = 1, .reusable = true}, SHIFT(712),
  [1477] = {.count = 1, .reusable = true}, SHIFT(705),
  [1479] = {.count = 1, .reusable = true}, SHIFT(713),
  [1481] = {.count = 1, .reusable = true}, SHIFT(714),
  [1483] = {.count = 1, .reusable = true}, SHIFT(715),
  [1485] = {.count = 1, .reusable = false}, REDUCE(sym_real_literal, 2),
  [1487] = {.count = 1, .reusable = true}, REDUCE(sym_real_literal, 2),
  [1489] = {.count = 1, .reusable = true}, SHIFT(716),
  [1491] = {.count = 1, .reusable = true}, SHIFT(717),
  [1493] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [1495] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1497] = {.count = 1, .reusable = true}, SHIFT(718),
  [1499] = {.count = 1, .reusable = true}, SHIFT(719),
  [1501] = {.count = 1, .reusable = false}, REDUCE(sym_integer_literal, 2),
  [1503] = {.count = 1, .reusable = true}, REDUCE(sym_integer_literal, 2),
  [1505] = {.count = 1, .reusable = false}, REDUCE(sym__regular_string_literal, 2),
  [1507] = {.count = 1, .reusable = true}, REDUCE(sym__regular_string_literal, 2),
  [1509] = {.count = 1, .reusable = false}, SHIFT(721),
  [1511] = {.count = 1, .reusable = false}, SHIFT(720),
  [1513] = {.count = 1, .reusable = true}, SHIFT(722),
  [1515] = {.count = 1, .reusable = false}, SHIFT(723),
  [1517] = {.count = 1, .reusable = false}, SHIFT(724),
  [1519] = {.count = 1, .reusable = false}, SHIFT(725),
  [1521] = {.count = 1, .reusable = false}, SHIFT(726),
  [1523] = {.count = 1, .reusable = false}, SHIFT(727),
  [1525] = {.count = 1, .reusable = false}, SHIFT(728),
  [1527] = {.count = 1, .reusable = false}, SHIFT(729),
  [1529] = {.count = 1, .reusable = false}, SHIFT(730),
  [1531] = {.count = 1, .reusable = true}, SHIFT(730),
  [1533] = {.count = 1, .reusable = false}, SHIFT(731),
  [1535] = {.count = 1, .reusable = false}, SHIFT(732),
  [1537] = {.count = 1, .reusable = false}, SHIFT(733),
  [1539] = {.count = 1, .reusable = false}, SHIFT(735),
  [1541] = {.count = 1, .reusable = true}, SHIFT(737),
  [1543] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2),
  [1545] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2),
  [1547] = {.count = 1, .reusable = false}, SHIFT(738),
  [1549] = {.count = 1, .reusable = false}, SHIFT(739),
  [1551] = {.count = 1, .reusable = false}, REDUCE(sym_checked_statement, 2),
  [1553] = {.count = 1, .reusable = true}, REDUCE(sym_checked_statement, 2),
  [1555] = {.count = 1, .reusable = false}, REDUCE(sym_unchecked_statement, 2),
  [1557] = {.count = 1, .reusable = true}, REDUCE(sym_unchecked_statement, 2),
  [1559] = {.count = 1, .reusable = false}, SHIFT(742),
  [1561] = {.count = 1, .reusable = false}, SHIFT(743),
  [1563] = {.count = 1, .reusable = true}, SHIFT(744),
  [1565] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [1567] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [1569] = {.count = 1, .reusable = true}, SHIFT(745),
  [1571] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [1573] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [1575] = {.count = 1, .reusable = false}, SHIFT(746),
  [1577] = {.count = 1, .reusable = false}, SHIFT(748),
  [1579] = {.count = 1, .reusable = true}, SHIFT(751),
  [1581] = {.count = 1, .reusable = true}, SHIFT(752),
  [1583] = {.count = 1, .reusable = true}, SHIFT(753),
  [1585] = {.count = 1, .reusable = true}, SHIFT(754),
  [1587] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [1589] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [1591] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 2),
  [1593] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 2),
  [1595] = {.count = 1, .reusable = true}, SHIFT(755),
  [1597] = {.count = 1, .reusable = true}, SHIFT(756),
  [1599] = {.count = 1, .reusable = false}, SHIFT(757),
  [1601] = {.count = 1, .reusable = true}, SHIFT(759),
  [1603] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1605] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1607] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1609] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1611] = {.count = 1, .reusable = false}, REDUCE(sym__declaration_statement, 2),
  [1613] = {.count = 1, .reusable = true}, REDUCE(sym__declaration_statement, 2),
  [1615] = {.count = 1, .reusable = true}, REDUCE(sym_local_variable_declarator, 1),
  [1617] = {.count = 1, .reusable = true}, SHIFT(760),
  [1619] = {.count = 1, .reusable = true}, SHIFT(761),
  [1621] = {.count = 1, .reusable = true}, REDUCE(sym_local_variable_declaration, 2),
  [1623] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(44),
  [1626] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(368),
  [1629] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(235),
  [1632] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [1634] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(357),
  [1637] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(358),
  [1640] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(359),
  [1643] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(359),
  [1646] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(360),
  [1649] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(370),
  [1652] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(361),
  [1655] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(362),
  [1658] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(363),
  [1661] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(386),
  [1664] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(364),
  [1667] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(365),
  [1670] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(371),
  [1673] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(372),
  [1676] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(373),
  [1679] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(374),
  [1682] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(375),
  [1685] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(376),
  [1688] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(377),
  [1691] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(378),
  [1694] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(379),
  [1697] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(380),
  [1700] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(381),
  [1703] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(382),
  [1706] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(383),
  [1709] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(384),
  [1712] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(385),
  [1715] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(389),
  [1718] = {.count = 1, .reusable = false}, REDUCE(sym_operator_declaration, 4),
  [1720] = {.count = 1, .reusable = true}, REDUCE(sym_operator_declaration, 4),
  [1722] = {.count = 1, .reusable = true}, SHIFT(764),
  [1724] = {.count = 1, .reusable = true}, SHIFT(765),
  [1726] = {.count = 1, .reusable = false}, REDUCE(sym_indexer_declaration, 4),
  [1728] = {.count = 1, .reusable = true}, REDUCE(sym_indexer_declaration, 4),
  [1730] = {.count = 1, .reusable = false}, SHIFT(769),
  [1732] = {.count = 1, .reusable = false}, REDUCE(sym_field_declaration, 4),
  [1734] = {.count = 1, .reusable = true}, REDUCE(sym_field_declaration, 4),
  [1736] = {.count = 1, .reusable = true}, REDUCE(sym_class_base, 5),
  [1738] = {.count = 1, .reusable = false}, SHIFT(770),
  [1740] = {.count = 1, .reusable = true}, SHIFT(772),
  [1742] = {.count = 1, .reusable = true}, SHIFT(773),
  [1744] = {.count = 1, .reusable = false}, REDUCE(sym_interface_method_declaration, 4),
  [1746] = {.count = 1, .reusable = true}, REDUCE(sym_interface_method_declaration, 4),
  [1748] = {.count = 1, .reusable = true}, SHIFT(774),
  [1750] = {.count = 1, .reusable = false}, REDUCE(sym_interface_event_declaration, 4),
  [1752] = {.count = 1, .reusable = true}, REDUCE(sym_interface_event_declaration, 4),
  [1754] = {.count = 1, .reusable = true}, SHIFT(779),
  [1756] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_declaration_repeat1, 2), SHIFT_REPEAT(415),
  [1759] = {.count = 1, .reusable = true}, SHIFT(780),
  [1761] = {.count = 1, .reusable = true}, SHIFT(781),
  [1763] = {.count = 1, .reusable = true}, SHIFT(782),
  [1765] = {.count = 1, .reusable = true}, SHIFT(783),
  [1767] = {.count = 1, .reusable = true}, SHIFT(786),
  [1769] = {.count = 1, .reusable = true}, SHIFT(788),
  [1771] = {.count = 1, .reusable = true}, SHIFT(789),
  [1773] = {.count = 1, .reusable = true}, REDUCE(sym_interface_base, 5),
  [1775] = {.count = 1, .reusable = false}, SHIFT(790),
  [1777] = {.count = 1, .reusable = false}, SHIFT(791),
  [1779] = {.count = 1, .reusable = false}, SHIFT(792),
  [1781] = {.count = 1, .reusable = false}, SHIFT(793),
  [1783] = {.count = 1, .reusable = false}, SHIFT(794),
  [1785] = {.count = 1, .reusable = false}, SHIFT(795),
  [1787] = {.count = 1, .reusable = false}, SHIFT(796),
  [1789] = {.count = 1, .reusable = false}, SHIFT(797),
  [1791] = {.count = 1, .reusable = false}, SHIFT(798),
  [1793] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 7),
  [1795] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 7),
  [1797] = {.count = 1, .reusable = true}, REDUCE(sym_enum_member_declaration, 4),
  [1799] = {.count = 1, .reusable = true}, SHIFT(799),
  [1801] = {.count = 1, .reusable = true}, SHIFT(800),
  [1803] = {.count = 1, .reusable = true}, SHIFT(802),
  [1805] = {.count = 1, .reusable = true}, SHIFT(801),
  [1807] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 2),
  [1809] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_array, 3),
  [1811] = {.count = 1, .reusable = false}, SHIFT(803),
  [1813] = {.count = 1, .reusable = true}, SHIFT(803),
  [1815] = {.count = 1, .reusable = false}, SHIFT(804),
  [1817] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 3),
  [1819] = {.count = 1, .reusable = true}, REDUCE(aux_sym__formal_parameter_list_repeat1, 2),
  [1821] = {.count = 1, .reusable = true}, SHIFT(806),
  [1823] = {.count = 1, .reusable = true}, REDUCE(sym__formal_parameter_list, 3),
  [1825] = {.count = 2, .reusable = true}, REDUCE(aux_sym__formal_parameter_list_repeat1, 2), SHIFT_REPEAT(439),
  [1828] = {.count = 2, .reusable = true}, REDUCE(aux_sym__attributes_repeat1, 2), SHIFT_REPEAT(440),
  [1831] = {.count = 1, .reusable = true}, SHIFT(808),
  [1833] = {.count = 1, .reusable = true}, SHIFT(809),
  [1835] = {.count = 1, .reusable = true}, SHIFT(810),
  [1837] = {.count = 1, .reusable = true}, SHIFT(811),
  [1839] = {.count = 1, .reusable = true}, SHIFT(812),
  [1841] = {.count = 1, .reusable = true}, REDUCE(sym_delegate_declaration, 7),
  [1843] = {.count = 1, .reusable = false}, REDUCE(sym_delegate_declaration, 7),
  [1845] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 8),
  [1847] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 8),
  [1849] = {.count = 1, .reusable = true}, SHIFT(818),
  [1851] = {.count = 1, .reusable = true}, SHIFT(819),
  [1853] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 8),
  [1855] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 8),
  [1857] = {.count = 1, .reusable = true}, SHIFT(820),
  [1859] = {.count = 1, .reusable = true}, SHIFT(821),
  [1861] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 8),
  [1863] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 8),
  [1865] = {.count = 1, .reusable = true}, SHIFT(822),
  [1867] = {.count = 1, .reusable = true}, SHIFT(823),
  [1869] = {.count = 1, .reusable = false}, REDUCE(sym_destructor_declaration, 5),
  [1871] = {.count = 1, .reusable = true}, REDUCE(sym_destructor_declaration, 5),
  [1873] = {.count = 1, .reusable = false}, REDUCE(sym_method_declaration, 5),
  [1875] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 5),
  [1877] = {.count = 1, .reusable = true}, SHIFT(833),
  [1879] = {.count = 1, .reusable = true}, SHIFT(834),
  [1881] = {.count = 1, .reusable = true}, REDUCE(sym_constant_declarator, 3),
  [1883] = {.count = 1, .reusable = true}, REDUCE(aux_sym__constant_declarators_repeat1, 2),
  [1885] = {.count = 2, .reusable = true}, REDUCE(aux_sym__constant_declarators_repeat1, 2), SHIFT_REPEAT(481),
  [1888] = {.count = 1, .reusable = true}, SHIFT(836),
  [1890] = {.count = 1, .reusable = true}, REDUCE(sym__indexer_declarator, 5),
  [1892] = {.count = 1, .reusable = true}, SHIFT(839),
  [1894] = {.count = 1, .reusable = true}, SHIFT(841),
  [1896] = {.count = 1, .reusable = true}, SHIFT(842),
  [1898] = {.count = 1, .reusable = false}, SHIFT(843),
  [1900] = {.count = 1, .reusable = false}, SHIFT(844),
  [1902] = {.count = 1, .reusable = false}, SHIFT(845),
  [1904] = {.count = 1, .reusable = false}, SHIFT(846),
  [1906] = {.count = 1, .reusable = false}, SHIFT(847),
  [1908] = {.count = 1, .reusable = false}, SHIFT(848),
  [1910] = {.count = 1, .reusable = false}, SHIFT(849),
  [1912] = {.count = 1, .reusable = false}, SHIFT(850),
  [1914] = {.count = 1, .reusable = false}, SHIFT(851),
  [1916] = {.count = 1, .reusable = false}, REDUCE(sym__property_body, 3),
  [1918] = {.count = 1, .reusable = true}, SHIFT(852),
  [1920] = {.count = 1, .reusable = true}, REDUCE(sym__property_body, 3),
  [1922] = {.count = 1, .reusable = false}, REDUCE(sym_constant_declaration, 5),
  [1924] = {.count = 1, .reusable = true}, REDUCE(sym_constant_declaration, 5),
  [1926] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_declaration, 5),
  [1928] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_declaration, 5),
  [1930] = {.count = 1, .reusable = false}, REDUCE(sym_operator_declaration, 5),
  [1932] = {.count = 1, .reusable = true}, REDUCE(sym_operator_declaration, 5),
  [1934] = {.count = 1, .reusable = true}, REDUCE(sym_get_accessor_declaration, 3),
  [1936] = {.count = 1, .reusable = true}, REDUCE(sym_set_accessor_declaration, 3),
  [1938] = {.count = 1, .reusable = true}, SHIFT(858),
  [1940] = {.count = 1, .reusable = true}, SHIFT(859),
  [1942] = {.count = 1, .reusable = false}, SHIFT(860),
  [1944] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1946] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1948] = {.count = 1, .reusable = false}, SHIFT(861),
  [1950] = {.count = 1, .reusable = false}, SHIFT(862),
  [1952] = {.count = 1, .reusable = false}, SHIFT(863),
  [1954] = {.count = 1, .reusable = false}, SHIFT(864),
  [1956] = {.count = 1, .reusable = false}, SHIFT(865),
  [1958] = {.count = 1, .reusable = false}, SHIFT(866),
  [1960] = {.count = 1, .reusable = false}, SHIFT(867),
  [1962] = {.count = 1, .reusable = false}, SHIFT(868),
  [1964] = {.count = 1, .reusable = false}, REDUCE(sym_real_literal, 3),
  [1966] = {.count = 1, .reusable = true}, REDUCE(sym_real_literal, 3),
  [1968] = {.count = 1, .reusable = true}, SHIFT(869),
  [1970] = {.count = 1, .reusable = false}, REDUCE(sym_character_literal, 3),
  [1972] = {.count = 1, .reusable = true}, REDUCE(sym_character_literal, 3),
  [1974] = {.count = 1, .reusable = true}, SHIFT(870),
  [1976] = {.count = 1, .reusable = false}, REDUCE(sym__regular_string_literal, 3),
  [1978] = {.count = 1, .reusable = true}, REDUCE(sym__regular_string_literal, 3),
  [1980] = {.count = 2, .reusable = false}, REDUCE(aux_sym__regular_string_literal_repeat1, 2), SHIFT_REPEAT(721),
  [1983] = {.count = 1, .reusable = false}, REDUCE(aux_sym__regular_string_literal_repeat1, 2),
  [1985] = {.count = 1, .reusable = false}, REDUCE(sym__verbatim_string_literal, 3),
  [1987] = {.count = 1, .reusable = true}, REDUCE(sym__verbatim_string_literal, 3),
  [1989] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [1991] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [1993] = {.count = 1, .reusable = false}, SHIFT(871),
  [1995] = {.count = 1, .reusable = true}, SHIFT(872),
  [1997] = {.count = 1, .reusable = true}, SHIFT(873),
  [1999] = {.count = 1, .reusable = true}, SHIFT(874),
  [2001] = {.count = 1, .reusable = false}, SHIFT(874),
  [2003] = {.count = 1, .reusable = true}, SHIFT(875),
  [2005] = {.count = 1, .reusable = false}, SHIFT(875),
  [2007] = {.count = 1, .reusable = false}, SHIFT(876),
  [2009] = {.count = 1, .reusable = true}, SHIFT(877),
  [2011] = {.count = 1, .reusable = true}, SHIFT(878),
  [2013] = {.count = 1, .reusable = true}, SHIFT(871),
  [2015] = {.count = 1, .reusable = true}, SHIFT(879),
  [2017] = {.count = 1, .reusable = true}, SHIFT(880),
  [2019] = {.count = 1, .reusable = true}, SHIFT(881),
  [2021] = {.count = 1, .reusable = true}, REDUCE(sym_local_constant_declaration, 3),
  [2023] = {.count = 1, .reusable = false}, REDUCE(sym__labeled_statement, 3, .alias_sequence_id = 1),
  [2025] = {.count = 1, .reusable = true}, REDUCE(sym__labeled_statement, 3, .alias_sequence_id = 1),
  [2027] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment_statement, 3),
  [2029] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment_statement, 3),
  [2031] = {.count = 1, .reusable = true}, SHIFT(882),
  [2033] = {.count = 1, .reusable = true}, SHIFT(883),
  [2035] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3),
  [2037] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3),
  [2039] = {.count = 1, .reusable = true}, SHIFT(890),
  [2041] = {.count = 1, .reusable = true}, SHIFT(891),
  [2043] = {.count = 1, .reusable = false}, REDUCE(sym_yield_statement, 3),
  [2045] = {.count = 1, .reusable = true}, REDUCE(sym_yield_statement, 3),
  [2047] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2049] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2051] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_expression, 1),
  [2053] = {.count = 1, .reusable = true}, SHIFT(892),
  [2055] = {.count = 1, .reusable = true}, SHIFT(893),
  [2057] = {.count = 1, .reusable = true}, SHIFT(894),
  [2059] = {.count = 1, .reusable = true}, SHIFT(738),
  [2061] = {.count = 1, .reusable = true}, SHIFT(739),
  [2063] = {.count = 1, .reusable = false}, SHIFT(896),
  [2065] = {.count = 1, .reusable = true}, SHIFT(899),
  [2067] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2069] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2071] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 2),
  [2073] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3, .alias_sequence_id = 2),
  [2075] = {.count = 1, .reusable = true}, SHIFT(900),
  [2077] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 3),
  [2079] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 3),
  [2081] = {.count = 1, .reusable = true}, SHIFT(901),
  [2083] = {.count = 1, .reusable = false}, SHIFT(903),
  [2085] = {.count = 1, .reusable = true}, SHIFT(906),
  [2087] = {.count = 1, .reusable = true}, SHIFT(909),
  [2089] = {.count = 1, .reusable = true}, SHIFT(910),
  [2091] = {.count = 1, .reusable = false}, REDUCE(sym_property_declaration, 5),
  [2093] = {.count = 1, .reusable = true}, REDUCE(sym_property_declaration, 5),
  [2095] = {.count = 1, .reusable = true}, SHIFT(912),
  [2097] = {.count = 1, .reusable = true}, SHIFT(913),
  [2099] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_constraints, 3),
  [2101] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_constraint, 3),
  [2103] = {.count = 1, .reusable = false}, REDUCE(sym_interface_event_declaration, 5),
  [2105] = {.count = 1, .reusable = true}, REDUCE(sym_interface_event_declaration, 5),
  [2107] = {.count = 1, .reusable = false}, REDUCE(sym_interface_method_declaration, 5),
  [2109] = {.count = 1, .reusable = true}, REDUCE(sym_interface_method_declaration, 5),
  [2111] = {.count = 1, .reusable = true}, SHIFT(915),
  [2113] = {.count = 1, .reusable = true}, SHIFT(917),
  [2115] = {.count = 1, .reusable = true}, SHIFT(918),
  [2117] = {.count = 1, .reusable = false}, SHIFT(919),
  [2119] = {.count = 1, .reusable = true}, SHIFT(920),
  [2121] = {.count = 1, .reusable = true}, REDUCE(sym_interface_accessor, 2),
  [2123] = {.count = 1, .reusable = true}, SHIFT(921),
  [2125] = {.count = 1, .reusable = false}, REDUCE(sym_interface_property_declaration, 5),
  [2127] = {.count = 1, .reusable = true}, REDUCE(sym_interface_property_declaration, 5),
  [2129] = {.count = 1, .reusable = true}, REDUCE(aux_sym_interface_property_declaration_repeat1, 2),
  [2131] = {.count = 2, .reusable = true}, REDUCE(aux_sym_interface_property_declaration_repeat1, 2), SHIFT_REPEAT(600),
  [2134] = {.count = 2, .reusable = true}, REDUCE(aux_sym_interface_property_declaration_repeat1, 2), SHIFT_REPEAT(54),
  [2137] = {.count = 1, .reusable = true}, SHIFT(922),
  [2139] = {.count = 1, .reusable = true}, SHIFT(926),
  [2141] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 8),
  [2143] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 8),
  [2145] = {.count = 1, .reusable = true}, SHIFT(927),
  [2147] = {.count = 1, .reusable = true}, REDUCE(sym_array_rank_specifier, 2),
  [2149] = {.count = 1, .reusable = true}, SHIFT(929),
  [2151] = {.count = 1, .reusable = true}, SHIFT(928),
  [2153] = {.count = 1, .reusable = false}, SHIFT(930),
  [2155] = {.count = 1, .reusable = true}, REDUCE(sym_default_argument, 2),
  [2157] = {.count = 1, .reusable = true}, SHIFT(931),
  [2159] = {.count = 1, .reusable = true}, SHIFT(932),
  [2161] = {.count = 1, .reusable = false}, SHIFT(932),
  [2163] = {.count = 1, .reusable = true}, SHIFT(933),
  [2165] = {.count = 1, .reusable = false}, SHIFT(933),
  [2167] = {.count = 1, .reusable = false}, SHIFT(934),
  [2169] = {.count = 1, .reusable = true}, SHIFT(935),
  [2171] = {.count = 1, .reusable = true}, SHIFT(936),
  [2173] = {.count = 1, .reusable = true}, SHIFT(930),
  [2175] = {.count = 1, .reusable = true}, SHIFT(937),
  [2177] = {.count = 1, .reusable = true}, SHIFT(938),
  [2179] = {.count = 1, .reusable = true}, SHIFT(939),
  [2181] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 4),
  [2183] = {.count = 1, .reusable = true}, REDUCE(sym_parameter_array, 4),
  [2185] = {.count = 1, .reusable = true}, SHIFT(944),
  [2187] = {.count = 1, .reusable = true}, SHIFT(945),
  [2189] = {.count = 1, .reusable = true}, SHIFT(946),
  [2191] = {.count = 1, .reusable = true}, SHIFT(947),
  [2193] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 9),
  [2195] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 9),
  [2197] = {.count = 1, .reusable = true}, SHIFT(949),
  [2199] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 9),
  [2201] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 9),
  [2203] = {.count = 1, .reusable = true}, SHIFT(950),
  [2205] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 9),
  [2207] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 9),
  [2209] = {.count = 1, .reusable = true}, SHIFT(951),
  [2211] = {.count = 1, .reusable = false}, REDUCE(sym_method_declaration, 6),
  [2213] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 6),
  [2215] = {.count = 1, .reusable = true}, REDUCE(sym_add_accessor_declaration, 2),
  [2217] = {.count = 1, .reusable = true}, REDUCE(sym_remove_accessor_declaration, 2),
  [2219] = {.count = 1, .reusable = true}, SHIFT(953),
  [2221] = {.count = 1, .reusable = false}, SHIFT(958),
  [2223] = {.count = 1, .reusable = true}, SHIFT(958),
  [2225] = {.count = 1, .reusable = false}, SHIFT(959),
  [2227] = {.count = 2, .reusable = true}, REDUCE(aux_sym__formal_parameter_list_repeat1, 2), SHIFT_REPEAT(673),
  [2230] = {.count = 1, .reusable = true}, SHIFT(960),
  [2232] = {.count = 1, .reusable = true}, SHIFT(961),
  [2234] = {.count = 1, .reusable = true}, SHIFT(962),
  [2236] = {.count = 1, .reusable = true}, SHIFT(963),
  [2238] = {.count = 1, .reusable = false}, SHIFT(966),
  [2240] = {.count = 1, .reusable = false}, REDUCE(sym__property_body, 4),
  [2242] = {.count = 1, .reusable = true}, REDUCE(sym__property_body, 4),
  [2244] = {.count = 1, .reusable = true}, SHIFT(967),
  [2246] = {.count = 1, .reusable = true}, REDUCE(sym_get_accessor_declaration, 4),
  [2248] = {.count = 1, .reusable = true}, REDUCE(sym_set_accessor_declaration, 4),
  [2250] = {.count = 1, .reusable = true}, SHIFT(970),
  [2252] = {.count = 1, .reusable = false}, REDUCE(sym_real_literal, 4),
  [2254] = {.count = 1, .reusable = true}, REDUCE(sym_real_literal, 4),
  [2256] = {.count = 1, .reusable = true}, SHIFT(971),
  [2258] = {.count = 1, .reusable = false}, SHIFT(972),
  [2260] = {.count = 1, .reusable = false}, SHIFT(973),
  [2262] = {.count = 1, .reusable = false}, SHIFT(974),
  [2264] = {.count = 1, .reusable = false}, SHIFT(975),
  [2266] = {.count = 1, .reusable = false}, SHIFT(976),
  [2268] = {.count = 1, .reusable = false}, SHIFT(977),
  [2270] = {.count = 1, .reusable = false}, SHIFT(978),
  [2272] = {.count = 1, .reusable = false}, SHIFT(979),
  [2274] = {.count = 1, .reusable = false}, SHIFT(980),
  [2276] = {.count = 1, .reusable = false}, SHIFT(981),
  [2278] = {.count = 1, .reusable = true}, SHIFT(983),
  [2280] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2),
  [2282] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2),
  [2284] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2),
  [2286] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2),
  [2288] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [2290] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [2292] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [2294] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [2296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(738),
  [2299] = {.count = 1, .reusable = false}, REDUCE(sym_yield_statement, 4),
  [2301] = {.count = 1, .reusable = true}, REDUCE(sym_yield_statement, 4),
  [2303] = {.count = 1, .reusable = false}, SHIFT(987),
  [2305] = {.count = 1, .reusable = false}, SHIFT(988),
  [2307] = {.count = 1, .reusable = false}, SHIFT(989),
  [2309] = {.count = 1, .reusable = false}, SHIFT(990),
  [2311] = {.count = 1, .reusable = true}, SHIFT(992),
  [2313] = {.count = 1, .reusable = true}, SHIFT(995),
  [2315] = {.count = 1, .reusable = true}, SHIFT(996),
  [2317] = {.count = 1, .reusable = true}, SHIFT(997),
  [2319] = {.count = 1, .reusable = false}, REDUCE(sym_goto_statement, 4),
  [2321] = {.count = 1, .reusable = true}, REDUCE(sym_goto_statement, 4),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2325] = {.count = 1, .reusable = true}, REDUCE(sym_local_variable_initializer, 1),
  [2327] = {.count = 1, .reusable = true}, REDUCE(sym_local_variable_declarator, 3),
  [2329] = {.count = 1, .reusable = true}, REDUCE(sym__local_variable_declarators, 3),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2333] = {.count = 1, .reusable = false}, REDUCE(sym_destructor_declaration, 6),
  [2335] = {.count = 1, .reusable = true}, REDUCE(sym_destructor_declaration, 6),
  [2337] = {.count = 1, .reusable = false}, REDUCE(sym_constant_declaration, 6),
  [2339] = {.count = 1, .reusable = true}, REDUCE(sym_constant_declaration, 6),
  [2341] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_declaration, 6),
  [2343] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_declaration, 6),
  [2345] = {.count = 1, .reusable = false}, REDUCE(sym_operator_declaration, 6),
  [2347] = {.count = 1, .reusable = true}, REDUCE(sym_operator_declaration, 6),
  [2349] = {.count = 1, .reusable = false}, SHIFT(407),
  [2351] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2353] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_constraints, 4),
  [2355] = {.count = 1, .reusable = false}, REDUCE(sym_interface_method_declaration, 6),
  [2357] = {.count = 1, .reusable = true}, REDUCE(sym_interface_method_declaration, 6),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1007),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2363] = {.count = 1, .reusable = false}, REDUCE(sym_interface_property_declaration, 6),
  [2365] = {.count = 1, .reusable = true}, REDUCE(sym_interface_property_declaration, 6),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2369] = {.count = 1, .reusable = true}, REDUCE(sym_interface_accessor, 3),
  [2371] = {.count = 1, .reusable = false}, REDUCE(sym_interface_event_declaration, 6),
  [2373] = {.count = 1, .reusable = true}, REDUCE(sym_interface_event_declaration, 6),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2379] = {.count = 1, .reusable = false}, SHIFT(1014),
  [2381] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 9),
  [2383] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 9),
  [2385] = {.count = 1, .reusable = true}, REDUCE(sym_array_rank_specifier, 3),
  [2387] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2), SHIFT_REPEAT(929),
  [2390] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2),
  [2392] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2394] = {.count = 1, .reusable = false}, SHIFT(1016),
  [2396] = {.count = 1, .reusable = false}, SHIFT(1017),
  [2398] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2400] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2402] = {.count = 1, .reusable = false}, SHIFT(1020),
  [2404] = {.count = 1, .reusable = false}, SHIFT(1021),
  [2406] = {.count = 1, .reusable = false}, SHIFT(1022),
  [2408] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2410] = {.count = 1, .reusable = true}, REDUCE(sym_parameter, 5),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2414] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1027),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1031),
  [2422] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 10),
  [2424] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 10),
  [2426] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 10),
  [2428] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 10),
  [2430] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 10),
  [2432] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 10),
  [2434] = {.count = 1, .reusable = false}, REDUCE(sym_method_declaration, 7),
  [2436] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 7),
  [2438] = {.count = 1, .reusable = false}, REDUCE(sym_event_declaration, 7),
  [2440] = {.count = 1, .reusable = true}, REDUCE(sym_event_declaration, 7),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_add_accessor_declaration, 3),
  [2444] = {.count = 1, .reusable = true}, REDUCE(sym_remove_accessor_declaration, 3),
  [2446] = {.count = 1, .reusable = false}, SHIFT(1032),
  [2448] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2452] = {.count = 1, .reusable = false}, SHIFT(1034),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1035),
  [2456] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2458] = {.count = 1, .reusable = false}, SHIFT(1036),
  [2460] = {.count = 1, .reusable = true}, SHIFT(1037),
  [2462] = {.count = 1, .reusable = true}, SHIFT(1038),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1032),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1039),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1040),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1041),
  [2472] = {.count = 1, .reusable = true}, REDUCE(sym__unary_operator_declarator, 7),
  [2474] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1044),
  [2478] = {.count = 1, .reusable = true}, REDUCE(sym_variable_initializer, 1),
  [2480] = {.count = 1, .reusable = true}, REDUCE(sym__indexer_declarator, 7),
  [2482] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2484] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2486] = {.count = 1, .reusable = false}, REDUCE(sym_real_literal, 5),
  [2488] = {.count = 1, .reusable = true}, REDUCE(sym_real_literal, 5),
  [2490] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2494] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2498] = {.count = 1, .reusable = false}, SHIFT(1051),
  [2500] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 3),
  [2502] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 3),
  [2504] = {.count = 1, .reusable = false}, REDUCE(sym_lock_statement, 5),
  [2506] = {.count = 1, .reusable = true}, REDUCE(sym_lock_statement, 5),
  [2508] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2510] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2512] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2514] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [2516] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [2518] = {.count = 1, .reusable = false}, SHIFT(1057),
  [2520] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2522] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2524] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2526] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [2528] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [2530] = {.count = 2, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(738),
  [2533] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2535] = {.count = 1, .reusable = false}, SHIFT(1064),
  [2537] = {.count = 1, .reusable = false}, SHIFT(1065),
  [2539] = {.count = 1, .reusable = false}, SHIFT(1066),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1069),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1070),
  [2547] = {.count = 1, .reusable = true}, REDUCE(sym__conversion_operator_declarator, 7),
  [2549] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_constraints, 5),
  [2551] = {.count = 1, .reusable = false}, REDUCE(sym_interface_method_declaration, 7),
  [2553] = {.count = 1, .reusable = true}, REDUCE(sym_interface_method_declaration, 7),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1076),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2563] = {.count = 1, .reusable = false}, REDUCE(sym_interface_property_declaration, 7),
  [2565] = {.count = 1, .reusable = true}, REDUCE(sym_interface_property_declaration, 7),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2569] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2575] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 10),
  [2577] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 10),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1088),
  [2589] = {.count = 1, .reusable = false}, SHIFT(1089),
  [2591] = {.count = 1, .reusable = false}, SHIFT(1090),
  [2593] = {.count = 1, .reusable = false}, SHIFT(1091),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1092),
  [2597] = {.count = 1, .reusable = false}, SHIFT(1093),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1094),
  [2601] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1096),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2607] = {.count = 1, .reusable = false}, REDUCE(sym__property_initializer, 3),
  [2609] = {.count = 1, .reusable = true}, REDUCE(sym__property_initializer, 3),
  [2611] = {.count = 1, .reusable = false}, REDUCE(sym_method_declaration, 8),
  [2613] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 8),
  [2615] = {.count = 1, .reusable = false}, REDUCE(sym_event_declaration, 8),
  [2617] = {.count = 1, .reusable = true}, REDUCE(sym_event_declaration, 8),
  [2619] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2621] = {.count = 1, .reusable = true}, REDUCE(sym__exception_specifier, 3),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2627] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 4),
  [2629] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 4),
  [2631] = {.count = 1, .reusable = false}, SHIFT(1102),
  [2633] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 6),
  [2635] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 6),
  [2637] = {.count = 1, .reusable = false}, SHIFT(1106),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2645] = {.count = 1, .reusable = false}, SHIFT(1112),
  [2647] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2651] = {.count = 1, .reusable = false}, SHIFT(1059),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1060),
  [2655] = {.count = 1, .reusable = false}, SHIFT(1115),
  [2657] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2665] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2667] = {.count = 1, .reusable = true}, REDUCE(sym_array_initalizer, 3),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2673] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter_constraints, 6),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2677] = {.count = 1, .reusable = false}, REDUCE(sym_interface_indexer_declaration, 8),
  [2679] = {.count = 1, .reusable = true}, REDUCE(sym_interface_indexer_declaration, 8),
  [2681] = {.count = 1, .reusable = false}, REDUCE(sym_interface_method_declaration, 8),
  [2683] = {.count = 1, .reusable = true}, REDUCE(sym_interface_method_declaration, 8),
  [2685] = {.count = 1, .reusable = false}, SHIFT(1133),
  [2687] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 11),
  [2689] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 11),
  [2691] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 11),
  [2693] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 11),
  [2695] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 11),
  [2697] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 11),
  [2699] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2703] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2705] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 11),
  [2707] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 11),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2713] = {.count = 1, .reusable = true}, REDUCE(sym__exception_specifier, 4),
  [2715] = {.count = 1, .reusable = true}, REDUCE(sym__exception_filter, 4),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2721] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2723] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [2725] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2729] = {.count = 1, .reusable = false}, REDUCE(sym_switch_label, 2),
  [2731] = {.count = 1, .reusable = true}, REDUCE(sym_switch_label, 2),
  [2733] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 7),
  [2735] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 7),
  [2737] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_statement_repeat1, 2),
  [2739] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_statement_repeat1, 2), SHIFT_REPEAT(1059),
  [2742] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_statement_repeat1, 2), SHIFT_REPEAT(1060),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2749] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2753] = {.count = 1, .reusable = true}, REDUCE(sym_switch_section, 2),
  [2755] = {.count = 1, .reusable = false}, REDUCE(sym__statement_list, 1),
  [2757] = {.count = 1, .reusable = false}, REDUCE(aux_sym_switch_section_repeat1, 2),
  [2759] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_section_repeat1, 2),
  [2761] = {.count = 2, .reusable = false}, REDUCE(aux_sym_switch_section_repeat1, 2), SHIFT_REPEAT(1059),
  [2764] = {.count = 2, .reusable = false}, REDUCE(aux_sym_switch_section_repeat1, 2), SHIFT_REPEAT(1060),
  [2767] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2769] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 7),
  [2771] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 7),
  [2773] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_initalizer_repeat1, 2),
  [2775] = {.count = 1, .reusable = true}, REDUCE(sym_array_initalizer, 4),
  [2777] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_initalizer_repeat1, 2), SHIFT_REPEAT(1069),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_method_declaration, 9),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_method_declaration, 9),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_event_declaration, 9),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_event_declaration, 9),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_interface_indexer_declaration, 9),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_interface_indexer_declaration, 9),
  [2792] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2794] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 12),
  [2796] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 12),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym_struct_declaration, 12),
  [2800] = {.count = 1, .reusable = false}, REDUCE(sym_struct_declaration, 12),
  [2802] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 12),
  [2804] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 12),
  [2806] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2808] = {.count = 1, .reusable = true}, REDUCE(sym__binary_operator_declarator, 10),
  [2810] = {.count = 1, .reusable = false}, REDUCE(sym_switch_label, 3),
  [2812] = {.count = 1, .reusable = true}, REDUCE(sym_switch_label, 3),
  [2814] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2816] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(1111),
  [2819] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(1112),
  [2822] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(1113),
  [2825] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(1114),
  [2828] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [2830] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(1115),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2839] = {.count = 1, .reusable = false}, REDUCE(sym_interface_indexer_declaration, 10),
  [2841] = {.count = 1, .reusable = true}, REDUCE(sym_interface_indexer_declaration, 10),
  [2843] = {.count = 2, .reusable = false}, REDUCE(sym_if_statement, 5), SHIFT(1166),
  [2846] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2848] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2850] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2852] = {.count = 1, .reusable = false}, SHIFT(1172),
  [2854] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2856] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2858] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2860] = {.count = 2, .reusable = true}, REDUCE(sym_if_statement, 5), SHIFT(1177),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2865] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2867] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2871] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2879] = {.count = 2, .reusable = false}, REDUCE(sym_if_statement, 5), SHIFT(1192),
};

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_c_sharp() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier_name,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
